#include common_scripts\utility;
#include maps\_utility;
#include maps\_hud_util;
#include maps\_createmenu;
#include maps\_createcam;
#include maps\_debug;
#include maps\_destructible_types;

generic_combat(){}
specific_combat(){}
nml_loader() {
    deleteChalks();
    array_thread(getPlayers(), ::nml_environment);
    array_thread(getPlayers(), ::nml_startLocation);
    array_thread(getPlayers(), ::nml_weaponHud);
    array_thread(getPlayers(), ::nml_populationHud);
    if (!isSolo()) level thread nml_makePlayerArray();
    if (!isSolo()) array_thread(getPlayers(), ::nml_colorNames);
    if (!isSolo()) array_thread(getPlayers(), ::nml_weaponLocations);
    self thread nml_noMansLand();
    level thread skyBaseBox((-120, 412.5, 226.125), (0, 90, 0), (-108, 412.5, 243.8), (0, 90, 0), (90, 0, 0), 300, 20);
    wait 1.9;
    for (a = 0; a < 3; a++) level.intro_hud[a] destroy();
    set_zombie_var("zombie_max_ai", 15);
    setLobbyDvar("player_lastStandBleedoutTime", .05);
    setLobbyDvar("player_lastStandBleedoutTimeNoRevive", .05);
    setDvar("zombie_rise_test", 1);
}
nml_noMansLand() {
    if (isSolo()) {
        level.overridePlayerDamage = ::nml_soloDeath;
        level thread nml_secondChance();
    } else level.overridePlayerDamage = ::nml_multiDeath;
    array_thread(getPlayers(), ::nml_playIntroSounds);
    level thread nml_zombiePowerUpDrop();
    level thread nml_buildTower();
    level thread nml_colaRise();
    level thread nml_juggRise();
    level thread nml_doubleTap();
    level thread nml_blockPaths();
    level thread nml_dvars();
    wait 1;
    array_thread(getPlayers(), ::nml_welcomeMessage, "Welcome to No Mans Land", "Created by: AgreedBog381 & JordDev");
    wait 3.5;
    level thread nml_shootColt();
}
nml_environment() {
    self thread nml_clearPerks();
    self thread doHitMarkers();
    self thread sun("0", "", (0, 0, 0));
    self thread changeFog((0, 0, 0), 1);
}
nml_startLocation() {
    self freezeControls(true);
    self setClientDvars("ammoCounterHide", 1);
    locations = [];
    locations[0] = (790, -328.755, 63.4436);
    locations[1] = (-23, 365, 60.125);
    locations[2] = (660, 402, 60.125);
    locations[3] = (-515, 215, 56.125);
    angles = [];
    angles[0] = (0, 180, 0);
    angles[1] = (0, -60, 0);
    angles[2] = (0, -140, 0);
    angles[3] = (0, -15, 0);
    self setOrigin(locations[self getEntityNumber()]);
    self setPlayerAngles(angles[self getEntityNumber()]);
    self setClientDvar("cg_fov", 86);
    self thread nml_zombiePlayerRise(.3, locations[self getEntityNumber()], angles[self getEntityNumber()][1], true);
    self freezeControls(false);
}
nml_playIntroSounds() {
    self playSound("mx_splash_screen");
    wait 1;
    self playSound("sweeper_no_d");
}
nml_shootColt() {
    weapons = [];
    coltTag = [];
    weaponPlayerAngles = [];
    weaponPlayerAngles[0] = (-55, vectorToAngles(getPlayers()[0].origin - (221, 24.99995, 81.125))[1], 0);
    weaponPlayerAngles[1] = (-55, vectorToAngles(getPlayers()[1].origin - (221, 24.99995, 81.125))[1], 0);
    weaponPlayerAngles[2] = (-55, vectorToAngles(getPlayers()[2].origin - (221, 24.99995, 81.125))[1], 0);
    weaponPlayerAngles[3] = (-55, vectorToAngles(getPlayers()[3].origin - (221, 24.99995, 81.125))[1], 0);
    for (a = 0; a < getPlayers().size; a++) {
        weapons[a] = spawnSM((221, 24.99995, 81.125), "tag_origin", weaponPlayerAngles[a]);
        coltTag[a] = spawnSM(weapons[a].origin + anglesToForward((0, 0, 0)) * 8, "script_origin");
        coltTag[a] linkTo(weapons[a]);
        playfxontag(level._effect["powerup_on"], weapons[a], "tag_origin");
    }
    weapons[0] thread nml_coltFling(vectorScale(anglesToForward(weapons[0].angles), nml_getVelocity(46, distance(weapons[0].origin, getPlayers()[0].origin))), nml_getTime(46, distance(weapons[0].origin, getPlayers()[0].origin)), coltTag[0], getPlayers()[0]);
    if (isDefined(weapons[1])) weapons[1] thread nml_coltFling(vectorScale(anglesToForward(weapons[1].angles), nml_getVelocity(45, distance(weapons[1].origin, getPlayers()[1].origin))), nml_getTime(45, distance(weapons[1].origin, getPlayers()[1].origin)), coltTag[1], getPlayers()[1]);
    if (isDefined(weapons[2])) weapons[2] thread nml_coltFling(vectorScale(anglesToForward(weapons[2].angles), nml_getVelocity(45, distance(weapons[2].origin, getPlayers()[2].origin))), nml_getTime(45, distance(weapons[2].origin, getPlayers()[2].origin)), coltTag[2], getPlayers()[2]);
    if (isDefined(weapons[3])) weapons[3] thread nml_coltFling(vectorScale(anglesToForward(weapons[3].angles), nml_getVelocity(45, distance(weapons[3].origin, getPlayers()[3].origin))), nml_getTime(45, distance(weapons[3].origin, getPlayers()[3].origin)), coltTag[3], getPlayers()[3]);
    for (a = 0; a < 3; a++) {
        playfx(loadFx("explosions/mortarExp_water"), (221, 24.99995, 81.125 + a * 100));
        wait .1;
    }
}
nml_getVelocity(degrees, distance) {
    temp = distance * 9.8;
    return sqrt(temp) * 9.15;
}
nml_getTime(degrees, distance) {
    rate = nml_getVelocity(degrees, distance);
    time = distance / rate;
    return time * 1.65;
}
nml_coltFling(velocity, time, coltTag, player) {
    self moveGravity(velocity, time);
    wait time;
    self thread nml_coltgrab(coltTag, player);
    self thread powerup_wobble();
    if (player == getPlayers()[0]) level notify("EXPOSE_TOWER");
    wait .1;
    coltTag setModel(getWeaponModel("colt"));
}
nml_coltGrab(tag, player) {
    while (isDefined(self)) {
        if (distance(player.origin, self.origin) < 64) {
            playfx(level._effect["powerup_grabbed"], self.origin);
            playfx(level._effect["powerup_grabbed_wave"], self.origin);
            wait .1;
            playsoundatposition("powerup_grabbed", self.origin);
            self stoploopsound();
            self delete();
            tag delete();
            player takeAllGuns();
            player giveWeapon("colt");
            player giveMaxAmmo("colt");
            player switchToWeapon("colt");
            player.is_zombie = false;
            level notify("NML_UPDATE_POPULATION");
            player notify("COLT_GRABBED");
            break;
        }
        wait 0.05;
    }
}
nml_buildTower() {
    mgs = getentarray("fountain_mg", "targetname");
    trig = getent("trig_courtyard_mg", "targetname");
    for (a = 0; a < mgs.size; a++) mgs[a] delete();
    trig delete();
    level thread nml_towerFakeSolid();
    tower = [];
    for (a = 0; a < 20; a++) {
        tower[tower.size] = spawnSM((221, 24.99995, -18.875) - (0, 0, 125 * a), "static_berlin_fountain_base_mid");
        tower[tower.size] = spawnSM(tower[tower.size - 1].origin, "static_berlin_fountain_base_mid", (180, 0, 0));
    }
    tag = spawnSM(tower[tower.size - 1].origin, "tag_origin");
    start = tag.origin;
    for (a = 0; a < tower.size; a++) tower[a] linkTo(tag);
    level nml_towerRise(tag);
    level waittill("NML_TOWER_FALL");
    self thread nml_towerFallEffects();
    self thread nml_towerFall(tag, start);
    level waittill("NML_TOWER_HAS_FALL");
    if (isSolo()) {
        level thread nml_shootColt();
        level nml_towerRise(tag);
    } else {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread nml_gameOver();
    }
}
nml_gameOver() {
    self.intermission = true;
    self thread maps\_laststand::PlayerLastStand();
    level notify("fake_death");
    self notify("fake_death");
    self nml_player_fake_death(true);
    self thread nml_welcomeMessage("Game Over", "Thanks For Playing No Mans Land");
    self theGameIsOv(true);
}
nml_towerRise(tag) {
    level waittill("EXPOSE_TOWER");
    for (a = 0; a < 3; a++) playfx(loadFx("explosions/fx_mortarExp_dirt"), (221, 24.99995, 80 + a * 10));
    tag moveTo((221, 24.99995, 81.125), 5, .5, 4.5);
    wait .1;
    earthQuake(2, 1, (221, 24.99995, 80), 1500);
    playSoundAtPosition("barrel_explode_dist", (221, 24.99995, 100));
    wait .2;
    for (a = 0; a < 28; a++) {
        playSoundAtPosition("couch_slam", (221, 24.99995, 100));
        if (a <= 20) wait .1;
        else wait .2;
    }
}
nml_towerFall(tag, start) {
    tag moveTo((221, 24.99995, start[2] + 35), 3, 2.5);
    wait .1;
    earthQuake(2, 1, (221, 24.99995, 80), 1500);
    for (a = 0; a < 28; a++) {
        playSoundAtPosition("couch_slam", (221, 24.99995, 100));
        if (a <= 20) wait .1;
        else wait .2;
    }
}
nml_towerFallEffects() {
    wait 3;
    earthQuake(2, 1, (221, 24.99995, 80), 1500);
    level notify("TOWER_FALLEN");
    for (a = 0; a < 3; a++) {
        playfx(loadFx("explosions/mortarExp_water"), (221, 24.99995, 81.125 + a * 100));
        wait .1;
    }
    level killZombiesWithinDistance((221, 24.99995, 80), 1000, "headGib");
    level notify("NML_TOWER_HAS_FALL");
}
nml_towerFakeSolid() {
    for (a = 0; a < 6; a++) {
        radius = spawn("trigger_radius", (221, 24.99995, 80 + a * 50), 0, 210, 210);
        radius setContents(true);
    }
}
nml_blockPaths() {
    door = getEntArray("zombie_door", "targetname");
    door[5].doors[0].origin = (-621.5, 274.016, 130);
    door[5].doors[1].origin = (-619.5, 170.125, 130);
    door[5].doors[0].angles = (0, 90, 0);
    door[5].doors[1].angles = (0, 90, 0);
    door[5].doors[0] solid();
    door[5].doors[1] solid();
    door[5].doors[0] hide();
    door[5].doors[1] hide();
    door[8].doors[0].origin = (-280.25, -99, 120);
    door[8].doors[0].angles = (0, 0, 0);
    door[8].doors[0] solid();
    door[8].doors[0] hide();
    if (!isSolo()) spawnSM((-292, -80, 55), "static_berlin_bookshelf_wide", (0, 180, 0));
    door[8].doors[1].origin = (-282.2, -326, 120);
    door[8].doors[1].angles = (0, 0, 0);
    door[8].doors[1] solid();
    door[8].doors[1] hide();
    spawnSM((-292, -352, 55), "static_berlin_bookshelf_wide", (0, 180, 0));
    door[1].door.origin = (-140.125, 412.5, 235);
    door[2].door.origin = (-139.625, 465, 235);
    door[1].door.angles = (0, 90, 0);
    door[2].door.angles = (0, 90, 0);
    door[1].door solid();
    door[2].door solid();
    door[1].door hide();
    door[2].door hide();
}
nml_multiDeath(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, modelIndex, psOffsetTime) {
    if (iDamage < self.health) return;
    if (self.is_zombie) {
        self.groundRefEnt delete();
        self notify("NEW_ZOMBIE_LIFE");
        self enableInvulnerability();
        self.health = 100;
        self thread nml_killPlayer();
        self hide();
        self nml_player_fake_death();
        self thread nml_blackScreen();
        wait 1.5;
        self thread nml_deathWatch(1);
    } else {
        self nml_player_fake_death();
        wait .1;
        self enableInvulnerability();
        wait 1;
        self freezeControls(true);
        self.team = "axis";
        self notify("NML_PLAYER_DEAD");
        self thread nml_whileMelee("PLAYERS", 100);
        self.is_zombie = true;
        self thread nml_lastManIsDead();
        self.ignoreme = true;
        self.revivetrigger = true;
        self detachAll();
        self.headModel = getAISpeciesArray("axis", "all")[0].headModel;
        self attach(self.headModel, "", true);
        self thread nml_blackScreen();
        self.health = 100;
        self thread nml_deathWatch(1);
        wait 1.25;
        level notify("NML_UPDATE_NAMECOLOR");
        self.nml_soloDeath = true;
    }
    self.health = 100;
    level notify("PLAYER_HAS_DIED");
    level waittill("NEVER_END_THIS_SCRIPT");
}
nml_lastManIsDead() {
    wait 3;
    allDead = true;
    for (a = 0; a < getPlayers().size; a++) {
        if (!getPlayers()[a].is_zombie) allDead = false;
    }
    if (allDead) {
        level notify("NML_TOWER_FALL");
        level notify("ZOMBIE_FOLLOW_END");
        level thread nml_zombiesStopFollowing();
    }
}
nml_deathWatch(speed) {
    level.overridePlayerDamageBackup = level.overridePlayerDamage;
    while (true) {
        if (isDefined(self.nml_soloDeath)) break;
        wait .05;
    }
    self freezeControls(false);
    self disableInvulnerability();
    self allowStand(true);
    self allowCrouch(true);
    self allowSprint(true);
    self allowJump(true);
    self returnToSpawn();
    wait .25;
    self thread nml_zombiePlayerRise(speed);
    wait 3;
    if (isSolo()) level notify("NML_TOWER_FALL");
}
nml_colorNames() {
    self setClientDvar("cg_overheadIconSize", "0");
    self setClientDvar("cg_overheadRankSize", "0");
    for (a = 0; a < getPlayers().size; a++) self setClientDvar("cg_scoresColor_Gamertag_" + a, "0 1 0 1");
    while (true) {
        level waittill("NML_UPDATE_NAMECOLOR");
        wait .25;
        for (a = 0; a < getPlayers().size; a++)
            if (getPlayers()[a].is_zombie) self setClientDvar("cg_scoresColor_Gamertag_" + a, "1 0 0 1");
        wait .05;
    }
}
nml_weaponLocations() {
    self thread nml_whileFiring();
    self thread nml_whileMelee("ZOMBIES", 1000);
    self thread nml_whileGrenade();
    while (true) {
        self.nml_fireLocation = bulletTrace(self getTagOrigin("j_head"), self getTagOrigin("j_head") + anglesToForward(self getPlayerAngles()) * 1000000, true, self);
        self.nml_meleeLocation = bulletTrace(self getTagOrigin("j_head"), self getTagOrigin("j_head") + anglesToForward(self getPlayerAngles()) * 50, true, self);
        wait .05;
    }
}
nml_whileFiring() {
    self endon("NML_PLAYER_DEAD");
    while (true) {
        self waittill("weapon_fired");
        entity = self.nml_fireLocation["entity"];
        if (nml_attackingCorrectEntity("ZOMBIES", entity)) entity doDamage(190, entity.origin, undefined, undefined, "riflebullet");
        wait .05;
    }
}
nml_whileMelee(attackingType, damage) {
    self endon("NML_PLAYER_DEAD");
    while (true) {
        while (self isMeleeing()) {
            entity = self.nml_meleeLocation["entity"];
            if (nml_attackingCorrectEntity(attackingType, entity)) entity doDamage(damage, entity.origin, undefined, undefined, "riflebullet");
            wait .05;
        }
        wait .05;
    }
}
nml_whileGrenade() {
    self endon("NML_PLAYER_DEAD");
    while (true) {
        self waittill("grenade_fire", gren);
        self thread ffa_grenadeFollow(gren);
        gren waittill("explode");
        for (a = 0; a < getPlayers().size; a++) {
            if (getPlayers()[a] == self || !getPlayers()[a].is_zombie) continue;
            if (distance(getPlayers()[a].origin, self.myGren) <= 250) {
                getPlayers()[a] doDamage(1000, self.myGren, undefined, undefined, "riflebullet");
                getPlayers()[a] viewKick(2, self.myGren);
            }
        }
    }
}
nml_attackingCorrectEntity(attackingType, entity) {
    if (!isDefined(entity)) return false;
    if (attackingType == "ZOMBIES") {
        for (a = 0; a < getPlayers().size; a++)
            if (entity == getPlayers()[a] && getPlayers()[a].is_zombie) return true;
    } else if (attackingType == "PLAYERS") {
        for (a = 0; a < getPlayers().size; a++)
            if (entity == getPlayers()[a] && !getPlayers()[a].is_zombie) return true;
    }
    return false;
}
nml_killPlayer() {
    body = spawnSM(self.origin + (0, 0, 2), self.model, self.angles);
    body attach(self.headModel, "", true);
    body startRagDoll();
    wait 15;
    body delete();
}
nml_zombiesStopFollowing() {
    self endon("COLT_GRABBED");
    while (true) {
        zom = getAiSpeciesArray("axis", "all");
        for (a = 0; a < zom.size; a++) {
            zom[a] setGoalPos((221, 24.99995, 81.125));
            zom[a].favoriteenemy = undefined;
            zom[a].ignore_player = true;
            zom[a] notify("zombie_acquire_enemy");
            zom[a] notify("bad_path");
            zom[a] allowMelee(false);
        }
        wait .1;
    }
}
nml_blackScreen() {
    hud = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", 1, 0);
    hud hudFade(1, .75);
    self.is_zombie = true;
    self thread nml_clearPerks();
    if (isSolo()) self thread nml_watchForCola();
    if (isSolo()) self thread nml_watchForJugg();
    self setVision("zombie_turned", 50);
    wait .75;
    hud thread hudFadenDestroy(0, .5);
}
nml_clearPerks() {
    self thread doClearPerks();
    self.kills = 0;
    self.health = 100;
    self.nml_DoubleTap = undefined;
    self.nml_JuggTempOn = undefined;
    self.nml_SpeedColaTempOn = undefined;
}
nml_soloDeath(eInflictor, eAttacker, iDamage, iDFlags, sMeansOfDeath, sWeapon, vPoint, vDir, sHitLoc, modelIndex, psOffsetTime) {
    if (iDamage < self.health) return;
    self notify("NML_PLAYER_DEAD");
    self thread nml_zombiesStopFollowing();
    self allowSprint(false);
    self allowJump(false);
    self allowStand(false);
    self allowCrouch(false);
    self setStance("prone");
    if (isDefined(self.nml_zombieRevivePerk)) {
        self nml_player_fake_death();
        wait .1;
        self enableInvulnerability();
        wait 1;
        self freezeControls(true);
        self hide();
        self thread nml_blackScreen();
        self.health = 100;
        wait 1.45;
        self.nml_soloDeath = true;
        self.nml_zombieRevivePerk = undefined;
        level waittill("NEVER_END_THIS_SCRIPT");
    }
    self.is_zombie = true;
    level notify("NML_UPDATE_POPULATION");
    self.intermission = true;
    self thread maps\_laststand::playerLastStand(eInflictor, eAttacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, psOffsetTime);
    self nml_player_fake_death(true);
    self thread nml_welcomeMessage("Game Over", "Thanks For Playing No Mans Land");
    self theGameIsOv(true);
}
nml_player_fake_death(god) {
    self takeAllGuns();
    self allowStand(false);
    self allowCrouch(false);
    self allowProne(true);
    self.ignoreme = true;
    if (isDefined(god)) {
        self enableInvulnerability();
        wait 1;
        self freezeControls(true);
    }
}
nml_colaRise() {
    door = getEntArray("zombie_door", "targetname");
    door[4].doors[0].origin = (565, -410, 130);
    door[4].doors[1].origin = (615, -409.5, 130);
    door[4].doors[0].angles = (0, 0, 0);
    door[4].doors[1].angles = (0, 180, 0);
    door[4].doors[0] solid();
    door[4].doors[1] solid();
    door[4].doors[0] hide();
    door[4].doors[1] hide();
    speedCola = spawnSM((563, -420, -30), "zombie_vending_sleight", (0, 180, 0));
    wait .5;
    speedCola moveTo((563, -420, 56.125), 3);
    playSoundAtPosition("zombie_spawn", (563, -420, 56.125));
    playfx(level._effect["rise_burst"], (563, -420, 56.125));
    playfx(level._effect["rise_dust"], (563, -420, 56.125));
    wait .25;
    playfx(level._effect["rise_burst"], (563, -420, 56.125));
    playfx(level._effect["rise_billow"], (563, -420, 56.125));
    array_thread(getPlayers(), ::nml_watchForCola);
    wait 3;
    playSoundAtPosition("perks_rattle", speedCola.origin);
    playSoundAtPosition("broken_random_jingle", speedCola.origin);
    playSoundAtPosition("electrical_surge", speedCola.origin);
    while (true) {
        for (a = 0; a < getPlayers().size; a++) {
            if (isDefined(getPlayers()[a].nml_SpeedColaTempOn)) speedCola setModel("zombie_vending_sleight_on");
            else speedCola setModel("zombie_vending_sleight");
        }
        wait .5;
    }
}
nml_juggRise() {
    door = getEntArray("zombie_door", "targetname");
    door[0].doors[0].origin = (-350, 474, 135);
    door[0].doors[1].origin = (-353, 472, 135);
    door[0].doors[0].angles = (0, 0, 0);
    door[0].doors[1].angles = (0, 0, 0);
    door[0].doors[0] solid();
    door[0].doors[1] solid();
    door[0].doors[0] hide();
    door[0].doors[1] hide();
    jugg = spawnSM((-352, 484, -46), "zombie_vending_jugg");
    playfx(level._effect["dlight_fire_glow"], (-300, 610, 60));
    playfx(level._effect["dlight_fire_glow"], (-395, 610, 60));
    wait .5;
    jugg moveTo((-352, 484, 56.125), 3);
    playSoundAtPosition("zombie_spawn", (-352, 484, 56.125));
    playfx(level._effect["rise_burst"], (-352, 484, 56.125));
    playfx(level._effect["rise_dust"], (-352, 484, 56.125));
    wait .25;
    playfx(level._effect["rise_burst"], (-352, 484, 56.125));
    playfx(level._effect["rise_billow"], (-352, 484, 56.125));
    array_thread(getPlayers(), ::nml_watchForJugg);
    wait 3;
    playSoundAtPosition("perks_rattle", jugg.origin);
    playSoundAtPosition("broken_random_jingle", jugg.origin);
    playSoundAtPosition("electrical_surge", jugg.origin);
    while (true) {
        for (a = 0; a < getPlayers().size; a++) {
            if (isDefined(getPlayers()[a].nml_JuggTempOn)) jugg setModel("zombie_vending_jugg_on");
            else jugg setModel("zombie_vending_jugg");
        }
        wait .5;
    }
}
nml_watchForCola() {
    self endon("NML_PLAYER_DEAD");
    while (true) {
        if (self.kills >= 25) break;
        wait .1;
    }
    self.nml_SpeedColaTempOn = true;
    icon = spawnObjPointer(self, (563, -420, 155), "specialty_fastreload_zombies", false);
    self thread nml_deleteIcon(icon);
    trig = spawnTrigger((563, -420, 65), 40);
    self thread nml_trigDelete(trig);
    trig setString("Press [{+activate}] for Speed Cola");
    randomNumber = randomIntRange(0, 2147483647);
    self.nml_speedColaActivated["ID" + randomNumber] = true;
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie && isDefined(who.nml_speedColaActivated["ID" + randomNumber]) && !isDefined(who.is_drinking)) {
            who thread giveMenuPerkO("specialty_fastreload");
            break;
        }
    }
    trig delete();
    icon destroy();
    self.nml_SpeedColaTempOn = undefined;
}
nml_watchForJugg() {
    self endon("NML_PLAYER_DEAD");
    distanceTraveled = 0;
    while (true) {
        oldSpot = self.origin;
        wait .05;
        newSpot = self.origin;
        distanceTraveled += distance(oldSpot, newSpot);
        if (distanceTraveled >= 7000) break;
    }
    self.nml_JuggTempOn = true;
    icon = spawnObjPointer(self, (-352, 484, 147), "specialty_juggernaut_zombies", false);
    self thread nml_deleteIcon(icon);
    trig = spawnTrigger((-352, 484, 57), 40);
    self thread nml_trigDelete(trig);
    trig setString("Press [{+activate}] for Jugger-Nog");
    randomNumber = randomIntRange(0, 10000);
    self.nml_speedColaActivated["ID" + randomNumber] = true;
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie && isDefined(who.nml_speedColaActivated["ID" + randomNumber]) && !isDefined(who.is_drinking)) {
            who thread giveMenuPerkO("specialty_armorvest");
            break;
        }
    }
    trig delete();
    icon destroy();
    self.nml_JuggTempOn = undefined;
}
nml_doubleTap() {
    door = [];
    door[0] = spawnSM((-623.875, 274.016, 64.125), "prefab_berlin_asylum_dbldoor_dr");
    door[1] = spawnSM((-625.550, 170.125, 64.125), "prefab_berlin_asylum_dbldoor_dr", (0, 180, 0));
    DT = spawnSM((-650, 222, 64.125), "zombie_vending_doubletap", (0, 90, 0));
    trig = spawnTrigger((-610, 222, 64.125), 45);
    trig setString("Press [{+activate}] to Open Door [Cost: 1200]");
    while (1) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie) {
            if (who.score >= 1200) {
                who minus_to_player_score(1200);
                door[0] moveTo(door[0].origin + (0, 20, 0), 2);
                door[1] moveTo(door[1].origin - (0, 20, 0), 2);
                level thread nml_loopDoorOpening(door);
                break;
            } else who noMoneySound();
            wait .2;
        }
    }
    trig delete();
    DT setModel("zombie_vending_doubletap_on");
    wait 1.5;
    trig = spawnTrigger(DT.origin + (35, 0, 30), 48);
    trig setString("Press [{+activate}] for Double-Tap");
    while (1) {
        trig waittill("trigger", who);
        if (isDefined(who.nml_DoubleTap)) trig setString("");
        else trig setString("Press [{+activate}] for Double-Tap");
        if (who usebuttonPressed() && !who.is_zombie && !who hasPerk("specialty_rof") && !isDefined(who.nml_DoubleTap) && !isDefined(who.is_drinking)) {
            who.nml_DoubleTap = true;
            who thread giveMenuPerkO("specialty_rof");
        }
    }
}
nml_loopDoorOpening(door) {
    wait 1;
    playFx(level._effect["switch_sparks"], (-620, 270, 112));
    playFx(level._effect["switch_sparks"], (-620, 167, 95));
    playFx(level._effect["switch_sparks"], (-620, 167, 140));
    wait 1;
    while (1) {
        for (a = 0; a < 3; a++) {
            door[0] moveTo(door[0].origin - (0, 3, 0), .2);
            door[1] moveTo(door[1].origin + (0, 3, 0), .2);
            wait .2;
            door[0] moveTo(door[0].origin + (0, 3, 0), .2);
            door[1] moveTo(door[1].origin - (0, 3, 0), .2);
            wait .2;
        }
        door[0] moveTo((-623.875, 294.016, 64.125), .2);
        door[1] moveTo((-625.550, 150.125, 64.125), .2);
        wait .15;
    }
}
nml_secondChance() {
    secondChance = spawnSM((-293, -75, 64.125), "zombie_vending_revive_on", (0, 90, 0));
    trig = spawnTrigger(secondChance.origin, 47);
    trig setString("Press [{+activate}] for Zombie Revive [Cost: 1200]");
    while (1) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie && !isDefined(who.is_drinking)) {
            who.nml_zombieRevivePerk = true;
            who thread nml_zombieRevive();
            trig delete();
            break;
        }
    }
    secondChance setModel("zombie_vending_revive");
}
nml_zombieRevive() {
    self.is_drinking = true;
    weap = self getCurrentWeapon();
    playSoundAtPosition("bottle_dispense3d", self.origin);
    self disableOffhandWeapons();
    self disableWeaponCycling();
    self allowLean(false);
    self allowAds(false);
    self allowSprint(false);
    self allowProne(false);
    self allowMelee(false);
    self giveWeapon("zombie_perk_bottle_revive");
    self switchToWeapon("zombie_perk_bottle_revive");
    self waittill_any("fake_death", "death", "player_downed", "weapon_change_complete");
    self.perk_hud["specialty_quickrevive"] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", self.perk_hud.size * 30, -70, 1, 1, (1, 0, 0), "hint_health", 1, 1);
    self.perk_hud["specialty_quickrevive"] scaleOverTime(.4, 25, 25);
    self thread nml_deathWatch(.3);
    self enableOffhandWeapons();
    self enableWeaponCycling();
    self takeWeapon("zombie_perk_bottle_revive");
    self switchToWeapon(weap);
    self allowLean(true);
    self allowAds(true);
    self allowSprint(true);
    self allowProne(true);
    self allowMelee(true);
    self.is_drinking = undefined;
    self setVision("zombie_turned", 1);
    wait .5;
    self setVision("fly_dark", 1);
}
nml_deleteIcon(icon) {
    while (true) {
        if (self.is_zombie) break;
        wait .05;
    }
    icon destroy();
}
nml_trigDelete(trig) {
    while (true) {
        if (self.is_zombie) break;
        wait .05;
    }
    trig delete();
}
nml_welcomeMessage(message1, message2) {
    hud = [];
    hud[0] = self createRectangle("RIGHT", "RIGHT", 0, -100, 10, 10, divideColor(randomIntRange(0, 256), randomIntRange(0, 256), randomIntRange(0, 256)), "white", 100, .7);
    hud[0] scaleOverTime(.5, 10, 50);
    wait .7;
    hud[0] scaleOverTime(.6, 280, 50);
    wait .6;
    hud[1] = self createText(self getFont(), 1.25, "RIGHT", "RIGHT", hud[0].x - 10, hud[0].y - 7.5, 101, 1, message1, divideColor(255, 255, 0));
    hud[2] = self createText(self getFont(), 1.25, "RIGHT", "RIGHT", hud[0].x - 10, hud[0].y + 7.5, 101, 1, message2, divideColor(255, 255, 0));
    for (a = 1; a < 3; a++) hud[a] thread nml_colorFade(1.5);
    wait 5;
    hud[0] scaleOverTime(.3, 10, 50);
    hud[1] thread hudFadenDestroy(0, .1);
    hud[2] thread hudFadenDestroy(0, .1);
    wait .4;
    hud[0] thread hudFadenDestroy(0, .3);
}
nml_colorFade(time) {
    self fadeOverTime(time);
    self.color = divideColor(255, 255, 255);
}
nml_weaponHud() {
    hud = [];
    weap = self getCurrentWeapon();
    clipSize = weaponClipSize(weap);
    currentSize = self getWeaponAmmoClip(weap);
    grenadeClip = self getWeaponAmmoClip("fraggrenade");
    if (!isDefined(clipSize) || clipSize < 0) clipSize = 0;
    if (!isDefined(currentSize) || currentSize < 0) currentSize = 0;
    hud[0] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 0, 0, 125, 25, (0, 0, 0), "white", 100, 1);
    hud[1] = self createText(self getFont(), 1.2, "BOTTOMLEFT", "BOTTOMLEFT", hud[0].x, hud[0].y - 24, 101, 1, weaponNames(weap));
    hud["TOP_BAR"] = self createRectangle("TOPLEFT", "BOTTOMLEFT", 2, -23, 1 + int(((120 / clipSize) * currentSize)), 12, divideColor(255, 0 + (currentSize * 255 / clipSize), 0 + (currentSize * 255 / clipSize)), "white", 101, 1);
    hud["BOTTOM_BAR"] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 2, -2, 1 + int(((120 / clipSize) * currentSize)), 6, divideColor(255, 0 + (currentSize * 255 / clipSize), 0 + (currentSize * 255 / clipSize)), "white", 101, 1);
    hud["GRENADES"] = self createRectangle("LEFT", "BOTTOMLEFT", 120, -12.5, 25, 25, divideColor(255, 0 + (grenadeClip * 255 / 4), 0 + (grenadeClip * 255 / 4)), "hud_grenadeicon", 101, 1);
    hud["GRENADES_COUNT"] = self createText(self getFont(), 1.5, "LEFT", "BOTTOMLEFT", hud["GRENADES"].x + 20, hud["GRENADES"].y, 101, 1);
    hud["GRENADES_COUNT"].label = "";
    hud["GRENADES_COUNT"] setValue(grenadeClip);
    self thread nml_watchAmmo(hud["TOP_BAR"], hud["BOTTOM_BAR"]);
    self thread nml_watchGrenades(hud["GRENADES"], hud["GRENADES_COUNT"]);
    while (1) {
        if (weap != self getCurrentWeapon()) {
            hud[1] setText(weaponNames(self getCurrentWeapon()));
            hud[1].color = divideColor(255, 255, 0);
            hud[1] thread nml_colorFade(1.5);
            weap = self getCurrentWeapon();
        }
        wait .05;
    }
}
nml_watchAmmo(top, bottom) {
    weap = self getCurrentWeapon();
    clipSize = weaponClipSize(weap);
    currentAmmo = self getWeaponAmmoStock(weap);
    maxAmmo = weaponMaxAmmo(weap);
    currentSize = self getWeaponAmmoClip(weap);
    while (1) {
        if (weap != self getCurrentWeapon() || currentSize != self getWeaponAmmoClip(weap) || currentAmmo != self getWeaponAmmoStock(weap)) {
            scale = true;
            if (weap != self getCurrentWeapon()) scale = undefined;
            weap = self getCurrentWeapon();
            clipSize = weaponClipSize(weap);
            currentAmmo = self getWeaponAmmoStock(weap);
            maxAmmo = weaponMaxAmmo(weap);
            currentSize = self getWeaponAmmoClip(weap);
            top.color = divideColor(255, 0 + (currentSize * 255 / clipSize), 0 + (currentSize * 255 / clipSize));
            if (isDefined(scale)) top scaleOverTime(.05, 1 + int(((120 / clipSize) * currentSize)), 12);
            else top setShader("white", 1 + int(((120 / clipSize) * currentSize)), 12);
            currentNumberOfClips = (currentAmmo / maxAmmo);
            bottom.color = divideColor(255, 0 + (currentNumberOfClips * 255), 0 + (currentNumberOfClips * 255));
            if (isDefined(scale)) bottom scaleOverTime(.05, 1 + int(((120) * currentNumberOfClips)), 6);
            else bottom setShader("white", 1 + int(((120) * currentNumberOfClips)), 6);
        }
        wait .05;
    }
}
nml_watchGrenades(grenades, counter) {
    grenadeClip = self getWeaponAmmoClip("fraggrenade");
    while (1) {
        if (grenadeClip != self getWeaponAmmoClip("fraggrenade")) {
            grenadeClip = self getWeaponAmmoClip("fraggrenade");
            grenades.color = divideColor(255, 0 + (grenadeClip * 255 / 4), 0 + (grenadeClip * 255 / 4));
            counter setValue(grenadeClip);
        }
        wait .05;
    }
}
nml_populationHud() {
    hud = [];
    hud[0] = self createRectangle("BOTTOMRIGHT", "BOTTOMRIGHT", 0, 0, 105, 14, (0, 0, 0), "white", 100, 1);
    hud[1] = self createText(self getFont(), 1.2, "BOTTOMRIGHT", "BOTTOMRIGHT", hud[0].x, hud[0].y - 14, 101, 1, "Population Count ");
    hud["POP_BAR"] = self createRectangle("BOTTOMRIGHT", "BOTTOMRIGHT", hud[0].x - 2, hud[0].y - 2, 1, 10, divideColor(255, 0, 0), "white", 101, 1);
    hud["POP_ICON"] = self createRectangle("BOTTOMRIGHT", "BOTTOMRIGHT", hud[0].x - 99, hud[0].y + 1.5, 30, 30, divideColor(255, 255, 255), "stance_stand", 102, 1);
    hud["POP_COUNT"] = self createText(self getFont(), 2, "BOTTOMRIGHT", "BOTTOMRIGHT", hud[0].x - 122, hud[0].y + 1.5, 101, 1);
    hud["POP_COUNT"] setValue(0);
    maxPlayers = getPlayers().size;
    while (true) {
        livePlayers = 0;
        for (a = 0; a < getPlayers().size; a++) {
            if (!getPlayers()[a].is_zombie) livePlayers++;
        }
        hud["POP_BAR"].color = divideColor(255, 0 + (livePlayers * 255 / maxPlayers), 0 + (livePlayers * 255 / maxPlayers));
        hud["POP_BAR"] scaleOverTime(.05, 1 + int(((100 / maxPlayers) * livePlayers)), 10);
        hud["POP_COUNT"] setValue(livePlayers);
        hud["POP_COUNT"].color = divideColor(255, 0 + (livePlayers * 255 / maxPlayers), 0 + (livePlayers * 255 / maxPlayers));
        level waittill("NML_UPDATE_POPULATION");
    }
}
nml_zombify(zVisTime, speed, time, firstLimp) {
    self setStance("stand");
    self.is_zombie = true;
    if (isDefined(time)) wait time;
    level notify("NML_UPDATE_POPULATION");
    self setClientDvar("cg_fov", 86);
    self.groundRefEnt = spawnSM((0, 0, 0));
    self.playerSpeed = 50;
    self playerSetGroundReferenceEnt(self.groundRefEnt);
    lastWeapon = self getCurrentWeapon();
    self disableWeaponCycling();
    self disableOffhandWeapons();
    self takeAllGuns();
    self giveWeapon("zombie_melee");
    self switchToWeapon("zombie_melee");
    self allowProne(false);
    self allowCrouch(false);
    self allowSprint(false);
    self allowJump(false);
    self setMoveSpeedScale(speed);
    self thread setVision("zombie_turned", zVisTime);
    self setClientSysState("zombify", 1, self);
    if (isDefined(firstLimp) || isSolo()) self thread zombieLimp();
    if (!isDefined(firstLimp) && !isSolo()) {
        self thread nml_specialZombieLimp();
        return;
    }
    self waittill("COLT_GRABBED");
    self notify("zombify_over");
    self.groundRefEnt delete();
    self playerSetGroundReferenceEnt(undefined);
    self takeWeapon("zombie_melee", 0);
    self switchToWeapon(lastWeapon);
    self enableWeaponCycling();
    self enableOffhandWeapons();
    self allowProne(true);
    self allowCrouch(true);
    self allowSprint(true);
    self allowJump(true);
    self setMoveSpeedScale(1);
    self setVision("fly_dark", 1.5);
    self setClientSysState("zombify", 0, self);
    self thread ifAliveGrenades();
    self.groundRefEnt delete();
    self.is_zombie = false;
    self.ignoreme = false;
    self disableInvulnerability();
    level notify("NML_UPDATE_POPULATION");
}
ifAliveGrenades() {
    self thread removeGrenade("stielhandgranate");
    for (;;) {
        if (!self.is_zombie) {
            if (!self hasWeapon("fraggrenade")) {
                self giveWeapon("fraggrenade");
                self setWeaponAmmoClip("fraggrenade", 0);
            }
            if (self getFractionMaxAmmo("fraggrenade") < .25) self setWeaponAmmoClip("fraggrenade", 2);
            else if (self getFractionMaxAmmo("fraggrenade") < .5) self setWeaponAmmoClip("fraggrenade", 3);
            else self setWeaponAmmoClip("fraggrenade", 4);
        }
        level waittill("between_round_over");
    }
}
removeGrenade(grenade) {
    while (1) {
        if (self hasWeapon(grenade)) self takeWeapon(grenade);
        wait .05;
    }
}
nml_makePlayerArray() {
    wait 5;
    if (!isDefined(level.newPlayerArray)) level.newPlayerArray = [];
    for (a = 0; a < getPlayers().size; a++) level.newPlayerArray[a] = getPlayers()[a];
    while (true) {
        level waittill("PLAYER_HAS_DIED");
        level.newPlayerArray = [];
        for (a = 0; a < getPlayers().size; a++)
            if (!getPlayers()[a].is_zombie) level.newPlayerArray[a] = getPlayers()[a];
        wait .05;
    }
}
nml_dvars() {
    level thread nml_delayAttack();
    wait 2;
    level endon("ZOMBIE_FOLLOW_END");
    while (1) {
        zom = getAiSpeciesArray("axis", "all");
        for (a = 0; a < zom.size; a++) {
            if (!isDefined(zom[a].nml_attackMode) && isDefined(zom[a])) {
                zom[a].nml_attackMode = true;
                zom[a].got_to_entrance = true;
                zom[a].zombie_path_timer = 0;
                zom[a] zombie_setup_attack_properties();
                zom[a] thread find_flesh();
                zom[a] thread nml_followPlayer();
            }
        }
        wait .05;
    }
}
nml_followPlayer() {
    level endon("ZOMBIE_FOLLOW_END");
    self endon("death");
    while (isDefined(self)) {
        enemy = getClosest(self.origin, level.newPlayerArray);
        self setGoalPos(enemy.origin);
        wait .05;
    }
}
nml_delayAttack() {
    wait 4;
    level.zombie_vars["zombie_between_round_time"] = 0;
    level.zombie_vars["zombie_ai_per_player"] = 24;
    level.zombie_vars["zombie_max_ai"] = 50000;
    level.zombie_vars["zombie_spawn_delay"] = .35;
    level thread zombieSpeed("walk", 1);
    wait 34;
    level.zombie_vars["zombie_ai_per_player"] = 7;
    level.zombie_vars["zombie_max_ai"] = 15;
    level.zombie_vars["zombie_spawn_delay"] = 1.2;
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] playLocalSound("ann_vox_magicbox");
    wait 5;
    set_zombie_var("zombie_max_ai", 15);
    level thread activatePower();
    level thread zombieSpeed("sprint", 71);
}
nml_zombiePlayerRise(speed, risePosition, yawAngle, firstZombie) {
    self hide();
    if (!isDefined(firstZombie)) self thread nml_zombify(50, speed);
    else self thread nml_zombify(35, speed, .6, true);
    origin = [];
    origin[0] = (42, 179, 56.125);
    origin[1] = (-385, 236, 56.125);
    origin[2] = (349, -175, 56.125);
    if (!isDefined(firstZombie)) yawAngle = randomIntRange(0, 361);
    if (!isDefined(firstZombie)) risePosition = origin[randomIntRange(0, origin.size)];
    if (!isDefined(firstZombie)) self setOrigin(risePosition);
    wait .05;
    anchor = spawnSM(risePosition - (0, 0, 14), "tag_origin", (-80, yawAngle, 0));
    if (!isDefined(firstZombie)) self setPlayerAngles(anchor.angles);
    self playerLinkToAbsolute(anchor);
    earthQuake(1.3, 2, self.origin, 200);
    playSoundAtPosition("zombie_spawn", risePosition);
    playfx(level._effect["rise_burst"], risePosition);
    playfx(level._effect["rise_dust"], risePosition);
    self show();
    anchor moveTo(risePosition, 1);
    anchor rotateTo((0, yawAngle, 0), 2.5);
    wait .25;
    playfx(level._effect["rise_burst"], risePosition);
    playfx(level._effect["rise_billow"], risePosition);
    anchor waittill("rotatedone");
    self unlink();
    anchor delete();
    level notify("NML_UPDATE_POPULATION");
}
nml_specialZombieLimp() {
    self endon("NEW_ZOMBIE_LIFE");
    self endon("COLT_GRABBED");
    while (isDefined(self.groundRefEnt)) {
        velocity = self getVelocity();
        playerSpeed = abs(velocity[0]) + abs(velocity[1]);
        if (playerSpeed < 10) {
            wait .05;
            continue;
        }
        speedMultiplier = playerSpeed / self.playerSpeed;
        p = randomFloatRange(3, 5);
        if (randomInt(100) < 20) p *= 3;
        r = randomFloatRange(3, 7);
        y = randomFloatRange(-8, -2);
        stumbleAngles = (p / 3, y / 2, r / 3);
        stumbleAngles = vector_multiply(stumbleAngles, speedMultiplier);
        stumbleTime = randomFloatRange(.35, .45);
        recoverTime = randomFloatRange(.65, .8);
        self thread stumble(stumbleAngles, stumbleTime, recoverTime);
        self waittill("recovered");
    }
}
nml_zombiePowerUpDrop() {
    while (true) {
        zom = getAiSpeciesArray("axis", "all");
        for (a = 0; a < zom.size; a++)
            if (!isDefined(zom[a].nml_mightDrop)) zom[a] thread nml_mightDropPowerUp();
        wait .05;
    }
}
nml_mightDropPowerUp() {
    self.nml_mightDrop = true;
    self waittill("death");
    randomNumber = randomIntRange(0, 160);
    if (randomNumber > 2) return;
    powerup = spawn("script_model", self.origin + (0, 0, 40));
    powerup powerup_setup();
    level.powerup_drop_count++;
    powerup thread powerup_timeout();
    powerup thread powerup_wobble();
    powerup thread powerup_grab();
    level.zombie_vars["zombie_drop_item"] = 0;
}
ffa_start() {
    self thread ffa_watchKills();
    self thread ffa_door();
    self thread ffa_hud(1, 5);
    wait 4;
    self thread gameModeFFAInfo("Score: ^2", "Kills: ^2", "Deaths: ^2", "Killstreak: ^2");
    self thread ffa_randomWeapon();
    self freezeControls(false);
    self thread pickSpawnPoints();
    self setStance("stand");
    self thread ffa_deathCheck();
    self thread ffa_fireWeapon();
    self thread ffa_perks();
    self thread ffa_grenade();
    array_delete(getAiSpeciesArray("axis", "all"));
    if (isDefined(level.antiCamp)) self thread ffa_antiCamp();
    self setWeaponAmmoClip("stielhandgranate", 2);
    wait 5;
    array_delete(getAiSpeciesArray("axis", "all"));
}
ffa_watchKills() {
    level endon("FFA_OVER_WIN");
    while (1) {
        self.kills = 0;
        if (self.kills >= 20) break;
        wait .05;
    }
    self thread ffa_waitForWin();
}
ffa_waitForWin() {
    level notify("FFA_OVER_WIN");
    array_thread(getPlayers(), ::welcomeText, "^1Gametype: ^7Free For All", "^2WINNER: ^7" + self getName());
    wait 5;
    array_thread(getPlayers(), ::_hideSeek_timeoutInit);
}
ffa_door() {
    self activatePower();
    wait 10;
    self thread deleteTrigger("zombie_door");
}
ffa_hud(FOT, time) {
    self.FFAHud = self createRectangle("CENTER", "MIDDLE", 0, 0, 1000, 1000, (0, 0, 0), "white", 1000, 0);
    self.FFAHud fadeOverTime(FOT);
    self.FFAHud.alpha = 1;
    wait time;
    self.FFAHud fadeOverTime(FOT);
    self.FFAHud.alpha = 0;
    wait FOT;
    self.FFAHud destroyElem();
}
ffa_dvars() {
    self thread deleteTrigger("weapon_upgrade");
    self thread deleteTrigger("treasure_chest_use");
    self thread deleteTrigger("zombie_vending_upgrade");
    self thread deleteTrigger("bowie_upgrade");
    self thread teleDelete();
    self enableHealthShield(false);
    self disableInvulnerability();
    self setClientDvar("player_sustainAmmo", 0);
    self setClientDvar("g_gravity", 800);
    self setClientDvar("jump_height", 39);
    self setClientDvar("bg_fallDamageMinHeight", 200);
    self setClientDvar("bg_fallDamageMaxHeight", 350);
    self setClientDvar("r_specularMap", 1);
    self setClientDvar("player_meleeRange", 64);
    self setClientDvar("player_sprintSpeedScale", 1.5);
    self setClientDvar("player_sprintCameraBob", .5);
    self setClientDvar("player_sprintUnlimited", 0);
    self unSetPerk("specialty_armorvest");
    self unSetPerk("specialty_quickrevive");
    self unSetPerk("specialty_fastreload");
    self unSetPerk("specialty_rof");
}
openPackDoor() {
    Door = getEnt("pack_door", "targetname");
    Clip = getEntArray("pack_door_clip", "targetname");
    Door moveZ(-120, 3, 1);
    Door playSound("packa_door_2");
    for (i = 0; i < Clip.size; i++) {
        Clip[i] connectPaths();
        Clip[i] delete();
    }
}
ffa_deathCheck() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        self waittill("FFA_PLAYER_KILLED");
        self thread ffa_killPlayer();
        if (self.killstreak >= 2) self notify("YOU_WERE_KILLED");
        self takeWeapon(self.ffa_currentWeapon);
        self takeWeapon(self.PerkUpgradeWeap);
        self disableWeapons();
        self.killstreak = 0;
        if (!isDefined(level.quickScopeLobby)) self updateFFAText();
        if (getMap() == "nzp") self setOrigin((-156.993, -460.424, 1.125));
        else self setOrigin((-932.875, -39.125, 199.125));
        self setPlayerAngles((0, 180, 0));
        self freezeControls(true);
        self hide();
        self thread ffa_hud(.3, 5);
        self thread ffa_deathHud();
        wait 5;
        self enableWeapons();
        self thread pickSpawnPoints();
        self allowJump(true);
        self giveWeapon("stielhandgranate", 2);
        self setWeaponAmmoClip("stielhandgranate", 2);
        if (isDefined(level.quickScopeLobby)) self thread qs_giveWeapon();
        else self ffa_randomWeapon();
        self setStance("stand");
        self freezeControls(false);
        self show();
        self giveMaxAmmo(self.ffa_currentWeapon);
        self setWeaponAmmoClip(self.ffa_currentWeapon, 999);
    }
}
ffa_fireWeapon() {
    self endon("death");
    self endon("disconnect");
    if (isDefined(level.quickScopeLobby)) self thread FFAFire2(500);
    else self thread FFAFire2(50);
    self thread FFAFire3();
    while (true) {
        self.FriendFireLoc = bulletTrace(self getTagOrigin("j_head"), self getTagOrigin("j_head") + anglesToForward(self getPlayerAngles()) * 1000000, true, self);
        self.FriendFireMeleeLoc = bulletTrace(self getTagOrigin("j_head"), self getTagOrigin("j_head") + anglesToForward(self getPlayerAngles()) * 50, true, self);
        wait .05;
    }
}
FFAFire2(damage) {
    self endon("death");
    self endon("disconnect");
    while (true) {
        self waittill("weapon_fired");
        Entity = self.FriendFireLoc["entity"];
        Entity doDamage(damage, self.origin, undefined, undefined, "riflebullet");
        Fx2 = level._effect["bloodspurt"];
        PlayFx(Fx2, Entity getTagOrigin("J_Shoulder_LE"));
        PlayFx(Fx2, Entity getTagOrigin("J_Shoulder_RI"));
        PlayFx(Fx2, Entity getTagOrigin("J_Shoulder_LE"));
        PlayFx(Fx2, Entity getTagOrigin("J_Shoulder_RI"));
        PlayFx(Fx2, Entity getTagOrigin("J_wrist_RI"));
        PlayFx(Fx2, Entity getTagOrigin("J_wrist_LE"));
        PlayFx(Fx2, Entity getTagOrigin("J_SpineLower"));
        PlayFx(Fx2, Entity getTagOrigin("J_SpineUpper"));
        if (Entity.health <= 1 && isDefined(Entity.team)) self ffa_killConfirm(Entity, 100);
    }
}
FFAFire3() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        while (self isMeleeing()) {
            Entity = self.FriendFireMeleeLoc["entity"];
            Entity doDamage(1000, self.origin, undefined, undefined, "riflebullet");
            if (Entity.health <= 1 && isDefined(Entity.team)) self ffa_killConfirm(Entity, 100);
            wait .05;
        }
        wait .05;
    }
}
ffa_perks() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        if (self.killstreak == 2 && !self hasPerk("specialty_fastreload")) {
            self thread ffa_setPerks("specialty_fastreload", "specialty_fastreload_zombies", 0);
            self iPrintln("Perk Acquired: ^2Sleight of Hand");
        }
        if (self.killstreak == 4 && !self hasPerk("specialty_rof")) {
            self thread ffa_setPerks("specialty_rof", "specialty_doubletap_zombies", 30);
            self iPrintln("Perk Acquired: ^2Double Tap");
        }
        if (self.killstreak == 6 && !self hasPerk("specialty_bulletaccuracy")) {
            self thread ffa_setPerks("specialty_bulletaccuracy");
            self iPrintln("Perk Acquired: ^2Steady Aim");
        }
        if (self.killstreak == 7 && !isDefined(self.ffa_upgradePerk) && getMap() == "nzf") {
            self.ffa_upgradePerk = true;
            self takeWeapon(self.ffa_currentWeapon);
            self giveWeapon(self.ffa_currentWeapon + "_upgraded");
            self switchToWeapon(self.ffa_currentWeapon + "_upgraded");
            self.PerkUpgradeWeap = self.ffa_currentWeapon + "_upgraded";
            self iPrintln("Weapon ^2Upgraded");
        }
        wait .05;
    }
}
ffa_setPerks(perk, shader, x) {
    self setPerk(perk);
    hud = undefined;
    if (isDefined(shader) && getMap() != "nzp") {
        hud = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", x, -40, 100, 100, (1, 1, 1), shader, 1, 1);
        hud scaleOverTime(.4, 25, 25);
    }
    self waittill("YOU_WERE_KILLED");
    self.ffa_upgradePerk = undefined;
    self unSetPerk(perk);
    if (isDefined(hud)) hud destroy();
}
ffa_grenade() {
    self endon("disconnect");
    self endon("death");
    entityNumber = self getEntityNumber();
    while (true) {
        self waittill("grenade_fire", GrenadeWeapon);
        self thread ffa_grenadeFollow(GrenadeWeapon);
        GrenadeWeapon waittill("explode");
        for (a = 0; a < getPlayers().size; a++) {
            if (getPlayers()[a] == self) continue;
            getPlayers()[a] thread ffa_grenadeCheckKill(a, entityNumber);
        }
    }
}
ffa_grenadeCheckKill(k, PlayerFrag) {
    P = getPlayers();
    if (Distance(P[k].origin, P[PlayerFrag].myGren) <= 250) {
        P[k] doDamage(1000, P[PlayerFrag].myGren, undefined, undefined, "riflebullet");
        P[k] viewKick(2, P[PlayerFrag].myGren);
        P[PlayerFrag] thread ffa_killConfirm(P[k], 60);
    }
}
ffa_grenadeFollow(gren) {
    Gren endon("explode");
    while (true) {
        self.myGren = gren.origin;
        wait .01;
    }
}
ffa_killConfirm(killed, num) {
    killed notify("FFA_PLAYER_KILLED");
    killed thread ffa_dead();
    for (i = 0; i < getPlayers().size; i++) getPlayers()[i] iPrintln(self.playername + " ^2> ^1" + ffa_getRandomComment() + " ^2> ^7" + killed.playername);
    self.kills++;
    self.killstreak++;
    self.score_total = self.score_total + num;
    self.score = self.score + num;
    self set_player_score_hud();
    if (!isDefined(level.quickScopeLobby)) self updateFFAText();
}
ffa_deathHud() {
    Countdown = self createText("objective", 2, "Center", "Middle", 0, 0, 1, 1, "5");
    Countdown thread ffa_bigHud();
    wait 1;
    Countdown setText("4");
    Countdown.fontscale = 2;
    Countdown thread ffa_bigHud();
    wait 1;
    Countdown setText("3");
    Countdown.fontscale = 2;
    Countdown thread ffa_bigHud();
    wait 1;
    Countdown setText("2");
    Countdown.fontscale = 2;
    Countdown thread ffa_bigHud();
    wait 1;
    Countdown setText("1");
    Countdown.fontscale = 2;
    Countdown thread ffa_bigHud();
    wait 1;
    Countdown thread hudFadenDestroy(0, .3);
    wait .3;
}
ffa_bigHud() {
    for (i = self.fontscale; i <= 3; i += .1) {
        self.fontscale = i;
        wait .1;
    }
}
ffa_getRandomComment() {
    Com = [];
    Com[0] = "Killed";
    Com[1] = "Fucked";
    Com[2] = "Jizzed On";
    Com[3] = "Banged";
    Com[4] = "Bitch Slapped";
    Com[5] = "Cock Slapped";
    Com[8] = "Raped";
    Com[9] = "Flopped";
    Com[11] = "Took a Mean Ass Shit On";
    Com[12] = "Ass Punched";
    Com[13] = "Jew Smacked";
    Com[14] = "Butt Raped";
    RandCom = randomIntRange(0, Com.size);
    return Com[RandCom];
}
ffa_killPlayer() {
    wait .1;
    body = spawn("script_model", self.origin + (0, 0, 2));
    body setModel(self.model);
    body startRagDoll();
    wait 15;
    body delete();
}
ffa_dead() {
    Fx1 = level._effect["headshot"];
    Fx2 = level._effect["bloodspurt"];
    PlayFx(Fx1, self getTagOrigin("j_head"));
    PlayFx(Fx1, self getTagOrigin("J_neck"));
    PlayFx(Fx1, self getTagOrigin("J_Shoulder_LE"));
    PlayFx(Fx1, self getTagOrigin("J_Shoulder_RI"));
    PlayFx(Fx2, self getTagOrigin("J_Shoulder_LE"));
    PlayFx(Fx2, self getTagOrigin("J_Shoulder_RI"));
    PlayFx(Fx1, self getTagOrigin("J_Ankle_RI"));
    PlayFx(Fx1, self getTagOrigin("J_Ankle_LE"));
    PlayFx(Fx2, self getTagOrigin("J_Ankle_RI"));
    PlayFx(Fx2, self getTagOrigin("J_Ankle_LE"));
    PlayFx(Fx2, self getTagOrigin("J_wrist_RI"));
    PlayFx(Fx2, self getTagOrigin("J_wrist_LE"));
    PlayFx(Fx1, self getTagOrigin("J_SpineLower"));
    PlayFx(Fx1, self getTagOrigin("J_SpineUpper"));
}
ffa_randomWeapon() {
    weap = [];
    if (getMap() == "nzp") weap = strTok("stg44|thompson|mp40|bar|mg42_bipod", "|");
    if (getMap() == "nza") weap = strTok("stg44|thompson|mp40|ppsh|bar|mg42_bipod", "|");
    if (getMap() == "nzs") weap = strTok("zombie_stg44|zombie_thompson|zombie_mp40|zombie_type100_smg|zombie_ppsh|zombie_mg42", "|");
    if (getMap() == "nzf") weap = strTok("zombie_stg44|zombie_thompson|zombie_mp40|zombie_type100_smg|zombie_ppsh|zombie_mg42|zombie_bar", "|");
    randomWeap = randomIntRange(0, weap.size);
    self giveWeapon(weap[randomWeap]);
    self switchToWeapon(weap[randomWeap]);
    self giveMaxAmmo(weap[randomWeap]);
    self.ffa_currentWeapon = weap[randomWeap];
}
ffa_antiCamp() {
    self endon("disconnect");
    self endon("death");
    while (true) {
        while (!IsDefined(self.revivetrigger)) {
            OldPos = self getOrigin();
            wait 7;
            NewPos = self getOrigin();
            if (Distance(OldPos, NewPos) < 25) {
                self freezeControls(true);
                self enableInvulnerability();
                self playLocalSound("flytrap_creeper");
                self playLocalSound("sam_fly_last");
                NoCamp = createFontString("objective", 2, self);
                NoCamp setPoint("", "", 0, 100);
                NoCamp setText("Anti-Camp System Breached!");
                wait .5;
                NoCamp setText("^1Anti-Camp System Breached!");
                wait .5;
                NoCamp setText("Anti-Camp System Breached!");
                wait .5;
                NoCamp setText("^1Anti-Camp System Breached!");
                self ffa_noCamping();
                self thread pickSpawnPoints();
                self disableInvulnerability();
                self freezeControls(false);
                Gun = self getCurrentWeapon();
                self takeWeapon(Gun);
                self giveWeapon(self.ffa_currentWeapon);
                self switchToWeapon(self.ffa_currentWeapon);
                if (self.killstreak >= 2) self notify("YOU_WERE_KILLED");
                self.killstreak = 0;
                self updateFFAText();
                NoCamp destroyElem();
            }
            wait .01;
        }
        wait .01;
    }
}
ffa_noCamping() {
    self setStance("stand");
    Link = spawn("script_origin", (-42, 200 + self getEntityNumber() * 200, 466.125));
    Link.angles = (0, 90, 0);
    self freezeControls(true);
    self playerLinkToAbsolute(Link);
    Link rotateYaw(360, 1.5);
    wait 1.5;
    Link rotateYaw(-360, 1.5);
    wait 1.5;
    self freezeControls(false);
    self unlink();
    Link delete();
}
qs_start() {
    self thread ffa_hud(1, 5);
    self.kills = 0;
    self.killstreak = 0;
    self.IsPlayerFFA = true;
    self freezeControls(true);
    self takeAllGuns();
    self giveWeapon("stielhandgranate", 2);
    self.team = "axis";
    self thread qs_noGrenades();
    self thread qs_noHardScope();
    self disableWeaponCycling();
    wait 5;
    self thread qs_giveWeapon();
    self freezeControls(false);
    self thread pickSpawnPoints();
    self setStance("stand");
    self thread ffa_deathCheck();
    self thread ffa_fireWeapon();
    self thread ffa_perks();
    self thread ffa_grenade();
    array_delete(getAiSpeciesArray("axis", "all"));
    self setWeaponAmmoClip("stielhandgranate", 2);
    wait 5;
    array_delete(getAiSpeciesArray("axis", "all"));
}
qs_giveWeapon() {
    W = [];
    W[0] = "ptrs41_zombie";
    if (getMap() == "nzp") W[1] = "kar98k_scoped_zombie";
    Weapon = randomIntRange(0, W.size);
    self giveWeapon(W[Weapon], 0);
    self switchToWeapon(W[Weapon], 0);
    self giveMaxAmmo(W[Weapon], 0);
    self.ffa_currentWeapon = W[Weapon];
}
qs_noGrenades() {
    self endon("disconnect");
    while (true) {
        self giveMaxAmmo(self.Weapon);
        self takeWeapon("stielhandgranate");
        self takeWeapon("fraggrenade");
        wait .5;
    }
}
qs_noHardScope() {
    self endon("disconnect");
    while (true) {
        while (self adsButtonPressed()) {
            wait .75;
            if (self adsButtonPressed()) self allowADS(false);
        }
        self allowADS(true);
        wait .02;
    }
}
qs_instaKill() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        level.zombie_vars["zombie_insta_kill"] = 1;
        wait .1;
    }
}
cycleControl() {
    self setClientDvar("g_friendlyfireDist", 0);
    self disableOffHandWeapons();
    self thread gunGameDetection();
    cycle = strTok("walther;zombie_shotgun;zombie_doublebarrel;zombie_thompson;zombie_type100_smg;zombie_mp40;zombie_ppsh;zombie_m1garand;zombie_gewehr43;zombie_m1carbine;zombie_stg44;zombie_bar;zombie_fg42;zombie_30cal;zombie_mg42;zombie_kar98k;ptrs41_zombie", ";");
    while (true) {
        if (!self hasWeapon(cycle[self.cycle])) {
            self takeAllGuns();
            self giveWeapon(cycle[self.cycle]);
            self switchToWeapon(cycle[self.cycle]);
            self giveMaxAmmo(cycle[self.cycle]);
        }
        wait .05;
    }
}
gunGameLeader() {
    level.gunTxt = createServerText(getFont(), 1.2, "LEFT", "LEFT", 60, 70, 1, 1, "^6Player Gun Ranks:");
    timeHud = createServerText(getFont(), 1.2, "LEFT", "LEFT", 60, 80 + (getPlayers().size * 10), 1, 1, undefined);
    for (m = 0; m < getPlayers().size; m++) getPlayers()[m].gunGameHud = createServerText(getFont(), 1, "LEFT", "LEFT", 60, 80 + (m * 10), 1, 1, undefined);
    array_thread(getPlayers(), ::gunGameHuds);
    while (true) {
        dist = getPlayers()[0].cycle;
        index = 0;
        for (m = 1; m < getPlayers().size; m++) {
            temp_dist = getPlayers()[m].cycle;
            if (temp_dist > dist) {
                dist = temp_dist;
                index = m;
            }
        }
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a].gameModeInfo setText("Current Leader: ^2" + getPlayers()[index] getName());
        wait .05;
    }
}
gunGameHuds() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        cycle = self.cycle;
        gun = self getCurrentWeapon();
        wait .05;
        if (cycle != self.cycle || gun != self getCurrentWeapon()) self.gunGameHud setText("^2" + self getName() + ": ^7[" + (self.cycle + 1) + "] " + weaponNames(self getCurrentWeapon()));
    }
}
gunGameDetection() {
    knife = strTok("Knifed;Stabbed;Shanked;Sliced", ";");
    shot = strTok("Shot;Killed;Wasted;Smoked", ";");
    while (true) {
        self waittill("player_killed", enemy, weapon, damage, mod);
        if (mod == "MOD_MELEE") {
            iPrintln("^2" + self getName() + " ^7> " + knife[randomInt(knife.size)] + " > ^1" + enemy getName());
            self thread Ranked("Humiliation", "Demoted Enemy!");
            self playSound("knife_stab_plr");
            self playSound("melee_knife_hit_other");
            enemy thread GGDeath(self, "HUMILIATED");
            if (enemy.cycle > 0) enemy.cycle--;
        } else {
            self.cycle++;
            iPrintln("^2" + self getName() + " ^7> " + shot[randomInt(shot.size)] + " > ^1" + enemy getName());
            if (self.cycle == 17) array_thread(getPlayers(), ::gunGameEndon, self getName());
            else self thread ranked("Player Killed", "Advanced To The Next Tier!");
            enemy thread GGDeath(self, "KILLED");
        }
    }
}
gunGameEndon(winner) {
    self notify("gunGame_over");
    self freezeControls(true);
    self.gunGameHud destroy();
    if (self == getPlayers()[0]) level.gunTxt destroy();
    self welcomeText("^1" + level.patch, "^2" + winner + " ^7Is The Winner! -- ^2Created By: ^7" + level.creator);
    self suicide();
}
GGDeath(attacker, method) {
    self Hide();
    self DisableWeapons();
    self FreezeControls(true);
    if (IsDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive(self);
    body = spawnSM(self.origin, self.backUp["body"], self.angles);
    if (isDefined(self.backUp["head"])) body attach(self.backUp["head"], "", true);
    if (isDefined(self.backUp["hat"])) body attach(self.backUp["hat"], "", true);
    if (isDefined(self.backUp["gear"])) body attach(self.backUp["gear"], "", true);
    body startRagDoll();
    body thread deleteAfter30();
    self thread scavPack();
    self setOrigin((self.origin[0], self.origin[1], self.origin[2] - 100));
    bg = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", -1, 1);
    hud1 = self createText("smallFixed", 1.2, "CENTER", "CENTER", 0, -10, 1, 1, "YOU WERE " + method + " BY:");
    hud2 = self createText("smallFixed", 1.2, "CENTER", "CENTER", 0, 10, 1, 1, "^1" + attacker.playername);
    wait 4.9;
    self Show();
    self FreezeControls(false);
    self EnableWeapons();
    self pickSpawnPoints();
    self setWeaponAmmoClip(self getCurrentWeapon(), 1000);
    self giveMaxAmmo(self getCurrentWeapon());
    wait .1;
    hud1 destroy();
    hud2 destroy();
    bg destroy();
    self.health = self.maxhealth;
}
pickSpawnPoints() {
    point = [];
    yaw = [];
    if (getMap() == "nzp") {
        point[0] = (248, 557, 1.125);
        point[1] = (-175, -540, 2.125);
        point[2] = (315, 357, 3.125);
        point[3] = (185, -245, 6.53345);
        point[4] = (278, 169, 1.125);
        point[5] = (175, 15, 80.2247);
        point[6] = (190, -840, 0.709649);
        point[7] = (-180, -845, 1.125);
        point[8] = (166, 120, 0.932181);
        point[9] = (-175, -280, 1.125);
        point[10] = (34, 558, 1.125);
        point[11] = (-178, 555, 1.125);
        yaw[0] = (0, -135, 0);
        yaw[1] = (0, -45, 0);
        yaw[2] = (0, -180, 0);
        yaw[3] = (0, -135, 0);
        yaw[4] = (0, 135, 0);
        yaw[5] = (0, -135, 0);
        yaw[6] = (0, 135, 0);
        yaw[7] = (0, 45, 0);
        yaw[8] = (0, -135, 0);
        yaw[9] = (0, 45, 0);
        yaw[10] = (0, -45, 0);
        yaw[11] = (0, -45, 0);
    }
    if (getMap() == "nza") {
        point[0] = (825, -181, 64.125);
        point[1] = (828, 308, 64.125);
        point[2] = (1110, 460, 64.125);
        point[3] = (885, 109, 64.125);
        point[4] = (896, 450, 64.125);
        point[5] = (1152, 104, 75.5376);
        point[6] = (1532, 205, 64.125);
        point[7] = (1319, -470, 64.125);
        point[8] = (827, -436, 64.125);
        point[9] = (1240, 15, 64.125);
        point[10] = (1015, -661, 136.125);
        yaw[0] = (0, 135, 0);
        yaw[1] = (0, -135, 0);
        yaw[2] = (0, -135, 0);
        yaw[3] = (0, 45, 0);
        yaw[4] = (0, -45, 0);
        yaw[5] = (0, 135, 0);
        yaw[6] = (0, 180, 0);
        yaw[7] = (0, 180, 0);
        yaw[8] = (0, -135, 0);
        yaw[9] = (0, -45, 0);
        yaw[10] = (0, 90, 0);
    }
    if (getMap() == "nzs") {
        point[0] = (9564, 294, -528.875);
        point[1] = (9562, 740, -528.875);
        point[2] = (9659, 541, -528.875);
        point[3] = (9882, 548, -528.875);
        point[4] = (10121, 816, -517.625);
        point[5] = (10452, 819, -527.875);
        point[6] = (10640, 291, -513.006);
        point[7] = (10173, 363, -528.875);
        point[8] = (10315, 519, -528.875);
        yaw[0] = (0, 45, 0);
        yaw[1] = (0, -45, 0);
        yaw[2] = (0, -180, 0);
        yaw[3] = (0, 90, 0);
        yaw[4] = (0, -45, 0);
        yaw[5] = (0, -90, 0);
        yaw[6] = (0, 180, 0);
        yaw[7] = (0, 0, 0);
        yaw[8] = (0, -135, 0);
    }
    if (getMap() == "nzf") {
        point[0] = (205, -637, 36.154);
        point[1] = (-69, -633, 36.9852);
        point[2] = (38, 47, -2.875);
        point[3] = (281, 493, -2.875);
        point[4] = (316, 607, 9.25249);
        point[5] = (86, 604, -2.875);
        point[6] = (-262, -343, -2.875);
        point[7] = (-381, -207, -2.875);
        point[8] = (-131, 46, -2.875);
        point[9] = (-208, 607, -2.875);
        point[10] = (-564, 626, -2.875);
        point[11] = (-569, 493, -2.875);
        point[12] = (-705, 155, 5.67246);
        point[13] = (-415, -141, 69.125);
        point[14] = (-142, 433, 93.125);
        point[15] = (33, 94, 93.125);
        point[16] = (-145, 93, 93.125);
        point[17] = (32, 439, 93.125);
        point[18] = (-172, -621, -142.875);
        yaw[0] = (0, 135, 0);
        yaw[1] = (0, 45, 0);
        yaw[2] = (0, -45, 0);
        yaw[3] = (0, 135, 0);
        yaw[4] = (0, 225, 0);
        yaw[5] = (0, -45, 0);
        yaw[6] = (0, 90, 0);
        yaw[7] = (0, 0, 0);
        yaw[8] = (0, -135, 0);
        yaw[9] = (0, -135, 0);
        yaw[10] = (0, -45, 0);
        yaw[11] = (0, 45, 0);
        yaw[12] = (0, 0, 0);
        yaw[13] = (0, 45, 0);
        yaw[14] = (0, -45, 0);
        yaw[15] = (0, 135, 0);
        yaw[16] = (0, 45, 0);
        yaw[17] = (0, -135, 0);
        yaw[18] = (0, 90, 0);
    }
    randy = randomInt(point.size);
    self setOrigin(point[randy]);
    self setPlayerAngles(yaw[randy]);
    self setStance("stand");
}
Ranked(Txt1, Txt2) {
    if (isDefined(self.gunGameHasHuds)) return;
    self.gunGameHasHuds = true;
    Text = 0;
    Info = Txt1;
    Temp = "";
    for (i = 0; i < Info.size; i++) {
        Temp += Info[i];
        Text = createText(getFont(), 2, "CENTER", "TOP", 0, 20, 2, 1, Temp);
        wait .1;
        if (i != Info.size - 1) Text Destroy();
    }
    Fx = self CreateRectangle("CENTER", "TOP", 10, 25, 300, 100, (1, 0, 0), "scorebar_zom_1", 1, 0);
    Fx thread HUDFade(1, .5);
    Below = createText(getFont(), 1.5, "CENTER", "TOP", 0, 35, 2, 0, Txt2);
    Below HUDFade(1, .5);
    wait 2;
    Text Destroy();
    Fx Destroy();
    Below Destroy();
    self.gunGameHasHuds = undefined;
}
scavPack() {
    ammo = spawnSM(self.origin + (0, 0, 40), "grenade_bag");
    ammo physicsLaunch();
    playFxOnTag(level._effect["powerup_on"], ammo, "tag_origin");
    ammo thread scavDelete();
    wait .1;
    while (true) {
        old = ammo getOrigin();
        wait .05;
        new = ammo getOrigin();
        if (old == new) break;
    }
    trig = spawnTrig(ammo.origin, 20, 10, "HINT_NOICON", "");
    while (isDefined(ammo)) {
        trig waittill("trigger", i);
        i setWeaponAmmoStock(i getCurrentWeapon(), i getWeaponAmmoStock(i getCurrentWeapon()) + 30);
        playSoundAtPosition("ammo_pickup", ammo.origin);
        playFx(loadFx("misc/fx_zombie_powerup_wave"), ammo.origin);
        ammo delete();
    }
}
pvpThread() {
    self endon("disconnect");
    self endon("death");
    self endon("pvp_over");
    self enableHealthShield(false);
    while (true) {
        self waittill("weapon_pvp_attack", attacker, weapon, damage, mod);
        attacker thread doHitMarker();
        if (mod == "MOD_MELEE") self doDamage(((10 * 10) * 10), attacker.origin, undefined, undefined, "melee");
        if (mod == "MOD_RIFLE_BULLET") {
            if (weaponIsBoltAction(attacker getCurrentWeapon()) || isSubStr(attacker getCurrentWeapon(), "ptrs41")) self doDamage(((10 * 10) * 10), attacker.origin, undefined, undefined, "riflebullet");
            else self doDamage((damage * 8), attacker.origin, undefined, undefined, "riflebullet");
        }
        if (mod == "MOD_PISTOL_BULLET") {
            if (weaponClass(attacker getCurrentWeapon()) == "smg") {
                if (isSubStr(attacker getCurrentWeapon(), "type") || isSubStr(attacker getCurrentWeapon(), "mp40")) self doDamage(((damage) * 8), attacker.origin, undefined, undefined, "pistolbullet");
                else if (isSubStr(attacker getCurrentWeapon(), "ppsh")) self doDamage(((damage) * randomIntRange(2, 3)), attacker.origin, undefined, undefined, "pistolbullet");
                else self doDamage(((damage) * 6), attacker.origin, undefined, undefined, "pistolbullet");
            } else if (weaponClass(attacker getCurrentWeapon()) == "spread") self doDamage(((damage) * 10), attacker.origin, undefined, undefined, "pistolbullet");
            else self doDamage(((damage) * randomIntRange(4, 8)), attacker.origin, undefined, undefined, "pistolbullet");
        }
        if (mod == "MOD_THROWKNIFE") self doDamage(((10 * 10) * 10), attacker.origin, undefined, undefined, "melee");
        if (isDefined(self.revivetrigger)) attacker notify("player_killed", self, weapon, damage, mod);
    }
}
doHitMarker() {
    if (isDefined(self.hitMarker)) self.hitMarker.alpha = 1;
    else self.hitMarker = self createRectangle("", "", 0, 0, 24, 48, (1, 1, 1), "damage_feedback", 1, 1);
    self.hitMarker hudFadenDestroy(0, 1);
    self.hitMarker = undefined;
}
tigPick() {
    level.tig = [];
    for (m = 0; m < getPlayers().size; m++) level thread generateRandyScore(getPlayers()[m]);
    level.tig["it"] = [];
    wait 6;
    index = 0;
    array = level.tig["it"];
    for (m = 1; m < array.size; m++)
        if (array[m] < array[m - 1]) index = m;
    level.tig["it"] = getPlayers()[index];
    plr = level.tig["it"];
    plr setOrigin((308, -1678, 54));
    plr setPlayerAngles((0, 90, 0));
    plr thread tigger();
}
tigger() {
    self setClientDvar("player_sprintUnlimited", 1);
    self attach("zombie_teddybear", "j_ankle_le");
    self attach("zombie_teddybear", "j_ankle_ri");
    self playSound("laugh_child");
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a].gameModeInfo setText("^2" + self getName() + " ^7Is The Seeker!");
    self enableWeapons();
    self giveWeapon("zombie_melee");
    self switchToWeapon("zombie_melee");
    self setMoveSpeedScale(1.2);
    self.team = "axis";
    self freezeControls(true);
    wait 5;
    self freezeControls(false);
    while (true) {
        trace = bulletTrace(self getTagOrigin("j_head"), self getTagOrigin("j_head") + anglesToForward(self getPlayerAngles()) * 50, true, self);
        ent = trace["entity"];
        if (isDefined(ent) && ent.team == "allies")
            if (self meleeButtonPressed()) {
                ent thread tigger();
                break;
            }
        wait .05;
    }
    self deTach("zombie_teddybear", "j_ankle_le");
    self deTach("zombie_teddybear", "j_ankle_ri");
    self setClientDvar("player_sprintUnlimited", 0);
    self disableWeapons();
    self setMoveSpeedScale(1);
    self.team = "allies";
}
generateRandyScore(player) {
    player freezeControls(true);
    size = getPlayers().size - 1;
    text = createServerText("smallFixed", 1.2, "CENTER", "CENTER", (size * -100) + player getEntityNumber() * 200, 10, 1, 1, "");
    name = createServerText("smallFixed", 1.2, "CENTER", "CENTER", (size * -100) + player getEntityNumber() * 200, -10, 1, 1, player getName());
    speed = .1;
    score = 0;
    for (a = 0; a < 14; a++) {
        speed += .1;
        score = randomIntRange(-500, 500);
        text setValue(score);
        if (score < 0) text.color = (1, 0, 0);
        if (score > 0) text.color = (0, 1, 0);
        if (score == 0) text.color = (1, 1, 1);
        wait(speed / 2);
    }
    level.tig["it"][player getEntityNumber()] = score;
    wait .2;
    if (level.tig["it"] == player)
        for (a = 0; a < 5; a++) {
            text.color = (1, 1, 0);
            wait .1;
            text.color = (1, 0, 0);
            wait .1;
        }
    text thread hudFadenDestroy(0, 3);
    name thread hudFadenDestroy(0, 3);
    if (level.tig["it"] != player) player freezeControls(false);
}
initStructures() {
    pos = [];
    pos[0] = (-1570, -1123, 199.125);
    pos[1] = (1364, 1040, 168.125);
    pos[2] = (449, -3034, 156.125);
    pos[3] = (-471, 549, -2.875);
    ang = [];
    ang[0] = (0, 0, 0);
    ang[1] = (0, -180, 0);
    ang[2] = (0, -180, 0);
    ang[3] = (0, 0, 0);
    hud = [];
    hud[0] = "-26 -26";
    hud[1] = "50 37";
    hud[2] = "-78 8";
    hud[3] = "42 -12";
    rInt = arrayIntRandomize(0, 3);
    for (a = 0; a < getPlayers().size; a++) {
        sPos = pos[rInt[a]];
        spawnObjPointer(getPlayers()[a], sPos + (0, 0, 100), "offscreen_icon_us", false);
        spawnSM(sPos + (50, 50, 0), "static_peleliu_filecabinet_metal", (0, -90, 0));
        spawnSM(sPos + (-50, 50, 0), "static_peleliu_filecabinet_metal", (0, 90, 0));
        spawnSM(sPos + (50, -50, 0), "static_peleliu_filecabinet_metal", (0, -90, 0));
        spawnSM(sPos - (50, 50, 0), "static_peleliu_filecabinet_metal", (0, 90, 0));
        spawnSM(sPos + (50, 50, 0), "static_peleliu_filecabinet_metal");
        spawnSM(sPos + (-50, 50, 0), "static_peleliu_filecabinet_metal");
        spawnSM(sPos + (50, -50, 0), "static_peleliu_filecabinet_metal", (0, 180, 0));
        spawnSM(sPos - (50, 50, 0), "static_peleliu_filecabinet_metal", (0, 180, 0));
        level thread doStructureFx(sPos);
        level thread doStructureFx2(sPos + (-50, -50, 30));
        plr = getPlayers()[a];
        plr.invenSkulls = 0;
        plr.depoSkulls = 0;
        plr.withdrawnSkulls = 0;
        plr updateScavengerText();
        plr thread showMyStation(hud[rInt[a]], rInt[a]);
        plr thread stationWatch(sPos);
        plr thread skullExplosion();
        plr thread scoreBoard();
        plr thread skullDisplay();
        plr.homeBase = [];
        plr.homeBase["origin"] = sPos;
        plr.homeBase["angles"] = ang[rInt[a]];
    }
}
doStructureFx(pos) {
    light = [];
    randy = randomInt(360);
    for (a = randy; a <= randy + 360; a += 30) {
        light[light.size] = spawnSM(pos + (cos(a) * 20, sin(a) * 20, 0), "zombie_zapper_cagelight_green", (180, 0, 0));
        wait .05;
    }
    while (true) {
        randy = randomInt(light.size);
        for (a = randy; a < light.size; a++) {
            light[a] setModel("zombie_zapper_cagelight_red");
            wait .05;
        }
        for (a = 0; a < randy; a++) {
            light[a] setModel("zombie_zapper_cagelight_red");
            wait .05;
        }
        randy = randomInt(light.size);
        for (a = randy; a < light.size; a++) {
            light[a] setModel("zombie_zapper_cagelight_green");
            wait .05;
        }
        for (a = 0; a < randy; a++) {
            light[a] setModel("zombie_zapper_cagelight_green");
            wait .05;
        }
    }
}
doStructureFx2(pos) {
    fx = spawnSM(pos, "tag_origin");
    playFxOnTag(level._effect["tesla_bolt"], fx, "tag_origin");
    while (true) {
        fx moveX(100, .4);
        wait .4;
        fx moveY(100, .4);
        wait .4;
        fx moveX(-100, .4);
        wait .4;
        fx moveY(-100, .4);
        wait .4;
    }
}
initSkullZombies() {
    while (true) {
        zom = getAiSpeciesArray("axis", "all");
        for (a = 0; a < zom.size; a++)
            if (!isDefined(zom[a].skullInit) && zom[a] inMap() && isDefined(zom[a])) zom[a] thread skullZomInit();
        wait .05;
    }
}
skullZomInit() {
    self.skullInit = true;
    self waittill("death");
    skull = spawnSM(self.origin + (0, 0, 40), "zombie_skull");
    skull endon("powerup_timedout");
    skull thread powerup_timeout();
    skull physicsLaunch((randomIntRange(-200, 200), randomIntRange(-200, 200), 200));
    playFxOnTag(level._effect["powerup_on"], skull, "tag_origin");
    playSoundatPosition("pa_buzz", skull.origin);
    while (isDefined(skull)) {
        plr = getPlayers();
        for (m = 0; m < plr.size; m++) {
            if (distance(plr[m].origin, skull.origin) < 64 && !isDefined(plr[m].revivetrigger)) {
                playFx(level._effect["powerup_grabbed"], skull.origin);
                playFx(level._effect["powerup_grabbed_wave"], skull.origin);
                wait .1;
                playSoundAtPosition("powerup_grabbed", skull.origin);
                skull notify("powerup_grabbed");
                plr[m] notify("skull_picked");
                skull delete();
                break;
            }
        }
        wait .05;
    }
}
skullDisplay() {
    self endon("disconnect");
    self endon("death");
    link = spawnSM(self.origin + (0, 0, 100), "tag_origin");
    skull = [];
    for (m = 0; m < 360; m += 45) {
        skull[skull.size] = spawnSM(link.origin + (cos(m) * 30, sin(m) * 30, 0), "tag_origin", (0, m, 0));
        skull[skull.size - 1] linkTo(link);
    }
    self.scavSkulls = skull;
    link thread sSkullFollowPlayer(self);
    while (true) {
        self waittill("skull_picked");
        if (self.invenSkulls == 8) {
            self iPrintln("^1ERROR: ^7Your Inventory Is Full!");
            self iPrintln("^2INFO: ^7Please Deposit Your Skulls!");
            continue;
        }
        randy = undefined;
        while (true) {
            wait .05;
            randy = randomInt(skull.size);
            if (skull[randy].model == "tag_origin") break;
        }
        skull[randy] setModel("zombie_skull");
        self.invenSkulls++;
        self updateScavengerText();
    }
}
sSkullFollowPlayer(plr) {
    plr endon("death");
    plr endon("disconnect");
    while (true) {
        self moveTo(plr.origin + (0, 0, 100), .1);
        self rotateYaw(-18, .1);
        wait .05;
    }
}
showMyStation(coords, num) {
    self endon("disconnect");
    self endon("death");
    abc = "abcd";
    coords = strTok(coords, " ");
    menu = self createRectangle("CENTER", "CENTER", 0, 0, 0, 0, (1, 1, 1), "menu_map_nazi_zombie_factory", 1, 1);
    menu scaleOverTime(.6, 200, 100);
    wait .6;
    obj = self createRectangle("CENTER", "CENTER", 0, 0, 0, 0, (1, 1, 1), "objective" + abc[num], 2, 1);
    obj scaleOverTime(.6, 15, 15);
    wait .6;
    obj moveOverTime(1);
    obj setPoint("CENTER", "CENTER", int(coords[0]), int(coords[1]));
    wait 1;
    self setOrigin(self.homeBase["origin"]);
    self setPlayerAngles(self.homeBase["angles"]);
    wait 1;
    obj moveOverTime(1);
    menu moveOverTime(1);
    obj setPoint("CENTER", "CENTER", obj.x - 200, obj.y + 160);
    menu setPoint("CENTER", "CENTER", menu.x - 200, menu.y + 160);
    wait 1;
    while (true) {
        fx = self createRectangle("CENTER", "CENTER", obj.x, obj.y, 100, 100, (1, 1, 1), "hud_checkbox_active", 3, 1);
        fx scaleOverTime(.4, 17, 17);
        wait .4;
        fx hudFadenDestroy(0, .4);
        wait(randomIntRange(5, 10));
    }
}
stationWatch(ctr) {
    self endon("disconnect");
    self endon("death");
    self.stationTrig = spawn("trigger_radius", ctr, 1, 50, 50);
    trig = self.stationTrig;
    trig thread bootTehHackers(self);
    while (true) {
        trig waittill("trigger", user);
        if (user useButtonPressed() && !user.is_zombie) {
            if (user == self) {
                if (self.invenSkulls <= 0) {
                    self playSound("packa_deny");
                    wait .2;
                } else if (self.invenSkulls > 0) {
                    time = 0;
                    bar = self createPrimaryProgressBar();
                    bar updateBar(0, 1);
                    text = self createPrimaryProgressBarText();
                    text setText("Skull Depositing!");
                    while (true) {
                        time += .05;
                        if (!self useButtonPressed() || !self isTouching(trig)) break;
                        if (time >= 1) {
                            bar destroyElem();
                            text destroy();
                            randy = undefined;
                            for (e = 0; e < 10000; e++) {
                                randy = randomInt(self.scavSkulls.size);
                                if (self.scavSkulls[randy].model == "zombie_skull") break;
                            }
                            self.scavSkulls[randy] setModel("tag_origin");
                            self.invenSkulls--;
                            self.depoSkulls++;
                            self updateScavengerText();
                            self playSound("cha_ching");
                            if (self.depoSkulls == 40) array_thread(getPlayers(), ::depoSkullsWon, self);
                            break;
                        }
                        wait .05;
                    }
                    if (isDefined(bar)) {
                        bar destroyElem();
                        text destroy();
                    }
                }
            }
            if (user != self) {
                if (self.depoSkulls <= 0) {
                    user playSound("packa_deny");
                    wait .2;
                }
                if (self.depoSkulls > 0) {
                    time = 0;
                    bar = user createPrimaryProgressBar();
                    bar updateBar(0, 1 / 5);
                    text = user createPrimaryProgressBarText();
                    text setText("Skull Withdrawing!");
                    user.isWithdrawing = true;
                    while (true) {
                        time += .05;
                        if (!user useButtonPressed() || !user isTouching(trig)) break;
                        if (time >= 5) {
                            bar destroyElem();
                            text destroy();
                            self.depoSkulls--;
                            user.withdrawnSkulls++;
                            self updateScavengerText();
                            user updateScavengerText();
                            self playLocalSound("laugh_child");
                            user playSound("plr_" + user getEntityNumber() + "_vox_gen_laugh_" + randomInt(4));
                            break;
                        }
                        wait .05;
                    }
                    user.isWithdrawing = undefined;
                    if (isDefined(bar)) {
                        bar destroyElem();
                        text destroy();
                    }
                }
            }
        }
    }
}
bootTehHackers(user) {
    self endon("disconnect");
    self endon("death");
    while (true) {
        plr = getPlayers();
        for (m = 0; m < plr.size; m++) {
            if (user isTouching(self) && plr[m] isTouching(self) && isDefined(plr[m].isWithdrawing)) {
                plr[m] setOrigin(plr[m].homeBase["origin"]);
                plr[m] setPlayerAngles(plr[m].homeBase["angles"]);
            }
        }
        wait .05;
    }
}
depoSkullsWon(winner) {
    self thread welcomeText("^1" + level.patch, "^2" + winner getName() + ": ^7Has Deposited 40 Skulls - ^6Therefore He Is The Winner! ^7-- ^2Created By: ^7" + level.creator);
    array_delete(getAiSpeciesArray("axis", "all"));
    self setClientDvar("g_ai", 0);
    self freezeControls(true);
    wait 5;
    self suicide();
}
skullExplosion() {
    self endon("disconnect");
    self endon("death");
    while (true) {
        self waittill("player_downed");
        self playLocalSound("laugh_child");
        if (self.invenSkulls == 0) continue;
        temp = [];
        for (m = 0; m < self.scavSkulls.size; m++) {
            if (self.scavSkulls[m].model == "tag_origin") continue;
            temp[temp.size] = spawnSM(self.scavSkulls[m].origin, self.scavSkulls[m].model, self.scavSkulls[m].angles);
            self.scavSkulls[m] setModel("tag_origin");
            self.invenSkulls--;
        }
        for (m = 0; m < temp.size; m++) temp[m] thread skullv2();
        self updateScavengerText();
    }
}
skullv2() {
    self endon("powerup_timedout");
    self thread powerup_timeout();
    self physicsLaunch(self.origin, (randomIntRange(-200, 200), randomIntRange(-200, 200), 200));
    playFxOnTag(level._effect["powerup_on"], self, "tag_origin");
    playSoundatPosition("pa_buzz", self.origin);
    while (isDefined(self)) {
        plr = getPlayers();
        for (m = 0; m < plr.size; m++) {
            if (distance(plr[m].origin, self.origin) < 64 && !isDefined(plr[m].revivetrigger)) {
                playFx(level._effect["powerup_grabbed"], self.origin);
                playFx(level._effect["powerup_grabbed_wave"], self.origin);
                wait .1;
                playSoundAtPosition("powerup_grabbed", self.origin);
                self notify("powerup_grabbed");
                plr[m] notify("skull_picked");
                self delete();
                break;
            }
        }
        wait .05;
    }
}
skullsRevive() {
    while (true) {
        player = getPlayers();
        for (a = 0; a < player.size; a++)
            if (isDefined(player[a].revivetrigger)) player[a] thread doRevivee();
        wait .05;
    }
}
doRevivee() {
    self endon("death");
    self endon("disconnect");
    if (isDefined(self.doingRevive)) return;
    self.doingRevive = true;
    self.revivetrigger trigger_off_proc();
    self thread createProgressBar(3, "Reviving", 2, "Revived!");
    wait 3;
    self thread maps\_laststand::revive_force_revive();
    wait .05;
    self setOrigin(self.homeBase["origin"]);
    self setPlayerAngles(self.homeBase["angles"]);
    self.doingRevive = undefined;
}
scoreBoard() {
    self endon("disconnect");
    self endon("death");
    if (self == getPlayers()[0]) createServerText(getFont(), 1.2, "TOPLEFT", "TOPLEFT", 20, 20, 1, 1, "^6Scoreboard:");
    txt = createServerText(getFont(), 1, "TOPLEFT", "TOPLEFT", 20, 30 + (self getEntityNumber() * 10), 1, 1, self getName() + ": Deposited Skulls: ^5" + self.depoSkulls);
    self thread destroyOnDeath(txt);
    while (true) {
        while (true) {
            txt.y = 30 + (self getEntityNumber() * 10);
            skulls = self.depoSkulls;
            wait .05;
            if (skulls != self.depoSkulls) break;
        }
        txt setText(self getName() + ": Deposited Skulls: ^5" + self.depoSkulls);
        wait .05;
    }
}
destroyOnDeath(hud) {
    self waittill_any("death", "disconnect");
    hud destroyElem();
}
rainDif() {
    if (!isDefined(level.rainDifficulty)) {
        level.rainDifficulty = true;
        array_thread(getPlayers(), ::updateMenu, "Difficulty [^1Hard^7]", "rain", 0);
    } else {
        level.rainDifficulty = undefined;
        array_thread(getPlayers(), ::updateMenu, "Difficulty [^2Easy^7]", "rain", 0);
    }
}
initRainPour() {
    collectedNukes = 0;
    misses = 0;
    speed = 6;
    count = 0;
    count2 = 0;
    bar = createTeamBar((1, 1, 1), 300, 6);
    bar setPoint("CENTER", "BOTTOM", 0, -50);
    speedTxt = createServerText(getFont(), 1.3, "CENTER", "BOTTOM", 0, -65, 1, 1, "SPEED: ^2200");
    array_thread(getPlayers(), ::updateRainText, 0, 0);
    while (true) {
        amount = getPlayers().size;
        nuke = [];
        for (a = 0; a < amount; a++) {
            nuke[a] = spawnSM((randomIntRange(-370, 180), randomIntRange(-300, 180), 1200), "zombie_bomb", (90, 0, 0));
            if (!isDefined(level.rainDifficulty)) {
                for (t = 0; t < getPlayers().size; t++) nuke[a] setInvisibleToPlayer(getPlayers()[t]);
                nuke[a] setVisibleToPlayer(getPlayers()[a]);
            }
            playFxOnTag(level._effect["powerup_on"], nuke[a], "tag_origin");
            nuke[a] moveTo((nuke[a].origin[0], nuke[a].origin[1], 0), speed);
            nuke[a] playSound("weap_pnzr_fire");
        }
        count2++;
        level thread rainPourCapture(nuke);
        wait(speed);
        for (m = 0; m < nuke.size; m++) {
            if (!isDefined(nuke[m])) {
                collectedNukes++;
                continue;
            }
            misses += 16;
            count++;
            if (count == 10) misses = 1000;
            playFx(loadFx("explosions/default_explosion"), nuke[m].origin);
            playSoundAtPosition("grenade_explode", nuke[m].origin);
            for (e = 0; e < getPlayers().size; e++) getPlayers()[e] doDamage(misses, nuke[m].origin, undefined, undefined, "riflebullet");
            if (!isDefined(level.rainDifficulty)) iPrintLn("--- ^2" + getPlayers()[m] getName() + " ^7--- Missed a Nuke!");
            nuke[m] delete();
        }
        array_thread(getPlayers(), ::updateRainText, count, collectedNukes);
        level notify("rainpour_captureover");
        speed -= .2;
        if (speed < 3) speed += .2;
        actualSpeed = ceil(1200 / speed);
        if (count2 <= 15) {
            bar.bar scaleOverTime(1, count2 * 20, bar.height);
            bar.bar fadeOverTime(1);
            speedTxt setText("SPEED: ^2" + actualSpeed);
        }
        wait .05;
    }
}
rainPourCapture(nuke) {
    level endon("rainpour_captureover");
    while (true) {
        for (m = 0; m < nuke.size; m++)
            for (e = 0; e < getPlayers().size; e++)
                if (distance(getPlayers()[e] getTagOrigin("j_head"), nuke[m].origin) < 60) {
                    playSoundAtPosition("powerup_grabbed", nuke[m].origin);
                    playFx(loadFx("misc/fx_zombie_powerup_grab"), nuke[m].origin);
                    playFx(loadFx("misc/fx_zombie_powerup_wave"), nuke[m].origin);
                    nuke[m] delete();
                }
        wait .05;
    }
}
teslaFreezeTags_main() {
    self endon("death");
    self endon("disconnect");
    self disableWeaponCycling();
    self disableOffhandWeapons();
    self allowProne(false);
    self thread tft_keepHealth();
    self giveWeapon("tesla_gun");
    self switchToWeapon("tesla_gun");
    self giveMaxAmmo("tesla_gun");
    self.teslaTags = 0;
    self.teslaFreeze_tagsHud = createServerText(getFont(), 1, "LEFT", "LEFT", 60, 80 + (self getEntityNumber() * 10), 1, 1, "^2" + self getName() + ": ^7[" + self.teslaTags + "] Tags");
    oldWinner = 0;
    self thread tft_detection();
    if (self == getPlayers()[0]) {
        createServerText(getFont(), 1.2, "LEFT", "LEFT", 60, 70, 1, 1, "^6Player Tesla Tags:");
        leaderHud = createServerText(getFont(), 1.2, "LEFT", "LEFT", 60, 80 + (getPlayers().size * 10), 1, 1, "^6Current Leader: " + getPlayers()[0] getName());
        while (true) {
            tags = self.teslaTags;
            index = 0;
            for (m = 0; m < getPlayers().size; m++) {
                tempTags = getPlayers()[m].teslaTags;
                if (tempTags > tags) {
                    tags = tempTags;
                    index = m;
                }
            }
            if (index != oldWinner) {
                oldWinner = index;
                leaderHud setText("^6Current Leader: " + getPlayers()[index] getName());
            }
            wait .05;
        }
    }
}
tft_detection() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        self waittill("weapon_pvp_attack", attacker, weapon, damage, mod);
        if (mod != "MOD_PROJECTILE" && mod != "MOD_PROJECTILE_SPLASH") continue;
        if (attacker == self) continue;
        attacker.teslaTags++;
        attacker.teslaFreeze_tagsHud setText("^2" + attacker getName() + ": ^7[" + attacker.teslaTags + "] Tags");
        quotes = strTok("Tagged;Zapped;Electrocuted;Shocked;Stunned;Tasered", ";");
        iPrintln("^2" + attacker getName() + " ^7> " + quotes[randomInt(quotes.size)] + " > ^2" + self getName());
        attacker thread pickSpawnPoints();
        if (attacker.teslaTags == (getPlayers().size * 10)) array_thread(getPlayers(), ::tft_endGame, attacker getName());
    }
}
tft_endGame(winner) {
    self freezeControls(true);
    self welcomeText("^1" + level.patch, "^2" + winner + " ^7Is The Winner! -- ^2Created By: ^7" + level.creator);
    self suicide();
}
tft_keepHealth() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        self.maxhealth = 100;
        self.health = self.maxhealth;
        wait .05;
    }
}
zombiesPro() {
    self thread proVars();
    self thread doGunsStart();
    self thread ifAliveGrenades();
    set_zombie_var("zombie_health_start", 700);
    set_zombie_var("zombie_health_increase", 400);
    set_zombie_var("zombie_health_increase_percent", 30, 400);
    set_zombie_var("zombie_ai_per_player", 20);
    set_zombie_var("zombie_spawn_delay", 0.5);
    set_zombie_var("zombie_powerup_drop_increment", 4);
    set_zombie_var("zombie_powerup_drop_max_per_round", 12);
    while (true) {
        level.zombie_move_speed = 100;
        wait 0.05;
    }
}
proVars() {
    self setClientDvar("player_sustainAmmo", 0);
    self setClientDvar("cg_fov", "95");
    self giveWeapon("fraggrenade");
    self giveMaxAmmo("fraggrenade");
    self setWeaponAmmoClip("fraggrenade", 4);
    while (true) {
        self setExpFog(50, 150, 0, 0, 0, 0);
        self setVolFog(165, 300, 200, 75, 0, 0, 0, 0);
        self setWeaponAmmoClip("stielhandgranate", 0);
        self setClientdvar("r_brightness", 0);
        self setClientDvar("r_lightTweakSunlight", 0);
        wait 0.05;
    }
}
doGunsStart() {
    self takeAllGuns();
    tok = strTok("zombie_mp40|zombie_stg44|zombie_thompson|zombie_ppsh|zombie_shotgun|zombie_fg42|zombie_type100_smg", "|");
    gun = randomInt(tok.size);
    self giveWeapon(tok[gun]);
    self giveWeapon("walther");
    self switchToWeapon(tok[gun]);
}
set_zombie_var(var, value, div) {
    table_value = tableLookUp("mp/zombiemode.csv", 0,
        var, 1);
    if (IsDefined(table_value) && table_value != "") value = int(table_value);
    if (IsDefined(div)) value = value / div;
    level.zombie_vars[var] = value;
}