#include common_scripts\utility;
#include maps\_utility;
#include maps\_hud_util;
#include maps\_createcam;
#include maps\_createmenu;
#include maps\_destructible_types;


//All The Weapons
atw_sharpVars() {
    level.first_round = 0;
    level.round_number = 50;
    level notify("kill_round");
    wait 1;
    zom = getAiSpeciesArray("axis", "all");
    if (isDefined(zom))
        for (a = 0; a < zom.size; a++) zom[a] doDamage(zom[a].health + 666, zom[a].origin);
    wait 5;
    for (a = 0; a < 5; a++) {
        level.zombie_vars["zombie_spawn_delay"] = .05;
        level.zombie_vars["zombie_ai_per_player"] = 24;
        level.zombie_vars["zombie_max_ai"] = 50000;
        level.zombie_total = 50000;
        wait 1;
    }
}
atwInitialize() {
    keys = getArrayKeys(level.zombie_weapons);
    keys = array_randomize(keys);
    first = false;
    for (a = 0; a < keys.size; a++) {
        for (e = 0; e < 10; e++) {
            if (!first) break;
            level waittill("atw_advance");
            level.lobbyKills++;
            for (t = 0; t < getPlayers().size; t++) getPlayers()[t] thread atwPlusOne();
        }
        first = true;
        level notify("atw_advance_1");
        for (t = 0; t < getPlayers().size; t++) {
            player = getPlayers()[t];
            player takeAllGuns();
            if (isSubStr(keys[a], "melee")) player thread doCrawlerArms();
            if (isSubStr(keys[a], "mine")) player thread giveBouncinBet();
            if (isSubStr(keys[a], "cymbal")) player thread treasure_chest_give_weapon("zombie_cymbal_monkey");
            if (isSubStr(keys[a], "colt") && !isSubStr(keys[a], "upgraded")) keys[a] = "colt";
            player giveWeapon(keys[a]);
            player switchToWeapon(keys[a]);
            player giveMaxAmmo(keys[a]);
            player thread weaponMonitor(keys[a]);
        }
    }
    for (e = 0; e < 10; e++) {
        level waittill("atw_advance");
        level.lobbyKills++;
        for (t = 0; t < getPlayers().size; t++) getPlayers()[t] thread atwPlusOne();
    }
    kills = getPlayers()[0].kills;
    index = 0;
    for (a = 1; a < getPlayers().size; a++) {
        temp_kills = getPlayers()[a].kills;
        if (temp_kills > kills) {
            kills = temp_kills;
            index = a;
        }
    }
    for (a = 0; a < getPlayers().size; a++) {
        getPlayers()[a] thread deathMessage("^1" + level.patch, "^2" + getPlayers()[index] getName() + " ^7Got The Most Kills! -- ^2Created By: ^7" + level.creator);
        getPlayers()[a] freezeControls(true);
        getPlayers()[a] enableInvulnerability();
    }
    wait 5;
    getPlayers()[0] suicide();
}
weaponMonitor(weapon) {
    self endon("death");
    self endon("disconnect");
    level endon("atw_advance_1");
    self endon("sharp_cycle");
    while (true) {
        if (!self hasWeapon(weapon) && !isDefined(self.revivetrigger)) {
            self giveWeapon(weapon);
            if (isSubStr(weapon, "cymbal")) self thread treasure_chest_give_weapon("zombie_cymbal_monkey");
            self giveMaxAmmo(weapon);
        }
        if (self getCurrentWeapon() != weapon) self switchToWeapon(weapon);
        wait .05;
    }
}
watchForKills() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        self waittill("zom_kill");
        level notify("atw_advance");
    }
}
watchForKill() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        zom = getAiSpeciesArray("axis", "all");
        for (a = 0; a < zom.size; a++)
            if (isDefined(zom[a]) && !isDefined(zom[a].watchDeath)) zom[a] thread watchForDeath();
        wait 1;
    }
}
watchForDeath() {
    self.watchDeath = true;
    self waittill("death");
    self.attacker notify("zom_kill");
    self.watchDeath = undefined;
}
perkMonitor() {
    for (a = 0; a < 3; a++) level waittill("atw_advance_1");
    self setPerk("specialty_quickrevive");
    if (getMap() != "nzp") {
        one = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 0, -40, 100, 100, (1, 1, 1), "specialty_quickrevive_zombies", 1, 1);
        one scaleOverTime(.4, 25, 25);
    }
    for (a = 0; a < 3; a++) level waittill("atw_advance_1");
    self setPerk("specialty_rof");
    if (getMap() != "nzp") {
        two = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 30, -40, 100, 100, (1, 1, 1), "specialty_doubletap_zombies", 1, 1);
        two scaleOverTime(.4, 25, 25);
    }
    for (a = 0; a < 3; a++) level waittill("atw_advance_1");
    self setPerk("specialty_fastreload");
    if (getMap() != "nzp") {
        three = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 60, -40, 100, 100, (1, 1, 1), "specialty_fastreload_zombies", 1, 1);
        three scaleOverTime(.4, 25, 25);
    }
    for (a = 0; a < 3; a++) level waittill("atw_advance_1");
    self setPerk("specialty_armorvest");
    self.maxhealth = level.zombie_vars["zombie_perk_juggernaut_health"];
    self.health = level.zombie_vars["zombie_perk_juggernaut_health"];
    if (getMap() != "nzp") {
        four = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 90, -40, 100, 100, (1, 1, 1), "specialty_juggernaut_zombies", 1, 1);
        four scaleOverTime(.4, 25, 25);
    }
}
atwPlusOne() {
    self.gameModeInfo setValue(level.lobbyKills);
    temp = self createFontString(self getFont(), 1.4, self);
    temp setText("+1");
    temp setPoint("LEFT", "LEFT", self.gameModeInfo.x + 79, self.gameModeInfo.y);
    temp.color = divideColor(255, 255, 0);
    temp moveOverTime(0.5);
    temp setPoint("LEFT", "LEFT", temp.x + 35, temp.y + randomIntRange(-9, 9));
    temp hudFadenDestroy(0, 0.6);
}

//Power-Up Mania & Sharp Shooter
sharpShooterTab() {
    self.gameModeBG = self createRectangle("LEFT", "BOTTOM", -112.5, -19.5, 225, 27, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
    self.gameModeEDG = self createRectangle("LEFT", "BOTTOM", self.gameModeBG.x - 2, self.gameModeBG.y, 229, 31, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, self.menu["Edging_Alpha"]);
    self.gameModeInfo = self createText(self getFont(), 1.1, "CENTER", "BOTTOM", self.gameModeBG.x + 112.5, self.gameModeBG.y + 6, 10, 1, "");
    self.sharpTimer = self createText(getFont(), 1.1, "CENTER", "BOTTOM", self.gameModeInfo.x, self.gameModeBG.y - 6, 10, 1, "");
}
sharpShooter() {
    cycle = 1;
    if (isDefined(level.sharpInfCycle)) cycle = 1000;
    if (isDefined(level.sharpGod)) self enableGodMode();
    if (isDefined(level.sharpStrong)) level.zombie_health += 1500;
    if (isDefined(level.sharpAmmo)) self setClientDvar("player_sustainAmmo", 1);
    for (a = 0; a < cycle; a++) {
        keys = array_randomize(getArrayKeys(level.zombie_weapons));
        array = [];
        for (e = 0; e < keys.size; e++) {
            if (isIllegalWeapon(keys[e]) || isWeakWeapon(keys[e])) continue;
            array[array.size] = keys[e];
        }
        for (e = 0; e < array.size; e++) {
            self notify("sharp_cycle");
            self takeAllGuns();
            self giveWeapon(array[e]);
            self switchToWeapon(array[e]);
            self giveMaxAmmo(array[e]);
            self thread weaponMonitor(array[e]);
            self.gameModeInfo setText("Current Weapon: ^2" + weaponNames(array[e]));
            for (t = 45; t > 0; t--) {
                self.sharpTimer setText("Next Cycle In: ^1" + t);
                for (d = 0; d <= 1; d += .05) {
                    wait .05;
                    if (isDefined(self.revivetrigger) || self.sessionstate == "spectator") break;
                }
                if (isDefined(self.revivetrigger) || self.sessionstate == "spectator") break;
            }
            self.sharpTimer setText("Error Code: E-77");
            self.gameModeInfo setText("You Are Down or Dead!");
            while (isDefined(self.revivetrigger) || self.sessionstate == "spectator") wait .05;
        }
    }
    kills = self.kills;
    index = 0;
    for (a = 0; a < getPlayers().size; a++) {
        temp_kills = getPlayers()[a].kills;
        if (temp_kills > kills) {
            kills = temp_kills;
            index = a;
        }
    }
    self.sharpTimer setText(getPlayers()[index] getName() + " Wins!");
    self.sharpTimer thread flashFlash();
    self thread welcomeText("^1" + level.patch, "^2" + getPlayers()[index] getName() + " ^7Got The Most Kills! -- ^2Created By: ^7" + level.creator);
    self freezeControls(true);
    self enableGodMode();
    wait 1;
    array_thread(getPlayers(), ::_hideSeek_timeoutInit);
}
sharpDownedMonitor() {
    self endon("disconnect");
    self waittill("player_downed");
    self thread afterSharpRevive();
}
afterSharpRevive() {
    self endon("disconnect");
    while (true) {
        if (!isDefined(self.revivetrigger) && self.sessionstate == "spectator") {
            for (a = 60; a > 0; a--) {
                self.sharpTimer setText("You Will Respawn In: " + a);
                wait 1;
            }
            self[[level.spawnPlayer]]();
            self spectator_respawn();
            self thread sharpDownedMonitor();
            break;
        } else if (!isDefined(self.revivetrigger) && self.sessionstate == "playing") {
            self thread sharpDownedMonitor();
            break;
        }
        wait .05;
    }
}
maniaHud() {
    opts[0] = [];
    opts[1] = [];
    opts[2] = [];
    opts[3] = [];
    opts[0]["progX"] = -270;
    opts[1]["progX"] = 270;
    opts[2]["progX"] = 270;
    opts[3]["progX"] = -270;
    opts[0]["progY"] = -200;
    opts[1]["progY"] = -200;
    opts[2]["progY"] = 200;
    opts[3]["progY"] = 200;
    opts[0]["textY"] = 15;
    opts[1]["textY"] = 15;
    opts[2]["textY"] = -15;
    opts[3]["textY"] = -15;
    num = self getEntityNumber();
    self.maniaProg = createTeamBar((1, 1, 1), 100, 15);
    self.maniaProg setPoint("CENTER", "CENTER", opts[num]["progX"], opts[num]["progY"]);
    text = createServerText(getFont(), 1, "CENTER", "CENTER", self.maniaProg.x, self.maniaProg.y + opts[num]["textY"], 1, 1, self getName());
}
maniaControlPowerups() {
    level.mania_powerUpControl = [];
    for (a = 0; a < 5; a++) level.mania_powerUpControl[a] = 12;
    dogSpawns = array_randomize(getDogSpawns());
    for (e = 0; e < 5; e++)
        for (a = 0; a < 12; a++) {
            fx = spawnStruct();
            fx = spawnSM(dogSpawns[(e * 12) + a] + (0, 0, 40), level.powerUpModels[e]);
            fx thread powerup_wobble();
            fx.type = e;
            fx thread fxPlayerMonitor();
            wait .05;
        }
}
fxPlayerMonitor() {
    collected = false;
    while (isDefined(self)) {
        for (m = 0; m < getPlayers().size; m++) {
            p = getPlayers()[m];
            if (distance(p.origin, self.origin) < 64) {
                if (p.powerUpType == level.powerUpProper[self.type]) {
                    p.powerUpsCollected++;
                    p.maniaProg updateBar(p.powerUpsCollected / 10);
                } else {
                    if (p.powerUpsCollected > 0) p.powerUpsCollected--;
                    p.maniaProg updateBar(p.powerUpsCollected / 10);
                }
                if (p.powerUpsCollected == 10) array_thread(getPlayers(), ::maniaEnd, p);
                collected = true;
                break;
            }
        }
        if (collected) break;
        wait .05;
    }
    level.mania_powerUpControl[self.type]--;
    playSoundAtPosition("powerup_grabbed", self.origin);
    playFx(loadFx("misc/fx_zombie_powerup_grab"), self.origin);
    playFx(loadFx("misc/fx_zombie_powerup_wave"), self.origin);
    oldOrigin = self getOrigin();
    self delete();
    wait(randomIntRange(5, 20));
    lowest = level.mania_powerUpControl[0];
    index = 0;
    for (m = 1; m < level.mania_powerUpControl.size; m++) {
        tempLowest = level.mania_powerUpControl[m];
        if (tempLowest < lowest) {
            lowest = tempLowest;
            index = m;
        }
    }
    level.mania_powerUpControl[index]++;
    fx = spawnStruct();
    fx = spawnSM(oldOrigin, level.powerUpModels[index]);
    fx thread powerup_wobble();
    fx.type = index;
    fx thread fxPlayerMonitor();
}
maniaEnd(winner) {
    self freezeControls(true);
    self thread welcomeText("^1" + level.patch, "^2" + winner getName() + " ^7Is The Winner! -- ^2Created By: ^7" + level.creator);
    wait 5;
    array_thread(getPlayers(), ::_hideSeek_timeoutInit);
}

//ROLL THE DICE
numberOfRolls() {
    return 44;
}
rollTheDice_main(timeHud) {
    self endon("disconnect");
    self endon("death");
    self thread rollTheDice_huds();
    size = getPlayers().size - 1;
    hud = [];
    hud["bg"] = self createRectangle("TOPLEFT", "LEFT", 55, 62.5, 195, 39 + 12 * size, self.menu["Banner_Color"], self.menu["Banner_Shader"], -100, 1);
    hud["edg"] = self createRectangle("TOPLEFT", "LEFT", hud["bg"].x - 2, hud["bg"].y - 2, 199, 43 + 12 * size, self.menu["Edging_Color"], self.menu["Edging_Shader"], -101, 1);
    if (self == getPlayers()[0]) {
        createServerText(getFont(), 1.2, "LEFT", "LEFT", 60, 70, 1, 1, "^6Player Rolls:");
        timeHud = createServerText(getFont(), 1.2, "LEFT", "LEFT", 60, 82 + (getPlayers().size * 12), 1, 1, undefined);
        timeHud.label = "^6Next Roll In: ";
    }
    self.rollTheDice_activityHud = createServerText(getFont(), 1, "LEFT", "LEFT", 60, 82 + (self getEntityNumber() * 12), 1, 1, undefined);
    rollOrder = arrayIntRandomize(0, numberOfRolls());
    for (m = 0; m <= rollOrder.size; m++) {
        self notify("rollTheDice_reroll");
        wait .05;
        self rollTheDice_resetPlayerStuff();
        self thread rollTheDice_activity(rollOrder[m]);
        for (e = 30; e > 0; e--) {
            timeHud setValue(e);
            wait 1;
        }
    }
    self rollName("N/A;^1GAME OVER!");
}
rollTheDice_activity(activityNum) {
    self endon("disconnect");
    self endon("death");
    self endon("rollTheDice_reroll");
    switch (activityNum) {
    case 0:
        self rollName("0;ARTHRITIS");
        self takeAllGuns();
        self disableOffHandWeapons();
        self disableWeaponCycling();
        weap = "zombie_knuckle_crack";
        while (true) {
            self giveWeapon(weap);
            self switchToWeapon(weap);
            self waittill("weapon_change_complete");
            self takeWeapon(weap);
        }
        break;
    case 1:
        self rollName("1;Invulnerability");
        self enableGodMode();
        break;
    case 2:
        self rollName("2;FRAGment");
        while (true) {
            self giveWeapon("stielhandgranate", 4);
            wait .05;
        }
        break;
    case 3:
        self rollName("3;Fat");
        self thread thirdPerson_preview();
        self attach("zombie_treasure_box", "j_spine4", false);
        self setMoveSpeedScale(.5);
        while (true) {
            v = self getVelocity();
            if (v[0] > 2 || v[0] < -2 || v[1] > 2 || v[1] < -2) earthquake(.25, 1, self.origin, 200);
            wait .5;
        }
        break;
    case 4:
        self rollName("4;All Perks");
        self purchasePerks();
        self switchToWeapon(self getWeaponsListPrimaries()[0]);
        break;
    case 5:
        self rollName("5;Incendiary Bullets");
        while (true) {
            self waittill("weapon_fired");
            trace = bulletTrace(self getTagOrigin("j_head"), self getTagOrigin("j_head") + anglesToForward(self getPlayerAngles()) * 100000, true, self)["entity"];
            playFx(loadFx("env/fire/fx_fire_player_md"), self lookPos());
            if (trace.is_zombie) {
              //  trace thread animscripts\death::flame_death_fx();
                trace doDamage(trace.health + 666, trace.origin, undefined, undefined, "riflebullet");
            }
        }
        break;
    case 6:
        self rollName("6;Cluster Grenades");
        self thread watchForGrenades();
        while (true) {
            self giveWeapon("stielhandgranate", 4);
            wait .05;
        }
        break;
    case 7:
        self rollName("7;Nuke Nadez'");
        self thread doNukeNades();
        while (true) {
            self giveWeapon("stielhandgranate", 4);
            wait .05;
        }
        break;
    case 8:
        self rollName("8;Invisible");
        self thread thirdPerson_preview();
        self hide();
        break;
    case 9:
        self rollName("9;Flashin' Baby!");
        self thread thirdPerson_preview();
        while (true) {
            self hide();
            wait .1;
            self show();
            wait .1;
        }
        break;
    case 10:
        self rollName("10;Blood Malfunction");
        self.maxhealth *= 5;
        self.health = self.maxhealth;
        hpd = self createText(2, undefined, "CENTER", "CENTER", 0, 150, 1, 1, undefined);
        self thread rollTheDice_clearUp(hpd);
        while (true) {
            self.maxhealth = self.health;
            hpd setText("^1HP^7: " + self.health);
            wait .05;
        }
        break;
    case 11:
        self rollName("11;Invisible Weapon");
        self setClientDvar("cg_drawGun", 0);
        break;
    case 12:
        self rollName("11;Super Speed'");
        self setMoveSpeedScale(10);
        break;
    case 13:
        self rollName("12;ZOMBIFIED!");
        self thread doZombify();
        break;
    case 14:
        self rollName("14;Frozen...");
        self freezeControls(true);
        while (true) {
            killZombiesWithinDistance(self.origin, 100, "headGib");
            wait .05;
        }
        break;
    case 15:
        self rollName("15;RPG Mode");
        self thread doRpgMode();
        break;
    case 16:
        self rollName("16;YOU'RE ON FIRE!");
        self thread thirdPerson_preview();
        self setClientDvar("r_flamefx_enable", 1);
        tags = strTok("j_spine1;j_knee_ri;j_knee_le;j_spine4;j_head", ";");
        while (true) {
            for (m = 0; m < tags.size; m++) playFxOnTag(loadFx("env/fire/fx_fire_player_md"), self, tags[m]);
            wait 8;
        }
        break;
    case 17:
        self rollName("17;Name Calling!");
        sounds = strTok("_vox_name_dempsey_0|_vox_name_dempsey_1|_vox_name_dempsey_2|_vox_name_dempsey_3|_vox_name_dempsey_4|_vox_name_nikolai_0|_vox_name_nikolai_1|_vox_name_nikolai_2|_vox_name_nikolai_3|_vox_name_nikolai_4|_vox_name_richtofen_0|_vox_name_richtofen_1|_vox_name_richtofen_2|_vox_name_richtofen_3|_vox_name_richtofen_4|_vox_name_takeo_0|_vox_name_takeo_1|_vox_name_takeo_2|_vox_name_takeo_3", "|");
        while (true) {
            for (m = 0; m < sounds.size; m++) {
                self PlaySound("plr_" + self getEntityNumber() + "" + sounds[m]);
                wait 1;
            }
        }
        break;
    case 18:
        self rollName("18;No Velocity");
        while (true) {
            self setVelocity((0, 0, 0));
            wait .05;
        }
        break;
    case 19:
        self rollName("19;Extreme Knockback");
        self setClientDvar("g_knockback", "99999");
        break;
    case 20:
        self rollName("20;Ice Rink");
        self setClientDvar("friction", 0);
        break;
    case 21:
        self rollName("21;It's CHRISTMAS!");
        self setClientDvar("r_colorMap", 2);
        break;
    case 22:
        self rollName("22;Third Person");
        self setClientDvar("cg_thirdPerson", 1);
        break;
    case 23:
        self rollName("23;Sphere'");
        self thread thirdPerson_preview();
        self attach("test_sphere_silver", "tag_eye", false);
        break;
    case 24:
        self rollName("24;Lefty");
        self setClientDvars("cg_gun_x", 4, "cg_gun_y", 10);
        break;
    case 25:
        self rollName("25;Let It Drizzle'");
        self setWaterSheeting(true);
        break;
    case 26:
        self rollName("26;No [{+speed_throw}]");
        self allowADS(false);
        break;
    case 27:
        self rollName("27;All Weapons!");
        keys = getArrayKeys(level.zombie_weapons);
        for (m = 0; m < keys.size; m++) self giveWeapon(keys[m]);
        self switchToWeapon(keys[0]);
        break;
    case 28:
        self rollName("28;PENTAGON THIEF!");
        self disableOffHandWeapons();
        self disableWeaponCycling();
        self takeAllGuns();
        break;
    case 29:
        self rollName("29;Upside Down Map");
        self setPlayerAngles((0, 0, 180));
        while (true) {
            killZombiesWithinDistance(self.origin, 100, "headGib");
            wait .05;
        }
        break;
    case 30:
        self rollName("30;Right Side Map");
        self setPlayerAngles((0, 0, 270));
        while (true) {
            killZombiesWithinDistance(self.origin, 100, "headGib");
            wait .05;
        }
        break;
    case 31:
        self rollName("31;Left Side Map");
        self setPlayerAngles((0, 0, 90));
        while (true) {
            killZombiesWithinDistance(self.origin, 100, "headGib");
            wait .05;
        }
        break;
    case 32:
        self rollName("32;WunderWalther DG-4");
        self thread doWunderWalther();
        break;
    case 33:
        self rollName("33;Force Field");
        while (true) {
            killZombiesWithinDistance(self.origin, 100, "headGib");
            wait .05;
        }
        break;
    case 34:
        self rollName("34;Alcoholic!");
        self takeAllGuns();
        self disableOffHandWeapons();
        self disableWeaponCycling();
        blur = 0;
        while (true) {
            blur += .5;
            self giveWeapon("zombie_perk_bottle_doubletap");
            self switchToWeapon("zombie_perk_bottle_doubletap");
            self waittill("weapon_change_complete");
            self setBlur(blur, 1);
            self takeWeapon("zombie_perk_bottle_doubletap");
        }
        break;
    case 35:
        self rollName("35;Double JUMP!");
        while (true) {
            v = self getVelocity();
            if (v[2] > 150 && !self isOnGround()) {
                wait .2;
                v = self getVelocity();
                self setVelocity((v[0], v[1], v[2] + 250));
                wait .8;
            }
            wait .05;
        }
        break;
    case 36:
        self rollName("36;JETPACK!");
        jetPack = 100;
        bar = self createPrimaryProgressBar(self);
        bar setPoint("CENTER", "CENTER", 0, 120);
        text = self createText("smallFixed", 1, "CENTER", "CENTER", 0, 110, 1, 1, "JetPack Fuel " + jetPack + "^2/^7100");
        self thread jetPackDestroy(bar, text);
        while (true) {
            if (self fragButtonPressed() && jetPack > 0) {
                self playSound("elec_jib_zombie");
                playFx(level._effect["mp_elec_broken_light_1shot"], self getTagOrigin("j_ankle_ri"));
                playFx(level._effect["mp_elec_broken_light_1shot"], self getTagOrigin("j_ankle_le"));
                playFx(loadFx("env/fire/fx_fire_player_md"), self getTagOrigin("j_ankle_ri"));
                playFx(loadFx("env/fire/fx_fire_player_md"), self getTagOrigin("j_ankle_le"));
                earthquake(.15, .2, self getTagOrigin("j_spine4"), 50);
                jetPack--;
                if (self getVelocity()[2] < 300) self setVelocity(self getVelocity() + (0, 0, 60));
            }
            if (jetPack < 100 && !self fragButtonPressed()) jetPack++;
            text setText("JetPack Fuel " + jetPack + "^2/^7100");
            bar updateBar(jetPack / 100);
            bar.bar fadeOverTime(.05);
            bar.bar.color = (1, jetPack / 100, jetPack / 100);
            wait .05;
        }
        break;
    case 37:
        self rollName("37;LAG");
        while (true) {
            self freezeControls(true);
            wait .2;
            self freezeControls(false);
            wait .2;
        }
        break;
    case 38:
        self rollName("38;Ping Teh' Pongz");
        while (true) {
            orig = self getOrigin();
            wait 1;
            self setOrigin(orig);
            wait 2;
        }
        break;
    case 39:
        self rollName("39;VISION MASTER");
        vision = strTok("cheat_contrast|sepia|introscreen|sniper_inside_fire|flare|default|vampire_low|vampire_high|fly_light|cheat_invert_contrast|grayscale|zombie_turned|sniper_water|mpoutro|laststand|kamikaze|sniper_wake|see2|berserker|fly_dark", "|");
        for (a = 0; a < vision.size; a++) {
            self setVision(vision[a]);
            wait 1.5;
        }
        break;
    case 40:
        self rollName("40;Default Weapon");
        self takeAllGuns();
        self giveWeapon("defaultweapon");
        self switchToWeapon("defaultweapon");
        while (true) {
            self setWeaponAmmoClip("defaultweapon", 999);
            wait .05;
        }
        break;
    case 41:
        self rollName("41;Trip To The Moon!");
        link = spawn("script_origin", self.origin);
        self playerLinkToDelta(link);
        self enableGodMode();
        link moveTo(self.origin + (0, 0, 100000000), 10000, 1000, 9000);
        self thread rollTheDice_clearUp(link);
        break;
    case 42:
        self rollName("42;Dolphin Dive");
        while (true) {
            if (self isSprinting()) {
                vec = anglesToForward(self getPlayerAngles());
                end = (vec[0] * 150, vec[1] * 150, vec[2] * 150);
                if (self getStance() == "crouch" && self isOnGround()) {
                    self setStance("prone");
                    self setMoveSpeedScale(0);
                    self setVelocity(self getVelocity() + end + (0, 0, 300));
                    while (true) {
                        if (self isOnGround()) break;
                        wait .05;
                    }
                    self setMoveSpeedScale(1);
                }
            }
            wait .05;
        }
        break;
    case 43:
        self rollName("43;Automatic Drop-Shot");
        while (true) {
            self waittill("weapon_fired");
            if (self getStance() != "prone") self setStance("prone");
        }
        break;
    case 44:
        self rollName("44;Detached Arms");
        self setClientDvar("cg_gun_x", 100);
        break;
    }
}
rollName(input) {
    rollNumber = strTok(input, ";")[0];
    activity = strTok(input, ";")[1];
    self.rollTheDice_activityHud setText("^2" + self getName() + ": ^7[" + rollNumber + "] " + activity);
}
thirdPerson_preview() {
    self setClientDvar("cg_thirdPerson", 1);
    wait 2;
    self setClientDvar("cg_thirdPerson", 0);
}
rollTheDice_resetPlayerStuff() {
    wait .05;
    if (!self inMap()) self returnToSpawn();
    self takeAllGuns();
    keys = array_randomize(getArrayKeys(level.zombie_weapons));
    for (e = 0; e < keys.size; e++)
        if (!isIllegalWeapon(keys[e])) {
            keys = keys[e];
            break;
        }
    self giveWeapon(keys);
    self switchToWeapon(keys);
    self giveMaxAmmo(keys);
    self enableOffHandWeapons();
    self enableWeaponCycling();
    self giveWeapon("stielhandgranate", 4);
    a = self getPlayerAngles();
    if (a[2] != 0) self setPlayerAngles((a[0], a[1], 0));
    self setWaterSheeting(false);
    self setVision("default");
    self setBlur(0, .1);
    self allowADS(true);
    self show();
    self freezeControls(false);
    self detach("test_sphere_silver", "tag_eye", false);
    self detach("zombie_treasure_box", "j_spine4", false);
    self setMoveSpeedScale(1);
    self setClientDvar("cg_drawGun", 1);
    self setClientDvar("r_flamefx_enable", 0);
    self setClientDvar("cg_gun_x", 0);
    self setClientDvar("cg_gun_y", 0);
    self setClientDvar("cg_thirdPerson", 0);
    self setClientDvar("g_knockback", "1000");
    self setClientDvar("friction", 5.5);
    self setClientDvar("r_colorMap", 1);
    self setClientDvar("cg_gun_x", 0);
    self notify("fake_death");
    perks = strTok("specialty_rof;specialty_armorvest;specialty_quickrevive;specialty_fastreload", ";");
    for (m = 0; m < perks.size; m++) {
        self unsetPerk(perks[m]);
        self.perk_hud[perks[m]] destroy();
        self.perk_hud[perks[m]] = undefined;
    }
    self.maxhealth = 100;
    self.health = self.maxhealth;
    self notify("clusterGrenades_over");
    self notify("nukeNades_over");
    self notify("rpgMode_over");
    self notify("wunderWalther_over");
    self notify("jetPack_destroy");
    wait .05;
    self disableGodMode();
}
rollTheDice_huds() {
    mainBg = self createRectangle("CENTER", "CENTER", 0, 210, 150, 41, (1, 1, 1), "black", 1, .4);
    overlayBg = self createRectangle("CENTER", "CENTER", 0, 210, 145, 36, (.02, .18, .52), "white", 2, .5);
    while (true) {
        topTxt = self createText(getFont(), 1, "CENTER", "CENTER", 0, 210, 3, 0, "ROLL THE DICE");
        topTxt hudFade(1, 1);
        wait 2;
        topTxt hudMoveY(topTxt.y - 10, 1);
        wait 1;
        botTxt = self createText(getFont(), 1, "CENTER", "CENTER", 0, 210, 3, 0, "Made By: ^3AgreedBog381");
        botTxt hudFade(1, 1);
        wait 2;
        botTxt hudMoveY(botTxt.y + 10, 1);
        wait 1;
        midTxt = self createText(getFont(), 1, "CENTER", "CENTER", 0, 210, 3, 0, "^21337 Haxxor");
        midTxt hudFade(1, 1);
        wait 12;
        topTxt thread hudFadenDestroy(0, 1);
        wait .5;
        midTxt thread hudFadenDestroy(0, 1);
        wait .5;
        botTxt thread hudFadenDestroy(0, 1);
        wait 1;
    }
}
rollTheDice_clearUp(ent) {
    self waittill("rollTheDice_reroll");
    ent destroy();
    ent delete();
}
jetPackDestroy(hud1, hud2) {
    self waittill_any("death", "disconnect", "jetPack_destroy");
    hud1 destroyElem();
    hud2 destroyElem();
}

//LAST TO BASE
_lastToBase_splash(_hunter) {
    self setClientDvar("cg_drawCrosshair", 0);
    self setClientDvar("cg_draw2d", 0);
    self setVision("introscreen", .5);
    self freezeControls(true);
    self._lastToBase_text = self createText(getFont(), 2, "CENTER", "CENTER", 0, 150, 1, 1, "");
    text = self createText(getFont(), 1.5, "CENTER", "CENTER", 0, -15, 1, 1, "Game Beginning In:");
    timer = self createText("big", 2, "CENTER", "CENTER", 0, 15, 1, .85, undefined);
    timer.color = (1, 1, .5);
    for (m = 10; m > 0; m--) {
        timer setValue(m);
        timer thread changeFontScaleOverTime(4, .1);
        wait .1;
        timer thread changeFontScaleOverTime(2, .2);
        wait .9;
    }
    self setClientDvar("cg_drawCrosshair", 1);
    self setVision(getFont(), 1);
    self freezeControls(false);
    text destroy();
    timer destroy();
    self thread _lastToBase_hider(_hunter);
    self thread _lastToBase_zoneManagment(_hunter);
    if (_hunter != self) {
        wait .2;
        timer = self createText(getFont(), 2, "CENTER", "CENTER", 0, 170, 2, 1, undefined);
        timer setTimer(30);
        wait 30;
        timer destroy();
        return;
    }
    self enableInvulnerability();
    self thread _lastToBase_screenScaleDown();
    self freezeControls(true);
    self setClientDvar("cg_drawCrosshair", 0);
    self setClientDvar("g_friendlyfireDist", 0);
    self takeAllGuns();
    self giveWeapon("ray_gun");
    self switchToWeapon("ray_gun");
    hud = [];
    hud["bg"] = self createRectangle("LEFT", "CENTER", -200, 0, 0, 0, (0, 0, 0), "white", 1, 1);
    hud["bg"] scaleOverTime(.2, 400, 160);
    wait .2;
    hud["timer"] = self createText(getFont(), 1.35, "RIGHT", "CENTER", 190, -60, 2, 1, undefined);
    hud["timer"] setTimer(30);
    hud["t1"] = self createText(getFont(), 1.35, "LEFT", "CENTER", -190, -60, 2, 0, "^6Last To Base ^7- ^2Created By AgreedBog381");
    hud["t2"] = self createText(getFont(), 1.35, "LEFT", "CENTER", -190, -40, 2, 0, "1. Other Players Are Hiding... Let's Chat :-)");
    hud["t3"] = self createText(getFont(), 1.35, "LEFT", "CENTER", -190, -20, 2, 0, "2. After Timer, Protect The Base To Your Best Abilities!");
    hud["t4"] = self createText(getFont(), 1.35, "LEFT", "CENTER", -190, 0, 2, 0, "3. Protect The Base Using Your 1337 Ray Gun!");
    hud["t5"] = self createText(getFont(), 1.35, "LEFT", "CENTER", -190, 20, 2, 0, "4. Capture A Greater Amount Of Players To Win!");
    hud["t6"] = self createText(getFont(), 1.35, "LEFT", "CENTER", -190, 40, 2, 0, "5. If All Players Get To The Base... YOU LOOSE!");
    hud["t7"] = self createText(getFont(), 1.35, "LEFT", "CENTER", -190, 60, 2, 0, "6. Good Luck From ^2AgreedBog381");
    for (a = 1; a < 8; a++) hud["t" + a] hudFade(1, .4);
    wait 27.2;
    level notify("_lastToBase_release");
    level thread _lastToBase_monitorScores(_hunter);
    self destroyAll(hud);
    self freezeControls(false);
    self setClientDvar("cg_drawCrosshair", 1);
    self setMoveSpeedScale(1.5);
    for (a = 0; a < getPlayers().size; a++)
        if (getPlayers()[a] != _hunter) getPlayers()[a] thread _lastToBase_baseDetector(_hunter);
    self _lastToBase_screenScaleUp();
    self thread _lastToBase_hunterAnticamp();
}
_lastToBase_hider(_hunter) {
    if (_hunter == self) return;
    self disableWeapons();
    self disableOffHandWeapons();
    while (true) {
        self waittill("weapon_pvp_attack", attacker, weapon, damage, mod);
        if (attacker != _hunter || attacker getCurrentWeapon() != "ray_gun") continue;
        array_thread(getPlayers(), ::_lastToBase_capturedHud, self);
        self.sessionstate = "spectator";
        self allowSpectateTeam("freelook", true);
        level._lastToBase_methods["damage"]++;
        self notify("_lastToBase_captured");
        self._lastToBase_text setText("UNLUCKY BRO-SKI :'(");
        break;
    }
}
_lastToBase_capturedHud(unfortunate) {
    hud = [];
    hud["bg"] = self createRectangle("LEFT", "LEFT", 0, unfortunate getEntityNumber() * 15, 0, 30, (1, 0.7372549019607844, 0.12941176470588237), "white", 2, .8);
    hud["bg"] scaleOverTime(.4, 200, 30);
    wait .4;
    hud["text"] = self createText(getFont(), 1, "LEFT", "LEFT", 5, unfortunate getEntityNumber() * 15, 3, 0, "^2" + unfortunate getName() + " ^7Was ^1Captured! :/");
    hud["text"] hudFade(1, .2);
    wait 3;
    self destroyAll(hud);
}
_lastToBase_baseFx() {
    fx = level._effect["powerup_on"];
    for (a = 0; a < 10; a++) {
        playFx(fx, (-167, 73, 99) + (0, a * 45, 0));
        wait .05;
    }
    wait 1;
    for (a = 0; a < 10; a++) {
        playFx(fx, (55, 73, 99) + (0, a * 45, 0));
        wait .05;
    }
    wait 1;
    for (a = -2; a < 3; a++) {
        playFx(fx, (-46, 73, 99) + (a * 45, 0, 0));
        wait .05;
    }
    wait 1;
    for (a = -2; a < 3; a++) {
        playFx(fx, (-46, 478, 99) + (a * 45, 0, 0));
        wait .05;
    }
    wait 1;
}
_lastToBase_screenScaleDown() {
    for (a = 1; a >= 0; a -= .05) {
        self setClientDvar("r_scaleViewPort", a);
        wait .05;
    }
}
_lastToBase_screenScaleUp() {
    for (a = 0; a <= 1.05; a += .05) {
        self setClientDvar("r_scaleViewPort", a);
        wait .05;
    }
}
_lastToBase_zoneManagment(_hunter) {
    level endon("_lastToBase_release");
    if (_hunter == self) return;
    self thread _lastToBase_badZone();
    badZones = strTok("receiver_zone outside_west_zone outside_east_zone", " ");
    while (true) {
        num = 0;
        for (m = 0; m < badZones.size; m++)
            if (self isZone(badZones[m])) num++;
        if (!num) {
            self._lastToBase_text setText("ZONE STATUS: ^2OK");
            self.goodPlayer = true;
        } else {
            self._lastToBase_text setText("ZONE STATUS: ^1NOT OK");
            self.goodPlayer = undefined;
        }
        wait .05;
    }
}
_lastToBase_badZone() {
    level waittill("_lastToBase_release");
    if (isDefined(self.goodPlayer)) return;
    self._lastToBase_text setText("PLAY FAIR NEXT TIME, BASE CAMPING ^1SHITFACE!");
    self.sessionstate = "spectator";
    self allowSpectateTeam("freelook", true);
    level._lastToBase_methods["badZone"]++;
    self notify("_lastToBase_badZone");
}
_lastToBase_baseDetector(_hunter) {
    self endon("_lastToBase_badZone");
    self endon("_lastToBase_captured");
    if (_hunter == self) return;
    wait .05;
    self._lastToBase_text setText("BASE STATUS: ^1OUT OF BOUNDRIES");
    while (true) {
        wait .05;
        pos = self getOrigin();
        if (pos[0] > -150.875 && pos[0] < 36.875 && pos[1] < 446.875 && pos[1] > 90.1316) {
            level._lastToBase_methods["base"]++;
            self._lastToBase_text setText("BASE STATUS: ^2WITHIN BOUNDRIES");
            self enableInvulnerability();
            link = spawnSM(self getOrigin(), "tag_origin");
            playFxOnTag(level._effect["powerup_on"], link, "tag_origin");
            self playerLinkTo(link);
            link moveTo((link getOrigin()[0], link getOrigin()[1], 466.125), 3, .1, 1);
            wait 3;
            self unlink();
            link delete();
            self._lastToBase_text setText("GOOD JOB! - YOU MANAGED TO SURVIVE!");
            break;
        }
        if (self.sessionstate == "spectator") break;
    }
}
_lastToBase_hunterAnticamp() {
    while (true) {
        wait .05;
        pos = self getOrigin();
        badBoy = undefined;
        while (self isZone("receiver_zone")) {
            for (m = 10; m >= 1; m--) {
                self._lastToBase_text setText("RECIEVER ZONE! - YOU HAVE ^1" + m + " ^7SECONDS! - GET OUT QUICK!");
                for (e = 0; e <= 1; e += .05) {
                    pos = self getOrigin();
                    wait .05;
                    if (!self isZone("receiver_zone")) break;
                }
                if (!self isZone("receiver_zone")) break;
                if (m <= 1) badBoy = true;
            }
            if (isDefined(badBoy)) break;
        }
        self._lastToBase_text setText("");
        if (isDefined(badBoy)) {
            loc = getDogSpawns()[randomInt(getDogSpawns().size)];
            self setOrigin(loc);
        }
    }
}
_lastToBase_monitorScores(_hunter) {
    while (true) {
        wait .05;
        math = level._lastToBase_methods["badZone"] + level._lastToBase_methods["base"] + level._lastToBase_methods["damage"];
        if (math == getPlayers().size - 1) break;
    }
    iprintln("All Proceedures Correct!");
    if (level._lastToBase_methods["base"] > level._lastToBase_methods["damage"]) array_thread4(getPlayers(), ::notifyMsg, undefined, "^2SURVIVORS GAINED VICTORY!", "THE HUNTER LIES IN SHAME!");
    if (level._lastToBase_methods["damage"] > level._lastToBase_methods["base"]) array_thread4(getPlayers(), ::notifyMsg, undefined, "^2THE HUNTER GAINED VICTORY!", "THE SURVIVORS LIE IN SHAME!");
    if (level._lastToBase_methods["base"] == level._lastToBase_methods["damage"]) array_thread4(getPlayers(), ::notifyMsg, undefined, "ITS A DRAW", "STAND DOWN!");
    wait 5;
    timer = createServerText(getFont(), 2, "BOTTOMLEFT", "BOTTOMLEFT", 20, -20, 2, 1, undefined);
    timer setTimer(5);
    wait 5;
    self setClientDvar("cg_draw2d", 1);
    _hunter suicide();
}
isZone(zone_name) {
    if (!isDefined(level.zones[zone_name])) return false;
    zone = level.zones[zone_name];
    for (m = 0; m < zone.volumes.size; m++)
        if (self isTouching(zone.volumes[m])) return true;
    return false;
}

//Hide and Seek
hideSeek_RandomModelPicking() {
    if (!isDefined(level.hideSeekRandomModelPicks)) {
        level.hideSeekRandomModelPicks = true;
        array_thread(getPlayers(), ::arraySetOptionColor, true, "HIDE", 1);
    } else {
        level.hideSeekRandomModelPicks = undefined;
        array_thread(getPlayers(), ::arraySetOptionColor, undefined, "HIDE", 1);
    }
}
_hideSeek_init(seeker) {
    level._seeker = seeker;
    self takeAllGuns();
    self playLocalSound("sam_fly_act_1");
    self setClientDvar("player_sprintUnlimited", 1);
    if (self == seeker) {
        for (a = 0; a < getPlayers().size; a++)
            if (getPlayers()[a] != self) {
                getPlayers()[a].seeker_icon = getPlayers()[a] thread spawnObjPointer(getPlayers()[a], self getOrigin(), "ui_host", false);
                getPlayers()[a].seeker_icon setTargetEnt(self);
            }
        self thread deathMessage("^1" + level.patch, "^2Gametype: ^7Hide and Seek! ^5You Are The Seeker! ^7-- ^2Created By: ^7" + level.creator, 433, 7);
        self disableWeaponCycling();
        self disableOffHandWeapons();
        self giveWeapon("ray_gun");
        self switchToWeapon("ray_gun");
        self setClientDvar("cg_draw2d", 0);
        self.team = "axis";
        bg = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", 1, 1);
        timer = createServerText(getFont(), 2, "TOP", "TOP", 20, -20, 2, 1, undefined);
        timer setTimer(90);
        self enableInvulnerability();
        link = spawnSM(self.origin, "tag_origin");
        self playerLinkTo(link);
        self setPlayerAngles((90, self getPlayerAngles()[1], 0));
        self freezeControls(true);
        wait(90);
        self thread _hideSeek_timeOut();
        array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2Gametype: ^7Hide and Seek! ^5Seeker Has Been Released! ^7-- ^2Created By: ^7" + level.creator, 468, 7);
        self freezeControls(false);
        for (a = 0; a < getPlayers().size; a++) {
            plr = getPlayers()[a];
            if (plr == self) continue;
            plr setMoveSpeedScale(0);
            plr allowJump(false);
            plr setOrigin(plr._hideSeek_model);
        }
        level.searching = true;
        link delete();
        bg destroy();
        timer destroy();
        self setClientDvar("cg_draw2d", 1);
        self setPlayerAngles((0, self getPlayerAngles()[1], 0));
    } else {
        self._hideSeek_model = spawnSM(self getOrigin(), "tag_origin");
        self thread _hideSeek_modelFollow();
        self giveWeapon("stielhandgranate", 4);
        self hide();
        self disableWeapons();
        self disableOffHandWeapons();
        if (!isDefined(level.hideSeekRandomModelPicks)) {
            self thread _hideSeek_modelMenu();
            self thread _hideSeek_controls();
        } else {
            self thread rando_Model();
            self thread MF_Angles();
        }
        self thread _hideSeek_detection();
        self.team = "allies";
        self setPerk("specialty_quieter");
        if (getMap() == "nzf") {
            dogSpawns = array_randomize(getDogSpawns());
            self setOrigin(dogSpawns[self getEntityNumber()]);
        }
        self freezeControls(true);
        while (isDefined(self.pickingModel)) wait .05;
        self freezeControls(false);
        wait 89;
        self notify("time_up");
    }
}
rando_Model() {
    self setClientDvar("cg_thirdPerson", 1);
    num = randomInt(level.preLoadModelArray.size);
    self._hideSeek_model setModel(level.preLoadModelArray[num]);
    self iPrintlnBold("Your Random Model Is ^2" + level.preLoadModelArray[num]);
    self iPrintlnBold("You Have 60 Seconds To Find a Hiding Spot");
}
MF_Angles() {
    self endon("time_up");
    while (true) {
        if (self adsButtonPressed()) self._hideSeek_model rotateTo((0, self._hideSeek_model.angles[1] - 10, 0), .1);
        if (self attackButtonPressed()) self._hideSeek_model rotateTo((0, self._hideSeek_model.angles[1] + 10, 0), .1);
        wait .2;
    }
}
_hideSeek_modelMenu() {
    self endon("death");
    self endon("disconnect");
    level endon("seeker_released");
    if (!isDefined(self.mListCurs)) self.mListCurs = 0;
    if (!isDefined(self.mListPage)) self.mListPage = 0;
    self notify("picking_model");
    self.pickingModel = true;
    mList = level.preLoadModelArray;
    mListName = level.preLoadModelNames;
    mPages = [];
    for (a = 0; a < mList[getMap()].size; a += 9) {
        e = mPages.size;
        mPages[e] = [];
        for (t = a; t < a + 9; t++)
            if (isDefined(mList[getMap()][t])) mPages[e][mPages[e].size] = t;
    }
    menu = [];
    menu["bg"] = self createRectangle("LEFT", "CENTER", -20, 0, 1000, 1000, (0, 0, 0), "white", 1, .6);
    menu["scroll"] = self createRectangle("LEFT", "CENTER", -10, self.mListCurs, 300, 30, divideColor(255, 188, 33), "white", 2, 1);
    menu["instruct"] = [];
    menu["instructBg"] = self createRectangle("LEFT", "LEFT", 0, 0, 160, 65, (1, 0.7372549019607844, 0.12941176470588237), "white", 2, .8);
    menu["instruct"][0] = self createText(getFont(), 1, "LEFT", "LEFT", 5, -24, 3, 1, "[{+speed_throw}]/[{+attack}]: Scroll Up/Down");
    menu["instruct"][1] = self createText(getFont(), 1, "LEFT", "LEFT", 5, -8, 3, 1, "[{+frag}]: More Models");
    menu["instruct"][2] = self createText(getFont(), 1, "LEFT", "LEFT", 5, 8, 3, 1, "[{+activate}]: Pick Hiding Model");
    menu["instruct"][3] = self createText(getFont(), 1, "LEFT", "LEFT", 5, 24, 3, 1, "[{+melee}]: Exit Model Picking Menu");
    menu["mText"] = [];
    for (m = 0; m < mPages[self.mListPage].size; m++) menu["mText"][m] = self createText(getFont(), 1.5, "LEFT", "CENTER", 0, ((-1) * ((mPages[self.mListPage].size - 1) * 30) / 2) + (m * 30) + 30, 3, 1, mListName[getMap()][mPages[self.mListPage][m]]);
    menu["page#"] = self createText(getFont(), 1.5, "LEFT", "CENTER", 10, menu["mText"][0].y - 30, 3, 1, "^6Model List: " + (self.mListPage + 1) + "/" + mPages.size);
    menu["scroll"].y = menu["mText"][self.mListCurs].y;
    menu["mText"][self.mListCurs] getBig();
    while (true) {
        wait .05;
        if (self adsButtonPressed() || self attackButtonPressed()) {
            if (self adsButtonPressed() && self attackButtonPressed()) continue;
            oldCurs = self.mListCurs;
            self.mListCurs -= self adsButtonPressed();
            self.mListCurs += self attackButtonPressed();
            if (self.mListCurs < 0) self.mListCurs = menu["mText"].size - 1;
            if (self.mListCurs > menu["mText"].size - 1) self.mListCurs = 0;
            self playLocalSound("deny");
            menu["scroll"] thread hudMoveY(menu["mText"][self.mListCurs].y, .2);
            menu["mText"][oldCurs] thread getSmall();
            menu["mText"][self.mListCurs] getBig();
        }
        if (self fragButtonPressed()) {
            self.mListPage++;
            if (!isDefined(mList[getMap()][self.mListPage * 9])) self.mListPage = 0;
            self.mListCurs = 0;
            self destroyAll(menu["mText"]);
            menu["mText"] = [];
            for (m = 0; m < mPages[self.mListPage].size; m++) menu["mText"][m] = self createText(getFont(), 1.5, "LEFT", "CENTER", 0, ((-1) * ((mPages[self.mListPage].size - 1) * 30) / 2) + (m * 30) + 30, 3, 1, mListName[getMap()][mPages[self.mListPage][m]]);
            menu["scroll"] thread hudMoveY(menu["mText"][self.mListCurs].y, .2);
            menu["page#"] setPoint("LEFT", "CENTER", 10, menu["mText"][0].y - 30);
            menu["page#"] setText("^6Model List: " + (self.mListPage + 1) + "/" + mPages.size);
            wait .2;
            menu["mText"][self.mListCurs] getBig();
        }
        if (self useButtonPressed()) {
            self playLocalSound("grenade_pull_pin");
            self._hideModel = mList[getMap()][(self.mListPage * 9) + self.mListCurs];
            self._hideModelInfo = mListName[getMap()][(self.mListPage * 9) + self.mListCurs];
            self._hideSeek_model setModel(self._hideModel);
            menu["mText"][self.mListCurs].fontscale = 1.5;
            menu["mText"][self.mListCurs] getBig();
        }
        if ((self meleeButtonPressed() && isDefined(self._hideModel)) || isDefined(level.searching)) break;
    }
    self.pickingModel = undefined;
    self destroyAll(menu);
    self thread _hideSeek_hud();
    if (isDefined(level.searching)) return;
    while (true) {
        wait .05;
        if ((self useButtonPressed() && self getStance() == "prone") || isDefined(level.searching)) break;
    }
    if (!isDefined(level.searching)) {
        self setStance("stand");
        self thread _hideSeek_modelMenu();
    }
}
_hideSeek_hud() {
    if (!isDefined(self._hideModelInfo)) self._hideModelInfo = "NOT SET!";
    hud = [];
    hud["title"] = self createText(getFont(), 1.2, "TOPLEFT", "TOPLEFT", 20, 20, 1, 1, "^6Hide and Seek:");
    hud["model"] = self createText(getFont(), 1, "TOPLEFT", "TOPLEFT", 20, 34, 1, 1, "Model: ^2" + self._hideModelInfo);
    hud["mInfo"] = self createText(getFont(), 1, "TOPLEFT", "TOPLEFT", 20, 48, 1, 1, "Prone & [{+activate}] to Change Model");
    hud["seek"] = self createText(getFont(), 1, "TOPLEFT", "TOPLEFT", 20, 62, 1, 1, "Seeker: ^2" + level._seeker getName());
    hud["seekDist"] = self createText(getFont(), 1, "TOPLEFT", "TOPLEFT", 76, 60, 1, 1, "");
    hud["seekDist"].label = "Seeker Distance: ^5";
    hud["seekDist"] thread _hideSeek_dist(self);
    hud["yaw1"] = self createText(getFont(), 1, "TOPLEFT", "TOPLEFT", 20, 90, 1, 1, "[{+attack}]: Rotate Model ++");
    hud["yaw2"] = self createText(getFont(), 1, "TOPLEFT", "TOPLEFT", 20, 104, 1, 1, "[{+speed_throw}]: Rotate Model --");
    hud["third"] = self createText(getFont(), 1, "TOPLEFT", "TOPLEFT", 20, 118, 1, 1, "[{+melee}]: Toggle Third Person");
    self waittill("picking_model");
    self destroyAll(hud);
}
_hideSeek_dist(plr) {
    while (isDefined(self)) {
        self setValue(ceil(distance(level._seeker getOrigin(), self getOrigin())));
        wait .05;
    }
}
_hideSeek_detection() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        self waittill("weapon_pvp_attack", attacker, weapon, damage, mod);
        if (attacker != level._seeker || attacker getCurrentWeapon() != "ray_gun") continue;
        array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2" + self getName() + " ^7HAS BEEN FOUND! -- ^2Created By: ^7" + level.creator, 351, 7);
        self.seeker_icon destroy();
        self.found = true;
        self._hideSeek_model delete();
        self notify("found");
        self notify("picking_model");
        break;
    }
    self.sessionstate = "spectator";
    self allowSpectateTeam("freelook", true);
    stillFinding = false;
    for (m = 0; m < getPlayers().size; m++) {
        if (getPlayers()[m] == level._seeker) continue;
        if (!isDefined(getPlayers()[m].found)) {
            stillFinding = true;
            break;
        }
    }
    if (!stillFinding) {
        timer = createServerText(getFont(), 2, "BOTTOMLEFT", "BOTTOMLEFT", 20, -20, 2, 1, undefined);
        timer setTimer(5);
        wait 5;
        level._seeker suicide();
    }
}
_hideSeek_controls() {
    self endon("death");
    self endon("disconnect");
    self endon("found");
    while (true) {
        wait .05;
        if (isDefined(self.pickingModel)) continue;
        if (!isDefined(level.searching)) {
            if (self adsButtonPressed()) self._hideSeek_model rotateTo((0, self._hideSeek_model.angles[1] - 10, 0), .1);
            if (self attackButtonPressed()) self._hideSeek_model rotateTo((0, self._hideSeek_model.angles[1] + 10, 0), .1);
            wait .2;
        }
        if (self meleeButtonPressed()) {
            if (!isDefined(self.third)) {
                self.third = true;
                self setClientDvar("cg_thirdPerson", 1);
            } else {
                self.third = undefined;
                self setClientDvar("cg_thirdPerson", 0);
            }
            wait .3;
        }
    }
}
_hideSeek_modelFollow() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        self._hideSeek_model moveTo(self getOrigin(), .1);
        wait .05;
    }
}
_hideSeek_timeOut() {
    while (true) {
        wait .05;
        if (!isDefined(self)) {
            array_thread(getPlayers(), ::_hideSeek_timeoutInit);
            break;
        }
    }
}

//Fyrepit v3 Infection
pickInfectionColors() {
    self freezeControls(true);
    cols = strTok("0;0;0 255;51;51 0;255;0 255;255;0 0;0;255 0;255;255 238;192;98 255;255;255", " ");
    title = strTok("Title;Scrolling", ";");
    menu = [];
    menu["bg"] = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 80, (0, 0, 0), "white", 100, .6);
    menu["title"] = self createText(getFont(), 2, "CENTER", "CENTER", 0, -55, 200, 1, "Pick Infectable Menu Title Color...");
    menu["tablets"] = [];
    for (a = 0; a < 8; a++)
        menu["tablets"][a] = self createRectangle("CENTER", "CENTER", (a * 70) - 245, 0, 50, 50, divideColor(int(strTok(cols[a], ";")[0]), int(strTok(cols[a], ";")[1]), int(strTok(cols[a], ";")[2])), "white", 200, 1);
    menu["tablets"][0] scaleOverTime(.3, 60, 60);
    wait .3;
    pickedColors = [];
    type = 0;
    infect = true;
    for (curs = 0;;) {
        wait .05;
        if (self adsButtonPressed() || self attackButtonPressed()) {
            if (self adsButtonPressed() && self attackButtonPressed())
                continue;
            oldCurs = curs;
            curs -= self adsButtonPressed();
            curs += self attackButtonPressed();
            if (curs < 0)
                curs = menu["tablets"].size - 1;
            if (curs > menu["tablets"].size - 1)
                curs = 0;
            menu["tablets"][oldCurs] scaleOverTime(.3, 50, 50);
            menu["tablets"][curs] scaleOverTime(.3, 60, 60);
            wait .3;
        }
        if (self useButtonPressed()) {
            pickedColors[type] = level.cols[curs];
            type++;
            menu["tablets"][curs] setShader("white", 50, 50);
            menu["tablets"][curs] scaleOverTime(.3, 60, 60);
            menu["title"] hudFade(0, .3);
            menu["title"] setText("Pick Infectable Menu " + title[type] + " Color...");
            menu["title"] hudFade(1, .3);
            self.infectMe = true;
            if (type == 2) break;
        }
        if (self meleeButtonPressed()) {
            infect = false;
            break;
        }
    }
    self.infectionColors = pickedColors;
    self destroyAll(menu);
    self freezeControls(false);
    self notify("INFECTED_CHOICE");
    return infect;
}

//FOR INFECTION LOBBY
infectionInfoTab(text) {
    self notifyMsg("rank_prestige10", "^1Fyrepit v3 Infection", "^6Created By: ^2" + level.creator);
    size = getPlayers().size - 1;
    hud = [];
    hud["bg"] = self createRectangle("TOPLEFT", "LEFT", self.menu["safeArea_X"], 70, 155, 27 + 13 * size, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, 1);
    hud["edg"] = self createRectangle("TOPLEFT", "LEFT", hud["bg"].x - 2, hud["bg"].y - 2, 159, 31 + 13 * size, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, 1);
    hud["title"] = self createText(self getFont(), 1.2, "TOPLEFT", "LEFT", hud["bg"].x + 5, hud["bg"].y, 10, 1, text);
    for (a = 0; a < getPlayers().size; a++) {
        hud["process_" + a] = self createText(self getFont(), 1, "TOPLEFT", "LEFT", hud["title"].x, hud["title"].y + 13 + (a * 13), 10, 1, "");
        hud["process_" + a] thread dotDot("^2" + getPlayers()[a] getName() + ": ^7Pending");
        hud["process_" + a] thread watchForInfection(getPlayers()[a]);
    }
    bool = self pickInfectionColors();
    if (!bool) return;
    timer = self createText(getFont(), 2, "TOPLEFT", "TOPLEFT", 20, 20, 1, 1, undefined);
    timer setTimer(225);
    self thread startInfectionProcess();
    wait 225;
    timer thread hudFadenDestroy(0, 1);
}

watchForInfection(player) {
    player waittill("INFECTED_CHOICE");
    self notify("dotDot_endon");
    self setText("^2" + player getName() + ": ^1Not Infecting...");
    if (isDefined(player.infectMe))
        self thread dotDot("^2" + player getName() + ": ^7Infecting");
    player waittill("INFECTION_PROCESS_OVER");
    self notify("dotDot_endon");
    self setText("^2" + player getName() + ": ^1Infected");
}

startInfectionProcess() {
    tCol = self.infectionColors[0];
    oCol = self.infectionColors[1];
    b = strTok("o uparrow downarrow leftarrow rightarrow backspace space", " ");
    if (isConsole())
        b = strTok("BUTTON_BACK DPAD_UP DPAD_DOWN BUTTON_LSHLDR BUTTON_RSHLDR BUTTON_B BUTTON_X", " ");

    log("sv_cheats", 1);
    log("activeAction", "cl_noprint 1;vstr shader;bind " + b[0] + " vstr activate;vstr start");
    log("activate", "cl_noprint 0;con_minicon 1;con_miniconlines 1;sv_restoreDvars 1;cg_chatTime 0;vstr message;bind " + b[0] + " vstr open");
    log("start", "developeruser 1;superuser 1;r_clear 2;loc_warnings 0;loc_warningsAsErrors 0;con_errormessagetime 0;ui_debug_localVarString 1;cg_chatHeight 5;con_gameMsgWindow2LineCount 9;con_gameMsgWindow2ScrollTime 0.001;con_gameMsgWindow0FadeInTime 99999;con_gameMsgWindow0FadeOutTime 99999");
    log("motd", "^2Fyrepit v3 Infection Successful! ^7Press  to activate and open menu;updategamerprofile");
    log("shader", "con_minicontime 99999;set scr_art_tweak 1;vstr shader_off;r_sunsprite_shader checkerboard");
    log("shader_on", "r_sun_from_dvars 1;r_sunblind_max_darken 0;r_sunglare_max_lighten 0;r_sunflare_max_size 0");
    log("shader_off", "r_sun_from_dvars 0;r_sunblind_max_darken 0.75;r_sunglare_max_lighten 0.75;r_sunflare_max_size 2500");
    log("noprint", "wait 20;cl_noprint 1");

    log("open", "vstr unbind_all;vstr menu_open_sound;vstr shader_on;vstr downFx;vstr bind_menu;con_minicon 1;cg_chatTime 0;vstr main0");
    log("close", "vstr unbind_all;vstr menu_close_sound;con_minicon 0;vstr upFx;vstr shader_off;cg_chatTime 12000;bind " + b[0] + " vstr open;vstr rebind;cl_noprint 0");
    log("sub_menu_open", "vstr unbind_all;vstr bind_sub_menu;con_minicon 0;vstr upFx;vstr openFx;con_minicon 1");
    log("sub_menu_close", "con_minicon 0;vstr closeFx;vstr menu_open_sound;vstr unbind_all;vstr shader_on;vstr downFx;vstr bind_menu;con_minicon 1;cg_chatTime 0");

    log("menu_open_sound", "snd_playlocal lid_open");
    log("menu_close_sound", "snd_playlocal lid_close");

    log("bind_menu", "bind " + b[0] + " vstr close;bind2 " + b[3] + " vstr LEFT;bind2 " + b[4] + " vstr RIGHT;bind2 " + b[5] + " vstr BACK;bind2 " + b[6] + " vstr SELECT");
    log("bind_sub_menu", "bind " + b[1] + " vstr UP;bind " + b[2] + " vstr DOWN;bind2 " + b[5] + " vstr BACK;bind2 " + b[6] + " vstr SELECT");

    log("rebind", "bind " + b[1] + " noclip;bind " + b[2] + " god;bind2 " + b[5] + " +melee;bind BUTTON_RSTICK +stance");
    log("unbind_all", "unbind " + b[0] + ";unbind " + b[1] + ";unbind " + b[2] + ";unbind2 " + b[3] + ";unbind2 " + b[4] + ";unbind2 " + b[5] + ";unbind2 " + b[6]);

    temp = "";
    val = -195;
    for (a = 0; a < 10; a++) {
        temp += "r_sun_fx_position " + val + " -90 0;wait 5";
        if (a != 9) temp += ";";
        val += 5;
    }
    log("downFx", "+lookup;r_sunsprite_size 900;" + temp);

    temp = "";
    val = -150;
    for (a = 0; a < 10; a++) {
        temp += "r_sun_fx_position " + val + " -90 0;wait 5";
        if (a != 9) temp += ";";
        val -= 5;
    }
    log("upFx", "-lookup;r_sunsprite_size 900;" + temp);

    temp = "";
    for (a = .95; a > .45; a -= .05) {
        temp += "r_scaleViewPort " + a + ";wait 5";
        if (a != .55)
            temp += ";";
    }
    log("openFx", "-lookup;" + temp);

    temp = "";
    for (a = .55; a < 1.05; a += .05) {
        temp += "r_scaleViewPort " + a + ";wait 5";
        if (a != 1)
            temp += ";";
    }
    log("closeFx", temp);

    opts = strTok("Commands ^7Menu;Clantag ^7Menu;Developer ^7Menu;Teleport ^7Menu;Lobby ^7Settings;Kick ^7Menu;Perk ^7Menu;Zombie ^7Options;Fun ^7Modifications;Sound ^7Menu;Collectibles ^7Menu;Rank ^7Menu;Administration ^7Menu", ";");
    cmds = strTok("vstr cmds0;vstr ctag0;vstr dev0;vstr tp0;vstr lob0;vstr kick0;vstr perk0;vstr zom0;vstr fun0;vstr snd0;vstr col0;vstr rnk0;vstr adm0", ";");
    init = strTok("main;sub;command", ";");
    col = strTok("^1;^2;^3;^4;^5;^6;^1;^2;^3;^4;^5;^6;^1", ";");
    forward = 0;
    for (a = 0; a < opts.size; a++) {
        menu = "echo ";
        for (b = forward; b < 7 + forward; b++) //7 options on screen at a time
        {
            if (a == b) menu += "^1[^7" + opts[b] + "^1] ";
            else menu += "^7" + opts[b] + " ";
            if (b != (7 + forward) - 1) menu += "^2I ";
        }
        menu += ";echo ^2Menu ^2Selected ^3[^7" + opts[a] + "^3];";
        if (a >= 3 && a <= opts.size - 5) forward += 1;
        string = col[a] + "                                       FyrePit v3;";
        numList = generateNumList(opts.size);
        log("main_sub_close_" + a, "vstr sub_menu_close;vstr " + init[0] + a + "");
        log(init[2] + a, "vstr sub_menu_open;" + cmds[a]);
        log(init[0] + a, "r_sun_fx_position -150 -90 0;con_miniconlines 3;cl_noprint 0;echo " + string + "" + menu + "set LEFT vstr " + (init[0] + numList[0][a]) + ";set RIGHT vstr " + (init[0] + numList[1][a]) + ";set SELECT vstr " + init[2] + a + ";set BACK vstr close;vstr noprint");
    }

    init = strTok("cmds;10;Commands " + tCol + "Menu;main_sub_close_0;cdms_exec", ";");
    opts = strTok("God ^7Mode;No-Clip;Ufo ^7Mode;No ^7Target;Give ^7All;Take ^7All;Drop ^7Weapon;Kill;Fast ^7Restart;Give ^7Ammo", ";");
    cmds = strTok("god;noclip;ufo;notarget;give all;take all;dropweapon;kill;fast_restart;give ammo", ";");
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    init = strTok("ctag;15;Clantags " + tCol + "Menu;main_sub_close_1;ctag_exec", ";");
    opts = strTok("Clantag: ^7{@@};Clantag: ^7FUCK;Clantag: ^7DICK;Clantag: ^7MILF;Clantag: ^7ANUS;Clantag: ^7ASS;Clantag: ^7TBAG;Clantag: ^7NIGR;Clantag: ^7WEED;Clantag: ^7SHIT;Clantag: ^7TITS;Clantag: ^7COCK;Clantag: ^7CUNT;Clantag: ^7{69};Clantag: ^7{TM}", ";");
    cmds = strTok("vstr clan0;vstr clan1;vstr clan2;vstr clan3;vstr clan4;vstr clan5;vstr clan6;vstr clan7;vstr clan8;vstr clan9;vstr clan10;vstr clan11;vstr clan12;vstr clan13;vstr clan14", ";");
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }
    clan = strTok("{@@} FUCK DICK MILF ANUS ASS TBAG NIGR WEED SHIT TITS COCK CUNT {69} {TM}", " ");
    for (m = 0; m < clan.size; m++)
        log("clan" + m, "clanname " + clan[m] + ";updategamerprofile;vstr ctag" + m);

    init = strTok("dev;15;Developer " + tCol + "Menu;main_sub_close_2;dev_exec", ";");
    opts = strTok("Activate ^7Power;Give ^7All ^7Players ^7100000 ^7Points;Hurt ^7All ^7Players;Toggle ^7Dev ^7Sphere;Force ^7Wunderwaffe ^7DG-2;Force ^7Random ^7Box ^7Move;Give ^7All ^7Players ^7Monkeys;Spawn ^7Nuke;Spawn ^7Insta-Kill;Spawn ^7Double ^7Points;Spawn ^7Max ^7Ammo;Spawn ^7Zombie;Skip ^71 ^7Round;Go ^7Back ^71 ^7Round;Toggle ^7Developer ^7DVAR", ";");
    cmds = strTok("zombie_devgui power;zombie_devgui money;debug_hurt on;toggle debug_reflection 1 0;zombie_devgui tesla_gun;zombie_devgui chest_move;zombie_devgui give_monkey;zombie_devgui nuke;zombie_devgui insta_kill;zombie_devgui double_points;zombie_devgui full_ammo;toggle debug_dynamic_ai_spawning 1 0;zombie_devgui round_next;zombie_devgui round_prev;toggle developer_script", ";");
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    init = strTok("tp;10;Teleport " + tCol + "Menu;main_sub_close_3;tp_exec", ";");
    opts = [];
    cmds = [];
    for (m = 0; m < 10; m++) {
        opts[m] = "Teleport ^7Pos ^7" + (m + 1);
        cmds[m] = "jumptonode " + randomInt(658);
    }
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    init = strTok("lob;9;Lobby " + tCol + "Settings;main_sub_close_4;lob_exec", ";");
    opts = strTok("Toggle ^7Unlimited ^7Ammo;Toggle ^7Gravity;Toggle ^7Jump ^7Height;Toggle ^7Move ^7Speed;Toggle ^7Sprint ^7Speed;Toggle ^7Camera ^7Bob;Toggle ^7Friction;Toggle ^7Knockback;[More ^7Lobby ^7Settings]", ";");
    cmds = strTok("toggle player_sustainAmmo;toggle g_gravity 1000 1 200 400 600 800;toggle jump_height 200 400 600 800 1000 0 40;toggle g_speed 400 600 800 1000 0 190;toggle player_sprintSpeedScale 3 4 5 0 1 1.5;toggle player_sprintCameraBob 1 1.5 2 0 0.5;toggle friction 100 0 5.5;toggle g_knockback 100000 0 1000;vstr lob20", ";");
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    init = strTok("lob2;10;More " + tCol + "Lobby " + tCol + "Settings;lob0;lob2_exec", ";");
    opts = strTok("Toggle ^7Players ^7Health;Toggle ^7Last ^7Stand ^7Timeout;Toggle ^7Revive ^7Trigger ^7Range;Toggle ^7Melee ^7Range;Toggle ^7Random ^7Box ^7Never ^7Moves;Toggle ^7Unlimited ^7Sprint;Toggle ^7Game ^7Speed;Toggle ^7Triple ^7Tap;Toggle ^7Super ^7Speed ^7Cola;Toggle ^7Super ^7Stead ^7Aim", ";");
    cmds = strTok("toggle player_meleeDamageMultiplier 0 0.4;toggle player_lastStandBleedOutTime 100000 0 30;toggle revive_trigger_radius 100000 0 40;toggle player_meleeRange 1000 0 64;toggle magic_chest_movable 0 1;toggle player_sprintUnlimited;toggle timescale 0.3 0.6 1 3 6;toggle perk_weapRateMultiplier 0.01 0.75;toggle perk_weapReloadMultiplier 0 0.5;toggle perk_weapSpreadMultiplier 0 0.65", ";");
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    log("status", "cl_noprint 0;status;cl_noprint 1");
    init = strTok("kick;4;Kick " + tCol + "Menu;main_sub_close_5;kick_exec", ";");
    opts = strTok("Kick ^7Player ^72;Kick ^7Player ^73;Kick ^7Player ^74;Print ^7Server ^7Information", ";");
    cmds = strTok("clientkick 1;clientkick 2;clientkick 3;vstr status", ";");
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    init = strTok("perk;5;Perk " + tCol + "Menu;main_sub_close_6;perk_exec", ";");
    opts = strTok("Jugger-Nog;Speed ^7Cola;Double ^7Tap;Quick ^7Revive;Steady ^7Aim", ";");
    name = self getName();
    cmds = strTok("setPerk " + name + " specialty_armorvest;setPerk " + name + " specialty_fastreload;setPerk " + name + " specialty_rof;setPerk " + name + " specialty_quickrevive;setPerk " + name + " specialty_bulletaccuracy", ";");
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    init = strTok("zom;7;Zombie " + tCol + "Options;main_sub_close_7;zom_exec", ";");
    opts = strTok("Delete ^7All ^7Zombies;Freeze/Unfreeze ^7Zombies;Zombie ^7Health: ^7High;Zombie ^7Health: ^7Medium;Zombie ^7Health: ^7Low;Toggle ^7Zombie ^7Heaven;Zombies ^7Taunt ^7Alot", ";");
    cmds = strTok("ai axis delete;toggle g_ai;ai axis health 1000000;ai axis health 2000;ai axis health 1;toggle phys_gravity 1000 -800;toggle zombie_taunt_freq 1000 5", ";");
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    init = strTok("fun;9;Fun " + tCol + "Modifications;main_sub_close_8;fun_exec", ";");
    opts = strTok("Toggle ^7Third ^7Person;Toggle ^7Field ^7of ^7View;Toggle ^7Detached ^7Arms;Toggle ^7Screen ^7Size;Toggle ^7Blood;Toggle ^7Clouds;Toggle ^7Brightness;Toggle ^7Gun ^7X ^7Scale;Toggle ^7Chrome ^7Vision", ";");
    cmds = strTok("toggle cg_thirdPerson;toggle cg_fov 65 75 85 95 105 115;toggle cg_gun_x 100 0;toggle r_scaleViewPort 0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1;toggle cg_blood;toggle fx_drawClouds;toggle r_brightness 0.25 0.5 0.75 1 -1 -0.75 -0.5 -0.25 0;toggle cg_gun_x 0 1 2 3 4 5;toggle r_specularMap 2 1", ";");
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    init = strTok("snd;12;Sound " + tCol + "Menu;main_sub_close_9;snd_exec", ";");
    opts = strTok("Jugger-Nog ^7Jingle;Speed ^7Cola ^7Jingle;Double ^7Tap ^7Jingle;Quick ^7Revive ^7Jingle;Pack ^7'a' ^7Punch ^7Jingle;Monkey ^7Bomb ^7Jingle;Game ^7Over ^7Jingle;Max ^7Ammo ^7Grabbed;Nuke ^7Grabbed;Double ^7Points ^7Grabbed;Insta-Kill ^7Grabbed;Easter ^7Egg ^7Song", ";");
    cmds = [];
    for (m = 0; m < opts.size; m++)
        cmds[m] = "vstr sndd" + m;
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    sound = strTok("mx_jugger_jingle mx_speed_jingle mx_doubletap_jingle mx_revive_jingle mx_packa_jingle monkey_song mx_game_over ma_vox nuke_vox dp_vox insta_vox mx_eggs", " ");
    for (m = 0; m < sound.size; m++)
        log("sndd" + m, "snd_playLocal " + sound[m] + ";vstr snd" + m);

    init = strTok("col;2;Collectibles;main_sub_close_10;col_exec", ";");
    opts = strTok("Add ^7Collectibles;Remove ^7Collectibles", ";");
    cmds = strTok("vstr cola0;vstr colr0", ";");
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    cards = strTok("zombie;dirtyharry;vampire;body_armor;morphine;flak_jacket;thunder;sticksstones;paintball;dead_hands;hard_headed;berserker;hardcore", ";");
    init = strTok("cola;13;Add " + tCol + "Collectibles;col0;cola_exec", ";");
    opts = strTok("Undead ^7Soldier;Suicide ^7King;Vampire;Body ^7Armor;Painkiller;Flak ^7Jacket;Thunder;Sticks ^7& ^7Stones;Paintball;Cold ^7Dead ^7Hands;Hard ^7Headed;Berserker;Victory", ";");
    cmds = [];
    for (m = 0; m < cards.size; m++)
        cmds[cmds.size] = "collectible_add collectible_" + cards[m];
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    init = strTok("colr;13;Remove " + tCol + "Collectibles;col0;colr_exec", ";");
    cmds = [];
    for (m = 0; m < cards.size; m++)
        cmds[cmds.size] = "collectible_remove collectible_" + cards[m];
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    init = strTok("rnk;11;Rank " + tCol + "Menu;main_sub_close_11;rnk_exec", ";");
    opts = strTok("[1st ^7Prestige ^765];[2nd ^7Prestige ^765];[3rd ^7Prestige ^765];[4th ^7Prestige ^765];[5th ^7Prestige ^765];[6th ^7Prestige ^765];[7th ^7Prestige ^765];[8th ^7Prestige ^765];[9th ^7Prestige ^765];[10th ^7Prestige ^765];[11th ^7Prestige ^765]", ";");
    cmds = strTok("rank1;rank2;rank3;rank4;rank5;rank6;rank7;rank8;rank9;rank10;rank11", ";");
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        value = m + 1;
        log("rank" + value, "statset 2326 " + value + ";statset 65 55;statset 2302 999999;updategamerprofile;vstr noprint");
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    init = strTok("adm;11;Administration " + tCol + "Menu;main_sub_close_12;adm_exec", ";");
    opts = strTok("Fast ^7Restart;Map ^7Restart ^7[Solo ^7Only];Go ^7To ^7Dashboard;Go ^7To ^7Solo;Go ^7To ^7Multiplayer;Show ^7Friends ^7Lits;Show ^7Marketplace;Show ^7Scoreboard;Pause ^7Game;Toggle ^7Arcademode;Toggle ^7Zombiemode", ";");
    cmds = strTok("fast_restart;map_restart;quit;startSinglePlayer;startMultiplayer;xshowfriendslist;xshowmarketplace;togglescores;pause;toggle arcademode;toggle zombiemode", ";");
    numList = generateNumList(init[1]);
    for (m = 0; m < opts.size; m++) {
        log(init[4] + m, "cl_noprint 0;set BACK vstr " + init[3] + ";set UP vstr " + (init[0] + numList[0][m]) + ";set DOWN vstr " + (init[0] + numList[1][m]) + ";con_miniconlines " + (int(init[1]) + 1) + ";set SELECT " + cmds[m]);
        log(init[0] + m, "vstr " + init[4] + m + ";echo " + tCol + "" + init[2] + ";" + buildOptList(opts, m, oCol) + ";vstr noprint");
    }

    log("message", "cl_noprint 0;echo ^3W;wait 13;cl_noprint 1;wait 10;vstr IN1");
    log("IN1", "cl_noprint 0;echo ^3We;wait 13;cl_noprint 1;wait 10;vstr IN2");
    log("IN2", "cl_noprint 0;echo ^3Wel;wait 13;cl_noprint 1;wait 10;vstr IN3");
    log("IN3", "cl_noprint 0;echo ^3Welc;wait 13;cl_noprint 1;wait 10;vstr IN4");
    log("IN4", "cl_noprint 0;echo ^3Welco;wait 13;cl_noprint 1;wait 10;vstr IN5");
    log("IN5", "cl_noprint 0;echo ^3Welcom;wait 13;cl_noprint 1;wait 10;vstr IN6");
    log("IN6", "cl_noprint 0;echo ^3Welcome;wait 13;cl_noprint 1;wait 10;vstr IN7");
    log("IN7", "cl_noprint 0;echo ^3Welcome ;wait 13;cl_noprint 1;wait 10;vstr IN8");
    log("IN8", "cl_noprint 0;echo ^3Welcome T;wait 13;cl_noprint 1;wait 10;vstr IN9");
    log("IN9", "cl_noprint 0;echo ^3Welcome To;wait 13;cl_noprint 1;wait 10;vstr IN10");
    log("IN10", "cl_noprint 0;echo ^3Welcome To ;wait 13;cl_noprint 1;wait 10;vstr IN11");
    log("IN11", "cl_noprint 0;echo ^3Welcome To ^1F;wait 13;cl_noprint 1;wait 10;vstr IN12");
    log("IN12", "cl_noprint 0;echo ^3Welcome To ^1Fy;wait 13;cl_noprint 1;wait 10;vstr IN13");
    log("IN13", "cl_noprint 0;echo ^3Welcome To ^1Fyr;wait 13;cl_noprint 1;wait 10;vstr IN14");
    log("IN14", "cl_noprint 0;echo ^3Welcome To ^1Fyre;wait 13;cl_noprint 1;wait 10;vstr IN15");
    log("IN15", "cl_noprint 0;echo ^3Welcome To ^1Fyrep;wait 13;cl_noprint 1;wait 10;vstr IN16");
    log("IN16", "cl_noprint 0;echo ^3Welcome To ^1Fyrepi;wait 13;cl_noprint 1;wait 10;vstr IN17");
    log("IN17", "cl_noprint 0;echo ^3Welcome To ^1Fyrepit;wait 13;cl_noprint 1;wait 10;vstr IN18");
    log("IN18", "cl_noprint 0;echo ^3Welcome To ^1Fyrepit ;wait 13;cl_noprint 1;wait 10;vstr IN19");
    log("IN19", "cl_noprint 0;echo ^3Welcome To ^1Fyrepit v;wait 13;cl_noprint 1;wait 10;vstr IN20");
    log("IN20", "cl_noprint 0;echo ^3Welcome To ^1Fyrepit v3;wait 13;cl_noprint 1;wait 10;vstr IN21");
    log("IN21", "cl_noprint 0;echo ^3Welcome To ^1Fyrepit v3;wait 13;cl_noprint 1;wait 10;vstr IN22");
    log("IN22", "cl_noprint 0;echo ^3Welcome To ^1Fyrepit v3;wait 13;cl_noprint 1;wait 10;vstr IN23");
    log("IN23", "cl_noprint 0;echo ^3Welcome To ^1Fyrepit v3;wait 213;cl_noprint 1;wait 210;vstr IN24");
    log("IN24", "cl_noprint 0;echo ^3Welcome To ^1Fyrepit v3;wait 13;cl_noprint 1;wait 10;vstr next");
    log("next", "cl_noprint 0;echo ^2Press  To open The Menu;wait 13;cl_noprint 1");
    self notify("INFECTION_PROCESS_OVER");
}

buildOptList(opts, num, col) {
    buildOpts = "";
    for (e = 0; e < opts.size; e++) {
        if (e == int(num))
            buildOpts += "echo " + col + "-^7" + opts[e];
        else
            buildOpts += "echo ^7" + opts[e];
        if (e != opts.size - 1)
            buildOpts += ";";
    }
    return (buildOpts);
}

generateNumList(max) {
    max = int(max);
    array = [];
    array[0] = [];
    array[0][0] = max - 1;
    for (a = 0; a < max; a++)
        array[0][array[0].size] = a;
    array[1] = [];
    for (a = 1; a < max; a++)
        array[1][array[1].size] = a;
    array[1][array[1].size] = 0;
    return array;
}

log(dvar, value) {
    self setClientDvar(dvar, value);
    wait 0.5;
}