scriptPrintln(channel, msg)
{
	setprintchannel(channel);
	println(msg);
	setprintchannel ("script");
}
debugPrintln(channel, msg)
{
	setprintchannel("script_debug");
	println(msg);
	setprintchannel ("script");
}
draw_debug_line(start, end, timer)
{
	for (i=0;i<timer*20;i++)
	{
		line (start, end, (1,1,0.5));
		wait (0.05);
	}
}
waittillend(msg)
{
	self waittillmatch (msg, "end");
}
randomvector(num)
{
	return (randomfloat(num) - num*0.5, randomfloat(num) - num*0.5,randomfloat(num) - num*0.5);
}
angle_dif(oldangle, newangle)
{
	if (oldangle == newangle) return 0;
	while (newangle > 360) newangle -=360;
	while (newangle < 0) newangle +=360;
	while (oldangle > 360) oldangle -=360;
	while (oldangle < 0) oldangle +=360;
	olddif = undefined;
	newdif = undefined;
	if (newangle > 180) newdif = 360 - newangle;
	else newdif = newangle;
	if (oldangle > 180) olddif = 360 - oldangle;
	else olddif = oldangle;
	outerdif = newdif + olddif;
	innerdif = 0;
	if (newangle > oldangle) innerdif = newangle - oldangle;
	else innerdif = oldangle - newangle;
	if (innerdif < outerdif) return innerdif;
	else return outerdif;
}
vectorScale( vector, scale )
{
	vector = (vector[0] * scale, vector[1] * scale, vector[2] * scale);
	return vector;
}
sign( x )
{
	if ( x >= 0 ) return 1;
	return -1;
}
track(spot_to_track)
{
	if(isdefined(self.current_target))
	{
		if(spot_to_track == self.current_target) return;
	}
	self.current_target = spot_to_track;
}
get_enemy_team( team )
{
	assertEx( team != "neutral", "Team must be allies or axis" );
	teams = [];
	teams["axis"] = "allies";
	teams["allies"] = "axis";
	return teams[team];
}
clear_exception( type )
{
	assert( isdefined( self.exception[ type ] ) );
	self.exception[ type ] = anim.defaultException;
}
set_exception( type, func )
{
	assert( isdefined( self.exception[ type ] ) );
	self.exception[ type ] = func;
}
set_all_exceptions( exceptionFunc )
{
	keys = getArrayKeys( self.exception );
	for ( i=0;i < keys.size;i++ )
	{
		self.exception[ keys[ i ] ] = exceptionFunc;
	}
}
set_flash_duration(time_in_seconds)
{
	self.flashduration = time_in_seconds * 1000;
}
cointoss()
{
	return randomint( 100 ) >= 50;
}
waittill_string( msg, ent )
{
	if ( msg != "death" ) self endon ("death");
	ent endon ( "die" );
	self waittill ( msg );
	ent notify ( "returned", msg );
}
waittill_multiple( string1, string2, string3, string4, string5 )
{
	self endon ("death");
	ent = spawnstruct();
	ent.threads = 0;
	if (isdefined (string1))
	{
		self thread waittill_string (string1, ent);
		ent.threads++;
	}
	if (isdefined (string2))
	{
		self thread waittill_string (string2, ent);
		ent.threads++;
	}
	if (isdefined (string3))
	{
		self thread waittill_string (string3, ent);
		ent.threads++;
	}
	if (isdefined (string4))
	{
		self thread waittill_string (string4, ent);
		ent.threads++;
	}
	if (isdefined (string5))
	{
		self thread waittill_string (string5, ent);
		ent.threads++;
	}
	while (ent.threads)
	{
		ent waittill ("returned");
		ent.threads--;
	}
	ent notify ("die");
}
waittill_multiple_ents( ent1, string1, ent2, string2, ent3, string3, ent4, string4 )
{
	self endon ("death");
	ent = spawnstruct();
	ent.threads = 0;
	if ( isdefined( ent1 ) )
	{
		assert( isdefined( string1 ) );
		ent1 thread waittill_string( string1, ent );
		ent.threads++;
	}
	if ( isdefined( ent2 ) )
	{
		assert( isdefined( string2 ) );
		ent2 thread waittill_string ( string2, ent );
		ent.threads++;
	}
	if ( isdefined( ent3 ) )
	{
		assert( isdefined( string3 ) );
		ent3 thread waittill_string ( string3, ent );
		ent.threads++;
	}
	if ( isdefined( ent4 ) )
	{
		assert( isdefined( string4 ) );
		ent4 thread waittill_string ( string4, ent );
		ent.threads++;
	}
	while (ent.threads)
	{
		ent waittill ("returned");
		ent.threads--;
	}
	ent notify ("die");
}
waittill_any_return( string1, string2, string3, string4, string5 )
{
	if ((!isdefined (string1) || string1 != "death") && (!isdefined (string2) || string2 != "death") && (!isdefined (string3) || string3 != "death") && (!isdefined (string4) || string4 != "death") && (!isdefined (string5) || string5 != "death")) self endon ("death");
	ent = spawnstruct();
	if (isdefined (string1)) self thread waittill_string (string1, ent);
	if (isdefined (string2)) self thread waittill_string (string2, ent);
	if (isdefined (string3)) self thread waittill_string (string3, ent);
	if (isdefined (string4)) self thread waittill_string (string4, ent);
	if (isdefined (string5)) self thread waittill_string (string5, ent);
	ent waittill ("returned", msg);
	ent notify ("die");
	return msg;
}
waittill_any( string1, string2, string3, string4, string5 )
{
	assert( isdefined( string1 ) );
	if ( isdefined( string2 ) ) self endon( string2 );
	if ( isdefined( string3 ) ) self endon( string3 );
	if ( isdefined( string4 ) ) self endon( string4 );
	if ( isdefined( string5 ) ) self endon( string5 );
	self waittill( string1 );
}
waittill_any_ents( ent1, string1, ent2, string2, ent3, string3, ent4, string4, ent5, string5, ent6, string6, ent7, string7 )
{
	assert( isdefined( ent1 ) );
	assert( isdefined( string1 ) );
	if ( ( isdefined( ent2 ) ) && ( isdefined( string2 ) ) ) ent2 endon( string2 );
	if ( ( isdefined( ent3 ) ) && ( isdefined( string3 ) ) ) ent3 endon( string3 );
	if ( ( isdefined( ent4 ) ) && ( isdefined( string4 ) ) ) ent4 endon( string4 );
	if ( ( isdefined( ent5 ) ) && ( isdefined( string5 ) ) ) ent5 endon( string5 );
	if ( ( isdefined( ent6 ) ) && ( isdefined( string6 ) ) ) ent6 endon( string6 );
	if ( ( isdefined( ent7 ) ) && ( isdefined( string7 ) ) ) ent7 endon( string7 );
	ent1 waittill( string1 );
}
isFlashed()
{
	if ( !isdefined( self.flashEndTime ) ) return false;
	return gettime() < self.flashEndTime;
}
flag( message )
{
	assertEx( isdefined( message ), "Tried to check flag but the flag was not defined." );
	assertEx( isdefined( level.flag[ message ] ), "Tried to check flag " + message + " but the flag was not initialized." );
	if ( !level.flag[ message ] ) return false;
	return true;
}
flag_init( message )
{
	if ( !isDefined( level.flag ) )
	{
		level.flag = [];
		level.flags_lock = [];
		if ( !isdefined( level.sp_stat_tracking_func ) ) level.sp_stat_tracking_func = ::empty_init_func;
	}
	if ( !isdefined( level.first_frame ) ) assertEx( !isDefined( level.flag[ message ] ), "Attempt to reinitialize existing message: " + message );
	level.flag[ message ] = false;
	if ( !isdefined( level.trigger_flags ) )
	{
		init_trigger_flags();
		level.trigger_flags[ message ] = [];
	}
	else if ( !isdefined( level.trigger_flags[ message ] ) )
	{
		level.trigger_flags[ message ] = [];
	}
	if ( issuffix( message, "aa_" ) )
	{
		thread [[ level.sp_stat_tracking_func ]]( message );
	}
}
empty_init_func( empty )
{
}
issuffix( msg, suffix )
{
	if ( suffix.size > msg.size ) return false;
	for ( i = 0;i < suffix.size;i++ )
	{
		if ( msg[ i ] != suffix[ i ] ) return false;
	}
	return true;
}
flag_set(message)
{
	level.flag[message] = true;
	level notify(message);
	set_trigger_flag_permissions(message);
}
flag_wait( msg )
{
	while( !level.flag[ msg ] ) level waittill( msg );
}
flag_clear( message )
{
	if ( level.flag[ message ] )
	{
		level.flag[ message ] = false;
		level notify( message );
		set_trigger_flag_permissions( message );
	}
}
flag_waitopen( msg )
{
	while( level.flag[ msg ] ) level waittill( msg );
}
script_gen_dump_addline( string, signature )
{
	if ( !isdefined( string ) ) string = "nowrite";
	if ( !isdefined( level._loadstarted ) )
	{
		if ( !isdefined( level.script_gen_dump_preload ) ) level.script_gen_dump_preload = [];
		struct = spawnstruct();
		struct.string = string;
		struct.signature = signature;
		level.script_gen_dump_preload[ level.script_gen_dump_preload.size ] = struct;
		return;
	}
	if ( !isdefined( level.script_gen_dump[ signature ] ) ) level.script_gen_dump_reasons[ level.script_gen_dump_reasons.size ] = "Added: " + string;
	level.script_gen_dump[ signature ] = string;
	level.script_gen_dump2[ signature ] = string;
}
array_thread(entities,process,var1,var2,var3,var4,var5)
{
	keys = getArrayKeys(entities);
	for(i=0;i<keys.size;i++)
		entities[keys[i]] thread[[process]](var1,var2,var3,var4,var5);
}
array_thread4( entities, process, var1, var2, var3, var4 )
{
	keys = getArrayKeys( entities );
	for( i = 0;i < keys.size;i ++ ) entities[ keys[ i ] ] thread [[ process ]]( var1, var2, var3, var4 );
}
array_thread5( entities, process, var1, var2, var3, var4, var5 )
{
	keys = getArrayKeys( entities );
	for( i = 0;i < keys.size;i ++ ) entities[ keys[ i ] ] thread [[ process ]]( var1, var2, var3, var4, var5 );
}
remove_undefined_from_array( array )
{
	newarray = [];
	for( i = 0;i < array.size;i ++ )
	{
		if ( !isdefined( array[ i ] ) ) continue;
		newarray[ newarray.size ] = array[ i ];
	}
	return newarray;
}
trigger_on( name, type )
{
	if ( isdefined ( name ) && isdefined( type ) )
	{
		ents = getentarray( name, type );
		array_thread( ents, ::trigger_on_proc );
	}
	else self trigger_on_proc();
}
trigger_on_proc()
{
	if ( isDefined( self.realOrigin ) ) self.origin = self.realOrigin;
	self.trigger_off = undefined;
}
trigger_off( name, type )
{
	if ( isdefined ( name ) && isdefined( type ) )
	{
		ents = getentarray( name, type );
		array_thread( ents, ::trigger_off_proc );
	}
	else self trigger_off_proc();
}
trigger_off_proc()
{
	if ( !isDefined( self.realOrigin ) ) self.realOrigin = self.origin;
	if ( self.origin == self.realorigin ) self.origin += ( 0, 0, -10000 );
	self.trigger_off = true;
}
set_trigger_flag_permissions( msg )
{
	if ( !isdefined( level.trigger_flags ) ) return;
	level.trigger_flags[ msg ] = remove_undefined_from_array( level.trigger_flags[ msg ] );
	array_thread( level.trigger_flags[ msg ], ::update_trigger_based_on_flags );
}
update_trigger_based_on_flags()
{
	true_on = true;
	if ( isdefined( self.script_flag_true ) )
	{
		true_on = false;
		tokens = create_flags_and_return_tokens( self.script_flag_true );
		for( i=0;i < tokens.size;i++ )
		{
			if ( flag( tokens[ i ] ) )
			{
				true_on = true;
				break;
			}
		}
	}
	false_on = true;
	if ( isdefined( self.script_flag_false ) )
	{
		tokens = create_flags_and_return_tokens( self.script_flag_false );
		for( i=0;i < tokens.size;i++ )
		{
			if ( flag( tokens[ i ] ) )
			{
				false_on = false;
				break;
			}
		}
	}
	[ [ level.trigger_func[ true_on && false_on ] ] ]();
}
create_flags_and_return_tokens( flags )
{
	tokens = strtok( flags, " " );
	for( i=0;i < tokens.size;i++ )
	{
		if ( !isdefined( level.flag[ tokens[ i ] ] ) )
		{
			flag_init( tokens[ i ] );
		}
	}
	return tokens;
}
init_trigger_flags()
{
	level.trigger_flags = [];
	level.trigger_func[ true ] = ::trigger_on;
	level.trigger_func[ false ] = ::trigger_off;
}
getstructarray( name, type )
{
	assertEx( isdefined( level.struct_class_names ), "Tried to getstruct before the structs were init" );
	array = level.struct_class_names[ type ][ name ];
	if ( !isdefined( array ) ) return [];
	return array;
}
struct_class_init()
{
	assertEx( !isdefined( level.struct_class_names ), "level.struct_class_names is being initialized in the wrong place! It shouldn't be initialized yet." );
	level.struct_class_names = [];
	level.struct_class_names[ "target" ] = [];
	level.struct_class_names[ "targetname" ] = [];
	level.struct_class_names[ "script_noteworthy" ] = [];
	level.struct_class_names[ "script_linkname" ] = [];
	for ( i=0;i < level.struct.size;i++ )
	{
		if ( isdefined( level.struct[ i ].targetname ) )
		{
			if ( !isdefined( level.struct_class_names[ "targetname" ][ level.struct[ i ].targetname ] ) ) level.struct_class_names[ "targetname" ][ level.struct[ i ].targetname ] = [];
			size = level.struct_class_names[ "targetname" ][ level.struct[ i ].targetname ].size;
			level.struct_class_names[ "targetname" ][ level.struct[ i ].targetname ][ size ] = level.struct[ i ];
		}
		if ( isdefined( level.struct[ i ].target ) )
		{
			if ( !isdefined( level.struct_class_names[ "target" ][ level.struct[ i ].target ] ) ) level.struct_class_names[ "target" ][ level.struct[ i ].target ] = [];
			size = level.struct_class_names[ "target" ][ level.struct[ i ].target ].size;
			level.struct_class_names[ "target" ][ level.struct[ i ].target ][ size ] = level.struct[ i ];
		}
		if ( isdefined( level.struct[ i ].script_noteworthy ) )
		{
			if ( !isdefined( level.struct_class_names[ "script_noteworthy" ][ level.struct[ i ].script_noteworthy ] ) ) level.struct_class_names[ "script_noteworthy" ][ level.struct[ i ].script_noteworthy ] = [];
			size = level.struct_class_names[ "script_noteworthy" ][ level.struct[ i ].script_noteworthy ].size;
			level.struct_class_names[ "script_noteworthy" ][ level.struct[ i ].script_noteworthy ][ size ] = level.struct[ i ];
		}
		if ( isdefined( level.struct[ i ].script_linkname ) )
		{
			assertex( !isdefined( level.struct_class_names[ "script_linkname" ][ level.struct[ i ].script_linkname ] ), "Two structs have the same linkname" );
			level.struct_class_names[ "script_linkname" ][ level.struct[ i ].script_linkname ][ 0 ] = level.struct[ i ];
		}
	}
}
fileprint_start( file )
{
}
fileprint_map_start( file )
{
}
fileprint_chk( file , str )
{
}
fileprint_map_header( bInclude_blank_worldspawn )
{
	if ( !isdefined( bInclude_blank_worldspawn ) ) bInclude_blank_worldspawn = false;
	assert( isdefined( level.fileprint ) );
}
fileprint_map_keypairprint( key1, key2 )
{
}
fileprint_map_entity_start()
{
}
fileprint_map_entity_end()
{
}
fileprint_end()
{
}
fileprint_radiant_vec( vector )
{
}
is_mature()
{
	if ( level.onlineGame ) return true;
	return GetDvarInt( "cg_mature" );
}
is_german_build()
{
	if( GetDvar( "language" ) == "german" )
	{
		return true;
	}
	return false;
}
//ADDED FUNCTIONS
getMap()
{
	if(level.script == "nazi_zombie_prototype")return "nzp";
	if(level.script == "nazi_zombie_asylum")return "nza";
	if(level.script == "nazi_zombie_sumpf")return "nzs";
	if(level.script == "nazi_zombie_factory")return "nzf";
	if(level.script == "credits")return "cred";
}

checkIfDefined(scriptVar)
{
	if(!isDefined(scriptVar) || !scriptVar)
		return undefined;
	return true;
}