#include common_scripts\utility;
#include maps\_utility;
#include maps\_hud_util;
#include maps\_createmenu;
#include maps\_createcam;
#include maps\_destructible_types;
//Survival Mode
smelter() {
    level endon("SMELTER_FAIL");
    pos = (205.126, -650.927, 36.1994);
    trig = spawnTrigger(pos, 35);
    trig smallArray("SMELT");
    trig setString("Press [{+activate}] To Activate Smelter [Cost: 750]");
    level thread smelterHint(pos);
    orig = (207.02, -453.391, -2.87622);
    level.additionTrigs["smelt"] = trig;
    while (true) {
        trig waittill("trigger", i, check);
        if (!isDefined(check)) {
            if (!i useButtonPressed()) continue;
            if (i.is_zombie) continue;
            if (isDefined(i.revivetrigger)) continue;
            if (i.score < 750) {
                i noMoneySound();
                continue;
            }
            i minus_to_player_score(750);
        }
        trig setString("Smelter Activated");
        level.smelterActivated = true;
        for (a = 0; a < 16; a++) {
            origin = (orig[0] + (a * -20), orig[1], orig[2]);
            if (!isSurv()) {
                FX = spawnSM(origin, "tag_origin", (-90, 0, 0));
                FX smallArray("SMELT");
                playFxOnTag(loadFx("maps/zombie/fx_zombie_mainframe_steam"), FX, "tag_origin");
            } else playFx(loadFx("maps/zombie/fx_zombie_mainframe_steam"), origin);
            level thread smelterDoDamage(origin);
            wait .15;
        }
        trig setString("Please Wait");
        wait 10;
        level.smelterActivated = undefined;
        wait 20;
        trig setString("Press [{+activate}] to Activate Smelter [Cost: 750]");
    }
}
smelterHint(origin) {
    level endon("SMELTER_FAIL");
    while (true) {
        FX = spawnSM(origin, "tag_origin", (-90, 0, 0));
        FX smallArray("SMELT");
        playFxOnTag(loadFx("maps/zombie/fx_zombie_mainframe_steam"), FX, "tag_origin");
        wait 8;
    }
}
smelterDoDamage(origin) {
    level endon("SMELTER_FAIL");
    while (isDefined(level.smelterActivated)) {
        level killZombiesWithinDistance(origin, 30, "headGib");
        wait .05;
    }
}
initTeethTrap() {
    level endon("TEETH_FAIL");
    door = [];
    activator = spawnSM((590.875, -2103.3, 174.993), "zombie_wallclock_main", (-90, 270, 90));
    activator smallArray("TEETH");
    door[0] = spawnMultipleModels((140, -2003, 91), 3, 1, 2, -50, 0, 80, "zombie_vending_doubletap_on");
    door[1] = spawnMultipleModels(door[0][0].origin + (248, 0, 0), 3, 1, 2, 50, 0, 80, "zombie_vending_doubletap_on");
    door[2] = spawnMultipleModels(door[0][1].origin, 5, 1, 1, 50, 0, 0, "zombie_vending_doubletap_on");
    for (a = 0; a < door.size; a++) array_thread(door[a], ::smallArray, "TEETH");
    pos = (activator.origin - (0, 0, 70));
    teethTrig = spawnTrigger(pos, 40);
    teethTrig smallArray("TEETH");
    teethTrig setString("Press [{+activate}] To Activate Teeth Trap! [Cost: 2500]");
    level.additionTrigs["teethTrap"] = teethTrig;
    while (true) {
        teethTrig waittill("trigger", i, check);
        if (!isDefined(check)) {
            if (!i useButtonPressed()) continue;
            if (i.is_zombie) continue;
            if (isDefined(i.revivetrigger)) continue;
            if (i.score < 2500) {
                i noMoneySound();
                continue;
            }
            i minus_to_player_score(2500);
        }
        playSoundAtPosition("pa_buzz", activator.origin);
        teethTrig setString("Please wait...");
        activator rotatePitch(360, 18, .5, .5);
        for (b = 0; b < 4; b++) {
            for (a = 1; a < door[2].size; a++) {
                door[2][a] moveTo(door[2][a].origin + (0, 0, -80), 1, .2);
                door[2][a] waittill("movedone");
                playSoundAtPosition("grenade_explode", door[2][a].origin);
                playFx(loadFx("maps/zombie/fx_zombie_dog_explosion"), door[2][a].origin);
                playFx(loadFx("env/fire/fx_fire_player_torso"), door[2][a].origin);
                playFx(loadfx("explosions/default_explosion"), door[2][a].origin);
                killZombiesWithinDistance(door[2][a].origin, 150, "flame");
                doPlayerDamage(door[2][a].origin, 100);
                earthquake(1.5, 1, door[2][a].origin, 90);
                door[2][a] moveTo(door[2][a].origin + (0, 0, 80), 3, .5, .5);
            }
        }
        wait 30;
        teethTrig setString("Press [{+activate}] To Activate ^2Teeth Trap ^7[Cost: 2500]");
    }
}
teslaTrap() {
    pt = [];
    pt[0] = spawnSM((177, -2373, 194), "zombie_zapper_tesla_coil", (-135, 0, 0));
    pt[1] = spawnSM((74, -2373, 194), "zombie_zapper_tesla_coil", (-225, 0, 0));
    pt[2] = spawnSM((177, -2373, 88), "zombie_zapper_tesla_coil", (-45, 0, 0));
    pt[3] = spawnSM((74, -2373, 88), "zombie_zapper_tesla_coil", (45, 0, 0));
    lever = spawnSM((241, -2368, 147), "zombie_power_lever_handle", (180, 0, -90));
    light = spawnSM(lever.origin - (20, 0, 0), "zombie_zapper_cagelight_red", (0, 0, 90));
    lever2 = spawnSM((241, -2377, 147), "zombie_power_lever_handle", (180, 180, -90));
    light2 = spawnSM(lever2.origin - (20, 0, 0), "zombie_zapper_cagelight_red", (0, 180, 90));
    trig = spawnTrigger(lever.origin - (0, 0, 40), 50);
    trig setString("Press [{+activate}] To Activate Electric Trap [Cost: 1500]");
    level.additionTrigs["teslaTrap"] = trig;
    while (true) {
        trig waittill("trigger", i, check);
        if (!isDefined(check)) {
            if (!i useButtonPressed()) continue;
            if (i.is_zombie) continue;
            if (isDefined(i.revivetrigger)) continue;
            if (i.score < 1500) {
                i noMoneySound();
                continue;
            }
            i minus_to_player_score(1500);
        }
        trig setString("");
        light setModel("zombie_zapper_cagelight_green");
        light2 setModel("zombie_zapper_cagelight_green");
        lever rotateRoll(-90, .5);
        lever playSound("amb_sparks_l_b");
        lever2 rotateRoll(-90, .5);
        lever2 playSound("amb_sparks_l_b");
        sound = spawn("script_origin", pt[0].origin);
        sound playSound("elec_start");
        sound playLoopSound("elec_loop");
        hitPos = [];
        for (m = 89; m <= 164; m += 7.5) hitPos[hitPos.size] = (m, -2373, 88);
        for (m = 0; m < 30; m++) {
            fx = [];
            for (e = 0; e < pt.size; e++) {
                fx[e] = spawnSM(pt[e].origin, "tag_origin");
                playFxOnTag(level._effect["tesla_bolt"], fx[e], "tag_origin");
            }
            fx[0] moveTo(pt[3].origin, .4, .2);
            fx[1] moveTo(pt[2].origin, .4, .2);
            fx[2] moveTo(pt[1].origin, .4, .2);
            fx[3] moveTo(pt[0].origin, .4, .2);
            for (e = 0; e <= 1; e += .05) {
                zom = getAiSpeciesArray("axis", "all");
                for (j = 0; j < zom.size; j++) {
                    for (t = 0; t < hitPos.size; t++) {
                        if (distance(zom[j].origin, hitPos[t]) < 10 && !isDefined(zom[j].marked_for_death)) {
                            zom[j] thread tesla_play_death_fx();
                            zom[j] doDamage(zom[j].health + 666, zom[j].origin, undefined, undefined, "riflebullet");
                            zom[j].marked_for_death = true;
                            zom[j] thread playElecVocals();
                        }
                    }
                }
                for (t = 0; t < hitPos.size; t++) doPlayerDamage(hitPos[t], 10);
                wait .05;
            }
            array_delete(fx);
        }
        sound stopLoopSound();
        sound delete();
        light setModel("zombie_zapper_cagelight_red");
        light2 setModel("zombie_zapper_cagelight_red");
        lever rotateRoll(90, .5);
        lever playSound("elec_arc");
        lever2 rotateRoll(90, .5);
        lever2 playSound("elec_arc");
        wait(randomIntRange(15, 30));
        lever playSound("pa_buzz");
        lever2 playSound("pa_buzz");
        trig setString("Press [{+activate}] To Activate Electric Trap [Cost: 1500]");
    }
}
playElecVocals() {
    if (isDefined(self)) {
        org = self.origin;
        wait .15;
        playSoundAtPosition("elec_vocals", org);
        playSoundAtPosition("zombie_arc", org);
        playSoundAtPosition("exp_jib_zombie", org);
    }
}
doTeleportingRounds() {
    level notify("teleZoms_over");
    while (true) {
        wait(randomIntRange(240, 600));
        if (isDefined(level.bossRound)) continue;
        level.teleRound = true;
        rNum = randomIntRange(30, 45);
        array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^5WARPING ZOMBIES! ^7for " + rNum + " Seconds! -- ^2Created By: ^7" + level.creator, 384);
        level thread init_teleZoms();
        wait(rNum);
        level notify("teleZoms_over");
        level.teleRound = undefined;
    }
}
alwaysFoggy() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        self setVolFog(229, 200, 380, 200, .16, .204, .274, 1);
        wait 1;
    }
}
destroy_stopWatch() {
    while (true) {
        self.stopwatch_elem destroy();
        self.stopwatch_elem_glass destroy();
        wait .05;
    }
}
bounceAround() {
    while (isDefined(self)) {
        self thread rotateEntYaw(360, 1);
        self moveZ(-20, .5, .2, .2);
        wait .5;
        self moveZ(20, .5, .2, .2);
        wait .5;
    }
}
physicalMenuFx() {
    fx1 = spawnMultipleModels((-129, 541, 121), 1, 1, 10, 0, 0, 10, "zombie_zapper_cagelight_red", (-90, 0, 0));
    fx2 = spawnMultipleModels((17, 541, 121), 1, 1, 10, 0, 0, 10, "zombie_zapper_cagelight_red", (90, 0, 0));
    fx1[0] playLoopSound("packa_rollers_loop");
    while (true) {
        for (m = 0; m < 10; m++) {
            if (m == 0) {
                fx1[9] setModel("zombie_zapper_cagelight_red");
                fx2[9] setModel("zombie_zapper_cagelight_red");
            }
            fx1[m] setModel("zombie_zapper_cagelight_green");
            fx2[m] setModel("zombie_zapper_cagelight_green");
            fx1[m - 1] setModel("zombie_zapper_cagelight_red");
            fx2[m - 1] setModel("zombie_zapper_cagelight_red");
            wait .2;
        }
    }
}
initPhysicalMenu() {
    array = [];
    keys = getArrayKeys(level.zombie_weapons);
    for (a = 0; a < keys.size; a++)
        if (!isSubStr(keys[a], "upgraded") && !isIllegalWeapon(keys[a])) array[array.size] = keys[a];
    keys = array;
    basePoint = (-57, 618, 160);
    trig = spawnTrigger(basePoint - (0, 50, 60.875), 50);
    trig setString("Press [{+activate}] To Use Physical Weapons Menu");
    while (true) {
        trig waittill("trigger", user);
        if (user useButtonPressed() && !user.is_zombie && !isDefined(user.revivetrigger) && user.menuMoves < 5) {
            randy = array_randomize(keys);
            weapon = [];
            weapon[0] = spawnSM(basePoint + (0, 0, 15), getWeaponModel(randy[0]), (0, 180, 0));
            weapon[1] = spawnSM(basePoint, getWeaponModel(randy[1]), (0, 180, 0));
            weapon[2] = spawnSM(basePoint - (0, 0, 15), getWeaponModel(randy[2]), (0, 180, 0));
            weapon[0] moveY(-40, 2, 0, 1);
            weapon[1] moveY(-50, 2, 0, 1);
            weapon[2] moveY(-40, 2, 0, 1);
            weapon[0] playSound("packa_weap_upgrade");
            trig setString("");
            currentWeapon = [];
            currentWeapon[0] = randy[0];
            currentWeapon[1] = randy[1];
            currentWeapon[2] = randy[2];
            moves = 5 - user.menuMoves;
            text = user createText("smallFixed", 1, "CENTER", "CENTER", 0, 100, 1, 1, "Moves Remaining: " + (5 - user.menuMoves));
            wait 1;
            while (true) {
                if (user adsButtonPressed() && user.menuMoves < 5) {
                    user.menuMoves++;
                    for (m = 0; m < weapon.size; m++) weapon[m] hide();
                    thread createTempWeapon(weapon[0].origin, weapon[0].origin + (0, 40, 0), weapon[0].model, (0, 180, 0), .5, .25, .25);
                    thread createTempWeapon(weapon[1].origin, weapon[1].origin + (0, 10, 15), weapon[1].model, (0, 180, 0), .5, .25, .25);
                    thread createTempWeapon(weapon[2].origin, weapon[2].origin + (0, -10, 15), weapon[2].model, (0, 180, 0), .5, .25, .25);
                    while (true) {
                        newWeapon = keys[randomInt(keys.size)];
                        if (newWeapon != currentWeapon[0] && newWeapon != currentWeapon[1] && newWeapon != currentWeapon[2]) break;
                        wait .05;
                    }
                    thread createTempWeapon(basePoint - (0, 0, 15), basePoint - (0, 40, 15), getWeaponModel(newWeapon), (0, 180, 0), .5, .25, .25);
                    weapon[0] setModel(weapon[1].model);
                    weapon[1] setModel(weapon[2].model);
                    weapon[2] setModel(getWeaponModel(newWeapon));
                    currentWeapon[0] = currentWeapon[1];
                    currentWeapon[1] = currentWeapon[2];
                    currentWeapon[2] = newWeapon;
                    wait .5;
                    for (m = 0; m < weapon.size; m++) weapon[m] show();
                    text setText("Moves Remaining: " + (5 - user.menuMoves));
                }
                if (user attackButtonPressed() && user.menuMoves < 5) {
                    user.menuMoves++;
                    for (m = 0; m < weapon.size; m++) weapon[m] hide();
                    while (true) {
                        newWeapon = keys[randomInt(keys.size)];
                        if (newWeapon != currentWeapon[0] && newWeapon != currentWeapon[1] && newWeapon != currentWeapon[2]) break;
                        wait .05;
                    }
                    thread createTempWeapon(basePoint + (0, 0, 15), basePoint + (0, -40, 15), getWeaponModel(newWeapon), (0, 180, 0), .5, .25, .25);
                    thread createTempWeapon(weapon[0].origin, weapon[0].origin - (0, 10, 15), weapon[0].model, (0, 180, 0), .5, .25, .25);
                    thread createTempWeapon(weapon[1].origin, weapon[1].origin + (0, 10, -15), weapon[1].model, (0, 180, 0), .5, .25, .25);
                    thread createTempWeapon(weapon[2].origin, weapon[2].origin + (0, 40, 0), weapon[2].model, (0, 180, 0), .5, .25, .25);
                    weapon[2] setModel(weapon[1].model);
                    weapon[1] setModel(weapon[0].model);
                    weapon[0] setModel(getWeaponModel(newWeapon));
                    currentWeapon[2] = currentWeapon[1];
                    currentWeapon[1] = currentWeapon[0];
                    currentWeapon[0] = newWeapon;
                    wait .5;
                    for (m = 0; m < weapon.size; m++) weapon[m] show();
                    text setText("Moves Remaining: " + (5 - user.menuMoves));
                }
                if (user.menuMoves >= 5) {
                    for (t = 5; t >= 0; t--) {
                        text setText("Take Weapon or Leave [Time Left: ^1" + t + "^7]");
                        for (e = 0; e <= 1; e += .05) {
                            wait .05;
                            if (user useButtonPressed() || distance(basePoint - (0, 50, 60.875), user.origin) > 50 || isDefined(user.revivetrigger)) break;
                        }
                        if (user useButtonPressed() || distance(basePoint - (0, 50, 60.875), user.origin) > 50 || isDefined(user.revivetrigger)) break;
                    }
                }
                if (user useButtonPressed()) {
                    sWeapon = currentWeapon[1];
                    primaries = user getWeaponsListPrimaries();
                    if (isDefined(primaries) && primaries.size >= 2) user takeWeapon(user getCurrentWeapon());
                    user giveWeapon(sWeapon);
                    user giveMaxAmmo(sWeapon);
                    user switchToWeapon(sWeapon);
                    user.menuMoves = 5;
                    break;
                }
                if (distance(basePoint - (0, 50, 60.875), user.origin) > 50 || isDefined(user.revivetrigger) || user.menuMoves >= 5) break;
                wait .05;
            }
            text destroy();
            weapon[0] playSound("packa_deny");
            weapon[0] moveY(50, 2, 1);
            weapon[1] moveY(60, 2, 1);
            weapon[2] moveY(50, 2, 1);
            wait 2;
            for (m = 0; m < weapon.size; m++) weapon[m] delete();
            trig setString("Press [{+activate}] To Use Physical Weapons Menu");
            wait .05;
        }
    }
}
quicklyMove(endPos) {
    self hide();
    self.origin = endPos;
    self show();
}
initFlinger() {
    origin = (-597, -119, 69.125);
    flin = [];
    for (m = 0; m < 3; m++) flin[m] = spawnSM((origin[0] + (m * 24), origin[1], origin[2]), "zombie_treasure_box_lid", (0, 90, 0));
    flin[0] linkTo(flin[2]);
    flin[1] linkTo(flin[2]);
    trig = spawn("trigger_radius", flin[1].origin - (12, 0, 0), 1, 35, 35);
    while (true) {
        trig waittill("trigger", user);
        if (user.is_zombie == true) continue;
        player = getPlayers();
        flin[2] playSound("ray_reload_open");
        wait 1.3;
        flin[2] playSound("ray_reload_open");
        wait 1.3;
        for (m = 0; m < player.size; m++)
            if (distance(player[m].origin, trig.origin) <= 35) player[m] thread flingerLaunch(flin[1]);
        flin[2] rotateRoll(55, .3);
        flin[2] playSound("shoot_off");
        wait 1;
        flin[2] rotateRoll(-55, .3);
    }
}
flingerLaunch(flin) {
    pos1 = flin getOrigin();
    pos2 = (320, pos1[1], pos1[2]);
    dist = distance(pos1, pos2);
    center = spawnSM((pos1[0] + (dist / 2), pos1[1], pos1[2]), "tag_origin");
    link = spawnSM(self getOrigin(), "tag_origin");
    link linkTo(center);
    self playerLinkTo(link);
    center rotatePitch(180, 1.5);
    wait 1.5;
    link delete();
    center delete();
}
initBombs() {
    self thread spawnBomb(0, (442, -1664, 56), (0, -90, 0));
    self thread spawnBomb(1, (388, -2502, 88), (0, 0, 0));
    self thread spawnBomb(2, (-175, -508, 69), (0, 0, 0));
    self thread spawnBomb(3, (511, 210, 61), (0, -90, 0));
}
spawnBomb(num, loc, angle) {
    bomb = spawnSM(loc, "zombie_transformer", angle);
    temp = spawnSM(loc + (0, 0, 70), "tag_origin", (-90, 0, 0));
    playFxOnTag(level._effect["zombie_elec_gen_idle"], temp, "tag_origin");
    bomb playLoopSound("power_loop");
    trig = spawnTrig(bomb.origin, 40, 40, "HINT_NOICON", "Press &&1 To Detonate Bomb! [Cost: 1000]");
    level.additionTrigs["bomb" + num] = trig;
    while (true) {
        trig waittill("trigger", m, check);
        if (!isDefined(check)) {
            if (!m useButtonPressed()) continue;
            if (m.is_zombie) continue;
            if (isDefined(m.revivetrigger)) continue;
            if (m.score < 1000) {
                m noMoneySound();
                continue;
            }
            m minus_to_player_score(1000);
        }
        trig setHintString("");
        m playSound("cha_ching");
        for (m = 5; m > 0; m--) {
            bomb playSound("pa_audio_link_" + m);
            wait 1;
        }
        bomb hide();
        temp delete();
        for (m = 0; m < 5; m++) {
            bomb playSound("gen_start");
            bomb playSound("weap_rgun_flux_r");
            bomb playSound("grenade_explode");
            playFx(loadFx("explosions/default_explosion"), bomb.origin);
            playFx(loadFx("weapon/bouncing_betty/fx_explosion_betty_generic"), bomb.origin);
            killZombiesWithinDistance(bomb.origin, 200, "headGib");
            doPlayerDamage(bomb.origin, 200);
            wait .1;
        }
        bomb stopLoopSound();
        wait 45;
        bomb playLoopSound("power_loop");
        temp = spawnSM(loc + (0, 0, 70), "tag_origin");
        playFxOnTag(level._effect["zombie_elec_gen_idle"], temp, "tag_origin");
        trig setHintString("Press &&1 To Detonate Bomb! [Cost: 1000]");
        playFx(loadFx("maps/zombie/fx_transporter_start"), bomb.origin);
        bomb playSound("pa_buzz");
        bomb show();
    }
}
napalmZombie_init() {
    while (true) {
        wait(randomIntRange(120, 180));
        aiArray = getAiSpeciesArray("axis", "all");
        if (!isDefined(aiArray) || aiArray.size == 0 || isDefined(level.bossRound)) continue;
        zom = aiArray[randomInt(aiArray.size)];
        zom.napalm = true;
        zom thread napalmZombie_flame();
        zom thread napalmZombie_trail();
        zom thread napalmZombie_flameVision();
        zom thread napalmZombie_explosion();
        zom thread napalmZombie_alternativeDeath();
        zom startTanning();
        while (isDefined(zom)) {
            wait .05;
            zom.health = 1000000;
            zom.run_combatanim = level.scr_anim["zombie"]["walk1"];
        }
    }
}
napalmZombie_flame() {
    while (isDefined(self)) {
        self thread animscripts\death::flame_death_fx();
        wait 1;
    }
}
napalmZombie_trail() {
    while (isDefined(self)) {
        playFx(loadFx("env/fire/fx_fire_player_md"), self getOrigin());
        wait .2;
    }
}
napalmZombie_flameVision() {
    while (isDefined(self)) {
        plr = getPlayers();
        for (m = 0; m < plr.size; m++) {
            if (distance(plr[m] getOrigin(), self getOrigin()) <= 300) plr[m] setClientDvar("r_flamefx_enable", 1);
            else plr[m] setClientDvar("r_flamefx_enable", 0);
        }
        wait .05;
    }
    setLobbyDvar("r_flamefx_enable", 0);
}
napalmZombie_explosion() {
    self endon("alt_death");
    taunt = false;
    while (isDefined(self)) {
        wait .05;
        plr = getPlayers();
        for (m = 0; m < plr.size; m++) {
            if (distance(plr[m] getOrigin(), self getOrigin()) <= 50) {
                taunt = true;
                self notify("player_close");
                self zombie_taunt();
                self thread napalmZombie_doExplosion();
                break;
            }
        }
        if (taunt) break;
    }
}
napalmZombie_alternativeDeath() {
    self endon("player_close");
    while (true) {
        wait .05;
        if (self.health <= 1) {
            self notify("alt_death");
            self thread napalmZombie_doExplosion();
            break;
        }
    }
}
napalmZombie_doExplosion() {
    fx = strTok("betty_explode thunder default_explosion", " ");
    for (e = 0; e < fx.size; e++) playFx(level._effect[fx[e]], self getOrigin());
    self playSound("grenade_explode");
    for (e = 0; e < 30; e++) playFx(loadFx("env/fire/fx_fire_player_md"), self getOrigin() + (randomIntRange(-100, 100), randomIntRange(-100, 100), 0));
    self.health = 1;
    self thread napalmZombie_doDamage();
    self thread zombie_damage("MOD_ZOMBIE_BETTY", "none", self.origin, getPlayers()[0]);
    level thread killZombiesWithinDistance(self getOrigin(), 200, "flame");
}
napalmZombie_doDamage() {
    if (!isDefined(self getOrigin())) return;
    plr = getPlayers();
    for (e = 0; e < plr.size; e++) {
        if (distance(plr[e] getOrigin(), self getOrigin()) <= 100) radiusDamage(plr[e] getOrigin(), 10, plr[e].health + 100, plr[e].health + 100);
        if (distance(plr[e] getOrigin(), self getOrigin()) > 100 && distance(plr[e] getOrigin(), self getOrigin()) <= 150) radiusDamage(plr[e] getOrigin(), 10, plr[e].health + 50, plr[e].health + 50);
        if (distance(plr[e] getOrigin(), self getOrigin()) > 150 && distance(plr[e] getOrigin(), self getOrigin()) <= 200) getPlayers()[e] doDamage(50, self getOrigin());
        if (distance(plr[e] getOrigin(), self getOrigin()) <= 200) getPlayers()[e] shellShock("death", 5);
    }
}
zombie_taunt() {
    if (!self.has_legs) return;
    self.old_origin = self getOrigin();
    anime = level._zombie_board_taunt[self.animname][2];
    self animScripted("zombie_taunt", self getOrigin(), self.angles, anime);
    wait(getAnimLength(anime));
    self teleport(self.old_origin);
}
survivalLightning() {
    while (true) {
        self playLocalSound("couch_slam");
        earthquake(.3, 1, self.origin, 100);
        for (a = 0; a < 2; a++) {
            self setClientDvars("r_lightTweakSunColor", ".9 .9 .9", "r_lightTweakSunLight", "3");
            wait .1;
            self setClientDvars("r_lightTweakSunLight", "1.2", "r_lightTweakSunColor", "0.588235 0.788235 1 1");
            wait .1;
        }
        wait(randomIntRange(5, 20));
    }
}
roundText() {
    self endon("death");
    self endon("disconnect");
    level.round = 1;
    while (true) {
        self round_wait();
        check = self createRectangle("CENTER", "CENTER", -200, 195, 10, 10, (1, 1, 1), "hud_checkbox_done", 3, 0);
        check thread roundMenuWatch(self);
        check thread hudFade(1, .5);
        bg = self createRectangle("CENTER", "CENTER", -200, 210, 125, 40, (1, 0, 0), "scorebar_zom_2", 1, 0);
        bg thread roundMenuWatch(self);
        bg thread hudFade(1, .5);
        round = self createText(getFont(), 1, "CENTER", "CENTER", -200, 210, 2, 0, "ROUND " + level.round + " COMPLETE!");
        round thread roundMenuWatch(self);
        round hudFade(1, .5);
        round thread flashThread();
        wait 5;
        for (m = 5; m > 0; m--) {
            round setText("NEXT ROUND IN: " + m + "...");
            wait 1;
        }
        round setText("INTERMISSION OVER!");
        wait 1;
        round notify("flashThread Over");
        round thread hudFadenDestroy(0, 1);
        bg thread hudFadenDestroy(0, 1);
        check thread hudFadenDestroy(0, 1);
        level notify("hudChecksOver");
        if (self == getPlayers()[0]) level.round++;
    }
}
roundMenuWatch(player) {
    player endon("death");
    player endon("disconnect");
    level endon("hudChecksOver");
    while (true) {
        if (isDefined(player.usingSurvivalMenu)) self hudFadenDestroy(0, .2);
        wait .05;
    }
}
menuBarriers() {
    door = getEntArray("zombie_door", "targetname");
    door[6].doors[0].origin = (13, -2626, 106);
    door[6].doors[0].angles = (0, 90, 0);
    door[6].doors[0] hide();
    door[6].doors[0] solid();
    door[5].doors[0].origin = (1000.72, 378.984, 100.625);
    door[5].doors[0].angles = (90, 180, 0);
    door[5].doors[0] hide();
    door[5].doors[0] solid();
    door[5].doors[1].origin = (-450.077, -1455.81, 240.125);
    door[5].doors[1].angles = (90, 180, 0);
    door[5].doors[1] hide();
    door[5].doors[1] solid();
    for (a = 0; a < door.size; a++) {
        if (a != 1 && a != 4 && a != 5 && a != 6) {
            for (b = 0; b < door[a].doors.size; b++) door[a].doors[b] delete();
        }
    }
}
spawnSurvivalMenu() {
    box[0] = (6.92691, -2626.01, 88.125);
    ang[0] = (0, 0, 0);
    menu[0] = "KILLSTREAKS";
    func[0] = "surv_kills";
    icon[0] = "hud_burningcaricon";
    box[1] = (-450.077, -1455.81, 199.125);
    ang[1] = (0, 90, 0);
    menu[1] = "EQUIPMENT";
    func[1] = "surv_equip";
    icon[1] = "hud_us_grenade";
    box[2] = (1000.72, 378.984, 64.625);
    ang[2] = (0, 90, 0);
    menu[2] = "POWER-UPS";
    func[2] = "surv_powerup";
    icon[2] = strTok("specialty_instakill_zombies;specialty_doublepoints_zombies", ";")[randomInt(2)];
    menuBox = [];
    for (a = 0; a < box.size; a++) {
        menuBox[a] = spawnStruct();
        menuBox[a].temp = spawnSM(box[a], "zombie_treasure_box", ang[a] + (0, 90, 0));
        menuBox[a] = spawnSM(box[a] + (0, 0, 17.8), "zombie_treasure_box");
        menuBox[a].lid = spawnSM(menuBox[a].origin + (0, -12.05, 18), "zombie_treasure_box_lid");
        menuBox[a].fx = spawnSM(box[a], "tag_origin", (90, (ang[a])[1], 0));
        menuBox[a].lid linkTo(menuBox[a]);
        menuBox[a].angles = ang[a] + (0, -90, 0);
        wait .05;
        menuBox[a].lid unlink();
        menuBox[a].trig = spawn("trigger_radius", menuBox[a].origin, 1, 30, 30);
        menuBox[a] thread menuMonitor(a, func[a], menu[a]);
        menuBox[a] thread controlLid(menuBox[a].lid, menuBox[a].trig);
        playFxOnTag(level._effect["chest_light"], menuBox[a].fx, "tag_origin");
    }
}
menuMonitor(menuType, menuFunc, menuName) {
    while (true) {
        self.trig setCursorHint("HINT_NOICON");
        self.trig setHintString("Press &&1 to Use " + menuName + " Menu!");
        self.trig waittill("trigger", i);
        if (i useButtonPressed() && !isDefined(i.revivetrigger) && !isDefined(i.usingSurvivalMenu) && !i.is_zombie && !isDefined(level.bossRound)) {
            if (menuName == "KILLSTREAKS" && isDefined(i.killstreakInLine)) continue;
            i.usingSurvivalMenu = true;
            i thread useSurvivalMenu(menuType, menuFunc, menuName);
        }
    }
}
useSurvivalMenu(menuType, menuFunc, menuName) {
    self endon("death");
    self endon("disconnect");
    self setClientDvar("cg_draw2d", 0);
    self freezeControls(true);
    self.surv_permaPerkHud destroy();
    self.surv_permaPerkCheck destroy();
    shader = self.surv_permaPerkHud.shader;
    info = getPlayers()[0].menu[menuFunc];
    menu = [];
    menu["bg"] = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", 1, .7);
    menu["split"] = self createRectangle("CENTER", "CENTER", 0, 0, 10, 480, (1, 1, 1), "ui_scrollbar", 2, 1);
    menu["text"] = [];
    for (a = 0; a < info["option"].size; a++) {
        menu["text"][a] = self createText(getFont(), 1.5, "LEFT", "CENTER", 1000, ((-1) * ((info["option"].size - 1) * 30) / 2) + (a * 30), 3, 1, info["option"][a]);
        menu["text"][a] hudMoveX(30, .05);
    }
    menu["scroll"] = self createRectangle("CENTER", "CENTER", 140, menu["text"][0].y, 240, 30, (0, 1, 1), "white", 2, .8);
    menu["infoBox"] = self createRectangle("RIGHT", "CENTER", -20, menu["scroll"].y, 240, 100, (0, 1, 1), "white", 2, .8);
    menu["info1"] = self createText(getFont(), 1, "LEFT", "CENTER", -255, menu["infoBox"].y - 15, 3, 1, "^6" + menuName + " MENU: ^7" + info["option"][0]);
    menu["info2"] = self createText(getFont(), 1, "LEFT", "CENTER", -255, menu["infoBox"].y, 3, 1, "^2DESCRIPTION: ^7" + info["desc"][0]);
    menu["info3"] = self createText(getFont(), 1, "LEFT", "CENTER", -255, menu["infoBox"].y + 15, 3, 1, "^2KILLSTREAK COST: ^7$" + info["cost"][0]);
    self.surv_curs = 0;
    self thread watchFor_heldFragSkipping(info["option"].size);
    self thread watchFor_buttonPress();
    self thread watchFor_playerDowned();
    self thread watchFor_bossRound();
    while (true) {
        self waittill("buttonPress", button);
        if (button == "ads" || button == "attack" || button == "skip") {
            if (isDefined(self.heldingFrag)) continue;
            if (button == "ads") self.surv_curs--;
            if (button == "attack") self.surv_curs++;
            if (self.surv_curs < 0) self.surv_curs = info["option"].size - 1;
            if (self.surv_curs > info["option"].size - 1) self.surv_curs = 0;
            menu["scroll"] thread hudMoveY(menu["text"][self.surv_curs].y, .2);
            menu["infoBox"] thread hudMoveY(menu["scroll"].y, .2);
            menu["info1"] thread hudMoveY(menu["infoBox"].y - 15, .2);
            menu["info2"] thread hudMoveY(menu["infoBox"].y, .2);
            menu["info3"] thread hudMoveY(menu["infoBox"].y + 15, .2);
            menu["info1"] thread hudFade(0, .2);
            menu["info2"] thread hudFade(0, .2);
            menu["info3"] thread hudFade(0, .2);
            wait 0.2;
            menu["info1"] thread hudFade(1, .2);
            menu["info2"] thread hudFade(1, .2);
            menu["info3"] thread hudFade(1, .2);
            menu["info1"] setText("^6" + menuName + " MENU: ^7" + info["option"][self.surv_curs]);
            menu["info2"] setText("^2DESCRIPTION: ^7" + info["desc"][self.surv_curs]);
            menu["info3"] setText("^2KILLSTREAK COST: ^7$" + info["cost"][self.surv_curs]);
        }
        if (button == "use") {
            if (menuName == "KILLSTREAKS" || menuName == "POWER-UPS") {
                if (self.score >= info["cost"][self.surv_curs]) {
                    self thread[[info["function"][self.surv_curs]]](info["i1"][self.surv_curs], info["i2"][self.surv_curs], info["i3"][self.surv_curs]);
                    self minus_to_player_score(info["cost"][self.surv_curs]);
                    self playSound("cha_ching");
                    if (menuName == "KILLSTREAKS") {
                        wait 1;
                        break;
                    }
                } else self noMoneySound();
            } else {
                if (self hasPerk("specialty_altmelee") && info["option"][self.surv_curs] == "BOWIE KNIFE") continue;
                else {
                    if (self.score >= info["cost"][self.surv_curs]) {
                        self thread[[info["function"][self.surv_curs]]](info["i1"][self.surv_curs], info["i2"][self.surv_curs], info["i3"][self.surv_curs]);
                        self minus_to_player_score(info["cost"][self.surv_curs]);
                        self playSound("cha_ching");
                        wait 1;
                    } else self noMoneySound();
                }
            }
            wait .3;
        }
        if (button == "melee" || button == "quit") break;
    }
    self destroyAll(menu);
    self notify("survivalMenu_over");
    self setClientDvar("cg_draw2d", 1);
    self freezeControls(false);
    self.usingSurvivalMenu = undefined;
    self.surv_permaPerkHud = self createRectangle("BOTTOM", "BOTTOM", 0, -20, 25, 25, (1, 1, 1), shader, 1, 1);
    self.surv_permaPerkCheck = self createRectangle("BOTTOM", "BOTTOM", 10, -37, 15, 15, (1, 1, 1), "hud_checkbox_done", 2, 1);
}
watchFor_buttonPress() {
    self endon("death");
    self endon("disconnect");
    self endon("survivalMenu_over");
    while (true) {
        if (self adsButtonPressed()) self notify("buttonPress", "ads");
        if (self attackButtonPressed()) self notify("buttonPress", "attack");
        if (self useButtonPressed()) self notify("buttonPress", "use");
        if (self meleeButtonPressed()) self notify("buttonPress", "melee");
        wait .05;
    }
}
watchFor_playerDowned() {
    self endon("death");
    self endon("disconnect");
    self endon("survivalMenu_over");
    while (true) {
        self waittill("player_downed");
        self notify("buttonPress", "quit");
    }
}
watchFor_bossRound() {
    self endon("death");
    self endon("disconnect");
    self endon("survivalMenu_over");
    while (true) {
        if (isDefined(level.bossRound)) self notify("buttonPress", "quit");
        wait .05;
    }
}
watchFor_heldFragSkipping(max) {
    self endon("death");
    self endon("disconnect");
    self endon("survivalMenu_over");
    while (true) {
        held = 0;
        if (self fragButtonPressed()) {
            self.heldingFrag = true;
            while (self fragButtonPressed()) {
                held++;
                if (held > max - 1) held = 1;
                self playLocalSound("pa_audio_link_" + held);
                for (a = 0; a <= .5; a += .05) {
                    wait .05;
                    if (!self fragButtonPressed()) break;
                }
            }
            self.heldingFrag = undefined;
        }
        if (held != 0) {
            for (a = 0; a < held; a++) {
                self.surv_curs++;
                if (self.surv_curs > max - 1) self.surv_curs = 0;
            }
            self notify("buttonPress", "skip");
        }
        wait .05;
    }
}
controlLid(lid, trig) {
    pos = false;
    while (true) {
        num = 0;
        player = getPlayers();
        for (a = 0; a < player.size; a++)
            if (player[a] isTouching(trig)) num++;
        if (num == 0 && pos == true) {
            lid rotateRoll(-105, .5, .25);
            lid playSound("lid_close");
            pos = false;
            wait .5;
        }
        if (num >= 1 && pos == false) {
            lid rotateRoll(105, .5, .25);
            lid playSound("lid_open");
            pos = true;
            wait .5;
        }
        wait .05;
    }
}
killstreakInit(func, string, protection) {
    string = "PRONE & HOLD [{+activate}] TO " + string;
    if (!isDefined(self.hintString)) {
        self.hintString = self createText(getFont(), 1.1, "CENTER", "BOTTOM", 0, -60, 10, 1, string);
        self.hintString thread flashThread();
        self thread killstreakUse(protection);
    }
    self.hintString setText(string);
    self.killstreakInLine = func;
}
killstreakUse(protection) {
    self endon("death");
    self endon("disconnect");
    while (isDefined(self.hintString)) {
        if (self getStance() == "prone" && self useButtonPressed() && self.sessionstate == "playing" && !isDefined(self.revivetrigger)) {
            time = 0;
            bar = self createPrimaryProgressBar();
            bar updateBar(0, 1);
            text = self createPrimaryProgressBarText();
            text setText("Killstreak Deploying!");
            while (self useButtonPressed() && self getStance() == "prone") {
                time += .05;
                if (!self useButtonPressed() || self getStance() != "prone") break;
                if (time >= 1) {
                    bar destroyElem();
                    text destroy();
                    self.hintString destroy();
                    self.hintString = undefined;
                    self setStance("stand");
                    self[[self.killstreakInLine]]();
                    self setVision("fly_dark");
                    if (protection == "Y") self thread afterKillstreakProtection();
                    self.killstreakInLine = undefined;
                    break;
                }
                wait .05;
            }
            if (isDefined(bar)) {
                bar destroyElem();
                text destroy();
            }
        }
        wait .05;
    }
}
sm_startUpPrompt() {
    if (!isSolo()) wait 9;
    self endon("death");
    self endon("disconnect");
    self.pickingClass = true;
    self freezeControls(true);
    self enableInvulnerability();
    self setBlur(10, 1);
    hud = [];
    text = [];
    classType = strTok("Assault Support;Heavy Gunner;Scout Sniper;Sub-Machine Gunner", ";");
    classWeapons = strTok("zombie_stg44|zombie_shotgun;zombie_30cal|zombie_bar;ptrs41_zombie|zombie_sw_357;zombie_mp40|zombie_thompson", ";");
    classDetails = strTok("^2PRIMARY: ^7STG-44 --- ^2SECONDARY: ^7M1897 TRENCH GUN;^2PRIMARY: ^7BROWNING M1919 --- ^2SECONDARY: ^7BAR;^2PRIMARY: ^7PTRS-41 --- ^2SECONDARY: ^7.357 MAGNUM;^2PRIMARY: ^7MP40 --- ^2SECONDARY: ^7THOMPSON", ";");
    classInfo = strTok("Fight your way through using the close/medium ranged FIREPOWER!;Sit on your fat ass and rape zombie butt!;So I heard you like quickscoping? This is the class for you!;Rush like a try-hard,die like a bitch!", ";");
    perk = strTok("Faster Reloading;Quicker Reviving;Extended Health;Double Rate of Fire", ";");
    perkType = strTok("specialty_fastreload|zombie_perk_bottle_sleight|mx_speed_sting|specialty_fastreload_zombies;specialty_quickrevive|zombie_perk_bottle_revive|mx_revive_sting|specialty_quickrevive_zombies;specialty_armorvest|zombie_perk_bottle_jugg|mx_jugger_sting|specialty_juggernaut_zombies;specialty_rof|zombie_perk_bottle_doubletap|mx_doubletap_sting|specialty_doubletap_zombies", ";");
    perkDetails = strTok("^2PERK: ^7SPEED COLA AKA. SLEIGHT OF HAND;^2PERK: ^7QUICK REVIVE;^2PERK: ^7JUGGER-NOG AKA. JUGGERNAUT;^2PERK: ^7DOUBLE TAP", ";");
    perkInfo = strTok("Take a sip of Speed Cola and speed up your reloads!;Be a morphine addict and inject your teammates twice as fast!;Protect yourself from the undead with a boost of health!;The solution to sluggish guns!", ";");
    for (m = 0; m < 4; m++) {
        hud[m] = self createRectangle("CENTER", "CENTER", -100, (m * 35) - 50, 220, 25, (.5, .6, .8), "scorebar_zom_" + (m + 1), 1, 1);
        text[m] = self createText(getFont(), 1.4, "CENTER", "CENTER", -100, (m * 35) - 50, 2, 1, classType[m]);
    }
    text[0] thread flashThread();
    scroll = self createRectangle("CENTER", "CENTER", 0, -50, 25, 25, (.5, .6, .8), "ui_host", 2, 1);
    title = self createText(getFont(), 2, "LEFT", "CENTER", 35, -10, 2, 1, "PICK A CLASS!");
    details = self createText(getFont(), 1.1, "LEFT", "CENTER", 35, 10, 2, 1, classDetails[0]);
    info = self createText(getFont(), 1, "LEFT", "CENTER", 35, 28, 2, 1, classInfo[0]);
    curs = 0;
    wait .4;
    self thread sm_startUpPrompt_buttonMonitor();
    while (true) {
        self waittill("buttonPress", button);
        if (button == "ads" || button == "attack") {
            oldCurs = curs;
            if (isDefined(self.autoPick) && self.autoPick) curs++;
            curs += self attackButtonPressed();
            curs -= self adsButtonPressed();
            if (curs < 0) curs = text.size - 1;
            if (curs > text.size - 1) curs = 0;
            scroll moveOverTime(.2);
            scroll.y = (curs * 35) - 50;
            text[oldCurs] notify("flashThread Over");
            text[oldCurs] thread hudFade(1, .2);
            text[curs] thread flashThread();
            details setText(classDetails[curs]);
            info setText(classInfo[curs]);
            wait .2;
        }
        if (button == "use") {
            self takeAllGuns();
            self giveWeapon(strTok(classWeapons[curs], "|")[0]);
            self giveWeapon(strTok(classWeapons[curs], "|")[1]);
            self giveMaxAmmo(strTok(classWeapons[curs], "|")[0]);
            self giveMaxAmmo(strTok(classWeapons[curs], "|")[1]);
            self switchToWeapon(strTok(classWeapons[curs], "|")[0]);
            break;
        }
    }
    text[curs] notify("flashThread Over");
    text[curs] hudFade(1, .2);
    curs = 0;
    scroll moveOverTime(.4);
    scroll.y = -50;
    text[0] thread flashThread();
    title thread hudFade(0, .4);
    details thread hudFade(0, .4);
    info thread hudFade(0, .4);
    for (m = 0; m < text.size; m++) {
        text[m] thread hudMoveX(text[m].x - 100, .4);
        text[m] thread hudFade(0, .4);
    }
    wait .4;
    for (m = 0; m < text.size; m++) {
        text[m].x = text[m].x + 200;
        text[m] setText(perk[m]);
        text[m] thread hudMoveX(text[m].x - 100, .4);
        text[m] thread hudFade(1, .4);
    }
    title setText("PICK A PERMANENT PERK!");
    details setText(perkDetails[0]);
    info setText(perkInfo[0]);
    title thread hudFade(1, .4);
    details thread hudFade(1, .4);
    info thread hudFade(1, .4);
    wait .4;
    while (true) {
        self waittill("buttonPress", button);
        if (button == "ads" || button == "attack") {
            oldCurs = curs;
            if (isDefined(self.autoPick) && self.autoPick) curs++;
            curs += self attackButtonPressed();
            curs -= self adsButtonPressed();
            if (curs < 0) curs = text.size - 1;
            if (curs > text.size - 1) curs = 0;
            scroll moveOverTime(.2);
            scroll.y = (curs * 35) - 50;
            text[oldCurs] notify("flashThread Over");
            text[oldCurs] thread hudFade(1, .2);
            text[curs] thread flashThread();
            details setText(perkDetails[curs]);
            info setText(perkInfo[curs]);
            wait .2;
        }
        if (button == "use") {
            self thread sm_startUpPrompt_givePerk(strTok(perkType[curs], "|")[0], strTok(perkType[curs], "|")[1], strTok(perkType[curs], "|")[2], strTok(perkType[curs], "|")[3]);
            break;
        }
        wait .05;
    }
    text[curs] notify("flashThread Over");
    self freezeControls(false);
    self setBlur(0, 1);
    for (m = 0; m < hud.size; m++) hud[m] destroy();
    for (m = 0; m < text.size; m++) text[m] destroy();
    title destroy();
    scroll destroy();
    details destroy();
    info destroy();
    self.pickingClass = undefined;
    self thread sm_startUpPrompt_afterSpectator();
}
sm_startUpPrompt_givePerk(perk, bottle, jingle, shader) {
    wait 1;
    if (self isSwitchingWeapons()) self waittill("weapon_change_complete");
    self playSound("bottle_dispense3d");
    self playSound(jingle);
    currentWeapon = self getCurrentWeapon();
    self giveWeapon(bottle);
    self switchToWeapon(bottle);
    self disableOffhandWeapons();
    self disableWeaponCycling();
    self allowSprint(false);
    self waittill("weapon_change_complete");
    self enableOffhandWeapons();
    self enableWeaponCycling();
    self allowSprint(true);
    self takeWeapon(bottle);
    self switchToWeapon(currentWeapon);
    self setPerk(perk);
    if (perk == "specialty_armorvest") {
        self.maxhealth = level.zombie_vars["zombie_perk_juggernaut_health"];
        self.health = level.zombie_vars["zombie_perk_juggernaut_health"];
        self thread regenerateJuggUponAccident();
    }
    self setBlur(4, .1);
    wait .1;
    self setBlur(0, .1);
    hud = self createRectangle("CENTER", "CENTER", 0, 0, 10, 10, (1, 1, 1), shader, 1, 1);
    hud scaleOverTime(.1, 50, 50);
    wait .1;
    hud scaleOverTime(1, 25, 25);
    wait 2;
    hud moveOverTime(2);
    hud setPoint("BOTTOM", "BOTTOM", 0, -20);
    wait 2;
    check = self createRectangle("BOTTOM", "BOTTOM", 10, -37, 15, 15, (1, 1, 1), "hud_checkbox_done", 2, 0);
    check hudFade(1, .5);
    self.surv_permaPerkHud = hud;
    self.surv_permaPerkCheck = check;
    self thread sm_startUpPrompt_givePerk_monitor(perk);
    self disableGodMode();
}
sm_startUpPrompt_givePerk_monitor(perk) {
    self endon("disconnect");
    while (true) {
        wait .05;
        if (self.sessionstate == "spectator") {
            self.surv_permaPerkHud destroy();
            self.surv_permaPerkCheck destroy();
            if (self hasPerk("specialty_armorvest")) {
                self.maxhealth = 100;
                self.health = self.maxhealth;
            }
            self unsetPerk(perk);
            break;
        }
    }
}
regenerateJuggUponAccident() {
    self endon("disconnect");
    while (true) {
        self waittill("player_downed");
        while (true) {
            wait .05;
            if (!isDefined(self.revivetrigger) && self.sessionstate == "playing") {
                self.maxhealth = level.zombie_vars["zombie_perk_juggernaut_health"];
                self.health = level.zombie_vars["zombie_perk_juggernaut_health"];
                break;
            }
            if (!isDefined(self.revivetrigger) && self.sessionstate == "spectator") break;
        }
        if (!isDefined(self.revivetrigger) && self.sessionstate == "spectator") break;
    }
    self.maxhealth = 100;
    self.health = self.maxhealth;
}
sm_startUpPrompt_buttonMonitor() {
    self.autoPick = false;
    time = getTime();
    while (true) {
        wait .05;
        if (getTime() >= time + 10000) {
            self.autoPick = true;
            break;
        }
        if (self useButtonPressed() || self adsButtonPressed() || self attackButtonPressed() || self fragButtonPressed() || self meleeButtonPressed()) break;
    }
    if (self.autoPick) {
        for (m = 0; m < randomInt(4); m++) {
            self notify("buttonPress", "attack");
            wait .5;
        }
        self notify("buttonPress", "use");
        wait 1;
        for (m = 0; m < randomInt(4); m++) {
            self notify("buttonPress", "attack");
            wait .5;
        }
        self notify("buttonPress", "use");
    } else {
        while (isDefined(self.pickingClass)) {
            if (self adsButtonPressed()) self notify("buttonPress", "ads");
            if (self attackButtonPressed()) self notify("buttonPress", "attack");
            if (self useButtonPressed()) self notify("buttonPress", "use");
            wait .05;
        }
    }
}
sm_startUpPrompt_afterSpectator() {
    self endon("disconnect");
    self waittill("player_downed");
    self thread sm_startUpPrompt_decision();
}
sm_startUpPrompt_decision() {
    self endon("disconnect");
    while (true) {
        if (!isDefined(self.revivetrigger) && self.sessionstate == "spectator") {
            self waittill("spawned_player");
            self thread sm_startUpPrompt();
            break;
        } else if (!isDefined(self.revivetrigger) && self.sessionstate == "playing") {
            self thread sm_startUpPrompt_afterSpectator();
            break;
        }
        wait .05;
    }
}
survivalLunarLanders() {
    lunar = [];
    lunar[0] = spawnStruct();
    lunar[0] = spawnSM((52, -440, -1.2), "zombie_teleporter_pad");
    lunar[0] smallArray("LUNAR");
    lunar[1] = spawnSM((52, -440, -1.2), "zombie_teleporter_pad", (-180, 0, 0));
    lunar[1] smallArray("LUNAR");
    pos = (lunar[0].origin);
    FX = spawnSM(pos, "tag_origin", (270, 0, 0));
    FX smallArray("LUNAR");
    playFxOnTag(level._effect["zombie_flashback_american"], FX, "tag_origin");
    pos2 = ((300, -1640, 58));
    FX2 = spawnSM(pos2, "tag_origin", (270, 0, 0));
    FX2 smallArray("LUNAR");
    playFxOnTag(level._effect["zombie_flashback_american"], FX2, "tag_origin");
    lunar[1] linkTo(lunar[0]);
    lunar[0].seat = [];
    for (a = 0; a < 4; a++) lunar[0].seat[a] = spawnStruct();
    lunar[0].seat[0] = spawnSM(lunar[0].origin + (0, 50, 20), "tag_origin");
    lunar[0].seat[0] smallArray("LUNAR");
    lunar[0].seat[1] = spawnSM(lunar[0].origin + (0, -50, 20), "tag_origin");
    lunar[0].seat[1] smallArray("LUNAR");
    lunar[0].seat[2] = spawnSM(lunar[0].origin + (50, 0, 20), "tag_origin");
    lunar[0].seat[2] smallArray("LUNAR");
    lunar[0].seat[3] = spawnSM(lunar[0].origin + (-50, 0, 20), "tag_origin");
    lunar[0].seat[3] smallArray("LUNAR");
    for (a = 0; a < lunar[0].seat.size; a++) {
        lunar[0].seat[a] linkTo(lunar[0]);
        lunar[0].seat[a].occupied = false;
    }
    lunar[0].ctrlPanel = [];
    lunar[0].ctrlPanel[0] = spawnSM(lunar[0].origin + (0, -8, 40), "zombie_teleporter_control_panel");
    lunar[0].ctrlPanel[0] smallArray("LUNAR");
    lunar[0].ctrlPanel[1] = spawnSM(lunar[0].origin + (0, 8, 40), "zombie_teleporter_control_panel", (0, 180, 0));
    lunar[0].ctrlPanel[1] smallArray("LUNAR");
    for (a = 0; a < lunar[0].ctrlPanel.size; a++) lunar[0].ctrlPanel[a] linkTo(lunar[0]);
    lunar[0].trig = [];
    lunar[0].trig[0] = spawnTrig(lunar[0].origin, 50, 20, "HINT_NOICON", "Press & Hold &&1 To Use Lunar Lander! [Cost: 750]");
    lunar[0].trig[0] smallArray("LUNAR");
    lunar[0].trig[1] = spawnTrig((300, -1640, 58), 50, 20, "HINT_NOICON", "Press & Hold &&1 To Call Lunar Lander!");
    lunar[0].trig[1] smallArray("LUNAR");
    lunar[0].trig[0] thread lunarThink(lunar[0]);
    lunar[0].trig[1] thread lunarThink(lunar[0]);
    lunar[0].pos = "spawn";
}
lunarThink(lunar) {
    level endon("LUNAR_FAIL");
    while (true) {
        self waittill("trigger", a);
        if (a useButtonPressed() && !a.is_zombie && !isDefined(a.revivetrigger) && !isDefined(lunar.isMoving) && !isDefined(level.lunarCooling)) {
            time = 0;
            while (a useButtonPressed()) {
                time += .05;
                if (!a useButtonPressed()) break;
                if (time >= .3) {
                    distance1 = distance(a.origin, (52, -440, -1.2));
                    distance2 = distance(a.origin, (300, -1640, 58));
                    if (lunar.pos == "spawn") {
                        pos1 = distance1;
                        pos2 = distance2;
                    } else {
                        pos1 = distance2;
                        pos2 = distance1;
                    }
                    if (pos1 < pos2) {
                        if (a.score < 750) {
                            a noMoneySound();
                            break;
                        } else a minus_to_player_score(750);
                    }
                    lunar.isMoving = true;
                    level.isMoving = true;
                    for (e = 0; e < getPlayers().size; e++)
                        if (distance(getPlayers()[e].origin, lunar.origin) < 100) {
                            getPlayers()[e] enableInvulnerability();
                            getPlayers()[e] playerLinkTo(lunar.seat[getPlayers()[e] getEntityNumber()]);
                            getPlayers()[e].isOnLunar = true;
                            getPlayers()[e].usingSkyBase = true;
                        }
                    if (lunar.pos == "spawn") lunar thread lunarSpawn2Courtyard();
                    else lunar thread lunarCourtyard2Spawn();
                    wait 9;
                    for (e = 0; e < getPlayers().size; e++)
                        if (isDefined(getPlayers()[e].isOnLunar)) {
                            getPlayers()[e] unlink();
                            getPlayers()[e] thread godCheck();
                            getPlayers()[e].isOnLunar = undefined;
                            getPlayers()[e].usingSkyBase = undefined;
                        }
                    lunar.isMoving = undefined;
                    level.isMoving = undefined;
                }
                wait .05;
            }
        }
    }
}
lunarSpawn2Courtyard() {
    self.pos = "courtyard";
    self.trig[0] setHintString("Lunar Lander Is In Use!");
    self.trig[1] setHintString("Lunar Lander Is In Use!");
    self moveTo((self.origin[0], self.origin[1], 800), 3, .5, 1);
    self vibrate((0, -100, 0), 1.5, .4, 3);
    wait 3;
    self moveTo((300, -1640, self.origin[2]), 3, .5, 1);
    self rotateTo((5, 0, 10), 1, 0, .5);
    wait 2;
    self rotateTo((0, 0, 0), 1);
    wait 1;
    self moveTo((self.origin[0], self.origin[1], 58), 3, 0, 1);
    self vibrate((0, -100, 0), 1.5, .4, 3);
    wait 3;
    self.trig[0] setHintString("Lunar Lander Is Cooling...");
    self.trig[1] setHintString("Lunar Lander Is Cooling...");
    level.lunarCooling = randomIntRange(15, 30);
    wait(level.lunarCooling);
    level.lunarCooling = undefined;
    self.trig[0] setHintString("Press & Hold &&1 To Call Lunar Lander");
    self.trig[1] setHintString("Press & Hold &&1 To Use Lunar Lander! [Cost: 750]");
}
lunarCourtyard2Spawn() {
    self.pos = "spawn";
    self.trig[0] setHintString("Lunar Lander Is In Use!");
    self.trig[1] setHintString("Lunar Lander Is In Use!");
    self moveTo((self.origin[0], self.origin[1], 800), 3, .5, 1);
    self vibrate((0, -100, 0), 1.5, .4, 3);
    wait 3;
    self moveTo((52, -440, self.origin[2]), 3, .5, 1);
    self rotateTo((-5, 0, -10), 1, 0, .5);
    wait 2;
    self rotateTo((0, 0, 0), 1);
    wait 1;
    self moveTo((self.origin[0], self.origin[1], -1.2), 3, 0, 1);
    self vibrate((0, -100, 0), 1.5, .4, 3);
    wait 3;
    self.trig[0] setHintString("Lunar Lander Is Cooling...");
    self.trig[1] setHintString("Lunar Lander Is Cooling...");
    level.lunarCooling = randomIntRange(15, 30);
    wait(level.lunarCooling);
    level.lunarCooling = undefined;
    self.trig[0] setHintString("Press & Hold &&1 To Use Lunar Lander! [Cost: 750]");
    self.trig[1] setHintString("Press & Hold &&1 To Call Lunar Lander");
}
rareZombieDrops() {
    while (true) {
        wait(randomIntRange(200, 400));
        zombz = getAiSpeciesArray("axis", "all");
        chosenZombie = zombz[randomInt(zombz.size)];
        chosenZombie thread rareDropOnDeath();
    }
}
rareDropOnDeath(pickedWeapon) {
    self waittill("death");
    keys = getArrayKeys(level.zombie_weapons);
    if (!isDefined(pickedWeapon))
        while (true) {
            wait .05;
            pickedWeapon = keys[randomInt(keys.size)];
            if (!isSubStr(pickedWeapon, "upgraded") && !isIllegalWeapon(pickedWeapon)) break;
        }
    model = spawnSM(self.origin + (0, 0, 50), getWeaponModel(pickedWeapon), self.angles[1]);
    playFxOnTag(level._effect["powerup_on"], model, "tag_origin");
    model thread powerup_timeout();
    playSoundAtPosition("spawn_powerup", model.origin);
    model playLoopSound("spawn_powerup_loop");
    model thread bounceAround();
    trig = spawnTrigger(self.origin, 30);
    trig setString("Press [{+activate}] to Trade Weapons!");
    while (true) {
        plr = getPlayers();
        for (m = 0; m < plr.size; m++) {
            if (!plr[m].is_zombie && !isDefined(plr[m].revivetrigger) && distance(plr[m].origin, model.origin) < 64 && plr[m] useButtonPressed()) {
                primaries = plr[m] getWeaponsListPrimaries();
                if (isDefined(primaries) && primaries.size >= 2) plr[m] takeWeapon(plr[m] getCurrentWeapon());
                plr[m] giveWeapon(pickedWeapon);
                plr[m] giveMaxAmmo(pickedWeapon);
                plr[m] switchToWeapon(pickedWeapon);
                model delete();
                break;
            }
        }
        wait .05;
        if (!isDefined(model)) break;
    }
    trig delete();
}
allTrapped() {
    while (true) {
        zombie = [];
        wait(randomIntRange(200, 400));
        while (true) {
            wait .05;
            enemy = getAiSpeciesArray("axis", "all");
            zombie = enemy[randomInt(enemy.size)];
            if (!zombie inMap()) break;
        }
        zombie waittill("death");
        point = zombie.origin + (0, 0, 40);
        temp = spawnSM(point, "tag_origin");
        power[0] = spawnSM(point, "zombie_zapper_tesla_coil");
        power[1] = spawnSM(point, power[0].model, (90, 0, 0));
        power[2] = spawnSM(point, power[0].model, (180, 0, 0));
        power[3] = spawnSM(point, power[0].model, (-90, 0, 0));
        for (m = 0; m < power.size; m++) {
            power[m] linkTo(temp);
            power[m] thread deleteOnGrab(temp);
            power[m] thread powerup_timeout();
        }
        playSoundatPosition("spawn_powerup", temp.origin);
        temp playLoopSound("spawn_powerup_loop");
        temp thread powerup_wobble();
        temp thread powerup_timeout();
        temp thread grabAllTrapped();
    }
}
deleteOnGrab(ent) {
    ent waittill_any("powerup_timedout", "powerup_grabbed");
    self delete();
}
grabAllTrapped() {
    self endon("powerup_timedout");
    self endon("powerup_grabbed");
    while (isDefined(self)) {
        p = getPlayers();
        for (a = 0; a < p.size; a++) {
            if (distance(p[a].origin, self.origin) < 64) {
                playFx(loadFx("misc/fx_zombie_powerup_grab"), self.origin);
                playFx(loadFx("misc/fx_zombie_powerup_wave"), self.origin);
                p[a] add_to_player_score(3000);
                level thread activateTraps(p[0]);
                wait .1;
                playSoundAtPosition("powerup_grabbed", self.origin);
                self stopLoopSound();
                self delete();
                self notify("powerup_grabbed");
            }
        }
        wait .05;
    }
}
superAmmoPowerup() {
    while (true) {
        zombie = [];
        wait(randomIntRange(200, 400));
        while (true) {
            wait .05;
            enemy = getAiSpeciesArray("axis", "all");
            zombie = enemy[randomInt(enemy.size)];
            if (!zombie inMap()) break;
        }
        zombie waittill("death");
        point = zombie.origin + (0, 0, 40);
        temp = spawnSM(point, "tag_origin");
        power = spawnMultipleModels(point, 2, 3, 2, 6, 4, 2, "zombie_ammocan");
        for (m = 0; m < power.size; m++) {
            playFxOnTag(level._effect["powerup_on"], power[m], "tag_origin");
            power[m] linkTo(temp);
            power[m] thread deleteOnGrab(temp);
            power[m] thread powerup_timeout();
        }
        playSoundatPosition("spawn_powerup", temp.origin);
        temp playLoopSound("spawn_powerup_loop");
        temp thread powerup_wobble();
        temp thread powerup_timeout();
        temp thread grabSuperAmmo();
    }
}
grabSuperAmmo() {
    self endon("powerup_timedout");
    self endon("powerup_grabbed");
    while (isDefined(self)) {
        p = getPlayers();
        for (m = 0; m < p.size; m++) {
            if (distance(p[m].origin, self.origin) < 64) {
                playFx(loadFx("misc/fx_zombie_powerup_grab"), self.origin);
                playFx(loadFx("misc/fx_zombie_powerup_wave"), self.origin);
                level thread doSuperAmmo();
                wait .1;
                playSoundAtPosition("powerup_grabbed", self.origin);
                self stopLoopSound();
                self delete();
                self notify("powerup_grabbed");
            }
        }
        wait .05;
    }
}
doSuperAmmo() {
    text = [];
    for (m = 0; m < getPlayers().size; m++) {
        getPlayers()[m] playSound("plr_" + getPlayers()[m] getEntityNumber() + "_vox_powerup_ammo_1");
        text[m] = getPlayers()[m] createText(getFont(), 1.5, "BOTTOMRIGHT", "BOTTOMRIGHT", 0, -20, 1, 1, "UNLIMITED AMMO");
    }
    setLobbyDvar("player_sustainAmmo", 1);
    setLobbyDvar("ammoCounterHide", 1);
    wait 30;
    setLobbyDvar("player_sustainAmmo", 0);
    setLobbyDvar("ammoCounterHide", 0);
    for (m = 0; m < text.size; m++) text[m] destroy();
}
staminUp() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        weap = self getCurrentWeapon();
        if (isSubStr(weap, "upgraded")) self setMoveSpeedScale(1.3);
        else self setMoveSpeedScale(1);
        wait .05;
    }
}
tradingMachine() {
    pap = spawnSM((-473.078, -444.996, 88.3861), "zombie_vending_packapunch_on", (0, -50, 0));
    rollers = spawn("script_origin", pap.origin);
    rollers playLoopSound("packa_rollers_loop");
    sounds = spawn("script_origin", pap.origin);
    lid = spawnSM((-492.646, -461.829, 76.7549), "zombie_treasure_box_lid", (0, -50, 90));
    spawnSM((-487.646, -398.829, 76.7549), "zombie_treasure_box_lid", (0, -140, 90));
    mod = spawnSM((-430.646, -466.829, 76.7549), "zombie_treasure_box_lid", (0, 40, 90));
    mod playLoopSound("packa_rollers_loop");
    spawnSM((-492.646, -461.829, 100.7549), "zombie_treasure_box_lid", (0, -50, 0));
    spawnSM((-474.646, -446.829, 100.775), "zombie_treasure_box_lid", (0, -50, 0));
    spawnSM((-443.646, -419.829, 100.775), "zombie_treasure_box_lid", (0, -50, 0));
    spawnSM((-425.646, -403.829, 100.775), "zombie_treasure_box_lid", (0, -50, -90));
    trig = spawnTrigger(pap.origin - (10, 10, 40), 60);
    trig setString("Press [{+activate}] To Trade Current Weapon for Cash");
    while (true) {
        trig waittill("trigger", user);
        if (user useButtonPressed() && !isDefined(user.revivetrigger) && !user.is_zombie) {
            cWeap = user getCurrentWeapon();
            if (!isDefined(level.zombie_include_weapons[cWeap])) continue;
            trig setString("");
            pap vibrate((0, -100, 0), .3, .4, 3);
            sounds playSound("packa_weap_upgrade");
            user takeWeapon(cWeap);
            primaries = user getWeaponsListPrimaries();
            if (isDefined(primaries) && primaries.size > 0) user switchToWeapon(primaries[0]);
            value = user valueWeapon(cWeap);
            tm_insertWeapon(cWeap, pap.origin + (0, 0, 34), pap.angles + (0, 90, 0));
            if (randomInt(100) <= 10) {
                sounds playSound("laugh_child");
                playFx(loadFx("misc/fx_zombie_couch_effect"), pap.origin);
            } else {
                for (m = 0; m < 6; m++) {
                    sounds playSound("broken_random_jingle");
                    wait 1;
                }
                lid rotateRoll(90, 1.5, 0, .5);
                sounds playSound("packa_door_1");
                for (e = 0; e < 1.5; e += .5) {
                    sounds playSound("cha_ching");
                    wait .5;
                }
                x2 = spawnSM(pap.origin, "zombie_x2_icon", (0, -50, 0));
                forward = anglesToForward(pap.angles + (0, 90, 0));
                interactPos = pap.origin + (forward * -35);
                x2 moveTo(interactPos, .5);
                wait .5;
                playFxOnTag(level._effect["powerup_on"], x2, "tag_origin");
                sounds playSound("steam_effect");
                wait 1;
                trig setString("Press [{+activate}] To Take Cash");
                pap thread tm_timeout(trig);
                while (true) {
                    trig waittill("trigger", taker);
                    if (taker useButtonPressed() && taker == user) {
                        taker playSound("cha_ching");
                        newValue = int(value) - int(value) % 10;
                        if (newValue < value) newValue += 10;
                        taker add_to_player_score(newValue);
                        taker thread tm_wowEffect(newValue);
                        pap notify("score_taken");
                        break;
                    } else if (taker == level) {
                        sounds playSound("packa_deny");
                        break;
                    }
                }
                x2 delete();
                trig setString("");
                lid rotateRoll(-90, 1.5, 0, .5);
                sounds playSound("packa_door_1");
                wait 2;
            }
            trig setString("Press [{+activate}] To Trade Current Weapon for Cash");
        }
    }
}
tm_timeout(trig) {
    self endon("score_taken");
    wait(level.packapunch_timeout);
    trig notify("trigger", level);
}
tm_wowEffect(score) {
    self endon("death");
    self endon("disconnect");
    value = self createText("big", 2, "CENTER", "CENTER", 0, -60, 1, .85, "+" + score);
    value.color = (1, 1, .5);
    while (value.fontScale < 4) {
        value.fontScale = min(4, value.fontScale + (2 / 3));
        wait .05;
    }
    while (value.fontScale > 2) {
        value.fontScale = max(2, value.fontScale - (2 / 5));
        wait .05;
    }
    value thread hudFadenDestroy(0, .75);
}
tm_insertWeapon(currentWeapon, origin, angles) {
    forward = anglesToForward(angles);
    interactPos = origin + (forward * -25);
    worldGun = spawnSM(interactPos, getWeaponModel(currentWeapon), self.angles);
    playFx(level._effect["packapunch_fx"], origin + (0, -1, -34), forward);
    worldGun rotateTo(angles + (0, 90, 0), .35);
    wait .5;
    worldGun moveTo(origin, .5);
    wait .35;
    worldGun delete();
}
valueWeapon(weap) {
    multiplier = 0;
    class = weaponClass(weap);
    if (class == "rifle" || class == "pistol") multiplier = 3;
    else if (class == "smg" || class == "spread") multiplier = 4;
    else multiplier = 10;
    baseValue = 500 + randomIntRange(100, 300);
    maxAmmunition = (self getWeaponAmmoClip(weap) + self getWeaponAmmoStock(weap));
    if ((isSubStr(weap, "30cal") || isSubStr(weap, "mg42")) && maxAmmunition > 300) baseValue += maxAmmunition / 2 * multiplier;
    else baseValue += maxAmmunition * multiplier;
    startAmmo = weaponStartAmmo(weap);
    baseValue += startAmmo;
    if (weaponIsSemiAuto(weap)) baseValue -= baseValue / randomIntRange(3, 4);
    baseValue += weaponFireTime(weap) / randomInt(8);
    baseValue += self getWeaponAmmoClip(weap);
    if (isSubStr(weap, "upgraded")) baseValue += randomIntRange(1500, 2000);
    if (isSubStr(weap, "tesla") || isSubStr(weap, "ray")) baseValue += 4000;
    return (baseValue);
}
ammoMachine() {
    lid = spawnSM((749, -916, 121), "zombie_treasure_box_lid", (0, 0, -90));
    flag = spawnSM((784.906, -915.296, 127.053), "zombie_sign_please_wait", (-90, 180, 0));
    trig = spawnTrig(lid.origin - (0, 0, 40), 20, 20, "HINT_NOICON", "Press &&1 To Use Amm-o-Matic Machine! [Cost: 10000]");
    while (true) {
        trig waittill("trigger", user);
        if (user useButtonPressed() && !user.is_zombie) {
            if (user.score < 10000) {
                user noMoneySound();
                wait .1;
                continue;
            }
            user minus_to_player_score(10000);
            lid rotateRoll(-90, 2, 1);
            flag rotatePitch(90, 2, 0, 1);
            wait 2;
            for (m = 0; m < 30; m++) {
                ammo = spawnSM(lid.origin - (0, 0, 10), "zombie_ammocan");
                ammo physicsLaunch((randomIntRange(-40, 40), 50, 10));
                ammo thread ammoThread();
                ammo playSound("pa_audio_link_1");
                wait .2;
            }
            lid rotateRoll(90, 2, 0, 1);
            flag rotatePitch(-90, 2, 1);
            wait 2;
        }
    }
}
ammoThread() {
    wait .1;
    while (true) {
        old = self getOrigin();
        wait .05;
        new = self getOrigin();
        if (old == new) break;
    }
    self thread scavDelete();
    trig = spawnTrig(self.origin, 20, 10, "HINT_NOICON", "");
    while (isDefined(self)) {
        trig waittill("trigger", i);
        i setWeaponAmmoStock(i getCurrentWeapon(), i getWeaponAmmoStock(i getCurrentWeapon()) + 30);
        playSoundAtPosition("ammo_pickup", self.origin);
        playFx(loadFx("misc/fx_zombie_powerup_wave"), self.origin);
        self delete();
    }
    trig delete();
}
spawnWaterGheyser(orig) {
    if (!isDefined(orig)) {
        vecd = anglesToUp(self.angles) * -1;
        orig = bulletTrace(self.origin, vecd * 1000000, false, self)["position"] + (0, 0, 1.5);
    }
    ring = spawnSM(orig, "zombie_teleporter_mainframe_ring3");
    trig = spawnTrig(orig, 50, 50, "HINT_NOICON", "");
    if (!isSurv()) {
        if (!isDefined(level.waterGheyserArray)) level.waterGheyserArray = [];
        level.waterGheyserArray[level.waterGheyserArray.size] = ring;
        level.waterGheyserArray[level.waterGheyserArray.size] = trig;
    }
    trig thread waterGheyserStandby(orig);
    while (true) {
        trig waittill("trigger", user);
        if (user.is_zombie || isDefined(user.revivetrigger)) continue;
        for (a = 0; a < 2; a++) {
            earthQuake(.7, 1, orig, 90);
            playFx(level._effect["rise_billow_water"], orig);
            wait .5;
        }
        playFx(level._effect["mortarExp_water"], orig);
        for (a = 0; a < getPlayers().size; a++) {
            player = getPlayers()[a];
            if (player isTouching(trig)) player thread gheyserLaunch();
        }
        wait(randomIntRange(5, 8));
    }
}
waterGheyserStandby(orig) {
    while (isDefined(self)) {
        playFx(level._effect["rise_billow_water"], orig);
        wait 1;
    }
}
gheyserLaunch() {
    for (a = 0; a < 5; a++) {
        self setVelocity(self getVelocity() + (0, 0, 1000));
        wait .2;
    }
}
deleteWaterGheyser() {
    for (a = 0; a < level.waterGheyserArray.size; a++) level.waterGheyserArray[a] remove();
}
survivalPacka() {
    box = spawnStruct();
    box = spawnSM((684, -841, 109), "zombie_treasure_box", (0, 90, 90));
    lid = spawnSM(box.origin + (17.8, 0, -12), "zombie_treasure_box_lid", (0, 90, 90));
    trig = spawnTrig(box.origin + (40, 0, -40), 30, 30, "HINT_NOICON", "Press &&1 To Steroid-ize Your Weapon! [Cost: 8000]");
    box thread nearPacka(lid, trig);
    box thread openPacka(lid, trig);
    while (true) {
        trig waittill("trigger", user);
        if (user useButtonPressed() && !user.is_zombie) {
            currentWeapon = user getCurrentWeapon();
            if (!isDefined(level.zombie_include_weapons[currentWeapon]) || !isDefined(level.zombie_include_weapons[currentWeapon + "_upgraded"])) {
                wait .1;
                continue;
            }
            if (user.score < 8000) {
                box playSound("deny");
                user noMoneySound();
                wait .1;
                continue;
            }
            box.inUse = true;
            user minus_to_player_score(8000);
            box playSound("bottle_dispense3d");
            user playSound("plr_" + user getEntityNumber() + "_vox_gen_laugh_" + randomInt(3));
            box playSound("mx_packa_sting");
            trig setInvisibleToAll();
            user thread nuckleCrack();
            user packaInsert(currentWeapon, box.origin, box.angles + (0, 90, 0), box);
            lid moveZ(-23, .6, 0, .2);
            wait .6;
            lid linkTo(box);
            box thread lightFxs();
            for (m = 0; m < 2; m++) {
                box rotateTo((-35, 90, 90), .4);
                wait .4;
                box rotateTo((35, 90, 90), .4);
                wait .4;
            }
            box rotateTo((0, 90, 90), .2);
            wait 1;
            lid unlink();
            lid moveZ(23, .6, 0, .2);
            wait 1;
            user packaGive(currentWeapon, box.origin, box.angles + (0, 90, 0), box);
            box.inUse = undefined;
            wait 1;
            trig setVisibleToAll();
        }
    }
}
packaInsert(currentWeapon, origin, angles, perkMachine) {
    forward = anglesToForward(angles);
    interactPos = origin + (forward * -25);
    worldGun = spawnSM(interactPos, getWeaponModel(currentWeapon), self.angles);
    worldGun rotateTo((0, 90, 0), .35);
    wait .5;
    worldGun moveTo(origin, .5);
    perkMachine playSound("packa_weap_upgrade");
    wait .35;
    worldGun delete();
}
packaGive(currentWeapon, origin, angles, perkMachine) {
    forward = anglesToForward(angles);
    interactPos = origin + (forward * -25);
    perkMachine playSound("packa_weap_ready");
    worldGun = spawnSM(origin, getWeaponModel(currentWeapon + "_upgraded"), (0, 90, 0));
    worldGun physicsLaunch((100, 0, 50));
    wait 2;
    playFx(loadFx("maps/zombie/fx_transporter_start"), worldGun.origin);
    worldGun delete();
    worldGun = spawnSM((652, -593, 100), getWeaponModel(currentWeapon + "_upgraded"), (0, -90, 90));
    worldGun endon("pap_timeout");
    worldGun playLoopSound("ticktock_loop");
    playFx(loadFx("maps/zombie/fx_transporter_start"), worldGun.origin);
    trig = spawnTrig(worldGun.origin - (0, 0, 40), 30, 30, "HINT_NOICON", "Press &&1 to Take Weapon!");
    trig setInvisibleToAll();
    trig setVisibleToPlayer(self);
    worldGun thread packaTimout(trig);
    while (true) {
        trig waittill("trigger", user);
        if (user useButtonPressed() && user == self) {
            worldGun notify("pap_taken");
            weap = currentWeapon + "_upgraded";
            primaries = self getWeaponsListPrimaries();
            if (isDefined(primaries) && primaries.size >= 2) self takeWeapon(self getCurrentWeapon());
            self giveWeapon(weap);
            self giveMaxAmmo(weap);
            self switchToWeapon(weap);
            self playSound("plr_" + self getEntityNumber() + "_vox_perk_packa_get_" + randomInt(5));
            break;
        }
    }
    worldGun delete();
    trig delete();
}
packaTimout(trig) {
    self endon("pap_taken");
    wait(level.packapunch_timeout);
    self stopLoopSound(.05);
    self playSound("packa_deny");
    wait .05;
    self delete();
    trig delete();
    self notify("pap_timeout");
}
lightFxs() {
    pos = self.origin + (10, 0, 0);
    for (m = 0; m < 14; m++) {
        lt = [];
        lt[0] = spawnSM(pos + (randomIntRange(-10, 10), randomIntRange(-40, 40), randomIntRange(-20, 20)), "tag_origin");
        playFxOnTag(loadFx("maps/zombie/fx_zombie_light_glow_green"), lt[0], "tag_origin");
        lt[1] = spawnSM(pos + (randomIntRange(-10, 10), randomIntRange(-40, 40), randomIntRange(-20, 20)), "tag_origin");
        playFxOnTag(loadFx("maps/zombie/fx_zombie_light_glow_green"), lt[1], "tag_origin");
        lt[2] = spawnSM(pos + (randomIntRange(-10, 10), randomIntRange(-40, 40), randomIntRange(-20, 20)), "tag_origin");
        playFxOnTag(loadFx("maps/zombie/fx_zombie_light_glow_red"), lt[2], "tag_origin");
        lt[3] = spawnSM(pos + (randomIntRange(-10, 10), randomIntRange(-40, 40), randomIntRange(-20, 20)), "tag_origin");
        playFxOnTag(loadFx("maps/zombie/fx_zombie_light_glow_red"), lt[3], "tag_origin");
        wait .2;
        array_delete(lt);
    }
}
openPacka(lid, trig) {
    door = getEntArray("zombie_door", "targetname");
    door[1].doors[0].origin = self.origin + (38, 0, 60);
    door[1].doors[0].angles = (90, 0, 90);
    door[1].doors[0] hide();
    door[1].doors[0] solid();
    while (true) {
        self waittill("open_packa");
        self playSound("shoot_off");
        self moveX(18, .6, 0, .2);
        lid moveX(18, .6, 0, .2);
        wait .6;
        lid moveZ(23, .6, 0, .2);
        wait 1;
        trig trigger_on_proc();
        self waittill("close_packa");
        trig trigger_off_proc();
        lid moveZ(-23, .6, 0, .2);
        wait .6;
        self playSound("shoot_off");
        self moveX(-18, .6, 0, .2);
        lid moveX(-18, .6, 0, .2);
        wait .6;
        lid.origin = self.origin + (17.8, 0, -12);
        wait .4;
    }
}
nearPacka() {
    while (true) {
        if (isDefined(self.inUse)) {
            wait .05;
            continue;
        }
        plr = getPlayers();
        bool = false;
        for (m = 0; m < plr.size; m++) {
            pos = plr[m].origin;
            if (pos[0] > 715 && pos[0] < 860 && pos[1] > -920 && pos[1] < -750) {
                bool = true;
                break;
            }
        }
        if (bool) {
            self notify("open_packa");
            wait .05;
            continue;
        }
        wait .05;
        self notify("close_packa");
    }
}
spawnAutoTurret(turretWeapon, turretOrigin, turretAngles) {
    turret = spawnStruct();
    turret.weapon = spawnSM(turretOrigin, getWeaponModel(turretWeapon), turretAngles);
    turret.trig = spawnTrig(turret.weapon.origin, 60, 60, "HINT_NOICON", "Press &&1 To Activate Turret! [Cost: 1500]");
    while (true) {
        turret.trig waittill("trigger", i);
        if (i useButtonPressed() && i.score >= 1500 && !i.is_zombie && !isDefined(i.revivetrigger)) {
            i minus_to_player_score(1500);
            turret.trig setHintString("");
            turret thread controlTurret(turretWeapon);
            wait 45;
            turret notify("overHeated");
            turret.isNotTargetting = undefined;
            turret.weapon notify("forced_endon");
            turret.weapon rotateTo((0, 40, 0), 1, 0, .5);
            turret.trig setHintString("Turret Cooling Down...");
            wait(randomIntRange(20, 40));
            turret.trig setHintString("Press &&1 To Activate Turret! [Cost: 1500]");
        }
    }
}
turretAngles() {
    self endon("forced_endon");
    while (true) {
        self rotateTo((0, -40, 0), 2.6, .5, .5);
        wait 2.6;
        self rotateTo((0, 120, 0), 2.6, .5, .5);
        wait 2.6;
    }
}
controlTurret(turretWeapon) {
    self endon("overHeated");
    while (true) {
        enemy = getClosest(self.weapon.origin, getAiSpeciesArray("axis", "all"));
        if (isDefined(enemy) && enemy damageConeTrace(self.weapon.origin, self.weapon) > .75 && !isDefined(enemy.targetted)) {
            enemy.targetted = true;
            self.isNotTargetting = undefined;
            self.weapon notify("forced_endon");
            self.weapon rotateTo(vectorToAngles(enemy getTagOrigin("j_spine4") - self.weapon.origin), .2);
            wait .2;
            self.weapon thread turret_projectile(enemy);
            wait(weaponFireTime(turretWeapon));
        } else if (getAiSpeciesArray("axis", "all").size == 0 || !enemy damageConeTrace(self.weapon.origin, self.weapon) > .75)
            if (!isDefined(self.isNotTargetting)) {
                self.weapon thread turretAngles();
                self.isNotTargetting = true;
            }
        wait .05;
    }
}
turret_projectile(zom) {
    orb = spawnSM(self getTagOrigin("tag_flash"), "tag_origin");
    playFxOnTag(loadFx("misc/fx_zombie_powerup_on"), orb, "tag_origin");
    self playSound("weap_rgun_fire_plr");
    while (true) {
        orb moveTo(zom getTagOrigin("j_spine4"), distance(orb.origin, zom getTagOrigin("j_spine4")) / 150);
        wait .05;
        if (distance(orb.origin, zom getTagOrigin("j_spine4")) <= 10) break;
    }
    playSoundAtPosition("weap_rgun_exp", orb.origin);
    playFx(loadFx("misc/fx_zombie_powerup_grab"), orb.origin);
    playFx(loadFx("misc/fx_zombie_powerup_wave"), orb.origin);
    killZombiesWithinDistance(orb.origin - (0, 0, 40), 100, "tesla");
    earthQuake(.2, 1, orb.origin, 100);
    orb delete();
}
knifeTrap() {
    teddy = spawnSM((839, -1208, 203), "zombie_teddybear");
    db1 = spawnSM((1000, -1329, 216), getWeaponModel("zombie_doublebarrel"), (0, 110, 0));
    db2 = spawnSM((857, -1329, 216), db1.model, (0, 70, 0));
    knives = spawnMultipleModels((996, -1186, 282), 10, 1, 1, -15, 0, 0, "viewmodel_knife_bowie", (90, 0, 0));
    for (m = 5; m < knives.size; m++) knives[m].angles = (90, 180, 0);
    trig = spawnTrig(teddy.origin - (0, 0, 40), 20, 20, "HINT_NOICON", "Press &&1 To Unleash Knife & Shotty Crime! [Cost: 2500]");
    level.additionTrigs["knifeTrap"] = trig;
    while (true) {
        trig waittill("trigger", user, check);
        if (!isDefined(check)) {
            if (!user useButtonPressed()) continue;
            if (user.is_zombie) continue;
            if (isDefined(user.revivetrigger)) continue;
            if (user.score < 2500) {
                user noMoneySound();
                continue;
            }
            user minus_to_player_score(2500);
        }
        trig setInvisibleToAll();
        for (m = 0; m < knives.size; m++) knives[m] thread doKnifeTrap();
        db1 thread doDBTrap();
        db2 doDBTrap();
        wait(randomIntRange(30, 45));
        trig setVisibleToAll();
    }
}
doDBTrap() {
    angs = self.angles;
    weapon = "zombie_doublebarrel";
    for (m = 0; m <= 20; m += .05) {
        enemy = getClosest(self getTagOrigin("tag_flash"), getAiSpeciesArray("axis", "all"));
        if (isDefined(enemy) && enemy damageConeTrace(self getTagOrigin("tag_flash"), self) > .75) {
            self rotateTo(vectorToAngles(enemy getTagOrigin("j_head") - self.origin), .2);
            wait .2;
            magicBullet(weapon, self getTagOrigin("tag_flash"), enemy getTagOrigin("j_head"));
            wait(weaponFireTime(weapon));
        } else if (getAiSpeciesArray("axis", "all").size == 0 || !enemy damageConeTrace(self getTagOrigin("tag_flash"), self.weapon) > .75) self rotateTo(angs, .2);
        wait .05;
    }
    self rotateTo(angs, .2);
}
doKnifeTrap() {
    for (m = 0; m < 20; m++) {
        orig = self.origin;
        self moveZ(-150, 1, .5);
        t = 0;
        for (e = 0; e <= 1; e += .05) {
            t++;
            if (e == .5) {
                self playSound("knife_stab_plr");
                self playSound("melee_knife_hit_other");
            }
            damageLoc = orig - (0, 0, t * 7.5);
            self thread killZombiesWithinDistance(damageLoc, 30, "headGib");
            self thread doPlayerDamage(damageLoc, 30);
            wait .05;
        }
        wait .05;
        self hide();
        wait .05;
        self.origin += (0, 0, 150);
        wait .05;
        self show();
    }
}
startEasterEgg() {
    targ = easterEggTrig();
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "EASTER EGG STARTED! -- ^2Created By: ^7" + level.creator, 310);
    playSoundAtPosition("sam_fly_laugh", targ.origin);
    level NODE1();
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 1 ^7- THE FLAGS ARE FREE! ^7-- ^2Created By: ^7" + level.creator, 361);
    link = spawnSM(level.eeFlags[1].origin + (0, 0, 10), "tag_origin");
    for (m = 0; m < level.eeFlags.size; m++) level.eeFlags[m] linkTo(link);
    getPlayers()[0] playSound("flytrap_spin");
    playFxOnTag(loadFx("misc/fx_zombie_powerup_on"), link, "tag_origin");
    link rotateYaw(3600, 15, 5);
    link moveZ(250, 15, 5);
    wait 15;
    playFxOnTag(loadFx("maps/zombie/fx_transporter_beam"), link, "tag_origin");
    link playSound("shoot_off");
    link moveTo((randomIntRange(-2000, 2000), randomIntRange(-2000, 2000), randomIntRange(1500, 2000)), 1);
    wait 1;
    for (m = 0; m < level.eeFlags.size; m++) level.eeFlags[m] delete();
    link delete();
    orig[0] = (-639.65, -345.875, 265.163);
    ang[0] = (90, 90, 0);
    orig[1] = (1442.46, -268.944, 87.231);
    ang[1] = (90, 90, 0);
    orig[2] = (-592.875, -1553.52, 116.557);
    ang[2] = (90, 90, 90);
    randy = randomInt(orig.size);
    lever = spawnSM(orig[randy], "zombie_power_lever_handle", ang[randy]);
    level.eggLever = lever;
    playFxOnTag(level._effect["powerup_on"], lever, "tag_origin");
    level waittill("leverCaptured");
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 2 ^7- LEVER CAPTURED! -- ^2Created By: ^7" + level.creator, 342);
    playFx(loadFx("maps/zombie/fx_transporter_beam"), lever.origin);
    lever.origin = (56, 130, 130);
    lever.angles = (0, 90, 0);
    playFx(level._effect["powerup_on"], (1066.9, -1364.13, 193.125));
    suck = [];
    for (a = 0; a <= 360; a += 30) {
        suck[suck.size] = spawnSM((970, -1889.1, -11) + (cos(a) * 7, sin(a) * 7, 0), "zombie_brain", (0, a, 0));
        wait .05;
    }
    for (m = 1; m < suck.size; m++) suck[m] linkTo(suck[0]);
    suck = suck[0];
    suck.angles = (-45, 0, 0);
    while (true) {
        for (m = 0; m < getPlayers().size; m++) {
            player = getPlayers()[m];
            if (distance(player.origin, lever.origin) < 50 && !isDefined(player.revivetrigger) && isDefined(player)) {
                while (true) {
                    player = getPlayers()[m];
                    pos = bulletTrace(player getEye(), player getEye() + vectorScale(anglesToforward(player getPlayerAngles()), 60), false, lever)["position"];
                    lever moveTo(pos, .1);
                    if (distance(lever.origin, (1066.9, -1364.13, 193.125)) < 50 || isDefined(player.revivetrigger) || !isDefined(player)) break;
                    wait .05;
                }
            }
        }
        if (distance(lever.origin, (1066.9, -1364.13, 193.125)) < 50) break;
        lever.origin = (56, 130, 130);
        wait .05;
    }
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 2 ^7- LEVER PLACED! -- ^2Created By: ^7" + level.creator, 323);
    lever moveTo((1066.9, -1364.13, 193.125), 1);
    lever rotateTo((0, 0, 90), 1);
    wait 5;
    juggTrig = spawnTrig((1069, -1403, 135), 10, 10, "HINT_NOICON", "Press &&1 To Reveal The Pyramid of Doctors Redemption!");
    while (true) {
        juggTrig waittill("trigger", user);
        if (user useButtonPressed() && !user.is_zombie) {
            lever rotateTo((0, 0, 0), .5, .2);
            lever playSound("switch_flip");
            lever playSound("lever_pull_warmup");
            break;
        }
    }
    juggTrig setHintString("");
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 2 ^7- PYRAMID REVEALED! -- ^2Created By: ^7" + level.creator, 356);
    playSoundAtPosition("ann_vox_magicbox", lever.origin);
    bottom = spawnMultipleModels((982.007, -1838.97, -36.1155), 5, 5, 1, 25, -25, 0, "static_peleliu_crate01_short");
    middle = spawnMultipleModels(bottom[6].origin + (0, 0, 25), 3, 3, 1, 25, -25, 0, "static_peleliu_crate01_short");
    top = spawnSM((middle[4].origin + (0, 0, 25)), "static_peleliu_crate01_short");
    for (m = 0; m < bottom.size; m++) bottom[m] moveZ(100, 5, 0, 2);
    for (m = 0; m < middle.size; m++) middle[m] moveZ(100, 5, 0, 2);
    top moveZ(100, 5, 0, 2);
    suck moveTo((990, -1889.1, 108), 5, 0, 2);
    wait 5;
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 3 ^7- HACK THE INTEL! -- ^2Created By: ^7" + level.creator, 335);
    desk = spawnSM((644, 49, 66), "static_berlin_metal_desk", (0, 180, 0));
    radio = spawnSM((646, 44, 100), "static_berlin_ger_radio", (0, 90, 0));
    radio2 = spawnSM(desk.origin + (-20, 0, 34), "static_berlin_ger_radio", (0, 65, 0));
    radio2 playLoopSound("radio_static");
    radio3 = spawnSM(radio2.origin + (0, 0, 9), "static_berlin_ger_radio", (0, 55, 0));
    lamp = spawnSM((644, 28, 173), "lights_indlight_on", (0, 90, 0));
    lampFx = spawnSM(lamp.origin + (0, 30, -7), "tag_origin", (90, 0, 0));
    playFxOnTag(loadFx("maps/mp_maps/fx_mp_light_lamp"), lampFx, "tag_origin");
    nameTag = spawnSM(desk.origin + (0, 10, 34), "zombie_nameplate_maxis", (0, 180, 0));
    betty = spawnSM((674, 49, 106), getWeaponModel("mine_bouncing_betty"));
    ray = spawnSM((672, 63, 102), getWeaponModel("ray_gun"), (0, 45, 90));
    door = getEntArray("zombie_door", "targetname");
    door[4].doors[0].origin = (653, 66, 100);
    door[4].doors[0] hide();
    door[4].doors[1].origin = door[4].doors[0].origin - (0, 20, 0);
    door[4].doors[1] hide();
    trig = spawnTrig((644, 88, 66), 10, 10, "HINT_NOICON", "Press & Hold &&1 To Hack Intel!");
    completed = false;
    while (true) {
        for (a = 0; a < getPlayers().size; a++) trig setInvisibleToPlayer(getPlayers()[a]);
        trig waittill("trigger", user);
        if (user.is_zombie || isDefined(user.revivetrigger)) continue;
        if (isSubStr(user getCurrentWeapon(), "mine")) {
            trig setVisibleToPlayer(user);
            if (user useButtonPressed()) {
                radio playLoopSound("homepad_power_loop");
                trig setVisibleToPlayer(user);
                time = 0;
                bar = user createPrimaryProgressBar();
                bar updateBar(0, 1 / 30);
                text = user createPrimaryProgressBarText();
                while (user useButtonPressed() && user isTouching(trig) && isSubStr(user getCurrentWeapon(), "mine")) {
                    time += .05;
                    text setText("Hacking " + ceil((time / 30) * 100) + "/100");
                    if (!user useButtonPressed() || !user isTouching(trig) || !isSubStr(user getCurrentWeapon(), "mine")) break;
                    if (time >= 30) {
                        bar destroyElem();
                        text destroy();
                        completed = true;
                        break;
                    }
                    wait .05;
                }
                radio stopLoopSound();
                if (isDefined(bar)) {
                    bar destroyElem();
                    text destroy();
                }
                if (completed) break;
            }
        }
        wait .05;
        trig setInvisibleToPlayer(user);
    }
    trig delete();
    radio playSound("radio_two");
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 3 ^7- FINISH THE JOB! -- ^2Created By: ^7" + level.creator, 328);
    sphere = spawnSM((1265, 696, 244), "test_sphere_silver");
    link = spawnSM(sphere.origin, "tag_origin");
    pt = [];
    for (a = 0; a < 8; a++) {
        pt[a] = spawnSM(sphere.origin + (cos(a * 45) * 50, sin(a * 45) * 50, 0), "tag_origin");
        pt[a] linkTo(link);
    }
    ball = [];
    for (m = 0; m <= 360; m += 30) {
        ball[ball.size] = spawnSM(sphere.origin, "zombie_brain", (0, m, 0));
        ball[ball.size] = spawnSM(ball[0].origin - (0, 0, 3), "zombie_brain", (180, m, 0));
        wait .05;
    }
    for (m = 1; m < ball.size; m++) ball[m] linkTo(ball[0]);
    list = strTok("projectile_usa_m9a1_riflegrenade;zombie_perk_bottle_sleight;zombie_perk_bottle_revive;zombie_perk_bottle_doubletap;zombie_perk_bottle_jugg;zombie_teleporter_control_panel;weapon_zombie_monkey_bomb;" + getWeaponModel("mine_bouncing_betty") + "", ";");
    list = array_randomize(list);
    ptPick = array_randomize(pt);
    link thread rotateEntYaw(360, 4);
    lever2 = spawnSM((1385, 359, 113), "zombie_zapper_wall_control", (0, 90, 0));
    handle = spawnSM((1374.5, 354, 109), "zombie_zapper_handle", (180, -90, 0));
    optNum = 0;
    while (true) {
        wait .05;
        zom = getAiSpeciesArray("axis", "all");
        if (!isDefined(zom) || !isDefined(zom.size) || (isDefined(zom.size) && zom.size == 0)) continue;
        zomb = zom[randomInt(zom.size)];
        if (!isDefined(zomb) || !zomb inMap() || !isAlive(zomb) || zomb.health <= 1) continue;
        optNum++;
        zomb waittill("death");
        bool = zomb ee_dropPiece(sphere, ptPick[optNum], list[optNum], optNum + 1);
        if (!bool) optNum--;
        if (optNum == 8) break;
        wait(randomIntRange(30, 45));
    }
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 4 ^7- Shrink The Sphere! -- ^2Created By: ^7" + level.creator, 334);
    trig = spawnTrig(handle.origin - (0, 0, 40), 20, 20, "HINT_NOICON", "Press &&1 To Shrink Sphere!");
    while (true) {
        trig waittill("trigger", user);
        if (user useButtonPressed() && !user.is_zombie) {
            handle rotatePitch(-180, 1);
            wait 1;
            wait .05;
            handle rotatePitch(180, 1);
            break;
        }
    }
    trig delete();
    for (m = 0; m < pt.size; m++) {
        pt[m] unlink();
        pt[m] moveTo(sphere.origin, 5, 2);
    }
    for (m = 0; m < 5; m++) {
        earthquake(m * .3, 1, sphere.origin, 1000);
        sphere playSound("pa_audio_link_" + (5 - m));
        wait 1;
    }
    for (m = 0; m < 20; m++) {
        earthquake(3, .2, sphere.origin, 1000);
        sphere playSound("grenade_explode");
        sphere playSound("gen_start");
        sphere playSound("weap_rgun_flux_r");
        playFx(loadFx("explosions/default_explosion"), sphere.origin);
        playFx(loadFx("weapon/bouncing_betty/fx_explosion_betty_generic"), sphere.origin);
        playFx(loadFx("explosions/default_explosion"), sphere.origin);
        killZombiesWithinDistance(sphere.origin, 1000, "headGib");
        wait .2;
    }
    for (m = 0; m < pt.size; m++) pt[m] delete();
    sphere delete();
    ball[0] playLoopSound("meteor_loop");
    thread playLoopedFxOnTags(level._effect["monkey_glow"], ball[0], "tag_origin", 13);
    wait 2;
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 5 ^7- I'm Repairing The Perk Machines! -- ^2Created By: ^7" + level.creator, 415);
    ent = getEnt("trig_ee_exp_monkey", "targetname");
    ent.origin = ball[0].origin;
    upgraded_hit = false;
    while (!upgraded_hit) {
        ent waittill("damage", amount, inflictor, direction, point, mod);
        if (isSubStr(inflictor getCurrentWeapon(), "upgrade")) upgraded_hit = true;
    }
    desk delete();
    radio delete();
    radio2 delete();
    radio3 delete();
    lamp delete();
    lampFx delete();
    nameTag delete();
    betty delete();
    ray delete();
    ball[1] playSound("full_ammo");
    o[0] = (792, 1148, 235);
    o[1] = (908, 615, 265);
    o[2] = (570, 371, 265);
    o[3] = (211, 726, 338);
    o[4] = (-368, -760, 108);
    for (m = 0; m < o.size; m++) {
        time = (distance(ball[m].origin, o[m]) / 80);
        ball[0] moveTo(o[m], time);
        if (m == (o.size - 1)) ball[0] rotateTo((0, 0, 0), time);
        else ball[0] rotateTo((randomIntRange(-360, 360), randomIntRange(-360, 360), randomIntRange(-360, 360)), time);
        wait(time);
        ball[1] playSound("full_ammo");
    }
    for (m = 0; m < 10; m++) {
        ball[0] moveY(20, .2);
        wait .2;
        ball[0] moveY(-20, .2);
        ball[0] playSound("power_down_2d");
        wait .2;
    }
    perkMachines = getEntArray("zombie_vending", "targetname");
    for (m = 0; m < perkMachines.size; m++)
        if (perkMachines[m].script_noteworthy == "specialty_fastreload") perkMachines[m] thread doPerkRevive("sleight");
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 5 ^7- Speed Cola Repaired! -- ^2Created By: ^7" + level.creator, 348);
    damageTriggerMelee(ball[0].origin);
    damageTriggerMelee();
    o = undefined;
    o[0] = (-106, -679, 177);
    o[1] = (-8, -878, 297);
    o[2] = (-328, -939, 248);
    o[3] = (-366, -1043, 239);
    for (m = 0; m < o.size; m++) {
        time = (distance(ball[m].origin, o[m]) / 80);
        ball[0] moveTo(o[m], time);
        if (m == (o.size - 1)) ball[0] rotateTo((0, 0, 0), time);
        else ball[0] rotateTo((randomIntRange(-360, 360), randomIntRange(-360, 360), randomIntRange(-360, 360)), time);
        wait(time);
        ball[1] playSound("full_ammo");
    }
    for (m = 0; m < 10; m++) {
        ball[0] moveY(20, .2);
        wait .2;
        ball[0] moveY(-20, .2);
        ball[0] playSound("power_down_2d");
        wait .2;
    }
    for (m = 0; m < perkMachines.size; m++)
        if (perkMachines[m].script_noteworthy == "specialty_rof") perkMachines[m] thread doPerkRevive("doubletap");
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 5 ^7- Double Tap Repaired! -- ^2Created By: ^7" + level.creator, 352);
    damageTriggerMelee(ball[0].origin);
    damageTriggerMelee();
    o = undefined;
    o[0] = (-228, -948, 250);
    o[1] = (-353, -1967, 262);
    o[2] = (-66, -1685, 583);
    o[3] = (-202, -2119, 156);
    o[4] = (-350, -2330, 218);
    o[5] = (-475, -2100, 184);
    for (m = 0; m < o.size; m++) {
        time = (distance(ball[m].origin, o[m]) / 80);
        ball[0] moveTo(o[m], time);
        if (m == (o.size - 1)) ball[0] rotateTo((0, 0, 0), time);
        else ball[0] rotateTo((randomIntRange(-360, 360), randomIntRange(-360, 360), randomIntRange(-360, 360)), time);
        wait(time);
        ball[1] playSound("full_ammo");
    }
    for (m = 0; m < 10; m++) {
        ball[0] moveY(-20, .2);
        wait .2;
        ball[0] moveY(20, .2);
        ball[0] playSound("power_down_2d");
        wait .2;
    }
    for (m = 0; m < perkMachines.size; m++)
        if (perkMachines[m].script_noteworthy == "specialty_quickrevive") perkMachines[m] thread doPerkRevive("revive");
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 5 ^7- Quick Revive Repaired! -- ^2Created By: ^7" + level.creator, 357);
    damageTriggerMelee(ball[0].origin);
    damageTriggerMelee();
    o = undefined;
    o[0] = (-228, -2163, 341);
    o[1] = (-101, -2253, 50);
    o[2] = (-37, -2289, 134);
    o[3] = (8, -2288, 88.125);
    o[4] = (713, -2182, 978);
    o[5] = (1720, -1610, 1567);
    for (m = 0; m < o.size; m++) {
        time = (distance(ball[m].origin, o[m]) / 80);
        ball[0] moveTo(o[m], time);
        if (m == (o.size - 1)) ball[0] rotateTo((0, 0, 0), time);
        else ball[0] rotateTo((randomIntRange(-360, 360), randomIntRange(-360, 360), randomIntRange(-360, 360)), time);
        wait(time);
        ball[1] playSound("full_ammo");
    }
    wait 2;
    playFx(loadFx("explosions/mortarExp_water"), ball[0].origin);
    for (m = 0; m < getPlayers().size; m++) earthquake(.3, 3, getPlayers()[m].origin, 50);
    link = spawnSM((1210, -1621, 1567), "tag_origin");
    ball[0] linkTo(link);
    link rotatePitch(-180, 3);
    wait 3;
    link delete();
    ball[0] moveTo((674, -1420, 227), 3);
    wait 3;
    for (m = 0; m < 10; m++) {
        ball[0] moveX(20, .2);
        wait .2;
        ball[0] moveX(-20, .2);
        ball[0] playSound("power_down_2d");
        wait .2;
    }
    for (m = 0; m < perkMachines.size; m++)
        if (perkMachines[m].script_noteworthy == "specialty_armorvest") perkMachines[m] thread doPerkRevive("jugg");
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 5 ^7- Jugger-Nog Repaired! -- ^2Created By: ^7" + level.creator, 349);
    damageTriggerMelee(ball[0].origin);
    damageTriggerMelee();
    o = undefined;
    o[0] = (926, -1443, 133);
    o[1] = (1323, -1443, 486);
    o[2] = (649, -1770, 317);
    o[3] = (983, -1889.1, 104);
    for (m = 0; m < o.size; m++) {
        time = (distance(ball[m].origin, o[m]) / 80);
        ball[0] moveTo(o[m], time);
        if (m == (o.size - 1)) ball[0] rotateTo((-45, 0, 0), time);
        else ball[0] rotateTo((randomIntRange(-360, 360), randomIntRange(-360, 360), randomIntRange(-360, 360)), time);
        wait(time);
        ball[1] playSound("full_ammo");
    }
    ball[0] playSound("grenade_explode");
    ball[0] notify("loopedFx_over");
    playFxOnTag(loadFx("maps/zombie/fx_zombie_wire_spark"), ball[0], "tag_origin");
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 5 ^7- Vril Sphere Secured! -- ^2Created By: ^7" + level.creator, 341);
    for (m = 0; m < ball.size; m++) {
        ball[m] delete();
        wait .05;
    }
    pos = strTok("874 -1117 162 983 -1252 160 1283 -1497 133 749 -1392 133", " ");
    containers = [];
    for (m = 0; m < pos.size; m += 3) {
        size = containers.size;
        containers[size] = spawnStruct();
        containers[size] = spawnSM((int(pos[m]), int(pos[m + 1]), int(pos[m + 2])) - (0, 0, 35), "zombie_beaker_brain");
        containers[size].fx = spawnSM(containers[size].origin, "tag_origin", (-90, 0, 0));
        containers[size].fx linkTo(containers[size]);
        containers[size] moveZ(4, 1, 0, .5);
        containers[size].souls = 0;
    }
    level thread soulsAmmo();
    while (true) {
        wait .05;
        for (e = 0; e < containers.size; e++)
            if (containers[e].souls == 25) {
                containers[e].souls++;
                playFxOnTag(loadFx("maps/mp_maps/fx_mp_light_lamp"), containers[e].fx, "tag_origin");
            }
        if (containers[0].souls == 26 && containers[1].souls == 26 && containers[2].souls == 26 && containers[3].souls == 26) break;
        zom = getAiSpeciesArray("axis", "all");
        for (m = 0; m < zom.size; m++) {
            if (!isDefined(zom[m].soulCapping)) zom[m] thread processSouls(containers);
        }
    }
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 6 ^7- Cylindrical Containers Filled! -- ^2Created By: ^7" + level.creator, 386);
    level notify("soulsAmmo_over");
    lever thread leverAlert();
    lever rotateTo((0, 0, 90), 1);
    wait 1;
    juggTrig setHintString("Press &&1 To Reveal The Master!");
    while (true) {
        juggTrig waittill("trigger", user);
        if (user useButtonPressed() && !user.is_zombie) {
            lever rotateTo((0, 0, 0), .5, .2);
            lever playSound("switch_flip");
            lever playSound("lever_pull_warmup");
            break;
        }
    }
    juggTrig delete();
    for (m = 0; m < containers.size; m++) containers[m] moveZ(-40, 2, 1);
    for (m = 0; m < 4; m++) containers[m].fx delete();
    lever notify("buzz_over");
    lever playSound("laugh_child");
    top moveZ(-50, 1, .2);
    top playSound("ray_reload_open");
    wait .5;
    sam = spawnSM(bottom[12].origin, "defaultactor", (0, 180, 0));
    sam moveZ(50, 5, 0, 2);
    sam rotateYaw(1080, 5, 0, 2);
    wait 5;
    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 6 ^7- Doctors Grand Scheme ^1COMPLETED! ^7-- ^2Created By: ^7" + level.creator, 439);
    sam thread slowlyMoveSam();
    for (m = 0; m < getPlayers().size; m++) {
        getPlayers()[m] giveWeapon("zombie_ppsh_upgraded");
        getPlayers()[m] thread giveAllPerks();
        getPlayers()[m] thread deathMachine();
        getPlayers()[m] setClientDvar("jump_height", 1000);
        getPlayers()[m].menuMoves = 0;
    }
    self full_ammo_powerup(getPlayers()[0]);
    level thread after_ee_eyeFx();
    level thread ee_walther();
    level thread ee_menuMoves();
    level thread initPhysicalMenu();
    level.easterEggComplete = true;
}
ee_menuMoves() {
    while (true) {
        level waittill("between_round_over");
        for (m = 0; m < getPlayers().size; m++) getPlayers()[m].menuMoves = 0;
    }
}
deathMachine() {
    self endon("death");
    self endon("disconnect");
    machine = "zombie_colt";
    self disableOffHandWeapons();
    self disableWeaponCycling();
    self allowSprint(false);
    self allowADS(false);
    curWeap = self getCurrentWeapon();
    hasMg = self hasWeapon(machine);
    self giveWeapon(machine);
    hairs = self createText(getFont(), 2, "CENTER", "CENTER", 0, 0, 1, 1, "<<(=-=)>>");
    hairs thread alwaysColorful();
    self setPerk("specialty_bulletaccuracy");
    self setClientDvars("perk_weapSpreadMultiplier", .01, "cg_drawCrosshair", 0, "ammoCounterHide", 1);
    for (m = 0; m <= 90; m += .2) {
        self switchToWeapon(machine);
        self setClientDvar("cg_drawCrosshair", 0);
        self setWeaponAmmoClip(machine, 1000);
        if (self attackButtonPressed()) magicBullet("zombie_doublebarrel_upgraded", self getTagOrigin("tag_inhand"), self lookPos(), self);
        wait .2;
    }
    hairs destroy();
    if (!hasMg) self takeWeapon(machine);
    self switchToWeapon(curWeap);
    self enableOffHandWeapons();
    self enableWeaponCycling();
    self allowSprint(true);
    self allowADS(true);
    self setClientDvars("perk_weapSpreadMultiplier", .50, "cg_drawCrosshair", 1, "ammoCounterHide", 0);
    self thread doWunderWalther();
}
giveAllPerks() {
    tok = strTok("specialty_rof|zombie_perk_bottle_doubletap|specialty_doubletap_zombies;specialty_armorvest|zombie_perk_bottle_jugg|specialty_juggernaut_zombies;specialty_quickrevive|zombie_perk_bottle_revive|specialty_quickrevive_zombies;specialty_fastreload|zombie_perk_bottle_sleight|specialty_fastreload_zombies", ";");
    for (m = 0; m < tok.size; m++) {
        perk = strTok(tok[m], "|")[0];
        if (self hasPerk(perk)) continue;
        shader = strTok(tok[m], "|")[2];
        self setPerk(perk);
        self thread perkHud(shader, perk);
        if (perk == "specialty_armorvest") {
            self.maxhealth = level.zombie_vars["zombie_perk_juggernaut_health"];
            self.health = level.zombie_vars["zombie_perk_juggernaut_health"];
        }
    }
}
ee_walther() {
    walther = spawnSM((-408, -791, 68.5), getWeaponModel("walther"), (0, 45, 90));
    trig = spawnTrig(walther.origin, 10, 10, "HINT_NOICON", "");
    while (true) {
        trig waittill("trigger", user);
        if (user useButtonPressed() && !user.is_zombie) {
            user giveWeapon("walther");
            user switchToWeapon("walther");
            user giveMaxAmmo("walther");
        }
    }
}
slowlyMoveSam() {
    while (isDefined(self)) {
        self moveZ(15, 1, .5, .5);
        wait 1;
        self moveZ(-15, 1, .5, .5);
        wait 1;
    }
}
leverAlert() {
    self endon("buzz_over");
    while (true) {
        self playSound("pa_buzz");
        wait .4;
    }
}
soulsAmmo() {
    level endon("soulsAmmo_over");
    while (true) {
        plr = getPlayers();
        for (m = 0; m < plr.size; m++) {
            plyr = plr[m];
            pos = plyr.origin;
            if (pos[0] > 665 && pos[0] < 1470 && pos[1] > -1510 && pos[1] < -1066) plyr setWeaponAmmoClip(plyr getCurrentWeapon(), 1000);
        }
        wait .05;
    }
}
processSouls(containers) {
    self.soulCapping = true;
    self waittill("death");
    while (true) {
        pos = self.origin;
        if (pos[0] > 665 && pos[0] < 1470 && pos[1] > -1510 && pos[1] < -1066) {
            container = getClosest(self.origin, containers);
            while (true) {
                if (!isDefined(container.isMoving)) break;
                wait .05;
            }
            if (container.souls >= 25) break;
            self playSound("powerup_grabbed");
            playFx(level._effect["powerup_grabbed"], self.origin);
            playFx(level._effect["powerup_grabbed"], container.origin);
            container.souls++;
            container.isMoving = true;
            container moveZ(1.24, .1);
            wait .1;
            wait .05;
            container.isMoving = undefined;
            break;
        }
        wait .05;
    }
}
doPerkRevive(perk) {
    self trigger_on_proc();
    mach = getEntArray("vending_" + perk, "targetname");
    mach[0] playSound("perks_power_on");
    mach[0] vibrate((0, -100, 0), .3, .4, 3);
    playFx(loadFx("maps/zombie/fx_transporter_start"), mach[0].origin);
}
playLoopedFxOnTags(fx, ent, tag, time) {
    ent endon("loopedFx_over");
    while (isDefined(ent)) {
        playFxOnTag(fx, ent, tag);
        wait(time);
    }
}
ee_dropPiece(sphere, pt, model, num) {
    pickedUp = false;
    part = spawnSM(self.origin + (0, 0, 40), model);
    part endon("powerup_timedout");
    part thread powerup_wobble();
    part thread powerup_timeout();
    playSoundatPosition("spawn_powerup", part.origin);
    part playLoopSound("spawn_powerup_loop");
    while (isDefined(part)) {
        plr = getPlayers();
        for (m = 0; m < plr.size; m++) {
            if (distance(plr[m].origin, part.origin) < 64) {
                pickedUp = true;
                playFx(level._effect["powerup_grabbed"], part.origin);
                playFx(level._effect["powerup_grabbed_wave"], part.origin);
                wait .1;
                playSoundAtPosition("powerup_grabbed", part.origin);
                part stopLoopSound();
                part notify("powerup_grabbed");
                part moveTo(sphere.origin, 4, 2);
                wait 4;
                pt setModel(model);
                playFxOnTag(level._effect["powerup_on"], pt, "tag_origin");
                for (e = 0; e < getPlayers().size; e++) getPlayers()[e] playLocalSound("pa_audio_link_" + num);
                part delete();
                break;
            }
        }
        wait .05;
    }
    return pickedUp;
}
NODE1() {
    flag = [];
    flag[0] = spawnSM((-1266, -1488, 272), "zombie_sign_please_wait", (90, 0, 90));
    flag[1] = spawnSM((1352, 971, 119), flag[0].model, (90, 0, 0));
    flag[2] = spawnSM((599, -2863, 108), flag[0].model, (-180, 270, 0));
    level.eeFlags = flag;
    for (m = 0; m < flag.size; m++) flag[m] playLoopSound("meteor_loop");
    sound = strTok("sam_fly_first;sam_fly_second;sam_fly_last", ";");
    for (m = 0; m < flag.size; m++) {
        completed = false;
        while (true) {
            for (e = 0; e < getPlayers().size; e++) {
                player = getPlayers()[e];
                if (player isFacing(flag[m].origin, .99) && distance(player.origin, flag[m].origin) < 100 && player useButtonPressed()) {
                    array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^2NODE 1 ^7- FLAG " + (m + 1) + " FOUND! ^7-- ^2Created By: ^7" + level.creator, 326);
                    completed = true;
                    flag[m] stopLoopSound();
                    flag[m] playSound("meteor_affirm");
                    flag[m] rotatePitch(3600, 5.5, 4);
                    wait 5.5;
                    playFxOnTag(loadFx("maps/zombie/fx_zombie_wire_spark"), flag[m], "tag_origin");
                    playFxOnTag(loadFx("env/electrical/fx_elec_short_oneshot"), flag[m], "tag_origin");
                    flag[m] playSound(sound[m]);
                    flag[m] playSound("shoot_off");
                    flag[m] rotateTo((0, 270, 0), 5, 1, 1);
                    flag[m] moveTo((55.5637, 400 - (m * 30), 129.855), 5, 1, 1);
                    wait 5;
                }
            }
            wait .05;
            if (completed) break;
        }
    }
}
easterEggTrig() {
    trig = getEntArray("trig_ee", "targetname");
    trig[0] useTriggerRequireLookAt();
    trig[0] setCursorHint("HINT_NOICON");
    trig[0] waittill("trigger");
    return getEnt(trig[0].target, "targetname");
}
watch_killstreak() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        self waittill("zom_kill");
        if (!isDefined(level.moabInMap)) self.currentKillstreak++;
    }
}
watch_killstreakDowned() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        if (isDefined(self.revivetrigger) || self.sessionstate != "playing") self.currentKillstreak = 0;
        if (self.currentKillstreak > 250) self.currentKillstreak = 250;
        wait .05;
    }
}
watch_moab250() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        wait .05;
        if (self.currentKillstreak == 250) {
            for (a = 0; a < getPlayers().size; a++) {
                getPlayers()[a] thread notifyMsg("hud_status_dead", "^2" + self getName() + " ^7HAS A 250 KILLSTREAK!", "MOTHER OF ALL BOMBS EARNED!", "^6GO TO MAINFRAME TO ACTIVATE!");
                getPlayers()[a] playLocalSound("arcademode_kill_streak_won");
            }
            self.currentKillstreak = 0;
            level.moabInMap = true;
            nuke = spawnSM(getEnt("trigger_teleport_core", "targetname") getOrigin() + (0, 0, 40), "zombie_bomb");
            playFxOnTag(level._effect["powerup_on"], nuke, "tag_origin");
            nuke thread bounceAround();
            playSoundatPosition("spawn_powerup", nuke getOrigin());
            nuke playLoopSound("spawn_powerup_loop");
            while (isDefined(nuke)) {
                wait .05;
                for (a = 0; a < getPlayers().size; a++) {
                    if (distance(getPlayers()[a] getOrigin(), nuke getOrigin()) < 64) {
                        playFx(loadFx("misc/fx_zombie_powerup_grab"), nuke getOrigin());
                        playFx(loadFx("misc/fx_zombie_powerup_wave"), nuke getOrigin());
                        array_thread(getPlayers(), ::add_to_player_score, 1000);
                        wait .1;
                        playSoundAtPosition("powerup_grabbed", nuke getOrigin());
                        nuke stopLoopSound();
                        nuke delete();
                        level nukeInit();
                        break;
                    }
                }
            }
        }
    }
}
damageTriggerMelee(origin) {
    ent = getEnt("trig_ee_exp_monkey", "targetname");
    if (isDefined(origin)) {
        ent.origin = origin;
        return;
    }
    while (true) {
        ent waittill("damage", amount, inflictor, direction, point, mod);
        if (mod == "MOD_MELEE") {
            inflictor add_to_player_score(500);
            inflictor playSound("cha_ching");
            break;
        }
    }
}
after_ee_eyeFx() {
    while (true) {
        zom = getAiArray("axis");
        for (a = 0; a < zom.size; a++)
            if (!isDefined(zom[a].hasEyefx)) zom[a] thread do_eyeFx();
        wait .05;
    }
}
do_eyeFx() {
    self endon("death");
    self.hasEyefx = true;
    while (isDefined(self)) {
        playFxOnTag(loadFx("maps/zombie/fx_zombie_tesla_shock_eyes"), self, "J_Eyeball_LE");
        wait 3;
    }
}
survivalLights() {
    origin = [];
    origin[0] = (191.306, -2392.63, 88);
    origin[1] = (58.7277, -2392.63, 88);
    origin[2] = (191.676, -2347.37, 88);
    origin[3] = (58.7277, -2347.37, 88);
    origin[4] = (197.371, -2871.1, 87);
    origin[5] = (392.125, -2871.1, 87);
    origin[6] = (379.676, -2016.13, 89);
    origin[7] = (142.701, -2016.13, 89);
    origin[8] = (400.072, -1931.32, 64);
    origin[9] = (159.323, -1931.32, 90);
    origin[10] = (456.875, -1071.4, 66);
    origin[11] = (456.875, -1209.9, 67);
    origin[12] = (108.916, -1039.37, 191);
    origin[13] = (108.916, -1170.1, 192);
    origin[14] = (-876.048, -344.874, 67);
    origin[15] = (-699.122, -344.874, 67);
    origin[16] = (-620.874, -101.744, 69);
    origin[17] = (-620.874, -284.661, 69);
    origin[18] = (832.599, 373.126, 64);
    origin[19] = (679.603, 373.126, 64);
    origin[20] = (-309.911, -23.1251, 69);
    origin[21] = (-309.911, -164.308, 69);
    origin[22] = (-148.874, 90.165, 93);
    origin[23] = (36.8359, 90.165, 93);
    origin[24] = (-110.799, -280.874, -2);
    origin[25] = (-227.639, -280.874, -2);
    origin[26] = (-569.126, -811.675, 67);
    origin[27] = (-569.126, -910.765, 67);
    origin[28] = (-403.125, -1279.74, 199);
    origin[29] = (-403.125, -1156.98, 199);
    origin[30] = (500.127, -1066.93, 249);
    origin[31] = (500.127, -960.876, 253);
    origin[32] = (582.874, -2712.7, 93);
    origin[33] = (582.874, -2679.92, 118);
    origin[34] = (582.874, -2630.89, 155);
    origin[35] = (582.874, -2574.91, 197);
    origin[36] = (582.874, -2520.04, 238);
    origin[37] = (582.874, -2471.26, 272);
    origin[38] = (496.126, -2712.7, 93);
    origin[39] = (496.126, -2679.92, 118);
    origin[40] = (496.126, -2630.89, 155);
    origin[41] = (496.126, -2574.91, 197);
    origin[42] = (496.126, -2520.04, 238);
    origin[43] = (496.126, -2471.26, 272);
    origin[44] = (145, -1188, 207);
    origin[45] = (219, -1188, 214);
    origin[46] = (303, -1188, 223);
    origin[47] = (388, -1188, 234);
    origin[48] = (472, -1188, 247);
    origin[49] = (145, -1317, 207);
    origin[50] = (219, -1317, 214);
    origin[51] = (303, -1317, 223);
    origin[52] = (388, -1317, 234);
    origin[53] = (472, -1317, 247);
    origin[54] = (-867, -1143, 199);
    origin[55] = (-867, -1264, 199);
    origin[56] = (-1139, -1270, 199);
    origin[57] = (-1139, -1138, 199);
    origin[58] = (-1379, -767, 199);
    origin[59] = (-1246, -767, 199);
    origin[60] = (-1299, -1464, 199);
    origin[61] = (-1432, -1464, 199);
    origin[62] = (-1306, -1503, 191);
    origin[63] = (-1428, -1503, 191);
    origin[64] = (-1310, -1169, 199);
    origin[65] = (-1343, -1169, 199);
    origin[66] = (-1384, -1169, 199);
    origin[67] = (-1428, -1169, 199);
    origin[68] = (-1310, -1077, 199);
    origin[69] = (-1343, -1077, 199);
    origin[70] = (-1384, -1077, 199);
    origin[71] = (-1428, -1077, 199);
    origin[72] = (-505, -814, 105);
    origin[73] = (-456, -814, 133);
    origin[74] = (-505, -910, 105);
    origin[75] = (-456, -910, 133);
    origin[76] = (-454, -964, 167);
    origin[77] = (-454, -1013, 199);
    origin[78] = (682, 322, 64);
    origin[79] = (820, 322, 64);
    origin[80] = (792, -60, 66);
    origin[81] = (792, -212, 64);
    origin[82] = (1066, 367, 64);
    origin[83] = (1067, 321, 64);
    origin[84] = (1211, 321, 65);
    origin[85] = (1039, 650, 70);
    origin[86] = (1039, 710, 114);
    origin[87] = (1039, 760, 152);
    origin[88] = (1039, 794, 166);
    origin[89] = (1039, 912, 167);
    origin[90] = (933, 650, 70);
    origin[91] = (933, 710, 114);
    origin[92] = (933, 760, 152);
    origin[93] = (933, 794, 166);
    origin[94] = (933, 912, 167);
    origin[95] = (933, 833, 167);
    origin[96] = (933, 880, 167);
    origin[97] = (1479, 650, 71);
    origin[98] = (1479, 709, 111);
    origin[99] = (1479, 760, 148);
    origin[100] = (1479, 795, 164);
    origin[101] = (1479, 890, 164);
    origin[102] = (1479, 920, 164);
    origin[103] = (1584, 650, 71);
    origin[104] = (1584, 709, 111);
    origin[105] = (1584, 760, 148);
    origin[106] = (1584, 795, 164);
    origin[107] = (1584, 890, 164);
    origin[108] = (1584, 920, 164);
    origin[109] = (326, 368, 64);
    origin[110] = (326, 227, 63);
    origin[111] = (-364, -1156, 191);
    origin[112] = (-364, -1282, 191);
    for (a = 0; a < 113; a++) playFx(level._effect["mp_light_lamp"], origin[a]);
}
doBossRounds() {
    while (true) {
        wait(randomIntRange(240, 600));
        if (isDefined(level.teleRound)) continue;
        array_thread(getPlayers(), ::deathMessage, "^1" + level.patch, "^1BOSS ZOMBIE! ^7-- ^2Created By: ^7" + level.creator, 260);
        level.bossRound = true;
        zom = getAiSpeciesArray("axis", "all");
        zom[0].health = 100000;
        zom[0] thread do_eyeFx();
        icon = level thread spawnObjPointer(undefined, zom[0].origin, "hint_health", false);
        icon setTargetEnt(zom[0]);
        healthText = createServerText(undefined, 1.5, "CENTER", "CENTER", 0, 100, 10, 1, "^1BOSS ZOMBIE HEALTH:");
        healthValue = createServerText(undefined, 1.3, "CENTER", "CENTER", 0, 120, 10, 1, undefined);
        array = strTok("zombie_ppsh zombie_mg42 ray_gun", " ");
        gunPick = array[randomInt(array.size - 1)];
        if (randomInt(200) <= 5) gunPick = array[2];
        zom[0] thread rareDropOnDeath(gunPick);
        traps = strTok("warehouse_electric_trap;wuen_electric_trap;bridge_electric_trap", ";");
        for (a = 0; a < traps.size; a++) {
            trappy = getEntArray(traps[a], "targetname");
            for (e = 0; e < trappy.size; e++) trappy[e] thread trigger_off_proc();
        }
        while (true) {
            zom = getAiSpeciesArray("axis", "all");
            healthValue setValue(zom[0].health);
            for (a = 1; a < zom.size; a++) zom[a] delete();
            if (zom[0].health < 1) break;
            wait .05;
        }
        for (a = 0; a < traps.size; a++) {
            trappy = getEntArray(traps[a], "targetname");
            for (e = 0; e < trappy.size; e++) trappy[e] thread trigger_on_proc();
        }
        icon destroy();
        healthText destroy();
        healthValue destroy();
        level.bossRound = undefined;
    }
}
main() {}
setDefaultDepthOfField() {}