#include common_scripts\utility;
#include maps\_utility;
#include maps\_createFxMenu;
createfx()
{
	precacheModel( "fx_axis_createfx" );
	PrecacheShader( "black" );
	if( GetDvar( "createfx_scaleid" ) == "" )
	{
		SetDvar( "createfx_scaleid", "1" );
	}
	if( GetDvar( "createfx_drawaxis" ) == "" )
	{
		SetDvar( "createfx_drawaxis", "1" );
	}
	if( GetDvar( "createfx_drawaxis_range" ) == "" )
	{
		SetDvar( "createfx_drawaxis_range", "2000" );
	}
	if( GetDvar( "createfx_autosave_time" ) == "" )
	{
		SetDvar( "createfx_autosave_time", "120" );
	}
	flag_init( "createfx_saving" );
	if (level.script == "pby_fly")
		SetMapCenter((0,0,0));
	if ( !isdefined( level.createFX ) ) level.createFX = [];
	triggers = getentarray( "trigger_multiple", "classname" );
	for (i=0;i<triggers.size;i++) triggers[i] delete();
	triggers = getentarray( "trigger_radius", "classname" );
	for (i=0;i<triggers.size;i++) triggers[i] delete();
	ai = getaiarray();
	for (i=0;i<ai.size;i++) ai[i] delete();
	spawners = GetSpawnerArray();
	for( i = 0;i < spawners.size;i++ )
	{
		spawners[i] Delete();
	}
	thread createFxLogic();
	level waittill ("eternity");
}
fx_init()
{
	level.exploderFunction = maps\_utility::exploder_before_load;
	waittillframeend;
	waittillframeend;
	level.exploderFunction = maps\_utility::exploder_after_load;
	for ( i=0;i<level.createFXent.size;i++ )
	{
		ent = level.createFXent[i];
		ent set_forward_and_up_vectors();
		if(level.clientscripts)
		{
			if(!level.createFX_enabled)
			{
				continue;
			}
		}
		if (ent.v["type"] == "loopfx") ent thread maps\_fx::loopfxthread();
		if (ent.v["type"] == "oneshotfx") ent thread maps\_fx::oneshotfxthread();
		if (ent.v["type"] == "soundfx") ent thread maps\_fx::create_loopsound();
	}
}
add_effect(name, effect)
{
	if (!isdefined (level._effect)) level._effect = [];
	level._effect[ name ] = loadfx( effect );
}
createEffect( type, fxid )
{
	ent = spawnStruct();
	if (!isdefined(level.createFXent)) level.createFXent = [];
	level.createFXent[level.createFXent.size] = ent;
	ent.v = [];
	ent.v["type"] = type;
	ent.v["fxid"] = fxid;
	ent.v["angles"] = (0,0,0);
	ent.v["origin"] = (0,0,0);
	ent.drawn = true;
	return ent;
}
createLoopSound()
{
	ent = spawnStruct();
	if (!isdefined(level.createFXent)) level.createFXent = [];
	level.createFXent[level.createFXent.size] = ent;
	ent.v = [];
	ent.v["type"] = "soundfx";
	ent.v["fxid"] = "No FX";
	ent.v["soundalias"] = "nil";
	ent.v["angles"] = (0,0,0);
	ent.v["origin"] = (0,0,0);
	ent.drawn = true;
	return ent;
}
createNewExploder()
{
	ent = spawnStruct();
	if ( !isdefined( level.createFXent ) ) level.createFXent = [];
	level.createFXent[ level.createFXent.size ] = ent;
	ent.v = [];
	ent.v[ "type" ] = "exploder";
	ent.v[ "fxid" ] = "No FX";
	ent.v[ "soundalias" ] = "nil";
	ent.v[ "angles" ] = (0,0,0);
	ent.v[ "origin" ] = (0,0,0);
	ent.v[ "exploder" ] = 1;
	ent.v[ "exploder_type" ] = "normal";
	ent.drawn = true;
	return ent;
}
set_forward_and_up_vectors(){}
createFxLogic(){}
toggle_createfx_drawing(){}
manipulate_createfx_ents(){}
clear_settable_fx(){}
reset_fx_hud_colors(){}
button_is_held(){}
button_is_clicked(){}
toggle_entity_selection(){}
select_entity(){}
ent_is_highlighted(){}
deselect_entity(){}
index_is_selected(){}
ent_is_selected(){}
clear_entity_selection(){}
draw_axis(){}
spawn_axis_model(){}
draw_axis_think(){}
stop_drawing_axis_models(){}
clear_fx_hudElements(){}
set_fx_hudElement(){}
createfx_centerprint(){}
createfx_centerprint_thread(){}
buttonDown(){}
buttonPressed_internal(){}
get_selected_move_vector(){}
process_button_held_and_clicked(){}
locked(){}
kb_locked(){}
add_button(){}
add_kb_button(){}
set_anglemod_move_vector(){}
cfxprintln(){}
generate_client_fx_log(){}
generate_fx_log(){}
print_fx_options(){}
entity_highlight_disable(){}
entity_highlight_enable(){}
get_center_of_array(){}
ent_draw_axis(){}
rotation_is_occuring(){}
process_fx_rotater(){}
rotate_over_time(){}
delete_pressed(){}
remove_selected_option(){}
remove_option(){}
delete_selection(){}
move_selection_to_cursor(){}
insert_effect(){}
show_help(){}
select_last_entity(){}
copy_ents(){}
post_entity_creation_function(){}
paste_ents(){}
add_and_select_entity(){}
stop_fx_looper(){}
restart_fx_looper(){}
update_selected_entities(){}
copy_angles_of_selected_ents(){}
reset_axis_of_selected_ents(){}
last_selected_entity_has_changed(){}
createfx_showOrigin(){}
drop_selection_to_ground(){}
set_off_exploders(){}
draw_distance(){}
createfx_autosave(){}
move_player_around_map_fast(){}