#include common_scripts\utility;
#include maps\_utility;
main()
{
	flag_init("pullup_weapon");
	flag_init("starting final intro screen fadeout");
	flag_init("introscreen_complete");
	PrecacheShader("black");
	if(GetDvar("introscreen")== "")
		SetDvar("introscreen", "1");
	level.splitscreen = getDvarInt("splitscreen");
	level.hidef = GetDvarInt("hidef");
	level thread introscreen_report_disconnected_clients();
	switch(level.script)
	{
		case "example": break;
		case "prologue": PrecacheString(&"PROLOGUE_INTROSCREEN_TITLE");
		PrecacheString(&"PROLOGUE_INTROSCREEN_PLACE");
		PrecacheString(&"PROLOGUE_INTROSCREEN_DATE");
		PrecacheString(&"PROLOGUE_INTROSCREEN_INFO");
		introscreen_delay(&"PROLOGUE_INTROSCREEN_TITLE", &"PROLOGUE_INTROSCREEN_DATE", &"PROLOGUE_INTROSCREEN_PLACE", &"PROLOGUE_INTROSCREEN_INFO");
		break;
		case "nazi_zombie_prototype": introscreen_delay();
		break;
		default: wait(0.05);
		level notify("finished final intro screen fadein");
		wait(0.05);
		flag_set("starting final intro screen fadeout");
		wait(0.05);
		level notify("controls_active");
		wait(0.05);
		flag_set("introscreen_complete");
		break;
	}
}
introscreen_create_line(string, type, scale, font)
{
	index = level.introstring.size;
	yPos =(index * 30);
	if(level.console)
	{
		yPos -= 90;
		xPos = 0;
	}
	else
	{
		yPos -= 120;
		xPos = 10;
	}
	align_x = "center";
	align_y = "middle";
	horz_align = "center";
	vert_align = "middle";
	if(!IsDefined(type))
		type = "lower_left";
	if(IsDefined(type))
	{
		switch(type)
		{
			case "lower_left": yPos -= 30;
			align_x = "left";
			align_y = "bottom";
			horz_align = "left";
			vert_align = "bottom";
			break;
		}
	}
	if(!isDefined(scale))
	{
		if(level.splitscreen && !level.hidef)fontScale = 2.75;
		else fontScale = 1.75;
	}
	else fontScale = scale;
	level.introstring[index] = NewHudElem();
	level.introstring[index].x = xPos;
	level.introstring[index].y = yPos;
	level.introstring[index].alignX = align_x;
	level.introstring[index].alignY = align_y;
	level.introstring[index].horzAlign = horz_align;
	level.introstring[index].vertAlign = vert_align;
	level.introstring[index].sort = 1;
	level.introstring[index].foreground = true;
	level.introstring[index].fontScale = fontScale;
	level.introstring[index] SetText(string);
	level.introstring[index].alpha = 0;
	level.introstring[index] FadeOverTime(1.2);
	level.introstring[index].alpha = 1;
	if(IsDefined(font))
		level.introstring[index].font = font;
}
introscreen_fadeOutText()
{
	for(i = 0;i < level.introstring.size;i++)
	{
		level.introstring[i] FadeOverTime(1.5);
		level.introstring[i].alpha = 0;
	}
	wait(1.5);
	for(i = 0;i < level.introstring.size;i++)
		level.introstring[i] Destroy();
}
introscreen_delay(string1, string2, string3, string4, string5, pausetime1, pausetime2, timebeforefade)
{
	if(IsDefined(level.custom_introscreen))
	{
		[[level.custom_introscreen]](string1, string2, string3, string4, string5);
		return;
	}
	flag_wait("all_players_connected");
	level.introblack = NewHudElem();
	level.introblack.x = 0;
	level.introblack.y = 0;
	level.introblack.horzAlign = "fullscreen";
	level.introblack.vertAlign = "fullscreen";
	level.introblack.foreground = true;
	level.introblack setShader("black", 640, 480);
	freezecontrols_all(true);
	level._introscreen = true;
	wait(0.5);
	level.introstring = [];
	if(IsDefined(string1))
		introscreen_create_line(string1);
	if(IsDefined(pausetime1))
		wait(pausetime1);
	else
		wait(2);
	if(IsDefined(string2))
		introscreen_create_line(string2);
	if(IsDefined(string3))
		introscreen_create_line(string3);
	if(IsDefined(string4))
	{
		if(IsDefined(pausetime2))
			wait(pausetime2);
		else
			wait(2);
		introscreen_create_line(string4);
	}
	if(IsDefined(string5))
	{
		if(IsDefined(pausetime2))
			wait(pausetime2);
		else
			wait(2);
		introscreen_create_line(string5);
	}
	level notify("finished final intro screen fadein");
	if(IsDefined(level.introscreen_waitontext_flag))
	{
		level notify("introscreen_blackscreen_waiting_on_flag");
		flag_wait(level.introscreen_waitontext_flag);
	}
	if(IsDefined(timebeforefade))
		wait(timebeforefade);
	else
		wait(3);
	level.introblack FadeOverTime(1.5);
	level.introblack.alpha = 0;
	flag_set("starting final intro screen fadeout");
	level thread freezecontrols_all(false, 0.75);
	level._introscreen = false;
	level notify("controls_active");
	introscreen_fadeOutText();
	flag_set("introscreen_complete");
}
introscreen_player_connect()
{
	if(IsDefined(level._introscreen)&& level._introscreen)
		self freezeControls(true);
}
introscreen_report_disconnected_clients()
{
	flag_wait("introscreen_complete");
	if(isdefined(level._disconnected_clients))
		for(i = 0;i < level._disconnected_clients.size;i ++)
			ReportClientDisconnected(level._disconnected_clients[i]);
}