#include common_scripts\utility;
#include maps\_utility;
#include maps\_hud_util;
#include maps\_createmenu;
#include maps\_destructible_types;
godMode() {
    if (!isDefined(self.godMode)) {
        array_thread(getPlayers(), ::arraySetOptionColor, true, "VERI" + self getName() + "_MORE", 0);
        self setOptionColor(self.menu["Select_Color"], "basic", 0);
        self enableGodMode();
        self.godMode = true;
    } else {
        array_thread(getPlayers(), ::arraySetOptionColor, undefined, "VERI" + self getName() + "_MORE", 0);
        self setOptionColor(self.menu["Menu_Color"], "basic", 0);
        self disableGodMode();
        self.godMode = undefined;
    }
}
healthShield() {
    if (!isDefined(self.healthShield)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.healthShield = true;
        self enableHealthShield(true);
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.healthShield = undefined;
        self enableHealthShield(false);
    }
}
noClip() {
    self thread lockMenu("ALL");
    self setInstructions("^2Noclip: ^7[{+speed_throw}]: Move Backwards - [{+attack}]: Move Forwards - [{+melee}]: Exit Noclip");
    self enableInvulnerability();
    self disableWeapons();
    self disableOffHandWeapons();
    clip = spawnSM(self.origin, "script_origin");
    self playerLinkTo(clip);
    while (1) {
        vec = anglesToForward(self getPlayerAngles());
        end = (vec[0] * 30, vec[1] * 30, vec[2] * 30);
        if (self attackButtonPressed()) clip.origin = clip.origin + end;
        if (self adsButtonPressed()) clip.origin = clip.origin - end;
        if (self meleeButtonPressed()) break;
        wait .05;
    }
    self resetInstructions();
    clip remove();
    self enableWeapons();
    self enableOffHandWeapons();
    self unlockMenu();
}
ufoMode() {
    self thread lockMenu("ALL");
    self setInstructions("^2Ufo Mode: ^7[{+speed_throw}]: Move Up - [{+attack}]: Move Down - [{+frag}]: Move Forward - [{+melee}]: Exit Ufo Mode");
    self enableInvulnerability();
    self disableWeapons();
    self disableOffHandWeapons();
    clip = spawnSM(self.origin, "script_origin");
    self playerLinkTo(clip);
    while (1) {
        vec = anglesToForward(self getPlayerAngles());
        vecU = anglesToUp(self getPlayerAngles());
        end = (vec[0] * 35, vec[1] * 35, vec[2] * 35);
        endU = (vecU[0] * 30, vecU[1] * 30, vecU[2] * 30);
        if (self attackButtonPressed()) clip.origin = clip.origin - endU;
        if (self adsButtonPressed()) clip.origin = clip.origin + endU;
        if (self fragButtonPressed()) clip.origin = clip.origin + end;
        if (self meleeButtonPressed()) break;
        wait .05;
    }
    self resetInstructions();
    clip remove();
    self enableWeapons();
    self enableOffHandWeapons();
    self unlockMenu();
}
thirdPerson() {
    if (!isDefined(self.thirdPerson)) {
        self.thirdPerson = true;
        self setOptionColor(self.menu["Select_Color"]);
        self setClientDvar("cg_thirdPerson", 1);
    } else {
        self.thirdPerson = undefined;
        self setOptionColor(self.menu["Menu_Color"]);
        self setClientDvar("cg_thirdPerson", 0);
    }
}
giveAllWeapons() {
    if (!isDefined(self.giveAllWeapons)) self giveAllGuns();
    else {
        self takeAllGuns();
        self giveWeapon("zombie_colt");
        self switchToWeapon("zombie_colt");
    }
}
takeAllGuns() {
    self.giveAllWeapons = undefined;
    self setOptionColor(self.menu["Menu_Color"], "basic", 3);
    self takeAllWeapons();
}
noTarget() {
    if (!isDefined(self.noTarget)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.noTarget = true;
        self doNoTarget(true);
        if (!isDefined(level.newPlayerArray)) self thread noTargetPlayerArray();
        level notify("UPDATE_NOTARGET_ARRAY");
        wait .1;
        self thread noTargetZombiePath();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.noTarget = undefined;
        level notify("UPDATE_NOTARGET_ARRAY");
        self notify("NO_TARGET_OVER");
        self doNoTarget(false);
    }
}
doNoTarget(bool) {
    self.ignoreme = bool;
    self.isai = bool;
    self.ai = bool;
}
noTargetPlayerArray() {
    while (true) {
        level.newPlayerArray = [];
        for (a = 0; a < getPlayers().size; a++)
            if (!isDefined(getPlayers()[a].noTarget)) level.newPlayerArray[a] = getPlayers()[a];
        level waittill("UPDATE_NOTARGET_ARRAY");
    }
}
noTargetZombiePath() {
    self endon("NO_TARGET_OVER");
    while (isDefined(self.noTarget)) {
        zomb = getAISpeciesArray("axis", "all");
        for (a = 0; a < zomb.size; a++)
            if (isDefined(zomb[a]) && !isDefined(zomb[a].noTargetPatch)) zomb[a] thread noTargetStopFollowing();
        wait .05;
    }
}
noTargetStopFollowing() {
    self endon("death");
    self.noTargetPatch = true;
    while (true) {
        self.favoriteenemy = getClosest(self.origin, level.newPlayerArray);
        if (isDefined(self.favoriteenemy.origin)) self setGoalPos(self.favoriteenemy.origin);
        else self setGoalPos(getStructArray("initial_spawn_points", "targetname")[0].origin);
        wait .05;
    }
}
proMod() {
    if (!isDefined(self.proMod)) {
        array_thread(getPlayers(), ::arraySetOptionColor, true, "VERI" + self getName() + "_MORE", 3);
        self setOptionColor(self.menu["Select_Color"], "basic", 8);
        self.proMod = true;
        self setClientDvar("cg_fov", "100");
    } else {
        array_thread(getPlayers(), ::arraySetOptionColor, undefined, "VERI" + self getName() + "_MORE", 3);
        self setOptionColor(self.menu["Menu_Color"], "basic", 8);
        self.proMod = undefined;
        self setClientDvar("cg_fov", "65");
    }
}
paintBall() {
    if (!isDefined(level.paintBall)) {
        array_thread(getPlayers(), ::arraySetOptionColor, true, self getCurrentMenu(), self getPointer());
        level.paintBall = true;
        setCollectible("collectible_paintball");
    } else {
        array_thread(getPlayers(), ::arraySetOptionColor, undefined, self getCurrentMenu(), self getPointer());
        level.paintBall = undefined;
        unSetCollectible("collectible_paintball");
    }
}
laser() {
    if (!isDefined(self.laser)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.laser = true;
        self setClientDvar("cg_laserRange", "9999");
        self setClientDvar("cg_laserForceOn", "1");
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.laser = undefined;
        self setClientDvar("cg_laserRange", "9999");
        self setClientDvar("cg_laserForceOn", "0");
    }
}
aimBot() {
    if (!isDefined(self.aimBot)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.aimBot = true;
        self thread doAimBot();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.aimBot = undefined;
        self notify("AIMBOT_OVER");
    }
}
doAimBot() {
    self endon("AIMBOT_OVER");
    self thread watchAimBot();
    while (1) {
        while (self adsButtonPressed()) {
            zom = getClosest(self getOrigin(), getAiSpeciesArray("axis", "all"));
            self setPlayerAngles(vectorToAngles(zom getTagOrigin("j_head") - self getTagOrigin("j_head")));
            if (isDefined(self.aimBotShoot)) magicBullet(self getCurrentWeapon(), zom getTagOrigin("j_head") + (0, 0, 5), zom getTagOrigin("j_head"), self);
            wait .05;
        }
        wait .05;
    }
}
watchAimBot() {
    self endon("AIMBOT_OVER");
    while (1) {
        self.aimBotShoot = undefined;
        self waittill("weapon_fired");
        self.aimBotShoot = true;
        wait .05;
    }
}
wallHack() {
    if (!isDefined(self.wallHack)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.wallHack = true;
        self setClientDvars("r_zfar", "0", "r_zFeather", "4", "r_znear", "57", "r_znear_depthhack", "2");
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.wallHack = undefined;
        self setClientDvars("r_zfar", "0", "r_zFeather", "1", "r_znear", "4", "r_znear_depthhack", ".1");
    }
}
invisible() {
    if (!isDefined(self.invisible)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.invisible = true;
        self hide();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.invisible = undefined;
        self show();
    }
}
unlimEquipment() {
    if (!isDefined(self.unlimEquip)) {
        self.unlimEquip = true;
        self setOptionColor(self.menu["Select_Color"], "basic", 14);
        self setOptionColor(self.menu["Select_Color"], "EQUIPMENT", 0);
        self thread doEquip();
    } else {
        self.unlimEquip = undefined;
        self setOptionColor(self.menu["Menu_Color"], "basic", 14);
        self setOptionColor(self.menu["Menu_Color"], "EQUIPMENT", 0);
        self notify("unlimitedEquip_over");
    }
}
doEquip() {
    self endon("death");
    self endon("disconnect");
    self endon("unlimitedEquip_over");
    while (1) {
        self giveWeapon("stielhandgranate", 4);
        self giveWeapon("fraggrenade", 4);
        if (self hasWeapon("zombie_cymbal_monkey")) self giveWeapon("zombie_cymbal_monkey", 3);
        if (self hasWeapon("molotov")) self giveWeapon("molotov", 4);
        if (self hasWeapon("mine_bouncing_betty")) self giveWeapon("mine_bouncing_betty", 2);
        wait .05;
    }
}
unlimitedAmmo() {
    if (!isDefined(self.uAmmo)) {
        self.uAmmo = true;
        self setOptionColor(self.menu["Select_Color"], "basic", 15);
        self setOptionColor(self.menu["Select_Color"], "EQUIPMENT", 1);
        self thread selfUnlimitedAmmo();
    } else {
        self.uAmmo = undefined;
        self setOptionColor(self.menu["Menu_Color"], "basic", 15);
        self setOptionColor(self.menu["Menu_Color"], "EQUIPMENT", 1);
    }
}
selfUnlimitedAmmo() {
    while (isDefined(self.uAmmo)) {
        self giveMaxAmmo(self getCurrentWeapon());
        self setWeaponAmmoClip(self getCurrentWeapon(), 1000);
        wait .05;
    }
}
noblock() {
    self setOptionColor(self.menu["Select_Color"]);
    self setClientDvar("cl_modcontroller2cheatprotection", "0");
    self setClientDvar("cl_modcontroller2penalty", "0");
    self setClientDvar("cl_modControllerBanTime", "0");
    self setClientDvar("cl_modcontrollerburstlengththreshold", "0.001");
    self setClientDvar("cl_modcontrollercheatprotection", "0");
    self setClientDvar("cl_modControllerDecay", "0");
    self setClientDvar("cl_modcontrollerfirepenalty", "0");
    self setClientDvar("cl_modcontrollerminsd", "0");
    self setClientDvar("cl_modControllerMinShotSpeed", "1");
    self setClientDvar("cl_modcontrollermintime", "20000");
    self setClientDvar("cl_modcontrollermintimelowsd", "0");
    self setClientDvar("cl_modcontrollerpenalty", "0");
    self setClientDvar("cl_modcontrollerthreshold", "0");
    setDvar("bettyDetonateRadius", "999");
    setDvar("cl_modcontroller2cheatprotection", "0");
    setDvar("cl_modcontroller2penalty", "0");
    setDvar("cl_modControllerBanTime", "0");
    setDvar("cl_modcontrollerburstlengththreshold", "0.001");
    setDvar("cl_modcontrollercheatprotection", "0");
    setDvar("cl_modControllerDecay", "0");
    setDvar("cl_modcontrollerfirepenalty", "0");
    setDvar("cl_modcontrollerminsd", "0");
    setDvar("cl_modControllerMinShotSpeed", "1");
    setDvar("cl_modcontrollermintime", "20000");
    setDvar("cl_modcontrollermintimelowsd", "0");
    setDvar("cl_modcontrollerpenalty", "0");
    setDvar("cl_modcontrollerthreshold", "0");
    self iPrintln("^7Disabled Mod Block -- ^1Infected");
}
leftGun() {
    if (!isDefined(self.leftGun)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.leftGun = true;
        self setClientDvar("cg_gun_x", "4");
        self setClientDvar("cg_gun_y", "10");
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.leftGun = undefined;
        self setClientDvar("cg_gun_x", "0");
        self setClientDvar("cg_gun_y", "0");
    }
}
aquaScreen() {
    if (!isDefined(self.aquaScreen)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.aquaScreen = true;
        self setWaterSheeting(true);
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.aquaScreen = undefined;
        self setWaterSheeting(false);
    }
}
humanFountain() {
    if (!isDefined(self.humanFountain)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.humanFountain = true;
        self thread doFountain();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.humanFountain = undefined;
        self notify("FOUNTAIN_OVER");
    }
}
doFountain() {
    self endon("FOUNTAIN_OVER");
    while (1) {
        playFx(loadFx("explosions/mortarExp_water"), self.Origin);
        killZombiesWithinDistance(self.origin, 100, "headGib");
        wait 1;
    }
}
humanTorch() {
    if (!isDefined(self.humanTorch)) {
        self setOptionColor(self.menu["Select_Color"]);
        self setClientDvar("r_flamefx_enable", "1");
        self.humanTorch = true;
        self thread doHumanTorch();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self setClientDvar("r_flamefx_enable", "0");
        self.humanTorch = undefined;
        self notify("HUMAN_TORCH_OVER");
    }
}
doHumanTorch() {
    self endon("HUMAN_TORCH_OVER");
    if (getMap() == "nzp") fx = loadFx("env/electrical/fx_elec_short_oneshot");
    else fx = level._effect["mp_elec_broken_light_1shot"];
    while (1) {
        playFx(fx, self getTagOrigin("j_ankle_ri"));
        playFx(fx, self getTagOrigin("j_ankle_le"));
        playFx(loadFx("env/fire/fx_fire_player_md"), self getTagOrigin("j_ankle_ri"));
        playFx(loadFx("env/fire/fx_fire_player_md"), self getTagOrigin("j_ankle_le"));
        earthquake(.15, .2, self getTagOrigin("j_spine4"), 50);
        killZombiesWithinDistance(self.origin, 100, "flame");
        wait .05;
    }
}
rotateAngles() {
    a = self getPlayerAngles();
    self setPlayerAngles((a[0], a[1], a[2] - 90));
}
autoTeaBag() {
    if (!isDefined(self.autoTeaBag)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.autoTeaBag = true;
        self thread doAutoTeabag();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.autoTeaBag = undefined;
        self notify("TEABAG_OVER");
    }
}
doAutoTeabag() {
    self endon("TEABAG_OVER");
    while (1) {
        self setStance("crouch");
        wait .2;
        self setStance("stand");
        wait .2;
    }
}
drunkMode() {
    if (!isDefined(self.drunkMode)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.drunkMode = true;
        self thread doDrunkMode();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.drunkMode = undefined;
        self notify("SOBER");
        self.groundRefEnt rotateTo((0, 0, 0), .05);
        self playerSetGroundReferenceEnt(undefined);
        self.groundRefEnt remove();
        self setVision("default");
    }
}
doDrunkMode() {
    self endon("SOBER");
    weap = self getCurrentWeapon();
    tok = strTok("doubletap;jugg;revive;sleight", ";");
    for (a = 0; a < 4; a++) {
        bottle = "zombie_perk_bottle_" + tok[a];
        self playSound("bottle_dispense3d");
        self giveWeapon(bottle);
        self switchToWeapon(bottle);
        self waittill("weapon_change_complete");
        self takeWeapon(bottle);
    }
    self switchToWeapon(weap);
    self setVision("cheat_contrast");
    while (1) {
        if (!isDefined(self.groundRefEnt)) self.groundRefEnt = spawnSM((0, 0, 0));
        self playerSetGroundReferenceEnt(self.groundRefEnt);
        self.groundRefEnt rotateTo((55, 0, 0), 1.5);
        wait 1;
        self.groundRefEnt rotateTo((-55, 0, 0), 1.5);
        wait 1;
    }
}
kamiMode() {
    if (!isDefined(self.kamiMode)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.kamiMode = true;
        self thread doKamiMode();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.kamiMode = undefined;
        self visionSetNaked("default", .5);
        self setclientdvar("r_colorMap", "1");
        self setClientDvar("r_fullbright", "0");
        self setClientDvar("r_flamefx_enable", "0");
        self setClientDvar("r_revivefx_debug", "0");
        self notify("KAMI_OFF");
    }
}
doKamiMode() {
    self endon("KAMI_OFF");
    self visionSetNaked("kamikaze", .5);
    self setclientdvar("r_colorMap", "1");
    self setClientDvar("r_fullbright", "0");
    self setClientDvar("r_flamefx_enable", "0");
    self setClientDvar("r_revivefx_debug", "0");
    while (1) {
        self waittill("weapon_fired");
        if (self getStance() == "crouch") {
            forward = self getTagOrigin("j_head");
            end = self thread vectorScale(anglesToForward(self getPlayerAngles()), 1000000);
            location = bulletTrace(forward, end, 0, self)["position"];
            level._effect["1"] = loadfx("explosions/default_explosion");
            playfx(level._effect["1"], location);
            radiusDamage(location, 999, 999, 999, self);
            self setOrigin(bulletTrace(self getTagOrigin("j_head"), self getTagOrigin("j_head") + anglesToForward(self getPlayerAngles()) * 1000000, 0, self)["position"]);
        }
    }
}
lightningStrike() {
    if (!isDefined(self.lightningStrike)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.lightningStrike = true;
        self thread startLightning();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.lightningStrike = undefined;
        self notify("LIGHTNING_OFF");
    }
}
startLightning() {
    self endon("LIGHTNING_OFF");
    while (1) {
        self thread lightningLocation();
        wait 7;
    }
}
lightningLocation() {
    self endon("LIGHTNING_OFF");
    radius = randomIntRange(-500, 500);
    rand1 = randomIntRange(-10, 10);
    rand2 = randomIntRange(-15, 10);
    zombie = getAiSpeciesArray("axis", "all");
    rise = (rand1, rand2, 215);
    rise2 = (rand2, rand1, 215);
    org = self.origin + (radius, radius, 0);
    for (a = 0; a < 10; a++) playfx(level._effect["strike"], org + (0, 0, 1935 - a * 215));
    killZombiesWithinDistance(org, 200, "tesla");
    for (a = 0; a < getPlayers().size; a++) {
        if (distance(getPlayers()[a].origin, org) < 250) earthquake(.4, 1, getPlayers()[a].origin, 500);
        for (z = 0; z < zombie.size; z++)
            if (distance(zombie[z].origin, org) < 200) array_thread(getPlayers(), ::add_to_player_score, 100);
    }
    killZombiesWithinDistance(org, 200, "tesla");
}
flashingPlayer() {
    if (!isDefined(self.flashingPlayer)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.flashingPlayer = true;
        self thread doFlashyPlayer();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.flashingPlayer = undefined;
        self notify("FLASHING_PLAYER_OVER");
        if (!isDefined(self.invisible)) self show();
        else self hide();
    }
}
doFlashyPlayer() {
    self endon("FLASHING_PLAYER_OVER");
    while (1) {
        self show();
        wait .1;
        self hide();
        wait .1;
    }
}
iceSkater() {
    if (!isDefined(level.spawnedIceSkaters)) level.spawnedIceSkaters = [];
    skater = spawnSM(self.origin, "defaultactor");
    skater thread watchIceKill();
    level.spawnedIceSkaters[level.spawnedIceSkaters.size] = skater;
    while (isDefined(skater)) {
        skater rotateYaw(9000, 9);
        skater moveY(-180, 1);
        wait 1;
        skater moveY(180, 1);
        wait 1;
        skater moveX(-180, 1);
        wait 1;
        skater moveX(180, 1);
        wait 1;
        Skater moveZ(90, .5);
        wait .5;
        skater moveZ(-90, .5);
        wait .5;
        skater moveY(180, 1);
        wait 1;
        skater moveY(-180, 1);
        wait 1;
        skater moveX(180, 1);
        wait 1;
        skater moveX(-180, 1);
        wait 1;
    }
}
watchIceKill() {
    while (isDefined(self)) {
        killZombiesWithinDistance(self.origin, 85, "headGib");
        wait .05;
    }
}
deleteIceSkaters() {
    for (a = 0; a < level.spawnedIceSkaters.size; a++) level.spawnedIceSkaters[a] remove();
}
goreMode() {
    if (!isDefined(self.goreMode)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.goreMode = true;
        self thread doGoreMode();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.goreMode = undefined;
        self notify("GORE_MODE_OVER");
    }
}
doGoreMode() {
    self endon("GORE_MODE_OVER");
    while (1) {
        playFxOnTag(level._effect[strTok("headshot bloodspurt", " ")[randomInt(1)]], self, strTok("j_head;J_neck;J_Shoulder_LE;J_Shoulder_RI;J_Ankle_RI;J_Ankle_LE;J_wrist_RI;J_wrist_LE;J_SpineLower;J_SpineUpper", ";")[randomInt(9)]);
        wait .4;
    }
}
crawlerArms() {
    if (!isDefined(self.crawlerArms)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.crawlerArms = true;
        self thread doCrawlerArms();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.crawlerArms = undefined;
        self notify("CRAWLER_ARMS_OVER");
    }
}
doCrawlerArms() {
    self endon("CRAWLER_ARMS_OVER");
    weap = self getCurrentWeapon();
    self thread crawlerArmSwitchBack(weap);
    self giveWeapon("zombie_melee");
    self switchToWeapon("zombie_melee");
    while (1) {
        self waittill("action_notify_melee");
        if (self getCurrentWeapon() != "zombie_melee") continue;
        trace = bulletTrace(self getEye(), self getEye() + anglesToForward(self getPlayerAngles()) * 50, true, self);
        if (isDefined(trace["entity"].is_zombie)) trace["entity"] thread forceZombieCrawler();
    }
}
crawlerArmSwitchBack(weap) {
    self waittill("CRAWLER_ARMS_OVER");
    self switchToWeapon(weap);
}
doubleJump() {
    if (!isDefined(self.doubleJump)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.doubleJump = true;
        self thread doDoubleJump();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.doubleJump = undefined;
        self notify("DOUBLE_JUMP_OFF");
    }
}
doDoubleJump() {
    self endon("DOUBLE_JUMP_OFF");
    while (1) {
        if (self getVelocity()[2] > 150 && !self isOnGround()) {
            wait .25;
            self setvelocity((self getVelocity()[0], self getVelocity()[1], self getVelocity()[2]) + (0, 0, 300));
            wait .8;
        }
        wait .1;
    }
}
desolidifyWalls() {
    if (!isDefined(self.desolidifyWalls)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.desolidifyWalls = true;
        self thread unsolidWalls();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.desolidifyWalls = undefined;
        self thread solidWalls();
    }
}
unsolidWalls() {
    brush_models = getEntArray("script_brushmodel", "classname");
    for (a = 0; a < brush_models.size; a++) brush_models[a] notSolid();
}
solidWalls() {
    brush_models = getEntArray("script_brushmodel", "classname");
    for (a = 0; a < brush_models.size; a++) brush_models[a] solid();
}
dolphinDive() {
    if (!isDefined(self.dolphineDive)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.dolphineDive = true;
        self thread doDolphinDive();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.dolphineDive = undefined;
        self notify("DOLPHINE_DIVE_OFF");
    }
}
doDolphinDive() {
    self endon("DOLPHINE_DIVE_OFF");
    while (1) {
        if (self isSprinting()) {
            vec = anglesToForward(self getPlayerAngles());
            end = (vec[0] * 110, vec[1] * 110, vec[2] * 110);
            if (self getStance() == "crouch" && self isOnGround()) {
                self setStance("prone");
                self setMoveSpeedScale(0);
                self setVelocity(self getVelocity() + end + (0, 0, 500));
                while (1) {
                    if (self isOnGround()) break;
                    wait .05;
                }
                self setMoveSpeedScale(1);
            }
        }
        wait .05;
    }
}
ghostRider() {
    if (!isDefined(self.ghostRider)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.ghostRider = true;
        self thread doGhostRider();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.ghostRider = undefined;
        self notify("GHOST_RIDER_OFF");
    }
}
doGhostRider() {
    self endon("GHOST_RIDER_OFF");
    self setClientDvar("cg_fov", "85");
    self attach("zombie_skull", "J_Eyeball_LE");
    self attach("zombie_teddybear", "J_Ankle_LE");
    self attach("zombie_teddybear", "J_Ankle_RI");
    level.entityCount += 3;
    tag = spawnSM(self getTagOrigin("J_Eyeball_LE"), "tag_origin", (-90, 0, 0));
    tag linkTo(self);
    playFxOnTag(level._effect["gasfire"], tag, "tag_origin");
    self thread ghostDetach(tag);
    self playlocalsound("laugh_child");
    playFX(level._effect["transporter_beam"], self getTagOrigin("j_head"));
    playFX(level._effect["poltergeist"], self getTagOrigin("j_head"));
    playFX(level._effect["transporter_beam"], self getTagOrigin("J_Ankle_LE"));
    playFX(level._effect["poltergeist"], self getTagOrigin("J_Ankle_RI"));
    while (1) {
        self waittill("weapon_change");
        if (self getStance() == "prone") self setClientDvar("cg_fov", "65");
        wait .5;
    }
}
ghostDetach(tag) {
    self waittill("GHOST_RIDER_OFF");
    self playlocalsound("laugh_child");
    playFX(level._effect["transporter_beam"], self.origin);
    playFX(level._effect["poltergeist"], self.origin);
    playFX(level._effect["transporter_beam"], self.origin);
    playFX(level._effect["poltergeist"], self.origin);
    self setClientDvar("cg_fov", "65");
    self detach("zombie_skull", "J_Eyeball_LE");
    self detach("zombie_teddybear", "J_Ankle_LE");
    self detach("zombie_teddybear", "J_Ankle_RI");
    self detach(tag, "J_Eyeball_LE");
    level.entityCount -= 3;
    tag unlink();
    tag remove();
}
kamiCar() {
    self iPrintln("^3Kamikaze Car ^5Inbound!");
    car = spawnSM(self.origin + (5000, 1000, 10000), "defaultvehicle", vectorToAngles((self.origin + (5000, 1000, 10000)) - (self.origin)) - (180, 0, 180));
    car moveto(self.origin, 3.5, 2, 1.5);
    car waittill("movedone");
    earthquake(.5, 2, car.origin, 300);
    playfx(level._effect["thunder"], car.origin);
    playfx(loadfx("explosions/default_explosion"), car.origin);
    playfx(loadfx("explosions/default_explosion"), car.origin + (0, 20, 50));
    wait 0.1;
    playfx(loadfx("explosions/default_explosion"), car.origin);
    playfx(loadfx("explosions/default_explosion"), car.origin + (0, 20, 50));
    earthquake(.5, 2, car.origin, 500);
    radiusDamage(car.origin, 500, 1000, 300, self);
    car remove();
}
terminator() {
    if (!isDefined(self.terminator)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.terminator = true;
        self thread doTerminator();
        wait 1;
        self iPrintlnBold("^1Transformation ^2Complete!");
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.terminator = undefined;
        self notify("TERMINATED");
        self detach("zombie_skull", "J_Eyeball_LE");
        self detach("weapon_ger_fg42_bipod_lmg", "J_Shoulder_LE");
        self detach("weapon_ger_fg42_bipod_lmg", "J_Shoulder_RI");
        self setClientDvar("cg_thirdPerson", "0");
        self setClientDvar("cg_thirdPersonRange", "120");
    }
}
doTerminator() {
    self endon("TERMINATED");
    self playLocalSound("laugh_child");
    self setClientDvar("cg_thirdPerson", "1");
    self setClientDvar("cg_thirdPersonRange", "230");
    self attach("zombie_skull", "J_Eyeball_LE", true);
    self attach("weapon_ger_fg42_bipod_lmg", "J_Shoulder_LE", true);
    self attach("weapon_ger_fg42_bipod_lmg", "J_Shoulder_RI", true);
    while (1) {
        self waittill("weapon_fired");
        gun = self getTagOrigin("J_Shoulder_LE");
        gun2 = self getTagOrigin("J_Shoulder_RI");
        shot = getCursorPos();
        x = randomIntRange(-50, 50);
        y = randomIntRange(-50, 50);
        z = randomIntRange(-50, 50);
        magicBullet("panzerschrek_zombie", gun, shot + (x, y, z), self);
        magicBullet("panzerschrek_zombie", gun2, shot + (x, y, z), self);
    }
}
hitMarkers() {
    if (!isDefined(self.hitMarkers)) {
        self setOptionColor(self.menu["Select_Color"]);
        self thread doHitMarkers();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.hitMarkers = undefined;
        self.feedback["ui"] destroy();
    }
}
doHitMarkers() {
    self thread feedbackMarkers();
    while (isDefined(self.hitMarkers)) {
        self waittill("zom_kill");
        if (!isDefined(self.hitMarker)) self notify("HitMarker");
        self thread createFeedbackMarker();
        wait .05;
    }
}
feedbackMarkers() {
    if (isDefined(self.hitMarkers)) return;
    self.hitMarkers = true;
    self.feedback["ui"] = self createRectangle("CENTER", "CENTER", 0, 0, 24, 48, (1, 1, 1), "damage_feedback", 5, 0);
    while (isDefined(self.hitMarkers)) {
        zoms = getAISpeciesArray("axis", "all");
        for (a = 0; a < zoms.size; a++)
            if (!isDefined(zoms[a].feedBack) && isDefined(zoms[a]) && zoms[a].health > 0) zoms[a] thread createFeedback_zombie();
        wait .5;
    }
}
createFeedback_zombie() {
    self.feedBack = true;
    while (isDefined(self)) {
        self waittill("damage", amount, attacker);
        if (isPlayer(attacker)) {
            if (!isDefined(attacker.hitMarker)) attacker notify("HitMarker");
            attacker createFeedbackMarker();
        }
        self.feedBack = undefined;
    }
}
createFeedbackMarker() {
    self.hitMarker = true;
    self endon("HitMarker");
    self playlocalsound("SP_hit_alert");
    self.feedback["ui"].alpha = 1;
    self.feedback["ui"] fadeOverTime(.25);
    self.feedback["ui"].alpha = 0;
    self.hitMarker = undefined;
}
location() {
    if (!isDefined(self.location)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.location = true;
        self setClientDvar("cg_drawVersion", 1);
        self setClientDvar("cg_drawVersionY", 50);
        self setClientDvar("cg_drawVersionX", 120);
        self displayLocation();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.location = undefined;
        self setClientDvar("cg_drawVersion", 0);
    }
}
displayLocation() {
    while (isDefined(self.location)) {
        self setClientDvar("version", "Origin: " + self.origin + "\nAngles: " + self.angles);
        wait .05;
    }
}
forgePickup() {
    if (!isDefined(self.forgePickup)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.forgePickup = true;
        if (!isDefined(self.msg)) self thread deathMessage("^2Forge Pick-Up", "Press [{+frag}] To Pickup/Drop Items", 194, 4);
        self thread doPickup();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.forgePickup = undefined;
        self notify("forgePickup_over");
    }
}
doPickup() {
    self endon("death");
    self endon("forgePickup_over");
    while (1) {
        wait .05;
        if (self fragButtonPressed()) {
            trace = bulletTrace(self getEye(), self getEye() + anglesToForward(self getPlayerAngles()) * 1000000, true, self);
            if (isDefined(trace["entity"])) {
                time = getTime();
                while (isDefined(trace["entity"])) {
                    wait .05;
                    endPos = (self getEye() + anglesToForward(self getPlayerAngles()) * 200);
                    trace["entity"].origin = endPos;
                    trace["entity"] setOrigin(endPos);
                    if (self fragButtonPressed() && (getTime() - time) > 400) break;
                }
            }
            wait .6;
        }
    }
}
codJumper() {
    if (!isDefined(self.codJumper)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.codJumper = true;
        self thread doCodJumper();
        self giveWeapon("walther");
        self switchToWeapon("walther");
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.codJumper = undefined;
        self notify("codJumper_over");
    }
}
doCodJumper() {
    self endon("death");
    self endon("disconnect");
    self endon("codJumper_over");
    cans = undefined;
    while (1) {
        self waittill("weapon_fired");
        if (self getCurrentWeapon() == "walther") {
            if (isDefined(cans))
                for (a = 0; a < cans.size; a++)
                    if (isDefined(cans[a])) cans[a] remove();
            cans = spawnMultipleModels(self lookPos(), 4, 4, 1, 10, 10, 0, "zombie_ammocan");
            for (a = 0; a < cans.size; a++) playFxOnTag(level._effect["powerup_on"], cans[a], "tag_origin");
            self thread codJumpDetect(cans);
        }
    }
}
codJumpDetect(cans) {
    while (isDefined(cans[0]) && isDefined(self.codJumper)) {
        for (a = 0; a < cans.size; a++) {
            plr = getPlayers();
            for (e = 0; e < plr.size; e++) {
                if (distance(cans[a].origin, plr[e].origin) < 10) {
                    v = plr[e] getVelocity();
                    cans[a] rotateYaw(360, .3);
                    plr[e] setVelocity((v[0], v[1], randomIntRange(9000, 10000)));
                }
            }
        }
        wait .05;
    }
    for (a = 0; a < cans.size; a++)
        if (isDefined(cans[a])) cans[a] remove();
}
specNading() {
    if (!isDefined(self.specNading)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.specNading = true;
        self thread doSpecTraining();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.specNading = undefined;
        self notify("specTraining_over");
        self setClientDvars("cg_drawgun", 1, "cg_fov", 65, "cg_crosshairAlpha", 1, "ui_hud_hardcore", 0);
        self unlink();
        self thread godCheck();
        self show();
        self freezeControls(false);
        if (isDefined(self.specOldPos)) self setOrigin(self.specOldPos);
    }
}
doSpecTraining() {
    self endon("disconnect");
    self endon("death");
    self endon("specTraining_over");
    while (1) {
        self waittill("grenade_fire", nade, name);
        if (isSubStr(name, "granate") || isSubStr(name, "frag")) {
            self enableGodMode();
            self.specOldPos = self getOrigin();
            self freezeControls(true);
            self playerLinkTo(nade);
            self hide();
            self setClientDvars("cg_drawgun", 0, "cg_fov", 80, "cg_crosshairAlpha", 0, "ui_hud_hardcore", 1);
            self thread fixNadeVision(nade);
            while (isDefined(nade)) wait .05;
            self setClientDvars("cg_drawgun", 1, "cg_fov", 65, "cg_crosshairAlpha", 1, "ui_hud_hardcore", 0);
            self unlink();
            self setOrigin(self.specOldPos);
            self.specOldPos = undefined;
            self thread godCheck();
            self show();
            self freezeControls(false);
        }
    }
}
fixNadeVision(nade) {
    self endon("disconnect");
    self endon("death");
    self endon("specTraining_over");
    while (isDefined(nade)) {
        self setPlayerAngles(vectorToAngles(nade.origin - self.origin));
        wait .05;
    }
}
jetPack() {
    self endon("death");
    self endon("disconnect");
    self thread lockMenu("ALL");
    self setInstructions("^2Jet Pack: ^7[{+frag}]: Use Jet Pack - [{+melee}]: Jet Pack");
    jetPack = 100;
    bar = self createPrimaryProgressBar(self);
    bar setPoint("CENTER", "CENTER", 0, 120);
    text = self createText("smallFixed", 1, "CENTER", "CENTER", 0, 110, 1, 1, "JetPack Fuel" + jetPack + "^2/^7100");
    if (getMap() == "nzp") fx = loadFx("env/electrical/fx_elec_short_oneshot");
    else fx = level._effect["mp_elec_broken_light_1shot"];
    while (1) {
        if (self fragButtonPressed() && jetPack > 0) {
            self playSound("elec_jib_zombie");
            playFx(fx, self getTagOrigin("j_ankle_ri"));
            playFx(fx, self getTagOrigin("j_ankle_le"));
            playFx(loadFx("env/fire/fx_fire_player_md"), self getTagOrigin("j_ankle_ri"));
            playFx(loadFx("env/fire/fx_fire_player_md"), self getTagOrigin("j_ankle_le"));
            earthquake(.15, .2, self getTagOrigin("j_spine4"), 50);
            jetPack--;
            if (self getVelocity()[2] < 300) self setVelocity(self getVelocity() + (0, 0, 60));
        }
        if (jetPack < 100 && !self fragButtonPressed()) jetPack++;
        if (self meleeButtonPressed()) break;
        text setText("JetPack Fuel " + jetPack + "^2/^7100");
        bar updateBar(jetPack / 100);
        bar.bar fadeOverTime(.05);
        bar.bar.color = (1, jetPack / 100, jetPack / 100);
        wait .05;
    }
    bar destroy();
    bar.bar destroy();
    text destroy();
    self unlockMenu();
    self resetInstructions();
}
allWeaponBox() {
    keys = getArrayKeys(level.zombie_weapons);
    if (!isDefined(level.allWeaponsInBox)) {
        level.allWeaponsInBox = true;
        self setOptionColor(self.menu["Select_Color"]);
        for (a = 0; a < keys.size; a++)
            if (keys[a] != "mine_bouncing_betty") level.zombie_weapons[keys[a]].is_in_box = true;
    } else {
        level.allWeaponsInBox = undefined;
        self setOptionColor(self.menu["Menu_Color"]);
        for (a = 0; a < keys.size; a++)
            if (isSubStr(keys[a], "_upgraded") || keys[a] == "defaultweapon" || keys[a] == "zombie_melee" || keys[a] == "walther" || keys[a] == "colt_dirty_harry") level.zombie_weapons[keys[a]].is_in_box = false;
    }
}
moneyGun() {
    if (!isDefined(self.moneyGun)) {
        self setOptionColor(self.menu["Select_Color"], "basic", 45);
        self.moneyGun = true;
        if (isDefined(self.noMoney)) self noMoney();
        self thread doMoneyGun();
    } else {
        self setOptionColor(self.menu["Menu_Color"], "basic", 45);
        self.moneyGun = undefined;
        self notify("MONEY_GUN_OFF");
    }
}
doMoneyGun() {
    self endon("MONEY_GUN_OFF");
    while (isDefined(self.moneyGun)) {
        zoms = getAISpeciesArray("axis", "all");
        for (a = 0; a < zoms.size; a++)
            if (!isDefined(zoms[a].moneyGun) && isDefined(zoms[a]) && zoms[a].health > 0) zoms[a] thread watchForMoney(self);
        wait .05;
    }
}
watchForMoney(player) {
    self.moneyGun = true;
    self thread waitForDeath(player);
    while (isDefined(self)) {
        self waittill("damage", amount, attacker, direction, point, mod);
        if ((isPlayer(attacker) && mod != "MOD_MELEE" && mod != "MOD_GRENADE_SPLASH") && isDefined(attacker.moneyGun)) {
            if (level.zombie_vars["zombie_point_scalar"] == 2 || isDefined(attacker.zombie_point_scalar)) attacker thread add_to_player_score(200);
            else attacker thread add_to_player_score(100);
        }
    }
    self.moneyGun = undefined;
}
waitForDeath(player) {
    self waittill("death");
    if (isDefined(player.moneyGun)) player thread add_to_player_score(150);
}
noMoney() {
    if (!isDefined(self.noMoney)) {
        self.noMoney = true;
        array_thread(getPlayers(), ::arraySetOptionColor, true, "VERI" + self getName() + "_MORE", 5);
        if (isDefined(self.moneyGun)) self thread moneyGun();
        self thread doNoMoney();
    } else {
        self.noMoney = undefined;
        array_thread(getPlayers(), ::arraySetOptionColor, undefined, "VERI" + self getName() + "_MORE", 5);
    }
}
doNoMoney() {
    points = self.score;
    while (isDefined(self.noMoney)) {
        if (self.score > points) self.score = points;
        if (self.score < points) points = self.score;
        wait .05;
    }
}
setCrosshairUi(crosshair) {
    self.Chross_Hair = crosshair;
    self.customCrosshairUi setText(self.Chross_Hair);
}
customCrosshair(crosshair) {
    if (!isDefined(self.customCrosshair)) {
        self setOptionColor(self.menu["Select_Color"]);
        self thread setCrosshair(crosshair);
        self.customCrosshair = true;
        self setClientDvar("cg_drawCrosshair", 0);
        self setPerk("specialty_bulletaccuracy");
        self setClientDvar("perk_weapSpreadMultiplier", ".05");
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.customCrosshair = undefined;
        self notify("customCrosshair_over");
        self.customCrosshairUi destroy();
        self setClientDvar("cg_drawCrosshair", 1);
        if (!isDefined(self.berry_perks_bought) && !isDefined(self.hasSteadyPro)) {
            self setClientDvar("perk_weapSpreadMultiplier", ".65");
            self unSetPerk("specialty_bulletaccuracy");
        }
    }
}
setCrosshair(crosshair) {
    self endon("death");
    self endon("disconnect");
    self endon("customCrosshair_over");
    if (isDefined(self.customCrosshairUi)) {
        self setCrosshairUi(crosshair);
        return;
    } else {
        self.Chross_Hair = crosshair;
        self.customCrosshairUi = self createText(getFont(), 2, "CENTER", "CENTER", 0, 0, 1, 1, self.Chross_Hair);
        while (1) {
            self.customCrosshairUi fadeOverTime(1);
            self.customCrosshairUi.color = (randomInt(255) / 255, randomInt(255) / 255, randomInt(255) / 255);
            wait 1;
        }
    }
}
zombieCounter() {
    if (!isDefined(self.zombieCount)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.zombieCount = true;
        self thread doZombieCounter();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.zombieCount = undefined;
        self notify("zombieCountOver");
    }
}
doZombieCounter() {
    self endon("zombieCountOver");
    counter = self createText(getFont(), 1.25, "TOPLEFT", "TOPLEFT", 10, 10, 1, 1, "");
    counter.label = "^1Zombies Remaining: ";
    counter thread destroyZombieCounter(self);
    while (1) {
        counter setValue(getAIArray("axis").size);
        wait .05;
    }
}
destroyZombieCounter(player) {
    player waittill("zombieCountOver");
    self destroy();
}
purchasePerks() {
    self.givingPerk = true;
    weap = self getCurrentWeapon();
    if (!self hasPerk("specialty_armorvest")) {
        self thread giveMenuPerkO("specialty_armorvest");
        self waittill("ready");
    }
    if (!self hasPerk("specialty_fastreload")) {
        self thread giveMenuPerkO("specialty_fastreload");
        self waittill("ready");
    }
    if (!self hasPerk("specialty_quickrevive")) {
        self thread giveMenuPerkO("specialty_quickrevive");
        self waittill("ready");
    }
    if (!self hasPerk("specialty_rof")) {
        self thread giveMenuPerkO("specialty_rof");
        self waittill("ready");
    }
    self giveWeapon(weap);
    self switchToWeapon(weap);
    self.skybasePerking = undefined;
    self.givingPerk = undefined;
    self.perks_bought = true;
}
giveMenuPerkO(perk, pointer) {
    self.drinking = true;
    weap = self getCurrentWeapon();
    if (self hasPerk(perk)) {
        self notify("ready");
        return;
    }
    if (isDefined(self.is_drinking)) return;
    self.is_drinking = true;
    perkTokens = strTok("specialty_armorvest|specialty_fastreload|specialty_quickrevive|specialty_rof", "|");
    p = undefined;
    if (perk == "specialty_fastreload") p = strTok("mx_speed_sting specialty_fastreload_zombies zombie_perk_bottle_sleight", " ");
    if (perk == "specialty_armorvest") p = strTok("mx_jugger_sting specialty_juggernaut_zombies zombie_perk_bottle_jugg", " ");
    if (perk == "specialty_quickrevive") p = strTok("mx_revive_sting specialty_quickrevive_zombies zombie_perk_bottle_revive", " ");
    if (perk == "specialty_rof") p = strTok("mx_doubletap_sting specialty_doubletap_zombies zombie_perk_bottle_doubletap", " ");
    if (!isDefined(pointer)) pointer = self getPointer();
    array_thread(getPlayers(), ::arraySetOptionColor, true, "VERI" + self getName() + "_PERKS", pointer);
    self setOptionColor(self.menu["Select_Color"], "PERKS", pointer);
    self thread menuPerk_think(perk);
    if (getMap() == "nzp") {
        self.is_drinking = undefined;
        return;
    }
    playSoundAtPosition("bottle_dispense3d", self.origin);
    self disableOffhandWeapons();
    self disableWeaponCycling();
    self allowLean(false);
    self allowAds(false);
    self allowSprint(false);
    self allowProne(false);
    self allowMelee(false);
    self playSound(p[0]);
    self giveWeapon(p[2]);
    self switchToWeapon(p[2]);
    self waittill_any("fake_death", "death", "player_downed", "weapon_change_complete");
    self enableOffhandWeapons();
    self enableWeaponCycling();
    if (!isDefined(self.givingPerk)) self switchToWeapon(weap);
    self takeWeapon(p[2]);
    self thread perkHud(p[1], perk);
    if (self hasAllPerks()) self.perks_bought = true;
    self allowLean(true);
    self allowAds(true);
    self allowSprint(true);
    self allowProne(true);
    self allowMelee(true);
    self setBlur(4, .1);
    wait .1;
    self setBlur(0, .1);
    if (perk == "specialty_armorvest") {
        self.maxhealth = level.zombie_vars["zombie_perk_juggernaut_health"];
        self.health = self.maxhealth;
    }
    if (!isDefined(self.givingPerk)) self waittill("weapon_change_complete");
    self notify("ready");
    self.is_drinking = undefined;
    wait .5;
    self.drinking = false;
}
giveOtherPerk(perk, pointer) {
    if (!isDefined(pointer)) pointer = self getPointer();
    array_thread(getPlayers(), ::arraySetOptionColor, true, "VERI" + self getName() + "_PERKS", pointer);
    self setOptionColor(self.menu["Select_Color"], "PERKS", pointer);
    self setPerk(perk);
    if (perk == "specialty_bulletaccuracy") self setClientDvar("perk_weapSpreadMultiplier", ".60");
    if (perk == "specialty_longersprint") self setMoveSpeedScale(1.2);
}
clearPerks() {
    self thread doClearPerks();
    for (a = 0; a < 12; a++) {
        array_thread(getPlayers(), ::arraySetOptionColor, undefined, "VERI" + self getName() + "_PERKS", a);
        self setOptionColor(self.menu["Menu_Color"], "PERKS", a);
    }
    self setOptionColor(self.menu["Menu_Color"], "EQUIPMENT", 2);
}
doClearPerks() {
    perks = strTok("specialty_fastreload;specialty_armorvest;specialty_quickrevive;specialty_rof;specialty_bulletdamage;specialty_bulletaccuracy;specialty_quieter;specialty_holdbreath;specialty_bulletpenetration;specialty_flak_jacket;specialty_longersprint;specialty_detectexplosive;specialty_altmelee", ";");
    for (a = 0; a < perks.size; a++) self unsetPerk(perks[a]);
    self.has_altmelee = undefined;
    self.perks_bought = undefined;
    self.berry_perks_bought = undefined;
    self.hasStamin = undefined;
    self.hasSteady = undefined;
    self.hasSteadyPro = undefined;
    self setMoveSpeedScale(1);
    self.maxhealth = 100;
    if (getMap() == "nzp") return;
    for (a = 0; a < 4; a++) {
        self.perk_hud[perks[a]] destroy();
        self.perk_hud[perks[a]] = undefined;
    }
    self notify("clear_perks");
}
perkMods() {
    if (!isDefined(level.perkMods)) {
        self setOptionColor(self.menu["Select_Color"]);
        level.perkMods = true;
        self setClientDvar("perk_weapRateMultiplier", "0.01");
        self setClientDvar("perk_weapReloadMultiplier", "0.01");
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        level.perkMods = undefined;
        self setClientDvar("perk_weapRateMultiplier", "0.75");
        self setClientDvar("perk_weapReloadMultiplier", "0.5");
    }
}
hasAllPerks() {
    tok = strTok("specialty_fastreload|specialty_armorvest|specialty_quickrevive|specialty_rof", "|");
    for (a = 0; a < tok.size; a++)
        if (!self hasPerk()) return 0;
    return 1;
}
perkHud(shader, perk) {
    if (getMap() == "nzp" || self hasPerk(perk)) return;
    self setPerk(perk);
    self.perk_hud[perk] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", self.perk_hud.size * 30, -70, 1, 1, (1, 1, 1), shader, 1, 1);
    self.perk_hud[perk] scaleOverTime(.4, 25, 25);
    self thread menuPerk_think(perk);
}
menuPerk_think(perk) {
    self waittill_any("fake_death", "death", "player_downed", "clear_perks");
    self notify("other");
    self.perks_bought = undefined;
    self unsetPerk(perk);
    self.maxhealth = 100;
    self setMoveSpeedScale(1);
    if (getMap() == "nzp") return;
    self.berry_perks_bought = undefined;
    self.deadMoney = undefined;
    self.perk_hudCount = undefined;
    self.perk_hud[perk] destroy();
    self.perk_hud[perk] = undefined;
}
giveBowie() {
    if (self.has_altmelee == true || self hasPerk("specialty_altmelee")) {
        self playlocalsound("deny");
        return;
    }
    array_thread(getPlayers(), ::arraySetOptionColor, true, "VERI" + self getName() + "_PERKS", 11);
    self setOptionColor(self.menu["Select_Color"], "PERKS", 11);
    self setOptionColor(self.menu["Select_Color"], "EQUIPMENT", 2);
    self setPerk("specialty_altmelee");
    self.has_altmelee = true;
    gun = self getCurrentWeapon();
    self disableOffhandWeapons();
    self disableWeaponCycling();
    weapon = "zombie_bowie_flourish";
    self.is_drinking = true;
    self giveWeapon(weapon);
    self switchToWeapon(weapon);
    self playSound("plr_" + self getEntityNumber() + "_vox_bowie_0");
    self waittill_any("fake_death", "death", "player_downed", "weapon_change_complete");
    self takeWeapon(weapon);
    self switchToWeapon(gun);
    self enableOffhandWeapons();
    self enableWeaponCycling();
    self.is_drinking = undefined;
}
discoFog() {
    self notify("FC");
    self endon("FC");
    self.smooth["Fog"] = true;
    while (1) {
        F1 = ((randomIntRange(0, 101) * 2.55) / 255);
        F2 = ((randomIntRange(0, 101) * 2.55) / 255);
        F3 = ((randomIntRange(0, 101) * 2.55) / 255);
        self.menu["Player_Fog_Color"] = (F1, F2, F3);
        self setExpFog(256, 512, F1, F2, F3, .2);
        self setVolFog(165, 835, 200, 75, F1, F2, F3, .2);
        wait .2;
    }
}
doDisco() {
    self notify("FC");
    self endon("FC");
    self.smooth["Fog"] = true;
    while (1) {
        F1 = ((randomIntRange(0, 101) * 2.55) / 255);
        F2 = ((randomIntRange(0, 101) * 2.55) / 255);
        F3 = ((randomIntRange(0, 101) * 2.55) / 255);
        self.menu["Player_Fog_Color"] = (F1, F2, F3);
        self setExpFog(256, 512, F1, F2, F3, .2);
        wait .2;
    }
}
changeToDefault() {
    self notify("FC");
    self.menu["Player_Fog_Color"] = getMapFog();
    self.smooth["Fog"] = undefined;
    if (getMap() == "nzp") self setVolFog(165, 835, 200, 75, 0.5, 0.5, 0.5, 1);
    if (getMap() == "nza") self setVolFog(167, 416, 200, 124, 0.46, 0.38, 0.29, 1);
    if (getMap() == "nzs") self setVolFog(404.39, 1543.52, 460.33, -244.014, 0.65, 0.84, 0.79, 1);
    if (getMap() == "nzf") self setVolFog(440, 3200, 225, 64, 0.533, 0.717, 1, 1);
}
getMapFog() {
    if (getMap() == "nzp") return (0.5, 0.5, 0.5);
    if (getMap() == "nza") return (0.46, 0.38, 0.29);
    if (getMap() == "nzs") return (0.65, 0.84, 0.79);
    if (getMap() == "nzf") return (0.53, 0.71, 1);
    return (0.5, 0.5, 0.5);
}
changeFog(rgb, a) {
    self notify("FC");
    self.smooth["Fog"] = undefined;
    self.menu["Player_Fog_Color"] = (rgb[0], rgb[1], rgb[2]);
    self setExpFog(256, 512, rgb[0], rgb[1], rgb[2], a);
    self setVolFog(165, 835, 200, 75, rgb[0], rgb[1], rgb[2], a);
}
sun(Light, Color, rgb) {
    self notify("sunchange");
    self.smooth["Sun"] = undefined;
    self.menu["Player_Sun_Color"] = (rgb[0], rgb[1], rgb[2]);
    self setClientDvar("r_lightTweakSunLight", Light);
    self setClientDvar("r_lightTweakSunColor", Color);
}
discoSun() {
    if (isDefined(self.smooth["Sun"])) return;
    self endon("sunchange");
    self.smooth["Sun"] = true;
    while (1) {
        S1 = ((randomIntRange(0, 101) * 2.55) / 255);
        S2 = ((randomIntRange(0, 101) * 2.55) / 255);
        S3 = ((randomIntRange(0, 101) * 2.55) / 255);
        self.menu["Player_Sun_Color"] = (S1, S2, S3);
        self setClientDvar("r_lightTweakSunLight", "1.7");
        self setClientDvar("r_lightTweakSunColor", S1 + " " + S2 + " " + S3 + " 1");
        wait .2;
    }
}
weaponNames(gun) {
    guns = strTok("none|dirty|syrette|melee|defaultweapon|walther|tesla|ray_gun|mine_bouncing_betty|flame|schrek|garand_gl|mg42|fg42|30cal|shotgun|rrel_sawed|rrel|type100|thomp|stg|ppsh|mp40|ptrs|granate|molo|m1garand|carbine|gewehr|kar|colt|sw_357|type99|spring|98k_scope|m7|bar|zombie_perk_bottle_sleight|zombie_perk_bottle_jugg|zombie_perk_bottle_revive|zombie_perk_bottle_doubletap", "|");
    proper = strTok("None|Colt Dirty Harry|Syrette|BRAAAINS...|Default Weapon|Walther P38|Wunderwaffe DG-2|Ray Gun|Bouncing Betty|M2 Flamethrower|Panzerschrek|M1 Garand w/ Launcher|MG42|FG42|Browning M1919|M1897 Trench Gun|Sawed-Off Double-Barreled Shotgun w/ Grip|Double-Barreled Shotgun|Type 100|Thompson|STG-44|PPSh-41|MP40|PTRS-41|Stielhandgranate|Moltov|M1 Garand|M1A1 Carbine|Gewehr 43|Kar98k|Colt M1911|.357 Magnum|Arisaka|Springfield|Scoped Kar98k|M1 Garand w/ Launcher|BAR|Speed Cola Bottle|Jugger-Nog Bottle|Quick Revive Bottle|Double-Tap Bottle", "|");
    upgrade = strTok("!|!|!|!|!|!|Wunderwaffe DG-3 JZ|Porter's X2 Ray Gun|!|FIW Nitrogen Cooled|Longinus|The Imploder|Barracuda FU-A11|420 Impeller|B115 Accelerator|Gut Shot|!|24 Bore Long Range|1001 Samurais|Gibs-o-Matic|Spatz-447 +|The Reaper|The Afterburner|The Penetrator|!|!|M1000|Widdershins RC-1|G115 Compressor|Armageddon|C-3000 b1at-ch35|.357 Plus 1 K1l-u|!|!|!|The Imploder|The Widow Maker|!|!|!|!", "|");
    for (a = 0; a < guns.size; a++) {
        if (isSubStr(gun, guns[a]) && isSubStr(gun, "upgraded")) return upgrade[a];
        if (isSubStr(gun, guns[a]) && isSubStr(gun, "bipod")) return "Deployable" + proper[a];
        if (isSubStr(gun, guns[a])) return proper[a];
    }
}
giveMenuWeapon(weapon) {
    if (weapon == "mine_bouncing_betty") self giveBouncingBetty();
    self giveWeapon(weapon);
    self giveMaxAmmo(weapon);
    self switchToWeapon(weapon);
}
giveBouncingBetty() {
    if (!isDefined(self.has_betties) && self.score <= 1000) self.score += 1000;
    trigs = getEntArray("betty_purchase", "targetname");
    for (a = 0; a < trigs.size; a++) trigs[a] notify("trigger", self);
}
physicalWeap() {
    self thread lockMenu("ALL");
    self setInstructions("^2Physical Weapons Menu: ^7[{+attack}]: Scroll Weapons Down - [{+speed_throw}]: Scroll Weapons Up - [{+activate}]: Grab Weapon - [{+melee}]: Exit Physical Weapons Menu");
    self freezeControls(true);
    array = [];
    keys = getArrayKeys(level.zombie_weapons);
    for (a = 0; a < keys.size; a++) array[array.size] = keys[a];
    randy = array_randomize(array);
    self setStance("stand");
    self setPlayerAngles((0, 180, 0));
    tehAngle = self.angles + (0, 90, 0);
    weapon = [];
    for (a = 0; a < 3; a++) weapon[a] = spawnSM(self.origin + (0, 0, 75 - a * 20), getWeaponModel(randy[a]), tehAngle);
    for (a = 0; a < 3; a++) weapon[a] moveX(-70, 1, 1);
    currentWeapon = [];
    for (a = 0; a < 3; a++) currentWeapon[a] = randy[a];
    curs = 0;
    wait 1;
    self endon("disconnect");
    self endon("death");
    while (1) {
        if (self adsButtonPressed() || self attackButtonPressed()) {
            self playLocalSound("grenade_pull_pin");
            oldcurs = curs;
            curs += self adsButtonPressed();
            curs -= self attackButtonPressed();
            if (oldcurs < curs) {
                for (a = 0; a < weapon.size; a++) weapon[a] hide();
                thread createTempWeapon(weapon[0].origin, weapon[0].origin + (-50, 0, 0), weapon[0].model, tehAngle, .5, .25, .25);
                thread createTempWeapon(weapon[1].origin, weapon[1].origin + (0, 0, 20), weapon[1].model, tehAngle, .5, .25, .25);
                thread createTempWeapon(weapon[2].origin, weapon[2].origin + (0, 0, 20), weapon[2].model, tehAngle, .5, .25, .25);
                while (1) {
                    newWeapon = array[randomInt(array.size)];
                    if (newWeapon != currentWeapon[0] && newWeapon != currentWeapon[1] && newWeapon != currentWeapon[2]) break;
                    wait .05;
                }
                thread createTempWeapon(self.origin + (-70, 0, -5), self.origin + (-70, 0, 35), getWeaponModel(newWeapon), tehAngle, .5, .25, .25);
                weapon[0] setModel(weapon[1].model);
                weapon[1] setModel(weapon[2].model);
                weapon[2] setModel(getWeaponModel(newWeapon));
                currentWeapon[0] = currentWeapon[1];
                currentWeapon[1] = currentWeapon[2];
                currentWeapon[2] = newWeapon;
            }
            if (oldcurs > curs) {
                for (a = 0; a < weapon.size; a++) weapon[a] hide();
                thread createTempWeapon(weapon[0].origin, weapon[0].origin + (0, 0, -20), weapon[0].model, tehAngle, .5, .25, .25);
                thread createTempWeapon(weapon[1].origin, weapon[1].origin + (0, 0, -20), weapon[1].model, tehAngle, .5, .25, .25);
                thread createTempWeapon(weapon[2].origin, weapon[2].origin + (-50, 0, 0), weapon[2].model, tehAngle, .5, .25, .25);
                while (1) {
                    newWeapon = array[randomInt(array.size)];
                    if (newWeapon != currentWeapon[0] && newWeapon != currentWeapon[1] && newWeapon != currentWeapon[2]) break;
                    wait .05;
                }
                thread createTempWeapon(self.origin + (-70, 0, 105), self.origin + (-70, 0, 75), getWeaponModel(newWeapon), tehAngle, .5, .25, .25);
                weapon[2] setModel(weapon[1].model);
                weapon[1] setModel(weapon[0].model);
                weapon[0] setModel(getWeaponModel(newWeapon));
                currentWeapon[2] = currentWeapon[1];
                currentWeapon[1] = currentWeapon[0];
                currentWeapon[0] = newWeapon;
            }
            wait .5;
            for (a = 0; a < weapon.size; a++) weapon[a] show();
            if (curs < 0) curs = array.size - 1;
            if (curs > array.size - 1) curs = 0;
        }
        if (self useButtonPressed()) {
            self playLocalSound("cha_ching");
            sWeapon = currentWeapon[1];
            if (sweapon == "zombie_cymbal_monkey") self thread monkeyBomb();
            else if (sweapon == "mine_bouncing_betty") self thread giveBouncinBet();
            else self giveWeapon(sWeapon);
            self giveMaxAmmo(sWeapon);
            self switchToWeapon(sWeapon);
            weapon[1] moveX(60, 1, 1);
            wait 1;
            break;
        }
        if (self meleeButtonPressed()) {
            self playLocalSound("packa_deny");
            weapon[0] moveTo(weapon[0].origin + (0, 0, -70), .5, .25, .25);
            weapon[1] moveTo(weapon[1].origin + (0, 0, -70), .5, .25, .25);
            weapon[2] moveTo(weapon[2].origin + (0, 0, -70), .5, .25, .25);
            wait .45;
            break;
        }
        wait 0.05;
    }
    for (a = 0; a < weapon.size; a++) weapon[a] remove();
    self freezeControls(false);
    self resetInstructions();
    self unlockMenu();
}
createTempWeapon(startPos, endPos, model, angles, time, de, ac) {
    weapon = spawnSM(startPos, model, angles);
    weapon moveTo(endPos, time, de, ac);
    weapon waittill("movedone");
    weapon remove();
}
randomWeapon() {
    list = getArrayKeys(level.zombie_weapons);
    self playLocalSound("lid_open");
    self notify("close_menu");
    self playLocalSound("music_box");
    self iPrintlnBold("^5Please Wait...");
    self iPrintlnBold("^6Lets Hope You Dont Get The Teddy Bear! LOL");
    self iPrintlnBold("^4Sometimes it gives you GREYNAADAAS!");
    wait 5;
    weapon = randomInt(list.size);
    if (isSubStr(weapon, "mine")) self thread giveBouncinBet();
    else if (isSubStr(weapon, "cymbal")) self thread treasure_chest_give_weapon("zombie_cymbal_monkey");
    else self giveWeapon(list[weapon], 0);
    self switchToWeapon(list[weapon]);
    self playLocalSound("lid_close");
}
giveMolotovs(temp, cost) {
    self giveWeapon("molotov", 4);
}
giveFragGrenades(temp, cost) {
    self giveWeapon("fraggrenade", 4);
}
giveBouncinBet() {
    giveMenuWeapon("mine_bouncing_betty");
}
monkeyBomb() {
    self thread treasure_chest_give_weapon("zombie_cymbal_monkey");
}
giveAllGuns() {
    self.giveAllWeapons = true;
    self setOptionColor(self.menu["Select_Color"], "basic", 3);
    keys = getArrayKeys(level.zombie_weapons);
    extra = strTok("defaultweapon|zombie_melee|walther|colt_dirty_harry", "|");
    for (e = 0; e < extra.size; e++) keys[keys.size] = extra[e];
    for (e = 0; e < keys.size; e++)
        if (keys[e] != "molotov" && keys[e] != "zombie_cymbal_monkey") self giveWeapon(keys[e]);
    self switchToWeapon(keys[0]);
}
awsomeVision() {
    if (!isDefined(self.awsomeVision)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.awsomeVision = true;
        self setClientDvar("cg_fov", "160");
        self setClientDvar("cg_gun_x", "4");
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.awsomeVision = undefined;
        self setClientDvar("cg_fov", "65");
        self setClientDvar("cg_gun_x", "0");
    }
}
chromeVision() {
    if (!isDefined(self.chromeVision)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.chromeVision = true;
        self setClientDvar("r_specularMap", "2");
        self setClientDvar("r_specularColorScale", "100");
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.chromeVision = undefined;
        self setClientDvar("r_specularMap", "1");
        self setClientDvar("r_specularColorScale", "1");
    }
}
flameVision() {
    if (!isDefined(self.fireVision)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.fireVision = true;
        self visionSetNaked("default", 1.5);
        self setClientDvar("r_flamefx_enable", "1");
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.fireVision = undefined;
        self setClientDvar("r_flamefx_enable", "0");
    }
}
normalVision() {
    self setVision("default");
    self setClientDvar("r_flamefx_enable", "0");
    self setClientDvar("r_specularMap", "1");
    self setClientDvar("r_specularColorScale", "1");
    self setClientDvar("cg_fov", "65");
    self setClientDvar("cg_gun_x", "0");
}
setVision(vision, time, variable) {
    if (isDefined(variable)) self.visionVariable = variable;
    timer = 1.5;
    if (isDefined(time)) timer = time;
    if (vision == "default") {
        self.awsomeVision = undefined;
        self setOptionColor(self.menu["Menu_Color"], "vis", 1);
        self.chromeVision = undefined;
        self setOptionColor(self.menu["Menu_Color"], "vis", 2);
        self.fireVision = undefined;
        self setOptionColor(self.menu["Menu_Color"], "vis", 3);
        if (getMap() == "nzp") self visionSetNaked("zombie", timer);
        if (getMap() == "nza") self visionSetNaked("zombie_asylum", timer);
        if (getMap() == "nzs") self visionSetNaked("zombie_sumpf", timer);
        if (getMap() == "nzf") self visionSetNaked("zombie_factory", timer);
        if (getMap() == "cred") self visionSetNaked("zombie_factory", timer);
    } else self visionSetNaked(vision, timer);
}
saveVision() {
    self setSavedVariable("151", self.visionVariable);
    self setSavedVariable("152", 3);
    if (isConsole()) updateGamerProfile();
}
openAllDoors() {
    if (isDefined(level.Doors_Opened_Once)) return;
    level.Doors_Opened_Once = true;
    door = getEntArray("zombie_door", "targetname");
    debris = getEntArray("zombie_debris", "targetname");
    if (getMap() == "nzp") {
        door[0] thread open_door(true);
        debris[1] thread open_debris(true);
        debris[2] thread open_debris(true);
    }
    if (getMap() == "nza") {
        array = [];
        index = strTok("0 2 4 5 7 8", " ");
        for (a = 0; a < index.size; a++) array[array.size] = door[int(index[a])];
        array_thread(array, ::open_door, true);
        debris[1] thread open_debris(true);
        debris[2] thread open_debris(true);
    }
    if (getMap() == "nzs") {
        door[0] thread open_door(true);
        debris[0] thread open_debris(true);
        doubleDoor = getEntArray("zombie_double_door", "targetname");
        array_thread(doubleDoor, ::open_door, true);
    }
    if (getMap() == "nzf") {
        array_thread(door, ::open_door, true);
        array_thread(debris, ::open_debris, true);
    }
}
open_door(isSound) {
    if (getMap() == "nzf") {
        for (a = 0; a < self.doors.size; a++) {
            self.doors[a] notSolid();
            self.doors[a] connectPaths();
            if (isDefined(self.doors[a].door_moving)) continue;
            self.doors[a].door_moving = 1;
            if ((isDefined(self.doors[a].script_noteworthy) && self.doors[a].script_noteworthy == "clip") || (isDefined(self.doors[a].script_string) && self.doors[a].script_string == "clip")) continue;
            if (isDefined(isSound)) {
                if (isDefined(self.doors[a].script_sound)) playSoundAtPosition(self.doors[a].script_sound, self.doors[a].origin);
                else playSoundAtPosition("door_slide_open", self.doors[a].origin);
            }
            time = 1;
            if (isDefined(self.doors[a].script_transition_time)) time = self.doors[a].script_transition_time;
            if (isDefined(self.doors[a].script_vector)) {
                self.doors[a] moveTo(self.doors[a].origin + self.doors[a].script_vector, time, time * .25, time * .25);
                self.doors[a] thread door_solid_thread();
            }
            wait(randomfloat(.15));
            if (isDefined(isSound))
                if (a == 0) playSoundAtPosition("purchase", self.doors[a].origin);
            if (isDefined(self.doors[a].target)) self.doors[a] add_new_zombie_spawners();
        }
        if (isDefined(self.script_flag)) flag_set(self.script_flag);
        all_trigs = getEntArray(self.target, "target");
        array_thread(all_trigs, ::trigger_off);
    } else {
        if (isDefined(self.hinges)) {
            for (a = 0; a < self.doors.size; a++) {
                self.doors[a] connectPaths();
                if (isDefined(isSound)) playSoundAtPosition("door_rotate_open", self.doors[a].origin);
            }
            playSoundAtPosition("purchase", self.doors[0].origin);
            for (a = 0; a < self.hinges.size; a++) {
                struct = getStruct(self.hinges[a].script_linkto, "script_linkname");
                self.hinges[a] thread swing_door(struct);
            }
            if (isDefined(self.script_flag)) flag_set(self.script_flag);
            all_trigs = getEntArray(self.target, "target");
            array_thread(all_trigs, ::trigger_off);
            if (isDefined(self.clip)) self.clip remove();
        } else {
            self.door connectPaths();
            if (isDefined(isSound)) playSoundAtPosition("purchase", self.door.origin);
            if (self.type == "move") {
                self.door notSolid();
                time = 1;
                if (isDefined(self.door.script_transition_time)) time = self.door.script_transition_time;
                if (isDefined(isSound)) playSoundAtPosition("door_slide_open", self.door.origin);
                self.door moveTo(self.door.origin + self.door.script_vector, time, time * .25, time * .25);
                self.door thread door_solid_thread();
            } else if (self.type == "slide_apart") {
                for (a = 0; a < self.doors.size; a++) {
                    self.doors[a] notSolid();
                    time = 1;
                    if (isDefined(self.doors[a].script_transition_time)) time = self.doors[a].script_transition_time;
                    playSoundAtPosition("door_slide_open", self.doors[a].origin);
                    if (isDefined(self.clip))
                        if (self.clip == self.doors[a]) self.doors[a] connectPaths();
                        else self.doors[a] connectPaths();
                    if (isDefined(self.doors[a].script_vector)) {
                        self.doors[a] moveTo(self.doors[a].origin + self.doors[a].script_vector, time, time * .25, time * .25);
                        self.doors[a] thread door_solid_thread();
                    }
                    wait(randomfloat(.15));
                }
            }
            if (isDefined(self.door.target)) self.door add_new_zombie_spawners();
            if (isDefined(self.script_flag)) flag_set(self.script_flag);
            all_trigs = getEntArray(self.target, "target");
            array_thread(all_trigs, ::trigger_off);
        }
    }
}
door_solid_thread(skip) {
    if (!isDefined(skip)) self waittill_either("rotatedone", "movedone");
    else wait .1;
    while (1) {
        plr = getPlayers();
        player_touching = false;
        for (a = 0; a < plr.size; a++) {
            if (plr[a] isTouching(self)) {
                player_touching = true;
                break;
            }
        }
        if (!player_touching) {
            self solid();
            return;
        }
        wait 1;
    }
}
add_new_zombie_spawners() {
    if (isDefined(self.target)) self.possible_spawners = getentarray(self.target, "targetname");
    if (isDefined(self.script_string)) {
        spawners = getEntArray(self.script_string, "targetname");
        self.possible_spawners = array_combine(self.possible_spawners, spawners);
    }
    if (!isDefined(self.possible_spawners)) return;
    zombies_to_add = self.possible_spawners;
    for (a = 0; a < self.possible_spawners.size; a++) {
        self.possible_spawners[a].locked_spawner = false;
        add_spawner(self.possible_spawners[a]);
    }
}
add_spawner(spawner) {
    if (isDefined(spawner.script_start) && level.round_number < spawner.script_start) return;
    if (isDefined(spawner.locked_spawner) && spawner.locked_spawner) return;
    if (isDefined(spawner.has_been_added) && spawner.has_been_added) return;
    spawner.has_been_added = true;
    level.enemy_spawns[level.enemy_spawns.size] = spawner;
}
swing_door(struct) {
    time = .5;
    if (isDefined(self.script_transition_time)) time = self.script_transition_time;
    self moveTo(struct.origin, time, time * .5);
    self rotateTo(struct.angles, time * .75);
    self waittill("movedone");
    self remove();
}
open_debris(isSound) {
    junk = getEntArray(self.target, "targetname");
    trigs = getEntArray(self.target, "target");
    if (isDefined(self.script_flag)) flag_set(self.script_flag);
    if (isDefined(isSound)) playSoundAtPosition("purchase", self.origin);
    move_ent = undefined;
    clip = undefined;
    array_thread(trigs, ::trigger_off);
    for (a = 0; a < trigs.size; a++) junk[a].trig trigger_off();
    for (a = 0; a < junk.size; a++) {
        junk[a] connectPaths();
        junk[a] add_new_zombie_spawners();
        level notify("junk purchased");
        junk[a].debris_moving = 1;
        if (isDefined(junk[a].script_noteworthy))
            if (junk[a].script_noteworthy == "clip") {
                clip = junk[a];
                continue;
            }
        if (isDefined(junk[a].script_linkTo)) {
            move_ent = junk[a];
            junk[a] thread debris_move(isSound);
        } else junk[a] notSolid();
    }
    if (isDefined(clip)) {
        if (isDefined(move_ent)) {
            move_ent waittill("movedone");
            move_ent notSolid();
        }
        clip notSolid();
    }
}
debris_move(isSound) {
    struct = getStruct(self.script_linkTo, "script_linkname");
    self script_delay();
    self notSolid();
    if (isDefined(isSound)) {
        self playSound("debris_move");
        playSoundAtPosition("lightning_l", self.origin);
    }
    if (isDefined(self.script_firefx)) playFx(level._effect[self.script_firefx], self.origin);
    og_angles = self.angles;
    if (isDefined(self.script_noteworthy))
        if (self.script_noteworthy == "jiggle") {
            num = randomIntRange(3, 5);
            for (m = 0; m < num; m++) {
                angles = og_angles + (-5 + randomFloat(10), -5 + randomFloat(10), -5 + randomFloat(10));
                time = randomFloatRange(.1, .4);
                self rotateTo(angles, time);
                wait(time - .05);
            }
        }
    time = .5;
    if (isDefined(self.script_transition_time)) time = self.script_transition_time;
    self moveTo(struct.origin, time, time * .5);
    self rotateTo(struct.angles, time * .75);
    self waittill("movedone");
    if (isDefined(isSound)) self playSound("couch_slam");
    if (isDefined(self.script_fxid)) {
        playFx(level._effect[self.script_fxid], self.origin);
        if (isDefined(isSound)) playSoundAtPosition("zombie_spawn", self.origin);
    }
    self hide();
}
solidWhenDone() {
    self waittill_either("rotatedone", "movedone");
    self solid();
}
activateTraps(alt) {
    player = self;
    if (isDefined(alt)) player = alt;
    score = player.score;
    player add_to_player_score(6000);
    if (getMap() == "nza") {
        trap = getEntArray("gas_access", "targetname");
        for (a = 0; a < trap.size; a++) trap[a] notify("trigger", player);
    }
    if (getMap() == "nzs") {
        traps = strTok("elec_trap_trig;pendulum_buy_trigger", ";");
        for (a = 0; a < traps.size; a++) {
            trappy = getEntArray(traps[a], "targetname");
            for (e = 0; e < trappy.size; e++) trappy[e] notify("trigger", player);
        }
    }
    if (getMap() == "nzf") {
        traps = strTok("warehouse_electric_trap;wuen_electric_trap;bridge_electric_trap", ";");
        for (a = 0; a < traps.size; a++) {
            trappy = getEntArray(traps[a], "targetname");
            for (e = 0; e < trappy.size; e++) trappy[e] notify("trigger", player);
        }
    }
    if (isSurv()) {
        level.additionTrigs["teethTrap"] notify("trigger", player, 1);
        wait 1;
        level.additionTrigs["knifeTrap"] notify("trigger", player, 1);
        wait 1;
        level.additionTrigs["smelt"] notify("trigger", player, 1);
        wait 1;
        level.additionTrigs["teslaTrap"] notify("trigger", player, 1);
        wait 1;
        for (a = 0; a < 4; a++) level.additionTrigs["bomb" + a] notify("trigger", player, 1);
        wait 1;
    }
    player.score = score;
    player set_player_score_hud();
}
survivalDoors() {
    if (isDefined(level.Doors_Opened_Once)) return;
    level.Doors_Opened_Once = true;
    door = getEntArray("zombie_door", "targetname");
    array_thread(door, ::doorOpen, true);
    debris = getEntArray("zombie_debris", "targetname");
    array_thread(debris, ::open_debris, true);
    getPlayers()[0] activatePower();
}
doorOpen(move) {
    for (a = 0; a < self.doors.size; a++) {
        self.doors[a] notSolid();
        self.doors[a] connectPaths();
        if (isDefined(self.doors[a].door_moving)) continue;
        self.doors[a].door_moving = 1;
        time = 1;
        if (isDefined(self.doors[a].script_transition_time)) time = self.doors[a].script_transition_time;
        if (isDefined(move))
            if (isDefined(self.doors[a].script_vector)) {
                self.doors[a] moveTo(self.doors[a].origin + self.doors[a].script_vector, time, time * .25, time * .25);
                self.doors[a] thread solidWhenDone();
            }
    }
    if (isDefined(self.script_flag)) flag_set(self.script_flag);
    allTrigs = getEntArray(self.target, "target");
    for (a = 0; a < allTrigs.size; a++) allTrigs[a] trigger_off();
}
solidDoor() {
    if (isSolo()) wait .05;
    self solid();
}
unSolidifyFactoryDoors() {
    if (!isDefined(level.Doors_Opened_Once) || getMap() != "nzf") return;
    door = getEntArray("zombie_door", "targetname");
    for (a = 0; a < door.size; a++)
        for (b = 0; b < door[a].doors.size; b++) door[a].doors[b] notSolid();
}
forceHost() {
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "ADMIN", self getPointer());
    setDvar("scr_forcerankedmatch", 1);
    setDvar("onlinegame", 1);
    self setClientDvar("party_hostname", self.playername);
    self setClientDvar("sv_hostname", self.playername);
    self setClientDvar("ui_hostname", self.playername);
    self setClientDvar("party_iamhost", 1);
    self setClientDvar("party_host", 1);
    self setClientDvar("ui_hostOptionsEnabled", 1);
    self setClientDvar("party_connectToOthers", 0);
    self setClientDvar("party_hostmigration", 0);
    self setClientDvar("party_connectTimeout", 0);
    self setClientDvar("cg_drawversion", 0);
    self setClientDvar("cg_drawSnapshotTime", 0);
    self iPrintln("Force Host [^2ON^7]");
}
instaKill() {
    if (!level.zombie_vars["zombie_insta_kill"]) {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "ADMIN", self getPointer());
        level.zombie_vars["zombie_insta_kill"] = 1;
    } else {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "ADMIN", self getPointer());
        level.zombie_vars["zombie_insta_kill"] = 0;
    }
}
doublePoints() {
    if (level.zombie_vars["zombie_point_scalar"] == 1) {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "ADMIN", self getPointer());
        level.zombie_vars["zombie_point_scalar"] = 2;
    } else {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "ADMIN", self getPointer());
        level.zombie_vars["zombie_point_scalar"] = 1;
    }
}
disableZombiePoints() {
    if (!isDefined(level.disableZomPts)) {
        level.disableZomPts = true;
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "ADMIN", self getPointer());
        while (isDefined(level.disableZomPts)) {
            level.zombie_vars["zombie_point_scalar"] = 0;
            wait .05;
        }
    } else {
        level.disableZomPts = undefined;
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "ADMIN", self getPointer());
        level.zombie_vars["zombie_point_scalar"] = 1;
    }
}
mexicanWave() {
    if (!isDefined(level.mexicanWave)) level.mexicanWave = [];
    if (isDefined(level.mexicanWaveSpawned)) return;
    if (isDefined(level.mexicanWave[9])) {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "ADMIN", self getPointer());
        for (a = 0; a < 10; a++) level.mexicanWave[a] remove();
        return;
    }
    level.mexicanWaveSpawned = true;
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "ADMIN", self getPointer());
    for (a = 0; a < 10; a++) level.mexicanWave[a] = spawnSM((154, -150 - a * 25, -2.875), "defaultactor", (0, 180, 0));
    level.mexicanWaveSpawned = undefined;
    for (a = 0; a < level.mexicanWave.size; a++) {
        level.mexicanWave[a] thread mexicanMove();
        wait .1;
    }
}
mexicanMove() {
    while (isDefined(self)) {
        self moveZ(80, 1, .2, .4);
        wait 1;
        self moveZ(-80, 1, .2, .4);
        wait 1;
    }
}
startLobbyTimer() {
    if (!isDefined(level.lobbyTimerTime)) {
        self iPrintLn("Please Set The Timer First!");
        return;
    }
    if (isDefined(level.lobbyTimerIsSet)) self iPrintLn("Timed Lobby Already Set!");
    if (!isDefined(level.lobbyTimerIsSet)) {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "ADMIN", self.menu["ADMIN_POINTER"]);
        level.lobbyTimerIsSet = true;
        for (a = 0; a < getPlayers().size; a++)
            if (getPlayers()[a] thread getCurrentMenu() == "ADMIN" || getPlayers()[a] thread getCurrentMenu() == "TIMER" || getPlayers()[a] thread getCurrentMenu() == "setTimer") getPlayers()[a] thread backNewMenu("ADMIN");
        level.timerSet = true;
        text = createServerText(getFont(), 1.5, "LEFT", "BOTTOM", -320, -80, 1, 1, "Lobby Ends In:");
        time = createServerText(getFont(), 1.5, "LEFT", "BOTTOM", -320, -60, 1, 1, undefined);
        time setTimer(level.lobbyTimerTime * 60);
        wait(level.lobbyTimerTime * 60);
        text destroy();
        time destroy();
        exitLevel();
    }
}
setLobbyTimer(time) {
    level.lobbyTimer = "^2" + time + " Minutes";
    self thread updateMenu("Set Timer [" + level.lobbyTimer + "^7]", "TIMER", 0);
    level.lobbyTimerTime = time;
    self iPrintLn("Timer Set To: ^2" + time + " Minutes");
}
fixDebris() {
    door = getEntArray("zombie_door", "targetname");
    debris = getEntArray("zombie_debris", "targetname");
    array_thread(door, ::saveSolidOrigin, "DOOR");
    array_thread(debris, ::saveSolidOrigin, "DEBRIS");
    array_thread(debris, ::doFixDebris);
}
fix_Door() {
    self notSolid();
    if (isDefined(self.script_vector)) self thread door_solid_thread(true);
    self.angles = self.savedAngles;
    if (isDefined(self.door_moving)) self.origin = self.newOrigin;
    else self.origin = self.savedOrigin;
    wait .1;
    self show();
}
saveSolidOrigin(type) {
    if (type == "DEBRIS") {
        junk = getEntArray(self.target, "targetname");
        for (a = 0; a < junk.size; a++) {
            struct = getStruct(junk[a].script_linkTo, "script_linkname");
            junk[a].savedOrigin = junk[a].origin;
            junk[a].savedAngles = junk[a].angles;
            junk[a].savedStructOrigin = struct.origin;
            junk[a].savedStructAngles = struct.angles;
        }
    } else {
        for (a = 0; a < self.doors.size; a++) {
            self.doors[a].savedAngles = self.doors[a].angles;
            self.doors[a].savedOrigin = self.doors[a].origin;
            self.doors[a].newOrigin = self.doors[a].savedOrigin + self.doors[a].script_vector;
        }
    }
}
doFixDebris() {
    trigs = getEntArray(self.target, "target");
    junk = getEntArray(self.target, "targetname");
    for (a = 0; a < trigs.size; a++) {
        junk[a].trig = spawnTrigger(trigs[a].origin, 90);
        junk[a].trig setString("Press & hold [{+activate}] to Clear Debris [Cost: 1000]");
        junk[a].trig thread doFixDebrisThink(self);
    }
    array_thread(trigs, ::trigger_off);
    self thread watchForOpen();
    self waittill("Debris");
    for (a = 0; a < trigs.size; a++)
        if (isDefined(junk[a].trig)) junk[a].trig remove();
}
watchForOpen() {
    self endon("Debris");
    while (1) {
        if (isDefined(level.Doors_Opened_Once)) break;
        wait .5;
    }
    self notify("Debris");
}
doFixDebrisThink(d) {
    while (1) {
        self waittill("trigger", i);
        count = 0;
        while (i useButtonPressed() && isValidPlayer(i)) {
            if (i useButtonPressed() && count >= .4) {
                if (i.score >= 1000) {
                    i minus_to_player_score(1000);
                    count = undefined;
                    break;
                }
            }
            count += .05;
            wait .05;
        }
        if (!isDefined(count)) break;
    }
    d thread open_debris(true);
    d notify("Debris");
}
activatePower() {
    getEnt("use_master_switch", "targetname") notify("trigger", self);
    getEnt("use_power_switch", "targetname") notify("trigger", self);
    getEnt("zip_lever_trigger", "targetname") notify("trigger", self);
}
doFlyTrap() {
    if (isDefined(level.flyTrap) || self getMap() != "nzf") return;
    level.flyTrap = true;
    weap = self getCurrentWeapon();
    if (!isSubStr(weap, "upgraded")) {
        self giveWeapon("ray_gun_upgraded");
        self switchToWeapon("ray_gun_upgraded");
        wait .5;
    }
    getEnt("trig_ee_flytrap", "targetname") notify("damage", undefined, self);
}
linkTeles() {
    for (a = 0; a < 3; a++) {
        getEnt("trigger_teleport_pad_" + a, "targetname") notify("trigger");
        wait .3;
    }
    wait .05;
    getEntArray("trigger_teleport_core", "targetname")[0] notify("trigger");
}
jet_start() {
    origin = self.origin + (20, 10, 0);
    self thread jet_fly();
    self thread jet_shake(origin);
    wait 1.5;
    self notify("JET_START_OVER");
}
jet_fly() {
    self endon("JET_START_OVER");
    while (true) {
        self setWaterSheeting(true);
        self setWaterDrops(200);
        self setVelocity(self getVelocity() + (0, 0, 60));
        playFxOnTag(loadfx("bio/player/fx_footstep_water"), self, "j_ankle_le");
        playFxOnTag(loadfx("bio/player/fx_footstep_water"), self, "j_ankle_ri");
        playFxOnTag(loadfx("bio/player/fx_footstep_water"), self, "j_ankle_le");
        playFxOnTag(loadfx("bio/player/fx_footstep_water"), self, "j_ankle_ri");
        self setWaterSheeting(false);
        self setWaterDrops(0);
        wait .05;
    }
}
jet_shake(origin) {
    earthquake(1.0, 0.41, origin, 65);
    earthquake(1.0, 0.41, origin + (0, 0, 65), 65);
    earthquake(1.0, 0.41, origin + (0, 0, 130), 65);
    earthquake(1.0, 0.41, origin + (0, 0, 195), 65);
    playFx(loadfx("maps/zombie/fx_zombie_body_wtr_burst"), origin);
    playFx(loadfx("maps/zombie/fx_zombie_body_wtr_billowing"), origin);
    playFx(loadfx("maps/zombie/fx_zombie_body_wtr_falling"), origin);
    playFx(loadfx("maps/zombie/fx_zombie_body_wtr_burst"), origin);
    playFx(loadfx("maps/zombie/fx_zombie_body_wtr_billowing"), origin);
    playFx(loadfx("maps/zombie/fx_zombie_body_wtr_falling"), origin);
}
moddedDvars() {
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread modDvars();
}
modDvars() {
    self thread arraySetOptionColor(true, "RESET", 1);
    self thread arraySetOptionColor(undefined, "RESET", 0);
    self thread arraySetOptionColor(true, "SERVER", 11);
    level.uSprint = undefined;
    self thread arraySetOptionColor(true, "SERVER", 12);
    level.unlimitedAmmo = undefined;
    self thread unlimitedAmmoAll();
    self thread unlimitedSprint();
    self setClientDvar("sv_cheats", "1");
    self setClientDvar("superuser", "1");
    self setClientDvar("developeruser", "1");
    self setClientDvar("cg_ufo_scaler", "3");
    self setClientDvar("cg_scoreboardMyColor", "1 0 0 1");
    self setClientDvar("lowAmmoWarningColor2", "1 0 0 1");
    self setClientDvar("lowAmmoWarningNoAmmoColor1", "0 0 1 1");
    self setClientDvar("lowAmmoWarningNoAmmoColor2", "1 0 0 1");
    self setClientDvar("lowAmmoWarningNoReloadColor1", "0 0 1 1");
    self setClientDvar("lowAmmoWarningNoReloadColor2", "1 0 0 1");
    self setClientDvar("dynEnt_explodeForce", "99999");
    self setClientDvar("cg_overheadNamesFarDist", "2048");
    self setClientDvar("cg_overheadNamesFarScale", ".7");
    self setClientDvar("cg_overheadNamesMaxDist", "999999");
    self setClientDvar("cg_overheadNamesNearDist", "100");
    self setClientDvar("cg_overheadNamesSize", ".7");
    self setClientDvar("cg_drawThroughWalls", "1");
    self setClientDvar("phys_gravity", "-160");
    self setClientDvar("player_burstFireCooldown", "0");
    self setClientDvar("Revive_Trigger_Radius", "99999");
    self setClientDvar("player_lastStandBleedoutTime", "400");
    self setClientDvar("timescale", "1");
    self setClientDvars("jump_height", 1000, "g_gravity", 120, "player_sprintUnlimited", 1, "player_sustainAmmo", 1, "bg_fallDamageMinHeight", 999, "bg_fallDamageMaxHeight", 1000, "player_sprintCameraBob", .2, "player_sprintSpeedScale", 2, "player_meleeRange", 1000, "r_specularMap", 2, "bg_prone_yawcap", 360, "cg_scoreboardPingText", 1);
}
doFlashyDvars() {
    self endon("disconnect");
    self endon("death");
    randy = [];
    while (1) {
        for (a = 0; a < 4; a++) {
            for (e = 0; e < 3; e++) randy[e] = (randomInt(100) / 100);
            self setClientDvar("cg_scoresColor_Gamertag_" + a, randy[0] + "" + randy[1] + "" + randy[2] + "1");
            self setClientDvar("cg_scoresColor_Player_" + a, randy[0] + "" + randy[1] + "" + randy[2] + "1");
        }
        wait .1;
    }
}
doFlashyScoreBar() {
    a = "cg_ScoresColor_Zombie";
    for (;;) {
        self setClientDvar(a, "1 0 0 1");
        wait .1;
        self setClientDvar(a, "0 1 0 1");
        wait .1;
        self setClientDvar(a, "0 0 1 1");
        wait .1;
        self setClientDvar(a, "1 0 1 1");
        wait .1;
        self setClientDvar(a, "0 1 1 1");
        wait .1;
        self setClientDvar(a, "1 0 0 0");
        wait .1;
        self setClientDvar(a, "0 1 0 0");
        wait .1;
        self setClientDvar(a, "0 0 1 0");
        wait .1;
        self setClientDvar(a, "0 0 0 1");
        wait .1;
    }
}
infectionMenu(infection) {
    switch (infection) {
    case "Aimbot":
        self setClientDvar("aim_autoaim_debug", "1");
        self setClientDvar("aim_autoaim_enabled", "1");
        self setClientDvar("aim_autoaim_lerp", "100");
        self setClientDvar("aim_autoaim_region_height", "640");
        self setClientDvar("aim_autoaim_region_width", "640");
        self setClientDvar("aim_autoAimRangeScale", "5");
        self setClientDvar("aim_lockon_debug", "1");
        self setClientDvar("aim_lockon_enabled", "1");
        self setClientDvar("aim_lockon_region_height", "1386");
        self setClientDvar("aim_lockon_region_width", "0");
        self setClientDvar("aim_lockon_strength", "6");
        self setClientDvar("aim_lockon_deflection", "0.05");
        self setClientDvar("aim_input_graph_debug", "1");
        self setClientDvar("aim_input_graph_enabled", "1");
        self setClientDvar("cg_enemyNameFadeOut", "100");
        self setClientDvar("cg_enemyNameFadeIn", "0");
        setDvar("aim_autoaim_debug", "1");
        setDvar("aim_autoaim_enabled", "1");
        setDvar("aim_autoaim_lerp", "100");
        setDvar("aim_autoaim_region_height", "640");
        setDvar("aim_autoaim_region_width", "640");
        setDvar("aim_autoAimRangeScale", "5");
        setDvar("aim_lockon_debug", "1");
        setDvar("aim_lockon_enabled", "1");
        setDvar("aim_lockon_region_height", "1386");
        setDvar("aim_lockon_region_width", "0");
        setDvar("aim_lockon_strength", "6");
        setDvar("aim_lockon_deflection", "0.05");
        setDvar("aim_input_graph_debug", "1");
        setDvar("aim_input_graph_enabled", "1");
        setDvar("cg_enemyNameFadeOut", "100");
        setDvar("cg_enemyNameFadeIn", "0");
        break;
    case "Colored Reload":
        self setClientDvar("lowAmmoWarningColor2", "1 0 0 1");
        self setClientDvar("lowAmmoWarningNoAmmoColor1", "0 0 1 1");
        self setClientDvar("lowAmmoWarningNoAmmoColor2", "1 0 0 1");
        self setClientDvar("lowAmmoWarningNoReloadColor1", "0 0 1 1");
        self setClientDvar("lowAmmoWarningNoReloadColor2", "1 0 0 1");
        break;
    case "PC Graphics":
        self setClientDvar("scr_art_tweak", "1");
        self setClientDvar("scr_art_tweak_message", "1");
        self setClientDvar("r_glowUseTweaks", "1");
        self setClientDvar("r_filmUseTweaks", "1");
        self setClientDvar("r_filmusetweaks", "1");
        self setClientDvar("r_filmtweakenable", "1");
        self setClientDvar("r_filmtweakdarktint", "1.27 1.35 1.25");
        self setClientDvar("r_filmtweaklighttint", "1 1 1");
        self setClientDvar("r_filmtweakcontrast", "1.6");
        self setClientDvar("r_filmtweakdesaturation", "0");
        self setClientDvar("r_filmtweakbrightness", "0.12");
        self setClientDvar("r_lighttweaksunlight", "1.57");
        break;
    case "Extended Knife Range":
        self setClientDvar("aim_automelee_debug", "1");
        self setClientDvar("aim_automelee_enabled", "1");
        self setClientDvar("aim_automelee_lerp", "100");
        self setClientDvar("aim_automelee_maxpitch", "80");
        self setClientDvar("aim_automelee_range", "255");
        self setClientDvar("aim_automelee_region_height", "480");
        self setClientDvar("aim_automelee_region_width", "640");
        setDvar("aim_automelee_debug", "1");
        setDvar("aim_automelee_enabled", "1");
        setDvar("aim_automelee_lerp", "100");
        setDvar("aim_automelee_maxpitch", "80");
        setDvar("aim_automelee_range", "255");
        setDvar("aim_automelee_region_height", "480");
        setDvar("aim_automelee_region_width", "640");
        break;
    case "Scoreboard Color":
        self setClientDvar("cg_overheadNamesGlow", "1 0 0 1");
        self setClientDvar("cg_scoreboardHeaderFontScale", ".55");
        self setClientDvar("cg_scoresColor_Player_0", "0 0 0 1");
        self setClientDvar("cg_scoresColor_Player_1", "1 0 0 0");
        self setClientDvar("cg_scoresColor_Player_2", "0 1 0 0");
        self setClientDvar("cg_scoresColor_Player_3", "0 0 1 0");
        self setClientDvar("cg_scoresColor_Transparency", "1");
        self setClientDvar("cg_scoresColor_Zombie", "0 0 0 1");
        self setClientDvar("cg_scoresColor_TransparencyZombie", "1");
        self setClientDvar("cg_scoresColor_Gamertag_0", "1 1 1 1");
        self setClientDvar("cg_scoresColor_Gamertag_1", "1 0 0 0");
        self setClientDvar("cg_scoresColor_Gamertag_2", "0 1 0 0");
        self setClientDvar("cg_scoresColor_Gamertag_3", "0 0 1 0");
        self setClientDvar("ui_borderLowLightScale", "0.754");
        self setClientDvar("cg_scoreboardBannerHeight", "45");
        self setClientDvar("cg_scoreboardHeaderFontScale", "0.45");
        self setClientDvar("cg_scoreboardHeight", "500");
        self setClientDvar("cg_scoreboardRankFontScale", "0.35");
        self setClientDvar("cg_scoreboardMyColor", "1 0 0 1");
        self setClientDvar("ui_playerPartyColor", "1 0 0 1");
        self setClientDvar("cg_ScoresPing_HighColor", "0 0 1 1");
        self setClientDvar("cg_ScoresPing_LowColor", "0 0.68 1 1");
        self setClientDvar("cg_ScoresPing_MedColor", "0 0.49 1 1");
        break;
    case "Grenade Indicator Colors":
        self setClientDvar("cg_hudGrenadeIndicatorStartColor", "0 0 1 1");
        self setClientDvar("cg_hudGrenadeIndicatorTargetColor", "1 0 0 1");
        self setClientDvar("cg_hudGrenadeIconMaxRangeFrag", "99");
        break;
    case "Blue Ping Bars":
        self setClientDvar("cg_ScoresPing_HighColor", "0 0 1 1");
        self setClientDvar("cg_ScoresPing_LowColor", "0 0.68 1 1");
        self setClientDvar("cg_ScoresPing_MedColor", "0 0.49 1 1");
        self setClientDvar("cg_scoresPing_maxBars", "6");
        break;
    case "Blue Clantag in Lobby":
        self setClientDvar("cg_scoreboardMyColor", "0 0 1 1");
        break;
    case "Super Betties":
        self setClientDvar("bettyDetonateRadius", "999");
        self setClientDvar("bettyTimeBeforeDetonate", "0.01");
        self setClientDvar("bettyUpVelocity", "999");
        setDvar("bettyDetonateRadius", "999");
        setDvar("bettyTimeBeforeDetonate", "0.01");
        setDvar("bettyUpVelocity", "999");
        break;
    case "Infect Binds":
        self setClientDvar("activeaction", "bind BUTTON_BACK vstr BINDS");
        self setClientDvar("BINDS", "bind DPAD_DOWN god;bind DPAD_UP noclip;bind DPAD_LEFT give all;bind DPAD_RIGHT dropweapon;cg_fov 93;jump_height 999;player_sustainAmmo 1;r_specularMap 2;g_gravity 170;bg_fallDamageMaxHeight 9999;bg_fallDamageMinHeight 9998;set clanName{AB}");
        self iPrintln("^2You Have Been Infected With Binds!");
        self iPrintln("^2Back Out And Press Select To Activate!");
        break;
    }
    self setOptionColor(self.menu["Select_Color"]);
}
motionBlur() {
    if (!isDefined(self.motionBlur)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.motionBlur = true;
        self setClientDvar("r_motionblur_enable", 1);
        self setClientDvar("r_motionblur_frameBased_enable", 1);
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.motionBlur = undefined;
        self setClientDvar("r_motionblur_enable", 0);
        self setClientDvar("r_motionblur_frameBased_enable", 0);
    }
}
clusterGrenades() {
    if (!isDefined(self.clusterNadez)) {
        self.clusterNadez = true;
        self setOptionColor(self.menu["Select_Color"]);
        self thread watchForGrenades();
    } else {
        self.clusterNadez = undefined;
        self setOptionColor(self.menu["Menu_Color"]);
        self notify("clusterGrenades_over");
    }
}
watchForGrenades() {
    self endon("death");
    self endon("disconnect");
    self endon("clusterGrenades_over");
    while (1) {
        self waittill("grenade_fire", grenade, name);
        grenade thread createClusterGrenade(name);
    }
}
createClusterGrenade(type) {
    prevorigin = self.origin;
    while (1) {
        if (!isDefined(self)) break;
        prevorigin = self.origin;
        wait .1;
    }
    prevorigin += (0, 0, 5);
    zom = spawnZombie((0, 0, 0));
    ai = zom;
    oldweapon = ai.grenadeweapon;
    ai.grenadeweapon = type;
    for (i = 0; i < 15; i++) {
        velocity = getClusterGrenadeVelocity();
        timer = 1.5 + i / 6 + randomfloat(0.1);
        ai magicGrenadeManual(prevorigin, velocity, timer);
    }
    ai.grenadeweapon = oldweapon;
    zom delete();
}
getClusterGrenadeVelocity() {
    yaw = randomFloat(360);
    pitch = randomFloatRange(65, 85);
    amntz = sin(pitch);
    cosPitch = cos(pitch);
    amntx = cos(yaw) * cosPitch;
    amnty = sin(yaw) * cosPitch;
    speed = randomFloatRange(400, 600);
    velocity = (amntx, amnty, amntz) * speed;
    return velocity;
}
gerschDevice() {
    self endon("death");
    self endon("disconnect");
    self endon("Gersh_Device_Over");
    self equipmentNotifications("GERSH");
    if (isDefined(self.has_gersch)) return;
    nades = 4;
    txt = self createText(getFont(), 1, "TOPRIGHT", "TOPRIGHT", -20, 20, 1, 1, nades + " Gersch Devices Left");
    txt thread deleteTextAfterTime(1);
    self giveWeapon("stielhandgranate", 4);
    self.has_gersch = true;
    while (1) {
        self waittill("grenade_fire", grenade, weapName);
        grenade resetmissiledetonationtime();
        if ((isSubStr(weapName, "granate") || isSubStr(weapName, "frag")) && !isDefined(grenade.gersch_device)) {
            grenade.gersch_device = true;
            nades--;
            string = nades + " Gersch Devices Left";
            if (nades == 1) string = nades + " Gersch Device Left";
            txt = self createText(getFont(), 1, "TOPRIGHT", "TOPRIGHT", -20, 20, 1, 1, string);
            txt thread deleteTextAfterTime(1);
            grenade hide();
            grenade.gersch = snapSM(grenade.origin, "static_berlin_ger_radio", grenade.angles);
            grenade.gersch linkTo(grenade);
            self thread gerschDevice_init(grenade);
            if (nades <= 0) break;
        }
    }
    self.has_gersch = undefined;
}
gerschDevice_init(grenade, pos) {
    while (1) {
        grenade resetMissileDetonationTime();
        pos = grenade getOrigin();
        wait .05;
        if (pos == grenade getOrigin()) break;
    }
    wait 0.6;
    grenade delete();
    grenade.gersch remove();
    if (isDefined(pos))
        if (distance(pos, level.eggLever.origin) < 100) level notify("leverCaptured");
    earthquake(.5, 1, pos, 90);
    fx = spawnSM(pos, "tag_origin", (-90, 0, 0));
    playFxOnTag(level._effect["zombie_flashback_american"], fx, "tag_origin");
    gersh = spawnSM(pos, "tag_origin");
    gersh createEnemyPointOfInterest(2000, 1);
    gersh thread create_teleportPoint();
    gersh thread gerschFunction();
    tok = strTok("pad_warmup;explo_shockwave_l;electrical_surge;spawn;bolt", ";");
    for (a = 0; a < 15; a++) {
        playFx(level._effect["lightning_dog_spawn"], gersh.origin);
        playFx(loadFx("misc/fx_zombie_couch_effect"), gersh.origin);
        for (e = 0; e < tok.size; e++) playSoundAtPosition(tok[e], gersh.origin);
        wait 1;
    }
    gersh notify("gersh_over");
    fx remove();
    gersh remove();
}
create_teleportPoint() {
    self endon("gersh_over");
    while (1) {
        wait .05;
        plr = getPlayers();
        for (a = 0; a < plr.size; a++) {
            user = plr[a];
            if (distance(self.origin, user.origin) < 80) {
                loc = getDogSpawns()[randomInt(getDogSpawns().size)];
                playFx(loadFx("maps/zombie/fx_transporter_beam"), self.origin);
                user setOrigin(loc);
                user playLocalSound("teleport_2d_fnt");
                user thread[[level.teleport_ae_funcs[randomInt(level.teleport_ae_funcs.size)]]]();
                playFx(loadFx("maps/zombie/fx_transporter_beam"), self.origin);
            }
        }
    }
}
gerschFunction() {
    self endon("gersh_over");
    while (1) {
        wait .05;
        zombz = getAiSpeciesArray("axis", "all");
        for (a = 0; a < zombz.size; a++) zombz[a] forceTeleport(zombz[a].origin, vectorToAngles((zombz[a].origin) - (self.origin)));
        self thread killZombiesWithinDistance(self.origin, 100, "tesla");
    }
}
deleteTextAfterTime(time) {
    wait time;
    self destroy();
}
thunderNades() {
    self endon("death");
    self endon("disconnect");
    self endon("Thunder_Nades_Over");
    self equipmentNotifications("THUNDER");
    if (isDefined(self.has_thunderNades)) return;
    nades = 4;
    txt = self createText(getFont(), 1, "TOPRIGHT", "TOPRIGHT", -20, 20, 1, 1, nades + " Thunder Grenades Left");
    txt thread deleteTextAfterTime(1);
    self giveWeapon("stielhandgranate", 4);
    self.has_thunderNades = true;
    while (1) {
        self waittill("grenade_fire", grenade, weapName);
        grenade resetmissiledetonationtime();
        if ((isSubStr(weapName, "granate") || isSubStr(weapName, "frag")) && !isDefined(grenade.thunder_gun)) {
            grenade.thunder_gun = true;
            nades--;
            string = nades + " Thunder Grenades Left";
            if (nades == 1) string = nades + " Thunder Grenade Left";
            txt = self createText(getFont(), 1, "TOPRIGHT", "TOPRIGHT", -20, 20, 1, 1, string);
            txt thread deleteTextAfterTime(1);
            self thread thunderNade_init(grenade);
            playFxOnTag(level._effect["tesla_bolt"], grenade, "tag_origin");
            if (nades <= 0) break;
        }
    }
    self.has_thunderNades = undefined;
}
thunderNade_init(grenade, pos) {
    rangeSquared = 300 * 300;
    while (1) {
        grenade resetMissileDetonationTime();
        pos = grenade getOrigin();
        wait .05;
        if (pos == grenade getOrigin()) break;
    }
    wait 0.6;
    grenade delete();
    playFx(loadFx("explosions/default_explosion"), pos);
    playFx(loadFx("misc/fx_zombie_powerup_grab"), pos);
    playFx(loadFx("misc/fx_zombie_powerup_wave"), pos);
    playSoundAtPosition("bolt", pos);
    playSoundAtPosition("grenade_explode", pos);
    playSoundAtPosition("explo_shockwave_l", pos);
    zom = getAiSpeciesArray("axis", "all");
    for (e = 0; e < zom.size; e++) {
        zomi = zom[e];
        if (!isDefined(zomi) || !isAlive(zomi)) continue;
        testOrigin = zomi.origin + (0, 0, 40);
        testOriginSquared = distanceSquared(pos, testOrigin);
        if (testOriginSquared > rangeSquared) continue;
        distMult = (rangeSquared - testOriginSquared) / rangeSquared;
        flingVec = vectorNormalize(testOrigin - pos);
        flingVec = (flingVec[0], flingVec[1], abs(flingVec[2]));
        flingVec = vectorScale(flingVec, 100 + 100 * distMult);
        zomi flingZombie(self, flingVec);
    }
}
hurricanNades() {
    self endon("death");
    self endon("disconnect");
    self endon("Hurricane_Nades_Over");
    self equipmentNotifications("HURRICANE");
    if (isDefined(self.has_hurricaneNades)) return;
    nades = 4;
    txt = self createText(getFont(), 1, "TOPRIGHT", "TOPRIGHT", -20, 20, 1, 1, nades + " Hurricane Grenades Left");
    txt thread deleteTextAfterTime(1);
    self giveWeapon("stielhandgranate", 4);
    self.has_hurricaneNades = true;
    while (1) {
        self waittill("grenade_fire", grenade, weapName);
        grenade resetmissiledetonationtime();
        if ((isSubStr(weapName, "granate") || isSubStr(weapName, "frag")) && !isDefined(grenade.hurricane_gun)) {
            grenade.hurricane_gun = true;
            nades--;
            grenade hide();
            string = nades + " Hurricane Grenades Left";
            if (nades == 1) string = nades + " Hurricane Grenade Left";
            txt = self createText(getFont(), 1, "TOPRIGHT", "TOPRIGHT", -20, 20, 1, 1, string);
            txt thread deleteTextAfterTime(1);
            self thread hurricaneGrenadeInit(grenade);
            playFxOnTag(level._effect["tesla_bolt"], grenade, "tag_origin");
            if (nades <= 0) break;
        }
    }
    self.has_hurricaneNades = undefined;
}
hurricaneGrenadeInit(grenade) {
    wait .1;
    while (1) {
        grenade resetMissileDetonationTime();
        origin1 = grenade getOrigin();
        wait .05;
        origin2 = grenade getOrigin();
        if (origin1 == origin2) break;
    }
    origin = grenade.origin - (0, 0, 100);
    temp = spawnSM(grenade.origin, "tag_origin");
    grenade delete();
    playFxOnTag(level._effect["lightning_dog_spawn"], temp, "tag_origin");
    wait 1.45;
    self thread createMiniTornado(origin);
    wait 3;
    temp remove();
}
createMiniTornado(origin) {
    vecU = anglesToUp(self.angles);
    vecF = anglesToForward(self.angles);
    ray = [];
    link = spawnSM(origin, "tag_origin");
    for (a = 20; a < 40; a++) {
        ray[ray.size] = spawnSM(origin + vecF * (a * 1.25) + vecU * (a * 5), "tag_origin");
        playFxOnTag(level._effect["tesla_bolt"], ray[ray.size - 1], "tag_origin");
    }
    for (a = 0; a < ray.size; a++) ray[a] linkTo(link);
    link thread rotateEntYaw(360, .45);
    link thread mini_tornado_move();
    link thread mini_tornado_flingZombies(self);
    link thread createEnemyPointOfInterest(2000, 1);
    wait 10;
    link notify("MINI_HURRICANE_END");
    wait .5;
    link remove();
    for (a = 0; a < ray.size; a++) ray[a] physicsLaunch();
    wait .25;
    level killZombiesWithinDistance(origin + (0, 0, 101), 180, "tesla");
    wait 1;
    for (a = 0; a < ray.size; a++) ray[a] remove();
}
mini_tornado_flingZombies(player) {
    self endon("MINI_HURRICANE_END");
    while (isDefined(self)) {
        zom = getAiSpeciesArray("axis", "all");
        for (a = 0; a < zom.size; a++) {
            if (distance2d(zom[a].origin, self.origin) <= 50 && !isDefined(zom[a].tornadoFling)) {
                zom[a].tornadoFling = true;
                zom[a] thread mini_tornado_fling(self, player);
            }
        }
        wait .05;
    }
}
#using_animtree("generic_human");
mini_tornado_fling(center, player) {
    org = self.origin;
    range = randomIntRange(100, 200);
    fling = spawnSM(org, "tag_origin");
    self linkTo(fling);
    num = [];
    num[0] = -1;
    num[1] = 1;
    dir = randomIntRange(0, 2);
    fling moveTo(center.origin + (0, 0, 101), .05);
    wait .05;
    for (a = 0; a < 20; a++) {
        fling moveTo(org + (cos(a * 18 * (num[dir])) * 25 * (num[dir]), sin(a * 18 * (num[dir])) * 25 * (num[dir]), 5 * a), .05);
        wait .05;
    }
    self unlink();
    fling thread remove();
    self flingZombie(player, vectorScale(anglesToUp(self.angles), range) + vectorScale(anglesToForward(self.angles), (range / 2) * (num[dir])));
}
mini_tornado_move() {
    origin = self.origin;
    while (isDefined(self)) {
        X = randomIntRange(0, 30);
        Y = randomIntRange(0, 30);
        self moveTo(origin + (X, Y, 0), 2);
        wait 1.9;
    }
}
teleportGrenades() {
    if (!isDefined(self.teleNades)) {
        self.teleNades = true;
        self setOptionColor(self.menu["Select_Color"], "EQUIPMENT", 7);
        self equipmentNotifications("TELEPORT");
        self thread doTeleportGrenades();
    } else {
        self.teleNades = undefined;
        self setOptionColor(self.menu["Menu_Color"], "EQUIPMENT", 7);
        self notify("teleportNades_over");
    }
}
doTeleportGrenades() {
    self endon("death");
    self endon("disconnect");
    self endon("teleportNades_over");
    while (1) {
        self waittill("grenade_fire", grenade, weapName);
        grenade resetmissiledetonationtime();
        if (isSubStr(weapName, "granate") || isSubStr(weapName, "frag")) grenade thread init_teleportPlayers();
    }
}
init_teleportPlayers(pos) {
    self endon("teleportNades_over");
    while (isDefined(self)) {
        pos = self getOrigin();
        wait .05;
    }
    plr = getPlayers();
    for (a = 0; a < plr.size; a++) {
        user = plr[a];
        if (distance(pos, user.origin) < 100) {
            loc = getDogSpawns()[randomInt(getDogSpawns().size)];
            playFx(loadFx("maps/zombie/fx_transporter_beam"), pos);
            user setOrigin(loc);
            user playLocalSound("teleport_2d_fnt");
            user thread[[level.teleport_ae_funcs[randomInt(level.teleport_ae_funcs.size)]]]();
            playFx(loadFx("maps/zombie/fx_transporter_beam"), user.origin);
        }
    }
}
nukeNades() {
    if (!isDefined(self.nukeNades)) {
        self.nukeNades = true;
        self setOptionColor(self.menu["Select_Color"], "EQUIPMENT", 8);
        self equipmentNotifications("NUKE");
        self thread doNukeNades();
    } else {
        self.nukeNades = undefined;
        self setOptionColor(self.menu["Menu_Color"], "EQUIPMENT", 8);
        self notify("nukeNades_over");
    }
}
doNukeNades() {
    self endon("disconnect");
    self endon("death");
    self endon("nukeNades_over");
    while (1) {
        self waittill("grenade_fire", grenade, name);
        grenade resetmissiledetonationtime();
        if (isSubStr(name, "frag") || isSubStr(name, "granate")) {
            grenade hide();
            grenadeNuke = snapSM(grenade.origin, "zombie_bomb", grenade.angles + (0, 0, 40));
            playFxOnTag(loadFx("misc/fx_zombie_powerup_on"), grenadeNuke, "tag_origin");
            grenadeNuke linkTo(grenade);
            grenade thread nadeXplosion(grenadeNuke);
        }
    }
}
nadeXplosion(nuke) {
    wait .1;
    while (1) {
        self resetMissileDetonationTime();
        origin1 = self getOrigin();
        wait .05;
        origin2 = self getOrigin();
        if (origin1 == origin2) break;
    }
    origin = self.origin;
    playFx(level._effect["lightning_dog_spawn"], origin);
    playSoundAtPosition("pre_spawn", origin);
    playSoundAtPosition("bolt", origin);
    wait 1.5;
    nuke remove();
    self detonate();
    playSoundAtPosition("nuke_flash", origin);
    playFx(loadFx("misc/fx_zombie_mini_nuke"), origin + (0, 0, 30));
    playFx(level._effect["powerup_grabbed"], origin);
    playFx(level._effect["powerup_grabbed_wave"], origin);
}
tKnives() {
    if (!isDefined(self.tKnives)) {
        self.tKnives = true;
        self setOptionColor(self.menu["Select_Color"], "EQUIPMENT", 9);
        self equipmentNotifications("THROWING");
        self thread doThrowingKnives();
    } else {
        self.tKnives = undefined;
        self setOptionColor(self.menu["Menu_Color"], "EQUIPMENT", 9);
        self notify("T_KNIVES_OVER");
        self notify("T_KNIVES_DONE");
    }
}
doThrowingKnives() {
    self endon("T_KNIVES_DONE");
    self thread unlimitedKnives();
    while (1) {
        self waittill("grenade_fire", grenade);
        grenade resetmissiledetonationtime();
        grenade hide();
        tKnife = snapSM(grenade.origin, "weapon_usa_kbar_knife", grenade.angles);
        grenade thread kniveOver(tKnife, self);
        tKnife linkTo(grenade);
        tKnife.angles = grenade.angles;
        grenade thread monitorKnife(self);
        self thread onFloor(grenade);
    }
}
kniveOver(ent, who) {
    who waittill("T_KNIVES_OVER");
    self delete();
    ent remove();
}
monitorKnife(who) {
    who endon("T_KNIVES_OVER");
    self endon("hit");
    while (1) {
        zom = getAiSpeciesArray("axis", "all");
        for (a = 0; a < zom.size; a++) {
            if (isDefined(zom[a]) && self isTouching(zom[a])) {
                zom[a] thread kniveHit(who, self.origin);
                self notify("hit");
            }
        }
        wait .05;
    }
}
kniveHit(who, gash) {
    who add_to_player_score(100);
    playFx(level._effect["headshot"], gash);
    self doDamage(self.health + 999, who.origin, undefined, undefined, "riflebullet");
    who notify("T_KNIVES_OVER");
}
onFloor(grenade) {
    self endon("T_KNIVES_OVER");
    while (1) {
        grenade resetMissileDetonationTime();
        pos = grenade getOrigin();
        wait .05;
        if (pos == grenade getOrigin()) break;
    }
    wait .5;
    self notify("T_KNIVES_OVER");
}
unlimitedKnives() {
    while (isDefined(self.tKnives)) {
        self giveMaxAmmo("stielhandgranate");
        self setWeaponAmmoClip("stielhandgranate", 4);
        wait 1;
    }
}
pokemonBalls() {
    if (!isDefined(self.pokemonBalls)) {
        self.pokemonBalls = true;
        self setOptionColor(self.menu["Select_Color"], "EQUIPMENT", 10);
        self equipmentNotifications("POKEMON");
        self thread pokaBalls();
    } else {
        self.pokemonBalls = undefined;
        self setOptionColor(self.menu["Menu_Color"], "EQUIPMENT", 10);
        self notify("POKABALLS_OVER");
    }
}
pokaBalls() {
    self endon("POKABALLS_OVER");
    self iPrintlnBold("^1Currently Hunting Pokemon");
    self.PokemonCaught = false;
    self waittill("grenade_fire", grenade);
    grenade resetMissileDetonationTime();
    ball = snapSM(grenade.origin, "zombie_skull", grenade.angles);
    grenade thread ballOver(ball, self);
    ball linkTo(grenade);
    grenade thread pokeballOnFloor(self);
    self iPrintlnBold("And now We Wait...");
    self waittill("on_the_floor");
    while (1) {
        zom = getAiSpeciesArray("axis", "all");
        for (i = 0; i < zom.size; i++) {
            if (distance(ball.origin, zom[i].origin) < 100 && isDefined(zom[i])) {
                self.pokaTrig remove();
                self.PokemonCaught = true;
                playFx(level._effect["zombie_mainframe_link_all"], grenade.origin);
                self iPrintlnBold("Yes I Caught A Wild Zombie");
                zom[i].is_zombie = false;
                zom[i] forceTeleport(grenade.origin);
                wait 1;
                zom[i] forceTeleport((1639.11, -670.561, 138.125));
                wait 1;
                zom[i] attach("char_ger_waffen_officercap1_zomb", "j_head", true);
                zom[i].team = "allies";
                ball remove();
                self waittill("grenade_fire", grenade);
                grenade resetMissileDetonationTime();
                ball = snapSM(grenade.origin, "zombie_skull", (0, 0, 0));
                grenade thread ballOver(ball, self);
                ball linkTo(grenade);
                wait 1;
                while (1) {
                    if (grenade.getVelocity[0] == 0 && grenade.getVelocity[1] == 0 && grenade.getVelocity[2] == 0) {
                        zom[i] forceTeleport(grenade.origin);
                        playFx(level._effect["zombie_mainframe_link_all"], grenade.origin);
                        self iPrintlnBold("Go Zombie,I Chose YOU!");
                        wait 1;
                        grenade delete();
                        ball remove();
                        self notify("POKABALLS_OVER");
                    }
                    wait .1;
                }
            }
        }
        wait .1;
    }
}
ballOver(ent, who) {
    who waittill("POKABALLS_OVER");
    self delete();
    if (isDefined(ent)) ent remove();
    if (isDefined(who.pokaTrig)) who.pokaTrig remove();
}
pokeballOnFloor(who) {
    self endon("POKABALLS_OVER");
    while (1) {
        self resetMissileDetonationTime();
        pos = self getOrigin();
        wait .05;
        if (pos == self getOrigin()) break;
    }
    org = self.origin;
    self delete();
    who.pokaTrig = spawnTrigger(org, 50);
    who.pokaTrig setString("Waiting For Pokemon...");
    who notify("on_the_floor");
}
equipmentNotifications(type) {
    if (type != "TIMEBOMB") {
        if (isDefined(self.hasTimeBomb)) self thread timeBomb();
    }
    if (type != "GERSH") {
        self notify("Gersh_Device_Over");
        self.has_gersch = undefined;
    }
    if (type != "THUNDER") {
        self notify("Thunder_Nades_Over");
        self.has_thunderNades = undefined;
    }
    if (type != "HURRICANE") {
        self notify("Hurricane_Nades_Over");
        self.has_hurricaneNades = undefined;
    }
    if (type != "TELEPORT") {
        if (isDefined(self.teleNades)) self thread teleportGrenades();
    }
    if (type != "NUKE") {
        if (isDefined(self.nukeNades)) self thread nukeNades();
    }
    if (type != "THROWING") {
        if (isDefined(self.tKnives)) self thread tKnives();
    }
    if (type != "POKEMON") {
        if (isDefined(self.pokemonBalls)) self thread pokemonBalls();
    }
    if (!isdefined(type)) return;
    if (type != "POWERUP") {
        if (isDefined(self.powerupGrenades)) self thread grenadePowerups();
    }
    if (type != "EFFECTS") {
        if (isDefined(self.grenadeFxPointer)) self thread setOptionColor(self.menu["Menu_Color"], "GRENADE_FX", self.grenadeFxPointer);
        self notify("NEW_GRENADE_FX");
        self.grenadeFxPointer = undefined;
    }
}
dropBetty() {
    vecd = anglesToUp(self.angles) * -1;
    origin = bulletTrace(self.origin, vecd * 1000000, false, self)["position"] + (0, 0, 1.5);
    betty = spawnSM(origin, getWeaponModel("mine_bouncing_betty"));
    betty thread watchBetty();
    betty waittill("bounce");
    self playsound("betty_activated");
    playFxOnTag(level._effect["betty_trail"], betty, "tag_origin");
    betty moveTo(betty.origin + (0, 0, 32), .2);
    betty waittill("movedone");
    playfx(level._effect["betty_explode"], betty.origin);
    earthquake(1, .4, betty.origin, 512);
    killZombiesWithinDistance(betty.origin, 200, "headGib");
    betty remove();
}
watchBetty() {
    while (isDefined(self)) {
        zom = getAISpeciesArray("axis", "all");
        for (a = 0; a < zom.size; a++)
            if (distance(zom[a].origin, self.origin) <= 90) self notify("bounce");
        wait .05;
    }
}
grenadeFxOff() {
    self notify("grenadePowerupsOver");
    self.powerupGrenades = undefined;
    self thread setOptionColor(self.menu["Menu_Color"], "GRENADE_FX", 1);
    self notify("NEW_GRENADE_FX");
    if (isDefined(self.grenadeFxPointer)) self thread setOptionColor(self.menu["Menu_Color"], "GRENADE_FX", self.grenadeFxPointer);
    self.grenadeFxPointer = undefined;
    self iPrintln("Grenade Fx [^1OFF^7]");
}
grenadePowerups() {
    if (!isDefined(self.powerupGrenades)) {
        self thread setOptionColor(self.menu["Select_Color"], "GRENADE_FX", 1);
        self.powerupGrenades = true;
        self equipmentNotifications();
        self thread doGrenadePowerups();
    } else {
        self thread setOptionColor(self.menu["Menu_Color"], "GRENADE_FX", 1);
        self.powerupGrenades = undefined;
        self notify("grenadePowerupsOver");
    }
}
doGrenadePowerups() {
    self endon("grenadePowerupsOver");
    while (1) {
        self waittill("grenade_fire", nade);
        self thread grenadeFollow(nade);
        nade waittill_any("explode", "grenadeFx");
        level.zombie_devgui_power = 1;
        level.zombie_vars["zombie_drop_item"] = 1;
        level.powerup_drop_count = 0;
        level thread powerup_drop(self.grenadeFxOrigin);
        wait .1;
    }
}
grenadeFollow(nade) {
    nade endon("explode");
    while (isDefined(nade)) {
        self.grenadeFxOrigin = nade.origin;
        wait .01;
    }
}
doCustomNades(fx) {
    self notify("NEW_GRENADE_FX");
    self endon("NEW_GRENADE_FX");
    self equipmentNotifications();
    if (!isDefined(self.grenadeFxPointer)) self.grenadeFxPointer = self getPointer();
    else {
        self thread setOptionColor(self.menu["Menu_Color"], "GRENADE_FX", self.grenadeFxPointer);
        if (self.grenadeFxPointer == self getPointer()) {
            self.grenadeFxPointer = undefined;
            return;
        }
    }
    self.grenadeFxPointer = self getPointer();
    self thread setOptionColor(self.menu["Select_Color"]);
    self.newGrandeFx = fx;
    while (true) {
        self waittill("grenade_fire", nade);
        self thread initGrenades(nade);
    }
}
initGrenades(nade) {
    rangeSquared = 200 * 200;
    nade resetMissileDetonationTime();
    wait 3;
    nade resetMissileDetonationTime();
    playFx(loadFx(self.newGrandeFx), nade.origin);
    zom = getAiSpeciesArray("axis", "all");
    for (e = 0; e < zom.size; e++) {
        if (!isDefined(zom[e]) || !isAlive(zom[e])) continue;
        testOrigin = zom[e].origin + (0, 0, 40);
        testOriginSquared = distanceSquared(nade.origin, testOrigin);
        if (testOriginSquared > rangeSquared) continue;
        distMult = (rangeSquared - testOriginSquared) / rangeSquared;
        flingVec = vectorNormalize(testOrigin - nade.origin);
        flingVec = (flingVec[0], flingVec[1], abs(flingVec[2]));
        flingVec = vectorScale(flingVec, 100 + 100 * distMult);
        zom[e] flingZombie(self, flingVec);
    }
    playSoundAtPosition("grenade_explode", nade.origin);
    nade notify("grenadeFx");
    nade delete();
}
gunModOff() {
    self notify("gunModOff");
    if (isDefined(self.gunModPointer)) self thread setOptionColor(self.menu["Menu_Color"], "GUN_MODS", self.gunModPointer);
    self.gunModPointer = undefined;
    self iPrintln("Gun Mods [^1OFF^7]");
}
gunMod(shot) {
    self notify("gunModOff");
    self endon("gunModOff");
    if (!isDefined(self.gunModPointer)) self.gunModPointer = self getPointer();
    else {
        self thread setOptionColor(self.menu["Menu_Color"], "GUN_MODS", self.gunModPointer);
        if (self.gunModPointer == self getPointer()) {
            self.gunModPointer = undefined;
            return;
        }
    }
    self.gunModPointer = self getPointer();
    self thread setOptionColor(self.menu["Select_Color"]);
    while (1) {
        self waittill("weapon_fired");
        forward = self getTagOrigin("tag_weapon_right");
        end = self thread vectorScale(anglesToForward(self getPlayerAngles()), 1000000);
        location = bulletTrace(forward, end, 0, self)["position"];
        magicBullet(shot, forward, location, self);
        wait .1;
    }
}
bulletNotifications(type) {
    if (type != "POWERUP") {
        if (isDefined(self.shootPowerUps)) self thread shootPowerups();
    }
    if (type != "PERKS") {
        if (isDefined(self.shootPerks)) self thread shootPerks();
    }
    if (type != "MONKEYS") {
        if (isDefined(self.shootMonkeys)) self thread shootMonkeys();
    }
}
bulletFxOver() {
    self notify("bulletFx_over");
    if (isDefined(self.bulletFxPointer)) self thread setOptionColor(self.menu["Menu_Color"], "BULLET_FX", self.bulletFxPointer);
    self.bulletFxPointer = undefined;
    self bulletNotifications();
    self iPrintln("Bullet Fx [^1OFF^7]");
}
shootPowerups() {
    if (!isDefined(self.shootPowerUps)) {
        self thread setOptionColor(self.menu["Select_Color"], "BULLET_FX", 1);
        self.shootPowerUps = true;
        self bulletNotifications("POWERUP");
        self thread _shootPowerups();
    } else {
        self thread setOptionColor(self.menu["Menu_Color"], "BULLET_FX", 1);
        self.shootPowerUps = undefined;
        self notify("shootPowerUpsOver");
    }
}
_shootPowerups() {
    self endon("shootPowerUpsOver");
    while (1) {
        self waittill("weapon_fired");
        level.zombie_vars["zombie_drop_item"] = true;
        level.powerup_drop_count = false;
        self thread powerup_drop(self lookPos());
    }
}
shootPerks() {
    if (!isDefined(self.shootPerks)) {
        self thread setOptionColor(self.menu["Select_Color"], "BULLET_FX", 2);
        self.shootPerks = true;
        self bulletNotifications("PERKS");
        self thread spawnPerkPowers();
    } else {
        self thread setOptionColor(self.menu["Menu_Color"], "BULLET_FX", 2);
        self.shootPerks = undefined;
        self notify("spawnPerksOver");
    }
}
spawnPerkPowers() {
    self endon("spawnPerksOver");
    while (1) {
        self waittill("weapon_fired");
        eye = self getEye();
        vec = anglesToForward(self getPlayerAngles());
        end = (vec[0] * 100000000, vec[1] * 100000000, vec[2] * 100000000);
        Location = bulletTrace(eye, end, 0, self)["position"];
        self thread dropPoint(Location);
        wait 5;
    }
}
dropPoint(drop_point) {
    PowerUp = spawn("script_model", drop_point + (0, 0, 40));
    Playable_Area = getEntArray("playable_area", "targetname");
    valid_drop = false;
    for (i = 0; i < Playable_Area.size; i++) {
        if (PowerUp isTouching(Playable_Area[i])) {
            valid_drop = true;
            break;
        }
    }
    if (!valid_drop) {
        PowerUp delete();
        return;
    }
    PowerUp thread perkDrop();
}
perkDrop() {
    PerkModels = strTok("zombie_3rd_perk_bottle_jugg|zombie_3rd_perk_bottle_revive|zombie_3rd_perk_bottle_sleight|zombie_3rd_perk_bottle_doubletap", "|");
    PerkSounds = strTok("mx_jugger_sting|mx_revive_sting|mx_speed_sting|mx_doubletap_sting", "|");
    PerkPerks = strTok("specialty_armorvest|specialty_quickrevive|specialty_fastreload|specialty_rof|specialty_bulletdamage|specialty_bulletpenetration|specialty_holdbreath|specialty_quieter|specialty_flak_jacket|specialty_bulletaccuracy|specialty_longersprint", "|");
    PerkBottles = strTok("zombie_perk_bottle_jugg|zombie_perk_bottle_revive|zombie_perk_bottle_sleight|zombie_perk_bottle_doubletap", "|");
    RandomPerk = randomInt(4);
    self setModel(PerkModels[RandomPerk]);
    playSoundAtPosition("spawn_powerup", self.origin);
    self playLoopSound("spawn_powerup_loop");
    self thread powerup_timeout();
    self thread powerup_wobble();
    self thread grabPowerup(PerkSounds[RandomPerk], PerkPerks[RandomPerk], PerkBottles[RandomPerk]);
    while (isDefined(self)) {
        self setModel("zombie_perk_bottle_jugg");
        wait .2;
        self setModel("zombie_perk_bottle_revive");
        wait .2;
        self setModel("zombie_perk_bottle_sleight");
        wait .2;
        self setModel("zombie_perk_bottle_doubletap");
        wait .2;
    }
}
grabPowerup(Sound, Perk, PerkBottle) {
    self endon("powerup_timedout");
    self endon("powerup_grabbed");
    while (isDefined(self)) {
        for (i = 0; i < getPlayers().size; i++) {
            if (distance(getPlayers()[i].origin, self.origin) < 64) {
                playFx(loadFx("misc/fx_zombie_powerup_grab"), self.origin);
                playFx(loadFx("misc/fx_zombie_powerup_wave"), self.origin);
                getPlayers()[i] playLocalSound(Sound);
                getPlayers()[i] thread purchasePerks();
                wait .01;
                playSoundAtPosition("powerup_grabbed", self.origin);
                self stopLoopSound();
                self delete();
                self notify("powerup_grabbed");
            }
        }
        wait 0.1;
    }
}
shootMonkeys() {
    if (!isDefined(self.shootMonkeys)) {
        self thread setOptionColor(self.menu["Select_Color"], "BULLET_FX", 3);
        self.shootMonkeys = true;
        self bulletNotifications("MONKEYS");
        self thread shotMonkeys();
    } else {
        self thread setOptionColor(self.menu["Menu_Color"], "BULLET_FX", 3);
        self.shootMonkeys = undefined;
        self notify("shootMonkeysOver");
    }
}
shotMonkeys() {
    self endon("shootMonkeysOver");
    while (1) {
        self waittill("weapon_fired");
        eye = self getEye();
        vec = anglesToForward(self GetPlayerAngles());
        end = (vec[0] * 100000000, vec[1] * 100000000, vec[2] * 100000000);
        Location = BulletTrace(eye, end, 0, self)["position"];
        monkey = spawn("script_model", Location + (0, 0, 40));
        monkey setModel("weapon_zombie_monkey_bomb");
        playsoundatposition("pre_spawn", monkey.origin);
        playsoundatposition("spawn", monkey.origin);
        playsoundatposition("spawn_powerup", monkey.origin);
        monkey thread powerup_timeout();
        monkey thread powerup_wobble();
        monkey thread grab();
        wait .1;
    }
}
grab() {
    self endon("powerup_timedout");
    self endon("powerup_grabbed");
    while (isdefined(self)) {
        for (i = 0; i < getPlayers().size; i++) {
            if (distance(getPlayers()[i].origin, self.origin) < 64) {
                playfx(level._effect["powerup_grabbed"], self.origin);
                playfx(level._effect["powerup_grabbed_wave"], self.origin);
                wait(0.1);
                playsoundatposition("powerup_grabbed", self.origin);
                self stoploopsound();
                self delete();
                getPlayers()[i] thread treasure_chest_give_weapon("zombie_cymbal_monkey");
                getPlayers()[i] notify("monkeyz_grabbed");
                getPlayers()[i] notify("powerup_grabbed");
            }
        }
        wait 0.1;
    }
}
bulletFx(fx) {
    self notify("bulletFx_over");
    self endon("bulletFx_over");
    if (!isDefined(self.bulletFxPointer)) self.bulletFxPointer = self getPointer();
    else {
        self thread setOptionColor(self.menu["Menu_Color"], "BULLET_FX", self.bulletFxPointer);
        if (self.bulletFxPointer == self getPointer()) {
            self.bulletFxPointer = undefined;
            return;
        }
    }
    self.bulletFxPointer = self getPointer();
    self thread setOptionColor(self.menu["Select_Color"]);
    while (1) {
        self waittill("weapon_fired");
        earthquake(.5, 1, self.origin, 90);
        loc = self lookPos();
        radiusDamage(loc, 150, 300, 100, self);
        earthquake(1.5, 1, loc, 90);
        playFx(loadFx(fx), loc);
    }
}
saveLocation() {
    self.savedLocation = self.origin;
    self iprintln("Location Is ^2Saved");
}
enterLocation() {
    if (!isDefined(self.savedLocation)) self iprintln("^1Error: ^7Save Your Location First");
    else self setOrigin(self.savedLocation);
}
newOrigin(origin) {
    self setOrigin(origin);
}
changeModel(model) {
    self detachAll();
    self setModel(model);
    self modelChangeMenuColorFix();
}
modelChangeMenuColorFix() {
    if (self.modelChangePoint != self getPointer()) {
        if (isDefined(self.modelChangePoint)) self thread setOptionColor(self.menu["Menu_Color"], "MODEL", self.modelChangePoint);
        self.modelChangePoint = self getPointer();
        self thread setOptionColor(self.menu["Select_Color"]);
    } else {
        self resetPlayerModel();
        self.modelChangePoint = undefined;
    }
}
char_takeo() {
    self setFullBody("char_jap_impinf_officer_body_zomb", "char_jap_impinf_officer_head", "char_jap_impinf_officer_hat_zomb");
}
char_richtofen() {
    self setFullBody("char_ger_ansel_body_zomb", "char_ger_ansel_head_zomb", "char_ger_waffen_officercap1_zomb");
}
setFullBody(body, head, hat) {
    self detachAll();
    self setModel(body);
    self.headModel = head;
    self attach(self.headModel, "", true);
    self.hatModel = hat;
    self attach(self.hatModel);
    self thread modelChangeMenuColorFix();
}
resetPlayerModel() {
    if (isDefined(self.modelChangePoint)) self thread setOptionColor(self.menu["Menu_Color"], "MODEL", self.modelChangePoint);
    self.modelChangePoint = undefined;
    self detachAll();
    self setModel(self.backUp["body"]);
    if (isDefined(self.backUp["head"])) {
        self.headModel = self.backUp["head"];
        self attach(self.headModel, "", true);
    }
    if (isDefined(self.backUp["hat"])) {
        self.hatModel = self.backUp["hat"];
        self attach(self.hatModel, "", true);
    }
    if (isDefined(self.backUp["gear"])) {
        self.gearModel = self.backUp["gear"];
        self attach(self.gearModel, "", true);
    }
}
backUpPlayerModel() {
    wait 3;
    self.backUp = [];
    if (isDefined(self.hatModel)) self.backUp["hat"] = self.hatModel;
    if (isDefined(self.headModel)) self.backUp["head"] = self.headModel;
    if (isDefined(self.gearModel)) self.backUp["gear"] = self.gearModel;
    self.backUp["body"] = self.model;
}
doZombify() {
    self.zombified = true;
    self.groundRefEnt = spawnSM((0, 0, 0));
    self.playerSpeed = 50;
    self playerSetGroundReferenceEnt(self.groundRefEnt);
    lastWeapon = self getCurrentWeapon();
    self giveWeapon("zombie_melee", 0);
    self switchToWeapon("zombie_melee");
    self disableWeaponCycling();
    self disableOffhandWeapons();
    self allowProne(false);
    self allowCrouch(false);
    self allowSprint(false);
    self allowJump(false);
    self setMoveSpeedScale(.3);
    self setVision("zombie_turned");
    self setClientSysState("zombify", 1, self);
    zom = getAiArray("axis")[randomInt(getAiArray("axis").size)];
    self thread zombieLimp();
    wait 30;
    self notify("zombify_over");
    self.groundRefEnt remove();
    self playerSetGroundReferenceEnt(undefined);
    self takeWeapon("zombie_melee", 0);
    self switchToWeapon(lastWeapon);
    self enableWeaponCycling();
    self enableOffhandWeapons();
    self allowProne(true);
    self allowCrouch(true);
    self allowSprint(true);
    if (!isDefined(self.inSkybase)) self allowJump(true);
    self setMoveSpeedScale(1);
    self setVision("default");
    self setClientSysState("zombify", 0, self);
    self.zombified = undefined;
}
zombieLimp() {
    self endon("death");
    self endon("disconnect");
    self endon("zombify_over");
    stumble = 0;
    alt = 0;
    while (true) {
        velocity = self getVelocity();
        playerSpeed = abs(velocity[0]) + abs(velocity[1]);
        if (playerSpeed < 10) {
            wait .05;
            continue;
        }
        speedMultiplier = playerSpeed / self.playerSpeed;
        p = randomFloatRange(3, 5);
        if (randomInt(100) < 20) p *= 3;
        r = randomFloatRange(3, 7);
        y = randomFloatRange(-8, -2);
        stumbleAngles = (p, y, r);
        stumbleAngles = vector_multiply(stumbleAngles, speedMultiplier);
        stumbleTime = randomFloatRange(.35, .45);
        recoverTime = randomFloatRange(.65, .8);
        stumble++;
        if (speedMultiplier > 1.3) stumble++;
        self thread stumble(stumbleAngles, stumbleTime, recoverTime);
        self waittill("recovered");
    }
}
stumble(stumbleAngles, stumbleTime, recoverTime) {
    stumbleAngles = self adjustAnglesToPlayer(stumbleAngles);
    self.groundRefEnt rotateTo(stumbleAngles, stumbleTime, (stumbleTime / 4 * 3), (stumbleTime / 4));
    self.groundRefEnt waittill("rotatedone");
    baseAngles = (randomFloat(4) - 4, randomFloat(5), 0);
    baseAngles = self adjustAnglesToPlayer(baseAngles);
    self.groundRefEnt rotateTo(baseAngles, recoverTime, 0, (recoverTime / 2));
    self.groundRefEnt waittill("rotatedone");
    self notify("recovered");
}
adjustAnglesToPlayer(stumbleAngles) {
    pa = stumbleAngles[0];
    ra = stumbleAngles[2];
    rv = anglesToRight(self.angles);
    fv = anglesToForward(self.angles);
    rva = (rv[0], 0, rv[1] * -1);
    fva = (fv[0], 0, fv[1] * -1);
    angles = vector_multiply(rva, pa);
    angles = angles + vector_multiply(fva, ra);
    return (angles + (0, stumbleAngles[1], 0));
}
teslaAttack() {
    enemy = getAiSpeciesArray("axis", "all");
    for (a = 0; a < enemy.size; a++) {
        enemy[a] thread tesla_play_death_fx();
        enemy[a] doDamage(enemy[a].health + 666, enemy[a].origin);
    }
}
spawnZombie(org, friendly) {
    zomb = spawn_zombie(level.enemy_spawns[1]);
    origin = bulletTrace(self getEye(), self getEye() + (vectorScale(anglesToforward(self getPlayerAngles()), 200)), false, zomb)["position"];
    zomb zombie_setup_attack_properties();
    if (!isDefined(org)) {
        zomb forceTeleport(origin);
        zomb.first_node.barrier_chunks = undefined;
        zomb.first_node.angles = undefined;
        zomb.first_node = undefined;
        zomb.target = undefined;
        zomb.attacking_node = undefined;
        zomb.attacking_spot_index = undefined;
        zomb notify("goal");
    } else zomb forceTeleport(org);
    if (!isDefined(friendly)) zomb thread find_flesh();
    zomb pushPlayer(true);
    return zomb;
}
spawn_zombie(spawner) {
    guy = spawner stalingradSpawn();
    spawner.count = 666;
    return guy;
}
spawnDog() {
    dog = spawn_zombie(level.enemy_dog_spawns[0]);
    origin = bulletTrace(self getEye(), self getEye() + (vectorScale(anglesToforward(self getPlayerAngles()), 200)), false, dog)["position"];
    dog forceTeleport(origin);
    self thread dogSpawnFx(dog, origin);
}
dogSpawnFx(ai, origin) {
    ai forceTeleport(origin);
    playFx(level._effect["lightning_dog_spawn"], origin);
    playSoundAtPosition("pre_spawn", origin);
    wait 1.5;
    playSoundAtPosition("bolt", origin);
    earthQuake(0.5, 0.75, origin, 1000);
    playRumbleOnPosition("explosion_generic", origin);
    playsoundatposition("spawn", origin);
    ai zombie_setup_attack_properties_dog();
    wait .01;
    ai show();
}
bodyGuards() {
    if (!isDefined(self.bodyGuards)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.bodyGuards = true;
        self thread doBodyGuards();
    } else {
        self setOptionColor(divideColor(255, 255, 255));
        self.bodyGuards = undefined;
        for (a = 0; a < self.createZombies.size; a++) self.createZombies[a] delete();
        anim.idleAnimArray["stand"][0][0] = % ai_zombie_idle_v1_delta;
    }
}
doBodyGuards() {
    self.createZombies = [];
    zombieArray = getAiSpeciesArray("axis", "all");
    if (zombieArray.size < 16)
        for (a = 0; a < 4; a++) {
            self.createZombies[self.createZombies.size] = self spawnZombie(self.origin + (cos(0 + 90 * a) * 50, sin(0 + 90 * a) * 50, 0), true);
            self.createZombies[a] detachAll();
            self.createZombies[a].headModel = "char_jap_impinf_officer_head";
            self.createZombies[a] attach(self.createZombies[a].headModel, "", true);
            self.createZombies[a].hatModel = "char_jap_impinf_officer_hat_zomb";
            self.createZombies[a] attach(self.createZombies[a].hatModel);
            wait .05;
        } else {
            for (a = 0; a < zombieArray.size; a++) {
                if (isAlive(zombieArray[a])) self.createZombies[self.createZombies.size] = zombieArray[a];
                if (self.createZombies.size == 4) break;
            }
        }
    for (a = 0; a < 4; a++) {
        self.createZombies[a] forceTeleport(self.origin + (cos(0 + 90 * a) * 50, sin(0 + 90 * a) * 50, 0));
        self.createZombies[a] thread guardProtectPlayer(self);
    }
}
guardProtectPlayer(player) {
    self notSolid();
    self.ignoreme = true;
    self.grenadeAwareness = 1;
    self.ignoreSuppression = false;
    self.suppressionThreshold = 0;
    self.noDodgeMove = false;
    self.dontShootWhileMoving = false;
    self.pathenemylookahead = 1;
    self.is_zombie = false;
    self.dropweapon = true;
    self pushPlayer(false);
    weap = "ray_gun";
    if (getMap() == "nzf") weap = "ray_gun_upgraded";
    self animscripts\shared::placeWeaponOn(weap, "right");
    self.team = "allies";
    self.health = 1000000;
    self thread enableGodMode();
    self thread alwaysIgnorePlayer();
    self.zombie_move_speed = "sprint";
    self.zombie_custom_speed = true;
    var = randomintrange(1, 8);
    self set_run_anim("+speed+" +
        var);
    self.run_combatanim = level.scr_anim["zombie"]["+speed+" +
        var
    ];
    while (isDefined(self)) {
        anim.idleAnimArray["stand"][0][0] = % casual_stand_v2_idle;
        self pushPlayer(false);
        self.ignoreall = false;
        self orientMode("face default");
        self setGoalPos(player.origin);
        if (self.origin[2] - player.origin[2] >= 50 || player.origin[2] - self.origin[2] >= 50 || distance(self.origin, player.origin) >= 350) {
            self.is_zombie = true;
        }
        if (self.origin[2] - player.origin[2] < 50 && player.origin[2] - self.origin[2] < 50 && distance(self.origin, player.origin) < 350) {
            self.is_zombie = false;
        }
        wait .05;
    }
}
alwaysIgnorePlayer() {
    while (isDefined(self)) {
        self.ignore_player = true;
        wait .05;
    }
}
zomVisibility() {
    if (!isDefined(level.zombieVisible)) {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "ZOMBIES", self getPointer());
        level.zombieVisible = true;
        level thread zombieHide();
    } else {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "ZOMBIES", self getPointer());
        level.zombieVisible = undefined;
        zom = getAiSpeciesArray("axis", "all");
        for (a = 0; a < zom.size; a++) zom[a] show();
    }
}
zombieHide() {
    while (isDefined(level.zombieVisible)) {
        zom = getAiSpeciesArray("axis", "all");
        for (a = 0; a < zom.size; a++) zom[a] hide();
        wait .05;
    }
}
zombieSpeed(speed, num) {
    level notify("NEW_Z_SPEED");
    if (level.zombieSpeedSet != speed) level.zombieSpeedSet = speed;
    else {
        zom = getAiArray("axis");
        for (a = 0; a < zom.size; a++) zom[a] thread setZombieSpeed("reset", (level.round_number - 1) * 8);
        level.zombieSpeedSet = undefined;
        return;
    }
    pointer = self getPointer();
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "ZOMBIE_SPEED", pointer);
    self doZombieSpeed(speed, num);
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "ZOMBIE_SPEED", pointer);
}
doZombieSpeed(speed, num) {
    level endon("NEW_Z_SPEED");
    while (1) {
        zom = getAiArray("axis");
        for (a = 0; a < zom.size; a++)
            if (zom[a].zombie_move_speed != speed && !isDefined(zom[a].zombie_custom_speed) || isDefined(zom[a].zombie_custom_speed) && speed != "Custom") zom[a] thread setZombieSpeed(speed, num);
        wait .05;
    }
}
setZombieSpeed(speed, num) {
    if (isDefined(num)) level.zombie_move_speed = num;
    if (speed != "crawl") {
        self.has_legs = true;
        self allowedStances("stand");
        death_anims = level._zombie_deaths["zombie"];
        self.deathanim = random(death_anims);
        self.crouchRunAnim = undefined;
        self.crouchrun_combatanim = undefined;
    }
    switch (speed) {
    case "crawl":
        self allowedStances("crouch");
        self.has_legs = false;
        self.zombie_move_speed = speed;
        self.zombie_custom_speed = undefined;
        var = randomintrange(1, 6);
        dead = randomintrange(3, 5);
        array = [];
        array[0] = % ai_zombie_crawl_death_v1;
        array[1] = % ai_zombie_crawl_death_v2;
        self.deathanim = array[randomint(2)];
        self set_run_anim("death" + dead);
        self.run_combatanim = level.scr_anim["zombie"]["crawl" +
            var
        ];
        self.crouchRunAnim = level.scr_anim["zombie"]["crawl" +
            var
        ];
        self.crouchrun_combatanim = level.scr_anim["zombie"]["crawl" +
            var
        ];
        break;
    case "walk":
        self.zombie_move_speed = speed;
        self.zombie_custom_speed = undefined;
        var = randomintrange(1, 8);
        self set_run_anim("walk" +
            var);
        self.run_combatanim = level.scr_anim["zombie"]["walk" +
            var
        ];
        break;
    case "run":
        self.zombie_move_speed = speed;
        self.zombie_custom_speed = undefined;
        var = randomintrange(1, 6);
        self set_run_anim("run" +
            var);
        self.run_combatanim = level.scr_anim["zombie"]["run" +
            var
        ];
        break;
    case "sprint":
        self.zombie_move_speed = speed;
        self.zombie_custom_speed = undefined;
        var = randomintrange(1, 4);
        self set_run_anim("sprint" +
            var);
        self.run_combatanim = level.scr_anim["zombie"]["sprint" +
            var
        ];
        break;
    case "custom":
        self.zombie_move_speed = "sprint";
        self.zombie_custom_speed = true;
        var = randomintrange(1, 8);
        self set_run_anim("+speed+" +
            var);
        self.run_combatanim = level.scr_anim["zombie"]["+speed+" +
            var
        ];
        break;
    case "reset":
        rand = randomIntRange(level.zombie_move_speed, level.zombie_move_speed + 35);
        if (rand <= 35) self thread setZombieSpeed("walk");
        else if (rand <= 70) self thread setZombieSpeed("run");
        else self thread setZombieSpeed("sprint");
        break;
    }
}
forceZombieCrawler() {
    if (!isDefined(self)) return;
    if (self.gibbed) return;
    refs[0] = "no_legs";
    self.a.gib_ref = animscripts\death::get_random(refs);
    self.has_legs = false;
    self allowedStances("crouch");
    animation = randomInt(5);
    if (getMap() == "nzp") animation = randomInt(3);
    switch (animation) {
    case 0:
        self.deathanim = % ai_zombie_crawl_death_v1;
        self set_run_anim("death3");
        self.run_combatanim = level.scr_anim["zombie"]["crawl1"];
        self.crouchRunAnim = level.scr_anim["zombie"]["crawl1"];
        self.crouchrun_combatanim = level.scr_anim["zombie"]["crawl1"];
        break;
    case 1:
        self.deathanim = % ai_zombie_crawl_death_v2;
        self set_run_anim("death4");
        self.run_combatanim = level.scr_anim["zombie"]["crawl2"];
        self.crouchRunAnim = level.scr_anim["zombie"]["crawl2"];
        self.crouchrun_combatanim = level.scr_anim["zombie"]["crawl2"];
        break;
    case 2:
        self.deathanim = % ai_zombie_crawl_death_v1;
        self set_run_anim("death3");
        self.run_combatanim = level.scr_anim["zombie"]["crawl3"];
        self.crouchRunAnim = level.scr_anim["zombie"]["crawl3"];
        self.crouchrun_combatanim = level.scr_anim["zombie"]["crawl3"];
        break;
    case 3:
        self.deathanim = % ai_zombie_crawl_death_v2;
        self set_run_anim("death4");
        self.run_combatanim = level.scr_anim["zombie"]["crawl4"];
        self.crouchRunAnim = level.scr_anim["zombie"]["crawl4"];
        self.crouchrun_combatanim = level.scr_anim["zombie"]["crawl4"];
        break;
    case 4:
        self.deathanim = % ai_zombie_crawl_death_v1;
        self set_run_anim("death3");
        self.run_combatanim = level.scr_anim["zombie"]["crawl5"];
        self.crouchRunAnim = level.scr_anim["zombie"]["crawl5"];
        self.crouchrun_combatanim = level.scr_anim["zombie"]["crawl5"];
        break;
    }
    if (self.health > 50) {
        self.health = 50;
        self thread animscripts\death::do_gib();
    }
}
gunnerZombs() {
    level notify("gunnerZom_over");
    if (!isDefined(level.gunnerZom)) {
        level.gunnerZom = true;
        level.friendlyGunnerZom = undefined;
        for (a = 0; a < getPlayers().size; a++) {
            getPlayers()[a] thread arraySetOptionColor(true, "ZOMBIES", self getPointer());
            getPlayers()[a] thread arraySetOptionColor(undefined, "ZOMBIES", self getPointer() + 1);
        }
        level thread gunZomDo();
    } else {
        level.gunnerZom = undefined;
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "ZOMBIES", self getPointer());
    }
}
gunZomDo() {
    level endon("gunnerZom_over");
    while (1) {
        enemy = getAISpeciesArray("axis", "all");
        for (a = 0; a < enemy.size; a++)
            if (!isDefined(enemy[a].isGunner)) enemy[a] thread enemyAttack();
        wait .05;
    }
}
enemyAttack() {
    self endon("death");
    self.isGunner = true;
    if (getMap() == "nzf")
        while (1) {
            wait .05;
            if (self inMap()) break;
            if (!isDefined(level.gunnerZom)) {
                self.isGunner = undefined;
                return;
            }
        }
    wait 1.5;
    if (getMap() == "nzp" || getMap() == "nza") self.weapon = "mp40";
    else self.weapon = "zombie_ppsh";
    self.grenadeAwareness = 1;
    self.ignoreSuppression = false;
    self.suppressionThreshold = 0;
    self.noDodgeMove = false;
    self.dontShootWhileMoving = false;
    self.pathenemylookahead = 1;
    self allowedStances("crouch");
    self.is_zombie = false;
    self.dropweapon = true;
    self pushPlayer(false);
    self thread animscripts\grenade_return_throw::main();
    self.closestEnemy = getClosest(getAiSpeciesArray("axis", "all"), self.origin);
    self thread zombieShoot();
    self thread zombieMove();
    while (1) {
        closestEnemy = getClosest(getAiSpeciesArray("allies", "all"), self.origin);
        self.closestEnemy = closestEnemy;
        wait .05;
    }
}
zombieShoot() {
    self endon("death");
    while (1) {
        if (self damageConeTrace(self.closestEnemy.origin, self.closestEnemy) > .75) {
            hitLoc = self.closestEnemy getTagOrigin("j_head");
            self setLookAt(hitLoc, .05);
            self aimAtPos(hitLoc, .1);
            self shoot();
            wait(weaponFireTime(self.weapon));
        } else wait .05;
    }
}
zombieMove() {
    self endon("death");
    while (1) {
        hitLoc = self.closestEnemy getTagOrigin("j_head");
        self setLookAt(hitLoc, .05);
        self aimAtPos(hitLoc, .1);
        self setRunToPos(self.closestEnemy.origin);
        wait .1;
    }
}
friendlyGunnerZombs() {
    level notify("gunnerZom_over");
    if (!isDefined(level.friendlyGunnerZom)) {
        level.friendlyGunnerZom = true;
        level.gunnerZom = undefined;
        for (a = 0; a < getPlayers().size; a++) {
            getPlayers()[a] thread arraySetOptionColor(true, "ZOMBIES", self getPointer());
            getPlayers()[a] thread arraySetOptionColor(undefined, "ZOMBIES", self getPointer() - 1);
        }
        level thread friendlyZombieGunners();
    } else {
        level.friendlyGunnerZom = undefined;
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "ZOMBIES", self getPointer());
    }
}
friendlyZombieGunners() {
    level endon("gunnerZom_over");
    while (1) {
        enemy = getAISpeciesArray("axis", "all");
        for (a = 0; a < enemy.size; a++)
            if (!isDefined(enemy[a].isGunner)) enemy[a] thread friendlyGunners();
        wait .05;
    }
}
friendlyGunners() {
    self endon("death");
    self.isGunner = true;
    if (getMap() == "nzf")
        while (1) {
            wait .05;
            if (self inMap()) break;
            if (!isDefined(level.friendlyGunnerZom)) {
                self.isGunner = undefined;
                return;
            }
        }
    wait 1.5;
    self.weapon = "zombie_thompson";
    self.ignoreme = true;
    self.grenadeAwareness = 1;
    self.ignoreSuppression = false;
    self.suppressionThreshold = 0;
    self.noDodgeMove = false;
    self.dontShootWhileMoving = false;
    self.pathenemylookahead = 1;
    self allowedStances("crouch");
    self.is_zombie = false;
    self.dropweapon = true;
    self pushPlayer(false);
    self thread animscripts\grenade_return_throw::main();
    self thread zombshoot2();
    playfxontag(level._effect["powerup_on"], self, "j_head");
    self.team = "allies";
}
zombshoot2() {
    self endon("death");
    while (1) {
        close_zombie = getClosest(self.origin, getAiSpeciesArray("axis", "all"));
        hitLoc = close_zombie gettagorigin("j_head");
        if (close_zombie damageConeTrace(self.origin, self) > .75 && isDefined(close_zombie)) {
            self setLookAt(hitLoc, 0.05);
            self aimAtPos(hitLoc, 0.1);
            self shoot();
            wait(weaponFireTime(self.weapon));
        } else {
            self setLookAt(hitLoc, 0.05);
            self aimAtPos(hitLoc, 0.1);
            self setRunToPos(close_zombie.origin);
        }
        wait .05;
    }
}
headlessZombies() {
    zom = getAiSpeciesArray("axis", "all");
    for (i = 0; i < zom.size; i++) zom[i] detachAll();
}
zombieDefault() {
    zom = getAiSpeciesArray("axis", "all");
    for (i = 0; i < zom.size; i++) zom[i] setModel("defaultactor");
}
zombiePush() {
    if (!isDefined(level.zombiePush)) {
        level.zombiePush = true;
        level thread doZombiePush(false);
        array_thread(getPlayers(), ::arraySetOptionColor, undefined, "ZOMBIES", getPlayers()[0].menu["ZOMBIES"]["option"].size - 1);
    } else {
        level notify("zombiePush");
        level.zombiePush = undefined;
        zom = getAiArray("axis");
        for (a = 0; a < zom.size; a++) zom[a] pushPlayer(true);
        array_thread(getPlayers(), ::arraySetOptionColor, true, "ZOMBIES", getPlayers()[0].menu["ZOMBIES"]["option"].size - 1);
    }
}
doZombiePush(arg) {
    level endon("zombiePush");
    while (1) {
        zom = getAiArray("axis");
        for (a = 0; a < zom.size; a++) zom[a] pushPlayer(arg);
        wait .5;
    }
}
freezeZombies() {
    if (getDvarInt("g_ai") == 1) {
        array_thread(getPlayers(), ::arraySetOptionColor, true, "ZOMBIES", self getPointer());
        setLobbyDvar("g_ai", "0");
    } else if (getDvarInt("g_ai") == 0) {
        array_thread(getPlayers(), ::arraySetOptionColor, undefined, "ZOMBIES", self getPointer());
        setLobbyDvar("g_ai", "1");
    }
}
disablezspawn() {
    if (!isDefined(level.zspawn)) {
        array_thread(getPlayers(), ::arraySetOptionColor, true, "ZOMBIES", self getPointer());
        setLobbyDvar("ai_disableSpawn", "1");
        level.zspawn = true;
    } else {
        array_thread(getPlayers(), ::arraySetOptionColor, undefined, "ZOMBIES", self getPointer());
        setLobbyDvar("ai_disableSpawn", "0");
        level.zspawn = undefined;
    }
}
teleportingZombies() {
    if (!isDefined(level.teleZoms)) {
        array_thread(getPlayers(), ::arraySetOptionColor, true, "ZOMBIES", self getPointer());
        level.teleZoms = true;
        level thread init_teleZoms();
    } else {
        array_thread(getPlayers(), ::arraySetOptionColor, undefined, "ZOMBIES", self getPointer());
        level.teleZoms = undefined;
        level notify("teleZoms_over");
    }
}
init_teleZoms() {
    level endon("teleZoms_over");
    while (1) {
        wait(5);
        zom = getAiSpeciesArray("axis", "all");
        if (!isDefined(zom) || zom.size <= 0) continue;
        target = zom[randomInt(zom.size)];
        plr = getPlayers()[randomInt(getPlayers().size)];
        array = [];
        array[0] = target;
        for (a = 0; a < zom.size; a++) {
            if (zom[a] == target) continue;
            if (distance(target.origin, zom[a].origin) < 75) array[array.size] = zom[a];
        }
        for (a = 0; a < array.size; a++) {
            zom = array[a];
            if (isDefined(zom.napalm)) continue;
            randX = randomIntRange(-150, 150);
            randY = randomIntRange(-150, 150);
            playFx(loadFx("maps/zombie/fx_transporter_beam"), zom.origin);
            targetPos = plr.origin + (randX, randY, 0);
            endPos = physicsTrace(plr.origin, targetPos);
            zom forceTeleport(endPos, vectorToAngles(zom.origin - plr.origin));
            zom zombie_setup_attack_properties();
            zom thread find_flesh();
            playFx(loadFx("maps/zombie/fx_transporter_beam"), zom.origin);
            wait .2;
        }
    }
}
shootZomToCh() {
    if (!isDefined(self.zomToCh)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.zomToCh = true;
        self thread zomToCh();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.zomToCh = undefined;
        self notify("ZOMB_CH_OFF");
    }
}
zomToCh() {
    self endon("death");
    self endon("disconnect");
    self endon("ZOMB_CH_OFF");
    while (1) {
        self waittill("weapon_fired");
        zom = getAiSpeciesArray("axis", "all");
        for (i = 0; i < zom.size; i++) {
            zom[i] forceTeleport(self lookPos());
            zom[i] setRunToPos(self.origin);
        }
    }
}
teleportZomToCh() {
    zom = getAiSpeciesArray("axis", "all");
    for (a = 0; a < zom.size; a++) {
        zom[a] forceTeleport(self lookPos());
        zom[a] zombie_setup_attack_properties();
        zom[a] thread find_flesh();
    }
}
summonZombies() {
    zom = getAiSpeciesArray("axis", "all");
    for (a = 0; a < zom.size; a++) {
        zom[a] forceTeleport(self getOrigin());
        zom[a] zombie_setup_attack_properties();
        zom[a] thread find_flesh();
    }
}
musicZombies() {
    snd = strTok("mx_jugger_jingle;mx_speed_jingle;mx_doubletap_jingle;mx_revive_jingle;mx_packa_jingle", ";");
    zom = getAiSpeciesArray("axis", "all");
    for (a = 0; a < zom.size; a++) zom[a] playSound(snd[randomInt(snd.size)]);
}
zStance(stance) {
    zombies = getAiSpeciesArray("axis", "all");
    for (i = 0; i < zombies.size; i++) zombies[i] allowedStances(stance);
}
attackThisPlayer(playerIndex) {
    if (!self goodInput(playerIndex) || self == getPlayers()[playerIndex]) return;
    level notify("ATTACK_NEW_PLAYER");
    level.attackThisPlayer = getPlayers()[playerIndex];
    if (level.attackPlayerPointer != self getPointer()) {
        if (isDefined(level.attackPlayerPointer)) array_thread(getPlayers(), ::arraySetOptionColor, undefined, "ATTACK_PLAYER", level.attackPlayerPointer);
        level.attackPlayerPointer = self getPointer();
        array_thread(getPlayers(), ::arraySetOptionColor, true, "ATTACK_PLAYER", level.attackPlayerPointer);
        self thread allZombiesFollow();
    } else {
        array_thread(getPlayers(), ::arraySetOptionColor, undefined, "ATTACK_PLAYER", level.attackPlayerPointer);
        level.attackPlayerPointer = undefined;
        level.attackThisPlayer = undefined;
    }
}
allZombiesFollow() {
    level endon("ATTACK_NEW_PLAYER");
    while (true) {
        if (isDefined(level.attackThisPlayer.noTarget)) level.attackThisPlayer noTarget();
        zombs = getAISpeciesArray("axis", "all");
        for (a = 0; a < zombs.size; a++)
            if (!isDefined(zombs[a].attackFollowPlayer)) zombs[a] thread followPlayer();
        wait .05;
    }
}
followPlayer() {
    self endon("death");
    self.attackFollowPlayer = true;
    while (isDefined(level.attackThisPlayer)) {
        self.favoriteenemy = undefined;
        self setGoalPos(level.attackThisPlayer.origin);
        wait .05;
    }
    self.attackFollowPlayer = undefined;
}
dvarEditor(dvar, multiply, normal) {
    self thread lockMenu("HALF");
    self setMenuTitle(self buildFromMenu()[self getCurrentMenu()]["option"][self getPointer()]);
    self setInstructions("^2Dvar Editor: ^7[{+attack}]/[{+speed_throw}]: Edit Dvar Value - [{+activate}]: Set Dvar - [{+melee}]: Cancel");
    editor = [];
    var = 0;
    if (getDvarFloat(dvar) > getDvarInt(dvar)) var = getDvarFloat(dvar);
    else var = getDvarInt(dvar);
    curs =
        var;
    curs /= multiply;
    WIDTH = 40;
    editor["top_bar"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2) - 70.5, self.menu["positioning_Y"] - 65, 141, 1, (1, 1, 1), "white_line_faded_center", 12, 1);
    editor["bottom_bar"] = self createRectangle("LEFT", "LEFT", editor["top_bar"].x, self.menu["positioning_Y"] + 65, 141, 1, (1, 1, 1), "white_line_faded_center", 12, 1);
    editor["bg_bar"] = self createRectangle("BOTTOM", "LEFT", editor["top_bar"].x + 70.5, self.menu["positioning_Y"] + 60, WIDTH, 120, divideColor(100, 164, 247), "white", 12, .6);
    editor["bar"] = self createRectangle("BOTTOM", "LEFT", editor["bg_bar"].x, self.menu["positioning_Y"] + 60, WIDTH, int((curs + 1) * (120 / 101)), divideColor(255, 255 - curs * (255 / 100), 255 - curs * (255 / 100)), "white", 13, .6);
    editor["default_bar"] = self createRectangle("BOTTOM", "LEFT", editor["bar"].x, editor["bar"].y - int((curs + 1) * (120 / 101)) + .75, WIDTH, 1, (0, 1, 0), "white", 14, 1);
    editor["default_bar_text"] = createText(self getFont(), 1, "LEFT", "LEFT", editor["top_bar"].x + 2, editor["top_bar"].y - 11.25, 22, .8, "Default: " + normal);
    editor["dvar_val"] = createText(self getFont(), 1, "LEFT", "LEFT", editor["default_bar_text"].x, editor["bottom_bar"].y + 11.25, 22, .8, "");
    editor["dvar_val"].label = self buildFromMenu()["option"][self getPointer()] + ": ^2";
    editor["dvar_val"] setValue(var);
    wait .25;
    while (!self downedCloseMenu()) {
        if (self adsButtonPressed() || self attackButtonPressed()) {
            curs -= self adsButtonPressed();
            curs += self attackButtonPressed();
            if (curs < 0) curs = 100;
            if (curs > 100) curs = 0;
            editor["bar"] scaleOverTime(.05, WIDTH, int((curs + 1) * (120 / 101)));
            editor["default_bar"] thread hudMoveY(editor["bar"].y - int((curs + 1) * (120 / 101)) + .75, .1);
            editor["bar"].color = divideColor(255, 255 - curs * (255 / 100), 255 - curs * (255 / 100));
            editor["bar"] fadeOverTime(0.5);
            editor["dvar_val"] setValue(multiply * curs);
        }
        if (self useButtonPressed()) self setLobbyDvar(dvar, multiply * curs);
        if (self meleeButtonPressed()) break;
        wait .05;
    }
    self destroyAll(editor);
    self resetInstructions();
    self unlockMenu("unlockHalf");
}
adjustBright() {
    self openMenu("ingameoptions_brightness");
}
adjustVol() {
    self openMenu("ingameoptions_volume");
}
unlimitedSprint() {
    if (!isDefined(level.uSprint)) {
        level.uSprint = true;
        array_thread(getPlayers(), ::arraySetOptionColor, true, "SERVER", 11);
        setLobbyDvar("player_sprintUnlimited", 1);
    } else {
        level.uSprint = undefined;
        array_thread(getPlayers(), ::arraySetOptionColor, undefined, "SERVER", 11);
        setLobbyDvar("player_sprintUnlimited", 0);
    }
}
unlimitedAmmoAll() {
    if (!isDefined(level.unlimitedAmmo)) {
        level.unlimitedAmmo = true;
        array_thread(getPlayers(), ::arraySetOptionColor, true, "SERVER", 12);
        setLobbyDvar("player_sustainAmmo", 1);
        self giveMaxAmmo(self getCurrentWeapon());
        self setWeaponAmmoClip(self getCurrentWeapon(), 1000);
    } else {
        level.unlimitedAmmo = undefined;
        array_thread(getPlayers(), ::arraySetOptionColor, undefined, "SERVER", 12);
        setLobbyDvar("player_sustainAmmo", 0);
    }
}
autoRevive() {
    if (!isDefined(level.autoRevive)) {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "SERVER", self getPointer());
        level.autoRevive = true;
        level thread doRevive();
    } else {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "SERVER", self getPointer());
        level.autoRevive = undefined;
        level notify("autoReviveOver");
    }
}
doRevive() {
    level endon("autoReviveOver");
    while (1) {
        for (a = 0; a < getPlayers().size; a++)
            if (isDefined(getPlayers()[a].revivetrigger)) getPlayers()[a] thread reviveMeh();
        wait .05;
    }
}
reviveMeh() {
    self endon("death");
    self endon("disconnect");
    if (isDefined(self.revivngPlayer)) return;
    self.revivngPlayer = true;
    self thread createProgressBar(3, "Reviving", 2, "Revived!");
    wait 3;
    self thread maps\_laststand::revive_force_revive();
    wait .05;
    self.revivngPlayer = undefined;
}
shootRevive() {
    if (!isDefined(level.shootRevive)) {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "SERVER", self getPointer());
        level.shootRevive = true;
        SetCollectible("collectible_morphine");
    } else {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "SERVER", self getPointer());
        level.shootRevive = undefined;
        unSetCollectible("collectible_morphine");
    }
}
flyableUfo() {
    self thread lockMenu("ALL");
    self thread setInstructions("^2Flyable Ufo: ^7[{+speed_throw}]: Navigate Ufo - [{+attack}]: Shoot - [{+activate}]: Drop Bomb - [{+melee}]: Exit Ufo");
    self enableInvulnerability();
    savedOrigin = self.origin;
    ufo = [];
    ufo["top"] = spawnSM((self.origin[0], self.origin[1], 800), "zombie_teleporter_pad", 1);
    ufo["bottom"] = spawnSM((ufo["top"].origin[0], ufo["top"].origin[1], 800), "zombie_teleporter_pad", (0, 0, -180), 1);
    ufo["fx"] = spawnSM((ufo["top"].origin[0], ufo["top"].origin[1], 800), "tag_origin", (-270, 0, 0), 1);
    ufo["bottom"] linkTo(ufo["top"]);
    ufo["fx"] linkTo(ufo["top"]);
    ufo["top"] thread ufoAngles(self);
    self setClientDvar("cg_thirdPerson", 1);
    self setClientDvar("cg_thirdPersonRange", 500);
    self setClientDvar("ui_hud_hardcore", 1);
    self setClientDvar("cg_drawCrosshair", 0);
    self playerLinkTo(ufo["top"]);
    self thread javelinHud();
    playFxOnTag(loadFx("maps/zombie/fx_zombie_factory_marker"), ufo["fx"], "tag_origin");
    playFxOnTag(loadFx("maps/mp_maps/fx_mp_light_lamp"), ufo["fx"], "tag_origin");
    self hide();
    self disableWeapons();
    self disableOffHandWeapons();
    self.justShot = undefined;
    wait .3;
    while (1) {
        if (self adsButtonPressed()) {
            vec = anglesToForward(self getPlayerAngles());
            ufo["top"] moveTo(ufo["top"].origin + (vec[0] * 45, vec[1] * 45, 0), .1);
        }
        if (self attackButtonPressed()) {
            if (!isDefined(self.justShot)) {
                self.justShot = true;
                self thread ufoShoot(ufo["top"].origin, ufo["top"]);
            }
        }
        if (self useButtonPressed()) {
            if (!isDefined(self.justShotNuke)) {
                self.justShotNuke = true;
                self thread ufoNuke();
            }
        }
        if (self meleeButtonPressed()) break;
        wait .05;
    }
    keys = getArrayKeys(ufo);
    for (a = 0; a < keys.size; a++) ufo[keys[a]] remove();
    self setOrigin(savedOrigin);
    self enableWeapons();
    self enableOffHandWeapons();
    self setClientDvar("cg_thirdPerson", 0);
    self setClientDvar("cg_thirdPersonRange", 120);
    self setClientDvar("ui_hud_hardcore", 0);
    self setClientDvar("cg_drawCrosshair", 1);
    self show();
    self.justShot = undefined;
    self resetInstructions();
    self unlockMenu();
}
ufoAngles(who) {
    while (isDefined(self)) {
        who takeWeapon("stielhandgranate");
        self rotateTo(who getPlayerAngles(), .1);
        wait .05;
    }
}
ufoShoot(org, ufo) {
    self endon("disconnect");
    self endon("death");
    for (a = 0; a < 5; a++) {
        if (!isDefined(ufo)) break;
        orb = spawnSM(org, "tag_origin");
        playFxOnTag(loadFx("misc/fx_zombie_powerup_on"), orb, "tag_origin");
        playSoundAtPosition("weap_rgun_fire", org);
        orb moveTo(self lookPos(), .4);
        orb thread impactSound("grenade_explode");
        wait .05;
    }
    self.justShot = undefined;
}
impactSound(sound) {
    self waittill("movedone");
    playSoundAtPosition(sound, self.origin);
    playFx(loadFx("misc/fx_zombie_powerup_grab"), self.origin);
    playFx(loadFx("misc/fx_zombie_powerup_wave"), self.origin);
    killZombiesWithinDistance(self.origin, 150, "tesla");
    doPlayerDamage(self.origin, 150);
    earthQuake(.4, 1, self.origin, 100);
    self remove();
}
ufoNuke() {
    self endon("disconnect");
    self endon("death");
    nuke = spawnSM(self.origin - (0, 0, 40), "zombie_bomb", (90, 0, 0), 1);
    playSoundAtPosition("weap_pnzr_fire", nuke.origin);
    collision = bulletTrace(nuke.origin, nuke.origin - (0, 0, 5000), 0, self)["position"];
    nuke moveTo(collision, .35);
    nuke waittill("movedone");
    playFx(loadFx("misc/fx_zombie_mini_nuke"), nuke.origin + (0, 0, 30));
    playFx(loadFx("misc/fx_zombie_mini_nuke_hotness"), nuke.origin + (0, 0, 30));
    playSoundAtPosition("nuke_flash", nuke.origin + (0, 0, 30));
    playSoundAtPosition("nuked", nuke.origin + (0, 0, 30));
    killZombiesWithinDistance(nuke.origin + (0, 0, 30), 200, "flame");
    doPlayerDamage(nuke.origin + (0, 0, 30), 200);
    earthQuake(1, 1, nuke.origin + (0, 0, 30), 100);
    nuke remove();
    self.justShotNuke = true;
    wait 1;
    self.justShotNuke = undefined;
}
javelinHud() {
    modelTarget = spawnSM(self lookPos() - (0, 0, 50), "tag_origin");
    target = self spawnObjPointer(self, modelTarget.origin, "javelin_hud_target", true, self);
    target setTargetEnt(modelTarget);
    while (1) {
        modelTarget moveTo(self lookPos() - (0, 0, 50), .15);
        if (self meleeButtonPressed()) break;
        wait .05;
    }
    target clearTargetEnt();
    target destroy();
    modelTarget remove();
}
flyableHarrier() {
    self thread lockMenu("ALL");
    savedOrigin = self getOrigin();
    self setClientDvar("cg_thirdPerson", "1");
    self setClientDvar("cg_thirdPersonRange", "500");
    self setClientDvar("cg_drawCrosshair", "1");
    self setClientDvar("ui_hud_hardcore", "1");
    harrier = spawnSM(self.origin, "defaultvehicle");
    self playerLinkTo(harrier);
    self disableWeapons();
    self enableGodMode();
    hud = [];
    hud["BG"] = self createRectangle("LEFT", "LEFT", 0, 0, self.menu["width"], 27, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
    hud["EDG"] = self createRectangle("LEFT", "LEFT", hud["BG"].x - 2, hud["BG"].y, self.menu["width"] + 4, 31, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, self.menu["Edging_Alpha"]);
    hud["WEAP"] = self createText(self getFont(), 1.1, "LEFT", "LEFT", hud["BG"].x + 3, hud["BG"].y - 6, 20, 1, "Weapon Loaded: ^1Missiles");
    hud["MPH"] = self createText(self getFont(), 1.1, "LEFT", "LEFT", hud["BG"].x + 3, hud["BG"].y + 6, 20, 1, undefined);
    hud["MPH"].label = "Speed: ^2";
    self hide();
    speed = 30;
    self setInstructions("^2Harrier: ^7[{+speed_throw}]: Slow Down - [{+frag}]: Speed Up - [{+attack}]: Fire Missiles - [{+melee}]: Exit Harrier");
    while (1) {
        hud["MPH"] setValue(speed);
        harrier.angles = self getPlayerAngles();
        vec = anglesToForward(self getPlayerAngles());
        end = (vec[0] * (speed * .7), vec[1] * (speed * .7), vec[2] * (speed * .7));
        harrier moveTo(harrier.origin + end, .05);
        if (self fragButtonPressed())
            if (speed < 150) speed += 5;
        if (self adsButtonPressed())
            if (speed > 0) speed -= 5;
        if (self attackButtonPressed()) magicBullet("colt_dirty_harry", self getEye(), vectorScale(anglesToForward(self getPlayerAngles()), 100000000), self);
        if (self meleeButtonPressed()) {
            harrier remove();
            self thread godCheck();
            self setOrigin(savedOrigin);
            self destroyAll(hud);
            self setClientDvar("cg_thirdPerson", "0");
            self setClientDvar("cg_drawCrosshair", "1");
            self SetClientDvar("cg_thirdPersonRange", "120");
            self setClientDvar("ui_hud_hardcore", "0");
            self thread unlockMenu();
            self resetInstructions();
            self enableWeapons();
            self show();
            break;
        }
        wait 0.05;
    }
}
littleHeli() {
    self thread lockMenu("ALL");
    self setInstructions("^2Little Heli: ^7[{+attack}]: Speed Up - [{+speed_throw}]: Slow Down - [{+frag}]: Move Up - [{+activate}]: Fire Machine Gun - [{+melee}]: Exit Little Heli");
    vecF = anglesToForward(self.angles);
    vecR = anglesToRight(self.angles);
    angF = vectorToAngles(vecF);
    seat = spawnSM(self.origin + vecF * 10, "tag_origin", (0, angF[1], 0));
    self enableGodMode();
    self playerlinkto(seat);
    self setClientDvar("cg_thirdperson", 1);
    self setClientDvar("cg_thirdpersonrange", 270);
    self disableWeapons();
    self hide();
    heli = [];
    heli[heli.size] = spawnSM(self.origin + (0, 0, 43) + vecF * 10, "test_sphere_silver");
    heli[heli.size] = spawnSM(heli[0].origin + (0, 0, 25), "zombie_zapper_tesla_coil");
    heli[heli.size] = spawnSM(heli[0].origin + (0, 0, 44) + vecR * 12, "zombie_treasure_box_lid", (0, angF[1], 0));
    heli[2] linkTo(heli[1]);
    heli[heli.size] = spawnSM(heli[0].origin + vecF * -93 - vecR * 5, "zombie_zapper_tesla_coil", (0, angF[1] + 180, 270));
    for (a = 0; a < 3; a++) {
        heli[heli.size] = spawnSM(heli[0].origin + vecF * -93 + vecR * 15, "zombie_sign_please_wait", (120 + a * 120, angF[1], 0));
        heli[heli.size - 1] linkTo(heli[3]);
    }
    heli[heli.size] = spawnSM(heli[0].origin + vecF * -60, "zombie_beaker_brain", (0, angF[1] + 90, 90));
    heli[heli.size] = spawnSM(heli[0].origin + vecF * -60, "zombie_beaker_brain", (0, angF[1] - 90, 90));
    heli[heli.size] = spawnSM(heli[0].origin + (0, 0, -35) + vecR * -30, "zombie_beaker_brain", (0, angF[1] - 90, 90));
    heli[heli.size] = spawnSM(heli[0].origin + (0, 0, -35) + vecR * 30, "zombie_beaker_brain", (0, angF[1] + 180 + 90, 90));
    heli[heli.size] = spawnSM(heli[0].origin + (0, 0, -35) + vecR * -30, "zombie_beaker_brain", (0, angF[1] + 90, 90));
    heli[heli.size] = spawnSM(heli[0].origin + (0, 0, -35) + vecR * 30, "zombie_beaker_brain", (0, angF[1] + 180 - 90, 90));
    for (a = 0; a < 3; a += 2)
        for (b = 0; b < 2; b++) heli[heli.size] = spawnSM(heli[0].origin + (0, 0, -35) + vecF * (10 - b * 20) + vecR * (30 - a * 30), "zombie_zapper_tesla_coil", (320 + a * 40, angF[1] + 180 + 90, 0));
    heli[0] linkTo(seat);
    for (a = 7; a < heli.size; a++) heli[a] linkTo(seat);
    hud = [];
    hud["BG"] = self createRectangle("LEFT", "LEFT", 0, 0, self.menu["width"], 27, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
    hud["EDG"] = self createRectangle("LEFT", "LEFT", hud["BG"].x - 2, hud["BG"].y, self.menu["width"] + 4, 31, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, self.menu["Edging_Alpha"]);
    hud["Height"] = self createText(self getFont(), 1.1, "LEFT", "LEFT", hud["BG"].x + 3, hud["BG"].y - 6, 20, 1, undefined);
    hud["Height"].label = "Altitude: ";
    hud["MPH"] = self createText(self getFont(), 1.1, "LEFT", "LEFT", hud["BG"].x + 3, hud["BG"].y + 6, 20, 1, undefined);
    hud["MPH"].label = "Speed: ";
    for (a = 0; a < 2; a++) self thread rotateMotor(heli);
    speed = 0;
    while (1) {
        hud["MPH"] setValue(speed);
        hud["Height"] setValue(heli[0].origin[2] - 40.125);
        seat rotateTo(self.angles, 0.1);
        heli[3] rotateTo((heli[3].angles[0], self.angles[1] - 180, heli[3].angles[2]), .05);
        heli[3] moveto(heli[0].origin + anglestoforward(self getplayerangles()) * speed + (sin(self.angles[1] * -1 - 90) * 93, cos(self.angles[1] * -1 - 90) * 93, 0), .1);
        if (self attackButtonPressed()) {
            if (speed < 200 && speed >= 0) speed++;
            if (speed < 0) speed += 5;
            self thread moveMotor(0.1, heli[0].origin + anglestoforward(self getplayerangles()) * speed, heli);
            seat moveto(self.origin + anglestoforward(self getplayerangles()) * speed, 0.1);
            seat rotateTo(self.angles, 0.1);
        } else {
            if (speed > 0) {
                if (speed > 50) speed -= 10;
                if (speed <= 50 && speed > 0) speed--;
                self thread moveMotor(0.1, heli[0].origin + anglestoforward(self getplayerangles()) * speed, heli);
                seat moveto(self.origin + anglestoforward(self getplayerangles()) * speed, 0.1);
            }
        }
        if (heli[0].angles != self.angles + (0, 0, 0)) heli[0].angles = self.angles + (0, 0, 0);
        if (self adsButtonPressed()) {
            if (speed <= 0 && speed > -200) speed--;
            if (speed > 0) speed -= 5;
            self thread moveMotor(0.1, heli[0].origin + anglestoforward(self getplayerangles()) * speed, heli);
            seat moveto(self.origin + anglestoforward(self getplayerangles()) * speed, 0.1);
            seat RotateTo(self.angles, 0.1);
        } else {
            if (speed < 0) {
                if (speed < -50) speed += 10;
                if (speed >= -50 && speed < 0) speed++;
                self thread moveMotor(0.1, heli[0].origin + anglestoforward(self getplayerangles()) * speed, heli);
                seat moveto(self.origin + anglestoforward(self getplayerangles()) * speed, 0.1);
            }
        }
        if (self useButtonPressed()) {
            playSoundAtPosition("weap_ppsh_fire", self.origin);
            self thread heliFire();
        }
        if (self fragButtonPressed()) {
            self thread moveMotor(0.1, heli[0].origin + (0, 0, 10), heli);
            seat moveto(self.origin + (0, 0, 10), 0.1);
            seat RotateTo(self.angles, 0.1);
        }
        if (self meleeButtonPressed()) {
            self destroyAll(hud);
            self unlink();
            self show();
            self thread godCheck();
            self enableWeapons();
            self setClientDvar("cg_thirdperson", 0);
            self setClientDvar("cg_thirdpersonrange", 120);
            self notify("Heli_Off");
            seat remove();
            for (a = 0; a < heli.size; a++) heli[a] remove();
            self unlockMenu();
            self resetInstructions();
            return;
        }
        wait 0.05;
    }
}
heliFire() {
    self endon("disconnect");
    self endon("death");
    bul = spawnSM(self.origin, "projectile_rus_grenade", vectorToAngles(self.origin - self lookPos()));
    bul moveTo(self lookPos(), .3);
    bul thread heliImpact();
}
heliImpact() {
    self waittill("movedone");
    playFx(loadFx("env/electrical/fx_elec_short_oneshot"), self.origin);
    killZombiesWithinDistance(self.origin, 60);
    doPlayerDamage(self.origin, 60);
    earthQuake(.2, 1, self.origin, 100);
    self remove();
}
rotateMotor(heli) {
    self endon("Heli_Off");
    while (true) {
        heli[3] rotatePitch(-180, 0.1);
        for (a = 0; a < 3; a++) heli[1] rotateYaw(-180, 0.1);
        wait 0.1;
    }
}
moveMotor(time, location, heli) {
    heli[1] moveto(location + (0, 0, 25), time);
    heli[3] moveto(location + (sin(self.angles[1] * -1 - 90) * 93, cos(self.angles[1] * -1 - 90) * 93, 0), time);
}
VTOL() {
    self thread lockMenu("ALL");
    self hide();
    self thread buildVTOL();
    self enableGodMode();
    bg = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", 1, 1);
    self.hover = true;
    self setClientDvar("cg_drawGun", 0);
    self setClientDvar("cg_thirdperson", 1);
    self setClientDvar("cg_thirdpersonrange", 270);
    self setClientDvar("ui_hud_hardcore", 1);
    weap = self getCurrentWeapon();
    self disableWeapons();
    self.planetext[0] = self createText("smallfixed", 1, "CENTER", "CENTER", 0, 0, 2, 1, "INITIALISING VTOL...", (204 / 255, 51 / 255, 51 / 255));
    wait 0.5;
    for (a = 0; a < 3; a++) {
        self.planetext[0].alpha = 0;
        wait 0.1;
        self.planetext[0].alpha = 1;
        wait 0.1;
    }
    for (i = 1; i >= 0; i -= 0.1) {
        bg.alpha = i;
        wait 0.1;
    }
    self.vtolSpeed = 0;
    acc = 1;
    num = 0;
    self.planeshad[0] = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 2, (204 / 255, 51 / 255, 51 / 255), "white_line_faded_center", 1, 0.8);
    self.planeshad[0] moveOverTime(1);
    self.planeshad[0].y = 200;
    self.planeshad[1] = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 2, (204 / 255, 51 / 255, 51 / 255), "white_line_faded_center", 1, 0.8);
    self.planeshad[1] moveOverTime(1);
    self.planeshad[1].y = -200;
    wait 0.3;
    self.planetext[0] destroy();
    bg destroy();
    self.planetext[1] = self createText(self getFont(), 1, "LEFT", "LEFT", 0, -125, 2, 1, undefined);
    self.planetext[1].label = "SPEED: ^1";
    self.planetext[2] = self createText(self getFont(), 1, "LEFT", "LEFT", 0, -100, 2, 1, "[{+frag}] FLIGHT ZLE: ^1HOVER");
    self.planetext[3] = self createText(self getFont(), 1, "LEFT", "LEFT", 0, -75, 2, 1, "[{+usereload}] FIRE WEAPON: ^3REAPER");
    self.planetext[4] = self createText(self getFont(), 1, "LEFT", "LEFT", 0, -50, 2, 1, "[{+melee}] SELF DESTRUCT: ^5V.T.O.L");
    for (a = 0; a < 3; a++) self thread doRollVTOL();
    for (a = 0; a < 3; a++) self thread doMoveVTOL();
    self endon("VTOL_Destroy");
    while (1) {
        self.planetext[1] setValue(self.vtolSpeed);
        if (isDefined(self.hover)) {
            self.plane[1].angles = self.angles;
            if (self adsButtonPressed() || self attackButtonPressed()) {
                num = 0;
                num += self attackButtonPressed();
                num -= self adsButtonPressed();
                acc -= 0.05;
                if (acc <= 0) acc = 0.05;
                self.plane[1] moveTo(self.plane[1].origin + (0, 0, 4 * num) * 5, acc, 0, 0);
            } else {
                if (acc < 1) {
                    acc += 0.05;
                    self.plane[1] moveTo(self.plane[1].origin + (0, 0, 4 * num) * 5, acc, 0, 0);
                }
            }
        } else {
            if (isDefined(self.inhover)) {
                for (i = 0; i < 21; i++) {
                    self.vtolSpeed = i;
                    self.planetext[1] setValue(self.vtolSpeed);
                    wait 0.05;
                }
                self.inhover = undefined;
            }
            self.plane[1] moveto(self.plane[1].origin + anglestoforward(self getplayerangles()) * self.vtolSpeed, 0.05);
            if (self adsButtonPressed()) {
                self.vtolSpeed -= 5;
                if (self.vtolSpeed < 20) self.vtolSpeed = 20;
            }
            if (self attackButtonPressed()) {
                self.vtolSpeed++;
                if (self.vtolSpeed > 120) self.vtolSpeed = 120;
            }
            if (!self attackButtonPressed()) {
                self.vtolSpeed--;
                if (self.vtolSpeed < 20) self.vtolSpeed = 20;
            }
        }
        if (self fragButtonPressed()) {
            if (isDefined(self.hover)) {
                self.planetext[2] setText("[{+frag}] FLIGHT ZLE: ^2FLY");
                self.planetext[3] setText("[{+usereload}] FIRE WEAPON: ^3PATRIOT MISSILE");
                self.hover = undefined;
                self.inhover = true;
            } else {
                self.planetext[2] setText("[{+frag}] FLIGHT ZLE: ^1HOVER");
                self.planetext[3] setText("[{+usereload}] FIRE WEAPON: ^3REAPER");
                self.hover = true;
                self.inhover = undefined;
            }
            for (i = self.vtolSpeed; i != 0; i -= 5) {
                if (i <= 5) i = 0;
                wait 0.05;
                self.plane[1] moveto(self.plane[1].origin + anglestoforward(self getplayerangles()) * i, 0.05);
                self.plane[1].angles = self.angles + (0 - (self getPlayerAngles()[0]), 0, 0);
                self.planetext[1] setValue(i);
                if (i == 0) break;
            }
            self.vtolSpeed = 0;
        }
        if (self useButtonPressed()) {
            if (isDefined(self.hover)) {
                if (!isDefined(self.VTOLreaper)) self thread reaperVTOL();
            } else self thread patriotVTOL();
        }
        if (self meleeButtonPressed()) {
            self unlink();
            self thread godCheck();
            self show();
            for (a = 0; a < self.plane.size; a++) self.plane[a] remove();
            for (a = 0; a < 2; a++) self.planeshad[a] destroy();
            for (a = 1; a < 5; a++) self.planetext[a] destroy();
            playFx(loadFx("explosions/fx_mortarExp_dirt"), self.origin);
            playFx(loadFx("explosions/default_explosion"), self.origin);
            self playLocalSound("grenade_explode");
            self playLocalSound("nuke_flash");
            wait .4;
            self setClientDvar("cg_thirdperson", 0);
            self setClientDvar("cg_thirdpersonrange", 120);
            self setClientDvar("ui_hud_hardcore", 0);
            self setClientDvar("cg_drawGun", 1);
            self enableWeapons();
            self switchToWeapon(weap);
            self.plane = undefined;
            self.hover = undefined;
            self unlockMenu();
            self returnToSpawn();
            self notify("VTOL_Destroy");
        }
        wait 0.05;
    }
}
buildVTOL() {
    ZL = "zombie_treasure_box_lid";
    angles = self.angles;
    vecF = anglesToForward(angles);
    vecR = anglesToRight(angles);
    origin = self.origin + (0, 0, 20);
    self.plane = [];
    self.plane[0] = spawnSM(origin + (0, 0, -10) + vecF * 60, "defaultvehicle", (0, angles[1], 0));
    self.plane[1] = spawnSM(self.plane[0].origin + vecR * 12 - vecF * 67, ZL, (0, angles[1], 0));
    self.plane[2] = spawnSM(self.plane[0].origin + vecR * 12 - vecF * 67, ZL, (0, angles[1], 90));
    self.plane[3] = spawnSM(self.plane[0].origin - vecR * 12 - vecF * 67, ZL, (0, angles[1] + 180, 90));
    self.plane[4] = spawnSM(self.plane[1].origin + vecR * -26.5 - (0, 0, .5), ZL, (0, angles[1] + 45, 0));
    self.plane[5] = spawnSM(self.plane[4].origin + anglesToForward(self.plane[4].angles) * 90, ZL, self.plane[4].angles);
    self.plane[6] = spawnSM(self.plane[4].origin + anglesToRight(self.plane[4].angles) * 24, ZL, self.plane[4].angles);
    self.plane[7] = spawnSM(self.plane[6].origin + anglesToForward(self.plane[6].angles) * 90, ZL, self.plane[4].angles);
    self.plane[8] = spawnSM(self.plane[1].origin + vecR * 3 - (0, 0, .5), ZL, (0, angles[1] - 225, 0));
    self.plane[9] = spawnSM(self.plane[8].origin + anglesToForward(self.plane[8].angles) * -90, ZL, self.plane[8].angles);
    self.plane[10] = spawnSM(self.plane[8].origin + anglesToRight(self.plane[8].angles) * 24, ZL, self.plane[8].angles);
    self.plane[11] = spawnSM(self.plane[10].origin + anglesToForward(self.plane[10].angles) * -90, ZL, self.plane[8].angles);
    self.plane[12] = spawnSM(self.plane[1].origin - vecR * 12, "tag_origin");
    self.plane[13] = spawnSM(self.plane[0].origin + (0, 0, 65), "zombie_bomb", (0, angles[1], 0));
    self playerLinkTo(self.plane[12]);
    for (a = 0; a < self.plane.size; a++)
        if (a != 1) self.plane[a] linkTo(self.plane[1]);
}
doRollVTOL() {
    self endon("VTOL_Destroy");
    while (1) {
        if (!isDefined(self.hover)) self.plane[1] rotateTo((self.angles + (0 + (self getPlayerAngles()[0]), 0, self createRoll(1.5) * -1)), .2, .05, .05);
        wait .05;
    }
}
doMoveVTOL() {
    self endon("VTOL_Destroy");
    while (1) {
        if (!isDefined(self.hover)) self.plane[1] moveto(self.plane[1].origin + anglestoforward(self getplayerangles()) * self.vtolSpeed, 0.05);
        wait .05;
    }
}
reaperVTOL() {
    if (isDefined(self.VTOLreaper)) return;
    self.VTOLreaper = true;
    bomb = spawnSM(self.plane[13].origin, "zombie_bomb", self.plane[13].angles);
    bomb playSound("weap_pnzr_fire");
    while (1) {
        vector = anglesToForward(bomb.angles);
        forward = bomb.origin + (vector[0] * 45, vector[1] * 45, vector[2] * 45);
        collision = bulletTrace(bomb.origin, forward, false, self);
        bomb.angles = (vectorToAngles((getCursorPos() - (0, 0, 130)) - bomb.origin));
        bomb moveTo(forward, .05);
        if (collision["surfacetype"] != "default" && collision["fraction"] < 1) {
            expPos = bomb.origin;
            for (a = 0; a < 360; a += 80) playFx(loadFx("explosions/default_explosion"), (expPos[0] + (200 * cos(a)), expPos[1] + (200 * sin(a)), expPos[2]));
            earthquake(1, 1.6, expPos, 250);
            killZombiesWithinDistance(expPos, 400, "flame");
            doPlayerDamage(expPos, 200);
            bomb playSound("grenade_explode");
            self playLocalSound("grenade_explode_dist");
            break;
        }
        wait 0.05;
    }
    bomb remove();
    self.VTOLreaper = undefined;
}
patriotVTOL() {
    if (isDefined(self.patriot)) return;
    self.patriot = true;
    self thread patriotUndefine();
    patriot = spawnSM(self.plane[13].origin + anglesToForward(self.plane[13].angles) * (self.vtolSpeed * 3.5), "zombie_bomb", self.plane[13].angles);
    cursor = bulletTrace(patriot.origin, vectorScale(anglesToForward(patriot.angles), 1000000), 0, self.plane[1])["position"];
    curser = self getCursorPos();
    while (1) {
        patriot moveTo(cursor, .3);
        patriot waittill("movedone");
        expPos = patriot.origin;
        for (a = 0; a < 360; a += 80) playFx(loadfx("explosions/default_explosion"), (expPos[0] + (150 * cos(a)), expPos[1] + (150 * sin(a)), expPos[2] + 100));
        playsoundatposition("Grenade_explode", patriot.origin);
        earthquake(3, 1.6, expPos, 450);
        killZombiesWithinDistance(expPos, 400, "flame");
        doPlayerDamage(expPos, 200);
        patriot playSound("grenade_explode");
        self playLocalSound("grenade_explode_dist");
        break;
    }
    patriot remove();
}
patriotUndefine() {
    wait .1;
    self.patriot = undefined;
}
IMS() {
    if (!isDefined(self.ims)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.ims = true;
        self thread doIMS();
    } else {
        self notify("IMS_END");
        self setOptionColor(self.menu["Menu_Color"]);
        self.ims = undefined;
    }
}
doIMS() {
    self endon("IMS_END");
    origin = self.origin;
    rand = [];
    monster["box"][0] = spawnSM(origin, "zombie_treasure_box");
    monster["box"][1] = spawnSM(origin + (0, 24, 0), "zombie_treasure_box");
    monster["box"][2] = spawnSM(origin + (0, 48, 0), "zombie_treasure_box");
    monster["box"][3] = spawnSM(origin + (0, 72, 0), "zombie_treasure_box");
    monster["lid"][0] = spawnSM(origin + (0, -12, 17), "zombie_treasure_box_lid");
    monster["lid"][1] = spawnSM(origin + (0, 12, 17), "zombie_treasure_box_lid");
    monster["lid"][2] = spawnSM(origin + (0, 36 + 24, 17), "zombie_treasure_box_lid", (0, 180, 0));
    monster["lid"][3] = spawnSM(origin + (0, 60 + 24, 17), "zombie_treasure_box_lid", (0, 180, 0));
    self thread deleteIMS(monster);
    for (a = 0; a < 2; a++)
        for (b = 0; b < 4; b++) rand[rand.size] = monster["box"][1].origin + (randomInt(45), randomInt(-48 + 96 * a), 0);
    while (true) {
        zombs = getAISpeciesArray("axis", "all");
        for (i = 0; i < zombs.size; i++) {
            if (distance(zombs[i].origin, monster["lid"][2].origin) < 175) {
                for (a = 1; a < 3; a++) monster["lid"][a] rotateRoll(150, .25);
                wait .25;
                for (i = 0; i < 11; i++) {
                    betty[i] = spawn("script_model", rand[randomInt(rand.size)]);
                    betty[i] setModel(getWeaponModel("mine_bouncing_betty"));
                    self playsound("betty_activated");
                    betty[i] moveZ(100, .1);
                    wait .1;
                    if (getMap() != "nzp" && isOdd(i)) playFx(loadFx("weapon/bouncing_betty/fx_explosion_betty_generic"), betty[i].origin);
                    if (getMap() == "nzp")
                        if (i == 0 || i == 5 || i == 11) playFx(loadFx("explosions/fx_mortarExp_dirt"), betty[i].origin);
                    betty[i] delete();
                    killZombiesWithinDistance(monster["lid"][2].origin, 275, "headGib");
                }
                for (a = 1; a < 3; a++) monster["lid"][a] rotateRoll(-150, .25);
                wait .25;
            }
        }
        wait .05;
    }
}
deleteIMS(monster) {
    self waittill("IMS_END");
    for (i = 0; i < 5; i++) {
        monster["box"][i] remove();
        monster["lid"][i] remove();
    }
}
radar() {
    if (!isDefined(level.radar)) {
        level.radar = true;
        array_thread(getPlayers(), ::arraySetOptionColor, true, "ADVANCED", self getPointer());
        self thread runRadar();
    } else {
        if (!isDefined(level.radarMade)) return;
        level notify("radarOff");
        level.radarMade = undefined;
        level.radar = undefined;
        array_thread(getPlayers(), ::arraySetOptionColor, undefined, "ADVANCED", self getPointer());
        zom = getAiSpeciesArray("axis", "all");
        if (isDefined(zom))
            for (a = 0; a < zom.size; a++)
                if (isAlive(zom[a]) || isDefined(zom[a])) zom[a].doRadar = undefined;
    }
}
runRadar() {
    level endon("radarOff");
    rotate = spawnSM(self.origin, "tag_origin", (0, self.angles[1], 0));
    self thread radarDelete(rotate);
    vecF = anglesToForward(self.angles);
    for (a = 0; a < 20; a++) {
        line = spawnSM(rotate.origin + vecF * (a * 5), "tag_origin", vectorToAngles(anglesToUp((0, 0, 0))));
        self thread radarDelete(line);
        playFxOnTag(level._effect["zapper_light_ready"], line, "tag_origin");
        line linkTo(rotate);
    }
    for (a = 0; a < 72; a++) {
        circle = spawnSM(rotate.origin + (sin(a * (360 / 72)) * 100, cos(a * (360 / 72)) * 100, 0), "tag_origin", vectorToAngles(anglesToUp((0, 0, 0))));
        self thread radarDelete(circle);
        playFxOnTag(level._effect["zapper_light_ready"], circle, "tag_origin");
        playFxOnTag(level._effect["zapper_light_notready"], circle, "tag_origin");
    }
    level.radarMade = true;
    rotate thread rotateEntYaw(-360, 7);
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread doRadar(rotate);
    while (true) {
        zom = getAiSpeciesArray("axis", "all");
        if (isDefined(zom))
            for (a = 0; a < zom.size; a++)
                if (!isDefined(zom[a].doRadar) && isAlive(zom[a])) zom[a] thread doRadar(rotate);
        wait .05;
    }
}
radarDelete(tag) {
    level waittill("radarOff");
    tag remove();
}
doRadar(rotate) {
    level endon("radarOff");
    self.doRadar = true;
    range = 1500;
    temp = [];
    while (isAlive(self)) {
        if (distance2d(rotate.origin, self.origin) <= range && distance2d(rotate.origin + anglesToForward(rotate.angles) * distance2d(rotate.origin, self.origin), self.origin) <= 25) {
            temp[temp.size] = spawnSM(rotate.origin + anglesToForward(rotate.angles) * (distance2d(rotate.origin, self.origin) / (range / 95)), "tag_origin", vectorToAngles(anglesToUp((0, 0, 0))));
            temp[temp.size - 1] thread radar_fadeDelete();
            if (isPlayer(self)) playFxOnTag(level._effect["zapper_light_ready"], temp[temp.size - 1], "tag_origin");
            else playFxOnTag(level._effect["zapper_light_notready"], temp[temp.size - 1], "tag_origin");
            wait 2;
        }
        wait .05;
    }
    self.doRadar = undefined;
}
radar_fadeDelete() {
    for (a = 0; a < 40; a++)
        if (isDefined(level.radar)) wait .05;
    self moveZ(-15, 1.5);
    for (a = 0; a < 20; a++)
        if (isDefined(level.radar)) wait .05;
    self remove();
}
spawnTeslaTurret() {
    if (!isDefined(self.teslaTurret)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.teslaTurret = true;
        self thread doTeslaTurret();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.teslaTurret = undefined;
        self notify("deleteTesla");
    }
}
doTeslaTurret() {
    org = self.origin;
    ang = self.angles[1];
    vec = anglesToForward(self.angles);
    turret = spawnSM(org + (vec[0] * 50, vec[1] * 50, 0), "static_peleliu_crate01", (0, ang + 90, 0));
    coil = spawnSM(org + (vec[0] * 50, vec[1] * 50, 17), "zombie_zapper_tesla_coil", (0, ang + 90, 0));
    tesla = spawnSM(turret.origin + (0, 0, 40), getWeaponModel("tesla_gun"), (0, ang + 90, 0));
    tesla thread startTeslaTurret("tesla_gun", 0);
    self waittill("deleteTesla");
    tesla.isNotTargetting = undefined;
    tesla notify("idle_over");
    tesla notify("overHeated");
    turret remove();
    coil remove();
    tesla remove();
}
startTeslaTurret(turretWeapon, ang) {
    self endon("overHeated");
    enemy = undefined;
    while (1) {
        enemy = getClosest(self.origin, getAiSpeciesArray("axis", "all"));
        if (isDefined(enemy) && enemy damageConeTrace(self.origin, self) > .75 && !isDefined(enemy.targetted) || enemy canSee(self) && isDefined(enemy)) {
            enemy.targetted = true;
            self.isNotTargetting = undefined;
            self notify("idle_over");
            self rotateTo(vectorToAngles(enemy getTagOrigin("j_spine4") - self.origin), .2);
            wait .2;
            self thread teslaShooting(enemy);
            wait(weaponFireTime(turretWeapon));
        } else if ((getAiSpeciesArray("axis", "all").size < 1 || !enemy damageConeTrace(self.origin, self) > .75) && !isDefined(self.isNotTargetting) || !enemy canSee(self)) {
            self thread turretIdle(ang);
            self.isNotTargetting = true;
        }
        wait .05;
    }
}
teslaShooting(zom) {
    trace = bulletTrace(self getTagOrigin("j_head"), zom getTagOrigin("j_head"), true, self);
    orb = spawnSM(self getTagOrigin("tag_flash"), "tag_origin");
    playFxOnTag(level._effect["tesla_bolt"], orb, "tag_origin");
    playSoundAtPosition("wpn_tesla_fire_plr", self.origin);
    orb moveTo(zom getTagOrigin("j_spine4"), .4);
    wait .4;
    killZombiesWithinDistance(orb.origin - (0, 0, 40), 150, "tesla");
    earthQuake(.2, 1, orb.origin, 100);
    orb remove();
}
turretIdle(ang) {
    self endon("idle_over");
    self rotateTo((ang, self.angles[1], self.angles[2]), .2);
    wait .2;
    while (1) {
        self rotateYaw(-360, 3);
        wait 3;
    }
}
timeBomb() {
    if (!isdefined(self.hasTimeBomb)) {
        self setOptionColor(self.menu["Select_Color"]);
        self equipmentNotifications("TIMEBOMB");
        self.hasTimeBomb = self createText(self getFont(), 1, "TOPRIGHT", "TOPRIGHT", -20, 20, 1, 1, "");
        self thread giveTimeBomb();
    } else {
        self.hasTimeBomb destroy();
        self setOptionColor(self.menu["Menu_Color"]);
        self notify("Time_Bomb_End");
        self.timeBombTrig notify("trigger");
        if (isDefined(self.timeBombTrig)) self.timeBombTrig remove();
    }
}
giveTimeBomb() {
    self endon("Time_Bomb_End");
    while (isDefined(self.hasTimeBomb)) {
        self.timeBombPlant = undefined;
        self.hasTimeBomb setText("Press [{+frag}] To Activate Time Bomb");
        if (self getFractionMaxAmmo("stielhandgranate") == 0) self setWeaponAmmoClip("stielhandgranate", 1);
        else if (self getFractionMaxAmmo("stielhandgranate") <= .25) self setWeaponAmmoClip("stielhandgranate", 2);
        else if (self getFractionMaxAmmo("stielhandgranate") <= .5) self setWeaponAmmoClip("stielhandgranate", 3);
        else self setWeaponAmmoClip("stielhandgranate", 4);
        self thread updateTime();
        self waittill("grenade_fire", grenade);
        grenade resetMissileDetonationTime();
        self notify("endBombTimer");
        self.hasTimeBomb setText("Hold [{+activate}] To Detonate Time Bomb");
        grenade hide();
        bomb = snapSM(grenade.origin, "grenade_bag", grenade.angles);
        bomb linkTo(grenade);
        playFxOnTag(loadFx("misc/fx_zombie_powerup_on"), bomb, "tag_origin");
        grenade thread detonationResetLoop(self);
        self thread timeWarp(bomb);
        grenade thread watchForSignal(bomb, self);
        self waittill("timePickUp");
    }
}
timeWarp(bomb) {
    self endon("Time_Bomb_End");
    self endon("timePickUp");
    self waittill("Time_Bomb_Explode");
    killZombiesWithinDistance(bomb.origin, 8000, "headGib");
    playFx(loadFx("explosions/fx_mortarExp_dirt"), bomb.origin);
    bomb remove();
    self.hasTimeBomb destroy();
    self.timeBombTrig remove();
    self thread resetVision();
    self resetDvars();
    missionFailed();
    if (isDefined(self.godMode)) self enableGodMode();
}
updateTime() {
    self endon("Time_Bomb_End");
    self endon("endBombTimer");
    self setClientDvar("zombiemode", 0);
    wait .1;
    while (1) {
        self maps\_autosave::autosave_game_now(1);
        wait 1.5;
    }
}
watchForSignal(bomb, you) {
    you endon("Time_Bomb_End");
    you endon("Time_Bomb_Explode");
    while (1) {
        self resetMissileDetonationTime();
        pos = self getOrigin();
        wait .05;
        if (pos == self getOrigin()) break;
    }
    org = self.origin;
    self delete();
    you.timeBombTrig = spawnTrigger(org, 50);
    you.timeBombTrig setString("Press [{+activate}] To Pick Up Time Bomb");
    you.timeBombPlant = true;
    you thread detonateTimeBomb();
    while (isDefined(you.hasTimeBomb)) {
        you.timeBombTrig waittill("trigger", player);
        if (player useButtonPressed() && player == you) break;
        wait .05;
    }
    you.timeBombPlant = undefined;
    if (isDefined(you.timeBombTrig)) you.timeBombTrig remove();
    bomb remove();
    you notify("timePickUp");
}
detonateTimeBomb() {
    self endon("Time_Bomb_End");
    count = 0;
    while (isDefined(self.timeBombPlant)) {
        if (count != 0) count = 0;
        while (self useButtonPressed() && isDefined(self.timeBombPlant)) {
            if (count >= .5) {
                self notify("Time_Bomb_Explode");
                break;
            }
            count += .05;
            wait .05;
        }
        wait .05;
    }
}
detonationResetLoop(you) {
    you endon("Time_Bomb_End");
    while (isDefined(you.timeBombPlant)) {
        self resetMissileDetonationTime();
        wait .05;
    }
}
flappyBird() {
    self thread lockMenu("ALL");
    self deleteInstructions();
    self setClientDvar("ammoCounterHide", 1);
    self setClientDvars("ui_hud_hardcore", 1, "cg_drawCrosshair", 0);
    self freezeControls(true);
    self.FlappyGame = true;
    hud = [];
    bird = [];
    pipe = [];
    hud["bg"] = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, divideColor(120, 255, 255), "white", -12, 1);
    hud["bg_bot"] = self createRectangle("BOTTOM", "BOTTOM", 0, 100, 1000, 130, divideColor(255, 230, 192), "white", -7, 1);
    hud["bg_strip"] = self createRectangle("BOTTOM", "BOTTOM", 0, -20, 1000, 20, divideColor(97, 255, 113), "white", -6, 1);
    bird = self createBird();
    self thread floatWaitingFlappy(bird);
    self thread initFlappyOptions(bird, hud, pipe);
    self waittill("ExitFlappy");
    self thread remakeInstructions(1);
}
exitFlappyBird(bird, hud, pipe, end) {
    self notify("ExitFlappy");
    self.FlappyGame = undefined;
    self.FlappyGameOver = undefined;
    self destroyAll(bird);
    self destroyAll(pipe);
    self destroyAll(hud);
    self destroyAll(end);
    self freezeControls(false);
    self setClientDvars("ui_hud_hardcore", 0, "cg_drawCrosshair", 1, "ammoCounterHide", 0);
    self unlockMenu();
}
createBird() {
    bird = [];
    bird[0] = self createRectangle("CENTER", "CENTER", 0, 0, 45, 60, divideColor(255, 135, 135), "ui_sliderbutt_1", 1, 1);
    bird[1] = self createRectangle("CENTER", "CENTER", bird[0].x - 16, bird[0].y, 22, 26, divideColor(123, 197, 200), "ui_sliderbutt_1", 2, 1);
    bird[2] = self createRectangle("CENTER", "CENTER", bird[0].x + 9, bird[0].y - 4, 24, 34, (1, 1, 1), "ui_sliderbutt_1", 2, 1);
    bird[3] = self createRectangle("CENTER", "CENTER", bird[2].x + 5, bird[2].y + 1, 2, 3, (0, 0, 0), "white", 3, 1);
    bird[4] = self createRectangle("CENTER", "CENTER", bird[3].x - 1, bird[3].y + 10, 25, 20, divideColor(255, 255, 130), "ui_sliderbutt_1", 3, 1);
    bird[5] = self createRectangle("CENTER", "CENTER", bird[4].x + 3, bird[4].y, 14, 1, divideColor(131, 131, 122), "white", 4, 1);
    self.flappyBirdPosition = [];
    for (a = 0; a < 6; a++) self.flappyBirdPosition[a] = bird[a].y;
    return bird;
}
tempFlappy() {
    temp = [];
    temp[0] = self createRectangle("CENTER", "CENTER", 0, -10, 45, 60, (1, 1, 1), "ui_sliderbutt_1", 1, 1);
    temp[1] = self createRectangle("CENTER", "CENTER", temp[0].x - 16, temp[0].y, 22, 26, (1, 1, 1), "ui_sliderbutt_1", 2, 1);
    temp[2] = self createRectangle("CENTER", "CENTER", temp[0].x + 9, temp[0].y - 4, 24, 34, (1, 1, 1), "ui_sliderbutt_1", 2, 1);
    temp[3] = self createRectangle("CENTER", "CENTER", temp[2].x + 5, temp[2].y + 1, 2, 3, divideColor(131, 131, 122), "white", 3, 1);
    temp[4] = self createRectangle("CENTER", "CENTER", temp[3].x - 1, temp[3].y + 10, 25, 20, (1, 1, 1), "ui_sliderbutt_1", 3, 1);
    temp[5] = self createRectangle("CENTER", "CENTER", temp[4].x + 3, temp[4].y, 14, 1, divideColor(131, 131, 122), "white", 4, 1);
    temp[6] = self createText("bigfixed", 1, "CENTER", "CENTER", 0, 40, 8, 1, "Tap-- [{+activate}] --Tap");
    self waittill("flapping");
    for (a = 0; a < temp.size; a++) temp[a] thread hudFadenDestroy(0, .4);
}
floatWaitingFlappy(bird) {
    self endon("ExitFlappy");
    self endon("EnterFlappy");
    self endon("flapping");
    num = 20;
    while (1) {
        for (a = 0; a < 6; a++) bird[a] thread hudMoveY(bird[a].y + num, .55);
        num = num * -1;
        wait .6;
    }
}
initFlappyOptions(bird, hud, pipe) {
    self endon("ExitFlappy");
    if (!isDefined(self.FlappyGameOver)) hud["Title"] = self createText("bigfixed", 2, "CENTER", "CENTER", 0, -60, 1, 1, "FlappyBird");
    else hud["Title"] = self createText("bigfixed", 2, "CENTER", "CENTER", 0, -60, 1, 1, "^6Game Over");
    gameOverHud = self runGameOverScreen();
    hud[0] = self createRectangle("BOTTOM", "BOTTOM", -100, hud["bg_strip"].y - 25, 110, 50, (0, 1, 0), "white", 7, 0);
    hud[1] = self createRectangle("BOTTOM", "BOTTOM", 100, hud["bg_strip"].y - 25, 100, 40, (1, 0, 0), "white", 7, 0);
    hud[2] = self createText("default", 1.4, "BOTTOM", "BOTTOM", 0, hud["bg_strip"].y - 2, 3, 0, "^2Play FlappyBird");
    for (a = 0; a < 3; a++) hud[a] thread hudFade(1, .25);
    wait .3;
    curs = 0;
    while (1) {
        wait .05;
        if (self adsButtonPressed() || self attackButtonPressed()) {
            self playSound("deny");
            oldCurs = curs;
            curs += self attackButtonPressed();
            curs -= self adsButtonPressed();
            if (curs < 0) curs = 1;
            if (curs > 1) curs = 0;
            hud[oldCurs] scaleOverTime(.3, 100, 40);
            wait .25;
            if (curs == 0) hud[2] setText("^2Play FlappyBird");
            if (curs == 1) hud[2] setText("^1Exit FlappyBird");
            hud[curs] scaleOverTime(.3, 110, 50);
            wait .25;
        }
        if (self useButtonPressed()) {
            self.initFlappyOptions = undefined;
            self.FlappyBirdTop = undefined;
            self.FlappFallingCounter = undefined;
            self playSound("deny");
            hud[curs] scaleOverTime(.3, 100, 40);
            wait .25;
            hud[curs] scaleOverTime(.3, 110, 50);
            wait .25;
            if (curs == 0) break;
            if (curs == 1) self thread exitFlappyBird(bird, hud, pipe, gameOverHud);
            return;
        }
    }
    self.flappScore = 0;
    bird["wink"] = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", 9, 0);
    bird["wink"] hudFade(1, .6);
    wait .6;
    if (!isDefined(self.FlappyGameOver))
        for (a = 0; a < 6; a++) bird[a] thread hudMoveX(bird[a].x - 200, .05);
    else {
        for (a = 0; a < 6; a++) bird[a] thread hudMoveY(self.flappyBirdPosition[a], .05);
        self thread floatWaitingFlappy(bird);
    }
    self.FlappyGameOver = undefined;
    self destroyAll(gameOverHud);
    for (a = 0; a < 3; a++) hud[a] destroy();
    self thread tempFlappy();
    bird["score"] = self createText("bigfixed", 1.35, "TOP", "TOP", 0, 20, 5, 1, "0");
    hud["Title"] setText("^2Get Ready!");
    wait .15;
    bird["wink"] hudFadenDestroy(0, .6);
    wait .5;
    self thread controlFlappy(bird);
    self thread doFlappyLoop(bird, hud, pipe);
    self waittill("flapping");
    hud["Title"] thread hudFadenDestroy(0, .4);
    self notify("EnterFlappy");
    if (!isDefined(self.FlappyGameOver)) self thread marioPipes(bird, hud, pipe);
}
runGameOverScreen() {
    if (!isDefined(self.FlappyGameOver)) return undefined;
    hud = [];
    if (self.flappScore > self.menu["flappBestScore"]) {
        self.menu["flappBestScore"] = self.flappScore;
        self setSavedVariable("113", self.menu["flappBestScore"]);
        if (isConsole()) updateGamerProfile();
    }
    wait .5;
    hud[0] = self createRectangle("CENTER", "CENTER", 0, 350, 225, 50, divideColor(205, 226, 118), "white", 7, 1);
    hud[1] = self createText("default", 1.5, "CENTER", "CENTER", 0, 340, 8, 1, "Score: " + self.flappScore);
    hud[2] = self createText("default", 1.5, "CENTER", "CENTER", 0, 360, 8, 1, "Best: " + self.menu["flappBestScore"]);
    hud[0] thread hudMoveY(20, .6);
    hud[1] thread hudMoveY(hud[0].y - 10, .6);
    hud[2] thread hudMoveY(hud[0].y + 10, .6);
    wait 1;
    return hud;
}
doFlappyLoop(bird, hud, pipe) {
    while (1) {
        if (bird[5].y >= 180) {
            self.FlappyGameOver = true;
            bird["score"] destroy();
            self thread initFlappyOptions(bird, hud, pipe);
            self notify("flappyCollision");
            self notify("flapping");
            break;
        }
        if (bird[0].y <= -215) {
            self.FlappyBirdTop = true;
            self notify("flapping");
            wait .1;
            for (a = 0; a < 2; a++) self thread flappyFall(bird, 2);
            wait .15;
            self.FlappyBirdTop = undefined;
        }
        wait .05;
    }
}
controlFlappy(bird) {
    self endon("flappyCollision");
    while (1) {
        if (self useButtonPressed() && !isDefined(self.FlappyBirdTop)) {
            self thread flappySemiFly(bird);
            while (self useButtonPressed()) wait .01;
        }
        wait .01;
    }
}
flappySemiFly(bird) {
    self notify("flapping");
    self endon("flapping");
    num = 0;
    while (1) {
        for (a = 0; a < 6; a++) bird[a] thread hudMoveY(bird[a].y - 14, .05);
        num++;
        if (num > 3) break;
        wait 0.05;
    }
    wait .15;
    for (a = 0; a < 2; a++) self thread flappyFall(bird, 4);
}
flappyFall(bird, val) {
    self endon("flapping");
    while (1) {
        for (a = 0; a < 6; a++) bird[a] thread hudMoveY(bird[a].y + val, 0.05);
        wait 0.05;
        if (val < 7) val++;
    }
}
marioPipes(bird, hud, pipe) {
    self endon("flappyCollision");
    tok = strTok("tube|tube2|cap|cap2|tube3|tube4|cap3|cap4|tube5|tube6|cap5|cap6", "|");
    wait 2.5;
    while (1) {
        pipe = [];
        for (a = 0; a < 3; a++) {
            length = randomIntRange(70, 485);
            pipe[tok[pipe.size]] = self createRectangle("CENTER", "CENTER", 470, -230, 100, length, divideColor(35, 205, 35), "white", -8, 1);
            pipe[tok[pipe.size]] = self createRectangle("CENTER", "CENTER", 470, -230 + ((length / 2) + 295), 100, 300, divideColor(35, 205, 35), "white", -8, 1);
            pipe[tok[pipe.size]] = self createRectangle("CENTER", "CENTER", 470, pipe[tok[4 * a]].y + ((length / 2) - 15), 110, 30, divideColor(19, 190, 19), "white", -1, 1);
            pipe[tok[pipe.size]] = self createRectangle("CENTER", "CENTER", 470, pipe[tok[4 * a + 1]].y - 150, 110, 30, divideColor(19, 190, 19), "white", -1, 1);
            for (b = a * 4; b < pipe.size; b++) pipe[tok[b]] thread movePipes(self);
            wait 1.3;
            self thread checkPipeCollision(pipe[tok[2 + 4 * a]], pipe[tok[3 + 4 * a]], bird, pipe, hud);
        }
        wait .05;
    }
}
movePipes(me) {
    me endon("flappyCollision");
    self endon("PipesDeleted");
    self thread waitForCollision(me);
    self hudMoveX(self.x - 1000, 3.5);
    if (isDefined(self)) self destroy();
}
waitForCollision(me) {
    me waittill_any("FlappyCollider", "flappyCollision");
    self destroy();
}
checkPipeCollision(pipe, pipe2, bird, pip, hud) {
    self endon("flappyCollision");
    wait .85;
    pipe endon("PipeCollision");
    pipe thread collisionCount(self, bird);
    while (1) {
        if (bird[0].y - 15 < pipe.y + 15 || bird[0].y + 25 > pipe2.y - 15) {
            bird["score"] destroy();
            self notify("flapping");
            for (a = 0; a < 2; a++) self thread flappyFall(bird, 4);
            self notify("flappyCollision");
        }
        wait 0.05;
    }
}
collisionCount(me, bird) {
    me endon("flappyCollision");
    wait .45;
    me playSound("cha_ching");
    me.flappScore++;
    bird["score"] setText(me.flappScore);
    self notify("PipeCollision");
}
miniGame() {
    self thread lockMenu("ALL");
    self freezeControls(true);
    self deleteInstructions();
    self setBlur(1, 1);
    self enableGodMode();
    round = 10;
    bg = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", -100, .8);
    text = self createText("smallFixed", 1.5, "CENTER", "TOP", 0, 60, 5, 1, "MINI GAME - PRESS THE BUTTONS!");
    text thread alwaysColorful();
    text2 = self createText("smallFixed", 1.2, "CENTER", "TOP", 0, 80, 5, 1, "ROUND 1");
    buttons = strTok("[{+speed_throw}];[{+attack}];[{+melee}];[{+frag}];[{+activate}]", ";");
    space = "";
    for (e = 0; e < round; e++) {
        text2 setText("ROUND" + (e + 1));
        tok = [];
        order = "";
        for (a = 0; a < 4; a++) {
            randy = buttons[randomInt(buttons.size)];
            tok[a] = randy;
            order += randy;
            if (a < 3) order += space;
        }
        hud = self createText(getFont(), 2, "CENTER", "CENTER", 0, 0, 5, 1, order);
        check = [];
        for (a = 0; a < 4; a++) check[a] = self createRectangle("CENTER", "CENTER", a * 15 - 22, 40, 10, 20, (1, 0, 0), "ui_sliderbutt_1", 6, 1);
        for (a = 0; a < tok.size; a++) {
            while (1) {
                if (self adsButtonPressed() && tok[a] == "[{+speed_throw}]") break;
                if (self attackButtonPressed() && tok[a] == "[{+attack}]") break;
                if (self meleeButtonPressed() && tok[a] == "[{+melee}]") break;
                if (self fragButtonPressed() && tok[a] == "[{+frag}]") break;
                if (self useButtonPressed() && tok[a] == "[{+activate}]") break;
                if (isDefined(level.seekerReleased)) break;
                wait .05;
            }
            check[a] fadeOverTime(.2);
            check[a].color = (0, 1, 0);
            if (isDefined(level.seekerReleased)) break;
            wait .3;
        }
        hud destroy();
        for (a = 0; a < check.size; a++) check[a] destroy();
        if (isDefined(level.seekerReleased)) break;
    }
    text destroy();
    text2 destroy();
    bg destroy();
    self freezeControls(false);
    self unlockMenu();
    self remakeInstructions(1);
    self setBlur(0, 1);
    self thread godCheck();
}
moonDoors() {
    if (isDefined(level.bigSpawn)) return;
    if (!isDefined(level.moonDoors)) {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "ADVANCED", 6);
        level.moonDoors = true;
        self thread doMoonDoors();
    } else {
        level notify("KillMoonDoors");
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "ADVANCED", 6);
        level.moonDoors = undefined;
    }
}
doMoonDoors() {
    door = getEntArray("zombie_door", "targetname");
    debris = getEntArray("zombie_debris", "targetname");
    array_thread(door, ::watchDoor);
    array_thread(debris, ::watchDebris);
}
watchDoor() {
    self thread connectAllPaths("DOOR");
    level endon("KillMoonDoors");
    trigs = getEntArray(self.target, "target");
    array_thread(trigs, ::trigger_off);
    origin = self.doors[0].savedOrigin;
    origin2 = self.doors[1].savedOrigin;
    if (!isDefined(self.doors[1].savedOrigin)) origin2 = origin;
    if (isDefined(self.doors[0].door_moving)) self.doors[0].open = true;
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread everyOneWatchDoor(self, origin, origin2);
}
everyOneWatchDoor(door, origin, origin2) {
    while (isDefined(level.moonDoors)) {
        open = undefined;
        zoms = getAISpeciesArray("axis", "all");
        for (a = 0; a < zoms.size; a++)
            if (distance2d(zoms[a].origin, origin) <= 150 || distance2d(zoms[a].origin, origin2) <= 150) open = true;
        for (a = 0; a < getPlayers().size; a++)
            if (distance2d(getPlayers()[a].origin, origin) <= 150 || distance2d(getPlayers()[a].origin, origin2) <= 150) open = true;
        if (!isDefined(door.doors[0].open)) {
            if (isDefined(open)) {
                for (a = 0; a < door.doors.size; a++) door.doors[a] thread junk("dOPEN");
                wait .2;
                door.doors[0].open = true;
            }
        } else {
            if (!isDefined(open)) {
                for (a = 0; a < door.doors.size; a++) door.doors[a] thread junk("dCLOSE");
                wait .2;
                door.doors[0].open = undefined;
            }
        }
        wait .05;
    }
}
watchDebris() {
    self thread connectAllPaths("DEBRIS");
    level endon("KillMoonDoors");
    junk = getEntArray(self.target, "targetname");
    trigs = getEntArray(self.target, "target");
    for (a = 0; a < trigs.size; a++) junk[a].trig setString("");
    origin = junk[0].savedOrigin;
    if (isDefined(junk[0].debris_moving)) junk[0].open = true;
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread everyOneWatchDebris(junk, origin);
}
everyOneWatchDebris(junk, origin) {
    while (isDefined(level.moonDoors)) {
        open = undefined;
        zoms = getAISpeciesArray("axis", "all");
        for (a = 0; a < zoms.size; a++)
            if (distance(zoms[a].origin, origin) <= 200) open = true;
        for (a = 0; a < getPlayers().size; a++)
            if (distance(getPlayers()[a].origin, origin) <= 200) open = true;
        if (!isDefined(junk[0].open)) {
            if (isDefined(open)) {
                for (a = 0; a < junk.size; a++) junk[a] thread junk("OPEN");
                wait .2;
                junk[0].open = true;
            }
        } else {
            if (!isDefined(open)) {
                for (a = 0; a < junk.size; a++) junk[a] thread junk("CLOSE");
                wait .2;
                junk[0].open = undefined;
            }
        }
        wait .05;
    }
}
junk(type) {
    og_angles = self.angles;
    if (type == "CLOSE") {
        self show();
        for (a = 0; a < 2; a++) {
            angles = og_angles + (-5 + randomFloat(10), -5 + randomFloat(10), -5 + randomFloat(10));
            self rotateTo(angles, .15);
            wait .1;
        }
        time = .4;
        self moveTo(self.savedOrigin, time, time * .35);
        self rotateTo(self.savedAngles, time * .6);
        self waittill("movedone");
    }
    if (type == "OPEN") {
        self show();
        playSoundAtPosition("purchase", self.origin);
        self playSound("debris_move");
        playSoundAtPosition("lightning_l", self.origin);
        playFx(level._effect[self.script_firefx], self.origin);
        angles = og_angles + (-5 + randomFloat(10), -5 + randomFloat(10), -5 + randomFloat(10));
        self rotateTo(angles, .15);
        wait .1;
        time = .4;
        self moveTo(self.savedStructOrigin, time, time * .35);
        self rotateTo(self.savedStructAngles, time * .6);
        self waittill("movedone");
        self playSound("couch_slam");
        playFx(level._effect[self.script_fxid], self.origin);
        playSoundAtPosition("zombie_spawn", self.origin);
    }
    if (type == "dCLOSE") {
        self moveTo(self.savedOrigin, .3, .1, .1);
        if (isDefined(self.script_vector)) self door_solid_thread();
        self waittill("movedone");
    }
    if (type == "dOPEN") {
        self moveTo(self.newOrigin, .3, .1, .1);
        if (isDefined(self.script_vector)) self door_solid_thread();
        self waittill("movedone");
    }
}
connectAllPaths(type) {
    trigs = getEntArray(self.target, "target");
    junk = getEntArray(self.target, "targetname");
    if (type == "DOOR") {
        for (a = 0; a < self.doors.size; a++) {
            self.doors[a] notSolid();
            self.doors[a] connectPaths();
            if (isDefined(self.doors[a].target)) self.doors[a] thread add_new_zombie_spawners();
        }
        level waittill("KillMoonDoors");
        level.enemy_spawns = [];
        if (isDefined(self.doors[0].door_moving)) {
            if (!isDefined(self.doors[0].open))
                for (a = 0; a < self.doors.size; a++) self.doors[a] thread junk("dOPEN");
            return;
        } else {
            for (a = 0; a < self.doors.size; a++) {
                if (isDefined(self.doors[0].open)) self.doors[a] thread junk("dCLOSE");
                self.doors[a] solid();
                self.doors[a] disConnectPaths();
                if (isDefined(self.doors[a].target)) self.doors[a] thread add_new_zombie_spawners();
            }
            self.doors[0].open = undefined;
        }
        if (getMap() == "nzf") array_thread(trigs, ::trigger_on);
    } else if (type == "DEBRIS") {
        for (a = 0; a < junk.size; a++) {
            junk[a] show();
            junk[a] notSolid();
            junk[a] connectPaths();
            if (isDefined(junk[a].target)) junk[a] thread add_new_zombie_spawners();
        }
        level waittill("KillMoonDoors");
        level.enemy_spawns = [];
        if (isDefined(junk[0].debris_moving)) {
            if (!isDefined(junk[0].open))
                for (a = 0; a < junk.size; a++) junk[a] thread junk("OPEN");
            junk[0] waittill("movedone");
            for (a = 0; a < junk.size; a++) junk[a] hide();
            return;
        } else {
            for (a = 0; a < junk.size; a++) {
                if (isDefined(junk[0].open)) junk[a] thread junk("CLOSE");
                junk[a] solid();
                junk[a] disConnectPaths();
                if (isDefined(junk[a].target)) junk[a] thread add_new_zombie_spawners();
            }
            junk[0].open = undefined;
        }
    }
    for (a = 0; a < trigs.size; a++) junk[a].trig setString("Press & hold [{+activate}] to Clear Debris [Cost: 1000]");
}
predatorMissile() {
    if (getMap() == "nzf") self doPredatorMissile(loadFx("maps/mp_maps/fx_mp_zombie_hand_dirt_burst"), (-1200, 1100, 2400), (50, -45, 0));
    if (getMap() == "nzs") self doPredatorMissile(loadFx("maps/mp_maps/fx_mp_zombie_hand_dirt_burst"), (10341, 612, 408));
    if (getMap() == "nza") self doPredatorMissile(loadFx("maps/mp_maps/fx_mp_zombie_hand_dirt_burst"), (221, 20, 1337));
    if (getMap() == "nzp") self doPredatorMissile(loadFx("env/dirt/fx_dust_ceiling_impact_lg_mdbrown"), (-51, 45, 150));
}
doPredatorMissile(fx, spawnPoint, spawnAngles) {
    savedOrigin = self getOrigin();
    self thread lockMenu("ALL");
    self enableInvulnerability();
    self hide();
    self allowADS(false);
    self allowCrouch(false);
    self allowMelee(false);
    self allowSprint(false);
    self disableWeapons();
    self disableOffHandWeapons();
    self setInstructions("^2Predator Missile: ^7[{+attack}]: Boost");
    bg = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", 1, 0);
    bg hudFade(1, .2);
    coords = strTok("21;0;2;24;-20;0;2;24;0;-11;40;2;0;11;40;2;0;-39;2;57;0;39;2;57;-48;0;57;2;49;0;57;2;-155;-122;2;21;-155;122;2;21;155;122;2;21;155;-122;2;21;-145;132;21;2;145;-132;21;2;-145;-132;21;2;145;132;21;2", ";");
    hud = [];
    for (a = 0; a < coords.size; a += 4) {
        hud[hud.size] = self createRectangle("CENTER", "CENTER", int(coords[a]), int(coords[a + 1]), int(coords[a + 2]), int(coords[a + 3]), (1, 1, 1), "white", 2, 0);
        hud[hud.size - 1] thread hudFade(1, .2);
    }
    self setVision("introscreen");
    missile = spawnSM(spawnPoint, "zombie_bomb", vectorToAngles(self.origin - self lookPos()) - (180, 0, 0));
    missile setInvisibleToPlayer(self);
    for (a = 0; a < 5; a++) playFxOnTag(loadFx("misc/fx_zombie_powerup_on"), missile, "tag_origin");
    self playerLinkTo(missile);
    self setPlayerAngles(spawnAngles);
    self setClientDvars("cg_drawGun", 0, "ui_hud_hardcore", 1, "cg_drawCrosshair", 0);
    wait .2;
    bg hudFade(0, .2);
    missile playSound("weap_pnzr_fire");
    speed = 25;
    boost = false;
    while (1) {
        ang = self getPlayerAngles();
        if (ang[0] < 20) self setPlayerAngles((20, ang[1], ang[2]));
        vector = anglesToForward(missile.angles);
        forward = missile.origin + (vector[0] * speed, vector[1] * speed, vector[2] * speed);
        collision = bulletTrace(missile.origin, forward, false, self);
        missile.angles = (vectorToAngles((lookPos() - (0, 0, 70)) - missile.origin));
        missile moveTo(forward, .05);
        if (self attackButtonPressed() && !boost) {
            boost = true;
            self setClientDvar("cg_fov", 75);
            self playLocalSound("bridge_hit");
            speed = 75;
        }
        if (collision["surfacetype"] != "default" && collision["fraction"] < 1) {
            expPos = missile.origin;
            for (a = 0; a < 360; a += 80) playFx(loadFx("explosions/default_explosion"), (expPos[0] + (200 * cos(a)), expPos[1] + (200 * sin(a)), expPos[2]));
            earthquake(1, 1.6, expPos, 250);
            killZombiesWithinDistance(expPos, 400, "flame");
            doPlayerDamage(expPos, 200);
            playSoundAtPosition("grenade_explode", expPos);
            playSoundAtPosition("nuked", expPos);
            break;
        }
        wait .05;
    }
    self enableWeapons();
    self enableOffHandWeapons();
    self allowADS(true);
    self allowCrouch(true);
    self allowMelee(true);
    self allowSprint(true);
    self show();
    self unlink();
    self thread godCheck();
    missile remove();
    bg hudFade(1, .2);
    for (a = 0; a < hud.size; a++) hud[a] thread hudFadenDestroy(0, .2);
    wait .2;
    self freezeControls(false);
    self resetInstructions();
    self unlockMenu();
    self setOrigin(savedOrigin);
    self setVision("default");
    self setClientDvars("cg_drawGun", 1, "ui_hud_hardcore", 0, "cg_drawCrosshair", 1, "cg_fov", 65);
    bg hudFadenDestroy(0, .2);
    self notify("Predator Missile Over");
}
startPrecision(type) {
    self thread lockMenu("ALL");
    self thread startMapSelect(type);
    if (type == "AIRSTRIKE") self setInstructions("^2Precision Airstrike: ^7[{+activate}]: Choose Location - [{+melee}]: Exit Precision Airstrike");
    else if (type == "STEALTH") self setInstructions("^2Precision Stealth Bomber: ^7[{+activate}]: Choose Location - [{+melee}]: Exit Precision Stealth Bomber");
    else self setInstructions("^2Precision Teleporter: ^7[{+activate}]: Choose Location - [{+melee}]: Exit Precision Teleporter");
}
startMapSelect(type) {
    self enableGodMode();
    angle = self.angles;
    self setblur(10, 1);
    hud = [];
    hud[0] = createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", -200, 0);
    hud[1] = createRectangle("", "", 0, 0, 35, 35, undefined, "rank_prestige10", 3, 1);
    hud[2] = createRectangle("CENTER", "CENTER", 0, 0, 470, 270, undefined, "menu_map_nazi_zombie_factory", 2, 1);
    hud[0] thread hudFade(.8, .5);
    self monitorCursor(hud, type);
    self setPlayerAngles(angle);
    for (a = 0; a < hud.size; a++) hud[a] thread hudFadenDestroy(0, 1);
    self setblur(0, 1);
    wait 1;
    self unlockMenu();
    self thread godCheck();
    self resetInstructions();
}
monitorCursor(hud, type) {
    wait .5;
    self setPlayerAngles((0, 90, 0));
    while (1) {
        hud[1] moveOverTime(.05);
        if (90 - self getPlayerAngles()[1] < -2) hud[1].x -= 3;
        if (90 - self getPlayerAngles()[1] > 2) hud[1].x += 3;
        if (0 - self getPlayerAngles()[0] < -1) hud[1].y += 3;
        if (0 - self getPlayerAngles()[0] > 1) hud[1].y -= 3;
        self setPlayerAngles((0, 90, 0));
        if (hud[1].y > 125) hud[1].y = 125;
        if (hud[1].y < -125) hud[1].y = -125;
        if (hud[1].x > 130) hud[1].x = 130;
        if (hud[1].x < -200) hud[1].x = -200;
        if (self useButtonPressed()) {
            if (type == "AIRSTRIKE") self thread startAirstrike(hud[1].x, hud[1].y);
            else if (type == "STEALTH") {
                if (!isDefined(level.bomberInUse)) self thread spawnStealthBomber((-960, 1365.8, 682), (80 + hud[1].y * 11.5, -560 + hud[1].x * 12, 682));
                else self iPrintln("Stealth Bomber Is ^1In Use");
            } else if (type == "TELEPORT") {
                self iprintln("TELEPORT");
                self setOrigin((80 + hud[1].y * 11.5, -560 + hud[1].x * 12, 210));
            }
            break;
        } else if (self meleeButtonPressed()) break;
        wait 0.05;
    }
}
startAirstrike(x, y) {
    strikeBegin = (80, -560, self.origin[2] + 1300);
    strikeOrigin = strikeBegin + (y * 11.5, x * 12, 0);
    for (a = 0; a < 8; a++) {
        ground = strikeOrigin - (0, 0, 1300);
        random = (randomIntRange(-100, 100), randomIntRange(-150, 100), 0);
        magicBullet("panzerschrek_zombie", strikeOrigin, ground, self);
        wait .3;
        magicBullet("panzerschrek_zombie", strikeOrigin + random, ground + random, self);
        wait .3;
        magicBullet("panzerschrek_zombie", strikeOrigin + random, ground + random, self);
        wait .3;
    }
}
stealthBomber() {
    if (!isDefined(level.bomberInUse)) {
        if (getMap() == "nzf") self thread spawnStealthBomber((-960, 1365.8, 682), (1200, -3000, 682));
        if (getMap() == "nzs") self thread spawnStealthBomber((12454.4, -1286.07, 396.84), (7517.75, 2917.76, 396.847));
        if (getMap() == "nza") self thread spawnStealthBomber((-1667.89, -1212.33, 1050.76), (1844.59, 1421.16, 1050.76));
        if (getMap() == "nzp") self thread spawnStealthBomber((-454.815, -1611.51, 484.719), (830.339, 2015.8, 484.719));
    } else self iPrintln("Stealth Bomber Is ^1In Use");
}
spawnStealthBomber(start, end) {
    level.bomberInUse = true;
    bomber = spawnSM(start, "defaultvehicle", vectorToAngles(start - end) - (0, 180, 0));
    bomber moveTo(end, 12);
    for (a = 0; a < 120; a++) {
        magicBullet("colt_dirty_harry", bomber.origin, bomber.origin - (0, 0, 682), self);
        wait .1;
        earthquake(0.6, 4, bomber.origin, 850);
    }
    bomber remove();
    level.bomberInUse = undefined;
}
orbitalStrike() {
    if (getMap() == "nzf") self doOrbitalStrike(loadfx("maps/mp_maps/fx_mp_light_lamp"), level._effect["strike"]);
    else if (getMap() == "nzs") self doOrbitalStrike(loadFx("env/light/fx_ray_ceiling_amber_dim_sm"), loadFx("maps/zombie/fx_zombie_dog_lightning_buildup"));
    else self doOrbitalStrike(loadFx("env/light/fx_ray_ceiling_amber_dim_sm"), loadFx("misc/fx_zombie_couch_effect"));
}
doOrbitalStrike(fx, fx2) {
    self endon("disconnect");
    self endon("death");
    self thread lockMenu("ALL");
    self setInstructions("^2Orbital Strike: ^7[{+activate}]: Call In Strike At Marker - [{+melee}]: To Abort Strike");
    orb = spawnSM(self lookPos(), "tag_origin", (-90, 0, 0));
    for (a = 0; a < 10; a++) playFxOnTag(fx, orb, "tag_origin");
    wait .2;
    while (1) {
        orb moveTo(self lookPos(), .1);
        if (self useButtonPressed() && self getStance() != "prone") {
            self thread orbitStrike(orb, fx2);
            break;
        }
        if (self meleeButtonPressed() && self getStance() != "prone") {
            self playLocalSound("pa_buzz");
            orb remove();
            break;
        }
        wait .05;
    }
    self resetInstructions();
    self unlockMenu();
}
orbitStrike(orb, fx2) {
    self playLocalSound("pa_buzz");
    wait 3;
    for (a = 0; a < 20; a++) playFx(fx2, orb.origin);
    zombz = get_array_of_closest(orb.origin, getAiSpeciesArray("axis"), undefined, undefined, 300);
    for (a = 0; a < zombz.size; a++) {
        wait(randomFloatRange(.2, .3));
        zombz[a] zombie_head_gib();
        zombz[a] doDamage(10000, zombz[a].origin, self);
        playSoundatPosition("nuked", Zombz[a].origin);
    }
    orb remove();
}
valkyrieMissile() {
    self endon("death");
    self endon("disconnect");
    self thread lockMenu("ALL");
    self disableWeapons();
    savedOrigin = self getOrigin();
    self enableInvulnerability();
    self setVision("introscreen");
    coords = strTok("15;0;2;30;-15;0;2;30;0;-15;30;2;0;15;30;2;25;0;20;2;-25;0;20;2;0;25;2;20;0;-25;2;20;87;100;26;2;100;87;2;26;-87;100;26;2;100;-87;2;26;87;-100;26;2;-100;87;2;26;-87;-100;26;2;-100;-87;2;26", ";");
    hud = [];
    for (a = 0; a < coords.size; a += 4) {
        hud[hud.size] = self createRectangle("CENTER", "CENTER", int(coords[a]), int(coords[a + 1]), int(coords[a + 2]), int(coords[a + 3]), (1, 1, 1), "white", 2, 0);
        hud[hud.size - 1] thread hudFade(1, .2);
    }
    self setInstructions("^2Valkyrie Missile: ^7[{+attack}]: Launch Missile - [{+melee}]: Exit Valkyrie Missile");
    valkyries = 0;
    while (1) {
        wait .05;
        if (self attackButtonPressed()) {
            valkyries++;
            bomb = spawnSM(self getTagOrigin("tag_weapon_left"), "zombie_bomb", (vectorToAngles((lookPos() - (0, 0, 70)) - self getTagOrigin("tag_weapon_left"))));
            bomb setInvisibleToPlayer(self);
            self playSound("weap_pnzr_fire");
            self hide();
            self playerLinkTo(bomb);
            while (1) {
                vector = anglesToForward(bomb.angles);
                forward = bomb.origin + (vector[0] * 45, vector[1] * 45, vector[2] * 45);
                collision = bulletTrace(bomb.origin, forward, false, self);
                bomb.angles = (vectorToAngles((lookPos() - (0, 0, 70)) - bomb.origin));
                bomb moveTo(forward, .05);
                wait .05;
                if (collision["surfacetype"] != "default" && collision["fraction"] < 1) {
                    expPos = bomb.origin;
                    for (a = 0; a < 360; a += 80) playFx(loadFx("explosions/default_explosion"), (expPos[0] + (200 * cos(a)), expPos[1] + (200 * sin(a)), expPos[2]));
                    earthquake(1, 1.6, expPos, 250);
                    killZombiesWithinDistance(expPos, 400, "flame");
                    doPlayerDamage(expPos, 200);
                    bomb playSound("grenade_explode");
                    self playLocalSound("grenade_explode_dist");
                    bomb remove();
                    break;
                }
            }
            self setOrigin(savedOrigin);
        }
        if (self meleeButtonPressed() && !isSurv() || valkyries == 2) break;
    }
    self thread godCheck();
    bg = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", 1, 0);
    for (a = 0; a < hud.size; a++) hud[a] thread hudFadenDestroy(0, .2);
    bg hudFade(1, .2);
    self show();
    self resetInstructions();
    self unlockMenu();
    self enableWeapons();
    self setVision("default");
    self setOrigin(savedOrigin);
    bg hudFadenDestroy(0, .6);
    self notify("valkerie Over");
}
deployableApacheGunner(isWalking) {
    self endon("death");
    self endon("disconnect");
    self thread lockMenu("ALL");
    bg = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", 1, 0);
    bg hudFade(1, .2);
    self disableWeapons();
    savedOrigin = self getOrigin();
    self enableInvulnerability();
    self setVision("introscreen");
    apache = 0;
    chopper = 0;
    text = "Walking ";
    if (!isDefined(isWalking)) {
        text = "";
        apache = spawnHelicopter(getPlayers()[0].origin + (500, 500, 1000));
        for (a = 0; a < apache.size; a++) apache[a] setInvisibleToPlayer(self);
        chopper = apache[0];
        self playerLinkTo(chopper);
        self hide();
    }
    self setInstructions("^2" + text + "Apache Gunner: ^7[{+attack}]: Shoot - [{+melee}]: Exit " + text + "Apache Gunner");
    overwatch = 0;
    coords = strTok("0;-70;2;115;0;70;2;115;-70;0;115;2;70;0;115;2;0;-128;14;2;0;128;14;2;-128;0;2;14;128;0;2;14;0;-35;8;2;0;35;8;2;-29;0;2;8;29;0;2;8;-64;0;2;9;64;0;2;9;0;-85;10;2;0;85;10;2;-99;0;2;10;99;0;2;10", ";");
    hud = [];
    for (a = 0; a < coords.size; a += 4) {
        hud[hud.size] = self createRectangle("CENTER", "CENTER", int(coords[a]), int(coords[a + 1]), int(coords[a + 2]), int(coords[a + 3]), (1, 1, 1), "white", 2, 0);
        hud[hud.size - 1] thread hudFade(1, .2);
    }
    uiHud = [];
    uiHud[0] = hud[8];
    uiHud[1] = hud[9];
    uiHud[2] = hud[10];
    uiHud[3] = hud[11];
    self thread UIDetect(uiHud, "apacheOver", 100);
    bg hudFadenDestroy(0, .6);
    self thread apacheGunner();
    movements = 6;
    if (!isSurv()) movements = 100000000000;
    for (a = 0; a < movements; a++) {
        wait .05;
        if (self meleeButtonPressed() && !isSurv()) break;
        if (isDefined(isWalking)) continue;
        while (1) {
            zombz = getAiSpeciesArray("axis", "all");
            if (!isDefined(zombz[0])) wait .05;
            randy = randomInt(zombz.size);
            overwatch = zombz[randy];
            if (self meleeButtonPressed() && !isSurv() || isDefined(zombz[randy])) break;
            wait .05;
        }
        dest = getAboveBuildingsLocation(overwatch.origin + (0, 0, 1000));
        chopper moveTo(dest, 3, 1, 1);
        chopper rotateTo((chopper.angles[0], vectorToAngles(chopper.origin - dest)[1] - 180, chopper.angles[2]), 3, 1, 1);
        for (e = 0; e <= 10; e += .05) {
            wait .05;
            if (self meleeButtonPressed() && !isSurv()) break;
        }
    }
    self notify("apacheOver");
    bg = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", 1, 0);
    bg hudFade(1, .05);
    self setVision("default");
    for (a = 0; a < hud.size; a++) hud[a] thread hudFadenDestroy(0, .03);
    bg hudFadenDestroy(0, .03);
    self unlink();
    self show();
    self thread godCheck();
    self resetInstructions();
    self unlockMenu();
    if (!isDefined(isWalking)) {
        for (a = 0; a < apache.size; a++) apache[a] remove();
        self setOrigin(savedOrigin);
    }
    self enableWeapons();
    self setVision("default");
}
UIDetect(hud, endUpon, dist) {
    self endon("death");
    self endon("disconnect");
    self endon(endUpon);
    while (1) {
        zombz = getAiSpeciesArray("axis", "all");
        for (a = 0; a < zombz.size; a++)
            if (distance(self lookPos(), zombz[a].origin) < dist)
                for (e = 0; e < hud.size; e++) hud[e].color = (1, 0, 0);
        wait .05;
        for (e = 0; e < hud.size; e++) hud[e].color = (1, 1, 1);
    }
}
apacheGunner() {
    self endon("death");
    self endon("disconnect");
    self endon("apacheOver");
    deathFx[0] = % death_explosion_run_B_v2;
    deathFx[1] = % death_explosion_run_L_v2;
    deathFx[2] = % death_explosion_run_F_v2;
    deathFx[3] = % death_explosion_run_R_v2;
    while (1) {
        if (self attackButtonPressed()) {
            for (e = 0; e < 2; e++) {
                pos = self lookPos();
                magicBullet("zombie_sw_357", self.origin - (0, 0, 2), pos);
                earthquake(.25, 1, self.origin, 90);
                zombz = getAiSpeciesArray("axis", "all");
                for (a = 0; a < zombz.size; a++)
                    if (distance(zombz[a].origin, pos) <= 100) {
                        zombz[a].deathanim = deathFx[randomInt(deathFx.size)];
                        zombz[a] animMode("nogravity");
                        zombz[a] doDamage(99999, self.origin, undefined, undefined, "pistolbullet");
                    }
                doPlayerDamage(pos, 50);
                earthquake(1.5, 1, pos, 100);
                for (a = 0; a < 5; a++) playFx(loadFx("env/electrical/fx_elec_short_oneshot"), (pos[0] + randomIntRange(-15, 15), pos[1] + randomIntRange(-15, 15), pos[2]));
                wait .1;
            }
            wait .1;
        }
        wait .05;
    }
}
spawnHelicopter(pos) {
    prop[0] = spawnSM(pos, "defaultvehicle");
    prop[1] = spawnSM(prop[0].origin + (-17, -3, 60), "zombie_teleporter_powerline", (90, 0, 90));
    prop[2] = spawnSM(prop[1].origin, prop[1].model, (90, 0, -90));
    prop[3] = spawnSM(prop[1].origin, prop[1].model, (90, 0, -180));
    prop[4] = spawnSM(prop[1].origin, prop[1].model, (90, 0, 0));
    prop[5] = spawnSM(prop[1].origin, "tag_origin");
    for (a = 1; a < 5; a++) prop[a] linkTo(prop[5]);
    prop[5] thread rotateEntYaw(360, .5);
    prop[5] thread heliKeepUp(prop[0]);
    return prop;
}
heliKeepUp(ent) {
    while (isDefined(self)) {
        self moveTo(ent.origin + (-17, -3, 60), .05);
        wait .05;
    }
}
getAboveBuildingsLocation(location) {
    trace = bullettrace(location + (0, 0, 10000), location, false, undefined);
    startorigin = trace["position"] + (0, 0, -514);
    zpos = 0;
    maxxpos = 13;
    maxypos = 13;
    for (xpos = 0; xpos < maxxpos; xpos++)
        for (ypos = 0; ypos < maxypos; ypos++) {
            thisstartorigin = startorigin + ((xpos / (maxxpos - 1) - .5) * 1024, (ypos / (maxypos - 1) - .5) * 1024, 0);
            thisorigin = bullettrace(thisstartorigin, thisstartorigin + (0, 0, -10000), false, undefined);
            zpos += thisorigin["position"][2];
        }
    zpos = zpos / (maxxpos * maxypos);
    zpos = zpos + 850;
    return (location[0], location[1], zpos);
}
reaper(isWalking) {
    self endon("death");
    self endon("disconnect");
    self.reaperOver = undefined;
    self thread lockMenu("ALL");
    self enableInvulnerability();
    savedPos = self getOrigin();
    self disableWeapons();
    int = randomInt(360);
    reaper = 0;
    text = "Walking ";
    if (!isDefined(isWalking)) {
        text = "";
        hi = 2000;
        if (getMap() == "nzp") hi = 1400;
        reaper = spawnSM((cos(int) * 1200, sin(int) * 1200, hi), "defaultvehicle");
        reaper setInvisibleToPlayer(self);
        self playerLinkTo(reaper);
        self setPlayerAngles((59, 126, 0));
        self thread reaperRotate(reaper, int);
        self hide();
    }
    if (isSurv()) self thread reaperTimeOut();
    self thread reaperZoom();
    ui = strTok("0;15;40;2;0;-15;40;2;20;0;2;30;-20;0;2;30;-35;0;30;2;35;0;30;2", ";");
    hud = [];
    for (a = 0; a < ui.size + 1; a += 4) hud[hud.size] = self createRectangle("CENTER", "CENTER", int(ui[a]), int(ui[(a + 1)]), int(ui[(a + 2)]), int(ui[(a + 3)]), (1, 1, 1), "white", 1, 1);
    self thread UIDetect(hud, "reaperOver", 150);
    self setInstructions("^2" + text + "Reaper UAV: ^7[{+speed_throw}]: Zoom In - [{+attack}]: Launch Missile - [{+melee}]: Exit " + text + "Reaper UAV");
    while (1) {
        if (self attackButtonPressed()) {
            self disableWeapons();
            bomb = spawnSM(self getEye() + anglesToForward(self getPlayerAngles()) * -15, "zombie_bomb", (vectorToAngles((lookPos() - (0, 0, 70)) - self getEye() + anglesToForward(self getPlayerAngles()) * -15)));
            bomb playSound("weap_pnzr_fire");
            while (1) {
                vector = anglesToForward(bomb.angles);
                forward = bomb.origin + vector * 45;
                collision = bulletTrace(bomb.origin, forward, false, self);
                bomb.angles = (vectorToAngles((lookPos() - (0, 0, 70)) - bomb.origin));
                bomb moveTo(forward, .05);
                if (collision["surfacetype"] != "default" && collision["fraction"] < 1) {
                    expPos = bomb.origin;
                    for (a = 0; a < 360; a += 80) playFx(loadFx("explosions/default_explosion"), (expPos[0] + (200 * cos(a)), expPos[1] + (200 * sin(a)), expPos[2]));
                    earthquake(1, 1.6, expPos, 250);
                    killZombiesWithinDistance(expPos, 400, "flame");
                    doPlayerDamage(expPos, 200);
                    bomb playSound("grenade_explode");
                    self playLocalSound("grenade_explode_dist");
                    break;
                }
                if (self meleeButtonPressed() && !isSurv()) break;
                wait .05;
            }
            bomb remove();
        }
        wait .05;
        if (isDefined(self.reaperOver)) break;
        if (self meleeButtonPressed() && !isSurv()) break;
    }
    self notify("reaperOver");
    self setClientDvar("cg_fov", 65);
    for (a = 0; a < hud.size; a++) hud[a] destroy();
    if (!isDefined(isWalking)) {
        reaper remove();
        self unlink();
        self setOrigin(savedPos);
    }
    self thread godCheck();
    self resetInstructions();
    self unlockMenu();
    self show();
    self enableWeapons();
}
reaperZoom() {
    self endon("death");
    self endon("disconnect");
    self endon("reaperOver");
    while (1) {
        wait .05;
        if (self adsButtonPressed()) {
            self setClientDvar("cg_fov", 35);
            continue;
        }
        if (!self adsButtonPressed()) self setClientDvar("cg_fov", 65);
    }
}
reaperRotate(reaper, int) {
    self endon("death");
    self endon("disconnect");
    self endon("reaperOver");
    mod = 0;
    mod1 = 0;
    mod2 = 0;
    if (getMap() == "nzp") {
        mod = 1200;
        mod1 = 1200;
        mod2 = 1400;
    } else {
        mod = 1200;
        mod1 = 1200;
        mod2 = 2000;
    }
    firstLoc = reaper.origin;
    while (1) {
        for (a = int; a < 720; a += .5) {
            loc = (cos(a) * mod, sin(a) * mod1, mod2);
            angles = vectorToAngles(loc - reaper.origin);
            reaper moveTo(loc, .1);
            reaper rotateTo((angles[0], angles[1], angles[2] - 40), .1);
            wait .1;
        }
    }
}
reaperTimeOut() {
    self endon("death");
    self endon("disconnect");
    wait 45;
    self.reaperOver = true;
}
initAC130(isWalking) {
    hi = 2000;
    if (getMap() == "nzp") hi = 1400;
    self thread doAC130((-65, -392, hi), isWalking);
}
doAC130(spawnLoc, isWalking) {
    self endon("disconnect");
    self endon("death");
    self thread lockMenu("ALL");
    self enableInvulnerability();
    self.acEnding = undefined;
    savedOrigin = self getOrigin();
    base = 0;
    attacher = 0;
    text = "Walking ";
    if (!isDefined(isWalking)) {
        text = "";
        base = spawnSM(spawnLoc, "tag_origin");
        yaw = randomIntRange(-360, 360);
        attacher = spawnSM((cos(yaw) * 900, sin(yaw) * 900, spawnLoc[2]), "tag_origin");
        attacher linkTo(base);
        self playerLinkTo(attacher);
        self hide();
    }
    self disableWeapons();
    self hide();
    self thread doAC130Weapons();
    self setInstructions("^2" + text + "AC130 Spectre: ^7[{+attack}]: Shoot Missile/Bullet - [{+frag}]: Switch Weapons - [{+melee}]: Exit " + text + "AC130 Spectre");
    if (!isSurv())
        while (1) {
            base rotateYaw(360, 60);
            for (m = 0; m <= 60; m += .05) {
                if (isDefined(self.acEnding)) break;
                wait .05;
            }
            if (isDefined(self.acEnding)) break;
            wait .05;
        } else {
            base rotateYaw(360, 60);
            wait 60;
        }
    if (!isDefined(isWalking)) {
        self unlink();
        self thread godCheck();
        self setOrigin(savedOrigin);
        attacher remove();
        base remove();
    }
    self notify("ac130_over");
    for (a = 0; a < self.ac130HudArray.size; a++) self.ac130HudArray[a] destroy();
    self unlockMenu();
    self thread godCheck();
    self resetInstructions();
    self show();
    self enableWeapons();
    self setClientDvar("cg_fov", 65);
}
doAC130Weapons() {
    self endon("disconnect");
    self endon("death");
    self endon("ac130_over");
    currentWeapon = "105mm";
    self.ac130Weapon40Count = 0;
    self.ac130Weapon25Count = 0;
    self ac130_fov(currentWeapon);
    self ac130_hud(currentWeapon);
    while (1) {
        if (self fragButtonPressed()) {
            if (currentWeapon == "105mm") currentWeapon = "40mm";
            else if (currentWeapon == "40mm") currentWeapon = "25mm";
            else currentWeapon = "105mm";
            self ac130_fov(currentWeapon);
            self ac130_hud(currentWeapon);
            wait .1;
        }
        if (self attackButtonPressed()) {
            if (currentWeapon == "105mm") {
                if (!isDefined(self.ac130Weapon105OnHold)) {
                    self.ac130Weapon105OnHold = true;
                    playSoundAtPosition("weap_pnzr_fire", self.origin);
                    earthQuake(.1, 1, self.origin, 1000);
                    self ac130_105();
                    self thread ac130_105Wait();
                }
            } else if (currentWeapon == "40mm") {
                if (!isDefined(self.ac130Weapon40OnHold)) {
                    self.ac130Weapon40Count++;
                    playSoundAtPosition("weap_pnzr_fire", self.origin);
                    earthQuake(.1, 1, self.origin, 1000);
                    self ac130_40();
                    if (self.ac130Weapon40Count >= 5) self thread ac130_40Wait();
                    wait .3;
                }
            } else if (currentWeapon == "25mm") {
                if (!isDefined(self.ac130Weapon25OnHold)) {
                    self.ac130Weapon25Count++;
                    playSoundAtPosition("weap_ppsh_fire", self.origin);
                    earthQuake(.1, 1, self.origin, 1000);
                    self ac130_25();
                    if (self.ac130Weapon25Count >= 15) self thread ac130_25Wait();
                    wait .05;
                }
            }
        }
        if (self meleeButtonPressed()) self.acEnding = true;
        wait .05;
    }
}
ac130_105Wait() {
    wait 3;
    self.ac130Weapon105OnHold = undefined;
}
ac130_40Wait() {
    self.ac130Weapon40OnHold = true;
    wait 2;
    self.ac130Weapon40Count = 0;
    self.ac130Weapon40OnHold = undefined;
}
ac130_25Wait() {
    self.ac130Weapon25OnHold = true;
    wait 2;
    self.ac130Weapon25Count = 0;
    self.ac130Weapon25OnHold = undefined;
}
ac130_hud(cannon) {
    if (!isDefined(self.ac130HudArray)) self.ac130HudArray = [];
    for (a = 0; a < self.ac130HudArray.size; a++) self.ac130HudArray[a] destroy();
    if (cannon == "105mm") cannon = "21;0;2;24;-20;0;2;24;0;-11;40;2;0;11;40;2;0;-39;2;57;0;39;2;57;-48;0;57;2;49;0;57;2;-155;-122;2;21;-154;122;2;21;155;122;2;21;155;-122;2;21;-145;132;21;2;145;-132;21;2;-145;-132;21;2;146;132;21;2";
    if (cannon == "40mm") cannon = "0;-70;2;115;0;70;2;115;-70;0;115;2;70;0;115;2;0;-128;14;2;0;128;14;2;-128;0;2;14;128;0;2;14;0;-35;8;2;0;35;8;2;-29;0;2;8;29;0;2;8;-64;0;2;9;64;0;2;9;0;-85;10;2;0;85;10;2;-99;0;2;10;99;0;2;10";
    if (cannon == "25mm") cannon = "0;-10;10;2;0;10;10;2;-10;0;2;10;10;0;2;10;50;-60;20;2;60;-50;2;20;-50;-60;20;2;-60;-50;2;20;50;60;20;2;60;50;2;20;-50;60;20;2;-60;50;2;20";
    cannon = strTok(cannon, ";");
    for (a = 0; a < cannon.size + 1; a += 4) self.ac130HudArray[self.ac130HudArray.size] = self createRectangle("CENTER", "MIDDLE", int(cannon[a]), int(cannon[(a + 1)]), int(cannon[(a + 2)]), int(cannon[(a + 3)]), (1, 1, 1), "white", 1, 1);
}
ac130_fov(cannon) {
    if (cannon == "105mm") self setClientDvar("cg_fov", 65);
    else if (cannon == "40mm") self setClientDvar("cg_fov", 35);
    else self setClientDvar("cg_fov", 20);
}
ac130_105() {
    self endon("disconnect");
    self endon("death");
    bul = spawnSM(self getEye() + anglesToForward(self getPlayerAngles()) * -15, "zombie_bomb", (vectorToAngles((lookPos() - (0, 0, 70)) - self getEye() + anglesToForward(self getPlayerAngles()) * -15)));
    bul moveTo(self lookPos(), .4);
    bul thread ac130_105impact();
}
ac130_105impact() {
    self waittill("movedone");
    playSoundAtPosition("grenade_explode", self.origin);
    playFx(loadFx("explosions/default_explosion"), self.origin);
    killZombiesWithinDistance(self.origin, 300, "flame");
    doPlayerDamage(self.origin, 300);
    earthQuake(1, 1, self.origin, 100);
    self remove();
    darkScreen = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", -10, 0);
    darkScreen thread hudFade(.6, .2);
    wait .4;
    darkScreen thread hudFade(0, .8);
    darkScreen destroy();
}
ac130_40() {
    self endon("disconnect");
    self endon("death");
    bul = spawnSM(self.origin, "zombie_skull");
    bul moveTo(self lookPos(), .4);
    bul thread ac130_40impact();
}
ac130_40impact() {
    self waittill("movedone");
    playSoundAtPosition("grenade_explode", self.origin);
    playFx(loadFx("explosions/default_explosion"), self.origin);
    killZombiesWithinDistance(self.origin, 100, "flame");
    doPlayerDamage(self.origin, 100);
    earthQuake(.4, 1, self.origin, 100);
    self remove();
}
ac130_25() {
    self endon("disconnect");
    self endon("death");
    bul = spawnSM(self.origin, "projectile_usa_m9a1_riflegrenade", vectorToAngles(self.origin - self lookPos()));
    bul moveTo(self lookPos(), .2);
    bul thread ac130_25impact();
}
ac130_25impact() {
    self waittill("movedone");
    playSoundAtPosition("weap_ptrs_fire_dist", self.origin);
    playFx(loadFx("env/electrical/fx_elec_short_oneshot"), self.origin);
    killZombiesWithinDistance(self.origin, 50);
    doPlayerDamage(self.origin, 50);
    earthQuake(.2, 1, self.origin, 100);
    self remove();
}
attackHelicopter() {
    if (!isDefined(self.Attack_Helicopter_Real)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.Attack_Helicopter_Real = true;
        self thread attackHelicopter_Real();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.Attack_Helicopter_Real = undefined;
        for (a = 0; a < self.apache_Heli.size; a++) self.apache_Heli[a] remove();
    }
}
attackHelicopter_Real() {
    self.apache_Heli = spawnHelicopter(self.origin + (0, 0, 1000));
    self.chopper_Heli = self.apache_Heli[0];
    self.overwatch_Heli = undefined;
    for (t = 0; t < 10; t++) {
        while (1) {
            zombz = getAiSpeciesArray("axis", "all");
            if (!isDefined(zombz[0])) wait .05;
            randy = randomInt(zombz.size);
            self.overwatch_Heli = zombz[randy];
            if (isDefined(zombz[randy])) break;
            wait .05;
        }
        dest = getAboveBuildingsLocation(self.overwatch_Heli.origin + (0, 0, 1000));
        self.chopper_Heli moveTo(dest, 3, 1, 1);
        self.chopper_Heli rotateTo((self.chopper_Heli.angles[0], vectorToAngles(self.chopper_Heli.origin - dest)[1] - 180, self.chopper_Heli.angles[2]), 3, 1, 1);
        wait 3;
        for (e = 0; e < 30; e++) {
            target = getClosest(self.chopper_Heli.origin, getAiSpeciesArray("axis", "all"));
            magicBullet("zombie_bar_upgraded", self.chopper_Heli getTagOrigin("tag_flash"), target.origin);
            wait .1;
        }
        wait 4;
        for (e = 0; e < 30; e++) {
            target = getClosest(self.chopper_Heli.origin, getAiSpeciesArray("axis", "all"));
            magicBullet("zombie_bar_upgraded", self.chopper_Heli getTagOrigin("tag_flash"), target.origin);
            wait .1;
        }
    }
    if (isSurv()) {
        for (a = 0; a < self.apache_Heli.size; a++) self.apache_Heli[a] remove();
    }
}
attackUfo() {
    if (!isDefined(self.Attack_UFO)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.Attack_UFO = true;
        self thread attackUfo_True();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.Attack_UFO = undefined;
        playFx(loadFx("maps/zombie/fx_transporter_beam"), self.Attacking_ufo[0].origin);
        for (a = 0; a < self.Attacking_ufo.size; a++) self.Attacking_ufo[a] remove();
    }
}
attackUfo_True() {
    self.Attacking_ufo = [];
    self.Attacking_ufo[0] = spawnSM(self.origin + (0, 0, 750), "zombie_teleporter_pad");
    self.Attacking_ufo[1] = spawnSM(self.origin + (0, 0, 750), "zombie_teleporter_pad", (180, 0, 0));
    self.Attacking_ufo[2] = spawnSM(self.origin + (0, 0, 750), "tag_origin", (-270, 0, 0));
    self.Attacking_ufo[2] linkTo(self.Attacking_ufo[1]);
    self.Attacking_ufo[1] linkTo(self.Attacking_ufo[0]);
    playFxOnTag(loadFx("maps/zombie/fx_zombie_factory_marker"), self.Attacking_ufo[2], "tag_origin");
    playFxOnTag(level._effect["mp_light_lamp"], self.Attacking_ufo[2], "tag_origin");
    self.Attacking_ufo[0] thread ufoThink();
    self.Attacking_ufo[0] thread ufoMoveTo();
    self.Attacking_ufo[0] thread rotateEntYaw(360, .5);
    if (isSurv()) {
        wait 45;
        playFx(loadFx("maps/zombie/fx_transporter_beam"), self.Attacking_ufo[0].origin);
        for (a = 0; a < self.Attacking_ufo.size; a++) self.Attacking_ufo[a] remove();
    }
}
ufoMoveTo() {
    while (isDefined(self)) {
        zom = getAiSpeciesArray("axis", "all");
        self moveTo(zom[randomInt(zom.size)].origin + (0, 0, 1000), 50);
        wait 3;
    }
}
ufoThink() {
    while (isDefined(self)) {
        zom = getClosest(self.origin, getAiSpeciesArray("axis", "all"));
        if (isDefined(zom) && zom damageConeTrace(self.origin, self) > .75) {
            self thread ufoFire(zom.origin);
            wait 2;
        }
        wait .05;
    }
}
ufoFire(target) {
    orb = spawnSM(self.origin, "tag_origin");
    playFxOnTag(loadFx("misc/fx_zombie_powerup_on"), orb, "tag_origin");
    playSoundAtPosition("weap_rgun_fire", self.origin);
    orb moveTo(target, .4);
    wait .4;
    playSoundAtPosition("grenade_explode", target);
    killZombiesWithinDistance(target, 400, "flame");
    doPlayerDamage(target, 200);
    earthquake(.4, 1, target, 400);
    playFx(loadFx("explosions/fx_mortarExp_dirt"), target);
    orb remove();
}
UFOToggle() {
    if (!isDefined(self.ufoToggle)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.ufoToggle = true;
        self thread ufo();
    } else {
        if (!isDefined(self.ufoMade)) return;
        self.ufoMade = undefined;
        self setOptionColor(self.menu["Menu_Color"]);
        self.ufoToggle = undefined;
        self notify("ufoDelete");
    }
}
ufo() {
    ufo = [];
    ufo[ufo.size] = spawnSM((-960, 1365.8, 682), "zombie_teleporter_pad");
    ufo[ufo.size] = spawnSM((-960, 1365.8, 682), "zombie_teleporter_pad", (-180, 0, 0));
    ufo[ufo.size] = spawnSM((-960, 1365.8, 682), "tag_origin", (-270, 0, 0));
    ufo[2] linkTo(ufo[1]);
    ufo[0] moveTo(self.origin + (0, 0, 750), .3);
    ufo[1] moveTo(self.origin + (0, 0, 750), .3);
    for (a = 0; a < 4; a++) {
        playFxOnTag(loadFx("maps/zombie/fx_zombie_factory_marker"), ufo[2], "tag_origin");
        playFxOnTag(level._effect["mp_light_lamp"], ufo[2], "tag_origin");
    }
    wait .5;
    for (a = 0; a < 2; a++) {
        ufo[a] thread ufoThink();
        ufo[a] thread rotateEntYaw(360, .5);
    }
    self thread ufoMove(ufo);
    self.ufoMade = true;
    self waittill("ufoDelete");
    for (a = 0; a < ufo.size; a++) ufo[a] remove();
}
ufoMove(ufo) {
    while (isDefined(self.ufoToggle)) {
        zom = get_closest_ai(self.origin, "axis");
        ufo[0] moveTo(zom.origin + (0, 0, 750), 50);
        ufo[1] moveTo(zom.origin + (0, 0, 750), 50);
        wait .05;
    }
}
petPave() {
    if (!isDefined(self.petPave)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.petPave = true;
        self thread createPetPave();
    } else {
        if (!isDefined(self.paveMade)) return;
        self.paveMade = undefined;
        self setOptionColor(self.menu["Menu_Color"]);
        self.petPave = undefined;
        self notify("PET_PAVE_OVER");
    }
}
createPetPave() {
    pet = [];
    blade = [];
    pet[0] = spawnSM(self.origin + (0, 0, 200), "tag_origin");
    pet[1] = spawnSM(self.origin + (90, 0, 250), "tag_origin");
    pet[2] = spawnSM(pet[0].origin, "defaultvehicle", self.angles);
    pet[2] linkTo(pet[0]);
    pet[0] thread ufoThink();
    pet[0] thread petFollow(self, 200);
    for (a = 0; a < 5; a++) {
        blade[a] = spawnSM(self.origin + (0, 0, 250), "zombie_teleporter_powerline", (90, 0, -180 + a * 90));
        blade[a] thread rotateEntYaw(360, .5);
        blade[a] thread petFollow(self, 250);
    }
    self.paveMade = true;
    self waittill("PET_PAVE_OVER");
    array_thread(pet, ::remove);
    array_thread(blade, ::remove);
}
petFollow(player, z) {
    while (isDefined(player.petPave)) {
        self moveto(player.origin + (0, 0, z), .5);
        wait .05;
    }
}
carePackage() {
    self giveWeapon("stielhandgranate", 4);
    self thread lockMenu("ALL");
    self iPrintlnBold("Press [{+frag}] To Call Care Package at Grenade");
    self waittill("grenade_fire", nade);
    nade resetMissileDetonationTime();
    while (1) {
        origin = nade.origin;
        wait .05;
        if (nade.origin == origin) break;
    }
    nadeOrigin = nade.origin;
    nade detonate();
    package = [];
    angle = vectorToAngles((-575, 1517, 710) - nadeOrigin);
    package[0] = spawnSM((-575, 1517, 710), "defaultvehicle", (0, angle[1] + 180, 0));
    for (a = 0; a < 5; a++) package[package.size] = spawnSM(package[0].origin + (-17, -3, 60), "zombie_teleporter_powerline", (90, 0, -180 + a * 90));
    for (a = 1; a < package.size - 1; a++) package[a] linkTo(package[5]);
    package[5] thread rotateEntYaw(360, .5);
    package[0] moveTo((nadeOrigin[0], nadeOrigin[1], package[0].origin[2]), 7, 0, 1.5);
    package[5] moveTo((nadeOrigin[0], nadeOrigin[1], package[1].origin[2]), 7, 0, 1.5);
    package[5] waittill("movedone");
    model = "static_peleliu_filecabinet_metal";
    if (getMap() == "nzs") model = "test_sphere_silver";
    package[6] = spawnSM(package[5].origin, model, package[0].angles + (0, 90, 90));
    package[7] = spawnSM(package[5].origin + anglesToForward(package[6].angles) * -17, model, package[6].angles);
    package[8] = spawnSM(package[5].origin + anglesToUp(package[6].angles) * 25, "tag_origin");
    for (a = 6; a < 8; a++) package[a] linkTo(package[8]);
    package[8] moveTo(nadeOrigin + (0, 0, 13), 2.2, 1.5);
    package[8] waittill("movedone");
    self unlockMenu();
    wait 1;
    angle = vectorToAngles((package[0].origin) - (-1971, -1954, 730));
    package[0] rotateTo(angle + (0, 180, 0), 2, .5, .5);
    package[0] moveTo((-1971, -1954, 730), 7, 1.5);
    package[5] moveTo((-1971, -1954, 730), 7, 1.5);
    for (a = 0; a < 6; a++) package[a] thread deleteOverTime();
    trig = spawnTrigger(nadeOrigin + (0, 0, 20), 70);
    trig setString("Press [{+activate}] To Take Care Package [^2Power-Up^7]");
    while (1) {
        trig waittill("trigger", i);
        if (i useButtonPressed() && isPlayer(i)) {
            i freezeControls(true);
            i thread createProgressBar(1.4, "Capturing!", .75, "Captured!");
            wait 1.5;
            i freezeControls(false);
            for (a = 6; a < 9; a++) package[a] remove();
            trig remove();
            playFx(level._effect["body_remove"], nadeOrigin);
            playFx(loadFx("env/electrical/fx_elec_short_oneshot"), nadeOrigin);
            playFx(loadFx("explosions/default_explosion"), nadeOrigin);
            level.zombie_powerup_index = randomInt(4);
            level.zombie_vars["zombie_drop_item"] = 1;
            level.powerup_drop_count = 0;
            level thread powerup_drop(nadeOrigin);
            break;
        }
    }
}
deleteOverTime(time) {
    wait time;
    self remove();
}
sentryGun() {
    if (!isDefined(self.sentryGun)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.sentryGun = true;
        self thread spawnSentryGun("viewmodel_zombie_mg42_mg", (0, 0, 40));
    } else {
        if (!isDefined(self.sentryMade)) return;
        self.sentryMade = undefined;
        self setOptionColor(self.menu["Menu_Color"]);
        self.sentryGun = undefined;
        self notify("SENTRY_GUN_OVER");
    }
}
spawnSentryGun(arg, rise) {
    turret = spawnSM(self.origin + rise + (0, 50, 0), arg);
    stand = spawnSM(self.origin + (0, 50, 0), "static_berlin_metal_desk");
    stand.team = "allies";
    turret.team = "allies";
    level.zombie = getClosest(self getOrigin(), getAiSpeciesArray("axis", "all"));
    self thread sentryBarrier(turret);
    self.sentryMade = true;
    while (isDefined(self.sentryGun)) {
        enemy = getAiSpeciesArray("axis", "all");
        for (a = 0; a < enemy.size; a++) {
            if (distance(enemy[a].origin, stand.origin) <= 500) {
                turret thread sentryLook();
                turret thread sentryFire();
            } else turret thread sentryLook();
        }
        wait .05;
    }
    turret remove();
    stand remove();
}
sentryBarrier(turret) {
    self endon("SENTRY_GUN_OVER");
    while (1) {
        enemy = getAiSpeciesArray("axis", "all");
        for (a = 0; a < enemy.size; a++)
            if (distance(enemy[a].origin, turret.origin) < 100) enemy[a] doDamage(enemy[a].health + 666, enemy[a].origin);
        wait .1;
    }
}
sentryFire() {
    if (getMap() == "nzf" || getMap() == "nzs") self thread sentryShoot("zombie_mg42", self);
    else self thread sentryShoot("mg42_bipod", self);
}
sentryShoot(gun) {
    enemy = getAiSpeciesArray("axis", "all");
    for (a = 0; a < enemy.size; a++) {
        level.zombie = get_closest_ai(self.origin, "axis", "all");
        wait 1;
        magicBullet(gun, self getTagOrigin("tag_flash"), level.zombie.origin + (0, 0, 30), self);
    }
}
sentryLook() {
    self rotateTo(VectorToAngles(level.zombie.origin - self.origin), .5);
}
wunderWalther() {
    if (!isDefined(self.wunderWalther)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.wunderWalther = true;
        self thread doWunderWalther();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.wunderWalther = undefined;
        self notify("wunderWalther_over");
    }
}
doWunderWalther() {
    self endon("death");
    self endon("disconnect");
    self endon("wunderWalther_over");
    self giveWeapon("walther");
    self switchToWeapon("walther");
    while (1) {
        self waittill("weapon_fired");
        if (self getCurrentWeapon() == "walther") {
            trace = bulletTrace(self getTagOrigin("j_head"), self getTagOrigin("j_head") + anglesToForward(self getPlayerAngles()) * 100000000, true, self);
            tesla = spawnSM(self getTagOrigin("tag_inhand"), "tag_origin");
            playFxOnTag(level._effect["tesla_bolt"], tesla, "tag_origin");
            tesla moveTo(trace["position"], .135);
            ent = trace["entity"];
            if (ent.damageyaw > 135 || ent.damageyaw <= -135) ent.deathanim = % death_explosion_run_B_v2;
            else if (ent.damageyaw > 45 && ent.damageyaw <= 135) ent.deathanim = % death_explosion_run_L_v2;
            else if (ent.damageyaw > -45 || ent.damageyaw <= 45) ent.deathanim = % death_explosion_run_F_v2;
            else if (ent.damageyaw > -45 && ent.damageyaw <= -135) ent.deathanim = % death_explosion_run_R_v2;
            ent animMode("nogravity");
            if (ent.is_zombie) ent doDamage(ent.health + 666, self.origin, undefined, undefined, "pistolbullet");
            wait .135;
            tesla remove();
        }
    }
}
thunderColt() {
    if (!isDefined(self.thunderColt)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.thunderColt = true;
        self thread doThunderColt("colt", "zombie_colt");
        self giveWeapon("colt");
        self switchToWeapon("colt");
        self giveMaxAmmo("colt");
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.thunderColt = undefined;
        self notify("thunderColt_over");
    }
}
doThunderColt(one, two) {
    self endon("death");
    self endon("disconnect");
    self endon("thunderColt_over");
    rangeSquared = 300 * 300;
    while (1) {
        self waittill("weapon_fired");
        pos = self lookPos();
        if (self getCurrentWeapon() == one || self getCurrentWeapon() == two) {
            zom = getAiSpeciesArray("axis", "all");
            for (e = 0; e < zom.size; e++) {
                zomi = zom[e];
                if (!isDefined(zomi) || !isAlive(zomi)) continue;
                testOrigin = zomi.origin + (0, 0, 40);
                testOriginSquared = distanceSquared(pos, testOrigin);
                if (testOriginSquared > rangeSquared) continue;
                distMult = (rangeSquared - testOriginSquared) / rangeSquared;
                flingVec = vectorNormalize(testOrigin - pos);
                flingVec = (flingVec[0], flingVec[1], abs(flingVec[2]));
                flingVec = vectorScale(flingVec, 100 + 100 * distMult);
                zomi flingZombie(self, flingVec);
            }
        }
    }
}
deathSkull() {
    self endon("disconnect");
    self endon("death");
    DS = [];
    DS[DS.size] = spawnSM(self.origin + (0, 0, 40), "zombie_skull");
    DS[DS.size] = spawnSM(DS[0].origin, "tag_origin", (-90, 0, 0));
    playFxOnTag(loadFx("maps/mp_maps/fx_mp_fire_rubble_small"), DS[DS.size - 1], "tag_origin");
    DS[DS.size] = spawnSM(DS[0].origin, "tag_origin", (-90, 0, 0));
    playFxOnTag(loadFx("maps/zombie/fx_zombie_wire_spark"), DS[DS.size - 1], "tag_origin");
    DS[DS.size] = spawnSM(DS[0].origin, "tag_origin", (-90, 0, 0));
    playFxOnTag(loadFx("misc/fx_zombie_electric_trap"), DS[DS.size - 1], "tag_origin");
    playFxOnTag(loadFx("misc/fx_zombie_powerup_on"), DS[0], "tag_origin");
    array_thread(DS, ::deathSkullArray);
    level endon("DEATH_SKULL_DELETE");
    while (1) {
        playFx(loadFx("misc/fx_zombie_mini_nuke"), DS[0].origin - (0, 0, 40));
        wait .1;
        playFx(loadFx("weapon/bouncing_betty/fx_explosion_betty_generic"), DS[0].origin - (0, 0, 40));
        wait .1;
        DS[0] moveTo(DS[0].origin + (0, 0, 40), 1);
        DS[0] rotateYaw(2880, 2);
        if (distance(self.origin, DS[0].origin) < 155) {
            earthquake(1, .4, self.origin, 512);
            self playSound("nuke_flash");
            self playSound("tesla_happy");
        }
        wait 2;
        DS[0] moveTo(DS[0].origin - (0, 0, 40), .1);
        enemy = getAiSpeciesArray("axis", "all");
        killZombiesWithinDistance(DS[0].origin, 250, "headGib");
    }
}
deathSkull2() {
    self endon("disconnect");
    self endon("death");
    pos = self getOrigin();
    skull = spawnMultipleModels(pos - (20, 20, -40), 2, 2, 1, 40, 40, 0, "zombie_skull");
    link = spawnSM(pos, "tag_origin");
    link thread deathSkullArray();
    link playLocalSound("meteor_loop");
    for (a = 0; a < skull.size; a++) {
        skull[a] thread deathSkullArray();
        skull[a].angles = vectorToAngles(skull[a] getOrigin() - (pos + (0, 0, 40))) + (0, 90, 0);
        playFxOnTag(level._effect["tesla_bolt"], skull[a], "tag_origin");
        playFxOnTag(level._effect["powerup_on"], skull[a], "tag_origin");
        skull[a] linkTo(link);
    }
    fx = spawnSM(pos, "tag_origin", (-90, 0, 0));
    fxTag = strTok("maps/mp_maps/fx_mp_fire_rubble_small maps/zombie/fx_zombie_wire_spark misc/fx_zombie_electric_trap", " ");
    for (a = 0; a < fxTag.size; a++) playFxOnTag(loadFx(fxTag[a]), fx, "tag_origin");
    fx thread deathSkullArray();
    level endon("DEATH_SKULL_DELETE");
    while (1) {
        link moveZ(40, 3, 2);
        if (randomInt(100) < 50) link rotateYaw(2880, 3, 2);
        else link rotateYaw(-2880, 3, 2);
        wait 2;
        for (a = 20; a < 40; a++) {
            if (a % 2)
                for (e = 0; e < skull.size; e++) skull[e] hide();
            else
                for (e = 0; e < skull.size; e++) skull[e] show();
            if (a < 15) wait .5;
            else if (a < 25) wait .25;
            else wait .1;
        }
        for (e = 0; e < skull.size; e++) skull[e] show();
        link moveZ(-40, .1);
        wait .1;
        earthquake(3, .4, link getOrigin(), 250);
        for (a = 0; a < getPlayers().size; a++)
            if (distance(getPlayers()[a] getOrigin(), link getOrigin()) < 250) {
                getPlayers()[a] playLocalSound("nuke_flash");
                getPlayers()[a] playLocalSound("tesla_happy");
                getPlayers()[a] playLocalSound("grenade_explode");
            }
        killZombiesWithinDistance(link getOrigin(), 250, "flame");
        playFx(loadFx("misc/fx_zombie_mini_nuke"), link getOrigin());
        playFx(loadFx("weapon/bouncing_betty/fx_explosion_betty_generic"), link getOrigin());
        wait .6;
    }
}
deathSkullArray() {
    if (!isDefined(level.Deathingarray)) level.Deathingarray = [];
    a = level.Deathingarray.size;
    level.Deathingarray[a] = self;
}
deleteAllDeathSkulls() {
    if (!isDefined(level.Deathingarray)) return;
    level notify("DEATH_SKULL_DELETE");
    for (a = 0; a < level.Deathingarray.size; a++) level.Deathingarray[a] remove();
    level.Deathingarray = undefined;
}
ricochetBullets() {
    if (!isDefined(self.ricochetBullets)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.ricochetBullets = true;
        self thread _ricochetBullets();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.ricochetBullets = undefined;
        self notify("ricochetBullets_over");
    }
}
_ricochetBullets() {
    self endon("disconnect");
    self endon("death");
    self endon("ricochetBullets_over");
    while (1) {
        self waittill("weapon_fired");
        gun = self getCurrentWeapon();
        incident = anglesToForward(self getPlayerAngles());
        trace = bulletTrace(self getEye(), self getEye() + incident * 100000, false, self);
        reflection = incident - (2 * trace["normal"] * vectorDot(incident, trace["normal"]));
        magicBullet(gun, trace["position"], trace["position"] + (reflection * 100000), self);
        trace = bulletTrace(trace["position"], trace["position"] + (reflection * 100000), false, self);
        incident = reflection;
        reflection = incident - (2 * trace["normal"] * vectorDot(incident, trace["normal"]));
        magicBullet(gun, trace["position"], trace["position"] + (reflection * 100000), self);
    }
}
xPlosiveBullets() {
    if (!isDefined(self.xPlosiveBullets)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.xPlosiveBullets = true;
        self thread doXplosiveBullets();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.xPlosiveBullets = undefined;
        self notify("xPlosiveBullets_over");
    }
}
doXplosiveBullets() {
    self endon("disconnect");
    self endon("death");
    self endon("xPlosiveBullets_over");
    while (1) {
        self waittill("weapon_fired");
        loc = self lookPos();
        for (a = 0; a < 5; a++) playFx(loadFx("env/electrical/fx_elec_short_oneshot"), (loc[0] + randomIntRange(-15, 15), loc[1] + randomIntRange(-15, 15), loc[2]));
    }
}
rpgMode() {
    if (!isDefined(self.rpgMode)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.rpgMode = true;
        self thread doRpgMode();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.rpgMode = undefined;
        self notify("rpgMode_over");
    }
}
doRpgMode(rpg) {
    self endon("death");
    self endon("disconnect");
    self endon("rpgMode_over");
    if (getMap() == "nzp" || getMap() == "nza") rpg = "panzerschrek";
    if (getMap() == "nzs" || getMap() == "nzf") rpg = "panzerschrek_zombie";
    while (1) {
        self waittill("weapon_fired");
        magicBullet(rpg, self getTagOrigin("tag_weapon_left"), self lookPos(), self);
    }
}
dropWeaponsAtChs() {
    if (isDefined(self.Drop_Weaps_Cross)) self iprintln("Weapons Already Dropped!");
    pointer = self getPointer();
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "ADVANCED", pointer);
    if (!isDefined(self.Drop_Weaps_Cross)) {
        self.Drop_Weaps_Cross = true;
        keys = getArrayKeys(level.zombie_weapons);
        for (a = 0; a < keys.size; a++) {
            model = spawn("weapon_" + keys[a], self lookPos() + (randomIntRange(-40, 40), randomIntRange(-60, 60), 60), 4);
            level.entityCount++;
            model giveMaxAmmo();
            model giveMaxAmmo();
            model thread deleteAfter30();
            self thread resetAfter31(pointer);
        }
    }
}
deleteAfter30() {
    wait 30;
    self remove();
}
resetAfter31(pointer) {
    wait 31;
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "ADVANCED", pointer);
    self.Drop_Weaps_Cross = undefined;
}
doTracers() {
    if (!isDefined(self.bulletTracers)) {
        self setOptionColor(self.menu["Select_Color"]);
        self setOptionColor(self.menu["Menu_Color"], "ADVANCED", self getPointer() + 1);
        self.bulletTracers = true;
        self.bulletTracers2 = undefined;
        self thread doBulletTracersx();
        self notify("bulletTracers_over");
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.bulletTracers = undefined;
        self notify("Tracers_over");
    }
}
doBulletTracersx() {
    self endon("disconnect");
    self endon("death");
    self endon("Tracers_over");
    setLobbyDvar("cg_tracerSpeed", 100);
    setLobbyDvar("cg_tracerScrewRadius", 0);
    setLobbyDvar("cg_tracerLength", 999);
    setLobbyDvar("cg_tracerWidth", 9);
    while (1) {
        self waittill("weapon_fired");
        bulletTracer(self getTagOrigin("tag_inhand"), self lookPos(), true);
    }
}
bulletTracers() {
    if (!isDefined(self.bulletTracers2)) {
        self setOptionColor(self.menu["Select_Color"]);
        self setOptionColor(self.menu["Menu_Color"], "ADVANCED", self getPointer() - 1);
        self.bulletTracers2 = true;
        self.bulletTracers = undefined;
        self thread doBulletTracers();
        self notify("Tracers_over");
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.bulletTracers2 = undefined;
        self notify("bulletTracers_over");
    }
}
doBulletTracers() {
    self endon("disconnect");
    self endon("death");
    self endon("bulletTracers_over");
    setLobbyDvar("cg_tracerSpeed", 300);
    setLobbyDvar("cg_tracerScrewRadius", 10);
    setLobbyDvar("cg_tracerLength", 10000000);
    setLobbyDvar("cg_tracerWidth", 10);
    while (1) {
        self waittill("weapon_fired");
        bulletTracer(self getTagOrigin("tag_inhand"), self lookPos(), true);
    }
}
rayNPop() {
    if (!isDefined(self.rayPop)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.rayPop = true;
        self thread doRayNPop();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.rayPop = undefined;
    }
}
doRayNPop() {
    self endon("disconnect");
    self endon("death");
    skull = spawnSM(self.origin + (0, 0, 95), "zombie_skull", self.angles + (0, 90, 0));
    playFxOnTag(loadFx("maps/zombie/fx_zombie_wire_spark"), skull, "tag_origin");
    playFxOnTag(loadFx("misc/fx_zombie_powerup_on"), skull, "tag_origin");
    skull thread skullFollowPlayer(self);
    while (1) {
        enemy = getClosest(skull.origin, getAiSpeciesArray("axis", "all"));
        if (isDefined(enemy) && enemy damageConeTrace(skull.origin, skull) > .75 && distance(enemy.origin, self.origin) < 350) {
            fx = spawnSM(skull.origin, "tag_origin");
            fx playSound("weap_rgun_fire");
            playFxOnTag(loadFx("maps/zombie/fx_zombie_wire_spark"), fx, "tag_origin");
            playFxOnTag(loadFx("misc/fx_zombie_powerup_on"), fx, "tag_origin");
            fx moveTo(enemy getTagOrigin("j_head"), .2);
            wait .2;
            enemy zombie_head_gib();
            enemy doDamage(enemy.health + 666, enemy.origin);
            fx remove();
        }
        wait .05;
        if (!isDefined(self.rayPop)) break;
    }
    skull remove();
}
skullFollowPlayer(plr) {
    plr endon("disconnect");
    plr endon("death");
    while (isDefined(plr.rayPop)) {
        self moveTo(plr.origin + (0, 0, 95), .1);
        self rotateTo(plr.angles + (0, 90, 0), .1);
        wait .05;
    }
}
chargedGyrationBarrels() {
    if (!isDefined(self.chargedGyrationBarrels)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.chargedGyrationBarrels = true;
        self thread dochargedGyrationBarrels();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.chargedGyrationBarrels = undefined;
        self notify("chargedGyrationBarrels_over");
    }
}
dochargedGyrationBarrels() {
    self endon("disconnect");
    self endon("death");
    link = spawnSM(self.origin + (0, 0, 30), "tag_origin");
    link thread rotateEntYaw(360, 2);
    barrel[0] = spawnSM(self.origin + (0, 50, 30), "zombie_beaker_brain");
    barrel[1] = spawnSM(self.origin + (0, -50, 30), "zombie_beaker_brain");
    for (a = 0; a < barrel.size; a++) {
        playFxOnTag(loadFx("maps/zombie/fx_zombie_wire_spark"), barrel[a], "tag_origin");
        playFxOnTag(loadFx("maps/mp_maps/fx_mp_light_lamp"), barrel[a], "tag_origin");
        barrel[a] linkTo(link);
    }
    link thread linkFollowPlayer(self);
    while (1) {
        zombz = getAiSpeciesArray("axis", "all");
        for (a = 0; a < zombz.size; a++)
            for (e = 0; e < barrel.size; e++) self thread killZombiesWithinDistance(self.origin, 60, "tesla");
        wait .05;
        if (!isDefined(self.chargedGyrationBarrels)) break;
    }
    link remove();
    for (a = 0; a < barrel.size; a++) barrel[a] remove();
}
linkFollowPlayer(plr) {
    plr endon("disconnect");
    plr endon("death");
    while (isDefined(plr.chargedGyrationBarrels)) {
        self moveTo(plr.origin + (0, 0, 30), .1);
        wait .05;
    }
}
bogsWeapMod() {
    if (!isDefined(self.bogsWeapMods)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.bogsWeapMods = true;
        self.uAmmo = undefined;
        self setClientDvar("player_sustainAmmo", 0);
        if (!isDefined(self.msg)) self thread deathMessage("^2Single Shot Rapid Fire", "Hold [{+activate}] + [{+attack}] To Use Rapid Fire!", 230, 4);
        self thread doBogsWeapMods();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.bogsWeapMods = undefined;
        self notify("Bogs_Mod_Off");
        if (!isDefined(level.PerkMods)) {
            self setLobbyDvar("perk_weapRateMultiplier", "0.75");
            self setLobbyDvar("perk_weapReloadMultiplier", "0.5");
        }
        if (isDefined(level.gameTypeChosen)) self setLobbyDvar("player_sustainAmmo", "1");
        else self setLobbyDvar("player_sustainAmmo", "0");
    }
}
doBogsWeapMods() {
    if (!self hasPerk("specialty_fastreload")) {
        self thread perkHud("specialty_fastreload_zombies", "specialty_fastreload");
        self setPerk("specialty_fastreload");
    }
    if (!self hasPerk("specialty_rof")) {
        self thread perkHud("specialty_doubletap_zombies", "specialty_rof");
        self setPerk("specialty_rof");
    }
    self setLobbyDvar("perk_weapRateMultiplier", "0.01");
    self setLobbyDvar("perk_weapReloadMultiplier", "0.01");
    self setWeaponAmmoStock(self getCurrentWeapon(), 1000);
    self endon("Bogs_Mod_Off");
    while (1) {
        self setLobbyDvar("player_sustainAmmo", "0");
        self giveMaxAmmo(self getCurrentWeapon());
        wait 1.5;
    }
}
laughHolic() {
    if (!isDefined(self.laughHolic)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.laughHolic = true;
        self thread initLaughy();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.laughHolic = undefined;
        self notify("laughy_over");
    }
}
initLaughy() {
    self endon("disconnect");
    self endon("death");
    self endon("laughy_over");
    while (1) {
        for (a = 0; a < 4; a++) {
            self playSound("plr_" + self getEntityNumber() + "_vox_gen_laugh_" + a);
            wait 2;
        }
        wait .05;
    }
}
anoyingGuy() {
    if (!isDefined(self.anoyingGuy)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.anoyingGuy = true;
        self thread doAnoyingGuy();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.anoyingGuy = undefined;
        self notify("anoyingGuy_over");
    }
}
doAnoyingGuy() {
    self endon("disconnect");
    self endon("death");
    self endon("anoyingGuy_over");
    while (1) {
        self playSound("plr_0_vox_ppsh_0");
        wait 3;
        self playSound("plr_3_vox_kill_headdist_5");
        wait 3;
    }
}
anoyingGrunt() {
    if (!isDefined(self.annoyingGrunt)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.annoyingGrunt = true;
        self thread initGrunts();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.annoyingGrunt = undefined;
        self notify("grunt_over");
    }
}
initGrunts() {
    self endon("disconnect");
    self endon("death");
    self endon("grunt_over");
    while (1) {
        for (a = 0; a < 9; a++) {
            self playSound("plr_" + self getEntityNumber() + "_vox_gen_exert_" + a);
            wait 1;
        }
        wait .05;
    }
}
revivePlayers() {
    self iPrintln("All Players Are Revived!");
    for (a = 0; a < getPlayers().size; a++)
        if (isDefined(getPlayers()[a].revivetrigger)) getPlayers()[a] maps\_laststand::revive_force_revive(getPlayers()[a]);
}
saveGame() {
    self setClientDvar("zombiemode", 0);
    self thread createProgressMenu("Saving Current Game Session", "Current Game Session Saved!", 3);
    wait 3;
    self maps\_autosave::autosave_game_now();
}
changeWeather(weather) {
    if (isDefined(level.waitForWeatherChange)) return;
    level.waitForWeatherChange = true;
    level notify("NEW_WEATHER");
    if (!isDefined(level.weatherSet) || level.weatherSet != weather) level.weatherSet = weather;
    else if (isDefined(level.weatherSet) && level.weatherSet == weather) {
        level.weatherSet = undefined;
        level.waitForWeatherChange = undefined;
        return;
    }
    pointer = self getPointer();
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "WEATHER_MENU", pointer);
    array_thread(getPlayers(), ::setWeather, weather);
    wait 1.5;
    level.waitForWeatherChange = undefined;
    level waittill("NEW_WEATHER");
    for (a = 0; a < getPlayers().size; a++)
        for (b = 0; b < 2; b++) getPlayers()[a].personalWhatherTag[b] remove();
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "WEATHER_MENU", pointer);
}
setWeather(weather) {
    level endon("NEW_WEATHER");
    if (isDefined(self.personalWhatherTag)) wait .5;
    self.personalWhatherTag = [];
    for (a = 0; a < 2; a++) self.personalWhatherTag[a] = spawnSM(self.origin, "tag_origin", (-90, 0, 0));
    effect = undefined;
    if (weather == "SNOW") effect = level._effect["grain_test"];
    else if (weather == "ASH") effect = level._effect["mp_ash_and_embers"];
    for (i = 0; i < 100; i++) {
        playFxOnTag(effect, self.personalWhatherTag[0], "tag_origin");
        playFxOnTag(effect, self.personalWhatherTag[1], "tag_origin");
    }
    while (true) {
        for (a = 0; a < 2; a++) self.personalWhatherTag[a] setOrigin(self.origin);
        wait .05;
    }
}
cheatsMenu() {
    self openMenu("menu_special_features");
}
antiLeave() {
    if (!isDefined(self.antiLeave)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.antiLeave = true;
        level thread doAntiLeave();
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.antiLeave = undefined;
        level notify("antiLeave_over");
    }
}
doAntiLeave() {
    level endon("antiLeave_over");
    while (true) {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] closeInGameMenu();
        wait .05;
    }
}
antiCheat() {
    if (!isDefined(self.antiCheat)) {
        self setOptionColor(self.menu["Select_Color"]);
        self.antiCheat = true;
        self setClientDvar("sv_cheats", 0);
    } else {
        self setOptionColor(self.menu["Menu_Color"]);
        self.antiCheat = undefined;
        self setClientDvar("sv_cheats", 1);
    }
}
friendlyFire() {
    if (!isDefined(level.friendlyFires)) {
        level.friendlyFires = true;
        for (a = 0; a < getPlayers().size; a++) {
            if (isDefined(getPlayers()[a].godMode)) getPlayers()[a].turnBackOn = true;
            getPlayers()[a] thread arraySetOptionColor(true, "ADMIN", 6);
            getPlayers()[a] thread doFriendlyFire();
        }
    } else {
        level.friendlyFires = undefined;
        level notify("friendlyFire_over");
        for (a = 0; a < getPlayers().size; a++) {
            getPlayers()[a] thread arraySetOptionColor(undefined, "ADMIN", 6);
            if (isDefined(getPlayers()[a].turnBackOn)) {
                if (!isDefined(getPlayers()[a].godMode)) getPlayers()[a] godMode();
                if (!isDefined(getPlayers()[a].healthShield)) getPlayers()[a] healthShield();
            }
        }
    }
}
doFriendlyFire() {
    self endon("disconnect");
    level endon("friendlyFire_over");
    if (isDefined(self.godMode)) self godMode();
    if (isDefined(self.healthShield)) self healthShield();
    self disableGodMode();
    while (true) {
        while (self isFiring()) {
            trace = bulletTrace(self getTagOrigin("j_head"), self getTagOrigin("j_head") + anglesToForward(self getPlayerAngles()) * 1000000, true, self);
            while (self isFiring()) {
                trace["entity"] doDamage(45, self.origin, undefined, undefined, "riflebullet");
                wait .05;
            }
            wait .05;
        }
        wait .05;
    }
}
deleteATrigger(trigger) {
    array_thread(getPlayers(), ::arraySetOptionColor, true, "DELETEABLES", self getPointer());
    self thread deleteTrigger(trigger);
}
teleDelete() {
    array_thread(getPlayers(), ::arraySetOptionColor, true, "DELETEABLES", self getPointer());
    for (i = 0; i < 3; i++) {
        trig = getEnt("trigger_teleport_pad_" + i, "targetname");
        if (isDefined(trig)) trig remove();
    }
}
roundEdit(text) {
    level notify("RoundHudFixDone");
    if (isDefined(level.chalk_hud2)) level.chalk_hud2 destroy();
    level.chalk_hud1 hudFade(0, .2);
    level.chalk_hud1 setText(text);
    level.chalk_hud1 hudFade(1, .2);
    if (level.round_number < 11 && level.gameTypeSelected == "Mod Menu") self thread roundHudReFix();
}
roundHudReFix() {
    level endon("RoundEditFix");
    while (true) {
        self round_wait();
        self thread fixRounds();
    }
}
fixRounds() {
    level endon("RoundHudFixDone");
    level notify("RoundEditFix");
    level notify("roundEffectsOver");
    self thread watchFixRounds();
    level.chalk_hud1 notify("flashThread Over");
    level.chalk_hud1.alpha = 1;
    level.chalk_hud1.fontscale = 32;
    level.chalk_hud1.sort = -27;
    while (true) {
        if (level.round_number < 11) {
            if (isDefined(level.chalk_hud2)) level.chalk_hud2 destroy();
            level.chalk_hud1 setText(level.round_number);
            if (level.round_number > 10) level notify("RoundHudFixDone");
        } else break;
        wait .5;
    }
}
watchFixRounds() {
    level endon("RoundHudFixDone");
    while (true) {
        self round_wait();
        level.roundPulse = undefined;
        level.roundBeat = undefined;
        wait .05;
    }
}
setRoundColor(color) {
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a].coloredMenu["UI_Round_RAINBOW"] = undefined;
    self.menu["Round_Color"] = color;
    level.chalk_hud1 fadeOverTime(.4);
    level.chalk_hud1.color = color;
}
roundPulse() {
    if (isDefined(level.roundPulse)) return;
    level.roundPulse = true;
    level.chalk_hud1 thread flashThread();
}
roundHeartbeat() {
    if (isDefined(level.roundBeat)) return;
    level.roundBeat = true;
    level endon("roundEffectsOver");
    while (isDefined(level.chalk_hud1)) {
        level.chalk_hud1.fontscale = level.chalk_hud1.fontscale / 2;
        wait .2;
        level.chalk_hud1.fontscale = level.chalk_hud1.fontscale * 2;
        wait .2;
    }
}
roundEffectEnd() {
    level notify("roundBow");
    level.roundBow = undefined;
    level notify("roundEffectsOver");
    level.roundPulse = undefined;
    level.roundBeat = undefined;
    level.chalk_hud1 notify("flashThread Over");
    level.chalk_hud1.alpha = 1;
    level.chalk_hud1.fontscale = 32;
    level.chalk_hud1.color = (0.423, 0.004, 0);
    if (level.round_number < 11 && level.gameTypeSelected == "Mod Menu") self thread fixRounds();
    else if (level.gameTypeSelected != "Mod Menu") self thread chalk_one_up();
}
drawSelector() {
    button = strTok("leftarrow rightarrow downarrow uparrow space backspace enter # v c", " ");
    if (isConsole()) button = strTok("DPAD_LEFT DPAD_RIGHT BUTTON_LSHLDR BUTTON_RSHLDR BUTTON_A BUTTON_LTRIG BUTTON_X BUTTON_RTRIG BUTTON_RSTICK BUTTON_LSTICK", " ");
    self thread lockMenu("ALL");
    self freezeControls(true);
    self setClientDvar("cg_drawCrosshair", 0);
    self deleteInstructions();
    menu = [];
    menu["bg"] = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", 1, .8);
    menu["row"] = self createText(getFont(), 1.2, "CENTER", "CENTER", 0, -140, 3, 1, "^2'^7a^2' ^7b c d e f g h i j k l m n o p q r s t u v w x y z _ [ ]{}( ) * ^ $ ! ? ' : ;. , + - / 0 1 2 3 4 5 6 7 8 9");
    menu["rowBg"] = self createRectangle("CENTER", "CENTER", 0, -140, 1000, 50, (1, 0.7372549019607844, 0.12941176470588237), "line_horizontal", 2, 1);
    menu["cmd"] = self createText(getFont(), 1.2, "CENTER", "CENTER", 0, -177.5, 3, 1, "Enter a DVAR, MSG or COMMAND...");
    menu["cmdBg"] = self createRectangle("CENTER", "CENTER", 0, -177.5, 1000, 25, (1, 0.7372549019607844, 0.12941176470588237), "white", 2, .8);
    menu["instruct"] = [];
    menu["instructBg"] = self createRectangle("LEFT", "LEFT", 0, 0, 160, 130, (1, 0.7372549019607844, 0.12941176470588237), "white", 2, .8);
    menu["instruct"][0] = self createText(getFont(), 1, "LEFT", "LEFT", 5, -56, 3, 1, "[{+actionslot 3}]/[{+actionslot 4}]: Scroll Left/Right By 1");
    menu["instruct"][1] = self createText(getFont(), 1, "LEFT", "LEFT", 5, -40, 3, 1, "[{+smoke}]/[{+frag}]: Scroll Left/Right By 5");
    menu["instruct"][2] = self createText(getFont(), 1, "LEFT", "LEFT", 5, -24, 3, 1, "[{+gostand}]: Enter Letter");
    menu["instruct"][3] = self createText(getFont(), 1, "LEFT", "LEFT", 5, 8, 3, 1, "[{+activate}]: Submit To Console");
    menu["instruct"][4] = self createText(getFont(), 1, "LEFT", "LEFT", 5, 24, 3, 1, "[{+attack}]: Add Space");
    menu["instruct"][5] = self createText(getFont(), 1, "LEFT", "LEFT", 5, -8, 3, 1, "[{+speed_throw}]: Backspace");
    menu["instruct"][6] = self createText(getFont(), 1, "LEFT", "LEFT", 5, 40, 3, 1, "[{+breath_sprint}]: Toggle Case");
    menu["instruct"][7] = self createText(getFont(), 1, "LEFT", "LEFT", 5, 56, 3, 1, "[{+melee}]: Close Console");
    abc = "abcdefghijklmnopqrstuvwxyz_[]{}()*^$!?':;.,+-/0123456789";
    curs = 0;
    cmd = "";
    while (true) {
        wait .05;
        if (self buttonPressed(button[0]) || self buttonPressed(button[1]) || self buttonPressed(button[2]) || self buttonPressed(button[3])) {
            curs -= self buttonPressed(button[0]);
            curs -= self buttonPressed(button[2]) * 5;
            curs += self buttonPressed(button[1]);
            curs += self buttonPressed(button[3]) * 5;
            if (curs < 0 && self buttonPressed(button[0])) curs = abc.size - 1;
            if (curs < 0 && self buttonPressed(button[2])) curs = (abc.size - 1) - (curs * -1) + 1;
            if (curs > abc.size - 1 && self buttonPressed(button[1])) curs = 0;
            if (curs > abc.size - 1 && self buttonPressed(button[3])) curs = (curs - (abc.size - 1)) - 1;
            row = "";
            for (m = 0; m < abc.size; m++) {
                if (m == curs) row += " ^2'^7";
                row += abc[m];
                if (m == curs) row += "^2'^7 ";
                if (m != abc.size - 1) row += " ";
            }
            menu["row"] setText(row);
            wait .1;
        }
        if (self buttonPressed(button[4]) || self buttonPressed(button[7])) {
            if (self buttonPressed(button[4])) cmd += abc[curs];
            if (self buttonPressed(button[7])) cmd += " ";
            menu["cmd"] setText(cmd);
            self setClientDvar("con_select", cmd);
            while (self buttonPressed(button[4]) || self buttonPressed(button[7])) wait .05;
        }
        if (self buttonPressed(button[5])) {
            if (cmd.size == 0) continue;
            string = "";
            for (m = 0; m < cmd.size - 1; m++) string += cmd[m];
            cmd = string;
            menu["cmd"] setText(cmd);
            if (cmd.size == 0) menu["cmd"] setText("Enter a DVAR, MSG or COMMAND...");
            self setClientDvar("con_select", cmd);
            while (self buttonPressed(button[5])) wait .05;
        }
        if (self buttonPressed(button[6])) {
            if (cmd != "" && cmd[0] == "s" && cmd[1] == "a" && cmd[2] == "y" && cmd[3] == " ") {
                string = "";
                for (m = 4; m < cmd.size; m++) string += cmd[m];
                cmd = string;
                array_thread(getPlayers(), ::notifyMsg, "rank_prestige10", "^6Console - ^2Created By: ^1AgreedBog381", cmd, cmd);
            }
            cmd = "";
            curs = 0;
            menu["cmd"] setText("Enter a DVAR, MSG or COMMAND...");
            menu["row"] setText("^2'^7a^2' ^7b c d e f g h i j k l m n o p q r s t u v w x y z _ [ ]{}( ) * ^ $ ! ? ' : ;. , + - / 0 1 2 3 4 5 6 7 8 9");
            abc = "abcdefghijklmnopqrstuvwxyz_[]{}()*^$!':;.,+-/0123456789";
            self setClientDvar("con_select", "");
            while (self buttonPressed(button[5])) wait .05;
        }
        if (self buttonPressed(button[9])) {
            if (abc[0] == "a") abc = "ABCDEFGHIJKLMNOPQRSTUVWXYZ_[]{}()*^$!?':;.,+-/0123456789";
            else abc = "abcdefghijklmnopqrstuvwxyz_[]{}()*^$!?':;.,+-/0123456789";
            row = "";
            for (m = 0; m < abc.size; m++) {
                if (m == curs) row += " ^2'^7";
                row += abc[m];
                if (m == curs) row += "^2'^7 ";
                if (m != abc.size - 1) row += " ";
            }
            menu["row"] setText(row);
            while (self buttonPressed(button[9])) wait .05;
        }
        if (self meleeButtonPressed()) break;
        killZombiesWithinDistance(self getOrigin(), 100, "delete");
    }
    self setClientDvar("con_select", "");
    self setClientDvar("cg_drawCrosshair", 1);
    self destroyAll(menu);
    self unlockMenu();
    self thread remakeInstructions(1);
    self freezeControls(false);
}
teleAllPlayers() {
    if (!isDefined(self.teleAll)) {
        self setOptionColor(self.menu["Select_Color"], "ADMIN", self getPointer());
        self.teleAll = true;
        self thread doTeleAll();
    } else {
        self setOptionColor(self.menu["Menu_Color"], "ADMIN", self getPointer());
        self.teleAll = undefined;
        self notify("teleAll_over");
    }
}
doTeleAll() {
    self endon("death");
    self endon("disconnect");
    self endon("teleAll_over");
    while (true) {
        self waittill("weapon_fired");
        self playLocalSound("tesla_happy");
        for (a = 0; a < getPlayers().size; a++) {
            if (getPlayers()[a] == self || getPlayers()[a] == getPlayers()[0]) continue;
            getPlayers()[a] playLocalSound("tesla_happy");
            getPlayers()[a] setOrigin(self lookPos());
            getPlayers()[a] iPrintln("You have been teleported to ^2" + self getName() + "'s ^7Crosshairs!");
        }
        self iPrintln("All players to Crosshairs!");
    }
}
bossRound() {
    zomb = getAiSpeciesArray("axis", "all");
    if (zomb.size <= 0) {
        self iprintln("NO ZOMBIES ON MAP!");
        return;
    }
    zomb[0] attach("zombie_skull", "J_Eyeball_LE", true);
    zomb[0] attach("zombie_teddybear", "J_Ankle_LE", true);
    zomb[0] attach("zombie_teddybear", "J_Ankle_RI", true);
    zomb[0].health = 100000;
    for (a = 0; a < getPlayers().size; a++) {
        getPlayers()[a] thread welcomeText("^1BOSS ROUND!", "Make Sure You Have Ammunition!");
        getPlayers()[a] thread lockMenu("ALL");
        getPlayers()[a] deleteInstructions();
        getPlayers()[a] thread bossRoundInfo(zomb[0], "Health: ^1", "Distance: ^2");
    }
    while (1) {
        zombies = getAIArray("axis");
        for (a = 1; a < zombies.size; a++) zombies[a] delete();
        if (zomb[0].health < 10) break;
        wait .05;
    }
    zomb[0].health = 0;
    zomb[0] detachAll();
    zomb[0] notify("death");
    for (a = 0; a < getPlayers().size; a++) {
        getPlayers()[a] unlockMenu();
        getPlayers()[a] thread remakeInstructions(1);
    }
}
bossRoundInfo(zomb, label, label2) {
    hud = [];
    hud[0] = self createRectangle("LEFT", "LEFT", 0, 0, self.menu["width"], 27, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
    hud[1] = self createRectangle("LEFT", "LEFT", hud[0].x - 2, hud[0].y, self.menu["width"] + 4, 31, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, self.menu["Edging_Alpha"]);
    hud[2] = self createText(self getFont(), 1.2, "LEFT", "LEFT", hud[0].x + 7, hud[0].y - 6, 10, 1, "");
    hud[3] = self createText(self getFont(), 1.2, "LEFT", "LEFT", hud[0].x + 7, hud[0].y + 6, 10, 1, "");
    hud[2].label = label;
    hud[3].label = label2;
    while (1) {
        if (zomb[0].health > 0) hud[2] setValue(zomb.health);
        else hud[2] setValue(0);
        hud[3] setValue(ceil(distance(zomb.origin, self.origin)));
        if (zomb.health <= 0) break;
        wait .05;
    }
    self destroyAll(hud);
}
doCreditMap() {
    if (getMap() != "cred") self iprintln("Error: Only Works On Credits Map!");
    else if (getMap() == "cred") {
        level.bg_hud destroy();
        self unlink();
        self freezeControls(false);
    }
}
activatePerkMachine(perk) {
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "ADMIN", self getPointer());
    perkList = strTok("fastreload|quickrevive|rof|armorvest", "|");
    if (perk == "ALL") {
        for (i = 0; i < perkList.size; i++) level notify("specialty_" + perkList[i] + "_power_on");
        self iprintln("All Perk Machines Activated");
    } else {
        level notify("specialty_" + perk + "_power_on");
        self iprintln(perk + " Perk Machine Activated");
    }
}
custom_spawn_points() {
    if (getDvar("scr_spawn_points") != "active") {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(true, "ADMIN", self getPointer());
        getPlayers()[0] setClientDvar("scr_spawn_points", "active");
    } else {
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "ADMIN", self getPointer());
        getPlayers()[0] setClientDvar("scr_spawn_points", "deactive");
    }
}
fxMenu() {
    self thread lockMenu("ALL");
    fx = getArrayKeys(level._effect);
    disp = self createText(getFont(), 1, "CENTER", "CENTER", 0, 100, 1, 1, "Current Fx: ^2" + fx[0]);
    ent = spawnSM(self lookPos(), "tag_origin", (-90, 0, 0));
    playFxOnTag(level._effect[fx[0]], ent, "tag_origin");
    curs = 0;
    self setInstructions("^2Fx Menu: ^7[{+attack}]/[{+speed_throw}]: Change Fx - [{+melee}]: Cancel");
    wait .15;
    while (true) {
        if (self adsButtonPressed() || self attackButtonPressed()) {
            curs -= self adsButtonPressed();
            curs += self attackButtonPressed();
            if (curs < 0) curs = fx.size - 1;
            if (curs > fx.size - 1) curs = 0;
            disp setText("Current Fx: ^2" + fx[curs]);
            ent remove();
            ent = spawnSM(self lookPos(), "tag_origin", (-90, 0, 0));
            playFxOnTag(level._effect[fx[curs]], ent, "tag_origin");
            wait .2;
        }
        if (self useButtonPressed()) {
            tag = spawnSM(self lookPos(), "tag_origin", (-90, 0, 0));
            playFxOnTag(level._effect[fx[curs]], tag, "tag_origin");
            self fxArray(tag);
            wait .2;
        }
        if (self meleeButtonPressed()) break;
        wait .05;
    }
    disp destroy();
    ent remove();
    if (isDefined(self.fxArray))
        for (a = 0; a < self.fxArray.size; a++) self.fxArray[a] remove();
    self unlockMenu();
    self resetInstructions();
}
fxArray(fx) {
    if (!isDefined(self.fxArray)) self.fxArray = [];
    self.fxArray[self.fxArray.size] = fx;
}
nukeInit(endGame) {
    array_thread(getPlayers(), ::donukeInit, endGame);
}
donukeInit(endGame) {
    self thread lockMenu("ALL");
    bgTop = self createRectangle("CENTER", "CENTER", -250, -201, 76, 12, (0, 0, 0), "white", 1, 1);
    bgBot = self createRectangle("CENTER", "CENTER", -250, -159, 76, 12, (0, 0, 0), "white", 1, 1);
    topTxt = self createText(getFont(), 1, "CENTER", "CENTER", -250, -201, 2, 1, "Nuke Inbound!");
    botTxt = self createText(getFont(), 1, "CENTER", "CENTER", -250, -159, 2, 1, "");
    botTxt thread doCountdownx(10);
    color[0] = (1, (188 / 255), (33 / 255));
    color[1] = (0, 0, 0);
    col = color[0];
    while (!isDefined(level.nukeXplosion)) {
        hud = self createRectangle("CENTER", "CENTER", -287.5, -180, 1, 30, col, "white", 1, 1);
        hud scaleOverTime(.5, 15, 30);
        hud moveOverTime(.5);
        hud.x += 7.5;
        wait .5;
        hud thread doNukeMovement();
        if (col == color[0]) col = color[1];
        else col = color[0];
    }
    wait 2.5;
    topTxt thread hudFadenDestroy(0, .4);
    botTxt hudFadenDestroy(0, .4);
    bgTop thread hudMoveY(-180, .4);
    bgBot hudMoveY(-180, .4);
    bgTop destroy();
    bgBot scaleOverTime(.4, 1, 1);
    wait .4;
    bgBot destroy();
    if (isDefined(endGame)) exitLevel();
    self unlockMenu();
}
doCountdownx(arg, arg1) {
    for (a = arg; a > 0; a--) {
        if (a == 20 || a == 15 || a <= 10) array_thread(getPlayers(), ::playSingleSound, "pa_audio_link_" + a);
        self setText("Time: " + a);
        wait 1;
    }
    if (isDefined(arg1)) self setText("Extinction");
    else self setText("KA-BOOM!");
    array_thread(getPlayers(), ::playSingleSound, "nuke_vox");
    array_thread(getPlayers(), ::doNukeExplosion, arg1);
}
doNukeExplosion(arg) {
    if (!isDefined(level.extinction)) level.nukeXplosion = true;
    self setVision("sniper_inside_fire");
    earthQuake(1, 3, self.origin, 200);
    self thread doSlomo();
    playFx(loadFx("explosions/fx_mortarExp_dirt"), (-57, 288, 103));
    for (a = 0; a < 10; a++) {
        playFx(loadFx("explosions/default_explosion"), (-57, 288, 103) + (randomIntRange(-40, 40), randomIntRange(-40, 40), randomIntRange(0, 40)));
        self playLocalSound("grenade_explode");
        self playLocalSound("nuke_flash");
        wait .2;
    }
    if (self == getPlayers()[0]) {
        level thread killZombiesWithinDistance((0, 0, 0), 1000000, "flame");
        if (!isDefined(arg)) level thread jumpToRound(level.round_number + 1);
    }
    level.nukeXplosion = undefined;
    self setVision("berserker");
    if (!isDefined(arg)) wait 18;
    else wait 11;
    self setVision("default");
}
doSlomo() {
    for (a = .9; a >= .3; a -= .1) {
        self setClientDvar("timescale", a);
        wait .1;
    }
    wait 3;
    for (a = getTimeScale(); a < 1.1; a += .1) {
        self setClientDvar("timescale", a);
        wait .1;
    }
}
doNukeMovement(bool) {
    if (self.color == (1, (188 / 255), (33 / 255))) self thread doNukePulse();
    for (a = 0; a < 5; a++) {
        if (a == 4) {
            self scaleOverTime(.5, 1, 30);
            self moveOverTime(.5);
            self.x += 7.5;
        } else {
            self moveOverTime(.5);
            self.x += 15;
        }
        wait .5;
    }
    self destroy();
}
doNukePulse() {
    self fadeOverTime(.8);
    self.color = (.891, .195, .059);
    wait .25;
    self fadeOverTime(.8);
    self.color = (1, (188 / 255), (33 / 255));
    wait .25;
    self fadeOverTime(.8);
    self.color = (.891, .195, .059);
    wait .25;
    self fadeOverTime(.8);
    self.color = (1, (188 / 255), (33 / 255));
    wait .25;
}
destroy_infectMenu() {
    if (isDefined(self.destroyInfectMenu)) return;
    self.destroyInfectMenu = true;
    self setOptionColor(self.menu["Select_Color"], "ADMIN", self getPointer());
    dvar = strTok("con_minicon con_gameMsgWindow0Time cg_chatTime", " ");
    value = strTok("0 4 5", " ");
    for (a = 0; a < dvar.size; a++) self setClientDvar(dvar[a], value[a]);
    self iPrintLn("Infectable Menu [^1Unbound^7]");
}
resetExtinction() {
    if (isDefined(self.extinctionRankReset)) return;
    self.extinctionRankReset = true;
    self setOptionColor(self.menu["Select_Color"], "Esure", self getPointer());
    self thread updateMenu("Rank Reset", "Esure", self getPointer());
    self setSavedVariable("153", 0);
    self setSavedVariable("154", 0);
    self setSavedVariable("hctwar_losses", 0, "mp/playerStatsTable.csv");
    self setSavedVariable("hckoth_losses", 0, "mp/playerStatsTable.csv");
    self setSavedVariable("155", 1);
}
playVid(vid) {
    movie = newClientHudElem();
    movie setShader("cinematic", 800, 600);
    cinematicInGame(vid);
}
stopVid() {
    stopCinematicInGame();
}
scavDelete() {
    for (a = 30; a >= 0; a--) {
        if (!isDefined(self)) break;
        wait 1;
    }
    self delete();
}
menuCredits() {
    self thread lockMenu("HALF");
    self setMenuTitle("Menu Credits");
    self setInstructions("^2Menu Credits: ^7[{+melee}]: Exit Menu Credits");
    self.menuCredits = true;
    self thread credits_effects();
    self thread credits_createText();
    while (isDefined(self.menuCredits) && !self downedCloseMenu()) {
        if (self meleeButtonPressed()) break;
        wait .05;
    }
    self.menuCredits = undefined;
    self notify("CREDITS_OVER");
    self resetInstructions();
    self unlockMenu("unlockHalf");
}
credits_createText() {
    text = [];
    text[0] = self createText(self getFont(), 1.2, "CENTER", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2), self.menu["positioning_Y"] - 7, 7, 0, "^6Patch: Elasticity");
    text[1] = self createText(self getFont(), 1.2, "CENTER", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2), self.menu["positioning_Y"] + 7, 7, 0, "^6Creator: AgreedBog381");
    for (a = 0; a < 2; a++) text[a] thread hudFade(1, 4);
    self thread credits_creditText();
    self thread credits_moveText(text);
    while (isDefined(self.menuCredits)) wait .05;
    self destroyAll(text);
}
credits_creditText() {
    self endon("CREDITS_OVER");
    wait 9;
    text = [];
    text[text.size] = "^1Start: ^6January 18th, 2015";
    text[text.size] = "^2End: ^6May 15th, 2016";
    text[text.size] = "~4";
    text[text.size] = "^1*^6THANKS TO^1*";
    text[text.size] = "IsoSickle";
    text[text.size] = "Versatile Ear";
    text[text.size] = "~4";
    text[text.size] = "^1*^6SPECIAL THANKS TO^1*";
    text[text.size] = "ChrisTheGr8est";
    text[text.size] = "^6*For always helping*";
    text[text.size] = "~4";
    text[text.size] = "^1*^6MENU CODED BY^1*";
    text[text.size] = "AgreedBog381";
    text[text.size] = "~4";
    text[text.size] = "^1*^6BUGFINDERS^1*";
    text[text.size] = "AgreedBog381";
    text[text.size] = "ChrisTheGr8est";
    text[text.size] = "IsoSickle";
	text[text.size] = "Cunts didn't do a good job";
    text[text.size] = "~6";
    text[text.size] = "Elasticity(C)(R)";
    text[text.size] = "~2";
	text[text.size] = "StarF*cked";
    text[text.size] = "~2";
	text[text.size] = "Get Fucked jk ily";
	
    for (a = 0; a < text.size; a++) {
        if (text[a].size > 0 && text[a][0] != "~") {
            hud = self createText(self getFont(), 1.25, "CENTER", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2), self.menu["positioning_Y"] + 100, 7, 0, text[a]);
            self thread credits_delete(hud);
            hud thread credits_hudMoveDelete(self.menu["positioning_Y"] - 100, 14);
            wait .75;
            hud thread hudFade(1, 1);
        }
        if (text[a][0] != "~") wait .6;
        else wait int(text[a][1]);
        if (text[a][2] == "*") wait .15;
    }
    wait 12.5;
    self.menuCredits = undefined;
}
credits_delete(hud) {
    self waittill("CREDITS_OVER");
    if (isDefined(hud)) hud destroy();
}
credits_moveText(text) {
    self endon("CREDITS_OVER");
    wait 5;
    text[0] thread credits_hudMoveDelete(self.menu["positioning_Y"] - 100, 5);
    text[1] thread credits_hudMoveDelete(self.menu["positioning_Y"] - 100, 6);
}
credits_hudMoveDelete(y, time) {
    self thread hudMoveY(y, time);
    wait time - 1.5;
    self thread hudFadenDestroy(0, 1);
}
credits_effects() {
    hud = [];
    for (a = 0; a < 10; a++) {
        hud[a] = self createRectangle("CENTER", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2), self.menu["positioning_Y"], 10, 20, divideColor(randomIntRange(0, 256), randomIntRange(0, 256), randomIntRange(0, 256)), "ui_sliderbutt_1", 6, 0);
        hud[a] thread credits_startMovement(0 + a * .15, self, sin(180 + (a * 36)) * -3, cos(180 + (a * 36)) * 3);
    }
    while (isDefined(self.menuCredits)) wait .05;
    self destroyAll(hud);
}
credits_startMovement(time, player, x, y) {
    player endon("CREDITS_OVER");
    wait time;
    self.alpha = 1;
    while (isDefined(self)) {
        self thread hudMoveXY(.1, self.x + x, self.y + y);
        if (self.y < player.menu["positioning_Y"] - 81) y *= -1;
        if (self.y > player.menu["positioning_Y"] + 81) y *= -1;
        if (self.x < player.menu["UI"]["Status"].x + 5) x *= -1;
        if (self.x > player.menu["UI"]["Status"].x + player.menu["width"] - 5) x *= -1;
        wait .01;
    }
}