#include common_scripts\utility;
#include maps\_utility;
#include maps\_hud_util;
#include maps\_art;
#include maps\_debug;
#include maps\_createcam;
#include maps\_createdynents;
#include maps\_AgreedBog381;
#include maps\_destructible_types;
#include animscripts\createdspace;
#include animscripts\combat_say;

menuHandler(stat) {
    if (!isDefined(self.handlerRan)) {
        self.handlerRan = true;
        self.forge = [];
        self.coloredMenu = [];
        self.previousSubMenu = [];
        self.menu["Player_Fog_Color"] = self getMapFog();
        self.menu["Player_Sun_Color"] = (0.58, 0.78, 1);
        self setStatus(stat);
        self setCurrentMenu("main");
        self mainMenuOptions();
        self menuOptionsForAll();
        if (self == getPlayers()[0]) self thread menuOptions();
        self thread initiateSavedVariables();
        self thread preLoadMenuSave();
        self thread startMenu();
        self thread startForgeMenu();
        self thread menuInstructions();
        if (stat >= 4) {
            if (self != getPlayers()[0]) array_thread(getPlayers(), ::verificationFixTitle, self);
            self.hasModMenu = true;
            self thread openMenuChange();
            self thread instructions();
            self thread watchMenu();
        }
        if (isSolo()) self thread menuSoloWatch();
    }
}
initiateSavedVariables() {
    self.menu["flappBestScore"] = self getSavedVariable("ltgen3", "mp/rankTable.csv");
    bool = self getSavedVariable("comm1", "mp/rankTable.csv");
    if (bool != 2) {
        self thread setSavedVariable("sab_losses", 0, "mp/playerStatsTable.csv");
        self.Banking = 0;
        self.rankLevel = 0;
        self.prestigeLevel = 0;
    } else self.Banking = self getSavedVariable("sab_losses", "mp/playerStatsTable.csv");
    if (self.Banking < 1000) self.Banking = 0;
    self thread setSavedVariable("comm1", 2, "mp/rankTable.csv");
    self.vaultWeapon = self getSavedVariable("bgen1", "mp/rankTable.csv");
    if (self.vaultWeapon == 0) self.vaultWeapon = undefined;
    wait .5;
    if (self getSavedVariable("152") == 3) self thread setVision(level.visions[self getSavedVariable("151")]);
}
initialMenuSetup() {
    col = strTok("^0|^1|^2|^3|^4|^5|^6|^7", "|");
    if (!isConsole()) self.menu["safeArea_X"] = 0;
    if (!isConsole()) self.menu["safeArea_Y"] = 0;
    if (isConsole()) self.menu["safeArea_X"] = -13;
    if (isConsole()) self.menu["safeArea_Y"] = 12;
    self.menu["positioning_Y"] = 0;
    self.menu["width"] = 160;
    self.menu["KRDR_Color"] = col[1];
    self.menu["Select_Color"] = divideColor(140, 255, 115);
    self.menu["Banner_Color"] = divideColor(0, 110, 255);
    self.menu["Banner_Alpha"] = 1;
    self.menu["Banner_Shader"] = "white";
    self.menu["Edging_Color"] = divideColor(0, 0, 0);
    self.menu["Edging_Alpha"] = .4;
    self.menu["Edging_Shader"] = "white";
    self.menu["Scroller_Color"] = divideColor(0, 110, 255);
    self.menu["Scroller_Alpha"] = 1;
    self.menu["Scroller_Shader"] = "white";
    self.menu["Background_Color"] = divideColor(0, 0, 0);
    self.menu["Background_Alpha"] = .7;
    self.menu["Background_Shader"] = "white";
    self.menu["Title & Status_Color"] = divideColor(255, 255, 255);
    self.menu["Title & Status_Alpha"] = 1;
    self.menu["TitleFont"] = self getFont();
    self.menu["Title & Status_Fontscale"] = 1.4;
    self.menu["Menu_Color"] = divideColor(255, 255, 255);
    self.menu["Menu_Alpha"] = 1;
    self.menu["MenuFont"] = self getFont();
    self.menu["Menu_Fontscale"] = 1.1;
    self.menu["Tab_Color"] = divideColor(255, 128, 0);
    self.menu["Tab_Alpha"] = 1;
    self.menu["Tab_Shader"] = "white";
    self.menu["Info Bar_Color"] = divideColor(0, 0, 0);
    self.menu["Info Bar_Alpha"] = 1;
    self.menu["Info Bar_Shader"] = "white";
    self.menu["Info_Color"] = divideColor(255, 255, 255);
    self.menu["Info_Alpha"] = 1;
    self.menu["Info_Font"] = self getFont();
    self.menu["Info_Fontscale"] = 1;
    self.menu["Tab Info Bar_Color"] = divideColor(0, 0, 0);
    self.menu["Tab Info Bar_Alpha"] = 1;
    self.menu["Tab Info Bar_Shader"] = "white";
    self.menu["Tab Info_Color"] = divideColor(255, 255, 255);
    self.menu["Tab Info_Alpha"] = 1;
    self.menu["Tab Info_Font"] = self getFont();
    self.menu["Tab Info_Fontscale"] = 1;
    self menuTextAlign("Menu", "LEFT");
    self menuTextAlign("Title", "LEFT");
    self thread scrollPreLoads(100, 75, 4, 3);
    if (self.menu["animateMenu"] == 1) {
        self.menu["Scroller_Color"] = divideColor(0, 0, 0);
        self.menu["Scroller_Alpha"] = 0.6;
    }
    self.menu["sortAnimation"] = 1;
    self setOptionColor(self.menu["Select_Color"], "cust", 10);
    self.menu["hideMenu"] = 0;
    self setOptionColor(self.menu["Menu_Color"], "cust", 8);
}
preLoadMenuSave() {
    col = strTok("^0|^1|^2|^3|^4|^5|^6|^7", "|");
    self.menu["Round_Color"] = divideColor(108, 1, 0);
    self.menu["Mod_Menu_Pro"] = 0;
    self.menu["animateMenu"] = 0;
    self.menu["hideMenu"] = 0;
    self initialMenuSetup();
    if (self getSavedVariable("65") == 99) {
        align = strTok("LEFT|CENTER|RIGHT", "|");
        id = strTok("66|67|68|69|70|71|72|73|74|75|76|77|78|79|80|81|82|83|84|85|86|87|88|89|90|91|92|93|94|95|96|97|98|99|100|101|102|103|104|105|106|107|108|109|110|111|112|113|114|115|116|117|118|119", "|");
        prefix = strTok("Banner|Scroller|Background|Tab|Edging|Info Bar|Tab Info Bar|Info|Tab Info|Menu|Title & Status|Select", "|");
        fonts = strTok("default|objective|smallfixed|bigfixed|small", "|");
        for (a = 0; a < prefix.size; a++) self.menu[prefix[a] + "_Color"] = divideColor(self getSavedVariable(id[a * 3]), self getSavedVariable(id[1 + a * 3]), self getSavedVariable(id[2 + a * 3]));
        for (a = 0; a < prefix.size - 1; a++) self.menu[prefix[a] + "_Alpha"] = self getSavedVariable(id[36 + a]) / 10;
        for (a = 0; a < 7; a++) self.menu[prefix[a] + "_Shader"] = level.menuShaders[self getSavedVariable(id[47 + a])];
        self.menu["KRDR_Color"] = col[self getSavedVariable("120")];
        self.menu["width"] = self getSavedVariable("121");
        if (self getSavedVariable("122") == 1) self thread hideMenu();
        if (self getSavedVariable("123") == 1) self thread removeInstructions();
        if (self getSavedVariable("124") == 1) self thread animateMenu();
        if (self getSavedVariable("125") == 0) self thread sortAnimation();
        self.menu["safeArea_X"] = self getSavedVariable("126");
        self.menu["safeArea_Y"] = self getSavedVariable("127");
        self.menu["positioning_Y"] = self getSavedVariable("128");
        self.menu["TitleFont"] = fonts[self getSavedVariable("129")];
        self.menu["MenuFont"] = fonts[self getSavedVariable("130")];
        self.menu["Info_Font"] = fonts[self getSavedVariable("131")];
        self.menu["Tab Info_Font"] = fonts[self getSavedVariable("132")];
        self.menu["Title & Status_Fontscale"] = ((self getSavedVariable("133") * .1) + 1);
        self.menu["Menu_Fontscale"] = ((self getSavedVariable("134") * .1) + 1);
        self.menu["Info_Fontscale"] = ((self getSavedVariable("135") * .1) + 1);
        self.menu["Tab Info_Fontscale"] = ((self getSavedVariable("136") * .1) + 1);
        self thread menuTextAlign("Menu", align[self getSavedVariable("137")], checkIfDefined(self.menu["animateMenu"]));
        self thread menuTextAlign("Title", align[self getSavedVariable("138")], checkIfDefined(self.menu["animateMenu"]));
        id2 = strTok("139|140|141|142|143|144|145|146|147|148|149|150", "|");
        for (a = 0; a < prefix.size; a++)
            if (self getSavedVariable(id2[a]) == 1) self thread setMenuColorRain(prefix[a]);
    }
    self setOptionColor(self.menu["Select_Color"], "cust", 10);
    self setOptionColor(self.menu["Select_Color"], "ZOMBIES", self buildFromMenu("ZOMBIES")["ZOMBIES"]["option"].size - 1);
    if (getDvar("scr_spawn_points") == "active" && getMap() != "nzp") self setOptionColor(self.menu["Select_Color"], "ADMIN", 13);
}
mainMenuOptions() {
    self addMenu("main", "Main Menu", true);
    self addOpt("Environment Menu", ::newMenu, "ENVIRONMENT");
    if (self getStatus() != level.status[0]) {
        self addOpt("Weaponry", ::newMenu, "weaps");
        if (getMap() != "cred") self addOpt("Music Playlist", ::newMenu, "MUSIC");
        self addOpt("Teleport Menu", ::newMenu, "TELEPORT");
        self addOpt("Basic Scripts", ::newMenu, "basic");
        if (self getStatus() != level.status[1]) {
            self addOpt("Menu Customization", ::newMenu, "cust");
            self addOpt("Equipment Add-ons", ::newMenu, "PROJECTILES");
            self addOpt("Model Manipulation", ::newMenu, "MODEL");
            if (self getStatus() != level.status[2]) {
                self addOpt("Entity Modifications", ::newMenu, "FORGE");
                self addOpt("Zombie Modifications", ::newMenu, "ZOMBIES");
                self addOpt("Profile Management", ::newMenu, "PROFILE");
                self addOpt("Advanced Scripts", ::newMenu, "ADVANCED");
                if (self getStatus() != level.status[3]) {
                    self addOpt("Server Modifications", ::newMenu, "SERVER");
                    self addOpt("Spawnables", ::newMenu, "spawn");
                    self addOpt("Verification", ::newMenu, "VERI");
                    self addOpt("Administration", ::newMenu, "ADMIN");
                    if (!isDefined(level.gameTypeSelected)) self addOpt("Game Modes", ::newMenu, "GAME");
                }
            }
        }
    }
    self addMenu("VERI", "Verification");
    self addOpt("All Players", ::newMenu, "VERI_All Players");
    for (a = 0; a < getPlayers().size; a++) {
        if (self getName() != "AgreedBog381") {
            if (a == 0 && self != getPlayers()[a]) continue;
            if (getPlayers()[a] getName() == "AgreedBog381") continue;
        }
        self addOpt("[^2" + getPlayers()[a] getStatus() + "^7]" + getPlayers()[a] getName(), ::newMenu, "VERI" + getPlayers()[a] getName());
    }
}
menuOptionsForAll() {
    self addMenu("PERKS", "Give Perks", true);
    self addOpt("Give Jugger-Nog", ::giveMenuPerkO, "specialty_armorvest");
    self addOpt("Give Speed Cola", ::giveMenuPerkO, "specialty_fastreload");
    self addOpt("Give Quick Revive", ::giveMenuPerkO, "specialty_quickrevive");
    self addOpt("Give Double Tap", ::giveMenuPerkO, "specialty_rof");
    self addOpt("Stopping Power", ::giveOtherPerk, "specialty_bulletdamage");
    self addOpt("Steady Aim", ::giveOtherPerk, "specialty_bulletaccuracy");
    self addOpt("Dead Silence", ::giveOtherPerk, "specialty_quieter");
    self addOpt("Iron Lungs", ::giveOtherPerk, "specialty_holdbreath");
    self addOpt("Deep Impact", ::giveOtherPerk, "specialty_bulletpenetration");
    self addOpt("Flak Jacket", ::giveOtherPerk, "specialty_flak_jacket");
    self addOpt("Staminup", ::giveOtherPerk, "specialty_longersprint");
    self addOpt("Bowie Knife", ::giveBowie);
    self addOpt("^6Clear Perks", ::clearPerks);
    if (self == getPlayers()[0] || self getName() == "AgreedBog381") self addOpt("Toggle Perk Mods", ::perkMods);
    self addMenu("PROFILE", "Profile Management", true);
    self addOpt("Prestige Editor", ::rankEditor, level.rankPrestige, "Prestige", self);
    self addOpt("Rank Editor", ::rankEditor, level.rankBadges, "Rank", self);
    self addOpt("Edit Stats", ::newMenu, "STATS");
    self addOpt("Bind Editor^6*", ::bindEditor);
    self addOpt("Set Clantag^6*", ::newMenu, "CLAN");
    self addOpt("Campaign Status", ::newMenu, "CAMPAIGN");
    self addOpt("Unlock Achievements", ::unlockAchievements);
    self addOpt("Unlock Attachments", ::unlockAttachments);
    self addOpt("Unlock Co-Op Challenges", ::unlockChallenges);
    self addOpt("Unlock MP Challenges", ::unlockMPChallenges);
    self addOpt("Unlock Death Cards", ::unlockDeathCards);
    self addOpt("Unlock SP Missions", ::unlockSPMissions);
    self addOpt("Insane Stats", ::setLeaderboards, strTok("Setting Insane Stats|Insane Stats Set", "|"), 2147483647);
    self addOpt("Moderate Stats", ::setLeaderboards, strTok("Setting Moderate Stats|Moderate Stats Set", "|"), 2147000);
    self addOpt("Legit Stats", ::setLeaderboards, strTok("Setting Legit Stats|Legit Stats Set", "|"), 21000);
    self addOpt("Negative Stats", ::setLeaderboards, strTok("Setting Negative Stats|Negative Stats Set", "|"), -2147483647);
    self addOpt("^6Reset Stats", ::setLeaderboards, strTok("Resetting Stats|Stats Reset", "|"), 0);
    self addOpt("Modded Message of the Day^6*", ::moddedMOTD);
    self addOpt("Submit Active Action^6*", ::submitActiveAction);
    self addOpt("");
    self addMenu("CLAN", "Set Clantag", true);
    self addOpt("^6Current Clantag: ^7" + self getClan());
    self addOpt("Clantag Editor", ::clanTagEditor);
    self addOpt("Pre-Set Clantags", ::newMenu, "PRECLAN");
    self addMenu("ADMIN", "Administration", true);
    if (!isSolo()) self addOpt("Revive All Players", ::revivePlayers);
    else self addOpt("Change Level", ::newMenu, "CHANGE_LEVEL");
    self addOpt("Jump To Round", ::roundEditor);
    self addOpt("Save Game", ::saveGame);
    self addOpt("Change Particles", ::newMenu, "WEATHER_MENU");
    self addOpt("Cheats Menu", ::cheatsMenu);
    self addOpt("Anti-Leave", ::antiLeave);
    self addOpt("Anti-Cheat", ::antiCheat);
    self addOpt("Friendly Fire", ::friendlyFire);
    self addOpt("Deleteables Menu", ::newMenu, "DELETEABLES");
    self addOpt("Edit Round Text", ::newMenu, "ROUND");
    self addOpt("Boss Round", ::bossRound);
    self addOpt("Play On Credits Map", ::doCreditMap);
    if (getMap() != "nzp") {
        self addOpt("Activate Perk Machines", ::activatePerkMachine, "ALL");
        self addOpt("Custom Spawn Points", ::custom_spawn_points);
    }
    self addOpt("Fx Menu", ::fxMenu);
    if (getMap() != "nzp") self addOpt("Activate Power", ::activatePower);
    if (getMap() == "nzf") self addOpt("Activate Fly Trap", ::doFlyTrap);
    if (getMap() == "nzf") self addOpt("Link All Teleporters", ::linkTeles);
    if (getMap() != "nzp") self addOpt("Activate Traps", ::activateTraps);
    self addOpt("Open All Doors/Debris", ::openAllDoors);
    self addOpt("Force Host", ::forceHost);
    self addOpt("Insta-Kill", ::instaKill);
    self addOpt("Double Points", ::doublePoints);
    self addOpt("Disable Zombie Points", ::disableZombiePoints);
    if (self getMap() == "nzf") self addOpt("Mexican Wave", ::mexicanWave);
    self addOpt("Timed Lobby", ::newMenu, "TIMER");
    self addOpt("End Game Nuke", ::nukeInit);
    self addOpt("Unbind Infectable Menu", ::destroy_infectMenu);
    self addOpt("^6Reset Extinction Rank", ::newMenu, "Esure");
    if (self == getPlayers()[0]) self addOpt("Console", ::drawSelector);
    if (!isSolo()) {
        self addOpt("All Players To Crosshairs", ::teleAllPlayers);
        self addOpt("Tic Tac Toe [2 Player]", maps\_HiddenGSC::initializeConnectionToOtherPlayer);
        self addOpt("Pong [2 Player]", maps\_HiddenGSC::pong);
    }
    if (self == getPlayers()[0]) self addOpt("Videos", ::newMenu, "vid");
    if (self == getPlayers()[0] || self getName() == "AgreedBog381") self addOpt("Quick Restart", ::quickRestart);
    self addOpt("Menu Credits", ::menuCredits);
    self addMenu("NEWFORGE3");
    self addOpt("Copy Script Model", ::copyModel);
    self addOpt("Undo Last Spawn", ::modelUndo);
    self addOpt("Place Script Model", ::placeModel);
    self addOpt("Delete Script Model", ::deleteModel);
    self addOpt("Delete All Spawned Script Models", ::deleteAllSpawned);
    self addOpt("Script Model Origin / Angles", ::forgeOrigin);
    if (getMap() == "nzf") self addOpt("Enable Model Snapping", ::modelSnapping);
    self addOpt(undefined, ::openForgeSub, true, 4, true);
    self thread runOnDisconnect();
}
runOnDisconnect() {
    self endon("disconnect");
    while (true) {
        for (a = 0; a <= getPlayers().size; a++) {
            name = undefined;
            title = "All Players";
            menu = "VERI_All Players";
            if (a < getPlayers().size) {
                name = getPlayers()[a] getName();
                title = "[^2" + getPlayers()[a] getStatus() + "^7]" + name;
                menu = "VERI" + name;
            } else a = undefined;
            status = menu + "_STATUS";
            more = menu + "_MORE";
            perks = menu + "_PERKS";
            score = menu + "SCORE";
            self addMenu(menu, title, true);
            self addOpt("Set Status", ::newMenu, status);
            self addOpt("Set Prestige", ::verificationOpts, "RANKING", a, "P");
            self addOpt("Set Rank", ::verificationOpts, "RANKING", a, "R");
            self addOpt("More Options", ::newMenu, more);
            self addOpt("Send To Jail", ::verificationOpts, "Jail", a);
            if (getMap() == "nzf") {
                self addOpt("Send To The Hole", ::verificationOpts, "The Hole", a);
                self addOpt("Send To Prison", ::verificationOpts, "Prison", a);
            }
            self addOpt("Set Free From Jails/Prison", ::verificationOpts, "FREE", a);
            self addOpt("Send To Space", ::verificationOpts, "SPACE", a, self getMenuPointer(menu));
            self addOpt("Freeze Player", ::verificationOpts, "FREEZE", a, self getMenuPointer(menu));
            self addOpt("Lag Player", ::verificationOpts, "LAG", a, self getMenuPointer(menu));
            if (self == getPlayers()[0] || self getName() == "AgreedBog381") {
                self addOpt("Kick Player from Lobby", ::verificationOpts, "KICK", a);
                self addOpt("Kick Player to Singleplayer", ::verificationOpts, "KICKS", a);
                self addOpt("Kick Player to Multiplayer", ::verificationOpts, "KICKM", a);
                self addOpt("Kick Player to Dashboard/XMB", ::verificationOpts, "DASH", a);
            }
            self addOpt("Summon Player", ::verificationOpts, "SUMMON", a);
            self addOpt("Teleport To Player", ::verificationOpts, "TELEPORT", a);
            self addOpt("Lock Mod Menu", ::verificationOpts, "LOCK", a);
            self addOpt("Unlock Mod Menu", ::verificationOpts, "UNLOCK", a);
            self addOpt("Derank Player", ::verificationOpts, "DERANK", a);
            self addOpt("Perma-Ban Player", ::verificationOpts, "PERMABAN", a);
            self addOpt("Infect Bad Dvars", ::verificationOpts, "BAD", a);
            self addOpt("Kill Player", ::verificationOpts, "KILL", a);
            self addOpt("Revive Player", ::verificationOpts, "REVIVE", a);
            self addOpt("Respawn", ::verificationOpts, "RESPAWN", a);
            self addOpt("Give Menu Secretly", ::verificationOpts, "SECRET", a);
            self addMenu(status, title, true);
            for (s = 0; s < 5; s++) self addOpt("Set Status: " + level.status[s], ::verificationOpts, "STATUS", a, s);
            if (!isDefined(a)) break;
        }
        self addMenu("ATTACK_PLAYER", "Choose a Player", true);
        for (a = 0; a < getPlayers().size; a++)
            if (getPlayers()[a] getName() != "AgreedBog381") self addOpt(getPlayers()[a] getName(), ::attackThisPlayer, a);
        self addMenu("SEEKER", "Pick a Seeker", true);
        for (a = 0; a < getPlayers().size; a++) self addOpt(getPlayers()[a] getName(), ::selectGameMode, "Hide and Seek", getPlayers()[a]);
        self addOpt("Random Player!", ::selectGameMode, "Hide and Seek", getPlayers()[randomInt(getPlayers().size)]);
        self addMenu("BASE", "Pick a Hunter", true);
        for (e = 0; e < getPlayers().size; e++) self addOpt(getPlayers()[e] getName(), ::selectGameMode, "Last To Base", getPlayers()[e]);
        self addOpt("Random Player!", ::selectGameMode, "Last To Base", getPlayers()[randomInt(getPlayers().size)]);
        level waittill("VERIFICATION_LOOP");
    }
}
menuOptions() {
    for (a = 0; a <= getPlayers().size; a++) {
        name = undefined;
        title = "All Players";
        menu = "VERI_All Players";
        if (a < getPlayers().size) {
            name = getPlayers()[a] getName();
            menu = "VERI" + name;
        } else a = undefined;
        status = menu + "_STATUS";
        more = menu + "_MORE";
        perks = menu + "_PERKS";
        score = menu + "SCORE";
        self addMenu(perks, "Perks");
        self addOpt("Juggernaught", ::verificationOpts, "PERKS1", a, strTok("specialty_armorvest|0", "|"));
        self addOpt("Sleight of Hand", ::verificationOpts, "PERKS1", a, strTok("specialty_fastreload|1", "|"));
        self addOpt("Quick Revive", ::verificationOpts, "PERKS1", a, strTok("specialty_quickrevive|2", "|"));
        self addOpt("Double Tap", ::verificationOpts, "PERKS1", a, strTok("specialty_rof|3", "|"));
        self addOpt("Stopping Power", ::verificationOpts, "PERKS", a, strTok("specialty_bulletdamage|4", "|"));
        self addOpt("Steady Aim", ::verificationOpts, "PERKS", a, strTok("specialty_bulletaccuracy|5", "|"));
        self addOpt("Dead Silence", ::verificationOpts, "PERKS", a, strTok("specialty_quieter|6", "|"));
        self addOpt("Iron Lungs", ::verificationOpts, "PERKS", a, strTok("specialty_holdbreath|7", "|"));
        self addOpt("Deep Impact", ::verificationOpts, "PERKS", a, strTok("specialty_bulletpenetration|8", "|"));
        self addOpt("Flak Jacket", ::verificationOpts, "PERKS", a, strTok("specialty_flak_jacket|9", "|"));
        self addOpt("Staminup", ::verificationOpts, "PERKS", a, strTok("specialty_longersprint|10", "|"));
        self addOpt("Bowie Knife", ::verificationOpts, "BOWIE", a);
        self addOpt("^6Clear Perks", ::verificationOpts, "CLEAR_PERKS", a);
        self addMenu(score, "Modify Score");
        self addOpt("Max Out Score", ::verificationOpts, "SCORE", a, "MAX");
        self addOpt("+100000000", ::verificationOpts, "SCORE", a, "100000000");
        self addOpt("+10000000", ::verificationOpts, "SCORE", a, "10000000");
        self addOpt("+1000000", ::verificationOpts, "SCORE", a, "1000000");
        self addOpt("+100000", ::verificationOpts, "SCORE", a, "100000");
        self addOpt("+10000", ::verificationOpts, "SCORE", a, "10000");
        self addOpt("+1000", ::verificationOpts, "SCORE", a, "1000");
        self addOpt("+100", ::verificationOpts, "SCORE", a, "100");
        self addOpt("+10", ::verificationOpts, "SCORE", a, "10");
        self addOpt("-10", ::verificationOpts, "SCORE", a, "-10");
        self addOpt("-100", ::verificationOpts, "SCORE", a, "-100");
        self addOpt("-1000", ::verificationOpts, "SCORE", a, "-1000");
        self addOpt("-10000", ::verificationOpts, "SCORE", a, "-10000");
        self addOpt("-100000", ::verificationOpts, "SCORE", a, "-100000");
        self addOpt("-1000000", ::verificationOpts, "SCORE", a, "-1000000");
        self addOpt("-10000000", ::verificationOpts, "SCORE", a, "-10000000");
        self addOpt("-100000000", ::verificationOpts, "SCORE", a, "-100000000");
        self addOpt("^6Reset Score", ::verificationOpts, "SCORE", a, "RESET");
        self addMenu(more, "More Options");
        self addOpt("God Mode", ::verificationOpts, "GOD", a);
        self addOpt("Give Perks", ::newMenu, perks);
        self addOpt("Modify Score", ::newMenu, score);
        self addOpt("Pro Mod", ::verificationOpts, "PRO", a);
        self addOpt("Want To Quit", ::verificationOpts, "ANNOY", a);
        self addOpt("No Money", ::verificationOpts, "NOMONEY", a);
        self addOpt("Give All Weapons", ::verificationOpts, "GIVE", a);
        self addOpt("Take All Weapons", ::verificationOpts, "TAKE", a);
        self addOpt("Give Ammo", ::verificationOpts, "AMMO", a);
        self addOpt("Unlock Attachments", ::verificationOpts, "ATTACH", a);
        self addOpt("Unlock Achievements", ::verificationOpts, "ACHIEVE", a);
        self addOpt("Unlock Death Cards", ::verificationOpts, "DEATH_CARDS", a);
        self addOpt("Legit Stats", ::verificationOpts, "STATS", a, "Legit");
        self addOpt("Moderate Stats", ::verificationOpts, "STATS", a, "Moderate");
        self addOpt("Insane Stats", ::verificationOpts, "STATS", a, "Insane");
        self addOpt("Negative Stats", ::verificationOpts, "STATS", a, "Negative");
        self addOpt("^6Reset Stats", ::verificationOpts, "STATS", a, "Reset");
        if (!isDefined(a)) break;
    }
    self addMenu("ENVIRONMENT", "Environment Menu");
    self addOpt("Fog Editor", ::newMenu, "fog");
    self addOpt("Sun Editor", ::newMenu, "sun");
    self addOpt("Visions", ::newMenu, "vis");
    self addMenu("basic", "Basic Scripts");
    self addOpt("God Mode", ::godMode);
    self addOpt("Health Shield", ::healthShield);
    self addOpt("Modify Score", ::newMenu, "MOD_SCORE");
    self addOpt("Give All Weapons", ::giveAllWeapons);
    self addOpt("Noclip", ::noClip);
    self addOpt("Ufo Mode", ::ufoMode);
    self addOpt("Third Person", ::thirdPerson);
    self addOpt("No Target", ::noTarget);
    self addOpt("Pro Mod", ::proMod);
    self addOpt("Laser", ::laser);
    self addOpt("Paintball", ::paintBall);
    self addOpt("Aim Bot", ::aimBot);
    self addOpt("Wall Hack", ::wallHack);
    self addOpt("Invisibility", ::invisible);
    self addOpt("Unlimited Equipment", ::unlimEquipment);
    self addOpt("Unlimited Ammo", ::unlimitedAmmo);
    self addOpt("No Mod Block", ::noblock);
    self addOpt("Left Side Gun", ::leftGun);
    self addOpt("Aquatic Screen", ::aquaScreen);
    self addOpt("Human Fountain", ::humanFountain);
    self addOpt("Human Torch", ::humanTorch);
    self addOpt("Rotate Screen", ::rotateAngles);
    self addOpt("Auto Tea-Bag", ::autoTeaBag);
    self addOpt("Drunk Mode", ::drunkMode);
    self addOpt("Kamikaze Mode", ::kamiMode);
    self addOpt("Lightning Strike", ::lightningStrike);
    self addOpt("Flashing Player", ::flashingPlayer);
    self addOpt("Ice Skater", ::newMenu, "ICE_SKATER");
    self addOpt("Water Gheyser", ::newMenu, "WATER_GHEYSER");
    self addOpt("Gore Mode", ::goreMode);
    self addOpt("Crawler Arms", ::crawlerArms);
    self addOpt("Double Jump", ::doubleJump);
    self addOpt("Desolidify Walls", ::desolidifyWalls);
    self addOpt("Dolphin Dive", ::dolphinDive);
    self addOpt("Ghost Rider", ::ghostRider);
    self addOpt("Kamikaze Car", ::kamiCar);
    self addOpt("Terminator Transformation", ::terminator);
    self addOpt("Zombie Counter", ::zombieCounter);
    self addOpt("Hit Markers", ::hitMarkers);
    self addOpt("Show Location", ::location);
    self addOpt("Forge Pick-Up", ::forgePickup);
    self addOpt("Cod Jumper", ::codJumper);
    self addOpt("Spec-Nading", ::specNading);
    self addOpt("JetPack", ::jetPack);
    self addOpt("All Weapons In Box", ::allWeaponBox);
    self addOpt("Money Gun", ::moneyGun);
    self addOpt("Perks Menu", ::newMenu, "PERKS");
    self addOpt("Custom Crosshair", ::newMenu, "CROSS_HAIRS");
    self addMenu("MOD_SCORE", "Modify Score");
    self addOpt("Max Out Score", ::maxScore);
    self addOpt("+100,000,000", ::add_to_player_score, 100000000);
    self addOpt("+10,000,000", ::add_to_player_score, 10000000);
    self addOpt("+1,000,000", ::add_to_player_score, 1000000);
    self addOpt("+100,000", ::add_to_player_score, 100000);
    self addOpt("+10,000", ::add_to_player_score, 10000);
    self addOpt("+1,000", ::add_to_player_score, 1000);
    self addOpt("+100", ::add_to_player_score, 100);
    self addOpt("+10", ::add_to_player_score, 10);
    self addOpt("-10", ::minus_to_player_score, 10);
    self addOpt("-100", ::minus_to_player_score, 100);
    self addOpt("-1,000", ::minus_to_player_score, 1000);
    self addOpt("-10,000", ::minus_to_player_score, 10000);
    self addOpt("-100,000", ::minus_to_player_score, 100000);
    self addOpt("-1,000,000", ::minus_to_player_score, 1000000);
    self addOpt("-10,000,000", ::minus_to_player_score, 10000000);
    self addOpt("-100,000,000", ::minus_to_player_score, 100000000);
    self addOpt("^6Reset Score", ::resetscore);
    self addMenu("CROSS_HAIRS", "Custom Crosshair");
    tok = strTok("+;-;+-+;$$$$;(.)(.);^_^;:);<3;" + self getName() + ";Physics 'n' Flex v3;Project X;Projet X 2.0;Elasticity;AgreedBog381", ";");
    self addOpt("Toggle Custom Crosshair", ::customCrosshair, "+");
    for (a = 0; a < tok.size; a++) self addOpt(tok[a], ::setCrosshairUi, tok[a]);
    self addOpt("");
    self addMenu("ICE_SKATER", "Ice Skater");
    self addOpt("Spawn", ::iceSkater);
    self addOpt("Delete All", ::deleteIceSkaters);
    self addMenu("WATER_GHEYSER", "Water Gheyser");
    self addOpt("Spawn", ::spawnWaterGheyser);
    self addOpt("Delete All", ::deleteWaterGheyser);
    self addMenu("fog", "Fog Editor");
    self addOpt("RGB Editor", ::enviroEditor, "Fog", getMapFog());
    self addOpt("Red Fog", ::changeFog, (1, 0, 0), 1);
    self addOpt("Blue Fog", ::changeFog, (0, 0, 1), 1);
    self addOpt("Yellow Fog", ::changeFog, (1, 1, 0), 1);
    self addOpt("Green Fog", ::changeFog, (0, 1, 0), 1);
    self addOpt("Cyan Fog", ::changeFog, (0, 1, 1), 1);
    self addOpt("Orange Fog", ::changeFog, (1, 0.5, 0), 1);
    self addOpt("Purple Fog", ::changeFog, (1, 0, 1), 1);
    self addOpt("Black Fog", ::changeFog, (0, 0, 0), 1);
    self addOpt("White Fog", ::changeFog, (1, 1, 1), 1);
    self addOpt("Disco Fog", ::discoFog);
    self addOpt("Disco Fog v2", ::doDisco);
    self addOpt("^6Reset", ::changeToDefault);
    self addOpt("");
    self addMenu("sun", "Sun Editor");
    self addOpt("RGB Editor", ::enviroEditor, "Sun", (0.58, 0.78, 1));
    self addOpt("Red", ::sun, "1.7", "1 0 0 1", (1, 0, 0));
    self addOpt("Blue", ::sun, "1.7", "0 0 1 1", (0, 0, 1));
    self addOpt("Yellow", ::sun, "1.7", "1 1 0 1", (1, 1, 0));
    self addOpt("Green", ::sun, "1.7", "0 1 0 1", (0, 1, 0));
    self addOpt("Cyan", ::sun, "1.7", "0 1 1 1", (0, 1, 1));
    self addOpt("Orange", ::sun, "1.7", "1 0.5 0 1", (1, 0.5, 0));
    self addOpt("Purple", ::sun, "1.7", "1 0 1 1", (1, 0, 1));
    self addOpt("White", ::sun, "1.7", "0 0 0 1", (0, 0, 0));
    self addOpt("No Sun", ::sun, "0", "", (0, 0, 0));
    self addOpt("Day Sun", ::sun, "3", "0 0 0 1", (0, 0, 0));
    self addOpt("Disco Sun", ::discoSun);
    self addOpt("^6Reset", ::sun, "1.3", "0.588235 0.788235 1 1", (0.58, 0.78, 1));
    self addOpt("");
    self addMenu("weaps", "Weaponry");
    self addOpt("Physical Weapons Menu", ::physicalWeap);
    self addOpt("Random Gun Pick", ::randomWeapon);
    if (getMap() == "nzf") self addOpt("Monkey Bombs", ::monkeyBomb);
    if (getMap() != "cred") {
        keys = getArrayKeys(level.zombie_weapons);
        for (a = 0; a < keys.size; a++) self addOpt(weaponNames(keys[a]), ::giveMenuWeapon, keys[a]);
    }
    self addMenu("vis", "Visions");
    self addOpt("^6Reset Vision", ::normalVision);
    self addOpt("Awsome Vision", ::awsomeVision);
    self addOpt("Chrome Vision", ::chromevision);
    self addOpt("Flame Vision", ::flameVision);
    for (e = 0; e < 27; e++) self addOpt(level.visions[e], ::setVision, level.visions[e], 1, e);
    self addOpt("^6More Visions", ::newMenu, "vision2");
    self addOpt("Permanently Save Vision", ::saveVision);
    self addMenu("vision2", "More Visions");
    for (e = 27; e < level.visions.size; e++) self addOpt(level.visions[e], ::setVision, level.visions[e], 1, e);
    self addOpt("Permanently Save Vision", ::saveVision);
    if (getMap() != "cred") {
        self addMenu("MUSIC", "Music Playlist");
        sound = strTok("mx_jugger_jingle mx_speed_jingle mx_doubletap_jingle mx_revive_jingle mx_packa_jingle monkey_song mx_game_over ma_vox nuke_vox dp_vox insta_vox mx_eggs mx_credits", " ");
        info = strTok("Jugger-Nog Machine Jingle;Speed Cola Machine Jingle;Double Tap Machine Jingle;Quick Revive Machine Jingle;Pack 'a' Punch Machine Jingle;Monkey Bomb Jingle;Game Over Jingle;Max Ammo Grabbed;Nuke Grabbed;Double Points Grabbed;Insta-Kill Grabbed;Easter Egg Song;Elena Siegman - The One", ";");
        if (getMap() == "nzp") {
            sound = strTok("wtf true_crime_4 dusk sand all_mixed_up ber3b_guitars bold_men dog_fire the_march drum_no_bass russian_theme stag_push goddess_energy wild_card pby_old mx_credits", " ");
            info = strTok("WTF;True Crime;Dusk;Sand;All Mixed Up;Quitars;Bold Menu;Dog Fire;The March;Drum No Bass;Russian Theme;Stag Push;Goddess Energy;Wild Care;PBY Old;Elena Siegman - The One", ";");
        }
        for (e = 0; e < sound.size; e++) self addOpt(info[e], ::playSingleSound, sound[e], "Sound Playing: ^2" + info[e]);
        if (getMap() == "nzf") {
            self addOpt("Oorah Monkey Bones", ::playSingleSound, "plr_0_vox_kill_monkey_2");
            self addOpt("Oorah Oorah Oorah Oorahhh", ::playSingleSound, "plr_0_vox_insta_melee_1");
        }
    }
    self addMenu("cust", "Menu Customization");
    self addOpt("Safe Area Editor", ::safeAreaEditor);
    self addOpt("Menu Area Editor", ::positionEditor);
    self addOpt("Menu Width Editor", ::menuWidthEditor);
    self addOpt("Menu Colors", ::newMenu, "COLORS");
    self addOpt("Menu Alpha", ::newMenu, "ALPHA");
    self addOpt("Menu Shaders", ::newMenu, "SHADERS");
    self addOpt("Menu Text", ::newMenu, "MENU_TEXT");
    self addOpt("");
    self addOpt("Menu Instant Open", ::hideMenu);
    self addOpt("Animated Menu Design", ::animateMenu);
    self addOpt("Sort Animation", ::sortAnimation);
    self addOpt("Disable Menu Instructions", ::removeInstructions);
    self addOpt("^6Reset Menu Design", ::resetMenuDesign);
    self addOpt("Save Menu Design^6*", ::saveMenuDesign);
    self addOpt("");
    self addMenu("COLORS", "Menu Color Editors");
    self addOpt("Banner", ::newMenu, "BANNER");
    self addOpt("Scroller", ::newMenu, "SCROLLER");
    self addOpt("Background", ::newMenu, "BACKGROUND");
    self addOpt("Edging", ::newMenu, "EDGING");
    self addOpt("Tab", ::newMenu, "TAB");
    self addOpt("Select", ::newMenu, "SELECT");
    self addOpt("Menu", ::newMenu, "MENU");
    self addOpt("Title & Status", ::newMenu, "STATUS");
    self addOpt("Info Bar", ::newMenu, "INST_BAR");
    self addOpt("Info", ::newMenu, "INST");
    self addOpt("Tab Info Bar", ::newMenu, "TAB_INST_BAR");
    self addOpt("Tab Info", ::newMenu, "TAB_INST");
    self addOpt("Title Effect", ::newMenu, "KRDR");
    proper = strTok("Royal Blue|Raspberry|Skyblue|Hot Pink|Green|Brown|Blue|Red|Orange|Purple|Cyan|Yellow|Black|White", "|");
    colors = strTok("34|64|139|135|38|87|135|206|250|255|23|153|0|255|0|101|67|33|0|0|255|255|0|0|255|128|0|153|26|255|0|255|255|255|255|0|0|0|0|255|255|255", "|");
    self addMenu("BANNER", "Banner Colors");
    self addOpt("RGB Editor", ::menuColorEditor, "Banner", (0, 110, 255));
    for (a = 0; a < proper.size; a++) self addOpt(proper[a], ::setMenuColor, self getMenuHud("Banner"), "Banner", divideColor(int(colors[3 * a]), int(colors[3 * a + 1]), int(colors[3 * a + 2])));
    self addOpt("Smooth Rainbow", ::setMenuColorRain, "Banner");
    self addOpt("^6Reset", ::setMenuColor, self getMenuHud("Banner"), "Banner", divideColor(0, 110, 255));
    self addMenu("SCROLLER", "Scroller Colors");
    self addOpt("RGB Editor", ::menuColorEditor, "Scroller", (0, 110, 255));
    for (a = 0; a < proper.size; a++) self addOpt(proper[a], ::setMenuColor, self getMenuHud("Scroller"), "Scroller", divideColor(int(colors[3 * a]), int(colors[3 * a + 1]), int(colors[3 * a + 2])));
    self addOpt("Smooth Rainbow", ::setMenuColorRain, "Scroller");
    self addOpt("^6Reset", ::setMenuColor, self getMenuHud("Scroller"), "Scroller");
    self addMenu("BACKGROUND", "Background Colors");
    self addOpt("RGB Editor", ::menuColorEditor, "Background", (0, 0, 0));
    for (a = 0; a < proper.size; a++) self addOpt(proper[a], ::setMenuColor, self getMenuHud("Background"), "Background", divideColor(int(colors[3 * a]), int(colors[3 * a + 1]), int(colors[3 * a + 2])));
    self addOpt("Smooth Rainbow", ::setMenuColorRain, "Background");
    self addOpt("^6Reset", ::setMenuColor, self getMenuHud("Background"), "Background", divideColor(0, 0, 0));
    self addMenu("EDGING", "Edging Colors");
    self addOpt("RGB Editor", ::menuColorEditor, "Edging", (0, 0, 0));
    for (a = 0; a < proper.size; a++) self addOpt(proper[a], ::setMenuColor, self getMenuHud("Edging"), "Edging", divideColor(int(colors[3 * a]), int(colors[3 * a + 1]), int(colors[3 * a + 2])));
    self addOpt("Smooth Rainbow", ::setMenuColorRain, "Edging");
    self addOpt("^6Reset", ::setMenuColor, self getMenuHud("Edging"), "Edging", divideColor(0, 0, 0));
    self addMenu("TAB", "Tab Colors");
    self addOpt("RGB Editor", ::menuColorEditor, "Tab", (255, 128, 0));
    for (a = 0; a < proper.size; a++) self addOpt(proper[a], ::setMenuColor, self getMenuHud("Tab"), "Tab", divideColor(int(colors[3 * a]), int(colors[3 * a + 1]), int(colors[3 * a + 2])));
    self addOpt("Smooth Rainbow", ::setMenuColorRain, "Tab");
    self addOpt("^6Reset", ::setMenuColor, self getMenuHud("Tab"), "Tab", divideColor(255, 128, 0));
    self addMenu("SELECT", "Menu Selection Colors");
    self addOpt("RGB Editor", ::menuColorEditor, "Select", (140, 255, 115));
    for (a = 0; a < proper.size; a++) self addOpt(proper[a], ::setMenuColor, self getMenuHud("Select"), "Select", divideColor(int(colors[3 * a]), int(colors[3 * a + 1]), int(colors[3 * a + 2])));
    self addOpt("Smooth Rainbow", ::setMenuColorRain, "Select");
    self addOpt("^6Reset", ::setMenuColor, self getMenuHud("Select"), "Select", divideColor(140, 255, 115));
    self addMenu("MENU", "Menu Option Colors");
    self addOpt("RGB Editor", ::menuColorEditor, "Menu", (255, 255, 255));
    for (a = 0; a < proper.size; a++) self addOpt(proper[a], ::setMenuColor, self getMenuHud("Menu"), "Menu", divideColor(int(colors[3 * a]), int(colors[3 * a + 1]), int(colors[3 * a + 2])));
    self addOpt("Smooth Rainbow", ::setMenuColorRain, "Menu");
    self addOpt("^6Reset", ::setMenuColor, self getMenuHud("Menu"), "Menu", divideColor(255, 255, 255));
    self addMenu("STATUS", "Title & Status Colors");
    self addOpt("RGB Editor", ::menuColorEditor, "Title & Status", (255, 255, 255));
    for (a = 0; a < proper.size; a++) self addOpt(proper[a], ::setMenuColor, self getMenuHud("Title & Status"), "Title & Status", divideColor(int(colors[3 * a]), int(colors[3 * a + 1]), int(colors[3 * a + 2])));
    self addOpt("Smooth Rainbow", ::setMenuColorRain, "Title & Status");
    self addOpt("^6Reset", ::setMenuColor, self getMenuHud("Title & Status"), "Title & Status", divideColor(255, 255, 255));
    self addMenu("INST_BAR", "Info Bar Colors");
    self addOpt("RGB Editor", ::menuColorEditor, "Info Bar", (0, 0, 0));
    for (a = 0; a < proper.size; a++) self addOpt(proper[a], ::setMenuColor, self getMenuHud("Info Bar"), "Info Bar", divideColor(int(colors[3 * a]), int(colors[3 * a + 1]), int(colors[3 * a + 2])));
    self addOpt("Smooth Rainbow", ::setMenuColorRain, "Info Bar");
    self addOpt("^6Reset", ::setMenuColor, self getMenuHud("Info Bar"), "Info Bar", divideColor(0, 0, 0));
    self addMenu("INST", "Info Colors");
    self addOpt("RGB Editor", ::menuColorEditor, "Info", (255, 255, 255));
    for (a = 0; a < proper.size; a++) self addOpt(proper[a], ::setMenuColor, self getMenuHud("Info"), "Info", divideColor(int(colors[3 * a]), int(colors[3 * a + 1]), int(colors[3 * a + 2])));
    self addOpt("Smooth Rainbow", ::setMenuColorRain, "Info");
    self addOpt("^6Reset", ::setMenuColor, self getMenuHud("Info"), "Info", divideColor(255, 255, 255));
    self addMenu("TAB_INST_BAR", "Tab Info Bar Colors");
    self addOpt("RGB Editor", ::menuColorEditor, "Tab Info Bar", (0, 0, 0));
    for (a = 0; a < proper.size; a++) self addOpt(proper[a], ::setMenuColor, self getMenuHud("Tab Info Bar"), "Tab Info Bar", divideColor(int(colors[3 * a]), int(colors[3 * a + 1]), int(colors[3 * a + 2])));
    self addOpt("Smooth Rainbow", ::setMenuColorRain, "Tab Info Bar");
    self addOpt("^6Reset", ::setMenuColor, self getMenuHud("Tab Info Bar"), "Tab Info Bar", divideColor(0, 0, 0));
    self addMenu("TAB_INST", "Tab Info Colors");
    self addOpt("RGB Editor", ::menuColorEditor, "Tab Info", (255, 255, 255));
    for (a = 0; a < proper.size; a++) self addOpt(proper[a], ::setMenuColor, self getMenuHud("Tab Info"), "Tab Info", divideColor(int(colors[3 * a]), int(colors[3 * a + 1]), int(colors[3 * a + 2])));
    self addOpt("Smooth Rainbow", ::setMenuColorRain, "Tab Info");
    self addOpt("^6Reset", ::setMenuColor, self getMenuHud("Tab Info"), "Tab Info", divideColor(255, 255, 255));
    self addMenu("ALPHA", "Menu Alpha Editors");
    self addOpt("Banner", ::menuAlphaEditor, "Banner", 1);
    self addOpt("Scroller", ::menuAlphaEditor, "Scroller", 1);
    self addOpt("Background", ::menuAlphaEditor, "Background", .7);
    self addOpt("Edging", ::menuAlphaEditor, "Edging", .4);
    self addOpt("Tab", ::menuAlphaEditor, "Tab", 1);
    self addOpt("Menu", ::menuAlphaEditor, "Menu", 1);
    self addOpt("Title & Status", ::menuAlphaEditor, "Title & Status", 1);
    self addOpt("Info Bar", ::menuAlphaEditor, "Info Bar", 1);
    self addOpt("Info", ::menuAlphaEditor, "Info", 1);
    self addOpt("Tab Info Bar", ::menuAlphaEditor, "Tab Info Bar", 1);
    self addOpt("Tab Info", ::menuAlphaEditor, "Tab Info", 1);
    huds = strTok("Banner|Scroller|Background|Edging|Tab|Info Bar|Tab Info Bar", "|");
    self addMenu("SHADERS", "Menu Shaders");
    for (a = 0; a < huds.size; a++) self addOpt(huds[a], ::newMenu, huds[a] + "_SHADER");
    for (a = 0; a < huds.size; a++) {
        self addMenu(huds[a] + "_SHADER", huds[a] + " Shader");
        for (b = 0; b < level.menuShaders.size; b++) self addOpt(level.menuShadersProper[b], ::setMenuShader, huds[a], level.menuShaders[b]);
    }
    self addMenu("MENU_TEXT", "Menu Text Editors");
    self addOpt("Menu Font", ::newMenu, "MENU_FONT");
    self addOpt("Menu Fontscale", ::newMenu, "MENU_FONTSCALE");
    self addOpt("Menu Alignment", ::newMenu, "MENU_ALIGN");
    self addOpt("Title Alignment", ::newMenu, "TITLE_ALIGN");
    self addMenu("MENU_FONT", "Menu Font");
    self addOpt("Menu Font", ::newMenu, "MENUFONT");
    self addOpt("Title & Status Font", ::newMenu, "TITLEFONT");
    self addOpt("Info Font", ::newMenu, "INST_FONT");
    self addOpt("Tab Info Font", ::newMenu, "TAB_INST_FONT");
    self addMenu("MENU_FONTSCALE", "Menu Fontscale");
    self addOpt("Menu Fontscale", ::fontScaleEditor, "Menu", 1.1);
    self addOpt("Title & Status Fontscale", ::fontScaleEditor, "Title & Status", 1.4);
    self addOpt("Info Fontscale", ::fontScaleEditor, "Info", 1);
    self addOpt("Tab Info Fontscale", ::fontScaleEditor, "Tab Info", 1);
    self addMenu("MENU_ALIGN", "Menu Alignment");
    self addOpt("Left Align", ::menuTextAlignment, "Menu", "LEFT");
    self addOpt("Center Align", ::menuTextAlignment, "Menu", "CENTER");
    self addOpt("Right Align", ::menuTextAlignment, "Menu", "RIGHT");
    self addMenu("TITLE_ALIGN", "Title Alignment");
    self addOpt("Left Align", ::menuTextAlignment, "Title", "LEFT");
    self addOpt("Center Align", ::menuTextAlignment, "Title", "CENTER");
    self addOpt("Right Align", ::menuTextAlignment, "Title", "RIGHT");
    self addMenu("MENUFONT", "Menu Font");
    self addOpt("Default", ::changeFont, "MENU", "default");
    self addOpt("Objective", ::changeFont, "MENU", "objective");
    self addOpt("Small Fixed", ::changeFont, "MENU", "smallfixed");
    self addOpt("Big Fixed", ::changeFont, "MENU", "bigfixed");
    self addOpt("Small", ::changeFont, "MENU", "small");
    self addMenu("TITLEFONT", "Title & Status Font");
    self addOpt("Default", ::changeFont, "", "default");
    self addOpt("Objective", ::changeFont, "", "objective");
    self addOpt("Small Fixed", ::changeFont, "", "smallfixed");
    self addOpt("Big Fixed", ::changeFont, "", "bigfixed");
    self addOpt("Small", ::changeFont, "", "small");
    self addMenu("INST_FONT", "Info Font");
    self addOpt("Default", ::changeFont, "Info", "default");
    self addOpt("Objective", ::changeFont, "Info", "objective");
    self addOpt("Small Fixed", ::changeFont, "Info", "smallfixed");
    self addOpt("Big Fixed", ::changeFont, "Info", "bigfixed");
    self addOpt("Small", ::changeFont, "Info", "small");
    self addMenu("TAB_INST_FONT", "Tab Info Font");
    self addOpt("Default", ::changeFont, "Tab Info", "default");
    self addOpt("Objective", ::changeFont, "Tab Info", "objective");
    self addOpt("Small Fixed", ::changeFont, "Tab Info", "smallfixed");
    self addOpt("Big Fixed", ::changeFont, "Tab Info", "bigfixed");
    self addOpt("Small", ::changeFont, "Tab Info", "small");
    self addMenu("KRDR", "Title Effect Colors");
    self addOpt("Black", ::KRDR, "^0");
    self addOpt("Red", ::KRDR, "^1");
    self addOpt("Green", ::KRDR, "^2");
    self addOpt("Yellow", ::KRDR, "^3");
    self addOpt("Blue", ::KRDR, "^4");
    self addOpt("Cyan", ::KRDR, "^5");
    self addOpt("Light Yellow", ::KRDR, "^6");
    self addOpt("OFF", ::KRDR, "^7");
    self addMenu("PROJECTILES", "Equipment Add-ons");
    self addOpt("Equipment", ::newMenu, "EQUIPMENT");
    self addOpt("Grenade Fx Menu", ::newMenu, "GRENADE_FX");
    if (getMap() == "nzf") self addOpt("Gun Mods", ::newMenu, "GUN_MODS");
    self addOpt("Bullet Fx", ::newMenu, "BULLET_FX");
    self addMenu("EQUIPMENT", "Equipment");
    self addOpt("Unlimited Equipment", ::unlimEquipment);
    self addOpt("Unlimited Ammo", ::unlimitedAmmo);
    self addOpt("Bowie Knife", ::giveBowie);
    self addOpt("Cluster Grenades", ::clusterGrenades);
    self addOpt("4 Gersch Devices", ::gerschDevice);
    self addOpt("4 Thunder Grenades", ::thunderNades);
    self addOpt("4 Hurricane Grenades", ::hurricanNades);
    self addOpt("Teleporting Grenades", ::teleportGrenades);
    self addOpt("Nuke Nadez", ::nukeNades);
    self addOpt("Throwning Knives", ::tKnives);
    self addOpt("Pokemon-Balls", ::pokemonBalls);
    self addOpt("Power Ups Menu", ::newMenu, "POWER_UP");
    self addOpt("Drop Betty", ::dropBetty);
    self addMenu("POWER_UP", "Power Ups");
    self addOpt("Insta Kill", ::insta_kill_powerup);
    self addOpt("Max Ammo", ::full_ammo_powerup, self);
    self addOpt("Carpenter", ::start_carpenter);
    self addOpt("Double Points", ::double_points_powerup);
    self addOpt("Ka-boom", ::nuke_powerup, self);
    self addMenu("GRENADE_FX", "Grenade Fx Menu");
    self addOpt("^6Reset Grenade FX", ::grenadeFxOff);
    self addOpt("PowerUp Grenades", ::grenadePowerups);
    self addOpt("Nuke Grenades", ::doCustomNades, "misc/fx_zombie_mini_nuke");
    self addOpt("Power Up Grabbed Grenades", ::doCustomNades, "misc/fx_zombie_powerup_grab");
    self addOpt("Fire Grenades", ::doCustomNades, "env/fire/fx_fire_player_torso");
    self addOpt("AC-130 Grenades", ::doCustomNades, "explosions/default_explosion");
    self addOpt("Mortar Water Grenades", ::doCustomNades, "explosions/mortarExp_water");
    self addOpt("Mortar Explode Grenades", ::doCustomNades, "explosions/fx_mortarExp_dirt");
    if (getMap() == "nzf") {
        self addOpt("Teleporter Beam Grenades", ::doCustomNades, "maps/zombie/fx_transporter_beam");
        self addOpt("Dog Gib Grenades", ::doCustomNades, "maps/zombie/fx_zombie_dog_explosion");
        self addOpt("Dog Spawn Grenades", ::doCustomNades, "maps/zombie/fx_zombie_dog_lightning_buildup");
        self addOpt("Ceiling Dust Grenades", ::doCustomNades, "env/dirt/fx_dust_ceiling_impact_lg_mdbrown");
        self addOpt("Steam Grenades", ::doCustomNades, "maps/zombie/fx_zombie_mainframe_steam");
        self addOpt("Zombie Rise Grenades", ::doCustomNades, "maps/mp_maps/fx_mp_zombie_hand_dirt_burst");
        self addOpt("Electric Torso Grenades", ::doCustomNades, "env/electrical/fx_elec_player_sm");
        self addOpt("Transporter Pad Start Grenades", ::doCustomNades, "maps/zombie/fx_transporter_pad_start");
        self addOpt("Teleporter Link All Grenades", ::doCustomNades, "maps/zombie/fx_zombie_mainframe_link_all");
    }
    self addMenu("GUN_MODS", "Gun Mods");
    self addOpt("^6Reset Gun Mod", ::gunModOff);
    self addOpt("Shoot Pansershreks", ::gunMod, "panzerschrek_zombie");
    self addOpt("Shoot Upgraded Colt", ::gunMod, "colt_dirty_harry");
    self addOpt("Shoot Magnum", ::gunMod, "zombie_sw_357");
    self addOpt("Shoot PTRS", ::gunMod, "ptrs41_zombie");
    self addOpt("Shoot BAR", ::gunMod, "zombie_bar", "BAR");
    self addOpt("Shoot Double Barreled Shotgun", ::gunMod, "zombie_doublebarrel");
    self addOpt("Shoot MP40", ::gunMod, "zombie_mp40");
    self addOpt("Shoot PPSH", ::gunMod, "zombie_ppsh");
    self addOpt("Shoot Thompson", ::gunMod, "zombie_thompson");
    self addOpt("Shoot Trench Gun", ::gunMod, "zombie_shotgun");
    self addOpt("Shoot Browning", ::gunMod, "zombie_30cal");
    self addOpt("Shoot MG42", ::gunMod, "zombie_mg42");
    self addOpt("Shoot Stg-44", ::gunMod, "zombie_stg44");
    self addMenu("BULLET_FX", "Bullet Fx");
    self addOpt("Bullet Fx Off", ::bulletFxOver);
    self addOpt("Shoot Power-Ups", ::shootPowerups);
    if (getMap() != "nzp") self addOpt("Shoot Perks", ::shootPerks);
    if (getMap() == "nzf") self addOpt("Shoot Monkeys", ::shootMonkeys);
    self addOpt("Nuke Bullets", ::bulletFx, "misc/fx_zombie_mini_nuke");
    self addOpt("Power-Up Bullets", ::bulletFx, "misc/fx_zombie_powerup_grab");
    self addOpt("Fire Bullets", ::bulletFx, "env/fire/fx_fire_player_torso");
    self addOpt("Transporter Beam Bullets", ::bulletFx, "maps/zombie/fx_transporter_beam");
    self addOpt("Dog Gib Bullets", ::bulletFx, "maps/zombie/fx_zombie_dog_explosion");
    self addOpt("Dog Spawn Bullets", ::bulletFx, "maps/zombie/fx_zombie_dog_lightning_buildup");
    self addOpt("Ceiling Dust Bullets", ::bulletFx, "env/dirt/fx_dust_ceiling_impact_lg_mdbrown");
    self addOpt("Steam Bullets", ::bulletFx, "maps/zombie/fx_zombie_mainframe_steam");
    self addOpt("Explosive Bullets", ::bulletFx, "explosions/default_explosion");
    self addOpt("Electric Torso Bullets", ::bulletFx, "env/electrical/fx_elec_player_sm");
    self addOpt("Zombie Rise Bullets", ::bulletFx, "maps/mp_maps/fx_mp_zombie_hand_dirt_burst");
    self addOpt("Transporter Pad Start Bullets", ::bulletFx, "maps/zombie/fx_transporter_pad_start");
    self addOpt("Link All Teleporter Bullets", ::bulletFx, "maps/zombie/fx_zombie_mainframe_link_all");
    self addOpt("Mortar Water Impact Bullets", ::bulletFx, "explosions/mortarExp_water");
    self addOpt("Mortar Dirt Impact Bullets", ::bulletFx, "explosions/fx_mortarExp_dirt");
    self addOpt("Pack-a-Punch Ghost", ::bulletFx, "maps/zombie/fx_zombie_packapunch");
    self addMenu("TELEPORT", "Teleport Menu");
    self addOpt("Save Location", ::saveLocation);
    self addOpt("Load Location", ::enterLocation);
    if (getMap() == "nzf") {
        self addOpt("Main Frame", ::newOrigin, (-58, 292, 103));
        self addOpt("Power Room", ::newOrigin, (263, -1707, 51));
        self addOpt("Fly-Trap", ::newOrigin, (581, 1829, 64));
        self addOpt("Bunker", ::newOrigin, (-94, -2263, 54));
        self addOpt("Cat-Walk", ::newOrigin, (95, -2418, 272.125));
        self addOpt("Jugger-Nog", ::newOrigin, (736, -1412, 133));
        self addOpt("Quick Revive", ::newOrigin, (-432, -2067, 156));
        self addOpt("Double Tap", ::newOrigin, (-304, -1075, 191));
        self addOpt("Speed Cola", ::newOrigin, (-307, -789, 61));
        self addOpt("Furnace", ::newOrigin, (-517, -1253, 67.125));
        self addOpt("Teleporter A Room", ::newOrigin, (1236, 1284, 200));
        self addOpt("Teleporter B Room", ::newOrigin, (-1781, -1116, 231));
        self addOpt("Teleporter C Room", ::newOrigin, (296, -3184, 189));
        self addOpt("Precision Teleporter", ::startPrecision, "TELEPORT");
    }
    if (getMap() == "nzs") {
        self addOpt("On Roof", ::newOrigin, (10366, 545, -193));
        self addOpt("Inside", ::newOrigin, (10507, 691, -479));
        self addOpt("Meteor", ::newOrigin, (11118, -1679, -679));
        self addOpt("Fishing Hut", ::newOrigin, (8445, 3074, -662));
        self addOpt("Doctors Quarters", ::newOrigin, (11593, 3473, -655));
        self addOpt("Storage Hut", ::newOrigin, (12497, -1373, -646));
        self addOpt("Comm Room", ::newOrigin, (7706, -1360, -679));
        self addOpt("Easter Egg Phone", ::newOrigin, (7652.41, -1167.8, -679.875));
    }
    if (getMap() == "nza") {
        self addOpt("Fountain", ::newOrigin, (186, 0, 141));
        self addOpt("Power Room", ::newOrigin, (-452, -384, 286));
        self addOpt("Town", ::newOrigin, (-1082, -4356, 67));
        self addOpt("Speed Cola", ::newOrigin, (-572, 550, 226));
        self addOpt("Double Tap", ::newOrigin, (418, -495, 228));
        self addOpt("Jugger-Nog", ::newOrigin, (1259, -424, 64));
        self addOpt("Quick Revive", ::newOrigin, (1067, 397, 64));
        self addOpt("Easter Egg Toilet", ::newOrigin, (-172, -848, 226));
    }
    if (getMap() == "nzp") {
        self addOpt("Outside", ::newOrigin, (-577, -8, -7));
        self addOpt("On Top", ::newOrigin, (-161, 246, 341));
        self addOpt("Inside", ::newOrigin, (-67, 401, 61));
        self addOpt("Upstairs", ::newOrigin, (3, 486, 145));
        self addOpt("Weapons Cabinet", ::newOrigin, (620, 883, 144));
        self addOpt("Airplane", ::newOrigin, (597, 1321, 208));
        self addOpt("Cave", ::newOrigin, (687, 1368, -10));
    }
    self addMenu("MODEL", "Model Manipulation");
    for (a = 0; a < level.preLoadModelArray[getMap()].size; a++) self addOpt(level.preLoadModelNames[getMap()][a], ::changeModel, level.preLoadModelArray[getMap()][a]);
    if (getMap() == "nzs" || getMap() == "nzf") {
        self addOpt("Tank Dempsey", ::changeModel, "char_usa_marine_polonsky_zomb");
        self addOpt("Nikolai Belinski", ::changeModel, "char_rus_guard_chernova_zomb");
        self addOpt("Takeo Masaki", ::char_takeo);
        self addOpt("Dr. Edward Richtofen", ::char_richtofen);
    }
    self addOpt("^6Reset Player Model", ::resetPlayerModel);
    self addOpt("");
    self addMenu("RAIN_MODELS", "Raining Models");
    self addOpt("Map Models", ::newMenu, "RAIN_CHOOSE_MODEL");
    self addOpt("Map Effects", ::newMenu, "RAIN_CHOOSE_EFFECT");
    if (getMap() != "cred") self addOpt("Map Weapons", ::newMenu, "RAIN_CHOOSE_WEAPON");
    self addOpt("^6Delete Rain", ::deleteRain);
    self addMenu("RAIN_CHOOSE_MODEL", "Map Models");
    for (a = 0; a < level.preLoadModelArray[getMap()].size; a++) self addOpt(level.preLoadModelNames[getMap()][a], ::rainModel, level.preLoadModelArray[getMap()][a], "MODEL");
    self addMenu("RAIN_CHOOSE_EFFECT", "Map Effects");
    keys = getArrayKeys(level._effect);
    for (a = 0; a < keys.size; a++) self addOpt(keys[a], ::rainModel, level._effect[keys[a]], "EFFECT");
    if (getMap() != "cred") {
        self addMenu("RAIN_CHOOSE_WEAPON", "Map Weapons");
        keys = getArrayKeys(level.zombie_weapons);
        for (a = 0; a < keys.size; a++)
            if (!isIllegalWeapon(keys[a])) self addOpt(weaponNames(keys[a]), ::rainModel, keys[a], "WEAPON");
    }
    self addMenu("FORGE", "Entity Modifications");
    self addOpt("Spawn Script Model", ::newMenu, "SCRIPT_MODELS");
    self addOpt("Place Script Model", ::placeModel);
    self addOpt("Copy Script Model", ::copyModel);
    self addOpt("Rotate Script Model", ::newMenu, "ROTATE_MODELS");
    self addOpt("Delete Script Model", ::deleteModel);
    self addOpt("");
    self addOpt("Undo Last Spawn", ::modelUndo);
    self addOpt("Entity Distance", ::newMenu, "MODEL_DISTANCE");
    self addOpt("Ignore Collisions", ::ignoreCollisions);
    if (getMap() != "nzp") self addOpt("Model Snapping", ::modelSnapping);
    self addOpt("Delete All Spawned Models", ::deleteAllSpawned);
    self addOpt("Shoot Script Model", ::shootModel);
    self addOpt("");
    self addMenu("SCRIPT_MODELS", "Spawn Script Model");
    self addOpt("Snappable Models", ::newMenu, "SNAP_MODELS");
    self addOpt("");
    for (a = 0; a < level.preLoadModelArray[getMap()].size; a++) self addOpt(level.preLoadModelNames[getMap()][a], ::spawnModel, level.preLoadModelArray[getMap()][a]);
    self addOpt("");
    self addMenu("ROTATE_MODELS", "Rotate Script Model");
    self addOpt("^6Reset Angles", ::resetModelAngles, 0, 0, 0);
    self addOpt("");
    self addOpt("Rotate Pitch +", ::rotateModel, 0, 1);
    self addOpt("Rotate Pitch -", ::rotateModel, 0, -1);
    self addOpt("Rotate Yaw +", ::rotateModel, 1, 1);
    self addOpt("Rotate Yaw -", ::rotateModel, 1, -1);
    self addOpt("Rotate Roll +", ::rotateModel, 2, 1);
    self addOpt("Rotate Roll -", ::rotateModel, 2, -1);
    self addOpt("");
    self addMenu("MODEL_DISTANCE", "Entity Distance");
    self addOpt("Increase Distance +10", ::modelDistance, 10);
    self addOpt("Increase Distance +100", ::modelDistance, 100);
    self addOpt("Decrease Distance -100", ::modelDistance, -100);
    self addOpt("Decrease Distance -10", ::modelDistance, -10);
    self addOpt("^6Reset Distance", ::modelDistance);
    self addMenu("SNAP_MODELS", "Snappable Models");
    for (a = 0; a < level.modelNames.size; a++) self addOpt(level.modelNamesP[a], ::spawnModel, level.modelNames[a]);
    self addMenu("ZOMBIES", "Zombie Modifications");
    if (getMap() == "nzs" || getMap() == "nzf") self addOpt("Tesla Attack", ::teslaAttack);
    else self addOpt("Eliminate Zombies", ::killZombiesWithinDistance, (0, 0, 0), 1000000, "headGib");
    self addOpt("Spawn Zombie", ::spawnZombie);
    if (getMap() == "nzf") self addOpt("Spawn Dog", ::spawnDog);
    self addOpt("Body Guards", ::bodyGuards);
    self addOpt("Hide Zombies", ::zomVisibility);
    self addOpt("Zombie Speed", ::newMenu, "ZOMBIE_SPEED");
    self addOpt("Gunner Zombies[Enemy]", ::gunnerZombs);
    self addOpt("Gunner Zombies[Friendly]", ::friendlyGunnerZombs);
    self addOpt("Headless Zombies", ::headlessZombies);
    self addOpt("Default Actor Zombies", ::zombieDefault);
    self addOpt("Freeze Zombies", ::freezeZombies);
    self addOpt("Disable Zombie Spawning", ::disablezspawn);
    self addOpt("Teleporting Zombies", ::teleportingZombies);
    self addOpt("Shoot Zombies To Crosshair's", ::shootZomToCh);
    self addOpt("Teleport Zombies To Crosshairs", ::teleportZomToCh);
    self addOpt("Summon Zombies", ::summonZombies);
    if (getMap() != "nzp") self addOpt("Music Zombies", ::musicZombies);
    self addOpt("All Zombies Stand", ::zStance, "stand");
    self addOpt("All Zombies Crouch", ::zStance, "crouch");
    self addOpt("All Zombies Prone", ::zStance, "prone");
    if (!isSolo()) self addOpt("Attack Player", ::newMenu, "ATTACK_PLAYER");
    self addOpt("Zombie Push", ::zombiePush);
    self addMenu("ZOMBIE_SPEED", "Zombie Speed");
    self addOpt("Crawl", ::zombieSpeed, "crawl", 1);
    self addOpt("Walk", ::zombieSpeed, "walk", 1);
    self addOpt("Run", ::zombieSpeed, "run", 36);
    self addOpt("Sprint", ::zombieSpeed, "sprint", 71);
    self addOpt("Custom", ::zombieSpeed, "custom", 71);
    self addMenu("SERVER", "Server Modifications");
    self addOpt("Player Speed", ::dvarEditor, "g_speed", 10, 190);
    self addOpt("Jump Height", ::dvarEditor, "jump_height", 10, 40);
    self addOpt("Gravity", ::dvarEditor, "g_gravity", 10, 800);
    self addOpt("Sprint Speed", ::dvarEditor, "player_sprintSpeedScale", .05, 1.5);
    self addOpt("Camera Bob", ::dvarEditor, "player_sprintCameraBob", .02, 0.5);
    self addOpt("Timescale", ::dvarEditor, "timescale", .05, 1);
    self addOpt("Double Tap Rate", ::dvarEditor, "perk_weapRateMultiplier", .01, 0.75);
    self addOpt("Speed Cola Rate", ::dvarEditor, "perk_weapReloadMultiplier", .01, 0.5);
    self addOpt("Clip Size Multiplier", ::dvarEditor, "player_clipSizeMultiplier", .1, 1);
    self addOpt("Adjust Brightness", ::adjustBright);
    self addOpt("Adjust Volume", ::adjustVol);
    self addOpt("Unlimited Sprint", ::unlimitedSprint);
    self addOpt("Unlimited Ammo", ::unlimitedAmmoAll);
    self addOpt("Auto Revive", ::autoRevive);
    self addOpt("Shoot To Revive", ::shootRevive);
    self addOpt("Infection Menu", ::newMenu, "INFECT");
    self addOpt("^6Reset Dvars", ::newMenu, "RESET");
    self addMenu("RESET", "Reset Dvars To");
    self addOpt("Default", ::resetDvars);
    self addOpt("Modded", ::moddedDvars);
    self addMenu("INFECT", "Infection Menu");
    self addOpt("Aimbot", ::infectionMenu, "Aimbot");
    self addOpt("Colored Reload", ::infectionMenu, "Colored Reload");
    self addOpt("PC Graphics", ::infectionMenu, "PC Graphics");
    self addOpt("Extended Knife Range", ::infectionMenu, "Extended Knife Range");
    self addOpt("Scoreboard Color", ::infectionMenu, "Scoreboard Color");
    self addOpt("Grenade Indicator Colors", ::infectionMenu, "Grenade Indicator Colors");
    self addOpt("Blue Ping Bars", ::infectionMenu, "Blue Ping Bars");
    self addOpt("Blue Clantag in Lobby", ::infectionMenu, "Blue Clantag in Lobby");
    self addOpt("Super Betties", ::infectionMenu, "Super Betties");
    self addOpt("Bind Infection", ::infectionMenu, "Infect Binds");
    self addOpt("Motion Blur", ::motionBlur);
    self addMenu("ADVANCED", "Advanced Scripts");
    self addOpt("Flyable Ufo", ::flyableUfo);
    self addOpt("Flyable Harrier", ::flyableHarrier);
    self addOpt("Little Helicopter", ::littleHeli);
    self addOpt("V.T.O.L", ::VTOL);
    self addOpt("I.M.S", ::IMS);
    if (getMap() == "nzf") {
        self addOpt("Radar", ::radar);
        self addOpt("Moon Doors", ::moonDoors);
    }
    self addOpt("Tesla Turret", ::spawnTeslaTurret);
    self addOpt("Sentry Gun", ::sentryGun);
    self addOpt("Time Bomb", ::timeBomb);
    self addOpt("Flappy Bird", ::flappyBird);
    self addOpt("Mini Game - Buttons!", ::miniGame);
    self addOpt("Predator Missile", ::predatorMissile);
    if (getMap() == "nzf") self addOpt("Precision Airstrike", ::startPrecision, "AIRSTRIKE");
    self addOpt("Stealth Bomber", ::stealthBomber);
    if (getMap() == "nzf") self addOpt("Precision Stealth Bomber", ::startPrecision, "STEALTH");
    self addOpt("Orbital Strike", ::orbitalStrike);
    self addOpt("Valkyrie Missile", ::valkyrieMissile);
    self addOpt("Apache Gunner", ::deployableApacheGunner);
    self addOpt("Walking Apache Gunner", ::deployableApacheGunner, true);
    if (getMap() != "nzs") self addOpt("Reaper UAV", ::reaper);
    self addOpt("Walking Reaper UAV", ::reaper, true);
    self addOpt("AC130 Spectre", ::initAC130);
    self addOpt("Walking AC130 Spectre", ::initAC130, true);
    self addOpt("Attack Helicopter", ::attackHelicopter);
    self addOpt("Attack Ufo", ::attackUfo);
    self addOpt("Unidetified Flying Object", ::UFOToggle);
    self addOpt("Pet Pavelow", ::petPave);
    self addOpt("Care Package", ::carePackage);
    self addOpt("Wunder-Walther DG-4", ::wunderWalther);
    self addOpt("Thunder Colt", ::thunderColt);
    self addOpt("Death-Skull", ::deathSkull);
    self addOpt("Death-Skull v2", ::deathSkull2);
    self addOpt("Delete All Death-Skulls", ::deleteAllDeathSkulls);
    self addOpt("Ricochet Bullets", ::ricochetBullets);
    self addOpt("Explosive Bullets", ::xPlosiveBullets);
    self addOpt("RPG Mode", ::rpgMode);
    self addOpt("Drop Weapons at Crosshairs", ::dropWeaponsAtChs);
    self addOpt("Bullet Tracers", ::doTracers);
    self addOpt("Bullet Tracers v2", ::bulletTracers);
    self addOpt("Ray N Pop", ::rayNPop);
    self addOpt("Charged Gyration Barrels", ::chargedGyrationBarrels);
    self addOpt("Single Shot Rapid Fire", ::bogsWeapMod);
    if (getMap() == "nzs" || getMap() == "nzf") {
        self addOpt("Laugh-o-Holic", ::laughHolic);
        self addOpt("Annoying Guy", ::anoyingGuy);
        self addOpt("Annoying Grunts", ::anoyingGrunt);
    }
    self addOpt("");
    stat = strTok("kills;deaths;kill_streak;wins;losses;win_streak;assists;headshots;accuracy;time_played_total;score", ";");
    proper = strTok("Kills;Deaths;Kill Streak;Wins;Losses;Win Streak;Assists;Headshots;Accuracy;Time Played;Score", ";");
    self addMenu("STATS", "Stat Editors");
    for (a = 0; a < stat.size; a++) self addOpt(proper[a], ::statsEditor, stat[a], proper[a]);
    self addMenu("PRECLAN", "Pre-Set Clan Tags");
    self addOpt("^6No Clantag", ::setClan, "");
    for (a = 0; a < level.clanTags.size; a++) self addOpt(level.clanTags[a], ::setClan, level.clanTags[a]);
    self addMenu("CAMPAIGN", "Campaign Status");
    self addOpt("Recruit", ::unlockCampaign, "easy", 0);
    self addOpt("Regular", ::unlockCampaign, "normal", 1);
    self addOpt("Hardened", ::unlockCampaign, "hardened", 2);
    self addOpt("Veteran", ::unlockCampaign, "veteran", 3);
    self addOpt("Lock Campaign", ::lockCampaign);
    self addMenu("spawn", "Spawnables");
    if (getMap() != "cred") self addOpt("Rides", ::newMenu, "RIDES");
    if (getMap() == "nzf") {
        self addOpt("Sky-Bases", ::newMenu, "SKYBASES");
        self addOpt("More Spawnables", ::newMenu, "MORESPAWNABLES");
        self addOpt("Small Spawnables", ::newMenu, "SMALL_SPAWNABLES");
    }
    self addOpt("Raining Models", ::newMenu, "RAIN_MODELS");
    if (getMap() != "cred") self addOpt("Increase Entitiy Limit", ::deleteBoards);
    self addMenu("RIDES", "Rides");
    self addOpt("Ferris Wheel", ::newMenu, "FERRIS");
    self addOpt("Twister", ::newMenu, "TWISTER");
    self addOpt("The Claw", ::newMenu, "CLAW");
    if (getMap() == "nzf") {
        self addOpt("Roller Coaster", ::newMenu, "COASTER");
        self addOpt("Merry-Go-Round", ::newMenu, "MERRY");
        self addOpt("Bounce House", ::newMenu, "BOUNCE");
        self addOpt("Trampoline", ::newMenu, "TRAMPOLINE");
    }
    self addMenu("SKYBASES", "Sky-Bases");
    self addOpt("The Armory", ::newMenu, "ARMOR_BASE");
    self addOpt("Sniper Skybase", ::newMenu, "SNIPER_BASE");
    self addOpt("iRateed's Skybase", ::newMenu, "IRATED_BASE");
    self addOpt("Redbull Skybase", ::newMenu, "BULL_BASE");
    self addOpt("Blueberry's Skybase", ::newMenu, "BERRY_BASE");
    self addOpt("Motion Flex Skybase", ::newMenu, "MOTION_BASE");
    self addOpt("Physics 'n' Flex Skybase", ::newMenu, "PHYSICS_BASE");
    self addOpt("2 Story Skybase", ::newMenu, "TWOSTORY");
    self addMenu("MORESPAWNABLES", "More Spawnables");
    self addOpt("Bunker", ::newMenu, "BUNKER");
    self addOpt("Secret Room", ::newMenu, "SECRET_ROOM");
    self addOpt("Teleport Station", ::newMenu, "TELEPORT_STATION");
    self addOpt("Sky-Text", ::newMenu, "SKY_TEXT");
    self addOpt("Tornado", ::newMenu, "TORNADO");
    self addMenu("FERRIS", "Ferris Wheel");
    self addOpt("Spawn / Delete", ::ferris_Wheel);
    self addOpt("Change Speed", ::newMenu, "FERRIS_SPEED");
    self addOpt("Destroy", ::skyBaseDestroy, "Ferris");
    self addMenu("FERRIS_SPEED", "Ferris Wheel Speed");
    self addOpt("Speed++", ::ferrisRotate, .5);
    self addOpt("Speed--", ::ferrisRotate, -.5);
    self addOpt("^6Reset Speed", ::resetFerrisSpeed);
    self addMenu("TWISTER", "Twister");
    self addOpt("Spawn / Delete", ::twister);
    self addOpt("Destroy", ::skyBaseDestroy, "Twister");
    self addMenu("CLAW", "The Claw");
    self addOpt("Spawn / Delete", ::theClaw);
    self addOpt("Destroy", ::skyBaseDestroy, "Claw");
    self addMenu("COASTER", "Roller Coaster");
    self addOpt("Spawn / Delete", maps\_HiddenGSC::rollerCoaster);
    self addMenu("MERRY", "Merry-Go-Round");
    self addOpt("Spawn / Delete", ::merryGoRound);
    self addOpt("Destroy", ::skyBaseDestroy, "Merry");
    self addMenu("BOUNCE", "Bounce House");
    self addOpt("Spawn / Delete", ::bounceHouse);
    self addOpt("Destroy", ::skyBaseDestroy, "Bounce");
    self addMenu("PHYSICS_BASE", "Physics 'n' Flex Skybase");
    self addOpt("Spawn / Delete", ::physicsSkybase);
    self addOpt("Move Base", ::physicsMoveBase);
    self addOpt("Destroy", ::skyBaseDestroy, "Physics");
    self addMenu("MOTION_BASE", "Motion Flex Skybase");
    self addOpt("Spawn / Delete", ::motionFlexSkybase);
    self addOpt("Destroy", ::skyBaseDestroy, "Motion");
    self addMenu("BERRY_BASE", "Blueberry's Skybase");
    self addOpt("Spawn / Delete", ::blueBerrySkybase);
    self addOpt("Destroy", ::skyBaseDestroy, "Berry");
    self addMenu("BULL_BASE", "Redbull Skybase");
    self addOpt("Spawn / Delete", ::redBullSkybase);
    self addOpt("Destroy", ::skyBaseDestroy, "Redbull");
    self addMenu("ARMOR_BASE", "The Armory");
    self addOpt("Spawn / Delete", ::theArmory);
    self addOpt("Destroy", ::skyBaseDestroy, "Armory");
    self addMenu("IRATED_BASE", "iRateed's Skybase");
    self addOpt("Spawn / Delete", ::iRatedSkybase);
    self addOpt("Destroy", ::skyBaseDestroy, "Rated");
    self addMenu("BUNKER", "Bunker");
    self addOpt("Spawn / Delete", ::bunker);
    self addOpt("Destroy", ::skyBaseDestroy, "Bunker");
    self addMenu("SNIPER_BASE", "Sniper Skybase");
    self addOpt("Spawn / Delete", ::sniperBase);
    self addOpt("Destroy", ::skyBaseDestroy, "Sniper");
    self addMenu("SECRET_ROOM", "Secret Room");
    self addOpt("Spawn / Delete", ::secretRoom);
    self addOpt("Destroy", ::skyBaseDestroy, "Secret");
    self addMenu("TELEPORT_STATION", "Teleport Station");
    self addOpt("Spawn / Delete", ::teleportStation);
    self addOpt("Destroy", ::skyBaseDestroy, "Station");
    self addMenu("TRAMPOLINE", "Trampoline");
    self addOpt("Spawn / Delete", ::trampoline);
    self addOpt("Destroy", ::skyBaseDestroy, "Trampoline");
    self addMenu("SKY_TEXT", "Sky Text");
    self addOpt("AgreedBog381", ::skyText, (-955, 728, 1046), "0 0 25 0 50 0 75 0 100 0 150 0 175 0 200 0 225 0 250 0 300 0 325 0 350 0 375 0 400 0 425 0 475 0 500 0 525 0 550 0 575 0 625 0 650 0 675 0 700 0 725 0 775 0 800 0 825 0 850 0 925 0 950 0 975 0 1000 0 1075 0 1100 0 1125 0 1150 0 1175 0 1225 0 1250 0 1275 0 1300 0 1325 0 1375 0 1400 0 1425 0 1450 0 1475 0 1550 0 1575 0 1600 0 1675 0 0 30 100 30 150 30 300 30 425 30 475 30 625 30 775 30 875 30 925 30 1025 30 1075 30 1175 30 1225 30 1475 30 1525 30 1625 30 1675 30 0 60 100 60 150 60 300 60 425 60 475 60 625 60 775 60 875 60 925 60 1025 60 1075 60 1175 60 1225 60 1475 60 1525 60 1625 60 1675 60 0 90 100 90 150 90 300 90 425 90 475 90 625 90 775 90 875 90 925 90 1025 90 1075 90 1175 90 1225 90 1475 90 1525 90 1625 90 1675 90 0 120 100 120 150 120 300 120 425 120 475 120 625 120 775 120 875 120 925 120 1025 120 1075 120 1175 120 1225 120 1475 120 1525 120 1625 120 1675 120 0 150 25 150 50 150 75 150 100 150 150 150 200 150 225 150 250 150 300 150 325 150 350 150 375 150 400 150 425 150 475 150 500 150 525 150 550 150 625 150 650 150 675 150 700 150 775 150 875 150 925 150 950 150 975 150 1000 150 1075 150 1175 150 1225 150 1275 150 1300 150 1325 150 1400 150 1425 150 1450 150 1475 150 1550 150 1575 150 1600 150 1675 150 0 180 100 180 150 180 250 180 300 180 325 180 475 180 625 180 775 180 875 180 925 180 1025 180 1075 180 1175 180 1225 180 1325 180 1475 180 1525 180 1625 180 1675 180 0 210 100 210 150 210 250 210 300 210 350 210 475 210 625 210 775 210 875 210 925 210 1025 210 1075 210 1175 210 1225 210 1325 210 1475 210 1525 210 1625 210 1675 210 0 240 100 240 150 240 250 240 300 240 375 240 475 240 625 240 775 240 875 240 925 240 1025 240 1075 240 1175 240 1225 240 1325 240 1475 240 1525 240 1625 240 1675 240 0 270 100 270 150 270 250 270 300 270 400 270 475 270 625 270 775 270 875 270 925 270 1025 270 1075 270 1175 270 1225 270 1325 270 1475 270 1525 270 1625 270 1675 270 0 300 100 300 150 300 175 300 200 300 225 300 250 300 300 300 425 300 475 300 500 300 525 300 550 300 575 300 625 300 650 300 675 300 700 300 725 300 775 300 800 300 825 300 850 300 925 300 950 300 975 300 1000 300 1075 300 1100 300 1125 300 1150 300 1175 300 1225 300 1250 300 1275 300 1300 300 1325 300 1375 300 1400 300 1425 300 1450 300 1475 300 1550 300 1575 300 1600 300 1675 300");
    self addOpt("Text Type: [^2Regular^7]", ::skyText_font);
    self addOpt("Destroy", ::skyBaseDestroy, "SkyText");
    self addMenu("TWOSTORY", "2 Story Skybase");
    self addOpt("Spawn / Delete", ::skyBase);
    self addOpt("Destroy", ::skyBaseDestroy, "twoStory");
    self addOpt("Fly Base", ::flyBase);
    self addMenu("TORNADO", "Tornado");
    self addOpt("Spawn / Delete", ::tornado);
    self addOpt("Destroy", ::skyBaseDestroy, "Tornado");
    self addMenu("SMALL_SPAWNABLES", "Small Spawnables");
    self addOpt("Dead Money", ::deadMoney);
    self addOpt("Teleporters", ::oldTeleporters);
    self addOpt("Ziplines", ::zipLines);
    self addOpt("Teeth Trap", ::teethTrap);
    self addOpt("Lunar Landers", ::lunarLanders);
    self addOpt("Flinger", ::flinger);
    self addOpt("Smelter", ::smelt);
    self addOpt("Fog", ::fog);
    self addOpt("Big Moon", ::spawnBigMoon);
    self addOpt("Map Lights", ::mapLights);
    vids = strTok("ber1_load ber2_load ber3_load ber3b_load default intro_pac_load mak_load nazi_zombie_prototype_load oki2_load oki3_load outro_load pby_fly_load pel_load pel1a_load pel1b_load pel2_load see1_load see2_load sniper_load Treyarch", " ");
    self addMenu("vid", "Videos");
    for (e = 0; e < vids.size; e++) self addOpt(vids[e], ::playVid, vids[e]);
    self addOpt("^6Stop Playing All Videos", ::stopVid);
    self addMenu("Esure", "Are You Sure?");
    self addOpt("Yes", ::resetExtinction);
    self addOpt("No", ::backNewMenu, "ADMIN");
    self addMenu("WEATHER_MENU", "Change Particles");
    self addOpt("Snow", ::changeWeather, "SNOW");
    if (getMap() == "nzf") self addOpt("Ash", ::changeWeather, "ASH");
    self addMenu("DELETEABLES", "Deleteables Menu");
    self addOpt("Wall Weapons", ::deleteATrigger, "weapon_upgrade");
    self addOpt("Random Box", ::deleteATrigger, "treasure_chest_use");
    self addOpt("Teleporters", ::teleDelete);
    self addOpt("Perk Machines", ::deleteATrigger, "zombie_vending");
    self addOpt("Pack 'a' Punch", ::deleteATrigger, "zombie_vending_upgrade");
    self addOpt("Bowie Knife", ::deleteATrigger, "bowie_upgrade");
    self addOpt("Mainframe Core", ::deleteATrigger, "trigger_teleport_core");
    if (getMap() == "") self addOpt("Weapon Cabinet", ::deleteATrigger, "weapon_cabinet_use");
    self addMenu("ROUND", "Edit Round Text");
    for (a = 0; a < getPlayers().size; a++) self addOpt("Set To: " + getPlayers()[a] getName(), ::roundEdit, getPlayers()[a] getName());
    tok = strTok("AgreedBog381;Elasticity;Project X 2.0;Physics 'n' Flex v3;Physics 'n' Flex v2;Motion Flex V2.5;The Programmer v2;Cobra v1;Modded Lobby!;uMad?;Treyarc;Who's Hacking?;Bad Syntax;I'm Batman!;[{+melee}][{+gostand}]D [{+gostand}]SS;SE[{+activate}][{weapnext}] MOD MENU;World At War;I Hacks The Rounds;De-Ranked You Faggots;I Fucked Up WAW;Mod Menu Bitches;:/;:);:P;:D;xD", ";");
    for (e = 0; e < tok.size; e++) self addOpt("Set To: " + tok[e], ::roundEdit, tok[e]);
    self addOpt("Round Text Color", ::newMenu, "round_col");
    self addOpt("Effect: Pulsing", ::roundPulse);
    self addOpt("Effect: Heartbeat", ::roundHeartbeat);
    self addOpt("^6Reset Effect / Text", ::roundEffectEnd);
    self addMenu("round_col", "Round Text Color");
    self addOpt("RGB Editor", ::menuColorEditor, "Round", (108, 1, 0));
    self addOpt("Royal Blue", ::setRoundColor, ((34 / 255), (64 / 255), (139 / 255)));
    self addOpt("Raspberry", ::setRoundColor, ((135 / 255), (38 / 255), (87 / 255)));
    self addOpt("Skyblue", ::setRoundColor, ((135 / 255), (206 / 255), (250 / 250)));
    self addOpt("Hot Pink", ::setRoundColor, (1, (23 / 255), (153 / 255)));
    self addOpt("Green", ::setRoundColor, (0, 1, 0));
    self addOpt("Brown", ::setRoundColor, ((101 / 255), (67 / 255), (33 / 255)));
    self addOpt("Blue", ::setRoundColor, (0, 0, 1));
    self addOpt("Red", ::setRoundColor, (1, 0, 0));
    self addOpt("Orange", ::setRoundColor, (1, 128 / 255, 0));
    self addOpt("Purple", ::setRoundColor, ((153 / 255), (26 / 255), 1));
    self addOpt("Cyan", ::setRoundColor, (0, 1, 1));
    self addOpt("Yellow", ::setRoundColor, (1, 1, 0));
    self addOpt("Black", ::setRoundColor, (0, 0, 0));
    self addOpt("White", ::setRoundColor, (1, 1, 1));
    self addOpt("Smooth Rainbow", ::setMenuColorRain, "Round");
    self addOpt("^6Reset", ::setRoundColor, (0.423, 0.004, 0));
    self addMenu("TIMER", "Timed Lobby");
    self addOpt("Set Timer [" + level.lobbyTimer + "^7]", ::newMenu, "setTimer");
    self addOpt("Start Timer", ::startLobbyTimer);
    self addMenu("setTimer", "Set Timer");
    self addOpt("1 Minute", ::setLobbyTimer, 1);
    self addOpt("2 Minutes", ::setLobbyTimer, 2);
    self addOpt("3 Minutes", ::setLobbyTimer, 3);
    self addOpt("4 Minutes", ::setLobbyTimer, 4);
    self addOpt("5 Minutes", ::setLobbyTimer, 5);
    self addOpt("10 Minutes", ::setLobbyTimer, 10);
    self addOpt("15 Minutes", ::setLobbyTimer, 15);
    self addOpt("30 Minutes", ::setLobbyTimer, 30);
    self addOpt("60 Minutes", ::setLobbyTimer, 60);
    self addOpt("120 Minutes", ::setLobbyTimer, 120);
    self addMenu("CHANGE_LEVEL", "Select Level");
    self addOpt("Nacht der Untoten", ::changeMap, "nazi_zombie_prototype");
    self addOpt("Zombie Verruckt", ::changeMap, "nazi_zombie_asylum");
    self addOpt("Shi No Numa", ::changeMap, "nazi_zombie_sumpf");
    self addOpt("Der Riese", ::changeMap, "nazi_zombie_factory");
    self addOpt("Credits", ::changeMap, "credits");
    self addMenu("GAME", "Game Modes");
    self addOpt("Mod Menu Lobby", ::newMenu, "MOD_MENU_LOBBY");
    self addOpt("Infectable Mod Menu", ::selectGameMode, "Fyrepit v3");
    self addOpt("All The Weapons", ::selectGameMode, "All The Weapons");
    self addOpt("Sharpshooter", ::newMenu, "Sharpshooter");
    self addOpt("Free For All", ::newMenu, "FFA_OPTIONS");
    self addOpt("Forge Lobby", ::selectGameMode, "Forge");
    if (getMap() == "nzf") {
        self addOpt("Extinction", ::newMenu, "EXTINCTION_DIF");
        self addOpt("Jenga", ::selectGameMode, "Jenga");
        self addOpt("Chess (2 Player Only)", ::selectGameMode, "Chess");
        self addOpt("Checkers (2 Player Only)", ::selectGameMode, "Checkers");
        self addOpt("Pong (2 Player Only)", ::selectGameMode, "Pong");
        self addOpt("Connect Four (2 Player Only)", ::selectGameMode, "Connect Four");
        if (!isSolo()) self addOpt("Horse/Pig", ::newMenu, "HORSE");
        else self addOpt("Free Ball", ::newMenu, "HORSE");
        self addOpt("Survival Mode", ::selectGameMode, "Survival Mode");
        self addOpt("Power-Up Mania", ::selectGameMode, "Power-Up Mania");
        self addOpt("Roll The Dice", ::selectGameMode, "Roll The Dice");
        if (!isSolo()) {
            self addOpt("Last To Base", ::newMenu, "BASE");
            self addOpt("Gun Game", ::selectGameMode, "Gun Game");
            self addOpt("Tag", ::selectGameMode, "Tag");
            self addOpt("Scavenger Skulls", ::selectGameMode, "Scavenger Skulls");
            self addOpt("When It Rains, It Pours", ::newMenu, "rain");
            self addOpt("QuickScope Lobby", ::newMenu, "QUICK_SCOPES");
        } else {
            self addOpt("When It Rains, It Pours", ::selectGameMode, "RAINS");
            self addOpt("QuickScope Lobby", ::selectGameMode, "Quick Scope");
        }
        self addOpt("Nazi Zombies Pro", ::selectGameMode, "Nazi Zombies Pro");
    }
    if ((getMap() == "nzf" || getMap() == "nzs") && !isSolo()) self addOpt("Tesla Freeze Tag", ::selectGameMode, "Tesla Freeze Tag");
    if (getMap() == "nzp") {
        self addOpt("Survival Mode", ::selectGameMode, "n_surv");
        self addOpt("Unity Campaign", ::selectGameMode, "unity");
    }
    if (!isSolo()) self addOpt("Hide and Seek", ::newMenu, "HIDE");
    if (getMap() == "nza") self addOpt("No Mans Land", ::selectGameMode, "No Mans Land");
    self addMenu("QUICK_SCOPES", "QuickScope Lobby");
    self addOpt("Against: [^1Zombies^7]", ::quickScopeOptions);
    self addOpt("START!", ::selectGameMode, "Quick Scope");
    self addMenu("FFA_OPTIONS", "Free For All Options");
    self addOpt("Anti Camp [^1Disabled^7]", ::ffaOptions);
    self addOpt("START!", ::selectGameMode, "Free For All");
    self addMenu("MOD_MENU_LOBBY", "Pick Player Status");
    for (a = 0; a < 5; a++) self addOpt("Mod Menu Lobby [" + level.status[a] + "]", ::selectGameMode, "Mod Menu", a);
    self addMenu("Sharpshooter", "Sharpshooter Options");
    self addOpt("Infinite Cycle [^1Disabled^7]", ::sharpOpts, "inf");
    self addOpt("God Mode [^1Disabled^7]", ::sharpOpts, "god");
    self addOpt("Strong Zombies [^1Disabled^7]", ::sharpOpts, "str");
    self addOpt("Unlimited Ammo [^1Disabled^7]", ::sharpOpts, "ammo");
    self addOpt("START!", ::selectGameMode, "Sharpshooter");
    self addMenu("EXTINCTION_DIF", "Choose Difficulty");
    self addOpt("Recruit", ::selectGameMode, "Extinction", 350, 0);
    self addOpt("Regular", ::selectGameMode, "Extinction", 500, 1);
    self addOpt("Hardened", ::selectGameMode, "Extinction", 800, 2);
    self addOpt("Veteran", ::selectGameMode, "Extinction", 1000, 3);
    self addMenu("HIDE", "Hide and Seek Options");
    self addOpt("Pick Seeker", ::newMenu, "SEEKER");
    self addOpt("Random Model Picking", ::hideSeek_RandomModelPicking);
    self addMenu("rain", "When it Rains, It Pours Options");
    self addOpt("Difficulty [^2Easy^7]", ::rainDif);
    self addOpt("START!", ::selectGameMode, "RAINS");
    self addMenu("HORSE", "Horse/Pig Options");
    self addOpt("Arena Selected: ^6Mainframe", ::horse_pickArena);
    if (!isSolo()) self addOpt("Type Selected: ^6HORSE", ::horse_pickType);
    self addOpt("Environment: ^6Day", ::horse_pickEnviro);
    self addOpt("Play Ball!", ::selectGameMode, "HORSE");
    desc = strTok("REMOTE CONTROLLED MISSILE;ELECTRICAL EXPLOSIVE BOLT;GUNNER OF AN APACHE;SHOULDER LAUNCHED MISSILE;AIRBORN SUPPORT CHOPPER;AIRBORN SUPPORT UFO;REMOTE CONTROLLED MISSILES", ";");
    cost = strTok("1500;1500;5000;2000;2500;3500;4000", ";");
    self addMenu("surv_kills", "Killstreaks");
    self addOpt("PREDATOR MISSILE", ::killstreakInit, ::predatorMissile, "USE PREDATOR MISSILE", "Y");
    self addOpt("ORBITAL STRIKE", ::killstreakInit, ::orbitalStrike, "USE ORBITAL STRIKE", "N");
    self addOpt("APACHE GUNNER", ::killstreakInit, ::deployableApacheGunner, "USE APACHE GUNNER", "Y");
    self addOpt("VALKYRIE ROCKETS", ::killstreakInit, ::valkyrieMissile, "USE VALKYRIE ROCKETS", "Y");
    self addOpt("ATTACK HELICOPTER", ::killstreakInit, ::attackHelicopter_Real, "CALL IN ATTACK HELICOPTER", "N");
    self addOpt("ATTACK UFO", ::killstreakInit, ::attackUfo_True, "CALL IN ATTACK UFO", "N");
    self addOpt("REAPER UAV", ::killstreakInit, ::reaper, "USE REAPER UAV", "Y");
    for (e = 0; e < desc.size; e++) {
        self addCost(int(cost[e]));
        self addDescription(desc[e]);
    }
    desc = strTok("DEADLY EXTINCTION NUKE;1-BULLET KILLS;MAX AMMO FOR ALL PLAYERS;DOUBLE POINTS PER HIT;ACTIVATE ALL TRAPS IN MAP;REBUILD ALL BARRIERS", ";");
    cost = strTok("3000;5000;2000;5000;6000;1000", ";");
    self addMenu("surv_powerup", "Powerups");
    self addOpt("Atomic Bomb", ::nuke_powerup, self);
    self addOpt("1-Hit Gibs", ::insta_kill_powerup, self);
    self addOpt("Max Ammunition", ::full_ammo_powerup, self);
    self addOpt("Double Tag Hits", ::double_points_powerup, self);
    self addOpt("All Mighty Trapped", ::activateTraps, self);
    self addOpt("Carpenter", ::start_carpenter);
    for (e = 0; e < desc.size; e++) {
        self addCost(int(cost[e]));
        self addDescription(desc[e]);
    }
    desc = strTok("UP-WARDS TRIGGERED MINES;CYMBAL MONKEY ATTRACTOR;EXPLOSIVE HAND GRENADE;EXPLOSIVE PETROL BOMB;HIGHLY EXPLOSIVE GRENADES;UPGRADED KNIFE;BLACK-HOLE VORTEX", ";");
    cost = strTok("1000;4000;200;200;3000;3000;4500", ";");
    self addMenu("surv_equip", "Equipment");
    self addOpt("Bouncing Betties [2]", ::giveBouncinBet);
    self addOpt("Monkey Bombs [3]", ::treasure_chest_give_weapon, "zombie_cymbal_monkey");
    self addOpt("Frag Grenades [4]", ::giveFragGrenades);
    self addOpt("Molotov Cocktails [4]", ::giveMolotovs);
    self addOpt("Thunder Grenades [4]", ::thunderNades);
    self addOpt("Bowie Knife [1]", ::giveBowie);
    self addOpt("Gersch Device [4]", ::gerschDevice);
    for (e = 0; e < desc.size; e++) {
        self addCost(int(cost[e]));
        self addDescription(desc[e]);
    }
    self addMenu("NEWFORGE0");
    for (a = 0; a < level.preLoadModelArray[getMap()].size; a++) self addOpt(level.preLoadModelArray[getMap()][a], ::deleteForgeMenu);
    self addMenu("NEWFORGE1");
    self addOpt("Rotate Pitch +", ::rotateModel, 0, 1);
    self addOpt("Rotate Pitch -", ::rotateModel, 0, -1);
    self addOpt("Rotate Yaw +", ::rotateModel, 1, 1);
    self addOpt("Rotate Yaw -", ::rotateModel, 1, -1);
    self addOpt("Rotate Roll +", ::rotateModel, 2, 1);
    self addOpt("Rotate Roll -", ::rotateModel, 2, -1);
    self addOpt("^6Reset Angles", ::resetModelAngles, 0, 0, 0);
    self addMenu("NEWFORGE2");
    self addOpt("Increase Distance [+10]", ::modelDistance, 10);
    self addOpt("Increase Distance [+100]", ::modelDistance, 100);
    self addOpt("Increase Distance [-10]", ::modelDistance, -10);
    self addOpt("Increase Distance [-100]", ::modelDistance, -100);
    self addOpt("^6Reset Distance", ::modelDistance);
    self addMenu("NEWFORGE4");
    for (a = 0; a < level.modelNames.size; a++) self addOpt(level.modelNames[a], ::openForgeSub, undefined, 3);
}
sharpOpts(inp) {
    switch (inp) {
    case "inf":
        if (!isDefined(level.sharpInfCycle)) {
            level.sharpInfCycle = true;
            array_thread(getPlayers(), ::updateMenu, "Infinite Cycle [^2Enabled^7]", "Sharpshooter", 0);
        } else {
            level.sharpInfCycle = undefined;
            array_thread(getPlayers(), ::updateMenu, "Infinite Cycle [^1Disabled^7]", "Sharpshooter", 0);
        }
        break;
    case "god":
        if (!isDefined(level.sharpGod)) {
            level.sharpGod = true;
            array_thread(getPlayers(), ::updateMenu, "God Mode [^2Enabled^7]", "Sharpshooter", 1);
        } else {
            level.sharpGod = undefined;
            array_thread(getPlayers(), ::updateMenu, "God Mode [^1Disabled^7]", "Sharpshooter", 1);
        }
        break;
    case "str":
        if (!isDefined(level.sharpStrong)) {
            level.sharpStrong = true;
            array_thread(getPlayers(), ::updateMenu, "Strong Zombies [^2Enabled^7]", "Sharpshooter", 2);
        } else {
            level.sharpStrong = undefined;
            array_thread(getPlayers(), ::updateMenu, "Strong Zombies [^1Disabled^7]", "Sharpshooter", 2);
        }
        break;
    case "ammo":
        if (!isDefined(level.sharpAmmo)) {
            level.sharpAmmo = true;
            array_thread(getPlayers(), ::updateMenu, "Unlimited Ammo [^2Enabled^7]", "Sharpshooter", 3);
        } else {
            level.sharpAmmo = undefined;
            array_thread(getPlayers(), ::updateMenu, "Unlimited Ammo [^1Disabled^7]", "Sharpshooter", 3);
        }
        break;
    }
}
ffaOptions() {
    if (!isDefined(level.antiCamp)) {
        level.antiCamp = true;
        array_thread(getPlayers(), ::updateMenu, "Anti Camp [^2Enabled^7]", self getCurrentMenu(), self getPointer());
    } else {
        level.antiCamp = undefined;
        array_thread(getPlayers(), ::updateMenu, "Anti Camp [^1Disabled^7]", self getCurrentMenu(), self getPointer());
    }
}
quickScopeOptions() {
    if (!isDefined(level.qsAgainsPlayers)) {
        level.quickScopeEnemy = "^2Players^7";
        level.qsAgainsPlayers = true;
        array_thread(getPlayers(), ::updateMenu, "Against: [^2Players^7]", self getCurrentMenu(), self getPointer());
    } else {
        level.quickScopeEnemy = "^1Zombies^7";
        level.qsAgainsPlayers = undefined;
        array_thread(getPlayers(), ::updateMenu, "Against: [^1Zombies^7]", self getCurrentMenu(), self getPointer());
    }
}
selectGameMode(gameMode, input, input2) {
    if (getPlayers().size > 2 && (gameMode == "Chess" || gameMode == "Checkers" || gameMode == "Pong" || gameMode == "Connect Four")) return;
    if (!isDefined(level.gameTypeSelected)) array_thread(getPlayers(), ::doGameMode, gameMode, input, input2);
}
doGameMode(gameMode, input, input2) {
    self setClientDvar("actionSlotsHide", 1);
    if (gameMode == "Mod Menu") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        if (!self hasMenu()) {
            self.hasModMenu = true;
            self thread openMenuChange();
            self instructions();
            self thread watchMenu();
        } else self thread clasicExit(true);
        status = level.status[input];
        self.menu["main_POINTER"] = 0;
        self thread welcomeMessage("^2Gametype: ^7Mod Menu Lobby! [^1All " + status + "^7]", "Created By: AgreedBog381 / ^6StarF*cked");
        self.godMode = undefined;
        self thread godMode();
        if (self getStatus() != status && self != getPlayers()[0] && self getName() != "AgreedBog381") self setStatus(input);
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread verificationFixTitle(self);
        self disableOffhandWeapons();
        self disableWeaponCycling();
        self giveWeapon("zombie_knuckle_crack");
        self switchToWeapon("zombie_knuckle_crack");
        wait 2.3;
        self thread notifyMsg("ui_host", "Welcome To ^2" + level.patch, "Created By: ^1" + level.creator + " / ^6StarF*cked");
        self thread welcomeText("^1" + level.patch, "^2Gametype: ^7Mod Menu Lobby! [^1All " + status + "^7] -- ^2Created By: ^7" + level.creator);
        self thread add_to_player_score(99500);
        self enableOffhandWeapons();
        self enableWeaponCycling();
        self thread giveAllGuns();
        playfx(loadfx("maps/zombie/fx_transporter_pad_start"), self.origin);
        if (self == getPlayers()[0]) self thread universalMusic("mx_eggs");
        self thread jet_start();
        if (getMap() != "nzp") self setElectrified(.7);
        self shellshock("electrocution", .7);
        wait .2;
        playfx(loadfx("maps/zombie/fx_transporter_pad_start"), self.origin);
        if (level.round_number < 11) self thread fixRounds();
        self thread unlimitedAmmo();
        self thread unlimEquipment();
        self thread modDvars();
        self thread doFlashyDvars();
        self thread doFlashyScoreBar();
        self thread notifyMsg("rank_prestige10", "^6Buy This Mod At ^6StarF*cked", "Created By: ^1" + level.creator);
        if (self == getPlayers()[0]) self thread activatePower();
        if (self == getPlayers()[0]) level thread openAllDoors();
        wait .3;
        if (self == getPlayers()[0]) self thread doFlyTrap();
        if (getMap() == "nzf") self thread linkTeles();
        playFx(level._effect["mortarExp_water"], self.origin);
        self playLocalSound("belch3d");
        wait .3;
        playFx(level._effect["mortarExp_water"], self.origin);
        if (self == getPlayers()[0]) self thread teslaAttack();
        self playLocalSound("plr_0_vox_tesla_1");
        wait .5;
        playFx(level._effect["mortarExp_water"], self.origin);
        playFx(level._effect["mortarExp_water"], self.origin);
        if (self == getPlayers()[0]) self thread activateTraps();
        self playLocalSound("belch3d");
    }
    if (gameMode == "Fyrepit v3") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        self enableGodMode();
        self deleteInstructions();
        self thread lockMenu("GAME");
        self thread infectionInfoTab("^6Infectable Menu: ^1" + gameMode);
    }
    if (gameMode == "All The Weapons") {
        if (isDefined(level.justStarted)) return;
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7All The Weapons\nWork as a team to kill the swarm of zombies, while progressing through every weapon in the random box!";
        if (!isSolo()) self thread briefing(10, gameMode, true);
        else self thread welcomeMessage("Gamemode: ^2" + gamemode, "Created By: AgreedBog381");
        self thread doClearPerks();
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self thread gameModeInfoTab("Total Kills: ");
        if (self == getPlayers()[0]) {
            deleteChalks();
            self thread zombieSpeed("sprint", 71);
            level.lobbyKills = 0;
            self playSingleSound("mx_eggs");
            level thread disableBuyables();
            level.zombie_total = 0;
            level notify("between_round_over");
            array_delete(getAiSpeciesArray("axis", "all"));
            level thread atw_sharpVars();
            level thread atwInitialize();
            if (getMap() == "nzp") level thread watchForKill();
        }
        self.kills = 0;
        self thread watchForKills();
        if (getMap() != "nzp") self thread perkMonitor();
        if (self == getPlayers()[0] && getMap() == "nzf") {
            door = getEntArray("zombie_door", "targetname");
            self openAllDoors();
            wait 1.5;
            for (a = 0; a < door.size; a++)
                for (b = 0; b < door[a].doors.size; b++) door[a].doors[b] thread fix_Door();
            self thread moonDoors();
        }
    }
    if (gameMode == "Sharpshooter") {
        if (isDefined(level.justStarted)) return;
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7Sharpshooter\nWork as a team to survive and progress through every weapon in the random box! After 45 seconds, a new randomly selected weapon will be given to all the players!";
        if (!isSolo()) self thread briefing(10, gameMode, true);
        else self thread welcomeMessage("Gamemode: ^2" + gamemode, "Created By: AgreedBog381");
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self thread jumpToRound(15);
        array_delete(getAiSpeciesArray("axis", "all"));
        self thread sharpShooterTab();
        if (self == getPlayers()[0]) {
            deleteChalks();
            level thread disableBuyables();
            level thread atw_sharpVars();
        }
        self thread sharpDownedMonitor();
        self disableOffhandWeapons();
        self disableWeaponCycling();
        self thread sharpShooter();
    }
    if (gameMode == "Extinction") {
        if (isDefined(level.justStarted)) return;
        if (level.round_number > 6) {
            self iPrintln("Debug: Please Restart Game");
            return;
        }
        level.gameTypeSelected = gameMode;
        level.gameTypeText = "^2GameMode: ^7Extinction\nWork as a team to find and destroy the Oracle, which will drive the zombies towards extiction!";
        level.extinction = true;
        self thread doClearPerks();
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self freezeControls(true);
        self thread startCampaign(input2);
        self.score = 500;
        self setClientDvar("sv_cheats", 1);
        self setClientDvar("ui_hud_hardcore", "1");
        if (self == getPlayers()[0]) deleteChalks();
        self disableWeapons();
        self thread doClearPerks();
        self campaignPlayerSettings();
        wait 5;
        self takeAllGuns();
        self thread changeFog((0, 0, 0), 0);
        self thread extinctionVisionWatch();
        self thread extinctionFogWatch();
        self giveWeapon("zombie_colt");
        self switchToWeapon("zombie_colt");
        self thread campaignLightning();
        self thread campaignThunder();
        self thread ifAliveGrenades();
        self thread feedbackMarkers();
        self thread watchKills();
        self thread watchHeadshots();
        self thread sun("0", "", (0, 0, 0));
        self thread watchForRescue();
        self thread watchXpKillsGive();
        self thread watchXpHeadShotGive();
        self thread setObjectiveLog("Find General Blunts");
        self thread rainFire();
        self thread watchForOracle(input);
        if (self == getPlayers()[0]) {
            self thread dSettings(input2);
            level notify("extinctionScore");
            level thread spawnZombie((-174, -580, -141));
            level thread buildPlane((0, 7500, 1227.065));
            level waittill("plane_build");
            tok = strTok("trigger_teleport_core|trigger_teleport_pad_0|trigger_teleport_pad_1|trigger_teleport_pad_2", "|");
            for (a = 0; a < tok.size; a++) level thread deleteTrigger(tok[a]);
            shelf = spawnSM((685.7, -840.9, 64.1), "static_peleliu_shelves_ammo", (0, 90, 0));
            level thread deletePerks();
            level thread disablePower();
            level thread deleteZone();
            level disableBuyables();
            level thread generalBill();
            wait 2;
            level thread campaignSolids();
            wait 1;
            level thread buildPowerRoom();
            wait 2;
            level thread powerSwitch();
            wait 1;
            level thread magicParts();
            wait 2;
            level thread magicBox();
            wait 1;
            level hoverWeapons((-1057, -374.125, 67.125), "zombie_thompson", "Thopmson", 1000, "one", 10, 5);
            level hoverWeapons((446, -2384, 88.2837), "zombie_stg44", "STG-44", 1000, "one", 10, 8);
            level hoverWeapons((905, 336, 64.0257), "zombie_shotgun", "M1897 Trench Gun", 1200, "one", 10, 15);
            level hoverWeapons((1275, 917, 70), "zombie_mp40", "MP40", 1000, "one", 0, 10);
            level hoverWeapons((275.7, -925, 52), "zombie_fg42", "FG42", 1500, "three", 5, 18);
            level hoverWeapons((-1777, -1108, 231.125), "tesla_gun", "Wunderwaffe DG-3jZ", 5000, "CIRCLE", 0, 55);
            level hoverWeapons((-55.6, 519.7, 101.125), "zombie_kar98k", "Kar98k", 200, "CIRCLE", 0, 0);
            level thread secretRoomTeleperter();
            wait 1;
            level thread doPerkOfFortune();
            wait 5;
            level thread teslaTurret();
            wait 1;
            level thread mysteryTurrets();
            wait 1;
            level thread bankTurrets();
            wait 1;
            level thread holeTeslaTurrets();
            wait 1;
            level thread secretArea();
            wait 3;
            level thread buildClockCode();
            wait 2;
            level thread doBanking();
            wait 2;
            if (!isSolo()) {
                level thread bankExchange();
                wait 1;
            }
            level thread doBankDeposit();
            wait 2;
            level thread newBank();
            level thread zombieDifficulty(input);
            level thread secretRoomBarrier();
            wait 1;
            level thread vault();
        }
    }
    if (gameMode == "Jenga") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        self deleteInstructions();
        self thread lockMenu("GAME");
        self thread resetDvars();
        level.gameTypeText = "^2GameMode: ^7Jenga\nCompete against each other in a competitive Jenga match. The last player to successfully add a piece to the tower before it is knocked over is the winner.";
        if (!isSolo()) self thread briefing(10, gameMode);
        else self thread welcomeMessage("Gamemode: ^2" + gamemode, "Created By: AgreedBog381");
        self thread jenga_createRevolver();
        self thread jenga_moveModel();
        if (self == getPlayers()[0]) {
            deleteChalks();
            self deleteBoards();
            self setClientDvar("ai_disableSpawn", "1");
            self setClientDvar("g_ai", 0);
            array_delete(getAiSpeciesArray("axis", "all"));
            self setClientDvar("phys_gravity", -8);
            self thread jenga_createTower();
        }
        level waittill("JENGA_OVER");
        wait 2;
        if (isDefined(self)) self thread deathMessage("^2Gametype: ^7Jenga", "Thanks For Playing! Would You Play It Again?", 263, 7);
    }
    if (gameMode == "Chess") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        self deleteInstructions();
        self thread lockMenu("GAME");
        self thread resetDvars();
        self hideAmmoHud(true);
        level.gameTypeText = "^2GameMode: ^7Chess\nPlay 1 v 1 in a competitive Chess match against your friend or foe. This is a real 3-D chess game with official rules applied, excluding a time limit per turn.";
        if (!isSolo()) self thread briefing(15, gameMode);
        else self thread welcomeMessage("Gamemode: ^2" + gamemode, "Created By: AgreedBog381");
        self disableWeapons();
        if (self == getPlayers()[0]) {
            level chess_setUpPlayers();
            self thread chess_playerAxisMovement(1);
            deleteChalks();
            self deleteBoards();
            self setClientDvar("ai_disableSpawn", 1);
            self setClientDvar("g_ai", 0);
            array_delete(getAiSpeciesArray("axis", "all"));
            level thread chess_makeBoard();
            self thread chess_watchPieces(1);
            if (isSolo()) self thread chess_watchPieces(2);
        } else {
            self thread chess_playerAxisMovement(2);
            self thread chess_watchPieces(2);
        }
    }
    if (gameMode == "Checkers") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        self deleteInstructions();
        self thread lockMenu("GAME");
        self thread resetDvars();
        self hideAmmoHud(true);
        level.gameTypeText = "^2GameMode: ^7Checkers\nPlay 1 v 1 in a competitive Checkers match against your friend or foe. This is a real 3-D checkers game with official rules applied.";
        if (!isSolo()) self thread briefing(26, gameMode);
        else self thread welcomeMessage("Gamemode: ^2" + gamemode, "Created By: AgreedBog381");
        self disableWeapons();
        if (self == getPlayers()[0]) {
            level checkers_setUpPlayers();
            self deleteBoards();
            deleteChalks();
            self setClientDvar("ai_disableSpawn", 1);
            self setClientDvar("g_ai", 0);
            array_delete(getAiSpeciesArray("axis", "all"));
            door = getEntArray("zombie_door", "targetname");
            for (a = 0; a < door.size; a++)
                for (b = 0; b < door[a].doors.size; b++) door[a].doors[b] remove();
            level thread disableBuyables();
            level thread checkers_makeBoard();
            self thread checkers_watchPieces(1);
            if (isSolo()) self thread checkers_watchPieces(2);
            self thread checkers_playerAxisMovement(1);
        } else {
            self thread checkers_watchPieces(2);
            self thread checkers_playerAxisMovement(2);
        }
    }
    if (gameMode == "Pong") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        self deleteInstructions();
        self thread lockMenu("GAME");
        self thread resetDvars();
        self hideAmmoHud(true);
        level.gameTypeText = "^2GameMode: ^7Pong\nPlay 1 v 1 in a competitive Pong match against your friend or foe. This is a 3-D Pong match based from the 2-D Pong arcade game!";
        if (!isSolo()) self thread briefing(29, gameMode);
        else self thread welcomeMessage("Gamemode: ^2" + gamemode, "Created By: AgreedBog381");
        self disableWeapons();
        if (self == getPlayers()[0]) {
            self deleteBoards();
            deleteChalks();
            self setClientDvar("ai_disableSpawn", 1);
            self setClientDvar("g_ai", 0);
            array_delete(getAiSpeciesArray("axis", "all"));
            door = getEntArray("zombie_door", "targetname");
            for (a = 0; a < door.size; a++)
                for (b = 0; b < door[a].doors.size; b++) door[a].doors[b] remove();
            level thread disableBuyables();
            level thread pong_createPongBoard();
            self thread pong_playPosition(1);
            self thread pong_pegController(1, 2);
            if (isSolo()) self thread pong_pegController(2, 1);
        } else {
            self thread pong_playPosition(2);
            self thread pong_pegController(2, 1);
        }
    }
    if (gameMode == "Connect Four") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        self deleteInstructions();
        self thread lockMenu("GAME");
        self thread resetDvars();
        self hideAmmoHud(true);
        level.gameTypeText = "^2GameMode: ^7Connect Four\nPlay 1 v 1 in a competitive Connect Four match against your friend or foe. This is a 3-D Connect Four match based off of the official boardgame!";
        if (!isSolo()) self thread briefing(28, gameMode);
        else self thread welcomeMessage("Gamemode: ^2" + gamemode, "Created By: AgreedBog381");
        self disableWeapons();
        if (self == getPlayers()[0]) {
            level cFour_setUpPlayers();
            self deleteBoards();
            deleteChalks();
            self setClientDvar("ai_disableSpawn", 1);
            self setClientDvar("g_ai", 0);
            array_delete(getAiSpeciesArray("axis", "all"));
            door = getEntArray("zombie_door", "targetname");
            for (a = 0; a < door.size; a++)
                for (b = 0; b < door[a].doors.size; b++) door[a].doors[b] remove();
            level thread disableBuyables();
            level thread cFour_createBoard();
            self thread cFour_makeMove(1);
            if (isSolo()) self thread cFour_makeMove(2);
            self thread cFour_viewPosition(1);
        } else {
            self thread cFour_makeMove(2);
            self thread cFour_viewPosition(2);
        }
    }
    if (gameMode == "HORSE") {
        if (isDefined(level.justStarted)) return;
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        self deleteInstructions();
        self thread lockMenu("GAME");
        self thread resetDvars();
        self hideAmmoHud(true);
        type = strTok("Horse|Pig", "|");
        level.gameTypeText = "^2GameMode: ^7" + type[level.horse_pickType] + "\nCompete against your friends in a game of basketball, COD style. ^2HINT:^7 Keep your power bar percent secret to make the shots harder for the other players.";
        if (!isSolo()) self thread briefing(10, type[level.horse_pickType]);
        else self thread welcomeMessage("Gamemode: ^2Free Ball", "Created By: AgreedBog381");
        self thread qs_noGrenades();
        self thread unlimitedAmmoAll();
        self thread unlimitedSprint();
        if (level.horse_pickEnviro == 0) {
            self thread setVision("fly_mid", 5);
            self thread sun("1.7", "1 0.5 0 1", (1, 0.5, 0));
        } else {
            self thread setVision("fly_dark", 5);
            self thread sun("0", "", (0, 0, 0));
            self thread changeFog((0, 0, 0), 1);
        }
        self thread changeWeather("ASH");
        self setClientDvar("sv_cheats", 0);
        if (self == getPlayers()[0]) {
            deleteChalks();
            deleteBoards();
            self thread jumpToRound(50);
            level disableBuyables();
            level openAllDoors();
            array_delete(getAiSpeciesArray("axis", "all"));
            self thread horse_buildHoop();
            level thread horse_updateStatus();
            self thread horse_deleteAllZombies();
        }
    }
    if (gameMode == "Survival Mode") {
        if (isDefined(level.justStarted)) return;
        if (level.round_number > 6) {
            self iPrintln("Debug: Please restart game");
            return;
        }
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7Survival Mode\nFight againt the undead horde of zombies to stay alive as long as you can. Remember, working as a team will keep you alive longer!";
        if (!isSolo()) self thread briefing(10, gameMode, true, true);
        else self thread welcomeMessage("Gamemode: ^2" + gamemode, "Created By: AgreedBog381");
        self thread doClearPerks();
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        level.isSurvivalMode = true;
        self thread alwaysFoggy();
        self thread destroy_stopWatch();
        self setClientDvar("actionSlotsHide", 0);
        self.currentKillstreak = 0;
        self thread watch_killstreak();
        self thread watch_killstreakDowned();
        self thread watch_moab250();
        wait .05;
        if (self == getPlayers()[0]) self thread doSurvivalThreads();
        self thread staminUp();
        self disableGodMode();
        self.score = 500;
        self add_to_player_score(4500);
        self setVision("fly_dark");
        self notify("fake_death");
        self setWaterDrops(10000000);
        self thread sm_startUpPrompt();
        self thread survivalLightning();
        self giveWeapon("stielhandgranate", 4);
        wait 2;
        level menuBarriers();
        wait 15;
        self thread roundText();
    }
    if (gameMode == "Power-Up Mania") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7Power-Up Mania\nRace against eachother and find all the powerups given to your player by random around the map! First player that reaches a score of 10 wins!";
        if (!isSolo()) self thread briefing(10, gameMode, true);
        else self thread welcomeMessage("Gamemode: ^2" + gamemode, "Created By: AgreedBog381");
        self deleteInstructions();
        self thread lockMenu("GAME");
        self setClientDvar("ui_hud_hardcore", "1");
        self.powerUpsCollected = 0;
        if (!isDefined(level.maniaArray)) level.maniaArray = array_randomize(level.powerUpProper);
        self.powerUpType = level.maniaArray[self getEntityNumber()];
        self thread gameModeInfo("Power-Up Type: ^2" + self.powerUpType);
        self thread maniaHud();
        if (self == getPlayers()[0]) {
            level thread stopRoundChanging();
            array_delete(getAiSpeciesArray("axis", "all"));
            self setClientDvar("g_ai", 0);
            deleteChalks();
            level thread disableBuyables();
            level thread survivalDoors();
            self thread activatePower();
            if (!isSolo()) wait 10;
            level thread maniaControlPowerups();
        }
    }
    if (gameMode == "Roll The Dice") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7Roll The Dice\nWork together to survive as long as you can while receiving a new good or bad function every 45 seconds ran on your player.";
        if (!isSolo()) self thread briefing(10, gameMode, true);
        else self thread welcomeMessage("Gamemode: ^2" + gamemode, "Created By: AgreedBog381");
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self disableGodMode();
        if (self == getPlayers()[0]) {
            level thread disableBuyables();
            level thread jumpToRound(4);
            level thread survivalDoors();
            deleteChalks();
        }
        self thread rollTheDice_main();
    }
    if (gameMode == "Last To Base") {
        if (!isDefined(input)) {
            self refreshMenu();
            return;
        }
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7Last To Base\nTeam up with eachother to get to the mainframe without the hunter capturing you. If everybody makes it to the base then the you win!";
        self thread briefing(10, gameMode, true);
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self setClientDvar("player_sustainAmmo", 1);
        if (self == getPlayers()[0]) {
            deleteChalks();
            level thread stopRoundChanging();
            array_delete(getAiSpeciesArray("axis", "all"));
            self setClientDvar("g_ai", 0);
            level thread disableBuyables();
            level thread openAllDoors();
            level thread activatePower();
            level.baseIcon = spawnObjPointer(undefined, (-56, 294, 112), "ui_host", false);
            level._hunterIcon = spawnObjPointer(undefined, undefined, "rank_prestige7", false);
            level._hunterIcon setTargetEnt(input);
            level thread _lastToBase_baseFx();
        }
        level._lastToBase_methods = [];
        level._lastToBase_methods["badZone"] = 0;
        level._lastToBase_methods["base"] = 0;
        level._lastToBase_methods["damage"] = 0;
        wait 10;
        self thread _lastToBase_splash(input);
    }
    if (gameMode == "Gun Game") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7Gun Game\nRun through all the weapons in the random box to kill eachother in this free for all match! First player to cycle through all the weapons wins!";
        self thread briefing(10, gameMode, true);
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self setClientDvar("sv_cheats", 1);
        self setClientDvar("miniscoreboardhide", 1);
        self setClientDvar("cg_drawOverHeadNames", 0);
        self disableGodMode();
        self thread gameModeInfo("");
        if (self == getPlayers()[0]) {
            deleteChalks();
            level thread stopRoundChanging();
            array_delete(getAiSpeciesArray("axis", "all"));
            self setClientDvar("g_ai", 0);
            level thread disableBuyables();
            level thread gunGameLeader();
            self playSingleSound("mx_eggs");
        }
        self thread welcomeText("^1" + level.patch, "^2Gametype: ^7Gun Game! -- ^2Created By: ^7" + level.creator);
        self.cycle = 0;
        self thread pvpThread();
        self thread cycleControl();
        self pickSpawnPoints();
    }
    if (gameMode == "Tag") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7Tag\nOnce a player gets knifed by the hunter, then they get turned into the new hunter! Work as hard as you can to out run the hunter or else you will be it!";
        self thread briefing(10, gameMode, true);
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self enableGodMode();
        self disableWeapons();
        self disableOffhandWeapons();
        self disableWeaponCycling();
        self setClientDvar("cg_drawOverHeadNames", 0);
        self thread gameModeInfo("CHOOSING WHO'S GOING TO BE IT!");
        wait 7;
        if (self == getPlayers()[0]) {
            deleteChalks();
            level thread stopRoundChanging();
            array_delete(getAiSpeciesArray("axis", "all"));
            self setClientDvar("g_ai", 0);
            level thread disableBuyables();
            level thread survivalDoors();
            level thread tigPick();
        }
    }
    if (gameMode == "Scavenger Skulls") {
        if (isDefined(level.justStarted)) return;
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7Scavenger Skulls\nKill zombies to scavenge their skulls and carry them back to deposit into your base! First player to deposit 40 skulls wins!";
        self thread briefing(10, gameMode);
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self takeAllGuns();
        self giveWeapon("zombie_ppsh");
        self switchToWeapon("zombie_ppsh");
        self giveMaxAmmo("zombie_ppsh");
        self thread alwaysFoggy();
        self disableGodMode();
        self setClientDvar("player_sustainAmmo", 1);
        self thread gameModeSkullInfo("Inventory Skulls: ^2", "Deposited Skulls: ^2", "Withdrawn Skulls: ^2");
        if (self == getPlayers()[0]) {
            level thread survivalDoors();
            level thread disableBuyables();
            level thread jumpToRound(8);
            level thread deleteChalks();
            level thread initStructures();
            level thread initSkullZombies();
            level thread skullsRevive();
        }
    }
    if (gameMode == "RAINS") {
        if (isDefined(level.justStarted)) return;
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7When It Rains, It Pours\nTry your best to catch each nuke falling from the sky! Because once it hits the ground, TAKE COVER!";
        if (!isSolo()) self thread briefing(10, "When It Rains, It Pours", true);
        else self thread welcomeMessage("Gamemode: ^2When It Rains, It Pours!", "Created By: AgreedBog381");
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self disableGodMode();
        self thread gameModeRainInfo("Nukes Missed: ", "Lobby Nukes Collected: ");
        if (self == getPlayers()[0]) {
            deleteChalks();
            level thread stopRoundChanging();
            array_delete(getAiSpeciesArray("axis", "all"));
            self setClientDvar("g_ai", 0);
            level thread disableBuyables();
            wait 9;
            level thread initRainPour();
        }
    }
    if (gameMode == "Tesla Freeze Tag") {
        if (isDefined(level.justStarted)) return;
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7Tesla Freeze Tag\nBattle amongst eachother with the Wunderwaffe in order to freeze your opponents!";
        self thread briefing(10, gameMode, true);
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self disableGodMode();
        self pickSpawnPoints();
        self setClientDvars("player_sustainAmmo", 1, "cg_drawOverHeadNames", 0);
        if (self == getPlayers()[0]) {
            deleteChalks();
            level thread stopRoundChanging();
            array_delete(getAiSpeciesArray("axis", "all"));
            self setClientDvar("g_ai", 0);
            level thread disableBuyables();
        }
        self thread teslaFreezeTags_main();
    }
    if (gameMode == "Nazi Zombies Pro") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7Nazi Zombies Pro\nSee if you can survive a Nazi Zombies match without the aid of any health icons or hint markers!";
        if (!isSolo()) self thread briefing(10, gameMode, true);
        else self thread welcomeMessage("Gamemode: ^2Nazi Zombies Pro", "Created By: AgreedBog381");
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self thread zombiesPro();
        self.score = 500;
        self add_to_player_score(4500);
        wait 4;
        self thread extinctionFogWatch();
        self setClientDvar("cg_drawOverHeadNames", 0);
        self setClientDvar("cg_drawBreathHint", 0);
        self setClientDvar("cg_drawCrosshair", 0);
        self setClientDvar("cg_weaponHintsCoD1Style", 0);
        level.powerup_hud[0] destroy();
        level.powerup_hud[1] destroy();
        self setClientDvar("hud_drawHUD", 0);
        self setClientDvar("ui_hud_visible", 0);
    }
    if (gameMode == "Hide and Seek") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7Hide and Seek\nHide as long as you can from the seeker by changing into any model in the map! Once the seeker gets released you cannot change your model!";
        self thread briefing(10, gameMode, true);
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self setClientDvar("player_sustainAmmo", 1);
        if (self == getPlayers()[0]) {
            level thread stopRoundChanging();
            array_delete(getAiSpeciesArray("axis", "all"));
            self setClientDvar("g_ai", 0);
            deleteChalks();
            level thread disableBuyables();
            if (getMap() == "nzf") level thread survivalDoors();
            else self thread openAllDoors();
            level thread activatePower();
        }
        self playSound("sam_fly_act_1");
        wait 10;
        self thread _hideSeek_init(input);
    }
    if (gameMode == "Free For All") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7Free For All\nCompete against eachother in a free for all match! The first player to reach 20 kills wins!";
        if (!isSolo()) self thread briefing(10, gameMode, true);
        else self thread welcomeMessage("Gamemode: ^2Free For All", "Created By: AgreedBog381");
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self thread ffa_dvars();
        if (self == getPlayers()[0]) {
            level disableBuyables();
            level thread stopRoundChanging();
            array_delete(getAiSpeciesArray("axis", "all"));
            self setClientDvar("g_ai", 0);
            deleteChalks();
            if (getMap() == "nzf") level thread survivalDoors();
            else self thread openAllDoors();
            level thread activatePower();
            self setClientDvar("sv_cheats", 0);
        }
        self disableInvulnerability();
        self giveWeapon("stielhandgranate", 2);
        self setClientDvar("cg_overheadIconSize", "0");
        self setClientDvar("cg_overheadRankSize", "0");
        self setClientDvar("cg_drawOverHeadNames", "0");
        self.team = "axis";
        self.kills = 0;
        self.killstreak = 0;
        self freezeControls(true);
        self takeAllGuns();
        self thread ffa_start();
    }
    if (gameMode == "Quick Scope") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7Quick Scope\nCompete against eachother in a free for all quickscope match! Remember... NO HARD SCOPING!!";
        if (!isSolo()) self thread briefing(10, gameMode, true);
        else self thread welcomeMessage("Gamemode: ^2Quick Scope Lobby: ^7Against [" + level.quickScopeEnemy + "]", "Created By: AgreedBog381");
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        level.quickScopeLobby = true;
        if (self == getPlayers()[0]) {
            level thread disableBuyables();
            if (getMap() == "nzf") level thread survivalDoors();
            else level thread openAllDoors();
        }
        if (!isDefined(level.qsAgainsPlayers)) {
            self takeAllGuns();
            self disableInvulnerability();
            self.Weapon = "ptrs41_zombie";
            self giveWeapon(self.Weapon);
            self switchToWeapon(self.Weapon);
            self disableWeaponCycling();
            self thread qs_noGrenades();
            self thread qs_noHardScope();
            self thread qs_instaKill();
        } else {
            if (self == getPlayers()[0]) {
                self setClientDvar("sv_cheats", 0);
                level thread stopRoundChanging();
                array_delete(getAiSpeciesArray("axis", "all"));
                self setClientDvar("g_ai", 0);
                deleteChalks();
            }
            self disableInvulnerability();
            self thread qs_start();
        }
        self allowMelee(false);
        if (getMap() == "nzf") self thread openPackDoor();
    }
    if (gameMode == "Forge") {
        level.gameTypeSelected = gameMode;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        self thread welcomeMessage("^2Gametype: ^7Forge Lobby", "Created By: AgreedBog381");
        self thread welcomeText("^2Gametype: ^7Forge Lobby", "TRY TO BE... ^1C^2R^3E^4A^5T^6I^1V^2E");
        self thread lockMenu("GAME");
        playfx(loadfx("maps/zombie/fx_transporter_pad_start"), self.origin);
        if (self == getPlayers()[0]) self thread universalMusic("mx_eggs");
        self thread jet_start();
        self thread add_to_player_score(99500);
        self thread giveAllGuns();
        self thread modDvars();
        self thread doFlashyDvars();
        self thread doFlashyScoreBar();
        self enableGodMode();
        self thread forge_onScreenText_init();
        self thread forgeButtonMonitor();
        self thread forgeNoClip();
        if (self == getPlayers()[0]) {
            self initTeleporters();
            deleteBoards();
        }
    }
    if (gameMode == "n_surv") {
        if (isDefined(level.justStarted)) return;
        if (level.round_number > 8) {
            self iPrintln("Debug: Please restart game");
            return;
        }
        level.gameTypeSelected = gameMode;
        self thread doClearPerks();
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self thread deathMessage("^1" + level.patch, "^2Gametype: ^7SURVIVAL MODE! -- ^2Created By: ^7" + level.creator, 339, 7);
        level notify("SecretStart");
    }
    if (gameMode == "unity") {
        if (isDefined(level.justStarted)) return;
        if (level.round_number > 4) {
            self iPrintln("Debug: Please restart game");
            return;
        }
        level.gameTypeSelected = gameMode;
        self thread doClearPerks();
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        level notify("UnityCampaign");
    }
    if (gameMode == "No Mans Land") {
        if (isDefined(level.justStarted)) return;
        if (isDefined(self.revivetrigger)) self thread maps\_laststand::revive_force_revive();
        level.gameTypeText = "^2GameMode: ^7No Mans Land\nOnce you die, you will be revived as a zombie to attack the rest of the remaining survivors!";
        if (!isSolo()) self thread briefing(10, gameMode, true);
        else {
            hud = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", 1000, 1);
            hud thread hudFadenDestroy(0, .75, .3);
        }
        self takeAllGuns();
        self deleteInstructions();
        self thread lockMenu("GAME");
        self resetDvars();
        self setVision("fly_dark", .05);
        if (self == getPlayers()[0]) {
            array_delete(getAiSpeciesArray("axis", "all"));
            if (!isSolo()) {
                self setClientDvar("g_ai", 0);
                wait 10;
                self setClientDvar("g_ai", 1);
            }
            self thread nml_loader();
            wait 3;
            self thread jumpToRound(50, true);
        }
    }
}
doSurvivalThreads() {
    level deleteBoards();
    self playSingleSound("mx_eggs");
    level thread jumpToRound(6);
    level thread survivalDoors();
    bigMoon = spawnSM((-403, 1161, 1760), "tag_origin", (20, -70, 0));
    playFxOnTag(level._effect["zombie_moon_eclipse"], bigMoon, "tag_origin");
    bigMoon thread rotateEntRoll(360, 10);
    deleteChalks();
    level.powerup_hud[0] destroy();
    level.powerup_hud[1] destroy();
    level thread spawnSurvivalMenu();
    level thread disableBuyables();
    level thread survivalLights();
    wait .5;
    level thread initFlinger();
    wait .05;
    level thread initBombs();
    wait .05;
    level thread survivalLunarLanders();
    wait .05;
    level thread tradingMachine();
    wait .5;
    level thread physicalMenuFx();
    wait .5;
    level thread napalmZombie_init();
    wait .5;
    level thread rareZombieDrops();
    wait .5;
    level thread initTeethTrap();
    wait .5;
    level thread smelter();
    wait .5;
    level thread allTrapped();
    wait .5;
    level thread superAmmoPowerup();
    wait .5;
    level thread spawnAutoTurret("ray_gun_upgraded", (-435, -411.66, 104.318), (0, 40, 0));
    level thread ammoMachine();
    wait .5;
    level thread spawnWaterGheyser((458, -2223, 89));
    wait .05;
    level thread spawnWaterGheyser((420, -1015, 65));
    wait .05;
    level thread doTeleportingRounds();
    level thread survivalPacka();
    wait .5;
    level thread doBossRounds();
    level thread knifeTrap();
    level thread teslaTrap();
    wait .5;
    level thread startEasterEgg();
    wait .5;
}
briefing(time, gameMode, spawn, freeze) {
    volume = getDvarFloat("snd_menu_master");
    self setClientDvar("snd_menu_master", 0);
    self freezeControls(true);
    self setClientDvar("didYouKnow", level.gameTypeText);
    self openMenu("briefing");
    self setClientDvar("cg_drawVersion", 1);
    self setClientDvar("cg_drawVersionY", 40);
    self setClientDvar("cg_drawVersionX", 80);
    self thread gameModeLoader(gameMode);
    wait .05;
    if (isDefined(spawn)) self thread returnToSpawn();
    wait time;
    self closeMenu();
    self setClientDvar("cg_drawVersion", 0);
    self setClientDvar("cg_drawVersionX", 0);
    self setClientDvar("didYouKnow", "Campaign Co-Op allows you to play through the story campaign with your friends without competing for high score.");
    self notify("Game_Start");
    if (!isDefined(freeze)) self freezeControls(false);
    self setClientDvar("snd_menu_master", volume);
}
gameModeLoader(gameMode) {
    self endon("Game_Start");
    while (true) {
        self setClientDvar("version", "Game Mode: " + gameMode + "\nLoading ");
        wait .15;
        self setClientDvar("version", "Game Mode: " + gameMode + "\nLoading. ");
        wait .15;
        self setClientDvar("version", "Game Mode: " + gameMode + "\nLoading.. ");
        wait .15;
        self setClientDvar("version", "Game Mode: " + gameMode + "\nLoading... ");
        wait .15;
        self setClientDvar("version", "Game Mode: " + gameMode + "\nLoading....");
        wait .15;
    }
}
gameModeInfoTab(label) {
    self.gameModeBG = self createRectangle("LEFT", "LEFT", 0, 0, self.menu["width"], 27, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
    self.gameModeEDG = self createRectangle("LEFT", "LEFT", self.gameModeBG.x - 2, self.gameModeBG.y, self.menu["width"] + 4, 31, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, self.menu["Edging_Alpha"]);
    self.gameModeInfo = self createText(self getFont(), 1, "LEFT", "LEFT", self.gameModeBG.x + 7, self.gameModeBG.y, 10, 1, "");
    self.gameModeInfo.label = label;
    self.gameModeInfo setValue(0);
}
gameModeInfo(text) {
    self.gameModeBG = self createRectangle("LEFT", "LEFT", 0, 0, self.menu["width"], 27, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
    self.gameModeEDG = self createRectangle("LEFT", "LEFT", self.gameModeBG.x - 2, self.gameModeBG.y, self.menu["width"] + 4, 31, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, self.menu["Edging_Alpha"]);
    self.gameModeInfo = self createText(self getFont(), 1, "LEFT", "LEFT", self.gameModeBG.x + 7, self.gameModeBG.y, 10, 1, text);
}
gameModeSkullInfo(text, text1, text2) {
    self.gameModeBG = self createRectangle("LEFT", "LEFT", 0, 0, self.menu["width"], 41, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
    self.gameModeEDG = self createRectangle("LEFT", "LEFT", self.gameModeBG.x - 2, self.gameModeBG.y, self.menu["width"] + 4, 45, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, self.menu["Edging_Alpha"]);
    self.gameModeInv = self createText(self getFont(), 1, "LEFT", "LEFT", self.gameModeBG.x + 7, -14, 10, 1);
    self.gameModeInv.label = text;
    self.gameModeDep = self createText(self getFont(), 1, "LEFT", "LEFT", self.gameModeBG.x + 7, 0, 10, 1);
    self.gameModeDep.label = text1;
    self.gameModeWit = self createText(self getFont(), 1, "LEFT", "LEFT", self.gameModeBG.x + 7, 14, 10, 1);
    self.gameModeWit.label = text2;
}
updateScavengerText() {
    self.gameModeInv setValue(self.invenSkulls);
    self.gameModeDep setValue(self.depoSkulls);
    self.gameModeWit setValue(self.withdrawnSkulls);
}
gameModeRainInfo(text, text1) {
    self.gameModeBG = self createRectangle("LEFT", "LEFT", 0, 0, self.menu["width"], 27, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
    self.gameModeEDG = self createRectangle("LEFT", "LEFT", self.gameModeBG.x - 2, self.gameModeBG.y, self.menu["width"] + 4, 31, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, self.menu["Edging_Alpha"]);
    self.gameModeMissed = self createText(self getFont(), 1, "LEFT", "LEFT", self.gameModeBG.x + 7, self.gameModeBG.y - 7, 10, 1);
    self.gameModeMissed.label = text;
    self.gameModeCollected = self createText(self getFont(), 1, "LEFT", "LEFT", self.gameModeBG.x + 7, self.gameModeBG.y + 7, 10, 1);
    self.gameModeCollected.label = text1;
}
updateRainText(value, value2) {
    self.gameModeMissed setValue(value);
    self.gameModeCollected setValue(value2);
}
gameModeFFAInfo(text, text1, text2, text3) {
    self.gameModeBG = self createRectangle("LEFT", "LEFT", 0, 0, self.menu["width"], 55, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
    self.gameModeEDG = self createRectangle("LEFT", "LEFT", self.gameModeBG.x - 2, self.gameModeBG.y, self.menu["width"] + 4, 59, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, self.menu["Edging_Alpha"]);
    self.gameModeScore = self createText(self getFont(), 1, "LEFT", "LEFT", self.gameModeBG.x + 7, -21, 10, 1);
    self.gameModeScore.label = text;
    self.gameModeKills = self createText(self getFont(), 1, "LEFT", "LEFT", self.gameModeBG.x + 7, -7, 10, 1);
    self.gameModeKills.label = text1;
    self.gameModeDowns = self createText(self getFont(), 1, "LEFT", "LEFT", self.gameModeBG.x + 7, 7, 10, 1);
    self.gameModeDowns.label = text2;
    self.gameModeKillstreak = self createText(self getFont(), 1, "LEFT", "LEFT", self.gameModeBG.x + 7, 21, 10, 1);
    self.gameModeKillstreak.label = text3;
    self thread updateFFAText();
}
updateFFAText() {
    self.gameModeScore setValue(self.score);
    self.gameModeKills setValue(self.kills);
    self.gameModeDowns setValue(self.downs);
    self.gameModeKillstreak setValue(self.killstreak);
}
addMenu(m, t, single) {
    self.menu[m] = [];
    if (isDefined(t)) self.menu[m]["title"] = t;
    self.menu["save"] = m;
    if (!isDefined(self.menu[m]["option"])) self.menu[m]["option"] = [];
    if (!isDefined(self.menu[m]["function"])) self.menu[m]["function"] = [];
    if (!isDefined(self.menu[m]["i1"])) self.menu[m]["i1"] = [];
    if (!isDefined(self.menu[m]["i2"])) self.menu[m]["i2"] = [];
    if (!isDefined(self.menu[m]["i3"])) self.menu[m]["i3"] = [];
    if (!isDefined(self.menu[m]["color"])) self.menu[m]["color"] = [];
    if (!isDefined(self.menu[m + "_POINTER"])) self.menu[m + "_POINTER"] = 0;
    if (!isDefined(single)) {
        for (a = 0; a < getPlayers().size; a++) {
            if (!isDefined(getPlayers()[a].menu[m])) getPlayers()[a].menu[m] = [];
            if (!isDefined(getPlayers()[a].menu[m]["color"])) getPlayers()[a].menu[m]["color"] = [];
            if (!isDefined(getPlayers()[a].menu[m + "_POINTER"])) getPlayers()[a].menu[m + "_POINTER"] = 0;
        }
    }
}
addOpt(option, function, i1, i2, i3, menu) {
    if (!isDefined(menu)) menu = self.menu["save"];
    a = self.menu[menu]["option"].size;
    self.menu[menu]["option"][a] = option;
    self.menu[menu]["function"][a] = function;
    self.menu[menu]["i1"][a] = i1;
    self.menu[menu]["i2"][a] = i2;
    self.menu[menu]["i3"][a] = i3;
}
deathMessage(message, message2, size, time, multiplier) {
    if (isDefined(self.msg))
        while (1) {
            wait .05;
            if (!isDefined(self.msg)) break;
        }
    self.msg = true;
    hud = [];
    hud[0] = self createRectangle("LEFT", "BOTTOMLEFT", 20, 100, 2, 35, self.menu["Scroller_Color"], "white", 5, .6);
    hud[0] thread hudMoveY(hud[0].y - 125, .3);
    wait .45;
    if (!isDefined(multiplier)) multiplier = 5.45;
    if (!isDefined(size)) size = int(message2.size * multiplier);
    hud[0] scaleOverTime(.3, size, 35);
    wait .25;
    hud[1] = self createText(self getFont(), 1.2, "LEFT", "BOTTOMLEFT", hud[0].x + 5, hud[0].y - 8, 10, 0, message);
    hud[2] = self createText(self getFont(), 1.2, "LEFT", "BOTTOMLEFT", hud[1].x, hud[1].y + 15, 10, 0, message2);
    for (a = 1; a < 3; a++) hud[a] thread hudFade(1, .45);
    if (!isDefined(time)) wait 5;
    else wait time;
    for (a = 1; a < 3; a++) hud[a] thread hudFadenDestroy(0, .25);
    wait .2;
    hud[0] scaleOverTime(.35, 2, 35);
    wait .45;
    hud[0] hudMoveY(hud[0].y + 120, .3);
    self destroyAll(hud);
    self.msg = undefined;
}
welcomeText(text1, text2) {
    if (isDefined(self.welcome_msg))
        while (1) {
            wait .05;
            if (!isDefined(self.welcome_msg)) break;
        }
    self.welcome_msg = true;
    self.txthudBG = self createRectangle("BOTTOM", "BOTTOM", -1000, -40, 1000, 50, divideColor(0, 0, 0), "menu_button_backing_highlight", 10, .8);
    self.txtline1 = self createText(getFont(), 1.3, "LEFT", "LEFTBOTTOM", -1000, -72, 11, 0, text1);
    self.txtline2 = self createText(getFont(), 1.3, "LEFT", "LEFTBOTTOM", -1000, -58, 11, 0, text2);
    self.txtline1 thread hudMoveX(20, .5);
    self.txtline2 thread hudMoveX(20, .5);
    self.txthudBG thread hudMoveX(0, .5);
    self.txtline1 thread hudFade(1, .25);
    self.txtline2 thread hudFade(1, .25);
    wait .5;
    self.txtline1 thread hudMoveX(500, 10);
    self.txtline2 thread hudMoveX(500, 15);
    wait 5;
    self.txtline1 thread hudMoveX(1000, .35);
    self.txtline2 thread hudMoveX(1000, .35);
    self.txthudBG thread hudMoveX(1000, .35);
    wait .35;
    self.txtline1 thread hudFadenDestroy(0, .55);
    self.txtline2 thread hudFadenDestroy(0, .55);
    self.txthudBG thread hudFadenDestroy(0, .5);
    wait .55;
    self.welcome_msg = undefined;
}
welcomeMessage(message, message2) {
    if (isDefined(self.welcomeMessage))
        while (1) {
            wait .05;
            if (!isDefined(self.welcomeMessage)) break;
        }
    self.welcomeMessage = true;
    hud = [];
    hud[0] = self createText(self getFont(), 1.35, "CENTER", "CENTER", -500, -140 + 60, 10, 1, message);
    hud[1] = self createText(self getFont(), 1.35, "CENTER", "CENTER", 500, -120 + 60, 10, 1, message2);
    hud[0] thread hudMoveX(-25, .35);
    hud[1] thread hudMoveX(25, .35);
    wait .35;
    hud[0] thread hudMoveX(25, 3);
    hud[1] thread hudMoveX(-25, 3);
    wait 3;
    hud[0] thread hudMoveX(500, .35);
    hud[1] thread hudMoveX(-500, .35);
    wait .35;
    self destroyAll(hud);
    self.welcomeMessage = undefined;
}
notifyMsg(icon, text1, text2, text3, sound) {
    intro = spawnStruct();
    if (isDefined(icon)) intro.iconName = icon;
    if (isDefined(text1)) intro.titleText = text1;
    if (isDefined(text2)) intro.notifyText = text2;
    if (isDefined(text3)) intro.notifyText2 = text3;
    if (isDefined(sound)) intro.sound = sound;
    intro.duration = 4.7;
    self thread maps\_hud_message::artificialMessage(intro, icon, text1, text2, text3, sound);
}
addCost(cost) {
    menu = self.menu["save"];
    if (!isDefined(self.menu[menu]["cost"])) self.menu[menu]["cost"] = [];
    self.menu[menu]["cost"][self.menu[menu]["cost"].size] = cost;
}
addDescription(desc) {
    menu = self.menu["save"];
    if (!isDefined(self.menu[menu]["desc"])) self.menu[menu]["desc"] = [];
    self.menu[menu]["desc"][self.menu[menu]["desc"].size] = desc;
}
instructions(kill) {
    if (isDefined(self.menuFullyLocked)) return;
    self setClientDvar("actionSlotsHide", 1);
    if (isDefined(kill) && kill) self destroyAll(self.menu["INFO"]);
    if (!isDefined(kill) || !kill) {
        if (isDefined(self.menu["INFO"]["BG"])) return;
        if (!self.menu["hideMenu"]) self openMenuInstructions();
        Y = self.menu["safeArea_Y"];
        if (isDefined(self.menu["INSTRUCTIONS"]["Info"]) && !self.menu["Mod_Menu_Pro"]) Y = self.menu["safeArea_Y"] - 17;
        else self thread doInstructions(true);
        if (self.menu["Mod_Menu_Pro"]) return;
        self.menu["INFO"]["Tab Info Bar"] = self createRectangle("BOTTOM", "BOTTOM", 0, Y, 152, 15, self.menu["Tab Info Bar_Color"], self.menu["Tab Info Bar_Shader"], -10, self.menu["Tab Info Bar_Alpha"]);
        self.menu["INFO"]["Tab Info"] = self createText(self.menu["Tab Info_Font"], self.menu["Tab Info_Fontscale"], "BOTTOM", "BOTTOM", 0, self.menu["INFO"]["Tab Info Bar"].y - 2, 2, self.menu["Tab Info_Alpha"], self getText(), self.menu["Tab Info_Color"]);
        self thread watchInstuctionOpen();
    }
}
openMenuInstructions() {
    if (!isDefined(self.menu["INFO"])) self.menu["INFO"] = [];
    self.menu["INFO"]["BG"] = self createRectangle("LEFT", "LEFT", self.menu["safeArea_X"], self.menu["positioning_Y"], self.menu["width"], 30, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
    if (isDefined(self.coloredMenu["UI_Title_RAINBOW"])) self.menu["INFO"]["BG"] thread smoothColorChange();
    self.menu["INFO"]["EDG"] = self createRectangle("LEFT", "LEFT", self.menu["INFO"]["BG"].x - 2, self.menu["INFO"]["BG"].y, self.menu["width"] + 4, 34, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, self.menu["Edging_Alpha"]);
    if (isDefined(self.coloredMenu["UI_Edging_RAINBOW"])) self.menu["INFO"]["EDG"] thread smoothColorChange();
    self.menu["INFO"]["TXT"] = self createText(self getFont(), 1, "LEFT", "LEFT", self.menu["INFO"]["BG"].x + 3, self.menu["INFO"]["BG"].y - 6, 10, 1, "Press [{+speed_throw}] + [{+melee}] To Open Menu");
    self thread watchForInstructionChange();
    self.menu["INFO"]["ENT"] = self createText(self getFont(), 1, "LEFT", "LEFT", self.menu["INFO"]["BG"].x + 3, self.menu["INFO"]["BG"].y + 6, 10, 1, "Entity Count:");
    self.menu["INFO"]["ENTC"] = self createText(self getFont(), 1, "LEFT", "LEFT", self.menu["INFO"]["BG"].x + 70, self.menu["INFO"]["BG"].y + 6, 10, 1, level.entityCount, self getEntityColor());
    self thread entityCount();
}
entityCount() {
    save = level.entityCount;
    while (isDefined(self.menu["INFO"]["ENT"])) {
        if (save != level.entityCount) {
            self.menu["INFO"]["ENTC"].color = self getEntityColor();
            self.menu["INFO"]["ENTC"] fadeOverTime(0.5);
            self.menu["INFO"]["ENTC"] setValue(level.entityCount);
            save = level.entityCount;
        }
        wait .05;
    }
}
getEntityColor() {
    if (level.entityCount <= 512) return divideColor(0 + (level.entityCount * 255 / 512), 255, 0);
    else return divideColor(255, 255 - (((level.entityCount - 512) * 255) / 512), 0);
}
watchForInstructionChange() {
    while (isDefined(self.menu["INFO"]["TXT"])) {
        if (!isDefined(self.menu["LOCK_MENU"])) self.menu["INFO"]["TXT"] setText(self.menu["TEXT"]);
        else self.menu["INFO"]["TXT"] setText("Your Mod Menu Is Locked!");
        self waittill("text_update");
        self.menu["INFO"]["TXT"].alpha = 1;
    }
}
smoothColorChange() {
    while (isDefined(self)) {
        self fadeOverTime(.15);
        self.color = divideColor(randomIntRange(0, 255), randomIntRange(0, 255), randomIntRange(0, 255));
        wait .25;
    }
}
alwaysColorful() {
    self endon("colors_over");
    while (isDefined(self)) {
        self fadeOverTime(1);
        self.color = (randomInt(255) / 255, randomInt(255) / 255, randomInt(255) / 255);
        wait 1;
    }
}
hudMoveY(y, time) {
    self moveOverTime(time);
    self.y = y;
    wait time;
}
hudMoveX(x, time) {
    self moveOverTime(time);
    self.x = x;
    wait time;
}
hudMoveXY(time, x, y) {
    self moveOverTime(time);
    self.y = y;
    self.x = x;
}
hudFade(alpha, time) {
    self fadeOverTime(time);
    self.alpha = alpha;
    wait time;
}
hudFadenDestroy(alpha, time, time2) {
    if (isDefined(time2)) wait time2;
    self hudFade(alpha, time);
    self destroy();
}
getBig() {
    while (self.fontscale < 2) {
        self.fontscale = min(2, self.fontscale + (2 / 20));
        wait .05;
    }
}
getSmall() {
    while (self.fontscale > 1.5) {
        self.fontscale = max(1.5, self.fontscale - (2 / 20));
        wait .05;
    }
}
divideColor(c1, c2, c3) {
    return (c1 / 255, c2 / 255, c3 / 255);
}
openMenuChange() {
    self thread checkForStatusChange();
    self endon("LOCK_MENU");
    self endon("NO_FORGE");
    self.menu["TEXT"] = "Press [{+speed_throw}] + [{+melee}] To Open Menu";
    while (true) {
        wait 5;
        if (isDefined(self.menu["INFO"]["TXT"])) self.menu["INFO"]["TXT"] thread hudFade(0, 1);
        wait 1;
        self.menu["TEXT"] = "Press [{+speed_throw}] + [{+frag}] To Open Forge";
        if (isDefined(self.menu["INFO"]["TXT"])) self.menu["INFO"]["TXT"] setText(self.menu["TEXT"]);
        if (isDefined(self.menu["INFO"]["TXT"])) self.menu["INFO"]["TXT"] thread hudFade(1, 1);
        wait 1;
        wait 5;
        if (isDefined(self.menu["INFO"]["TXT"])) self.menu["INFO"]["TXT"] thread hudFade(0, 1);
        wait 1;
        self.menu["TEXT"] = "Press [{+speed_throw}] + [{+melee}] To Open Menu";
        if (isDefined(self.menu["INFO"]["TXT"])) self.menu["INFO"]["TXT"] setText(self.menu["TEXT"]);
        if (isDefined(self.menu["INFO"]["TXT"])) self.menu["INFO"]["TXT"] thread hudFade(1, 1);
        wait 1;
    }
}
checkForStatusChange() {
    self endon("LOCK_MENU");
    while (true) {
        if (self getStatusIndex() < 3) break;
        wait .05;
    }
    self notify("NO_FORGE");
    self.menu["TEXT"] = "Press [{+speed_throw}] + [{+melee}] To Open Menu";
    if (isDefined(self.menu["INFO"]["TXT"])) self.menu["INFO"]["TXT"] setText(self.menu["TEXT"]);
    if (isDefined(self.menu["INFO"]["TXT"])) self.menu["INFO"]["TXT"].alpha = 1;
    while (true) {
        if (self getStatusIndex() >= 3) break;
        wait .05;
    }
    self thread openMenuChange();
}
watchInstuctionOpen() {
    self endon("lock");
    self notify("text_update");
    count = 0;
    while (isDefined(self.menu["INFO"]["Tab Info Bar"])) {
        if (self meleeButtonPressed()) {
            if (count != 0) count = 0;
            while (self meleeButtonPressed()) {
                if (count >= .6) {
                    self thread doInstructions(self.menu["INSTRUCTIONS"]["Info"]);
                    break;
                }
                count += .05;
                wait .05;
            }
        }
        wait .05;
    }
}
doInstructions(open) {
    if (isDefined(self.revivetrigger) || self inMenu()) return;
    if (!isDefined(open)) {
        self.instructionsWereOpen = true;
        self remakeInstructions(0);
        self.menu["INSTRUCTIONS"]["Info Bar"] thread hudScaleOverTime(.16, 1000, 18);
        self.menu["INFO"]["Tab Info Bar"] thread hudMoveY(self.menu["INFO"]["Tab Info Bar"].y - 17, .15);
        self.menu["INFO"]["Tab Info"] thread hudMoveY(self.menu["INFO"]["Tab Info"].y - 17, .15);
        self notify("text_update");
        self.menu["INSTRUCTIONS"]["Info Bar"] thread hudFade(self.menu["Info Bar_Alpha"], .35);
        wait .05;
        self.menu["INSTRUCTIONS"]["Info"] thread hudFade(self.menu["Info_Alpha"], .5);
        wait .2;
        self.menu["INFO"]["Tab Info"] setText(self getText());
    } else {
        self.instructionsWereOpen = undefined;
        self.menu["INFO"]["Tab Info Bar"] thread hudMoveY(self.menu["INFO"]["Tab Info Bar"].y + 17, .15);
        self.menu["INFO"]["Tab Info"] thread hudMoveY(self.menu["INFO"]["Tab Info"].y + 17, .15);
        self.menu["INSTRUCTIONS"]["Info Bar"] thread hudScaleOverTime(.15, 1000, 1);
        self.menu["INSTRUCTIONS"]["Info"] thread hudFadenDestroy(0, .1);
        self.menu["INSTRUCTIONS"]["Info Bar"] thread hudFadenDestroy(0, .2);
        wait .2;
        self.menu["INFO"]["Tab Info"] setText(self getText());
    }
}
getText() {
    if (isDefined(self.menu["INSTRUCTIONS"]["Info"])) return "Hold [{+melee}] To Close Instructions";
    return "Hold [{+melee}] To Open Instructions";
}
deleteInstructions() {
    if (isDefined(self.menu["INSTRUCTIONS"]["Info"])) self.menu["INSTRUCTIONS"]["Info"] destroy();
    if (isDefined(self.menu["INSTRUCTIONS"]["Info Bar"])) self.menu["INSTRUCTIONS"]["Info Bar"] destroy();
}
remakeInstructions(size) {
    if (isDefined(self.menu["INSTRUCTIONS"]["Info"]) || self.menu["Mod_Menu_Pro"] || !isDefined(self.instructionsWereOpen) || isDefined(self.menuFullyLocked)) return;
    if (size == 0) {
        self.menu["INSTRUCTIONS"]["Info Bar"] = self createRectangle("BOTTOM", "BOTTOM", 0, self.menu["safeArea_Y"], 1000, 1, self.menu["Info Bar_Color"], self.menu["Info Bar_Shader"], -2, 0);
        self.menu["INSTRUCTIONS"]["Info"] = self createText(self.menu["Info_Font"], self.menu["Info_Fontscale"], "BOTTOM", "BOTTOM", 0, self.menu["INSTRUCTIONS"]["Info Bar"].y - 3, -1, 0, "", self.menu["Info_Color"]);
    } else {
        self.menu["INSTRUCTIONS"]["Info Bar"] = self createRectangle("BOTTOM", "BOTTOM", 0, self.menu["safeArea_Y"], 1000, 18, self.menu["Info Bar_Color"], self.menu["Info Bar_Shader"], -2, self.menu["Info Bar_Alpha"]);
        self.menu["INSTRUCTIONS"]["Info"] = self createText(self.menu["Info_Font"], self.menu["Info_Fontscale"], "BOTTOM", "BOTTOM", 0, self.menu["INSTRUCTIONS"]["Info Bar"].y - 3, -1, self.menu["Info_Alpha"], "", self.menu["Info_Color"]);
    }
    self notify("text_update");
}
menuInstructions() {
    self endon("disconnect");
    self endon("text_over");
    while (true) {
        if (isDefined(self.menu["INSTRUCTIONS"]["Info"])) {
            if (!self inMenu()) {
                if (!isDefined(self.menu["LOCK_MENU"])) self.menu["INSTRUCTIONS"]["Info"] setText("Welcome To Elasticity -- Created By: AgreedBog381");
                else self.menu["INSTRUCTIONS"]["Info"] setText("Welcome To Elasticity -- Created By: AgreedBog381 -- Your Mod Menu Is Locked!");
            } else self.menu["INSTRUCTIONS"]["Info"] setText("[{+attack}]: Scroll Down - [{+speed_throw}]: Scroll Up - [{+activate}]: Select Menu/Mod - [{+melee}]: Go Back/Exit Menu");
            if (isDefined(self.menu["main"]["instructions"])) self.menu["INSTRUCTIONS"]["Info"] setText(self.menu["main"]["instructions"]);
        }
        self waittill("text_update");
    }
}
lockMenu(type) {
    if (isDefined(self.menu["LOCK_MENU"]) || !isDefined(self.hasModMenu)) return;
    self.menu["LOCK_MENU"] = true;
    if (type == "LOCK") {
        self instructions(true);
        self notify("lock");
        self clasicExit(true);
        self thread deleteInstructions();
        self.menu["IN_MENU"] = undefined;
        self waittill("unlockMenu");
        self thread watchMenu();
    }
    if (type == "VERI") {
        self notify("LOCK_MENU");
        self clasicExit();
        self notify("text_update");
        self waittill("unlockMenu");
        self thread openMenuChange();
    }
    if (type == "HALF") {
        self thread disableMenu();
        self waittill("unlockHalf");
        self thread drawText(self.menu["UI"]["Background"].x, 0);
        wait .2;
        self thread controls();
    }
    if (type == "ALL") {
        self thread disableMenu(true);
        self waittill("unlockMenu");
        if (self inMenu()) self quickCreate();
    }
    if (type == "GAME") {
        self.deathCloseMenu = true;
        self disableMenu(true);
        self.menu["IN_MENU"] = undefined;
        self.menuFullyLocked = true;
        self.deathCloseMenu = undefined;
    }
    self.menu["LOCK_MENU"] = undefined;
    if (type == "VERI") self notify("text_update");
    if (!self inMenu() && !isDefined(self.menu["INFO"]["TXT"]) && !isDefined(self.menuFullyLocked)) self instructions();
}
unlockMenu(menu) {
    if (!isDefined(self.menuFullyLocked) && self hasMenu()) {
        if (!isDefined(menu)) self notify("unlockMenu");
        else self notify(menu);
        self notify("text_update");
    }
}
createProgressMenu(text, text2, time) {
    self thread lockMenu("ALL");
    hud = [];
    hud[0] = self createRectangle("LEFT", "LEFT", self.menu["safeArea_X"], self.menu["positioning_Y"], self.menu["width"], 27, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
    hud[1] = self createRectangle("LEFT", "LEFT", hud[0].x - 2, hud[0].y, self.menu["width"] + 4, 31, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, self.menu["Edging_Alpha"]);
    hud[2] = self createText(self getFont(), 1, "LEFT", "LEFT", hud[0].x + 7, hud[0].y, 10, 1, "");
    hud[2] thread dotDot(text);
    wait time;
    hud[2] notify("dotDot_endon");
    hud[2] setText(text2);
    wait 2.5;
    self destroyAll(hud);
    self unlockMenu();
}
controls() {
    self endon("disconnect");
    self endon("menuExit");
    if (!isSolo()) self thread menuWatchDeath();
    wait .1;
    while (isDefined(self.menu["IN_MENU"])) {
        if (!isDefined(self.menu["DISABLE_MENU_CONTROLS"])) {
            if (self adsButtonPressed() && self meleeButtonPressed()) {
                self thread clasicExit(true);
            } else if (self adsButtonPressed() || self attackButtonPressed()) {
                if (!self adsButtonPressed() || !self attackButtonPressed()) {
                    self playlocalSound("gr_shotgun_push");
                    oldPointer = self getPointer();
                    self.menu[self getCurrentMenu() + "_POINTER"] += self attackButtonPressed();
                    self.menu[self getCurrentMenu() + "_POINTER"] -= self adsButtonPressed();
                    self revalueMenuPointer(self.menu[self getCurrentMenu() + "_POINTER"], oldPointer);
                    wait .15;
                }
            } else if (self useButtonPressed()) {
                self playlocalSound("gr_nambu_slide_forward_plr");
                self thread[[self buildFromMenu()[self getCurrentMenu()]["function"][self getPointer()]]](self buildFromMenu()[self getCurrentMenu()]["i1"][self getPointer()], self buildFromMenu()[self getCurrentMenu()]["i2"][self getPointer()], self buildFromMenu()[self getCurrentMenu()]["i3"][self getPointer()]);
                wait .2;
            } else if (self meleeButtonPressed()) {
                self playlocalSound("gr_1911_slide_forward_plr");
                if (self getCurrentMenu() == "main") self thread exitMenu();
                else self newMenu();
                wait .2;
            }
        }
        wait .05;
    }
}
revalueMenuPointer(pointer, oldPointer) {
    self setPointer(revaluePointer(pointer));
    if (oldPointer > pointer) self thread scrollingSystem(oldPointer, -1);
    else self thread scrollingSystem(oldPointer, 1);
}
revaluePointer(val) {
    if (val < 0) return val + self buildFromMenu()[self getCurrentMenu()]["option"].size + self getMenuFiller(self getMenuNumber());
    if (val >= self buildFromMenu()[self getCurrentMenu()]["option"].size) return val - self buildFromMenu()[self getCurrentMenu()]["option"].size - self getMenuFiller(self getMenuNumber());
    return val;
}
getMenuNumber() {
    if (self getCurrentMenu() == "main" && self.menu["animateMenu"]) return 5;
    return 7;
}
getMenuFiller(min) {
    if (self buildFromMenu()[self getCurrentMenu()]["option"].size <= min) return min - self buildFromMenu()[self getCurrentMenu()]["option"].size;
    return 0;
}
scrollingSystem(pointer, direction) {
    create = self revaluePointer(self getPointer() + self.menu["min"] * direction);
    destroy = self revaluePointer(self getPointer() - self.menu["max"] * direction);
    if (isDefined(self buildFromMenu()[self getCurrentMenu()]["option"]))
        for (a = 0; a < self buildFromMenu()[self getCurrentMenu()]["option"].size; a++) {
            if (!isDefined(self.menu["OPT"][a])) continue;
            if (!isDefined(self.menu["sub"]) && self.menu["animateMenu"]) self.menu["UI"][a] thread hudMoveY((self.menu["OPT"][a].y - self.menu["yDIF"] / self.menu["min"] * direction), .175);
            self.menu["OPT"][a] thread hudMoveY((self.menu["OPT"][a].y - self.menu["yDIF"] / self.menu["min"] * direction), .175);
        }
    if (isDefined(self buildFromMenu()[self getCurrentMenu()]["option"][create])) {
        self.menu["OPT"][destroy] thread hudFadenDestroy(0, .175);
        self.menu["OPT"][create] = self createText(self.menu["MenuFont"], self.menu["Menu_Fontscale"], self.menu["Menu_Alignment"], "LEFT", self.menu["UI"]["Background"].x + self.menu["x"], self.menu["positioning_Y"] + self.menu["y"] * direction, self menuGrabSort(), 0, self buildFromMenu()[self getCurrentMenu()]["option"][create], self menuGrabColor(create));
        self thread waitForAlpha(self.menu["OPT"][create]);
        self.menu["OPT"][create] thread hudMoveY(self.menu["positioning_Y"] + self.menu["yDIF"] * direction, .175);
    }
    if (!isDefined(self.menu["sub"]) && self.menu["animateMenu"]) {
        self.menu["OPT"][create].sort = 5;
        self.menu["UI"][destroy] thread hudFadenDestroy(0, .175);
        self.menu["UI"][create] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Background"].x + 5, self.menu["positioning_Y"] + self.menu["y"] * direction, self.menu["width"] - 23, 20, self.menu["Tab_Color"], self.menu["Tab_Shader"], 4, 0);
        self.menu["UI"][create] thread hudMoveY(self.menu["positioning_Y"] + self.menu["yDIF"] * direction, .175);
        self.menu["UI"][create] thread hudFade(self.menu["Tab_Alpha"], .25);
    }
    self thread systemSort(pointer);
}
systemSort(pointer) {
    wait .17;
    if ((self.menu["animateMenu"] && isDefined(self.menu["sub"])) || !self.menu["animateMenu"]) {
        if (self.menu["sortAnimation"]) {
            self.menu["OPT"][revaluePointer(pointer)].sort = 4;
            self.menu["OPT"][revaluePointer(self getPointer())].sort = 6;
        } else {
            self.menu["OPT"][revaluePointer(pointer)].sort = 6;
            self.menu["OPT"][revaluePointer(self getPointer())].sort = 8;
        }
    }
}
menuGrabSort() {
    if (self.menu["sortAnimation"]) return 1;
    return 6;
}
menuGrabColor(create) {
    if (self.menu[self getCurrentMenu()]["color"][create] != self.menu["Select_Color"]) return self.menu["Menu_Color"];
    return self.menu[self getCurrentMenu()]["color"][create];
}
waitForAlpha(hud) {
    wait .1;
    hud.alpha = self.menu["Menu_Alpha"];
}
quickCreate() {
    if (self.menu["animateMenu"]) {
        self.menu["UI"]["Title"] = self createRectangle("LEFT", "LEFT", self.menu["safeArea_X"] + (self.menu["width"] - 3), self.menu["positioning_Y"] - 100, self.menu["width"], 25, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
        self.menu["UI"]["Status"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Title"].x, self.menu["positioning_Y"] + 100, self.menu["width"], 25, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
        self.menu["OPT"]["Title"] = self createText(self.menu["TitleFont"], self.menu["Title & Status_Fontscale"], self.menu["Title_Alignment"], "LEFT", self.menu["UI"]["Title"].x + self.menu["title_x"], self.menu["UI"]["Title"].y, 10, self.menu["Title & Status_Alpha"], level.patch, self.menu["Title & Status_Color"]);
        self.menu["OPT"]["Status"] = self createText(self.menu["TitleFont"], self.menu["Title & Status_Fontscale"], self.menu["Title_Alignment"], "LEFT", self.menu["OPT"]["Title"].x, self.menu["UI"]["Status"].y, 10, self.menu["Title & Status_Alpha"], "Status: " + self.menu["Status"], self.menu["Title & Status_Color"]);
        self thread KRDR(self.menu["KRDR_Color"], self.menu["OPT"]["Title"], level.patch);
        self.menu["UI"]["Background"] = self createRectangle("LEFT", "LEFT", self.menu["safeArea_X"] + 9, self.menu["positioning_Y"], self.menu["width"] - 18, 20, self.menu["Background_Color"], self.menu["Background_Shader"], 2, self.menu["Background_Alpha"]);
        self.menu["UI"]["Scroller"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Title"].x, self.menu["positioning_Y"], self.menu["width"], 180, self.menu["Scroller_Color"], self.menu["Scroller_Shader"], 5, self.menu["Scroller_Alpha"]);
        self.menu["UI"][self.menu["main_POINTER"]] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Background"].x + 5, self.menu["positioning_Y"], self.menu["width"] - 23, 20, self.menu["Tab_Color"], self.menu["Tab_Shader"], 4, self.menu["Tab_Alpha"]);
        self.menu["UI"]["Tab"] = self.menu["UI"][self.menu["main_POINTER"]];
        self.menu["TITLE"] = self createText(self.menu["MenuFont"], self.menu["Menu_Fontscale"], "CENTER", "LEFT", self.menu["UI"]["Background"].x + ((self.menu["width"] - 18) / 2), self.menu["positioning_Y"], 5, 1, "", self.menu["Menu_Color"]);
    } else {
        self.menu["UI"]["Title"] = self createRectangle("LEFT", "LEFT", self.menu["safeArea_X"], self.menu["positioning_Y"] - 100, self.menu["width"], 25, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
        self.menu["UI"]["Status"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Title"].x, self.menu["UI"]["Title"].y + 200, self.menu["width"], 25, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
        self.menu["OPT"]["Title"] = self createText(self.menu["TitleFont"], self.menu["Title & Status_Fontscale"], self.menu["Title_Alignment"], "LEFT", self.menu["UI"]["Title"].x + self.menu["title_x"], self.menu["UI"]["Title"].y, 10, self.menu["Title & Status_Alpha"], "", self.menu["Title & Status_Color"]);
        self.menu["OPT"]["Status"] = self createText(self.menu["TitleFont"], self.menu["Title & Status_Fontscale"], self.menu["Title_Alignment"], "LEFT", self.menu["OPT"]["Title"].x, self.menu["UI"]["Status"].y, 10, self.menu["Title & Status_Alpha"], "Status: " + self.menu["Status"], self.menu["Title & Status_Color"]);
        self.menu["UI"]["Background"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Title"].x, self.menu["UI"]["Title"].y + 100, self.menu["width"], 225, self.menu["Background_Color"], self.menu["Background_Shader"], 5, self.menu["Background_Alpha"]);
        self.menu["UI"]["Edging"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Background"].x - 2, self.menu["UI"]["Background"].y, self.menu["width"] + 4, 229, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, self.menu["Edging_Alpha"]);
        self.menu["UI"]["Scroller"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Background"].x, self.menu["positioning_Y"], 2, 30, self.menu["Scroller_Color"], self.menu["Scroller_Shader"], 6, self.menu["Scroller_Alpha"]);
    }
    self drawText(self.menu["UI"]["Background"].x, self.menu["Menu_Alpha"]);
    wait .2;
    self thread controls();
}
KRDR(color, hud, text) {
    self.menu["KRDR_Color"] = color;
    while (isDefined(hud)) {
        if (self.menu["KRDR_Color"] == "^7") hud setText("^7" + text);
        while (self.menu["KRDR_Color"] == "^7") wait .05;
        for (a = 0; a < text.size; a++) {
            string = "";
            for (b = 0; b < text.size; b++) {
                if (b == a) string += self.menu["KRDR_Color"] + "" + text[b] + "^7";
                else string += text[b];
            }
            if (isDefined(self.menu["KRDR_wait"])) self waittill("KRDR");
            hud setText(string);
            wait .05;
        }
        wait .05;
        for (a = text.size - 1; a >= 0; a--) {
            string = "";
            for (b = 0; b < text.size; b++) {
                if (b == a) string += self.menu["KRDR_Color"] + "" + text[b] + "^7";
                else string += text[b];
            }
            if (isDefined(self.menu["KRDR_wait"])) self waittill("KRDR");
            hud setText(string);
            wait .05;
        }
        wait .05;
    }
}
continueKRDR() {
    self.menu["KRDR_wait"] = true;
    wait .33;
    self.menu["KRDR_wait"] = undefined;
    self notify("KRDR");
}
watchMenu() {
    self endon("disconnect");
    self endon("lock");
    while (true) {
        if (!self inMenu() && self hasMenu() && isAlive(self) || level.gameTypeSelected == "Forge") {
            if (level.gameTypeSelected != "Forge") {
                if (self adsButtonPressed() && self meleeButtonPressed()) self notify("OPEN_MENU");
                if (self adsButtonPressed() && self fragButtonPressed() && self getStatusIndex() >= 3) self notify("OPEN_FORGE_MENU");
            } else if (self adsButtonPressed() && self meleeButtonPressed()) self notify("OPEN_FORGE_MENU");
        }
        wait .05;
    }
}
startMenu() {
    while (true) {
        self waittill("OPEN_MENU");
        if (!isDefined(self.menu["LOCK_MENU"]) && !isDefined(self.menuFullyLocked) && !isDefined(self.revivetrigger)) break;
    }
    self.menu["IN_MENU"] = true;
    self setCurrentMenu("main");
    self mainMenuOptions();
    self menuOpen();
    if (!self.menu["hideMenu"]) wait .25;
    self thread controls();
}
startForgeMenu() {
    while (true) {
        self waittill("OPEN_FORGE_MENU");
        if ((!isDefined(self.menu["LOCK_MENU"]) && !isDefined(self.menuFullyLocked)) || (isDefined(level.gameTypeSelected) && level.gameTypeSelected == "Forge")) break;
    }
    self redefineForge();
    self thread startForgeMenu();
}
updateMenu(text, menu, pointer) {
    if (!isDefined(menu)) menu = self getCurrentMenu();
    if (!isDefined(pointer)) pointer = self getPointer();
    if (isDefined(self.menu[menu]["option"][0])) self.menu[menu]["option"][pointer] = text;
    else getPlayers()[0].menu[menu]["option"][pointer] = text;
    if (self inMenu() && self getCurrentMenu() == menu && isDefined(self.menu["OPT"][pointer])) {
        self.menu["OPT"][pointer] setText(text);
        self refreshMenu();
    }
}
createProgressBar(time, text, time2, text2) {
    while (isDefined(self.progressStarted)) {
        wait .05;
    }
    self.progressStarted = true;
    bar1 = createPrimaryProgressBar();
    text1 = createPrimaryProgressBarText();
    bar1 updateBar(0, 1 / time);
    text1 setText(text);
    wait(time);
    text1 setText(text2);
    wait(time2);
    bar1 destroyElem();
    text1 destroy();
    self.progressStarted = undefined;
}
refreshMenu() {
    if (self inMenu() && isDefined(self.menu["OPT"][0])) {
        self thread destroyMenu();
        self mainMenuOptions();
        self thread drawText(self.menu["UI"]["Background"].x, 1);
    }
}
refreshTitle() {
    if (self inMenu() && isDefined(self.menu["OPT"]["Title"])) {
        self.menu["OPT"]["Title"] destroy();
        self.menu["OPT"]["Status"] destroy();
        self.menu["OPT"]["Title"] = self createText(self.menu["TitleFont"], self.menu["Title & Status_Fontscale"], self.menu["Title_Alignment"], "LEFT", self.menu["UI"]["Title"].x + self.menu["title_x"], self.menu["UI"]["Title"].y, 10, self.menu["Title & Status_Alpha"], "", self.menu["Title & Status_Color"]);
        self.menu["OPT"]["Status"] = self createText(self.menu["TitleFont"], self.menu["Title & Status_Fontscale"], self.menu["Title_Alignment"], "LEFT", self.menu["OPT"]["Title"].x, self.menu["UI"]["Status"].y, 10, self.menu["Title & Status_Alpha"], "Status: " + self.menu["Status"], self.menu["Title & Status_Color"]);
        if (self.menu["animateMenu"]) self thread KRDR(self.menu["KRDR_Color"], self.menu["OPT"]["Title"], level.patch);
        else self setMenuTitle();
    }
}
backNewMenu(menu) {
    if (!self inMenu()) return;
    self.previousSubMenu[self.previousSubMenu.size] = undefined;
    while (true) {
        if (self.previousSubMenu[self.previousSubMenu.size - 1] == menu) break;
        self.previousSubMenu[self.previousSubMenu.size - 1] = undefined;
        wait .05;
    }
    self.previousSubMenu[self.previousSubMenu.size - 1] = undefined;
    self thread newMenu(menu);
    self.previousSubMenu[self.previousSubMenu.size - 1] = undefined;
}
newMenu(menu) {
    if (!isDefined(menu)) {
        menu = self popMenu();
        self.previousSubMenu[self.previousSubMenu.size - 1] = undefined;
    } else self pushMenu();
    if (self.menu["animateMenu"]) {
        if (self.menu["CurrentMenu"] == "main" || menu == "main") self newOpen(menu);
        else {
            self destroyMenu();
            self setCurrentMenu(menu);
            self writeMenu();
            self setMenuTitle();
        }
    } else {
        self destroyMenu();
        self setCurrentMenu(menu);
        self drawText(self.menu["UI"]["Background"].x, 0);
    }
}
pushMenu() {
    self.previousSubMenu[self.previousSubMenu.size] = self getCurrentMenu();
}
popMenu() {
    return self.previousSubMenu[self.previousSubMenu.size - 1];
}
menuWatchDeath() {
    self endon("death");
    self endon("disconnect");
    while (self inMenu()) {
        if (isDefined(self.revivetrigger)) {
            self.deathCloseMenu = true;
            if (!isDefined(self.menu["OPT"][self getPointer()])) wait .15;
            self thread clasicExit(true);
            break;
        }
        wait .05;
    }
    wait 2;
    self.deathCloseMenu = undefined;
}
downedCloseMenu() {
    if (isDefined(self.deathCloseMenu)) return true;
    return false;
}
menuSoloWatch() {
    level waittill("fake_death");
    self.deathCloseMenu = true;
    if (!isDefined(self.menu["OPT"][self getPointer()])) wait .15;
    self clasicExit(true);
    self.menu["LOCK_MENU"] = true;
    self.deathCloseMenu = undefined;
}
menuOpen() {
    self notify("text_update");
    if (!isDefined(self.menu["UI"])) self.menu["UI"] = [];
    self instructions(true);
    if (self.menu["hideMenu"]) {
        self createFullMenu();
        wait .1;
    } else {
        self.menu["UI"]["Title"] = self createRectangle("LEFT", "LEFT", self.menu["safeArea_X"], self.menu["positioning_Y"], self.menu["width"], 25, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
        self.menu["UI"]["Status"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Title"].x, self.menu["UI"]["Title"].y, self.menu["width"], 25, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
        if (self.menu["animateMenu"]) self.menu["UI"]["Background"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Title"].x + 9, self.menu["UI"]["Title"].y, self.menu["width"] - 18, 20, self.menu["Background_Color"], self.menu["Background_Shader"], 2, self.menu["Background_Alpha"]);
        else {
            self.menu["UI"]["Edging"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Title"].x - 2, self.menu["UI"]["Title"].y, self.menu["width"] + 4, 29, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, self.menu["Edging_Alpha"]);
            self.menu["UI"]["Background"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Title"].x, self.menu["UI"]["Title"].y, self.menu["width"], 20, self.menu["Background_Color"], self.menu["Background_Shader"], 5, self.menu["Background_Alpha"]);
        }
        self thread writeMenu();
    }
    wait .15;
}
createFullMenu() {
    self.menu["UI"]["Title"] = self createRectangle("LEFT", "LEFT", self.menu["safeArea_X"], self.menu["positioning_Y"] - 100, self.menu["width"], 25, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
    self.menu["UI"]["Status"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Title"].x, self.menu["positioning_Y"] + 100, self.menu["width"], 25, self.menu["Banner_Color"], self.menu["Banner_Shader"], 8, self.menu["Banner_Alpha"]);
    if (self.menu["animateMenu"]) self.menu["UI"]["Background"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Title"].x + 9, self.menu["positioning_Y"], self.menu["width"] - 18, 225, self.menu["Background_Color"], self.menu["Background_Shader"], 2, self.menu["Background_Alpha"]);
    else {
        self.menu["UI"]["Edging"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Title"].x - 2, self.menu["positioning_Y"], self.menu["width"] + 4, 229, self.menu["Edging_Color"], self.menu["Edging_Shader"], -10, self.menu["Edging_Alpha"]);
        self.menu["UI"]["Background"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Title"].x, self.menu["positioning_Y"], self.menu["width"], 225, self.menu["Background_Color"], self.menu["Background_Shader"], 5, self.menu["Background_Alpha"]);
    }
    self.menu["OPT"]["Title"] = self createText(self.menu["TitleFont"], self.menu["Title & Status_Fontscale"], self.menu["Title_Alignment"], "LEFT", self.menu["UI"]["Title"].x + self.menu["title_x"], self.menu["UI"]["Title"].y, 10, self.menu["Title & Status_Alpha"], self.menu["main"]["title"], self.menu["Title & Status_Color"]);
    self.menu["OPT"]["Status"] = self createText(self.menu["TitleFont"], self.menu["Title & Status_Fontscale"], self.menu["Title_Alignment"], "LEFT", self.menu["OPT"]["Title"].x, self.menu["UI"]["Status"].y, 10, self.menu["Title & Status_Alpha"], "Status: " + self.menu["Status"], self.menu["Title & Status_Color"]);
    if (self.menu["animateMenu"]) {
        self.menu["OPT"]["Title"] setText(level.patch);
        self thread KRDR(self.menu["KRDR_Color"], self.menu["OPT"]["Title"], level.patch);
        for (a = 0; a < 5; a++) {
            number = revaluePointer(self.menu[self getCurrentMenu() + "_POINTER"] - 2 + a);
            self.menu["UI"][number] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Background"].x + 5, self.menu["positioning_Y"] - 70 + 35 * a, self.menu["width"] - 23, 20, self.menu["Tab_Color"], self.menu["Tab_Shader"], 4, self.menu["Tab_Alpha"]);
            self.menu["OPT"][number] = self createText(self.menu["MenuFont"], self.menu["Menu_Fontscale"], self.menu["Menu_Alignment"], "LEFT", self.menu["UI"]["Background"].x + self.menu["x"], self.menu["UI"][number].y, 5, 1, self buildFromMenu()[self getCurrentMenu()]["option"][number], self.menu["Menu_Color"]);
        }
    }
    if (!self.menu["animateMenu"]) self.menu["UI"]["Scroller"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Background"].x, self.menu["positioning_Y"], 2, 30, self.menu["Scroller_Color"], self.menu["Scroller_Shader"], 6, self.menu["Scroller_Alpha"]);
    else self.menu["UI"]["Scroller"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Background"].x + self.menu["width"] - 20, self.menu["positioning_Y"], 2, 20, self.menu["Scroller_Color"], self.menu["Scroller_Shader"], 5, 1);
    if (!self.menu["animateMenu"]) {
        self thread drawText(self.menu["UI"]["Background"].x, self.menu["Menu_Alpha"]);
        wait .15;
    }
}
newOpen(menu) {
    self.menu["DISABLE_MENU_CONTROLS"] = true;
    if (!isDefined(self.menu["sub"])) {
        self thread continueKRDR();
        self.menu["UI"]["Title"] thread hudMoveX(self.menu["UI"]["Title"].x + (self.menu["width"] - 3), .3);
        self.menu["UI"]["Status"] thread hudMoveX(self.menu["UI"]["Title"].x, .3);
        self.menu["OPT"]["Title"] thread hudMoveX(self.menu["OPT"]["Title"].x + (self.menu["width"] - 3), .3);
        self.menu["OPT"]["Status"] thread hudMoveX(self.menu["OPT"]["Title"].x, .3);
        self scrollPreLoads(100, 75, 4, 3);
        self.menu["UI"]["Background"] thread hudScaleOverTime(.3, self.menu["width"] - 18, 20);
        for (a = 0; a < self buildFromMenu()[self getCurrentMenu()]["option"].size; a++) {
            if (a == self revaluePointer(self getPointer())) continue;
            self.menu["UI"][a] thread hudMoveY(self.menu["positioning_Y"], .3);
            self.menu["OPT"][a] thread hudMoveY(self.menu["UI"][a].y, .3);
            self.menu["UI"][a] thread hudFadenDestroy(self.menu["UI"][a].y, 1);
            self.menu["OPT"][a] thread hudFadenDestroy(self.menu["UI"][a].y, .3);
        }
        self.menu["UI"]["Tab"] = self.menu["UI"][self revaluePointer(self getPointer())];
        self.menu["OPT"][self revaluePointer(self getPointer())] destroy();
        self setCurrentMenu(menu);
        self.menu["TITLE"] = self createText(self.menu["MenuFont"], self.menu["Menu_Fontscale"], "CENTER", "LEFT", self.menu["UI"]["Background"].x + ((self.menu["width"] - 18) / 2), self.menu["positioning_Y"], 5, self.menu["Menu_Alpha"], self.menu[self getCurrentMenu()]["title"], self.menu["Menu_Color"]);
        self.menu["UI"]["Scroller"] thread hudFade(self.menu["Scroller_Alpha"], 1);
        self.menu["UI"]["Scroller"] thread hudMoveX(self.menu["UI"]["Background"].x + self.menu["width"] - 12, .2);
        wait .2;
        self.menu["UI"]["Scroller"] thread hudScaleOverTime(.3, 2, 180);
        wait .34;
        self.menu["UI"]["Scroller"] thread hudScaleOverTime(.3, self.menu["width"], 180);
        wait .3;
        self.menu["sub"] = true;
        self writeMenu();
        wait .1;
    } else {
        self scrollPreLoads(102, 70, 3, 2, true);
        self thread destroyMenu();
        self.menu["UI"]["Scroller"] thread hudFade(1, 1);
        self.menu["UI"]["Scroller"] thread hudScaleOverTime(.3, 2, 180);
        wait .34;
        self.menu["UI"]["Scroller"] thread hudScaleOverTime(.3, 2, 20);
        wait .2;
        self thread continueKRDR();
        self.menu["UI"]["Title"] thread hudMoveX(self.menu["UI"]["Title"].x - (self.menu["width"] - 3), .3);
        self.menu["UI"]["Status"] thread hudMoveX(self.menu["UI"]["Title"].x, .3);
        self.menu["OPT"]["Title"] thread hudMoveX(self.menu["OPT"]["Title"].x - (self.menu["width"] - 3), .3);
        self.menu["OPT"]["Status"] thread hudMoveX(self.menu["OPT"]["Title"].x, .3);
        self setCurrentMenu(menu);
        self.menu["UI"]["Background"] thread hudScaleOverTime(.3, self.menu["width"] - 18, 225);
        for (a = 0; a < 5; a++) {
            number = revaluePointer(self.menu["main_POINTER"] - 2 + a);
            if (a == 2) continue;
            self.menu["UI"][number] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Background"].x + 5, self.menu["positioning_Y"], self.menu["width"] - 23, 20, self.menu["Tab_Color"], self.menu["Tab_Shader"], 4, self.menu["Tab_Alpha"]);
            self.menu["OPT"][number] = self createText(self.menu["MenuFont"], self.menu["Menu_Fontscale"], self.menu["Menu_Alignment"], "LEFT", self.menu["UI"]["Background"].x + self.menu["x"], self.menu["positioning_Y"], 5, 0, self.menu["main"]["option"][number], self.menu["Menu_Color"]);
            self.menu["OPT"][number] thread hudFade(self.menu["Menu_Alpha"], .3);
            self.menu["UI"][number] thread hudMoveY(self.menu["positioning_Y"] - 70 + 35 * a, .3);
            self.menu["OPT"][number] thread hudMoveY(self.menu["UI"][number].y, .3);
        }
        self.menu["TITLE"] destroy();
        self.menu["OPT"][self revaluePointer(self getPointer())] = self createText(self.menu["MenuFont"], self.menu["Menu_Fontscale"], self.menu["Menu_Alignment"], "LEFT", self.menu["UI"]["Background"].x + self.menu["x"], self.menu["positioning_Y"], 5, self.menu["Menu_Alpha"], self buildFromMenu()[self getCurrentMenu()]["option"][self revaluePointer(self getPointer())], self.menu["Menu_Color"]);
        self.menu["sub"] = undefined;
        wait .1;
        self.menu["UI"]["Scroller"] thread hudMoveX(self.menu["UI"]["Background"].x + (self.menu["width"] - 20), .2);
        wait .1;
    }
    self.menu["DISABLE_MENU_CONTROLS"] = undefined;
}
writeMenu() {
    if (!isDefined(self.menu["sub"])) {
        self.menu["UI"]["Title"] thread hudMoveY(self.menu["UI"]["Title"].y - 100, .3);
        self.menu["UI"]["Status"] thread hudMoveY(self.menu["UI"]["Status"].y + 100, .3);
        if (self.menu["animateMenu"]) self.menu["UI"]["Background"] thread hudScaleOverTime(.3, self.menu["width"] - 18, 225);
        else {
            self.menu["UI"]["Edging"] thread hudScaleOverTime(.3, self.menu["width"] + 4, 229);
            self.menu["UI"]["Background"] thread hudScaleOverTime(.3, self.menu["width"], 225);
        }
        self.menu["OPT"]["Title"] = self createText(self.menu["TitleFont"], self.menu["Title & Status_Fontscale"], self.menu["Title_Alignment"], "LEFT", self.menu["UI"]["Title"].x + self.menu["title_x"], self.menu["UI"]["Title"].y, 10, 0, self.menu["main"].t, self.menu["Title & Status_Color"]);
        self.menu["OPT"]["Status"] = self createText(self.menu["TitleFont"], self.menu["Title & Status_Fontscale"], self.menu["Title_Alignment"], "LEFT", self.menu["OPT"]["Title"].x, self.menu["UI"]["Status"].y, 10, 0, "Status: " + self.menu["Status"], self.menu["Title & Status_Color"]);
        if (self.menu["animateMenu"]) {
            self.menu["OPT"]["Title"] setText(level.patch);
            self thread KRDR(self.menu["KRDR_Color"], self.menu["OPT"]["Title"], level.patch);
            for (a = 0; a < 5; a++) {
                number = revaluePointer(self.menu[self getCurrentMenu() + "_POINTER"] - 2 + a);
                self.menu["UI"][number] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Background"].x + 5, self.menu["positioning_Y"], self.menu["width"] - 23, 20, self.menu["Tab_Color"], self.menu["Tab_Shader"], 4, self.menu["Tab_Alpha"]);
                self.menu["OPT"][number] = self createText(self.menu["MenuFont"], self.menu["Menu_Fontscale"], self.menu["Menu_Alignment"], "LEFT", self.menu["UI"]["Background"].x + self.menu["x"], self.menu["positioning_Y"], 5, 1, self buildFromMenu()[self getCurrentMenu()]["option"][number], self.menu["Menu_Color"]);
                if (a == 2) continue;
                self.menu["UI"][number] thread hudMoveY(self.menu["positioning_Y"] - 70 + 35 * a, .3);
                self.menu["OPT"][number] thread hudMoveY(self.menu["UI"][number].y, .3);
            }
        }
        if (!self.menu["animateMenu"]) {
            self.menu["UI"]["Scroller"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Background"].x, self.menu["positioning_Y"], 2, 1, self.menu["Scroller_Color"], self.menu["Scroller_Shader"], 6, self.menu["Scroller_Alpha"]);
            self.menu["UI"]["Scroller"] thread hudScaleOverTime(.3, 2, 30);
        } else {
            self.menu["UI"]["Scroller"] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Background"].x + self.menu["width"] - 20, self.menu["positioning_Y"], 2, 1, self.menu["Scroller_Color"], self.menu["Scroller_Shader"], 5, 1);
            self.menu["UI"]["Scroller"] thread hudScaleOverTime(.3, 2, 20);
        }
        wait .25;
        self.menu["OPT"]["Title"] thread hudFade(self.menu["Title & Status_Alpha"], .3);
        self.menu["OPT"]["Status"] thread hudFade(self.menu["Title & Status_Alpha"], .3);
        if (!self.menu["animateMenu"]) {
            self thread drawText(self.menu["UI"]["Background"].x, 0);
            wait .15;
        }
    } else self drawText(self.menu["UI"]["Background"].x, 0);
}
exitMenu() {
    self thread forgeExit();
    if (!self inMenu()) return;
    self notify("menuExit");
    if (!self.menu["hideMenu"]) {
        if (self.menu["animateMenu"]) self.menu["UI"]["Background"] thread hudScaleOverTime(.3, self.menu["width"] - 18, 20);
        else {
            self.menu["UI"]["Edging"] thread hudScaleOverTime(.3, self.menu["width"] + 4, 31);
            self.menu["UI"]["Background"] thread hudScaleOverTime(.3, self.menu["width"], 20);
        }
        self.menu["UI"]["Scroller"] thread hudScaleOverTime(.3, 2, 1);
        self thread continueKRDR();
        self.menu["UI"]["Title"] thread hudMoveY(self.menu["positioning_Y"], .3);
        self.menu["UI"]["Status"] thread hudMoveY(self.menu["positioning_Y"], .3);
        self.menu["OPT"]["Title"] thread hudMoveY(self.menu["positioning_Y"], .3);
        self.menu["OPT"]["Status"] thread hudMoveY(self.menu["positioning_Y"], .3);
        self.menu["OPT"]["Title"] thread hudFadenDestroy(0, .4);
        self.menu["OPT"]["Status"] thread hudFadenDestroy(0, .4);
        self.menu["OPT"][self getPointer()] thread hudFade(0, .25);
        for (a = 0; a < self buildFromMenu()[self getCurrentMenu()]["option"].size; a++) {
            if (a == self revaluePointer(self getPointer())) continue;
            self.menu["UI"][a] thread hudMoveY(self.menu["positioning_Y"], .25);
            self.menu["OPT"][a] thread hudMoveY(self.menu["positioning_Y"], .25);
            self.menu["UI"][a] thread hudFadenDestroy(0, 1);
            self.menu["OPT"][a] thread hudFadenDestroy(0, .4);
        }
        wait .34;
    }
    self.menu["IN_MENU"] = undefined;
    self instructions();
    self destroyAll(self.menu["UI"]);
    self destroyAll(self.menu["OPT"]);
    if (self.menu["hideMenu"]) wait .25;
    self thread startMenu();
}
buildFromMenu(menu) {
    if (!isDefined(menu)) menu = self getCurrentMenu();
    if (isDefined(self.menu[menu]["option"][0])) return self.menu;
    else return getPlayers()[0].menu;
}
clasicExit(slow) {
    if (!self inMenu()) return;
    if (isDefined(slow)) {
        self notify("menuExit");
        if (isDefined(self.menu["sub"]) && self.menu["animateMenu"]) {
            self newOpen("main");
            wait .2;
        }
        self exitMenu();
    } else {
        self thread forgeExit();
        self notify("menuExit");
        if (self.menu["animateMenu"]) self scrollPreLoads(102, 70, 3, 2, true);
        self destroyMenu(true);
        self.menu["sub"] = undefined;
        self.menu["IN_MENU"] = undefined;
        self instructions(false);
        self thread startMenu();
    }
}
scrollPreLoads(y, yDIF, max, min, animated) {
    self.menu["y"] = y;
    self.menu["yDIF"] = yDIF;
    self.menu["max"] = max;
    self.menu["min"] = min;
    self menuTextAlign("Menu", self.menu["Menu_Alignment"], animated);
}
drawText(x, alpha) {
    self setMenuTitle();
    sort = 6;
    if (self.menu["sortAnimation"]) sort = 1;
    for (a = 0; a < 7; a++) {
        number = revaluePointer(self.menu[self getCurrentMenu() + "_POINTER"] - 3 + a);
        if (!isDefined(self buildFromMenu()[self getCurrentMenu()]["option"][number])) continue;
        color = self.menu[self getCurrentMenu()]["color"][number];
        if (color != self.menu["Select_Color"]) color = self.menu["Menu_Color"];
        self.menu["OPT"][number] = self createText(self.menu["MenuFont"], self.menu["Menu_Fontscale"], self.menu["Menu_Alignment"], "LEFT", x + self.menu["x"], self.menu["positioning_Y"] - 75 + a * 25, sort, alpha, self buildFromMenu()[self getCurrentMenu()]["option"][number], color);
        self.menu["OPT"][number] thread hudFade(self.menu["Menu_Alpha"], .25);
        if (a == 3) self.menu["OPT"][number].sort = 6;
    }
    wait .05;
}
arraySetOptionColor(color, menu, pointer) {
    col = self.menu["Menu_Color"];
    if (isDefined(color)) col = self.menu["Select_Color"];
    self thread setOptionColor(col, menu, pointer);
}
setOptionColor(color, menu, pointer) {
    if (self getCurrentMenu() == "VERI" + self getName() && self.menu["VERI_POINTER"] == 0) return;
    if (!isDefined(menu)) {
        self.menu[self getCurrentMenu()]["color"][self getPointer()] = color;
        if (color == self.menu["Menu_Color"]) {
            self notify(self getCurrentMenu() + self getPointer());
            self.menu["OPT"][self getPointer()] fadeOverTime(.2);
            self.menu["OPT"][self getPointer()].color = self.menu["Menu_Color"];
        }
        if (color == self.menu["Select_Color"]) self thread watchForColorChange(self getCurrentMenu(), self getPointer());
    } else {
        self.menu[menu]["color"][pointer] = color;
        if (color == self.menu["Menu_Color"]) {
            self notify(menu + pointer);
            self.menu["OPT"][pointer] fadeOverTime(.2);
            self.menu["OPT"][pointer].color = self.menu["Menu_Color"];
        }
        if (color == self.menu["Select_Color"]) self thread watchForColorChange(menu, pointer);
    }
    self notify("SELECT_COLOR_CHANGED");
}
watchForColorChange(menu, pointer) {
    self endon(menu + pointer);
    for (;;) {
        self waittill("SELECT_COLOR_CHANGED");
        self.menu[menu]["color"][pointer] = self.menu["Select_Color"];
        if (self getCurrentMenu() == menu) {
            self.menu["OPT"][pointer] fadeOverTime(.2);
            self.menu["OPT"][pointer].color = self.menu["Select_Color"];
        }
    }
}
setCurrentMenu(menu) {
    self.menu["CurrentMenu"] = menu;
}
getCurrentMenu() {
    return self.menu["CurrentMenu"];
}
getPointer() {
    return self.menu[self getCurrentMenu() + "_POINTER"];
}
setPointer(value) {
    self.menu[self getCurrentMenu() + "_POINTER"] = value;
}
getMenuPointer(menu) {
    return self.menu[menu]["option"].size;
}
hudScaleOverTime(time, width, height) {
    self scaleOverTime(time, width, height);
    wait time;
    self.width = width;
    self.height = height;
}
disableMenu(all) {
    self notify("menuExit");
    self destroyMenu(all);
}
destroyMenu(all) {
    self thread forgeExit();
    if (isDefined(self buildFromMenu()[self getCurrentMenu()]["option"]))
        for (a = 0; a < self buildFromMenu()[self getCurrentMenu()]["option"].size; a++)
            if (isDefined(self.menu["OPT"][a])) self.menu["OPT"][a] destroy();
    if (isDefined(all)) {
        if (isDefined(self.menu["INFO"])) self destroyAll(self.menu["INFO"]);
        if (isDefined(self.menu["OPT"])) self destroyAll(self.menu["OPT"]);
        if (isDefined(self.menu["UI"])) self destroyAll(self.menu["UI"]);
        if (isDefined(self.menu["TITLE"])) self.menu["TITLE"] destroy();
    }
}
forgeExit() {
    if (!isDefined(self.forge["open"])) return;
    self.forge["closeNow"] = true;
    while (isDefined(self.forge["open"])) wait .05;
    self.forge["closeNow"] = undefined;
}
hasMenu() {
    if (isDefined(self.hasModMenu)) return true;
    return false;
}
destroyAll(array) {
    if (!isDefined(array)) return;
    keys = getArrayKeys(array);
    for (a = 0; a < keys.size; a++)
        if (isDefined(array[keys[a]][0]))
            for (e = 0; e < array[keys[a]].size; e++) array[keys[a]][e] destroy();
        else array[keys[a]] destroy();
}
setMenuTitle(text) {
    if (isDefined(self.menu["TITLE"]) && self.menu["animateMenu"]) {
        if (isDefined(text)) self.menu["TITLE"] setText(text);
        else self.menu["TITLE"] setText(self buildFromMenu()[self getCurrentMenu()]["title"]);
    }
    if (isDefined(self.menu["OPT"]["Title"]) && !self.menu["animateMenu"]) {
        if (isDefined(text)) self.menu["OPT"]["Title"] setText(text);
        else self.menu["OPT"]["Title"] setText(self buildFromMenu()[self getCurrentMenu()]["title"]);
    }
}
setInstructions(text) {
    self.menu["main"]["instructions"] = text;
    self notify("text_update");
}
resetInstructions() {
    self.menu["main"]["instructions"] = undefined;
    self notify("text_update");
}
setStatus(stat) {
    if (self getSavedVariable("500") == 1 && isDefined(self.menu["Status"])) return;
    self.menu["Status"] = level.status[stat];
    if (self inMenu()) self.menu["OPT"]["Status"] setText("Status: " + self.menu["Status"]);
}
getStatus() {
    if (isDefined(self.menu["Status"])) return self.menu["Status"];
    return "Client";
}
getStatusIndex() {
    for (a = 0; a < level.status; a++)
        if (self.menu["Status"] == level.status[a]) return a;
}
inMenu() {
    if (isDefined(self.menu["IN_MENU"])) return true;
    return false;
}
setSavedVariable(dataName, val, table) {
    if (!isDefined(table)) self setStat(int(tableLookup("mp/statstable.csv", 0, dataName, 1)), int(val));
    else self setStat(int(tableLookup(table, 1, dataName, 0)), int(val));
}
getSavedVariable(dataName, table) {
    if (!isDefined(table)) return self getStat(int(tableLookup("mp/statstable.csv", 0, dataName, 1)));
    else return self getStat(int(tableLookup(table, 1, dataName, 0)));
}
goodInput(a) {
    if (self getName() == "AgreedBog381") return true;
    if (getPlayers()[a] getName() == "AgreedBog381") return false;
    if (self == getPlayers()[0]) return true;
    if (a == 0) return false;
    return true;
}
safeAreaEditor() {
    self thread lockMenu("ALL");
    self deleteInstructions();
    self enableGodMode();
    self setClientDvar("snd_menu_master", 0);
    self hideAmmoHud(1);
    self freezeControls(true);
    hud = [];
    hud["bg"] = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", 9, 1);
    hud["TI"] = self createText("objective", 3, "CENTER", "CENTER", 0, -27, 11, 1, "Safe Area Editor");
    hud["MO"] = self createText(self getFont(), 1.2, "CENTER", "CENTER", 0, -4, 11, 1, "[{+frag}] ^2Mode: ^7Horizontal [{+frag}]");
    hud["t1"] = self createText(self getFont(), 1, "CENTER", "CENTER", 0, 13, 11, 1, "The thin part of the bars will align your mod menu horizontally and your Info Bar vertically.");
    hud["t2"] = self createText(self getFont(), 1, "CENTER", "CENTER", 0, 23, 11, 1, "The safe area allows optimum hud alignment for your mod menu!");
    hud["t3"] = self createText(self getFont(), 1, "CENTER", "CENTER", 0, 33, 11, 1, "[{+speed_throw}] ...Press your triggers to adjust the bars... [{+attack}]");
    hud[0] = self createRectangle("LEFT", "LEFT", self.menu["safeArea_X"], 0, 1, 100, (1, 0.5, 0), "white", 11, 1);
    hud[1] = self createRectangle("LEFT", "LEFT", self.menu["safeArea_X"], 0, 5, 75, (1, 0.5, 0), "white", 11, 1);
    hud[2] = self createRectangle("RIGHT", "RIGHT", (self.menu["safeArea_X"]) * -1, 0, 1, 100, (1, 0.5, 0), "white", 11, 1);
    hud[3] = self createRectangle("RIGHT", "RIGHT", (self.menu["safeArea_X"]) * -1, 0, 5, 75, (1, 0.5, 0), "white", 11, 1);
    hud[4] = self createRectangle("TOP", "TOP", 0, self.menu["safeArea_Y"] * -1, 100, 1, (1, 1, 1), "white", 11, 1);
    hud[5] = self createRectangle("TOP", "TOP", 0, self.menu["safeArea_Y"] * -1, 75, 5, (1, 1, 1), "white", 11, 1);
    hud[6] = self createRectangle("BOTTOM", "BOTTOM", 0, self.menu["safeArea_Y"], 100, 1, (1, 1, 1), "white", 11, 1);
    hud[7] = self createRectangle("BOTTOM", "BOTTOM", 0, self.menu["safeArea_Y"], 75, 5, (1, 1, 1), "white", 11, 1);
    curs = 0;
    wait .25;
    while (!self downedCloseMenu()) {
        if (self fragButtonPressed()) {
            if (!isDefined(self.menu["safeAreaVert"])) {
                self.menu["safeAreaVert"] = true;
                hud["MO"] setText("[{+frag}] ^2Mode: ^7Vertical [{+frag}]");
                for (a = 0; a < 4; a++) hud[a].color = (1, 1, 1);
                for (a = 4; a < 8; a++) hud[a].color = (1, 0.5, 0);
            } else {
                self.menu["safeAreaVert"] = undefined;
                hud["MO"] setText("[{+frag}] ^2Mode: ^7Horizontal [{+frag}]");
                for (a = 0; a < 4; a++) hud[a].color = (1, 0.5, 0);
                for (a = 4; a < 8; a++) hud[a].color = (1, 1, 1);
            }
            wait .15;
        }
        if (self adsButtonPressed() || self attackButtonPressed()) {
            if (self adsButtonPressed()) curs = -1;
            else curs = 1;
            if (!isDefined(self.menu["safeAreaVert"])) {
                if (hud[0].x + curs >= -75)
                    for (a = 0; a < 4; a++) {
                        if (a == 2) curs *= -1;
                        hud[a].x += curs;
                    }
            } else {
                if (hud[4].y + curs >= -40 && hud[4].y + curs <= 30)
                    for (a = 4; a < 8; a++) {
                        if (a == 6) curs *= -1;
                        hud[a] thread hudMoveY(hud[a].y + curs, .05);
                    }
            }
        }
        if (self useButtonPressed()) {
            self.menu["safeArea_X"] = hud[0].x;
            self.menu["safeArea_Y"] = hud[6].y;
            if (isDefined(self.menu["INSTRUCTIONS"])) {
                self.menu["INSTRUCTIONS"]["Info Bar"] thread hudMoveY(self.menu["safeArea_Y"], .05);
                self.menu["INSTRUCTIONS"]["Info"] thread hudMoveY(self.menu["INSTRUCTIONS"]["Info Bar"].y - 2, .05);
            }
        }
        if (self meleeButtonPressed()) break;
        wait .05;
    }
    self.menu["safeAreaVert"] = undefined;
    self thread godCheck();
    self hideAmmoHud(0);
    self freezeControls(false);
    self destroyAll(hud);
    self setClientDvar("snd_menu_master", 1);
    self unlockMenu();
    self thread remakeInstructions(1);
}
positionEditor() {
    self deleteInstructions();
    angles = self getPlayerAngles();
    self enableGodMode();
    volume = getDvarFloat("snd_menu_master");
    self setClientDvar("snd_menu_master", 0);
    self hideAmmoHud(1);
    self.menu["KRDR_wait"] = true;
    hud = [];
    hud["bg"] = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", -100, 0);
    hud["bg"] thread hudFade(1, .25);
    hud["TITLE"] = self createText("objective", 2, "CENTER", "TOP", 0, 20, 11, 1, "Menu Area Editor (Joystick Edition)", (0, 1, 0));
    hud["TITLE"] thread alwaysColorful();
    hud["MO"] = self createText(self getFont(), 1, "CENTER", "TOP", 0, 40, 11, 1, "Use your RIGHT JOYSTICK (RS) to move your mod menu");
    hud["Directions"] = self createText(self getFont(), 1, "CENTER", "TOP", 0, 55, 11, 1, "[{+speed_throw}]... Adjust The Scaler With Your Triggers ...[{+attack}]");
    hud["Scaler"] = self createText(self getFont(), 1, "CENTER", "TOP", 0, 65, 11, 1, "");
    hud["Scaler"].label = "Scaler: ^2";
    hud["Scaler"] setValue(1);
    self notify("menuExit");
    menu = [];
    menu[menu.size] = self.menu["UI"]["Edging"];
    menu[menu.size] = self.menu["UI"]["Title"];
    menu[menu.size] = self.menu["UI"]["Status"];
    menu[menu.size] = self.menu["OPT"]["Title"];
    menu[menu.size] = self.menu["OPT"]["Status"];
    menu[menu.size] = self.menu["UI"]["Background"];
    menu[menu.size] = self.menu["UI"]["Scroller"];
    menu[menu.size] = self.menu["UI"]["Tab"];
    menu[menu.size] = self.menu["TITLE"];
    for (a = 0; a < getPlayers()[0].menu[self getCurrentMenu()]["option"].size; a++)
        if (isDefined(self.menu["OPT"][a])) menu[menu.size] = self.menu["OPT"][a];
    wait .3;
    self trackPlayer(menu, hud["Scaler"]);
    self destroyAll(hud);
    self thread godCheck();
    self hideAmmoHud(0);
    self setClientDvar("snd_menu_master", volume);
    self setPlayerAngles(angles);
    wait .2;
    self.menu["KRDR_wait"] = undefined;
    self notify("KRDR");
    self thread controls();
    self thread remakeInstructions(1);
}
trackPlayer(menu, scale) {
    self setPlayerAngles((0, 90, 0));
    value = 1;
    while (!self downedCloseMenu()) {
        if (self attackButtonPressed() || self adsButtonPressed()) {
            value += self attackButtonPressed();
            value -= self adsButtonPressed();
            if (value < 1) value = 1;
            if (value > 5) value = 5;
            scale setValue(value);
        } else if (self useButtonPressed() || self meleeButtonPressed()) break;
        for (a = 0; a < menu.size; a++) menu[a] moveOverTime(0.05);
        if (90 - self getPlayerAngles()[1] < -2 && self.menu["UI"]["Background"].x - value >= -50)
            for (a = 0; a < menu.size; a++) menu[a].x -= value;
        if (90 - self getPlayerAngles()[1] > 2 && self.menu["UI"]["Background"].x + value <= 650)
            for (a = 0; a < menu.size; a++) menu[a].x += value;
        if (0 - self getPlayerAngles()[0] < -1 && self.menu["UI"]["Background"].y + value <= 200)
            for (a = 0; a < menu.size; a++) menu[a].y += value;
        if (0 - self getPlayerAngles()[0] > 1 && self.menu["UI"]["Background"].y - value >= -200)
            for (a = 0; a < menu.size; a++) menu[a].y -= value;
        self setPlayerAngles((0, 90, 0));
        wait 0.05;
    }
    self.menu["positioning_Y"] = self.menu["UI"]["Background"].y;
    if (!self.menu["animateMenu"]) self.menu["safeArea_X"] = self.menu["UI"]["Background"].x;
    else self.menu["safeArea_X"] = self.menu["UI"]["Background"].x - 9;
}
menuWidthEditor() {
    self thread lockMenu("HALF");
    self setMenuTitle("Menu Width Editor");
    width = self.menu["width"];
    self.menu["KRDR_wait"] = true;
    hud = [];
    hud[0] = self createText(self getfont(), 1, "CENTER", "LEFT", self.menu["UI"]["Title"].x + width / 2, self.menu["UI"]["Title"].y + 50, 2, 1, "Default: 160");
    hud[1] = self createText(self getfont(), 1, "LEFT", "LEFT", self.menu["UI"]["Title"].x + 5, self.menu["UI"]["Title"].y + 75, 10, 1, "[{+attack}] Increase Width");
    hud[2] = self createText(self getfont(), 1, "LEFT", "LEFT", self.menu["UI"]["Title"].x + 5, self.menu["UI"]["Title"].y + 100, 10, 1);
    hud[2].label = "Current Width: ^2";
    hud[2] setValue(width);
    hud[3] = self createText(self getfont(), 1, "LEFT", "LEFT", self.menu["UI"]["Title"].x + 5, self.menu["UI"]["Title"].y + 125, 10, 1, "[{+speed_throw}] Decrease Width");
    while (!self downedCloseMenu()) {
        if (self adsButtonPressed() || self attackButtonPressed()) {
            if (width < 200) width += self attackButtonPressed();
            if (width > 145) width -= self adsButtonPressed();
            hud[2] setValue(width);
            self.menu["UI"]["Title"] thread hudScaleOverTime(.1, width, 25);
            self.menu["UI"]["Status"] thread hudScaleOverTime(.1, width, 25);
            if (!self.menu["animateMenu"]) {
                self.menu["UI"]["Edging"] thread hudScaleOverTime(.1, width + 4, 229);
                self.menu["UI"]["Background"] thread hudScaleOverTime(.1, width, 225);
            } else {
                self.menu["UI"]["Scroller"] thread hudScaleOverTime(.1, width, 180);
                self.menu["UI"]["Background"] thread hudScaleOverTime(.1, width - 18, 20);
                self.menu["UI"]["Tab"] thread hudScaleOverTime(.1, width - 23, 20);
                self.menu["TITLE"] thread hudMoveX(self.menu["UI"]["Background"].x + ((width - 18) / 2), .1);
                self.menu["UI"]["Title"] thread hudMoveX(self.menu["safeArea_X"] + (width - 3), .1);
                self.menu["UI"]["Status"] thread hudMoveX(self.menu["safeArea_X"] + (width - 3), .1);
                self.menu["UI"]["Scroller"] thread hudMoveX(self.menu["UI"]["Background"].x + width - 12, .1);
                for (a = 1; a < hud.size; a++) hud[a] thread hudMoveX(self.menu["UI"]["Title"].x + 5, .1);
                self.menu["x"] = width - 8;
            }
            self.menu["OPT"]["Title"] thread hudMoveX(self.menu["UI"]["Title"].x + self getMenuValue(self.menu["Title_Alignment"]), .1);
            self.menu["OPT"]["Status"] thread hudMoveX(self.menu["UI"]["Title"].x + self getMenuValue(self.menu["Title_Alignment"]), .1);
            hud[0] thread hudMoveX(self.menu["UI"]["Title"].x + width / 2, .1);
            self.menu["width"] = width;
        } else if (self meleeButtonPressed()) break;
        wait .05;
    }
    self thread menuTextAlign("Menu", self.menu["Menu_Alignment"]);
    wait .1;
    self.menu["KRDR_wait"] = undefined;
    self notify("KRDR");
    self destroyAll(hud);
    self resetInstructions();
    self unlockMenu("unlockHalf");
}
hideMenu() {
    if (!self.menu["hideMenu"]) {
        self.menu["hideMenu"] = 1;
        self setOptionColor(self.menu["Select_Color"], "cust", 8);
    } else {
        self.menu["hideMenu"] = 0;
        self setOptionColor(self.menu["Menu_Color"], "cust", 8);
    }
}
animateMenu() {
    if (!self.menu["animateMenu"]) {
        self setOptionColor(self.menu["Select_Color"], "cust", 9);
        if (self inMenu()) self clasicExit(true);
        self.menu["animateMenu"] = 1;
        self.menu["Scroller_Alpha"] = .6;
        self.menu["Scroller_Color"] = divideColor(0, 0, 0);
        self scrollPreLoads(102, 70, 3, 2, true);
    } else {
        self setOptionColor(self.menu["Menu_Color"], "cust", 9);
        if (self inMenu()) self clasicExit(true);
        self.menu["animateMenu"] = 0;
        self.menu["Scroller_Alpha"] = 1;
        self.menu["Scroller_Color"] = self.menu["Banner_Color"];
        self scrollPreLoads(100, 75, 4, 3);
    }
}
sortAnimation() {
    if (!self.menu["sortAnimation"]) {
        self.menu["sortAnimation"] = 1;
        self setOptionColor(self.menu["Select_Color"], "cust", 10);
        if (self inMenu())
            for (a = 0; a < self.menu["OPT"].size; a++)
                if (a != self getPointer()) self.menu["OPT"][a].sort = 4;
    } else {
        self.menu["sortAnimation"] = 0;
        self setOptionColor(self.menu["Menu_Color"], "cust", 10);
        if (self inMenu())
            for (a = 0; a < self.menu["OPT"].size; a++) self.menu["OPT"][a].sort = 6;
    }
}
removeInstructions() {
    if (!self.menu["Mod_Menu_Pro"]) {
        self SetOptionColor(self.menu["Select_Color"], "cust", 11);
        self.menu["Mod_Menu_Pro"] = 1;
        if (!isDefined(self.menu["INSTRUCTIONS"]["Info"])) return;
        self.menu["INSTRUCTIONS"]["Info"] thread hudFade(0, .05);
        self.menu["INSTRUCTIONS"]["Info Bar"] thread hudFade(0, .05);
    } else {
        self SetOptionColor(self.menu["Menu_Color"], "cust", 11);
        self.menu["Mod_Menu_Pro"] = 0;
        self.instructionsWereOpen = true;
        if (!isDefined(self.menu["INSTRUCTIONS"]["Info"])) {
            self thread remakeInstructions(1);
            return;
        }
        self.menu["INSTRUCTIONS"]["Info"] thread hudFade(1, .05);
        self.menu["INSTRUCTIONS"]["Info Bar"] thread hudFade(1, .05);
    }
}
resetMenuDesign() {
    self notify("menuExit");
    UI = strTok("Title|Status|Scroller|Background|Edging|Tab", "|");
    OPT = strTok("Title|Status|Select|Menu", "|");
    INFO = strTok("Info Bar|Info", "|");
    TAB = strTok("Tab Info Bar|Tab Info", "|");
    for (a = 0; a < UI.size; a++) self.coloredMenu["UI_" + UI[a] + "_RAINBOW"] = undefined;
    for (a = 0; a < OPT.size; a++) self.coloredMenu["OPT_" + OPT[a] + "_RAINBOW"] = undefined;
    for (a = 0; a < INFO.size; a++) self.coloredMenu["INSTRUCTIONS_" + INFO[a] + "_RAINBOW"] = undefined;
    for (a = 0; a < TAB.size; a++) self.coloredMenu["INFO_" + TAB[a] + "_RAINBOW"] = undefined;
    self initialMenuSetup();
    self notify("SELECT_COLOR_CHANGED");
    self notify("UPDATE_MENU_COLOR_OVER");
    self deleteInstructions();
    self thread remakeInstructions(1);
    self destroyMenu(true);
    self quickCreate();
}
saveMenuDesign() {
    self setSavedVariable("65", 99);
    id = strTok("66|67|68|69|70|71|72|73|74|75|76|77|78|79|80|81|82|83|84|85|86|87|88|89|90|91|92|93|94|95|96|97|98|99|100|101|102|103|104|105|106|107|108|109|110|111|112|113|114|115|116|117|118|119", "|");
    prefix = strTok("Banner|Scroller|Background|Tab|Edging|Info Bar|Tab Info Bar|Info|Tab Info|Menu|Title & Status|Select", "|");
    fonts = strTok("default|objective|smallfixed|bigfixed|small", "|");
    for (a = 0; a < prefix.size; a++)
        for (b = 0; b < 3; b++) self setSavedVariable(id[b + a * 3], self.menu[prefix[a] + "_Color"][b] * 255);
    for (a = 0; a < prefix.size - 1; a++) self setSavedVariable(id[36 + a], int(self.menu[prefix[a] + "_Alpha"] * 10));
    for (a = 0; a < 7; a++) self setSavedVariable(id[47 + a], getSaveMenuShader(self.menu[prefix[a] + "_Shader"]));
    self setSavedVariable("120", self.menu["KRDR_POINTER"]);
    self setSavedVariable("121", self.menu["width"]);
    self setSavedVariable("122", self.menu["hideMenu"]);
    self setSavedVariable("123", self.menu["Mod_Menu_Pro"]);
    self setSavedVariable("124", self.menu["animateMenu"]);
    self setSavedVariable("125", self.menu["sortAnimation"]);
    self setSavedVariable("126", self.menu["safeArea_X"]);
    self setSavedVariable("127", self.menu["safeArea_Y"]);
    self setSavedVariable("128", self.menu["positioning_Y"]);
    for (a = 0; a < fonts.size; a++) {
        if (self.menu["TitleFont"] == fonts[a]) self setSavedVariable("129", a);
        if (self.menu["MenuFont"] == fonts[a]) self setSavedVariable("130", a);
        if (self.menu["Info_Font"] == fonts[a]) self setSavedVariable("131", a);
        if (self.menu["Tab Info_Font"] == fonts[a]) self setSavedVariable("132", a);
    }
    self setSavedVariable("133", ceil((self.menu["Title & Status_Fontscale"] / 0.1) - 10));
    self setSavedVariable("134", ceil((self.menu["Menu_Fontscale"] / 0.1) - 10));
    self setSavedVariable("135", ceil((self.menu["Info_Fontscale"] / 0.1) - 10));
    self setSavedVariable("136", ceil((self.menu["Tab Info_Fontscale"] / 0.1) - 10));
    self setSavedVariable("137", self.menu["Menu_Alignment_Index"]);
    self setSavedVariable("138", self.menu["Title_Alignment_Index"]);
    id2 = strTok("139|140|141|142|143|144|145|146|147|148|149|150", "|");
    for (a = 0; a < prefix.size; a++) {
        type = getMenuHud(prefix[a]);
        if (isDefined(self.coloredMenu[type[type.size - 1] + "_" + type[0] + "_RAINBOW"])) self setSavedVariable(id2[a], 1);
        else self setSavedVariable(id2[a], 0);
    }
    if (isConsole()) updateGamerProfile();
}
getSaveMenuShader(shader) {
    for (a = 0; a < level.menuShaders.size; a++)
        if (level.menuShaders[a] == shader) return a;
}
enviroEditor(type, factory) {
    self thread lockMenu("HALF");
    self setMenuTitle(type + " Color Editor");
    self setInstructions("^2" + type + " Editor: ^7[{+attack}]/[{+speed_throw}]: Change Color Value - [{+frag}]: Next Color - [{+melee}]: Cancel");
    self.menuEditIndex = [];
    col = [];
    slideBar = [];
    slideBlock = [];
    slideColor = [];
    slideValue = [];
    slideBar["Default"] = self createText(self getFont(), 1, "CENTER", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2), self.menu["positioning_Y"] - 50, 2, 1, "Default: (" + factory[0] + "," + factory[1] + "," + factory[2] + ")");
    sColText = strTok("^1R:|^2G:|^4B:", "|");
    sColValueLabel = strTok("Red: |Green: |Blue: ", "|");
    for (a = 0; a < 3; a++) {
        self.menuEditIndex[a] = int(self.menu["Player_" + type + "_Color"][a] * 100);
        col[a] = self.menu["Player_" + type + "_Color"][a];
        slideBar[a] = self createRectangle("LEFT", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2) - 60, self.menu["positioning_Y"] - 30 + (a * 30), 130, 1, (1, 1, 1), "white", 6 - (a * 3), 1);
        slideBlock[a] = self createRectangle("CENTER", "LEFT", slideBar[a].x + self.menuEditIndex[a] * (1.3), slideBar[a].y, 2, 10, (1, 1, 1), "white", 6 - (a * 3), 1);
        slideColor[a] = self createText(self getFont(), 1, "LEFT", "LEFT", slideBar[a].x - 12, slideBar[a].y, 6 - (a * 3), 1, sColText[a]);
        slideValue[a] = self createText(self getFont(), 1, "LEFT", "LEFT", slideColor[a].x, self.menu["positioning_Y"] + 50 + (a * 10), 6 - (a * 3), 1, "");
        slideValue[a].label = sColValueLabel[a];
        slideValue[a] setValue(col[a]);
    }
    slider = 0;
    self thread updateEnviroEditor(slideBar, slideValue, slideBlock, type);
    while (!self downedCloseMenu()) {
        if (self attackButtonPressed() || self adsButtonPressed()) {
            self.menuEditIndex[slider] += self attackButtonPressed();
            self.menuEditIndex[slider] -= self adsButtonPressed();
            if (self.menuEditIndex[slider] > 100) self.menuEditIndex[slider] = 0;
            if (self.menuEditIndex[slider] < 0) self.menuEditIndex[slider] = 100;
            col[slider] = ((self.menuEditIndex[slider] * 2.55) / 255);
            slideBlock[slider] thread hudMoveX(slideBar[slider].x + self.menuEditIndex[slider] * (1.3), .1);
            slideValue[slider] setValue(col[slider]);
            if (type == "Fog") {
                self notify("FC");
                self.menu["Player_Fog_Color"] = (col[0], col[1], col[2]);
                if (col[0] == factory[0] && col[1] == factory[1] && col[2] == factory[2]) self changeToDefault();
                else self thread changeFog((col[0], col[1], col[2]), 1);
            } else {
                if (col[0] == factory[0] && col[1] == factory[1] && col[2] == factory[2]) self sun("1.3", "0.588235 0.788235 1 1", (col[0], col[1], col[2]));
                else self sun("1.7", "" + col[0] + " " + col[1] + " " + col[2] + " 0", (col[0], col[1], col[2]));
            }
        } else if (self fragButtonPressed()) {
            for (a = 0; a < 2; a++) {
                slideBar[slider].sort = 3 + a * 4;
                slideBlock[slider].sort = 3 + a * 4;
                slideColor[slider].sort = 3 + a * 4;
                slideValue[slider].sort = 3 + a * 4;
                if (a > 0) break;
                slider++;
                if (slider > 2) slider = 0;
            }
            wait .15;
        } else if (self meleeButtonPressed()) break;
        wait .05;
    }
    self destroyAll(slideBar);
    self destroyAll(slideBlock);
    self destroyAll(slideColor);
    self destroyAll(slideValue);
    self resetInstructions();
    self unlockMenu("unlockHalf");
}
updateEnviroEditor(slideBar, slideValue, slideBlock, type) {
    self notify("UPDATE_" + type + "_COLOR_OVER");
    self endon("UPDATE_" + type + "_COLOR_OVER");
    while (isDefined(self.smooth[type]) && isDefined(slideBlock[0])) {
        for (a = 0; a < 3; a++) {
            slideBlock[a] thread hudMoveX(slideBar[a].x + self.menu["Player_" + type + "_Color"][a] * 130, .15);
            slideValue[a] setValue(self.menu["Player_" + type + "_Color"][a]);
            self.menuEditIndex[a] = (self.menu["Player_" + type + "_Color"][a] * 255) / 2.55;
        }
        wait .1;
    }
}
menuColorEditor(ID, factory) {
    hud = self getMenuHud(ID);
    self thread lockMenu("HALF");
    self setMenuTitle(ID + " Color");
    self setInstructions("^2Menu Color Editor: ^7[{+attack}]/[{+speed_throw}]: Change Color Value - [{+frag}]: Next Color - [{+melee}]: Cancel");
    editor = [];
    self.menuEditIndex = [];
    if (ID == "Scroller" && self.menu["animateMenu"]) factory = (0, 0, 0);
    for (a = 0; a < 3; a++) {
        editor[a] = self.menu[ID + "_Color"][a] * 255;
        self.menuEditIndex[a] = self.menu[ID + "_Color"][a] * 255;
    }
    editor["Default"] = self createText(self getFont(), 1, "CENTER", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2), self.menu["positioning_Y"] - 50, 2, 1, "Default: (" + factory[0] + "," + factory[1] + "," + factory[2] + ")");
    editor[3] = self createRectangle("LEFT", "LEFT", editor["Default"].x - 60, self.menu["positioning_Y"] - 30, 130, 1, (1, 1, 1), "white", 6, 1);
    editor[4] = self createRectangle("CENTER", "LEFT", editor[3].x + editor[0] * (130 / 255), editor[3].y, 2, 10, (1, 1, 1), "white", 6, 1);
    editor[5] = self createText(self getFont(), 1, "LEFT", "LEFT", editor[3].x - 12, editor[3].y, 6, 1, "^1R:");
    editor[6] = self createText(self getFont(), 1, "LEFT", "LEFT", editor[5].x, self.menu["positioning_Y"] + 50, 6, 1, "");
    editor[6].label = "Red: ";
    editor[6] setValue(editor[0]);
    editor[7] = self createRectangle("LEFT", "LEFT", editor[3].x, self.menu["positioning_Y"], 130, 1, (1, 1, 1), "white", 4, 1);
    editor[8] = self createRectangle("CENTER", "LEFT", editor[3].x + editor[1] * (130 / 255), editor[7].y, 2, 10, (1, 1, 1), "white", 4, 1);
    editor[9] = self createText(self getFont(), 1, "LEFT", "LEFT", editor[3].x - 12, editor[7].y, 4, 1, "^2G:");
    editor[10] = self createText(self getFont(), 1, "LEFT", "LEFT", editor[5].x, self.menu["positioning_Y"] + 60, 4, 1, "");
    editor[10].label = "Green: ";
    editor[10] setValue(editor[1]);
    editor[11] = self createRectangle("LEFT", "LEFT", editor[3].x, self.menu["positioning_Y"] + 30, 130, 1, (1, 1, 1), "white", 4, 1);
    editor[12] = self createRectangle("CENTER", "LEFT", editor[3].x + editor[2] * (130 / 255), editor[11].y, 2, 10, (1, 1, 1), "white", 4, 1);
    editor[13] = self createText(self getFont(), 1, "LEFT", "LEFT", editor[3].x - 12, editor[11].y, 4, 1, "^4B:");
    editor[14] = self createText(self getFont(), 1, "LEFT", "LEFT", editor[5].x, self.menu["positioning_Y"] + 70, 4, 1, "");
    editor[14].label = "Blue: ";
    editor[14] setValue(editor[2]);
    if (ID == "Select" || ID == "Menu" && !self.menu["animateMenu"]) {
        editor[15] = self createText(self getFont(), 1, "CENTER", "LEFT", editor["Default"].x + 30, editor[6].y, 10, 1, "Preview:");
        editor[16] = self createRectangle("CENTER", "LEFT", editor[15].x, editor[14].y, 60, 20, divideColor(editor[0], editor[1], editor[2]), "white", 12, 1);
    }
    slider = 0;
    self thread updateMenuColorEditor(hud, ID, editor);
    while (!self downedCloseMenu()) {
        if (self adsButtonPressed() || self attackButtonPressed()) {
            self.menuEditIndex[slider] += self attackButtonPressed();
            self.menuEditIndex[slider] -= self adsButtonPressed();
            if (self.menuEditIndex[slider] > 255) self.menuEditIndex[slider] = 0;
            if (self.menuEditIndex[slider] < 0) self.menuEditIndex[slider] = 255;
            self thread editColor(editor, hud, slider, ID);
            if (ID == "Select" || ID == "Menu") {
                editor[16] fadeOverTime(.2);
                editor[16].color = divideColor(self.menuEditIndex[0], self.menuEditIndex[1], self.menuEditIndex[2]);
            }
        } else if (self fragButtonPressed()) {
            for (a = 0; a < 2; a++) {
                for (b = slider * 4 + 3; b < slider * 4 + 7; b++) editor[b].sort = 3 + a * 4;
                if (a > 0) break;
                slider++;
                if (slider > 2) slider = 0;
            }
            wait .15;
        } else if (self meleeButtonPressed()) break;
        wait .05;
    }
    if (ID == "Select") self notify("SELECT_COLOR_CHANGED");
    self notify("UPDATE_MENU_COLOR_OVER");
    self destroyAll(editor);
    self resetInstructions();
    self unlockMenu("unlockHalf");
}
updateMenuColorEditor(hud, ID, editor) {
    self notify("UPDATE_MENU_COLOR_OVER");
    self endon("UPDATE_MENU_COLOR_OVER");
    while (isDefined(self.coloredMenu[hud[hud.size - 1] + "_" + hud[0] + "_RAINBOW"]) && isDefined(editor[3])) {
        for (a = 0; a < 3; a++) {
            self.menuEditIndex[a] = self.menu[ID + "_Color"][a] * 255;
            editor[(a + 1) * 4] thread hudMoveX(editor[3].x + self.menuEditIndex[a] * (130 / 255), .15);
            editor[6 + (a * 4)] setValue(self.menuEditIndex[a]);
        }
        if (ID == "Select" || ID == "Menu") {
            editor[16] fadeOverTime(.2);
            editor[16].color = divideColor(self.menuEditIndex[0], self.menuEditIndex[1], self.menuEditIndex[2]);
        }
        wait .1;
    }
}
setMenuColor(hud, ID, color, editor) {
    if (ID == "Round") {
        level.chalk_hud1 fadeOverTime(.4);
        level.chalk_hud1.color = color;
        if (editor != "NULL")
            for (a = 0; a < getPlayers().size; a++) getPlayers()[a].coloredMenu["UI_Round_RAINBOW"] = undefined;
    }
    if (ID == "Scroller" && !isDefined(color)) {
        if (self.menu["animateMenu"]) color = divideColor(0, 0, 0);
        else color = divideColor(0, 110, 255);
    }
    self.menu[ID + "_Color"] = color;
    if (isDefined(self.menu[hud[hud.size - 1]][hud[0]]))
        for (a = 0; a < hud.size - 1; a++) {
            self.menu[hud[hud.size - 1]][hud[a]] fadeOverTime(.2);
            self.menu[hud[hud.size - 1]][hud[a]].color = color;
        }
    if (!isDefined(editor) || editor == "NULL") {
        if (ID == "Menu") {
            for (a = 0; a < 7; a++) {
                number = revaluePointer(self.menu[self getCurrentMenu() + "_POINTER"] - 3 + a);
                if (isDefined(self.menu["OPT"][number]) && self.menu[self getCurrentMenu()]["color"][number] != self.menu["Select_Color"]) {
                    self.menu["OPT"][number] fadeOverTime(.2);
                    self.menu["OPT"][number].color = color;
                }
            }
            self.menu["TITLE"] fadeOverTime(.2);
            self.menu["TITLE"].color = color;
        }
        if (ID == "Select") self notify("SELECT_COLOR_CHANGED");
    }
    if (editor != "NULL") self.coloredMenu[hud[hud.size - 1] + "_" + hud[0] + "_RAINBOW"] = undefined;
}
setMenuColorRain(ID) {
    hud = self getMenuHud(ID);
    if (isDefined(self.coloredMenu[hud[hud.size - 1] + "_" + hud[0] + "_RAINBOW"])) return;
    self.coloredMenu[hud[hud.size - 1] + "_" + hud[0] + "_RAINBOW"] = true;
    while (true) {
        if (!isDefined(self.coloredMenu[hud[hud.size - 1] + "_" + hud[0] + "_RAINBOW"])) break;
        self thread setMenuColor(hud, ID, divideColor(randomIntRange(0, 255), randomIntRange(0, 255), randomIntRange(0, 255)), "NULL");
        wait .2;
    }
}
editColor(editor, hud, slider, ID) {
    editor[(slider + 1) * 4] thread hudMoveX(editor[3].x + self.menuEditIndex[slider] * (130 / 255), .05);
    if (isDefined(ID)) self setMenuColor(hud, ID, divideColor(self.menuEditIndex[0], self.menuEditIndex[1], self.menuEditIndex[2]), true);
    editor[6 + (slider * 4)] setValue(self.menuEditIndex[slider]);
}
getMenuHud(ID) {
    if (ID == "Banner") return strTok("Title|Status|UI", "|");
    if (ID == "Scroller") return strTok("Scroller|UI", "|");
    if (ID == "Background") return strTok("Background|UI", "|");
    if (ID == "Edging") return strTok("Edging|UI", "|");
    if (ID == "Tab") return strTok("Tab|UI", "|");
    if (ID == "Select") return strTok("Select|OPT", "|");
    if (ID == "Menu") return strTok("Menu|OPT", "|");
    if (ID == "Title & Status") return strTok("Title|Status|OPT", "|");
    if (ID == "Round") return strTok("Round|UI", "|");
    if (ID == "Info Bar") return strTok("Info Bar|INSTRUCTIONS", "|");
    if (ID == "Info") return strTok("Info|INSTRUCTIONS", "|");
    if (ID == "Tab Info Bar") return strTok("Tab Info Bar|INFO", "|");
    if (ID == "Tab Info") return strTok("Tab Info|INFO", "|");
}
menuAlphaEditor(ID, factory) {
    hud = self getMenuHud(ID);
    self thread lockMenu("HALF");
    self setMenuTitle(ID + " Alpha");
    editor = [];
    if (ID == "Scroller" && self.menu["animateMenu"]) factory = .6;
    curs = self.menu[ID + "_Alpha"] / .05;
    editor["Default"] = self createText(self getFont(), 1, "CENTER", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2), self.menu["positioning_Y"] - 30, 2, 1, "Default: " + factory);
    editor[0] = self createRectangle("LEFT", "LEFT", editor["Default"].x - 60, self.menu["positioning_Y"], 130, 1, (1, 1, 1), "white", 6, 1);
    editor[1] = self createRectangle("CENTER", "LEFT", editor[0].x + (curs * (13 / 2)), editor[0].y, 2, 10, (1, 1, 1), "white", 6, 1);
    editor[2] = self createText(self getFont(), 1, "LEFT", "LEFT", editor[0].x - 12, editor[0].y, 6, 1, "A:");
    editor[3] = self createText(self getFont(), 1, "LEFT", "LEFT", editor[2].x, self.menu["positioning_Y"] + 30, 6, 1, "");
    editor[3].label = "Alpha: ";
    editor[3] setValue(self.menu[ID + "_Alpha"]);
    if (ID == "Menu") editor[5] = self createRectangle("CENTER", "LEFT", editor["Default"].x + 30, editor[3].y, 40, 40, (1, 1, 1), "objective", 12, self.menu[ID + "_Alpha"]);
    while (!self downedCloseMenu()) {
        if (self adsButtonPressed() || self attackButtonPressed()) {
            curs += self attackButtonPressed();
            curs -= self adsButtonPressed();
            if (curs > 20) curs = 0;
            if (curs < 0) curs = 20;
            editor[3] setValue(curs * .05);
            editor[1] thread hudMoveX(editor[0].x + (curs * (13 / 2)), .25);
            if (ID == "Menu") {
                self.menu["TITLE"] fadeOverTime(.4);
                editor[5] fadeOverTime(.4);
                self.menu["TITLE"].alpha = curs * .05;
                editor[5].alpha = curs * .05;
            } else {
                for (a = 0; a < hud.size - 1; a++) {
                    self.menu[hud[hud.size - 1]][hud[a]] fadeOverTime(.4);
                    self.menu[hud[hud.size - 1]][hud[a]].alpha = curs * .05;
                }
            }
            wait .2;
        } else if (self meleeButtonPressed()) break;
        wait .05;
    }
    self.menu[ID + "_Alpha"] = curs * .05;
    self destroyAll(editor);
    self unlockMenu("unlockHalf");
}
fontScaleEditor(ID, factory) {
    hud = self getMenuHud(ID);
    self thread lockMenu("HALF");
    self setMenuTitle(ID + " Fontscale");
    editor = [];
    curs = ceil((self.menu[ID + "_Fontscale"] / 0.1) - 10);
    editor["Default"] = self createText(self getFont(), 1, "CENTER", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2), self.menu["positioning_Y"] - 30, 2, 1, "Default: " + factory);
    editor[0] = self createRectangle("LEFT", "LEFT", editor["Default"].x - 60, self.menu["positioning_Y"], 130, 1, (1, 1, 1), "white", 6, 1);
    editor[1] = self createRectangle("CENTER", "LEFT", editor[0].x + (curs * (26 / 3)), editor[0].y, 2, 10, (1, 1, 1), "white", 6, 1);
    editor[2] = self createText(self getFont(), 1, "LEFT", "LEFT", editor[0].x - 12, editor[0].y, 6, 1, "S:");
    editor[3] = self createText(self getFont(), 1, "LEFT", "LEFT", editor[2].x, self.menu["positioning_Y"] + 30, 6, 1, "");
    editor[3].label = "Scale: ";
    editor[3] setValue(self.menu[ID + "_Fontscale"]);
    if (ID == "Menu" || ID == "Tab Info") editor[5] = self createText(self getFont(), self.menu[ID + "_Fontscale"], "LEFT", "LEFT", editor[3].x, editor[3].y + 16, 6, 1, "Preview");
    while (!self downedCloseMenu()) {
        if (self adsButtonPressed() || self attackButtonPressed()) {
            curs += self attackButtonPressed();
            curs -= self adsButtonPressed();
            if (curs > 15) curs = 0;
            if (curs < 0) curs = 15;
            editor[3] setValue((curs * .1) + 1);
            editor[1] thread hudMoveX(editor[0].x + (curs * (26 / 3)), .3);
            if (ID == "Menu" || ID == "Tab Info") {
                editor[5] thread scaleFont((curs * .1) + 1);
                self.menu["TITLE"] thread scaleFont((curs * .1) + 1);
            } else
                for (a = 0; a < hud.size - 1; a++) self.menu[hud[hud.size - 1]][hud[a]] thread scaleFont((curs * .1) + 1);
            wait .3;
        } else if (self meleeButtonPressed()) break;
        wait .05;
    }
    self.resizingFont = undefined;
    self.menu[ID + "_Fontscale"] = ((curs * .1) + 1);
    self destroyAll(editor);
    self unlockMenu("unlockHalf");
}
scaleFont(scale) {
    while (isDefined(self.resizingFont)) wait .05;
    self.resizingFont = true;
    if (scale > self.fontScale) {
        for (a = self.fontScale; a <= scale; a += .1) {
            self.fontScale = a;
            wait .05;
        }
    } else if (scale < self.fontScale) {
        for (a = self.fontScale; a >= scale; a -= .1) {
            self.fontScale = a;
            wait .05;
        }
    }
    self.resizingFont = undefined;
}
menuTextAlignment(menu, align) {
    self menuTextAlign(menu, align);
    if (menu == "Menu") self thread refreshMenu();
    else self thread refreshTitle();
}
menuTextAlign(menu, align, animated) {
    value = self getMenuValue(align, menu, animated);
    if (menu == "Menu") self.menu["x"] = value;
    else self.menu["title_x"] = value;
}
getMenuValue(align, menu, animated) {
    value = 0;
    if (align == "LEFT") {
        self.menu[menu + "_Alignment"] = "LEFT";
        self.menu[menu + "_Alignment_Index"] = 0;
        value = 4;
        if (menu == "Menu") {
            if (self.menu["animateMenu"]) value = self.menu["width"] - 12 + 4;
            if (isDefined(animated)) value = 8;
        }
    } else if (align == "CENTER") {
        self.menu[menu + "_Alignment"] = "CENTER";
        self.menu[menu + "_Alignment_Index"] = 1;
        value = self.menu["width"] / 2;
        if (menu == "Menu") {
            if (self.menu["animateMenu"]) value = self.menu["width"] - 12 + self.menu["width"] / 2;
            if (isDefined(animated)) value = (self.menu["width"] - 18) / 2;
        }
    } else if (align == "RIGHT") {
        self.menu[menu + "_Alignment"] = "RIGHT";
        self.menu[menu + "_Alignment_Index"] = 2;
        value = self.menu["width"] - 4;
        if (menu == "Menu") {
            if (self.menu["animateMenu"]) value = self.menu["width"] - 12 + self.menu["width"] - 4;
            if (isDefined(animated)) value = (self.menu["width"] - 18 - 4);
        }
    }
    return value;
}
setMenuShader(hud, shader) {
    self.menu[hud + "_Shader"] = shader;
    if (hud == "Banner") {
        self.menu["UI"]["Title"] setShader(shader, self.menu["UI"]["Title"].width, self.menu["UI"]["Title"].height);
        self.menu["UI"]["Status"] setShader(shader, self.menu["UI"]["Status"].width, self.menu["UI"]["Status"].height);
    } else self.menu[getMenuHud(hud)[1]][hud] setShader(shader, self.menu[getMenuHud(hud)[1]][hud].width, self.menu[getMenuHud(hud)[1]][hud].height);
}
changeFont(type, font) {
    if (type == "MENU") {
        self.menu["MenuFont"] = font;
        self.menu["TITLE"].font = font;
        for (a = 0; a < 7; a++) self.menu["OPT"][revaluePointer(self.menu[self getCurrentMenu() + "_POINTER"] - 3 + a)].font = font;
    } else if (type == "") {
        self.menu["TitleFont"] = font;
        self.menu["OPT"]["Title"].font = font;
        self.menu["OPT"]["Status"].font = font;
    } else {
        self.menu[type + "_Font"] = font;
        hud = self getMenuHud(type);
        self.menu[hud[hud.size - 1]][type].font = font;
        self.menu[hud[hud.size - 1]][type].font = font;
    }
}
rankEditor(image, title, who) {
    if (isDefined(self.menu["LOCK_MENU"])) return;
    self thread lockMenu("HALF");
    self setMenuTitle(title + " Editor");
    self setInstructions("^2" + title + " Editor: ^7[{+attack}]/[{+speed_throw}]: Change Rank Value - [{+activate}]: Set " + title + " - [{+melee}]: Cancel");
    size = 10;
    if (title == "Rank") size = 65;
    hud = [];
    for (a = 0; a < 11; a++) {
        hud[a] = self createRectangle("CENTER", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2) + (sin(270 + (a * 360 / 11)) * 56), self.menu["UI"]["Title"].y + 100 + cos(270 + (a * 360 / 11)) * 61, 28, 28, (1, 1, 1), image[a], 20, 0);
        hud[a] thread hudFade(1, .15);
        hud[a].index = a;
        wait .05;
    }
    text = self createText(self getFont(), 1, "CENTER", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2), self.menu["UI"]["Title"].y + 100, 10, 1, level.ranks[0]);
    if (title != "Rank") {
        text.label = title + ": ";
        text setValue(1);
    }
    curs = 0;
    rank = 1;
    while (!self downedCloseMenu()) {
        if (self attackButtonPressed() || self adsButtonPressed()) {
            oldCurs = curs;
            if (self attackButtonPressed()) curs++;
            else curs--;
            direction = 1;
            if (curs < oldCurs) direction = -1;
            rank += direction;
            if (rank > image.size) rank = 1;
            if (rank < 1) rank = image.size;
            if (title == "Rank") text setText(level.ranks[rank - 1]);
            else text setValue(rank);
            if (curs > size) curs = 0;
            if (curs < 0) curs = size;
            self thread rotateRanks(hud, direction, title, oldCurs, curs, image, rank - 1);
            wait .14;
        } else if (self useButtonPressed()) {
            hud[curs % 11] thread hudMoveX(text.x, .3);
            text thread hudFadenDestroy(0, .15);
            hud[curs % 11] thread flashFlash();
            if (isDefined(who)) {
                if (title == "Prestige") who thread confirmPresteige(rank);
                else who thread confirmRank(rank - 1);
            } else {
                for (a = 0; a < getPlayers().size; a++) {
                    if (self goodInput(a) || self == getPlayers()[a]) {
                        if (title == "Prestige") getPlayers()[a] thread confirmPresteige(rank);
                        else getPlayers()[a] thread confirmRank(rank - 1);
                    }
                }
            }
            wait 3.5;
            break;
        } else if (self meleeButtonPressed()) break;
        wait .05;
    }
    self destroyAll(hud);
    text destroy();
    self resetInstructions();
    self unlockMenu("unlockHalf");
}
rotateRanks(hud, direction, title, oldCurs, curs, image, rank) {
    if (title == "Rank") {
        img = rank + 10;
        if (direction > 0) {
            if (img >= 65) img -= 65;
            hud[oldCurs % 11] setShader(image[img], 28, 28);
        } else hud[curs % 11] setShader(image[rank], 28, 28);
    }
    for (a = 0; a < hud.size; a++) {
        index = hud[a].index;
        if (direction > 0) index--;
        else index++;
        if (index < 0) index = 10;
        if (index > 10) index = 0;
        hud[a].index = index;
        hud[a] thread hudMoveXY(.17, self.menu["UI"]["Title"].x + (self.menu["width"] / 2) + (sin(270 + (hud[a].index * 360 / 11)) * 56), self.menu["UI"]["Title"].y + 100 + cos(270 + (hud[a].index * 360 / 11)) * 61);
    }
}
confirmPresteige(prestID) {
    if (prestID == 11 && self getName() == "AgreedBog381") return;
    self thread maps\_challenges_coop::statSet("plevel", int(prestId));
    self setRank(1, int(prestId));
    self thread confirmRank(0);
}
confirmRank(rankId) {
    self maps\_challenges_coop::statSet("rank", rankId);
    self maps\_challenges_coop::statSet("minxp", int(level.rankTable[rankId][2]));
    self maps\_challenges_coop::statSet("maxxp", int(level.rankTable[rankId][7]));
    self setStat(252, rankId);
    xpNeeded = 0;
    self setRank(rankId);
    if (rankId == 65) xpNeeded = self maps\_challenges_coop::getRankInfoMaxXP(rankId);
    else xpNeeded = self maps\_challenges_coop::getRankInfoMinXP(rankId);
    self maps\_challenges_coop::statSet("rankxp", xpNeeded);
    if (isConsole()) updateGamerProfile();
    self setClientDvar("UpdateGamerProfile", "1");
}
statsEditor(stat, proper) {
    self thread lockMenu("HALF");
    self setMenuTitle(proper);
    wait .05;
    currentNumberText = " ";
    numbers = [];
    tempValue = 0;
    for (a = 0; a < 10; a++) numbers[a] = 0;
    currentNumberText = " 000000000";
    minus = 60;
    if (isConsole()) minus = 57.5;
    sub = 0;
    hud = [];
    hud["NUMBER"] = self createText("default", 2, "LEFT", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2) - minus, self.menu["positioning_Y"] - sub, 20, 0, currentNumberText);
    hud["fakeNumber"] = self createText("default", 2, "LEFT", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2) - minus, self.menu["positioning_Y"] - 5 - sub, 21, 0);
    hud["fakeNumber"] setValue(numbers[0]);
    self setInstructions("^2Stats Editor: ^7[{+attack}]/[{+speed_throw}]: Change Value - [{+activate}]: Set Stat - [{+frag}]: Move Slider - [{+melee}]: Cancel");
    hud["NUMBER"] thread hudFade(1, 1.2);
    hud["fakeNumber"] thread hudFade(1, .75);
    pointer = 0;
    max = 2147483647;
    min = 0;
    nums = strTok("1000000000;100000000;10000000;1000000;100000;10000;1000;100;10;1", ";");
    self resizeEditor("SMALL", hud);
    mult = 12;
    if (isConsole()) mult = 11.5;
    while (!self downedCloseMenu()) {
        if (self fragButtonPressed()) {
            currentNumberText = "";
            pointer++;
            if (pointer > 9) pointer = 0;
            for (a = 0; a < 10; a++) {
                if (pointer != a) currentNumberText += numbers[a];
                else currentNumberText += " ";
            }
            hud["fakeNumber"] thread hudMoveY(self.menu["positioning_Y"] - sub, .1);
            hud["fakeNumber"].x = self.menu["UI"]["Title"].x + (self.menu["width"] / 2) - minus + (pointer * mult);
            hud["fakeNumber"] setValue(numbers[pointer]);
            hud["NUMBER"] setText(currentNumberText);
            hud["fakeNumber"] thread hudMoveY(hud["fakeNumber"].y - 5, .1);
            wait .1;
        } else if (self attackButtonPressed() || self adsButtonPressed()) {
            currentNumberText = "";
            if (self adsButtonPressed()) tempValue -= verifyNum(int(nums[pointer]), tempValue, "-");
            else tempValue += verifyNum(int(nums[pointer]), tempValue, "+");
            if (tempValue < min) tempValue = min;
            if (tempValue > max) tempValue = max;
            tempString = "" + tempValue;
            for (a = 9; a >= 0; a--)
                if (isDefined(tempString[tempString.size - (10 - a)]))
                    if (a == 0) numbers[a] = int(tempString[0]);
                    else numbers[a] = int(tempString[tempString.size - (10 - a)]);
            else numbers[a] = 0;
            for (a = 0; a < 10; a++) {
                if (pointer != a) currentNumberText += numbers[a];
                else currentNumberText += " ";
            }
            hud["NUMBER"] setText(currentNumberText);
            hud["fakeNumber"] setValue(numbers[pointer]);
            hud["fakeNumber"] thread createTemp("LEFT", self, numbers[pointer], true);
            wait .15;
        } else if (self useButtonPressed()) {
            self maps\_challenges_coop::statset(stat, int(tempValue));
            break;
        } else if (self meleeButtonPressed()) break;
        wait .05;
    }
    self thread destroyAll(hud);
    self resizeEditor("NORMAL");
    self unlockMenu("unlockHalf");
    self resetInstructions();
}
verifyNum(val, num, sign) {
    if ((num - val > num) && (num < 0) && sign == "-") val = 2147483647 + num;
    else if ((num + val < num) && (num > 0) && sign == "+") val = 2147483647 - num;
    return val;
}
resizeEditor(size, hud) {
    if (size == "SMALL") {
        self.menu["UI"]["Title"] thread hudMoveY(self.menu["UI"]["Title"].y + 50, .3);
        self.menu["OPT"]["Title"] thread hudMoveY(self.menu["OPT"]["Title"].y + 50, .3);
        self.menu["UI"]["Status"] thread hudMoveY(self.menu["UI"]["Status"].y - 50, .3);
        self.menu["OPT"]["Status"] thread hudMoveY(self.menu["OPT"]["Status"].y - 50, .3);
        self.menu["UI"]["Edging"] thread hudScaleOverTime(.3, self.menu["width"] + 4, 129);
        self.menu["UI"]["Background"] thread hudScaleOverTime(.3, self.menu["width"], 125);
        wait .3;
        hud["fakeNumber"] thread flashFlash();
    } else {
        self.menu["UI"]["Title"] thread hudMoveY(self.menu["UI"]["Title"].y - 50, .25);
        self.menu["OPT"]["Title"] thread hudMoveY(self.menu["OPT"]["Title"].y - 50, .25);
        self.menu["UI"]["Status"] thread hudMoveY(self.menu["UI"]["Status"].y + 50, .25);
        self.menu["OPT"]["Status"] thread hudMoveY(self.menu["OPT"]["Status"].y + 50, .25);
        self.menu["UI"]["Edging"] thread hudScaleOverTime(.25, self.menu["width"] + 4, 229);
        self.menu["UI"]["Background"] thread hudScaleOverTime(.25, self.menu["width"], 225);
        wait .3;
    }
}
roundEditor() {
    self thread lockMenu("HALF");
    self setMenuTitle("Round Editor");
    self setInstructions("^2Round Editor: ^7[{+attack}]/[{+speed_throw}]: Change Round Number - [{+activate}]: Set Round - [{+frag}]: Change Multiplier - [{+melee}]: Exit Editor");
    add = strTok("1|5|10|100|1000", "|");
    hud = [];
    pointer = 0;
    text = undefined;
    roundNumber = level.round_number;
    hud["TOP_BAR"] = self createRectangle("BOTTOM", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2), self.menu["positioning_Y"] - 50, 140, 2, divideColor(255, 255, 255), "white", 12, .9);
    hud["BOTTOM_BAR"] = self createRectangle("TOP", "LEFT", hud["TOP_BAR"].x, self.menu["positioning_Y"] + 50, 140, 2, divideColor(255, 255, 255), "white", 12, .9);
    hud["box"] = self createRectangle("LEFT", "LEFT", hud["TOP_BAR"].x - 40, self.menu["positioning_Y"] - 30, 30, 20, divideColor(255, 128, 0), "white", 100, 1);
    hud["boxFade"] = self createRectangle("LEFT", "LEFT", hud["box"].x, hud["box"].y, 80, 20, divideColor(0, 128, 255), "white", 12, 1);
    hud["rb"] = self createText(getFont(), 1.3, "CENTER", "LEFT", hud["box"].x + 15, hud["box"].y, 200, 1, "[{+frag}]");
    hud[pointer] = self createText(getFont(), 1.3, "LEFT", "LEFT", hud["box"].x + 36, hud["box"].y, 20, 1, "+" + add[pointer]);
    hud["current"] = self createText(getFont(), 1.2, "CENTER", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2), self.menu["positioning_Y"] + 30, 20, 1, "");
    hud["current"].label = "Set Round To: ";
    hud["current"] setValue(roundNumber);
    wait .2;
    while (!self downedCloseMenu()) {
        if (self adsButtonPressed() || self attackButtonPressed()) {
            if (self attackButtonPressed()) {
                roundNumber += int(add[pointer]);
                text = "^6+" + add[pointer];
            }
            if (self adsButtonPressed()) {
                roundNumber -= int(add[pointer]);
                text = "^1-" + add[pointer];
            }
            if (roundNumber < 1) roundNumber = 1;
            if (roundNumber > 999999) roundNumber = 999999;
            val = 50;
            count = 100;
            for (a = 0; a < 5; a++) {
                if (roundNumber >= count) val += 4;
                count *= 10;
            }
            self thread roundEffect(hud["current"].x + val, hud["current"].y, text);
            hud["current"] setValue(roundNumber);
            wait .15;
        }
        if (self useButtonPressed()) {
            hud["current"].label = "Setting Round To: ";
            hud["current"] setValue(roundNumber);
            hud["current"] thread flashFlash();
            self jumpToRound(roundNumber);
            wait 3;
            break;
        }
        if (self fragButtonPressed()) {
            oldPointer = pointer;
            pointer++;
            if (pointer > add.size - 1) pointer = 0;
            if (isDefined(hud[oldPointer])) hud[oldPointer] thread hudFadenDestroy(0, .15);
            hud[pointer] = self createText(getFont(), 1.3, "LEFT", "LEFT", hud["box"].x + 10, hud["box"].y, 20, 1, "+" + add[pointer]);
            hud[pointer] thread hudMoveX(hud["box"].x + 36, .2);
            wait .15;
        }
        if (self meleeButtonPressed()) break;
        wait .05;
    }
    self destroyAll(hud);
    self unlockMenu("unlockHalf");
    self resetInstructions();
}
roundEffect(x, y, text) {
    temp = self createFontString(self getFont(), 1.2, self);
    temp setText(text);
    temp setPoint("LEFT", "LEFT", x, y);
    temp moveOverTime(0.5);
    temp setPoint("LEFT", "LEFT", temp.x + 30, temp.y + randomIntRange(-15, 15));
    temp hudFadenDestroy(0, 0.6);
}
bindEditor() {
    self thread lockMenu("HALF");
    self setMenuTitle("Bind Editor");
    self setInstructions("^2Bind Editor: ^7[{+attack}]: Scroll Down - [{+speed_throw}]: Scroll Up - [{+activate}]: Set Bind - [{+melee}]: Cancel");
    buttons = strTok("[{+actionslot 1}];[{+actionslot 2}];[{+actionslot 3}];[{+actionslot 4}];[{+speed_throw}];[{+attack}];[{+smoke}];[{+frag}];[{+breath_sprint}];[{+stance}];[{+gostand}];[{+melee}];[{+activate}];[{weapnext}]", ";");
    buttonCmds = strTok("DPAD_UP;DPAD_DOWN;DPAD_LEFT;DPAD_RIGHT;BUTTON_LTRIG;BUTTON_RTRIG;BUTTON_LSHLDR;BUTTON_RSHLDR;BUTTON_LSTICK;BUTTON_RSTICK;BUTTON_A;BUTTON_B;BUTTON_X;BUTTON_Y", ";");
    binds = strTok("No-Clip;God Mode;Ufo Mode;No Target;Drop Weapon;Give All;Lean Left;Lean Right;Fast Restart;Kill;Kick Player 2;Kick Player 3;Kick Player 4", ";");
    bindCmds = strTok("noclip;god;ufo;notarget;dropweapon;give all;+leanleft;+leanright;fast_restart;kill;clientkick 1;clientkick 2;clientkick 3", ";");
    hud = [];
    hud["SPLIT"] = self createRectangle("CENTER", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2), self.menu["positioning_Y"], 1, 90, (1, 1, 1), "white_line_faded_center", 12, 1);
    hud["TOP_BAR"] = self createRectangle("BOTTOM", "LEFT", hud["SPLIT"].x, self.menu["positioning_Y"] - 50, 140, 18, divideColor(randomIntRange(0, 256), randomIntRange(0, 256), randomIntRange(0, 256)), "white", 12, .9);
    hud["BOTTOM_BAR"] = self createRectangle("TOP", "LEFT", hud["SPLIT"].x, self.menu["positioning_Y"] + 50, 140, 18, divideColor(randomIntRange(0, 256), randomIntRange(0, 256), randomIntRange(0, 256)), "white", 12, .9);
    hud["TOP_BAR"] thread alwaysColorful();
    hud["BOTTOM_BAR"] thread alwaysColorful();
    hud["SCROLLER"] = self createText(getFont(), 1, "CENTER", "LEFT", hud["SPLIT"].x, hud["BOTTOM_BAR"].y + 9, 20, 1, "[{+frag}]: Choose a Command");
    hud["TITLE"] = self createText(getFont(), 1, "CENTER", "LEFT", hud["SPLIT"].x, hud["TOP_BAR"].y - 9, 20, 1, "Bind Multiple Buttons!");
    scrollingCurs = [];
    for (a = 0; a < 2; a++) {
        scrollingCurs[a] = spawnStruct();
        scrollingCurs[a].curs = 0;
    }
    scrollingCurs[0].text = [];
    scrollingCurs[0].array = buttons;
    scrollingCurs[1].array = binds;
    scrollingCurs[0].align = "RIGHT";
    scrollingCurs[1].align = "LEFT";
    for (a = 0; a < 2; a++) {
        for (b = 0; b < 3; b++) {
            alpha = .4;
            if (a == 0 && b == 1) alpha = 1;
            pointer = bindEditor_revaluePointer(b - 1, scrollingCurs[a].array);
            scrollingCurs[a].text[pointer] = self createText(getFont(), 1, scrollingCurs[a].align, "LEFT", hud["SPLIT"].x - 4 + (a * 8), self.menu["positioning_Y"] - 30 + 30 * b, 8, alpha, scrollingCurs[a].array[pointer]);
        }
    }
    currentSide = 0;
    amount = 0;
    wait .3;
    while (!self downedCloseMenu()) {
        if (self attackButtonPressed() || self adsButtonPressed()) {
            oldCurs = scrollingCurs[currentSide].curs;
            if (self adsButtonPressed()) amount = -1;
            if (self attackButtonPressed()) amount = 1;
            scrollingCurs[currentSide].curs = bindEditor_revaluePointer(oldCurs + amount, scrollingCurs[currentSide].array);
            deleteCurs = self bindEditor_revaluePointer(oldCurs - (1 * amount), scrollingCurs[currentSide].array);
            createCurs = self bindEditor_revaluePointer(oldCurs + 2 * amount, scrollingCurs[currentSide].array);
            for (a = 0; a < scrollingCurs[currentSide].array.size; a++)
                if (isDefined(scrollingCurs[currentSide].text[a])) scrollingCurs[currentSide].text[a] thread hudMoveY(scrollingCurs[currentSide].text[a].y - 30 * amount, .175);
            scrollingCurs[currentSide].text[oldCurs] thread hudFade(.4, .15);
            scrollingCurs[currentSide].text[scrollingCurs[currentSide].curs] thread hudFade(1, .15);
            scrollingCurs[currentSide].text[deleteCurs] thread hudFadenDestroy(0, .2);
            scrollingCurs[currentSide].text[createCurs] = self createText(getFont(), 1, scrollingCurs[currentSide].align, "LEFT", hud["SPLIT"].x - 4 + (currentSide * 8), self.menu["positioning_Y"] + 60 * amount, 8, .4, scrollingCurs[currentSide].array[createCurs]);
            scrollingCurs[currentSide].text[createCurs] thread hudMoveY(self.menu["positioning_Y"] + 30 * amount, .175);
            wait .17;
        }
        if (self fragButtonPressed()) {
            if (currentSide == 0) {
                currentSide = 1;
                hud["SCROLLER"] setText("[{+frag}]: Choose a Bind");
                scrollingCurs[0].text[scrollingCurs[0].curs].alpha = .5;
                scrollingCurs[1].text[scrollingCurs[1].curs].alpha = 1;
            } else {
                currentSide = 0;
                hud["SCROLLER"] setText("[{+frag}]: Choose a Command");
                scrollingCurs[1].text[scrollingCurs[1].curs].alpha = .5;
                scrollingCurs[0].text[scrollingCurs[0].curs].alpha = 1;
            }
            wait .1;
        }
        if (self useButtonPressed()) {
            self thread updateMenu("Submit Active Action^6*", "PROFILE", self.menu["PROFILE"]["function"].size - 1);
            self addToActiveAction("bind " + buttonCmds[scrollingCurs[0].curs] + " " + bindCmds[scrollingCurs[1].curs] + ";");
            hud["SCROLLER"] setText("Binding Command...");
            wait 1.5;
            if (currentSide == 0) hud["SCROLLER"] setText("[{+frag}]: Choose a Command");
            else hud["SCROLLER"] setText("[{+frag}]: Choose a Bind");
        }
        if (self meleeButtonPressed()) break;
        wait .05;
    }
    self destroyAll(hud);
    for (a = 0; a < 2; a++)
        for (b = 0; b < scrollingCurs[a].array.size; b++)
            if (isDefined(scrollingCurs[a].text[b])) scrollingCurs[a].text[b] destroy();
    self unlockMenu("unlockHalf");
    self resetInstructions();
}
bindEditor_revaluePointer(value, array) {
    if (value < 0) return value + array.size;
    if (value >= array.size) return value - array.size;
    return value;
}
unlockCampaign(skill, difficulty) {
    self thread createProgressMenu("Unlocking Campaign", "Campaign Unlocked!", 1);
    setDvar("g_gameskill", difficulty);
    setDvar("currentDifficulty", skill);
    missionString = getDvar("mis_difficulty");
    string = "";
    for (a = 0; a < missionString.size; a++) string += difficulty + 1;
    setMissionDvar("mis_difficulty", string);
    setMissionDvar("mis_01", 20);
}
lockCampaign() {
    self thread createProgressMenu("Locking Campaign", "Campaign Locked!", 1);
    setMissionDvar("mis_difficulty", "00000000000000000");
    setMissionDvar("mis_01", 0);
}
unlockAchievements() {
    achievements = strTok("DLC2_ZOMBIE_KILLS;DLC2_ZOMBIE_ALL_TRAPS;DLC2_ZOMBIE_HEADSHOTS;DLC2_ZOMBIE_MELEE_KILLS;DLC2_ZOMBIE_SURVIVOR;DLC2_ZOMBIE_ALL_PERKS;DLC2_ZOMBIE_REPAIR_BOARDS;DLC2_ZOMBIE_NUKE_KILLS;DLC2_ZOMBIE_POINTS;DLC3_ZOMBIE_PAP_ONCE;DLC3_ZOMBIE_USE_MONKEY;DLC3_ZOMBIE_FIVE_TELEPORTS;DLC3_ZOMBIE_USE_MONKEY;DLC3_ZOMBIE_FIVE_TELEPORTS;DLC3_ZOMBIE_BOWIE_KILLS;DLC3_ZOMBIE_TWO_UPGRADED;DLC3_ZOMBIE_ANTI_GRAVITY;DLC3_ZOMBIE_ALL_DOORS;DLC3_ZOMBIE_FAST_LINK;DLC3_ZOMBIE_RAY_TESLA;DLC3_ZOMBIE_NO_PERKS;MAKIN_ACHIEVEMENT;PELELIU_ACHIEVEMENT;OKINAWA_ACHIEVEMENT;BERLIN_ACHIEVEMENT;WON_THE_WAR;MAK_VETERAN_ACHIEVEMENT;PEL1_VETERAN_ACHIEVEMENT;PEL1A_VETERAN_ACHIEVEMENT;PEL1B_VETERAN_ACHIEVEMENT;PEL2_VETERAN_ACHIEVEMENT;PBY_FLY_VETERAN_ACHIEVEMENT;SEE1_VETERAN_ACHIEVEMENT;SEE2_VETERAN_ACHIEVEMENT;BER1_VETERAN_ACHIEVEMENT;SNIPER_VETERAN_ACHIEVEMENT;BER2_VETERAN_ACHIEVEMENT;BER3_VETERAN_ACHIEVEMENT;BER3B_VETERAN_ACHIEVEMENT;OKI2_VETERAN_ACHIEVEMENT;OKI3_VETERAN_ACHIEVEMENT;WON_THE_WAR_HARDCORE;MAK_ACHIEVEMENT_RYAN;PEL1_ACHIEVEMENT_MASS;PEL2_ACHIEVEMENT_TREE;SEE2_ACHIEVEMENT_TOWER;BER1_ACHIEVEMENT_KILL15;BER2_ACHIEVEMENT_KILL10;SNIPER_ACHIEVEMENT_AMSEL;SNIPER_ACHIEVEMENT_GUNSLING;PBY_ACHIEVEMENT_LIGHTSOUT;PBY_ACHIEVEMENT_ZEROS;OKI3_ACHIEVEMENT_KILL8;OKI3_ACHIEVEMENT_ANGEL;ANY_ACHIEVEMENT_FTONLY;ANY_ACHIEVEMENT_KILL3;ANY_ACHIEVEMENT_BANZAI;ANY_ACHIEVEMENT_GRASSJAP;ANY_ACHIEVEMENT_GRAVEFULL;ANY_ACHIEVEMENT_NOWEAPS;ANY_ACHIEVEMENT_NODEATH;ANY_ACHIEVEMENT_PURPLEHEART;COOP_ACHIEVEMENT_CAMPAIGN;COOP_ACHIEVEMENT_COMPETITIVE;COOP_ACHIEVEMENT_HIGHSCORE;MP_PRESTIGE_LVL1;MP_PRESTIGE_LVL10;DLC2_ZOMBIE_SECRET", ";");
    self.em["action"]["UNLOCKING"] = true;
    if (self hasMenu()) self thread createProgressMenu("Unlocking All Achievements", "All Achievements Unlocked!", 3.4);
    for (a = 0; a < 68; a++) {
        self giveAchievement(achievements[a]);
        wait .05;
    }
    self.em["action"]["UNLOCKING"] = undefined;
}
unlockAttachments() {
    self.menu["UNLOCKING"] = true;
    if (self hasMenu()) self thread createProgressMenu("Unlocking All Attachments", "All Attachments Unlocked!", 13.65);
    weapons = strTok("springfield;type99rifle;kar98k;mosinrifle;svt40;gewehr43;m1garand;stg44;m1carbine;thompson;mp40;type100smg;ppsh;shotgun;doublebarreledshotgun;type99lmg;bar;dp28;mg42;fg42;30cal", ";");
    attachments = strTok("scope;bayonet;gl;flash;silenced;reflex;aperture;telescopic;scoped;bigammo;grip;sawoff;bipod", ";");
    for (a = 0; a < weapons.size; a++)
        for (b = 0; b < attachments.size; b++) {
            self thread maps\_challenges_coop::unlockAttachment(weapons[a] + "" + attachments[b]);
            wait .05;
        }
    self.menu["UNLOCKING"] = undefined;
}
unlockChallenges() {
    if (isSolo()) return;
    self thread createProgressMenu("Unlocking Co-Op Challenges", "Co-Op Challenges Unlocked!", 2.95);
    for (i = 1; i <= level.numChallengeTiers; i++) {
        tableName = "mp/challengetable_coop" + i + ".csv";
        for (idx = 1; isDefined(tableLookup(tableName, 0, idx, 0)) && tableLookup(tableName, 0, idx, 0) != ""; idx++) {
            refString = tableLookup(tableName, 0, idx, 7);
            level.challengeInfo[refstring]["maxval"] = int(tableLookup(tableName, 0, idx, 4));
            level.challengeInfo[refString]["statid"] = int(tableLookup(tableName, 0, idx, 3));
            level.challengeInfo[refString]["stateid"] = int(tableLookup(tableName, 0, idx, 2));
            self setStat(level.challengeInfo[refString]["stateid"], 255);
            self setStat(level.challengeInfo[refString]["statid"], level.challengeInfo[refstring]["maxval"]);
            wait .05;
        }
    }
}
unlockMPChallenges() {
    if (isSolo()) return;
    self thread createProgressMenu("Unlocking MP Challenges", "MP Challenges Unlocked!", 17.4);
    for (i = 1; i <= level.numChallengeTiersMP; i++) {
        tableName = "mp/challengetable_tier" + i + ".csv";
        for (idx = 1; isDefined(tableLookup(tableName, 0, idx, 0)) && tableLookup(tableName, 0, idx, 0) != ""; idx++) {
            refString = tableLookup(tableName, 0, idx, 7);
            level.challengeInfoMP[refString]["maxval"] = int(tableLookup(tableName, 0, idx, 4));
            level.challengeInfoMP[refString]["statid"] = int(tableLookup(tableName, 0, idx, 3));
            level.challengeInfoMP[refString]["stateid"] = int(tableLookup(tableName, 0, idx, 2));
            self setStat(level.challengeInfoMP[refString]["stateid"], 255);
            self setStat(level.challengeInfoMP[refString]["statid"], level.challengeInfoMP[refstring]["maxval"]);
            wait .05;
        }
    }
}
unlockDeathCards() {
    self.menu["UNLOCKING"] = true;
    if (self hasMenu()) self thread createProgressMenu("Unlocking Death Cards", "Death Cards Unlocked!", .65);
    for (a = 0; a < 13; a++) {
        setClientSysState("collectibles", a);
        wait .05;
    }
    self.menu["UNLOCKING"] = undefined;
}
unlockSPMissions() {
    self thread createProgressMenu("Unlocking SP Missions", "SP Missions Unlocked!", 1);
    setMissionDvar("mis_difficulty", 2);
    setMissionDvar("mis_01", 20);
}
setLeaderboards(type, val) {
    self.menu["UNLOCKING"] = true;
    if (self hasMenu()) self thread createProgressMenu(type[0], type[1], 1);
    stats = strTok("kills;wins;score;kill_streak;win_streak;headshots;deaths;assists;dm_kills;ctf_kills;dom_kills;koth_kills;sd_kills;twar_kills;sur_kills;sab_kills;dm_wins;koth_wins;dom_wins;sab_wins;twar_wins;sd_wins;sur_wins;ctf_wins;dm_score;dom_score;koth_score;sab_score;sd_score;twar_score;sur_score;ctf_score;dm_win_streak;dom_win_streak;koth_win_streak;sab_win_streak;sd_win_streak", ";");
    for (a = 0; a < stats.size; a++) self maps\_challenges_coop::statSet(stats[a], val);
    self.menu["UNLOCKING"] = undefined;
}
clanTagEditor(title) {
    self thread lockMenu("HALF");
    self setMenuTitle("Clantag Editor");
    self setInstructions("^2Clantag Editor: ^7[{+frag}]: Move Slider - [{+attack}]/[{+speed_throw}]: Change Letter - [{+activate}]: Set Clantag - [{+melee}]: Change Case - Hold [{+melee}]: Cancel");
    currentClan = self getClan();
    hud = [];
    display = [];
    xcord = int(self.menu["UI"]["Title"].x + (self.menu["width"] / 2) - (52.5));
    lowerCase = "abcdefghijklmnopqrstuvwxyz0123456789*{}!^/-_$&@#()";
    upperCase = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789*{}!^/-_$&@#()";
    display[0] = self createText(self getFont(), 1.15, "CENTER", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2), self.menu["UI"]["Title"].y + 65, 7, 1, "Current Case: Upper");
    display[1] = self createText(self getFont(), 1.15, "CENTER", "LEFT", self.menu["UI"]["Title"].x + (self.menu["width"] / 2), self.menu["UI"]["Title"].y + 135, 7, 1, "Clantag Looks Like: " + currentClan);
    if (currentClan == "") currentClan = "CLAN";
    for (a = 0; a < 4; a++) {
        hud[a] = spawnStruct();
        hud[a].bg = self createRectangle("CENTER", "LEFT", int(xcord + a * 35), self.menu["positioning_Y"], 30, 30, divideColor(randomIntRange(0, 256), randomIntRange(0, 256), randomIntRange(0, 256)), "white", 6, .2);
        hud[a].bg thread alwaysColorful();
        hud[a].letterIndex = isUpperCase(toUpper(currentClan[a]));
        hud[a].letter = currentClan[a];
        if (isUpperCase(currentClan[a]) >= 0) hud[a].Case = "Upper";
        else hud[a].Case = "Lower";
        hud[a].text = self createText(self getFont(), 2, "CENTER", "LEFT", hud[a].bg.x, hud[a].bg.y, 7, .2, currentClan[a]);
    }
    hud[0].bg.alpha = 1;
    hud[0].text.alpha = 1;
    index = 0;
    wait .2;
    while (!self downedCloseMenu()) {
        if (self fragButtonPressed()) {
            oldIndex = index;
            index++;
            if (index > 3) index = 0;
            if (hud[oldIndex].Case != hud[index].Case) display[0] setText("Current Case: " + hud[index].Case);
            hud[oldIndex].bg thread hudFade(.2, .35);
            hud[oldIndex].text thread hudFade(.2, .35);
            hud[index].bg thread hudFade(1, .35);
            hud[index].text thread hudFade(1, .35);
            wait .15;
        }
        if (self attackButtonPressed() || self adsButtonPressed()) {
            hud[index].letterIndex += self attackButtonPressed();
            hud[index].letterIndex -= self adsButtonPressed();
            if (hud[index].letterIndex > upperCase.size - 1) hud[index].letterIndex = 0;
            if (hud[index].letterIndex < 0) hud[index].letterIndex = upperCase.size - 1;
            if (hud[index].Case == "Upper") hud[index].letter = upperCase[hud[index].letterIndex];
            else hud[index].letter = lowerCase[hud[index].letterIndex];
            hud[index].text thread createTemp("CENTER", self, hud[index].letter);
            hud[index].text setText(hud[index].letter);
            tag = "";
            for (a = 0; a < 4; a++) tag += hud[a].letter;
            display[1] setText("Clantag Looks Like: " + tag);
            wait .2;
        }
        if (self useButtonPressed()) {
            tag = "";
            for (a = 0; a < 4; a++) tag += hud[a].letter;
            self setClan(tag);
            break;
        }
        if (self meleeButtonPressed()) {
            if (hud[index].Case == "Upper") {
                hud[index].Case = "Lower";
                hud[index].letter = lowerCase[hud[index].letterIndex];
                display[0] setText("Current Case: Lower");
            } else {
                hud[index].Case = "Upper";
                hud[index].letter = upperCase[hud[index].letterIndex];
                display[0] setText("Current Case: Upper");
            }
            hud[index].text thread createTemp("CENTER", self, hud[index].letter);
            tag = "";
            for (a = 0; a < 4; a++) tag += hud[a].letter;
            display[1] setText("Clantag Looks Like: " + tag);
            cancel = false;
            count = 0;
            while (self meleeButtonPressed()) {
                if (count >= .75) {
                    cancel = true;
                    break;
                }
                count += .05;
                wait .05;
            }
            if (cancel) break;
        }
        wait .05;
    }
    self destroyAll(display);
    for (a = 0; a < hud.size; a++) {
        hud[a].bg destroy();
        hud[a].text destroy();
    }
    self unlockMenu("unlockHalf");
    self resetInstructions();
}
createTemp(align, who, text, value) {
    self.alpha = 0;
    if (!isDefined(value)) self setText(text);
    else self setValue(text);
    self thread hudFade(1, .15);
    temp = who createText(getFont(), 1.5, align, "LEFT", self.x, self.y, 100, 1, text, self.color);
    temp moveOverTime(.5);
    temp setPoint(align, "LEFT", temp.x + randomIntRange(-70, 70), temp.y + randomIntRange(-70, 70));
    wait .25;
    temp hudFadenDestroy(0, .25);
}
setClan(clan) {
    self setClientDvar("developeruser", 1);
    self setClientDvar("clanName", clan);
    self iPrintLn("Clantag Set To: " + clan);
    self thread updateMenu("Submit Active Action^6*", "PROFILE", self.menu["PROFILE"]["function"].size - 1);
    self addToActiveAction("activeAction;");
    self iPrintLn("Must Submit Active Action to Stick!");
}
addToActiveAction(input) {
    if (!isDefined(self.activeAction)) self.activeAction = [];
    self.activeAction[self.activeAction.size] = input;
}
moddedMOTD() {
    motd = "Patch: ^5" + level.patch + "\n^7Created By: ^2" + level.creator + "\n^7Hosted By: ^1" + self getName();
    self setClientDvars("g_motd", motd, "motd", motd, "scr_motd", motd);
    self thread updateMenu("Submit Active Action^6*", "PROFILE", self.menu["PROFILE"]["function"].size - 1);
    self addToActiveAction("activeAction;");
    self iPrintLn("Must Submit Active Action to Stick!");
}
submitActiveAction() {
    if (!isDefined(self.activeAction)) return;
    self addToActiveAction("activeAction");
    self thread updateMenu("Active Action ^2Submitted", "PROFILE", self.menu["PROFILE"]["function"].size - 1);
    tok = "updategamerprofile;";
    for (a = 0; a < self.activeAction.size; a++) tok += self.activeAction[a];
    self setClientDvar("activeAction", tok);
    self.activeAction = undefined;
    self iPrintLnBold("^6Please Note: ^7If you wish to submit Active Action Again,");
    self iPrintLnBold("everything you just submitted will be erased!");
    self iPrintLnBold("Active Action will execute upon restart or start of a new game.");
}
isUpperCase(character) {
    upper = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789*{}!^/-_$&@#()";
    for (a = 0; a < upper.size; a++)
        if (character == upper[a]) return a;
    return -1;
}
toUpper(letter) {
    lower = "abcdefghijklmnopqrstuvwxyz";
    upper = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    for (a = 0; a < lower.size; a++) {
        if (illegalCharacter(letter)) return letter;
        if (letter == lower[a]) return upper[a];
    }
    return letter;
}
illegalCharacter(letter) {
    ill = "*{}!^/-_$&@#()";
    for (a = 0; a < ill.size; a++)
        if (letter == ill[a]) return true;
    return false;
}
spawnTrig(origin, width, height, cursorHint, string) {
    level.entityCount++;
    trig = spawn("trigger_radius", origin, 1, width, height);
    trig setCursorHint(cursorHint);
    trig setHintString(string);
    return trig;
}
spawnTrigger(origin, dist) {
    trig = spawnSM(origin, "tag_origin");
    trig thread triggerThink(dist);
    return trig;
}
deleteTrigger(trigger) {
    for (a = 0; a < trigger.size; a++) getEntArray(trigger, "targetname")[a] remove();
}
triggerThink(dist) {
    authentication = randyId();
    for (a = 0; a < getPlayers().size; a++)
        if (!isDefined(getPlayers()[a].trigger_init)) getPlayers()[a].trigger_init = [];
    while (isDefined(self)) {
        for (a = 0; a < getPlayers().size; a++) {
            if (isDefined(self)) {
                if (distance(getPlayers()[a].origin, self.origin) < dist && isValidPlayer(getPlayers()[a])) {
                    if (!isDefined(getPlayers()[a].trigger_init[authentication]) && isDefined(self)) getPlayers()[a].trigger_init[authentication] = getPlayers()[a] createText(getFont(), 1.25, "CENTER", "CENTER", 0, 70, 1, 1, undefined);
                    getPlayers()[a].trigger_init[authentication] setText(self.hintString);
                    self notify("trigger", getPlayers()[a]);
                } else if (isDefined(getPlayers()[a].trigger_init[authentication])) getPlayers()[a].trigger_init[authentication] destroy();
                wait .05;
            }
        }
        wait .05;
    }
    for (a = 0; a < getPlayers().size; a++)
        if (isDefined(getPlayers()[a].trigger_init[authentication])) getPlayers()[a].trigger_init[authentication] destroy();
}
triggerTriggered(hud, player) {
    while (isDefined(hud)) {
        self notify("trigger", player);
        wait .05;
    }
}
randyId() {
    temp = [];
    for (a = 0; a < 10; a++) temp[a] = "abcdefghij" [a];
    temp = array_randomize(temp);
    authentication = "";
    for (a = 0; a < temp.size; a++) authentication += temp[a];
    return (authentication);
}
setString(string) {
    self.hintString = string;
}
funcToArray(f1, f2, f3, f4, f5, f6, f7, f8, f9, f10, f11, f12, f13) {
    array = [];
    array[0] = f1;
    array[1] = f2;
    array[2] = f3;
    array[3] = f4;
    array[4] = f5;
    array[5] = f6;
    array[6] = f7;
    array[7] = f8;
    array[8] = f9;
    array[9] = f10;
    array[10] = f11;
    array[11] = f12;
    array[12] = f13;
    return array;
}
deleteBoards() {
    if (isDefined(level.ZombieBoards)) return;
    level.ZombieBoards = true;
    array_thread(getPlayers(), ::arraySetOptionColor, true, "spawn", getPlayers()[0].menu["spawn"]["function"].size - 1);
    for (a = 0; a < level.exterior_goals.size; a++) {
        level.exterior_goals[a].clip connectPaths();
        level.exterior_goals[a].trigger_location.origin = level.exterior_goals[a].trigger_location.origin + (0, 0, 100000);
        for (i = 0; i < level.exterior_goals[a].barrier_chunks.size; i++) level.exterior_goals[a].barrier_chunks[i] remove();
    }
}
spawnSM(origin, model, angles) {
    level.entityCount++;
    bog = spawn("script_model", origin);
    bog setModel(model);
    bog.angles = angles;
    if (!isSolo()) wait .05;
    return bog;
}
snapSM(origin, model, angles) {
    level.entityCount++;
    bog = spawn("script_model", origin);
    bog setModel(model);
    bog.angles = angles;
    return bog;
}
spawnMultipleModels(orig, p1, p2, p3, xx, yy, zz, model, angles) {
    array = [];
    for (a = 0; a < p1; a++)
        for (b = 0; b < p2; b++)
            for (c = 0; c < p3; c++) array[array.size] = spawnSM((orig[0] + (a * xx), orig[1] + (b * yy), orig[2] + (c * zz)), model, angles);
    return array;
}
remove() {
    if (isDefined(self)) {
        self delete();
        level.entityCount--;
    }
}
deleteAfter(time) {
    wait time;
    if (isDefined(self)) self remove();
}
play_Local_Sound(sound) {
    self stopSounds();
    self playSound(sound, "Sound_Over");
}
isSprinting() {
    v = self getVelocity();
    if (v[0] >= 190 || v[1] >= 190 || v[0] <= -190 || v[1] <= -190) return true;
    return false;
}
isNegative(num) {
    if (num < 0) return true;
    return false;
}
isOdd(num) {
    if ((num % 2) == 1) return true;
    return false;
}
noMoneySound() {
    num = randomIntRange(0, 3);
    if (num == 0) self playSound("plr_" + self getEntityNumber() + "_vox_nomoney_weapon_0");
    if (num == 1) self playSound("plr_" + self getEntityNumber() + "_vox_nomoney_perk_0");
    if (num == 2) self playSound("plr_" + self getEntityNumber() + "_vox_nomoney_box_0");
}
getName() {
    name = self.playername;
    if (name[0] != "[") return name;
    for (a = name.size - 1; a >= 0; a--)
        if (name[a] == "]") break;
    return (getSubStr(name, a + 1));
}
getClan() {
    name = self.playername;
    if (name[0] != "[") return "";
    for (a = name.size - 1; a >= 0; a--)
        if (name[a] == "]") break;
    return (getSubStr(name, 1, a));
}
getCursorPos() {
    return bulletTrace(self getEye(), vectorScale(anglesToForward(self getPlayerAngles()), 1000000), 0, self)["position"];
}
setLobbyDvar(dvar, value) {
    for (i = 0; i < getPlayers().size; i++) getPlayers()[i] setClientDvar(dvar, value);
}
isIllegalWeapon(weapon) {
    illegal = strTok("molotov;zombie_cymbal_monkey;stielhandgranate;fraggrenade;mine_bouncing_betty", ";");
    for (a = 0; a < illegal.size; a++)
        if (isSubStr(weapon, illegal[a])) return true;
    return false;
}
isWeakWeapon(weapon) {
    weak = strTok("defaultweapon;zombie_melee", ";");
    for (a = 0; a < weak.size; a++)
        if (isSubStr(weapon, weak[a])) return true;
    return false;
}
killZombiesWithinDistance(pos, dist, deathFx) {
    zombz = getAiSpeciesArray("axis", "all");
    for (a = 0; a < zombz.size; a++) {
        if (distance(pos, zombz[a].origin) < dist) zombz[a] thread killZombies(deathFx);
    }
}
killZombies(type) {
    if (type == "tesla") self thread tesla_play_death_fx();
    if (type == "headGib") self thread zombie_head_gib();
    if (type == "flame") self thread animscripts\death::flame_death_fx();
    if (type == "delete") self remove();
    self doDamage(self.health + 666, self.origin, undefined, undefined, "riflebullet");
}
jumpToRound(target_round, forgetHealth) {
    if (target_round <= 1) return;
    if (getMap() == "nzf")
        while (level.dog_intermission) wait .5;
    if (target_round < 1) target_round = 1;
    level.zombie_health = level.zombie_vars["zombie_health_start"];
    level.zombie_total = 0;
    while (level.round_number < target_round) {
        if (!isDefined(forgetHealth)) self ai_calculate_health();
        level.round_number++;
        if (level.round_number > 50000) break;
    }
    level.round_number = target_round - 1;
    level notify("kill_round");
    wait 1;
    zom = getAiSpeciesArray("axis", "all");
    if (isDefined(zom))
        for (a = 0; a < zom.size; a++) zom[a] doDamage(zom[a].health + 667, zom[a].origin);
}
stopRoundChanging() {
    level endon("roundChanging_true");
    while (1) {
        level.zombie_total = 100;
        wait .05;
    }
}
isFacing(pos, angle) {
    orientation = self getPlayerAngles();
    forwardVec = anglesToForward(orientation);
    forwardVec2D = (forwardVec[0], forwardVec[1], 0);
    unitForwardVec2D = vectorNormalize(forwardVec2D);
    toFaceeVec = pos - self.origin;
    toFaceeVec2D = (toFaceeVec[0], toFaceeVec[1], 0);
    unitToFaceeVec2D = vectorNormalize(toFaceeVec2D);
    dotProduct = vectorDot(unitForwardVec2D, unitToFaceeVec2D);
    return (dotProduct > angle);
}
disableBuyables() {
    if (getMap() == "nzp") {
        weapons = getEntArray("weapon_upgrade", "targetname");
        for (i = 0; i <= weapons.size; i++) weapons[i] remove();
        weapon_cabs = getEntArray("weapon_cabinet_use", "targetname");
        for (i = 0; i <= weapon_cabs.size; i++) weapon_cabs[i] remove();
        pandorabox = getEntArray("treasure_chest_use", "targetname");
        for (i = 0; i <= pandorabox.size; i++) pandorabox[i] remove();
    }
    if (getMap() != "nzf") return;
    tok = strTok("m1carbine doublebarrel gewehr43 betty stg44 fg42_bipod type100_smg knife_bowie stielhandgranate stielhandgranate stielhandgranate thompson shotgun mp40 kar98k pack_door_clip", " ");
    array = getEntArray("script_brushmodel", "classname");
    for (a = 0; a < array.size; a++)
        for (e = 0; e < tok.size; e++)
            if (array[a].targetname == tok[e] || array[a].targetname == tok[e] + "_chalk" || array[a].targetname == tok[e] + "_chalk2" || array[a].targetname == tok[e] + "_chalk3") array[a] remove();
    tok = strTok("vending_pack_a_punch pf3788_auto1 pack_door", " ");
    array = getEntArray("script_model", "classname");
    for (a = 0; a < array.size; a++)
        for (e = 0; e < tok.size; e++)
            if (isDefined(array[a].targetname) && array[a].targetname == tok[e]) array[a] remove();
    for (a = 0; a < level.chests.size; a++) {
        rubble = getEntArray(level.chests[a].script_noteworthy + "_rubble", "script_noteworthy");
        if (isDefined(rubble))
            for (b = 0; b < rubble.size; b++) rubble[b] remove();
        for (e = 0; e < level.chests[a] getChestPieces().size; e++) {
            pieces = level.chests[a] getChestPieces();
            for (i = 0; i < pieces.size; i++) pieces[i] remove();
        }
    }
    getEntArray("trigger_multiple", "classname")[13] remove();
    getStructArray("perksacola", "targetname")[4] remove();
    array_delete(getEntArray("weapon_upgrade", "targetname"));
    array_delete(getEntArray("zombie_vending_upgrade", "targetname"));
    array_delete(getEntArray("bowie_upgrade", "targetname"));
    array_delete(getEntArray("treasure_chest_use", "targetname"));
    getEntArray("betty_purchase", "targetname")[0] trigger_off_proc();
    perkMachines = getEntArray("zombie_vending", "targetname");
    for (a = 0; a < perkMachines.size; a++) perkMachines[a] trigger_off_proc();
    level.pandora_light remove();
}
getChestPieces() {
    lid = getEnt(self.target, "targetname");
    org = getEnt(lid.target, "targetname");
    box = getEnt(org.target, "targetname");
    pieces = [];
    pieces[pieces.size] = self;
    pieces[pieces.size] = lid;
    pieces[pieces.size] = org;
    pieces[pieces.size] = box;
    return pieces;
}
startDvarReset(time) {
    self setVision("default");
    if (isDefined(time)) wait time;
    self thread resetVision();
    self thread resetDvars();
    self setClientDvar("jump_height", "40");
}
_hideSeek_timeoutInit() {
    timer = createText(getFont(), 2, "BOTTOMLEFT", "BOTTOMLEFT", 20, -20, 2, 1, undefined);
    timer setTimer(5);
    wait 3;
    self thread resetDvars();
    setLobbyDvar("sv_cheats", "1");
    self thread resetVision();
    wait 2;
    if (self == getPlayers()[0]) missionFailed();
}
resetVision() {
    self setClientDvar("r_specularMap", "1");
    self setClientDvar("r_specularColorScale", "1");
    self setClientDvar("cg_overheadIconSize", "0.8");
    self setClientDvar("cg_overheadRankSize", "0.6");
    self setClientDvar("cg_overheadNamesSize", "0.6");
    self setClientDvar("g_smoothClients", 1);
    self setClientDvar("hud_drawHUD", 1);
    self setClientDvar("cg_crosshairAlpha", 1);
    self setClientDvar("ui_hud_hardcore", 0);
    self setClientDvar("r_lightTweakSunlight", 1.3);
    self setClientDvar("r_flamefx_enable", "0");
    self thread sun("1.3", "0.588235 0.788235 1 1", (0.58, 0.78, 1));
}
resetDvars() {
    for (a = 0; a < getPlayers().size; a++) {
        getPlayers()[a] thread arraySetOptionColor(true, "RESET", 0);
        getPlayers()[a] thread arraySetOptionColor(undefined, "RESET", 1);
        getPlayers()[a] thread arraySetOptionColor(undefined, "SERVER", 11);
        level.uSprint = undefined;
        getPlayers()[a] thread arraySetOptionColor(undefined, "SERVER", 12);
        level.unlimitedAmmo = undefined;
    }
    for (a = 0; a < getPlayers()[0].dvarVars.size; a++) self setLobbyDvar(getPlayers()[0].dvarVars[a], getPlayers()[0].dvarVals[a]);
}
hideAmmoHud(value) {
    self setClientDvars("ammoCounterHide", value);
    self setClientDvars("ui_hud_hardcore", value);
}
dotDot(text) {
    self endon("dotDot_endon");
    while (isDefined(self)) {
        self setText(text);
        wait .2;
        self setText(text + ".");
        wait .15;
        self setText(text + "..");
        wait .15;
        self setText(text + "...");
        wait .15;
    }
}
flashFlash() {
    self endon("flashFlash_endon");
    self.alpha = 1;
    while (isDefined(self)) {
        self fadeOverTime(0.35);
        self.alpha = .2;
        wait 0.4;
        self fadeOverTime(0.35);
        self.alpha = 1;
        wait 0.45;
    }
}
changeFontScaleOverTime(size, time) {
    time = time * 20;
    _scale = (size - self.fontScale) / time;
    for (a = 0; a < time; a++) {
        self.fontScale += _scale;
        wait .05;
    }
}
lookPos() {
    x = 10000000;
    vector = anglesToForward(self getPlayerAngles());
    return (bulletTrace(self getEye(), (vector[0] * x, vector[1] * x, vector[2] * x), false, self)["position"]);
}
returnToSpawn() {
    self setStance("stand");
    struct = getStructArray("initial_spawn_points", "targetname");
    num = self getEntityNumber();
    self setOrigin(struct[num].origin);
    self setPlayerAngles(struct[num].angles);
}
playSingleSound(sound, info) {
    if (sound == "mx_eggs" || sound == "mx_credits") self thread universalMusic(sound, info);
    else self playSound(sound);
}
universalMusic(sound, info) {
    if (isDefined(level.EasterMusic) || (level.eggs && isDefined(level.eggs))) {
        self iprintln("There is music already playing");
        return;
    }
    if (isDefined(info)) self iPrintln(info);
    level.EasterMusic = true;
    self playsound(sound, "sound_done");
    self waittill("sound_done");
    level.EasterMusic = undefined;
}
physics(time) {
    self endon("NO_PHYSICS");
    if (isDefined(time)) wait time;
    while (isDefined(self)) {
        self physicsLaunch(self.origin, (0, 0, 0));
        wait .01;
    }
}
inMap() {
    playableArea = getEntArray("playable_area", "targetname");
    for (a = 0; a < playableArea.size; a++)
        if (self isTouching(playableArea[a])) return true;
    return false;
}
isSolo() {
    if (getPlayers().size <= 1) return true;
    return false;
}
arrayIntRandomize(min, max) {
    array = [];
    for (a = min; a <= max; a++) array[a] = min + a;
    int = maps\_utility::array_randomize(array);
    return (int);
}
spawnObjPointer(player, origin, icon, size, marker) {
    if (isDefined(player)) marker = newClientHudElem(player);
    else marker = newHudElem();
    marker.x = origin[0];
    marker.y = origin[1];
    marker.z = origin[2];
    marker.alpha = 1;
    marker setWayPoint(size, icon);
    return marker;
}
textMarker(player, org, text, size, color, title) {
    if (!isDefined(color)) color = (1, 1, 1);
    if (isDefined(player)) title = self createFontString(getFont(), 2, self);
    else title = createFontString(getFont(), 2);
    title.label = text;
    title.color = color;
    if (isDefined(color) && color == "RAIN") title thread smoothColorChange();
    title.x = org[0];
    title.y = org[1];
    title.z = org[2];
    title.alpha = 1;
    title setWayPoint(size, title);
    return title;
}
rotateEntPitch(pitch, time) {
    while (isDefined(self)) {
        self rotatePitch(pitch, time);
        wait time;
    }
}
rotateEntYaw(yaw, time) {
    while (isDefined(self)) {
        self rotateYaw(yaw, time);
        wait time;
    }
}
rotateEntRoll(roll, time) {
    while (isDefined(self)) {
        self rotateRoll(roll, time);
        wait time;
    }
}
getPlayerIndex() {
    return self.entity_num;
}
godCheck() {
    if (isDefined(self.godMode)) self enableGodMode();
    else self disableGodMode();
}
enableGodMode() {
    self enableInvulnerability();
    self enableHealthShield(true);
}
disableGodMode() {
    self disableInvulnerability();
    self enableHealthShield(false);
}
deleteChalks() {
    if (isDefined(level.chalk_hud1)) level.chalk_hud1 destroy();
    if (isDefined(level.chalk_hud2)) level.chalk_hud2 destroy();
    if (isDefined(level.intro_hud[0]))
        for (a = 0; a < level.intro_hud.size; a++) level.intro_hud[a] destroy();
}
isValidPlayer(player) {
    if (!isDefined(player)) return false;
    if (!isAlive(player)) return false;
    if (!isPlayer(player)) return false;
    if (player.is_zombie == true) return false;
    if (player.sessionstate == "spectator") return false;
    if (player.sessionstate == "intermission") return false;
    if (player maps\_laststand::player_is_in_laststand()) return false;
    if (player isnotarget()) return false;
    return true;
}
getFont() {
    if (!isConsole()) return "default";
    return "small";
}
isConsole() {
    if (level.xenon || level.ps3) return true;
    return false;
}
nuckleCrack() {
    weap = self getCurrentWeapon();
    crack = "zombie_knuckle_crack";
    primaries = self getWeaponsListPrimaries();
    if (weap != "none" && weap != "mine_bouncing_betty") self takeWeapon(weap);
    self giveWeapon(crack);
    self switchToWeapon(crack);
    self waittill("weapon_change_complete");
    self takeWeapon(crack);
    if (primaries.size <= 1) self giveWeapon("zombie_colt");
    primaries = self getWeaponsListPrimaries();
    if (isDefined(primaries) && primaries.size > 0) self switchToWeapon(primaries[0]);
    else self switchToWeapon("zombie_colt");
}
thirdPersonWeaponUpgrade(currentWeapon, origin, angles, perkMachine, arg) {
    level endon("VENDED");
    forward = anglesToForward(angles);
    interactPos = origin + (forward * -25);
    worldGun = spawnSM(interactPos, getWeaponModel(currentWeapon), self.angles, 1);
    worldGun skyBaseArray(true);
    if (isDefined(arg)) {
        FX = spawnSM(origin + (0, 1, -34), "tag_origin", forward - (0, 90, 0), 1);
        level thread weaponModelArray(worldGun, FX);
        playFxOnTag(level._effect["packapunch_fx"], FX, "tag_origin");
    } else playFx(level._effect["packapunch_fx"], origin + (0, 1, -34), forward);
    worldGun rotateTo(angles + (0, 90, 0), .35);
    wait .5;
    worldGun moveTo(origin, .5);
    perkMachine playSound("packa_weap_upgrade");
    wait .35;
    worldGun remove();
    wait 3;
    perkMachine playSound("packa_weap_ready");
    worldGun = spawnSM(origin, getWeaponModel(currentWeapon + "_upgraded"), angles + (0, 90, 0), 1);
    worldGun skyBaseArray(true);
    if (isDefined(arg)) level thread weaponModelArray(worldGun);
    worldGun moveTo(interactPos, .5);
    wait .5;
    worldGun moveTo(origin, level.packapunch_timeout);
    return worldGun;
}
randomMusicPlayers() {
    while (isDefined(self)) {
        self playSound("mx_packa_jingle");
        self.playingMusic = true;
        wait 46;
        self.playingMusic = undefined;
        wait(randomIntRange(50, 90));
    }
}
weaponModelArray(model, other) {
    level waittill("VENDED");
    model delete();
    if (isDefined(other)) other delete();
}
waitForPlayerToTake(player, weapon, packaTimer) {
    self endon("pap_timeout");
    while (1) {
        packaTimer playLoopSound("ticktock_loop");
        self.trig waittill("trigger", grabber);
        if (!grabber useButtonPressed()) continue;
        packaTimer stopLoopSound(.05);
        if (grabber == player) {
            self notify("pap_taken");
            primaries = player getWeaponsListPrimaries();
            if (isDefined(primaries) && primaries.size >= 2) player takeWeapon(player getCurrentWeapon());
            player giveWeapon(weapon + "_upgraded");
            player giveMaxAmmo(weapon + "_upgraded");
            player switchToWeapon(weapon + "_upgraded");
            packaTimer stopLoopSound(.05);
            player playSound("plr_" + player getEntityNumber() + "_vox_perk_packa_get_" + randomInt(5));
            return;
        }
        wait .05;
    }
}
waitForTimeout(packaTimer) {
    self endon("pap_taken");
    wait(level.packapunch_timeout);
    self notify("pap_timeout");
    packaTimer stopLoopSound(.05);
    packaTimer playSound("packa_deny");
}
doorMovementArray() {
    if (!isDefined(level.skybaseArrayDoor)) level.skybaseArrayDoor = [];
    level.skybaseArrayDoor[level.skybaseArrayDoor.size] = self;
}
smallArray(type) {
    if (!isDefined(level.smallSpawnArray)) level.smallSpawnArray = [];
    if (!isDefined(level.smallSpawnArray[type])) level.smallSpawnArray[type] = [];
    level.smallSpawnArray[type][level.smallSpawnArray[type].size] = self;
}
skyBaseArray(delete) {
    if (isDefined(delete)) self thread skyBaseDelete();
    else self thread skyBasePhysics();
    if (!isDefined(level.skybaseArray)) level.skybaseArray = [];
    level.skybaseArray[level.skybaseArray.size] = self;
}
physicsArray(delete) {
    if (isDefined(delete)) self thread skyBaseDelete();
    else self thread skyBasePhysics();
    if (!isDefined(level.physicsArray)) level.physicsArray = [];
    level.physicsArray[level.physicsArray.size] = self;
}
skyBaseDelete() {
    level waittill("SKYBASE_FAIL");
    if (isDefined(self)) self remove();
}
skyBasePhysics() {
    level endon("SKYBASE_DELETED");
    level waittill("SKYBASE_FAIL");
    if (isDefined(level.drivingSkybase)) return;
    while (true) {
        self physicsLaunch();
        wait .1;
    }
}
deleteSmallArray(type) {
    if (isDefined(level.smallSpawnArray[type]))
        for (a = 0; a < level.smallSpawnArray[type].size; a++)
            if (isDefined(level.smallSpawnArray[type][a])) level.smallSpawnArray[type][a] remove();
    level.smallSpawnArray[type] = undefined;
    if (level.smallSpawnArray.size == 0) {
        level.bigSpawn = undefined;
        level.smallSpawn = undefined;
        for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread arraySetOptionColor(undefined, "spawn", self.menu["spawn_POINTER"]);
    }
}
deleteSkyBase() {
    if (isDefined(level.skybaseArray))
        for (a = 0; a < level.skybaseArray.size; a++)
            if (isDefined(level.skybaseArray[a])) level.skybaseArray[a] remove();
    if (isDefined(level.physicsArray))
        for (a = 0; a < level.physicsArray.size; a++)
            if (isDefined(level.physicsArray[a])) level.physicsArray[a] remove();
    level.skybaseArray = undefined;
    level.physicsArray = undefined;
    level.skyBaseDestroyed = undefined;
}
skyBaseDestroy(base) {
    if (isDefined(level.skyBaseIsBuilding) || !isDefined(skyBaseBuilt(base)) || skybaseUsed() || isDefined(level.skyBaseDestroyed) || isDefined(level.drivingSkybase)) return;
    level notify("SKYBASE_FAIL");
    level.skyBaseDestroyed = true;
    level thread deleteIcon();
    level thread unSolidifyFactoryDoors();
    for (a = 0; a < getPlayers().size; a++) {
        player = getPlayers()[a];
        player thread godCheck();
        player.riding = undefined;
        player allowedStance(true);
        if (isDefined(player.clawInst)) player.clawInst destroy();
        if (isDefined(player.inSkyBase)) {
            player setStance("stand");
            if (base != "twoStory" && base != "Trampoline") player thread otherPlayerFall();
            else {
                if (isDefined(player.trampTimer)) player.trampTimer destroy();
                if (isDefined(player.trampInstructions[1])) self destroyAll(player.trampInstructions);
                player returnToSpawn();
                player thread afterKillstreakProtection();
            }
        }
        player.inSkyBase = undefined;
    }
}
allowedStance(bool) {
    self allowLean(bool);
    self allowAds(bool);
    self allowSprint(bool);
    self allowProne(bool);
    self allowCrouch(bool);
    self allowMelee(bool);
    self allowJump(bool);
}
deleteIcon() {
    if (isDefined(level.notifyIcon)) level.notifyIcon destroy();
}
skyBaseBuilt(base) {
    if (base == "Physics") return level.physicsBase;
    if (base == "Motion") return level.motionFlexBase;
    if (base == "Berry") return level.berryBase;
    if (base == "Redbull") return level.redBullBase;
    if (base == "Armory") return level.theArmory;
    if (base == "Rated") return level.iRatedBase;
    if (base == "Bunker") return level.bunker;
    if (base == "Sniper") return level.sniperBase;
    if (base == "Secret") return level.secretRoom;
    if (base == "Station") return level.teleportStation;
    if (base == "Trampoline") return level.trampoline;
    if (base == "twoStory") return level.twoStoryBase;
    if (base == "Ferris") return level.Ferris_Wheel;
    if (base == "Twister") return level.twister;
    if (base == "Claw") return level.claw;
    if (base == "Coaster") return level.coaster;
    if (base == "Merry") return level.merryRound;
    if (base == "Bounce") return level.bounceHouse;
    if (base == "Tornado") return level.tornado;
    if (base == "SkyText") return level.skyText;
}
skybaseUsed() {
    for (a = 0; a < getPlayers().size; a++)
        if (isDefined(getPlayers()[a].usingSkyBase) && isValidPlayer(getPlayers()[a])) return 1;
    return 0;
}
otherPlayerFall() {
    fly = spawn("script_origin", self.origin);
    self playerLinkToDelta(fly);
    fly moveto(self.origin + (0, 0, -200), .7);
    wait .8;
    self unlink();
    self allowJump(true);
    self allowProne(true);
    fly remove();
    self thread godCheck();
}
skyBaseBox(boxO, boxA, lidO, lidA, FXang, cost, num) {
    base = spawnStruct();
    base = spawnSM(boxO, "zombie_treasure_box", boxA);
    base skyBaseArray();
    base.lid = spawnSM(lidO, "zombie_treasure_box_lid", lidA);
    base.lid skyBaseArray();
    base.trig = spawnTrigger(base.origin + (0, 0, 20 - num) + anglesToRight(lidA) * -15, 40);
    base.trig skyBaseArray(true);
    while (1) {
        base.trig setString("Press [{+activate}] for a Random Weapon [Cost: " + cost + "]");
        user = undefined;
        while (1) {
            base.trig waittill("trigger", user);
            if (user useButtonPressed()) {
                if (user.score < cost) {
                    user noMoneySound();
                    wait .1;
                    continue;
                } else break;
            }
        }
        user.usingSkyBase = true;
        user minus_to_player_score(cost);
        base.lid rotateRoll(105, .5, (.5 * .5));
        base.lid playSound("lid_open");
        base.lid playSound("music_box");
        base thread treasureChestWeaponSpawn(user);
        base.fx = spawnSM(base.origin, "tag_origin", FXang);
        playFxOnTag(level._effect["chest_light"], base.fx, "tag_origin");
        base.trig setString("");
        base waittill("randomization_done");
        base.trig setString("Press & hold [{+activate}] to trade Weapons");
        base thread treasureChestTimeout();
        wait .5;
        while (1) {
            base.trig waittill("trigger", grabber);
            if (grabber useButtonPressed() && grabber == user) {
                if (base.randomlyRolledWeapon != "") grabber thread treasure_chest_give_weapon(base.RandomlyRolledWeapon);
                base playSound("cha_ching");
                base notify("user_grabbed_weapon");
                break;
            } else if (grabber == level) {
                base notify("user_grabbed_weapon");
                break;
            }
        }
        base.lid rotateRoll(-105, .5, (.5 * .5));
        base.lid playSound("lid_close");
        base.fx remove();
        base.weaponBeingRolled remove();
        base.trig setString("");
        user.usingSkyBase = undefined;
        wait 2;
    }
}
treasureChestWeaponSpawn(player) {
    self.weaponBeingRolled = spawnSM(self.origin, "tag_origin", self.lid.angles + (0, 180, 0));
    self.weaponBeingRolled moveTo(self.weaponBeingRolled.origin + (0, 0, 40), 3, 2, .9);
    keys = getArrayKeys(level.zombie_weapons);
    array = [];
    for (a = 0; a < keys.size; a++)
        if (!isSubStr(keys[a], "mine_bouncing_betty") && !isSubStr(keys[a], "_upgraded") && !player hasWeapon(keys[a]) && !player hasWeapon(keys[a] + "_upgraded")) array[array.size] = keys[a];
    randy = 0;
    for (a = 0; a < 40; a++) {
        if (a < 20) wait .05;
        else if (a < 30) wait .1;
        else if (a < 35) wait .2;
        else if (a < 38) wait .3;
        randy = array[randomInt(array.size)];
        self.weaponBeingRolled setModel(getWeaponModel(randy));
    }
    self.randomlyRolledWeapon = randy;
    self notify("randomization_done");
}
treasureChestTimeout() {
    self endon("user_grabbed_weapon");
    self.weaponBeingRolled moveTo(self.weaponBeingRolled.origin - (0, 0, 40), 12, (12 * .5));
    wait 12;
    self.trig notify("trigger", level);
}
afterKillstreakProtection(hide) {
    if (!isDefined(hide)) self thread deathMessage("^1" + level.patch, "^2PROTECTION ZONE ^7- Activated for 5 Seconds", 266, 5);
    self setVision("vampire_low");
    time = 0;
    while (1) {
        time += .05;
        level killZombiesWithinDistance(self.origin, 100, "headGib");
        if (time >= 5) break;
        wait .05;
    }
    if (isSurv()) self setVision("fly_dark");
    else self setVision("default");
}
isSurv() {
    if (isDefined(level.isSurvivalMode)) return true;
    return false;
}
setInvisibleToAll() {
    for (a = 0; a < get_players().size; a++) self setInvisibleToPlayer(get_players()[a]);
}
createRoll(divide) {
    roll = self getPlayerAngles()[1];
    wait 0.05;
    newRoll = (roll - self getPlayerAngles()[1]) * -6;
    return newRoll / divide;
}
doPlayerDamage(orig, dist) {
    for (e = 0; e < getPlayers().size; e++)
        if (distance(getPlayers()[e].origin, orig) <= dist) {
            if (!getPlayers()[e] hasPerk("specialty_armorvest") || getPlayers()[e].health - 100 < 1) radiusDamage(getPlayers()[e].origin, 10, getPlayers()[e].health + 100, getPlayers()[e].health + 100);
            else getPlayers()[e] doDamage(50, getPlayers()[e].origin);
        }
}
flingZombie(player, flingVec) {
    if (!isDefined(self) || !isAlive(self)) return;
    self doDamage(self.health + 666, player.origin, player);
    if (self.health <= 0) {
        self startRagdoll();
        self launchRagdoll(flingVec);
    }
}
getDogSpawns() {
    zones = getArrayKeys(level.zones);
    dogSpawns = [];
    for (a = 0; a < zones.size; a++) {
        zone = getStructArray(level.zones[zones[a]].volumes[0].target + "_dog", "targetname");
        for (e = 0; e < zone.size; e++) dogSpawns[dogSpawns.size] = zone[e].origin;
    }
    return (dogSpawns);
}
createEnemyPointOfInterest(attract_dist, num_attractors, added_poi_value, start_turned_on) {
    if (!isDefined(added_poi_value)) self.added_poi_value = 0;
    else self.added_poi_value = added_poi_value;
    if (!isDefined(start_turned_on)) start_turned_on = true;
    self.script_noteworthy = "zombie_poi";
    self.poi_active = start_turned_on;
    if (isDefined(attract_dist)) self.poi_radius = attract_dist * attract_dist;
    else self.poi_radius = undefined;
    self.num_poi_attracts = num_attractors;
    self.attract_to_origin = true;
}