#include common_scripts\utility;
#include maps\_utility;
#include maps\_hud_util;
#include maps\_createcam;
#include maps\_createmenu;
#include maps\_destructible_types;


jenga_createTower() {
    level.jenga_Blocks = [];
    origin = (-1582.005, -524, 619.125);
    ZB = "zombie_treasure_box";
    for (i = 0; i < 17; i++) {
        for (a = 0; a < 3; a++) level.jenga_Blocks[level.jenga_Blocks.size] = spawnSM(origin + (0, -30 + a * 30, i * 19.85), ZB);
        i++;
        for (a = 0; a < 3; a++) level.jenga_Blocks[level.jenga_Blocks.size] = spawnSM(origin + (-30 + a * 30, 0, i * 19.85), ZB, (0, 90, 0));
    }
    for (a = 1; a < level.jenga_Blocks.size; a += 3) level.jenga_Blocks[a].middleBlock = true;
    for (a = 0; a < level.jenga_Blocks.size; a++) {
        level.jenga_Blocks[a].indexNumber = a;
        level.jenga_Blocks[a] thread physics();
    }
    for (a = 0; a < getPlayers().size; a++) {
        for (b = 0; b < level.jenga_Blocks.size; b++) level.jenga_Blocks[b] thread jenga_watchOrigin(getPlayers()[a]);
        getPlayers()[a] thread jenga_watchClosest();
    }
    level thread jenga_checkForFail();
    if (!isSolo()) self waittill("Game_Start");
    level thread jenga_Hud();
    wait 3;
    level thread jenga_Notify("Tower Settling", "LOAD");
    wait 3;
    setLobbyDvar("phys_gravity", -1);
    level thread jenga_playerRotation();
}
jenga_checkForFail() {
    level thread jenga_waitForFail();
    level endon("JENGA_OVER");
    while (true) {
        for (a = 3; a < level.jenga_Blocks.size; a++) {
            if ((level.jenga_Blocks[a].origin[2] <= 630 || distance2d((-1582, -518, 619.125), level.jenga_Blocks[a].origin) >= 60) && isDefined(level.jenga_Blocks[a])) level notify("JENGA_OVER");
        }
        wait .05;
    }
}
jenga_waitForFail() {
    level waittill("JENGA_OVER");
    level.jengaTimer destroy();
    level.jenga_gameOver = true;
    setLobbyDvar("phys_gravity", -1000);
    level thread jenga_Notify("Jenga -- Game Over!", "FLASH");
    wait 5;
    level.jenga[3] settext("Winner: " + getPlayers()[level.jengaWinnerIndex] getName());
    getPlayers()[0] thread _hideSeek_timeoutInit();
}
jenga_createRevolver() {
    towerOrigin = (-1582.005, -524, 619.125);
    revolverSeat = spawnSM(towerOrigin + (sin(0) * 250, cos(0) * 250, 60), "script_origin");
    self notSolid();
    self hide();
    self setPlayerAngles((0, -90, 0));
    self playerLinkTo(revolverSeat);
    self disableWeapons();
    horizontal = 0;
    vertical = 60;
    level.jenga_Counter = 0;
    level.jenga_Stories = 18;
    level.jenga_Direction = true;
    while (true) {
        if (self attackButtonPressed() || self adsButtonPressed()) {
            if (self attackButtonPressed()) horizontal -= 3;
            else horizontal += 3;
            revolverSeat.origin = ((-1582.005, -524, revolverSeat.origin[2]) + (sin(horizontal) * 250, cos(horizontal) * 250, 0));
            self setPlayerAngles((0, -90 - horizontal, 0));
            if (horizontal > 360) horizontal = 3;
            if (horizontal < 0) horizontal = 357;
        }
        if (self meleeButtonPressed() || self fragButtonPressed()) {
            if (self fragButtonPressed() && vertical < level.jenga_Stories * 20) vertical += 10;
            if (self meleeButtonPressed() && vertical > 0) vertical -= 10;
            revolverSeat.origin = ((revolverSeat.origin[0], revolverSeat.origin[1], 619.125) + (0, 0, vertical));
        }
        if (self useButtonPressed() && isDefined(level.jenga_playersTurn) && isDefined(self.jenga_closestEnt)) self thread jenga_moveBlock(towerOrigin);
        wait .05;
    }
}
jenga_moveBlock(towerOrigin) {
    level endon("JENGA_OVER");
    if (level.jenga_playersTurn != self getPlayerIndex() || isDefined(level.jenga_gameOver)) return;
    if (!isSolo()) level.jengaTimer thread hudFade(0, .5);
    level.jenga_playersTurn = undefined;
    start = self.jenga_closestEnt.indexNumber;
    level.jenga_Blocks[start] notify("NO_PHYSICS");
    jengaBlock = level.jenga_Blocks[start];
    self.jenga_closestEnt = undefined;
    self.jenga_showLights = undefined;
    self notify("JENGA_LIGHTS_R");
    middleBlock = jengaBlock.middleBlock;
    level.jenga_Blocks[start] remove();
    if (isDefined(level.jenga_Direction)) level.jenga_Blocks[level.jenga_Blocks.size] = spawnSM(towerOrigin + (0, -30 + level.jenga_Counter * 30, level.jenga_Stories * 19.9), "zombie_treasure_box");
    else level.jenga_Blocks[level.jenga_Blocks.size] = spawnSM(towerOrigin + (-30 + level.jenga_Counter * 30, 0, level.jenga_Stories * 19.9), "zombie_treasure_box", (0, 90, 0));
    level.jenga_Blocks[level.jenga_Blocks.size - 1].indexNumber = level.jenga_Blocks.size - 1;
    for (a = 0; a < getPlayers().size; a++) level.jenga_Blocks[level.jenga_Blocks.size - 1] thread jenga_watchOrigin(getPlayers()[a]);
    level.jenga_Blocks[level.jenga_Blocks.size - 1].middleBlock = middleBlock;
    jengaBlock = level.jenga_Blocks[level.jenga_Blocks.size - 1];
    if (isDefined(jengaBlock.middleBlock)) start--;
    else if (start % 3 != 0) start -= 2;
    count = 0;
    for (a = start; a < start + 3; a++) {
        if (!isDefined(level.jenga_Blocks[a])) count++;
    }
    if (count > 1 && !isDefined(level.jenga_Blocks[start + 1])) jengaBlock.specialBlock = true;
    level.jenga_Counter++;
    if (level.jenga_Counter == 3) {
        level.jenga_Counter = 0;
        level.jenga_Stories++;
        if (!isDefined(level.jenga_Direction)) level.jenga_Direction = true;
        else level.jenga_Direction = undefined;
    }
    level thread jenga_Notify("Tower Settling", "LOAD");
    jengaBlock thread physics(.3);
    self jenga_structureTest(jengaBlock);
    level notify("jenga_playerRotate");
    level.jengaWinnerIndex = self getPlayerIndex();
    wait .25;
    if (!isSolo()) level.jengaTimer thread hudFade(1, .5);
}
jenga_moveModel() {
    level endon("JENGA_OVER");
    self.jenga_model = spawnSM(self.origin, "tag_origin");
    while (true) {
        self.jenga_model moveTo(self getEye() + vectorScale(anglesToforward(self getPlayerAngles()), 235), .1);
        wait .05;
    }
}
jenga_watchOrigin(who) {
    level endon("JENGA_OVER");
    who.jenga_closestEnt = self;
    while (isDefined(self)) {
        if (self == who.jenga_closestEnt && level.jenga_playersTurn == who getPlayerIndex() && isDefined(level.jenga_playersTurn)) {
            if (distance(self.origin, who.jenga_model.origin) <= 100) who jenga_createLights(self);
            else {
                who.jenga_closestEnt = undefined;
                who notify("JENGA_LIGHTS_R");
            }
        }
        wait .05;
    }
}
jenga_watchClosest() {
    level endon("JENGA_OVER");
    closest = [];
    while (true) {
        for (a = 0; a < level.jenga_Blocks.size; a++) {
            if (distance(level.jenga_Blocks[a].origin, self.jenga_model.origin) <= 100) closest[a] = level.jenga_Blocks[a];
            else closest[a] = undefined;
        }
        self.jenga_closestEnt = getClosest(self.jenga_model.origin, closest);
        if (distance(self.jenga_closestEnt.origin, self.jenga_model.origin) > 100) self.jenga_closestEnt = undefined;
        wait .05;
    }
}
jenga_createLights(ent) {
    level endon("JENGA_OVER");
    if (self.jenga_closestEnt != ent || !isDefined(self.jenga_showLights)) return;
    self notify("JENGA_LIGHTS_R");
    self.jenga_closestEnt = ent;
    vecF = anglesToForward(ent.angles);
    vecR = anglesToRight(ent.angles);
    vecU = anglesToUp(ent.angles);
    pos = ent.origin;
    model = "zombie_treasure_box";
    lights = [];
    lights[0] = snapSM(pos + (vecR * 12) + (vecU * 8.8), "tag_origin", vectorToAngles(vecR));
    lights[1] = snapSM(pos - (vecR * 12) + (vecU * 8.8), "tag_origin", vectorToAngles(vecR * -1));
    lights[2] = snapSM(pos + (vecF * 45) + (vecU * 8.8), "tag_origin", vectorToAngles(vecF));
    lights[3] = snapSM(pos - (vecF * 45) + (vecU * 8.8), "tag_origin", vectorToAngles(vecF * -1));
    for (a = 0; a < 4; a++) {
        self thread jenga_removeLights(lights[a]);
        playFxOnTag(level._effect["zapper_light_ready"], lights[a], "tag_origin");
        playFxOnTag(level._effect["zapper_light_notready"], lights[a], "tag_origin");
        playFxOnTag(level._effect["zapper_light_notready"], lights[a], "tag_origin");
    }
    while (true) {
        if (self.jenga_closestEnt != ent) break;
        wait .05;
    }
}
jenga_removeLights(lights) {
    self waittill_any("JENGA_LIGHTS_R", "JENGA_OVER");
    lights remove();
}
jenga_playerRotation() {
    level endon("JENGA_OVER");
    if (!isSolo()) {
        level.jengaTimer = level createServerText(getFont(), 1.5, "TOPLEFT", "TOPLEFT", 20, 20, 1, 0, undefined);
        level.jengaTimer.label = "Time Left: ";
        level.jengaTimer thread hudFade(1, .5);
    }
    index = randomIntRange(0, getPlayers().size);
    while (true) {
        if (index > getPlayers().size - 1) index = 0;
        level thread jenga_Notify("Players Turn: " + getPlayers()[index] getName());
        getPlayers()[index].jenga_showLights = true;
        if (!isSolo()) {
            getPlayers()[index] thread jenga_createTimer();
            level.jengaTimer setTimer(30);
        }
        level.jenga_playersTurn = index;
        index++;
        level waittill("jenga_playerRotate");
        wait .25;
    }
}
jenga_createTimer() {
    self endon("JENGA_LIGHTS_R");
    wait 30;
    self.jenga_playersTurn = undefined;
    level notify("jenga_playerRotate");
    self notify("JENGA_LIGHTS_R");
}
jenga_structureTest(block) {
    level endon("JENGA_OVER");
    if (isDefined(block.specialBlock)) {
        setLobbyDvar("phys_gravity", -1500);
        wait 2;
        setLobbyDvar("phys_gravity", -1000);
        wait 2;
        setLobbyDvar("phys_gravity", -500);
        wait 1;
        setLobbyDvar("phys_gravity", -100);
        wait .5;
    } else if (isDefined(block.middleBlock)) {
        setLobbyDvar("phys_gravity", -8);
        wait .5;
        setLobbyDvar("phys_gravity", -4);
        wait 2.5;
    } else if (!isDefined(block.middleBlock)) {
        setLobbyDvar("phys_gravity", -50);
        wait .5;
        setLobbyDvar("phys_gravity", -25);
        wait 2.5;
    }
    setLobbyDvar("phys_gravity", -5);
    wait 1;
    setLobbyDvar("phys_gravity", -1);
    block.specialBlock = undefined;
    if (isDefined(block.middleBlock) && level.jenga_Counter != 2) block.middleBlock = undefined;
    else block.middleBlock = true;
    wait .5;
}
jenga_Hud() {
    self.jenga = [];
    self.jenga[0] = self createRectangle("LEFT", "LEFT", -180, 0, 160, 1, (1, 0.7372549019607844, 0.12941176470588237), "white", 2, .8, true);
    self.jenga[1] = self createRectangle("LEFT", "LEFT", -180, 0, 160, 26, (0, 0, 0), "white", 1, .5, true);
    self.jenga[2] = self createServerText(getFont(), 1, "CENTER", "LEFT", self.jenga[1].x + 80, -6.25, 3, 1, "Jenga Controls");
    self.jenga[3] = self createServerText(getFont(), 1, "CENTER", "LEFT", self.jenga[1].x + 80, 6.25, 3, 1, "Welcome To Jenga");
    for (a = 0; a < 4; a++) self.jenga[a] thread hudMoveX(self.jenga[a].x + 185, .5);
    wait .6;
    self.jenga[0] scaleOverTime(.45, 160, 66);
    self.jenga[1] scaleOverTime(.45, 160, 90);
    self.jenga[2] thread hudMoveY(-38.75, .45);
    self.jenga[3] thread hudMoveY(38.75, .45);
    self.jenga[4] = self createServerText(getFont(), 1, "LEFT", "LEFT", self.jenga[0].x + 5, 0, 3, 0, "[{+frag}]: Move Up");
    self.jenga[5] = self createServerText(getFont(), 1, "LEFT", "LEFT", self.jenga[4].x, -12.9, 3, 0, "[{+attack}]: Revolve Right");
    self.jenga[6] = self createServerText(getFont(), 1, "LEFT", "LEFT", self.jenga[4].x, 12.9, 3, 0, "[{+melee}]: Move Down");
    self.jenga[7] = self createServerText(getFont(), 1, "LEFT", "LEFT", self.jenga[4].x, -25.8, 3, 0, "[{+speed_throw}]: Revolve Left");
    self.jenga[8] = self createServerText(getFont(), 1, "LEFT", "LEFT", self.jenga[4].x, 25.8, 3, 0, "[{+activate}]: Select Jenga Block");
    self.jenga[4] thread hudFade(1, .3);
    wait .15;
    self.jenga[5] thread hudFade(1, .3);
    self.jenga[6] thread hudFade(1, .3);
    wait .15;
    self.jenga[7] thread hudFade(1, .3);
    self.jenga[8] thread hudFade(1, .3);
    level waittill("JENGA_OVER");
    wait 5.5;
    self.jenga[0] scaleOverTime(.45, 160, 1);
    self.jenga[1] scaleOverTime(.45, 160, 26);
    self.jenga[2] thread hudMoveY(-6.25, .45);
    self.jenga[3] thread hudMoveY(6.25, .45);
    self.jenga[7] thread hudFadenDestroy(0, .15);
    self.jenga[8] thread hudFadenDestroy(0, .15);
    wait .1;
    self.jenga[5] thread hudFadenDestroy(0, .15);
    self.jenga[6] thread hudFadenDestroy(0, .15);
    wait .1;
    self.jenga[4] thread hudFadenDestroy(0, .1);
}
jenga_Notify(text, type) {
    self.jenga[3] notify("dotDot_endon");
    self.jenga[3] notify("flashFlash_endon");
    self.jenga[3] settext(text);
    if (isDefined(type)) {
        if (type == "LOAD") self.jenga[3] thread dotDot(text);
        else if (type == "FLASH") self.jenga[3] thread flashFlash();
    }
}
chess_playerAxisMovement(playerIndex) {
    self hide();
    origin = -200 - 640 * (playerIndex - 1);
    self setPlayerAngles((57, -90 + 180 * (playerIndex - 1), 0));
    clip = spawnSM((-1582, origin, 955), "script_origin");
    self playerLinkTo(clip);
    hud = [];
    hud["BG"] = self createRectangle("LEFT", "LEFT", 10, 0, 160, 85, (0, 0, 0), "white", 1, .6);
    hud["TITLE"] = self createText(self getFont(), 1.2, "CENTER", "LEFT", hud["BG"].x + 80, -33.75, 10, 1, "Clip Controls");
    hud["LINE"] = self createRectangle("LEFT", "LEFT", hud["BG"].x, -25, 160, 1, divideColor(0, 110, 255), "white", 10, 1);
    hud[0] = self createText(self getFont(), 1, "LEFT", "LEFT", hud["TITLE"].x - 75, -15, 10, 1, "[{+attack}]: Move Forwards");
    hud[1] = self createText(self getFont(), 1, "LEFT", "LEFT", hud[0].x, 0, 10, 1, "[{+speed_throw}]: Move Backwards");
    hud[2] = self createText(self getFont(), 1, "LEFT", "LEFT", hud[0].x, 15, 10, 1, "[{+activate}]: Select Piece / Move");
    hud["LINE2"] = self createRectangle("LEFT", "LEFT", hud["BG"].x, 25, 160, 1, divideColor(0, 110, 255), "white", 10, 1);
    hud["TURN"] = self createText(self getFont(), 1.2, "CENTER", "LEFT", hud["TITLE"].x, 33.75, 10, 1, "Solo Play");
    if (!isSolo()) self thread watchForNewTurn(playerIndex, hud["TURN"]);
    wall_1 = -424;
    wall_2 = -844;
    if (playerIndex == 1 && !isSolo()) {
        wall_1 = -204;
        wall_2 = -624;
    }
    if (isSolo()) wall_1 = -204;
    if (!isSolo()) level waittill("CHESS_BOARD");
    while (true) {
        vec = anglesToForward(self getPlayerAngles());
        end = (vec[0] * 20, vec[1] * 20, vec[2] * 20);
        if (isDefined(level.chess_Player[playerIndex].chess_playerPromotion)) self chess_moveToPromotionArea(playerIndex, clip);
        if (isSolo() && isDefined(level.chess_Player[level.chess_player[playerIndex].otherPlayerIndex].chess_playerPromotion)) self chess_moveToPromotionArea(level.chess_player[playerIndex].otherPlayerIndex, clip);
        if (self attackButtonPressed()) {
            forward = clip.origin + end;
            if (forward[0] <= -1302 && forward[0] >= -1862 && forward[1] >= wall_2 && forward[1] <= wall_1 && forward[2] >= 630 && forward[2] <= 1310) clip.origin = clip.origin + end;
        } else if (self adsButtonPressed()) {
            back = clip.origin - end;
            if (back[0] <= -1302 && back[0] >= -1862 && back[1] >= wall_2 && back[1] <= wall_1 && back[2] >= 630 && back[2] <= 1310) clip.origin = clip.origin - end;
        }
        wait .05;
    }
}
watchForNewTurn(playerIndex, hud) {
    wait 5;
    enemyIndex = level.chess_Player[level.chess_player[playerIndex].otherPlayerIndex].playerIndex;
    while (true) {
        if (isDefined(level.chess_Player[playerIndex].playersTurn)) {
            hud.alpha = 0;
            hud setText("It's Your Move");
            hud hudFade(1, 1);
            while (isDefined(level.chess_Player[playerIndex].playersTurn)) wait .05;
        } else {
            hud.alpha = 0;
            hud setText("It's " + getPlayers()[enemyIndex] getName() + "'s Move");
            hud hudFade(1, 1);
            while (!isDefined(level.chess_Player[playerIndex].playersTurn)) wait .05;
        }
        wait .05;
    }
}
chess_makeBoard() {
    level.chess_Board = [];
    board = spawnStruct();
    board.origin = (-1366.005, -326, 587.5);
    board.origin2 = board.origin + (-17, 5, 30);
    board.model = "static_berlin_metal_desk";
    board.model2 = "static_peleliu_palette";
    board.length = 72;
    board.width = 36;
    board.length2 = 57;
    board.width2 = 58;
    for (a = 0; a < 2; a++)
        for (b = 0; b < 2; b++) level.chess_Board[level.chess_Board.size] = spawnSM(board.origin + (50.5, 68, 162) - (532.5 * a, 532.5 * b, 0), "zombie_teleporter_mainframe_top", (0, 180 - b * 180, 0));
    for (a = 0; a < 13; a++)
        for (b = 0; b < 6; b++) level.chess_Board[level.chess_Board.size] = spawnSM(board.origin - (board.width * a, board.length * b, 0), board.model, (0, 90, 0));
    level.chess_Board[level.chess_Board.size] = spawnSM(board.origin - (0, 396, .1), board.model, (0, 90, 0));
    for (a = 0; a < 6; a++) level.chess_Board[level.chess_Board.size] = spawnSM(board.origin - (board.length * a + (54), 414, 0), board.model);
    for (a = 0; a < 8; a++)
        for (b = a % 2; b < 8; b += 2) level.chess_Board[level.chess_Board.size] = spawnSM(board.origin2 - (board.length2 * a, board.width2 * b, 0), board.model2, (0, 90, 0));
    level.chess_Spots = [];
    for (a = 0; a < 8; a++) {
        level.chess_Spots[a] = [];
        for (b = 0; b < 8; b++) level.chess_Spots[a][b] = spawnStruct();
    }
    for (a = 0; a < 8; a++)
        for (b = 0; b < 8; b++) {
            level.chess_Spots[a][b].org = board.origin2 - (board.length2 * a, board.width2 * b, -5);
            level.chess_Spots[a][b].row = a;
            level.chess_Spots[a][b].column = b;
            level.chess_Spots[a][b].positions = spawnSM(level.chess_Spots[a][b].org + (0, 0, 5), "tag_origin", vectorToAngles(anglesToUp((0, 0, 0))));
            playFxOnTag(level._effect["zapper_light_ready"], level.chess_Spots[a][b].positions, "tag_origin");
            playFxOnTag(level._effect["zapper_light_notready"], level.chess_Spots[a][b].positions, "tag_origin");
        }
    for (a = 1; a < 3; a++) {
        level.chess_Player[a].pieces = [];
        for (b = 0; b < 16; b++) level.chess_Player[a].pieces[b] = spawnStruct();
    }
    level.chess_pieceType = [];
    chess_buildPawns();
    level.chess_pieceType["PAWN"] = 3;
    chess_buildRooks();
    level.chess_pieceType["ROOK"] = 4;
    chess_buildKnights();
    level.chess_pieceType["KNIGHT"] = 8;
    chess_buildBishops();
    level.chess_pieceType["BISHOP"] = 4;
    chess_buildQueen();
    level.chess_pieceType["QUEEN"] = 8;
    chess_buildKing();
    level.chess_pieceType["KING"] = 8;
    for (a = 1; a < 3; a++)
        for (b = 0; b < 16; b++) {
            level.chess_Player[a].pieces[b].moveOrigin = level.chess_Player[a].pieces[b].piece.origin;
            level.chess_Player[a].pieces[b].currentMovePathPosition = [];
            for (c = 0; c < 8; c++) level.chess_Player[a].pieces[b].currentMovePathPosition[c] = [];
        }
    for (a = 1; a < 3; a++) {
        for (b = 0; b < 8; b++)
            for (c = 0; c < 3; c++) level thread chess_updateAllPositions(int(a), int(b), int(c));
        for (b = 8; b < 10; b++)
            for (c = 0; c < 4; c++) level thread chess_updateAllPositions(a, b, c);
        for (b = 10; b < 12; b++)
            for (c = 0; c < 8; c++) level thread chess_updateAllPositions(a, b, c);
        for (b = 12; b < 14; b++)
            for (c = 0; c < 4; c++) level thread chess_updateAllPositions(a, b, c);
        for (c = 0; c < 8; c++) level thread chess_updateAllPositions(a, 14, c);
        for (c = 0; c < 8; c++) level thread chess_updateAllPositions(a, 15, c);
    }
    for (a = 0; a < 8; a++)
        for (b = 0; b < 8; b++) level.chess_Spots[a][b].positions moveZ(-20, 1);
    if (isSolo()) wait .05;
    level notify("CHESS_BOARD");
}
chess_buildPawns() {
    for (a = 0; a < 8; a++) {
        for (b = 1; b < 3; b++) {
            level.chess_Player[b].pieces[a].piece = chess_makePawn(level.chess_Spots[a][(b - 1) * 5 + 1].org, (0, 270 - (b - 1) * 180, 0));
            level.chess_Player[b].pieces[a].pieceType = "PAWN";
            level.chess_Player[b].pieces[a].firstMove = undefined;
            level.chess_Player[b].pieces[a].deathOrigin = (-1582.005 - (300 * level.chess_Player[b].direction), -384 - (40 * a), 619.125);
            level.chess_Player[b].pieces[a].savedAngles = (0, 270 - (b - 1) * 180, 0);
        }
    }
}
chess_makePawn(origin, angle) {
    tag = spawnSM(origin, "tag_origin", angle);
    part = [];
    part[0] = spawnSM(tag.origin + (0, 0, 20), "zombie_spine", tag.angles);
    part[1] = spawnSM(part[0].origin - (0, 0, 7), "zombie_teddybear", tag.angles);
    part[2] = spawnSM(part[0].origin + (0, 0, 5), "zombie_teddybear_shanks", tag.angles);
    for (a = 0; a < 3; a++) {
        tag thread chess_watchForDelete(part[a]);
        part[a] linkTo(tag);
    }
    return tag;
}
chess_buildRooks() {
    for (a = 0; a < 2; a++) {
        for (b = 1; b < 3; b++) {
            level.chess_Player[b].pieces[8 + a].piece = chess_makeRook(level.chess_Spots[a * 7][(b - 1) * 7].org, (0, 270 - (b - 1) * 180, 0));
            level.chess_Player[b].pieces[8 + a].pieceType = "ROOK";
            level.chess_Player[b].pieces[8 + a].deathOrigin = (-1582.005 - (355 * level.chess_Player[b].direction), -384 - (280 * a), 619.125);
        }
    }
}
chess_makeRook(origin, angle, promotion) {
    tag = spawnSM(origin, "tag_origin", angle);
    barrel = spawnSM(tag.origin, "static_seelow_blackbarrel", tag.angles);
    if (isDefined(promotion)) tag thread chess_watchForDelete(barrel);
    barrel linkTo(tag);
    return tag;
}
chess_buildKnights() {
    for (a = 0; a < 2; a++) {
        for (b = 1; b < 3; b++) {
            level.chess_Player[b].pieces[10 + a].piece = chess_makeKnight(level.chess_Spots[1 + a * 5][(b - 1) * 7].org, (0, (b - 1) * 180, 0), b, 10 + a);
            level.chess_Player[b].pieces[10 + a].pieceType = "KNIGHT";
            level.chess_Player[b].pieces[10 + a].deathOrigin = (-1582.005 - (355 * level.chess_Player[b].direction), -424 - 200 * a, 619.125);
        }
    }
}
chess_makeKnight(origin, angle, playerIndex, pieceIndex, promotion) {
    tag = spawnSM(origin, "tag_origin", angle + (0, 270, 0));
    level.chess_Player[playerIndex].pieces[pieceIndex].knight = spawnSM(tag.origin + anglesToForward(tag.angles) * 20, "zombie_wolf", tag.angles);
    if (isDefined(promotion)) tag thread chess_watchForDelete(level.chess_Player[playerIndex].pieces[pieceIndex].knight);
    level.chess_Player[playerIndex].pieces[pieceIndex].knight thread chess_animateKnight(playerIndex);
    level.chess_Player[playerIndex].pieces[pieceIndex].knight linkTo(tag);
    return tag;
}
chess_animateKnight(playerIndex) {
    while (true) {
        while (isDefined(level.chess_Player[playerIndex].knightJump)) wait .05;
        for (a = 0; a < 3; a++) {
            wait(2.9 / 3);
            if (isDefined(level.chess_Player[playerIndex].knightJump)) break;
        }
        while (isDefined(level.chess_Player[playerIndex].knightJump)) wait .05;
        while (isDefined(level.chess_Player[playerIndex].knightJump)) wait .05;
        wait 1.3;
        while (isDefined(level.chess_Player[playerIndex].knightJump)) wait .05;
    }
}
chess_knightJump(moveOrigin, pieceIndex, playerIndex) {
    savedAngle = self.angles;
    angle = vectorToAngles(moveOrigin - self.origin);
    distance = distance(self.origin, moveOrigin);
    self rotateTo((self.angles[0], angle[1], self.angles[2]), .1);
    self waittill("rotatedone");
    vecF = anglesToForward(self.angles + (-65, 0, 0));
    level.chess_Player[playerIndex].knightJump = true;
    self moveGravity(vectorScale(vecF, distance * 2.7), 1);
    wait .85;
    self.origin = moveOrigin;
    self rotateTo(savedAngle, .2);
    wait .6;
    level.chess_Player[playerIndex].knightJump = undefined;
    wait .2;
}
chess_buildBishops() {
    for (a = 0; a < 2; a++) {
        for (b = 1; b < 3; b++) {
            level.chess_Player[b].pieces[12 + a].piece = chess_makeBishop(level.chess_Spots[2 + a * 3][(b - 1) * 7].org, (0, 270 - (b - 1) * 180, 0));
            level.chess_Player[b].pieces[12 + a].pieceType = "BISHOP";
            level.chess_Player[b].pieces[12 + a].deathOrigin = (-1582.005 - (355 * level.chess_Player[b].direction), -464 - 120 * a, 619.125);
        }
    }
}
chess_makeBishop(origin, angle, promotion) {
    tag = spawnSM(origin, "tag_origin", angle);
    bishop = spawnSM(tag.origin, "static_peleliu_filecabinet_metal", angle - (0, 90, 0));
    if (isDefined(promotion)) tag thread chess_watchForDelete(bishop);
    bishop linkTo(tag);
    return tag;
}
chess_buildQueen() {
    for (a = 1; a < 3; a++) {
        level.chess_Player[a].pieces[14].piece = chess_makeQueen(level.chess_Spots[3 + (a - 1)][(a - 1) * 7].org, (0, 270 - (a - 1) * 180, 0));
        level.chess_Player[a].pieces[14].pieceType = "QUEEN";
        level.chess_Player[a].pieces[14].deathOrigin = (-1582.005 - (355 * level.chess_Player[a].direction), -504 - 40 * (a - 1), 619.125);
    }
}
#using_animtree("generic_human");
chess_makeQueen(origin, angle, promotion) {
    tag = spawnSM(origin, "tag_origin", angle);
    queen = spawnSM(tag.origin, "defaultactor", tag.angles);
    if (isDefined(promotion)) tag thread chess_watchForDelete(queen);
    queen useAnimTree(#animtree);
    queen setAnim( % casual_stand_v2_idle);
    queen linkTo(tag);
    return tag;
}
chess_buildKing() {
    for (a = 1; a < 3; a++) {
        level.chess_Player[a].pieces[15].piece = chess_makeKing(level.chess_Spots[4 - (a - 1)][(a - 1) * 7].org, (0, 270 - (a - 1) * 180, 0));
        level.chess_Player[a].pieces[15].pieceType = "KING";
        level.chess_Player[a].pieces[15].deathOrigin = (-1582.005 - (355 * level.chess_Player[a].direction), -544 + 40 * (a - 1), 619.125);
    }
}
chess_makeKing(origin, angle) {
    tag = spawnSM(origin, "tag_origin", angle);
    king = spawnSM(tag.origin, "char_ger_honorgd_bodyz1_1", angle);
    king attach("char_ger_honorgd_zombiehead4_1", "", true);
    king useAnimTree(#animtree);
    king setAnim( % casual_stand_v2_idle);
    king attach(getWeaponModel("zombie_ppsh_upgraded"), "tag_weapon_right");
    king linkTo(tag);
    return tag;
}
chess_setUpPlayers() {
    level.chess_Player = [];
    for (a = 1; a < 3; a++) level.chess_Player[a] = spawnStruct();
    if (!isSolo()) level.chess_Player[randomIntRange(1, 3)].playersTurn = true;
    else level.chess_Player[1].playersTurn = true;
    level.chess_Player[1].playerIndex = 0;
    level.chess_Player[2].playerIndex = 1;
    level.chess_Player[1].direction = 1;
    level.chess_Player[2].direction = -1;
    level.chess_Player[1].otherPlayerIndex = 2;
    level.chess_Player[2].otherPlayerIndex = 1;
}
chess_watchPieces(playerIndex) {
    level waittill("CHESS_BOARD");
    self thread chess_watchForCheck(playerIndex);
    self thread chess_watchChoice(playerIndex);
    enemyIndex = level.chess_Player[playerIndex].otherPlayerIndex;
    if (!isDefined(self.chess_hudIndicator)) {
        self.chess_hudIndicator = self createRectangle("CENTER", "CENTER", 0, 0, 1, 2, (1, 1, 1), "damage_feedback", 5, 1);
        self.chess_hudIndicator scaleOverTime(.5, 20, 40);
    }
    for (a = 0; a < 8; a++) level.chess_Player[playerIndex].pieces[a] thread chess_watchForPromoton(self, playerIndex, a);
    while (true) {
        if (isSolo())
            while (!isDefined(level.chess_Player[playerIndex].playersTurn)) wait .05;
        level.chess_Player[playerIndex].currentPieceIndex = undefined;
        level.chess_Player[playerIndex].enemyPieceIndex = undefined;
        if (!isDefined(level.chess_Player[playerIndex].potentialMoveIndex)) self thread chess_setIndicatorColor((1, 1, 1));
        for (a = 0; a < level.chess_Player[playerIndex].pieces.size; a++) {
            if (distance(self lookPos() + (0, 0, 30), level.chess_Player[playerIndex].pieces[a].piece.origin) <= 45) {
                level.chess_Player[playerIndex].currentPieceIndex = a;
                self thread chess_setIndicatorColor((0, 1, 0));
                break;
            }
            if (distance(self lookPos() + (0, 0, 30), level.chess_Player[enemyIndex].pieces[a].piece.origin) <= 45) {
                level.chess_Player[playerIndex].enemyPieceIndex = a;
                if (!isDefined(level.chess_Player[playerIndex].chosePlayer)) self thread chess_setIndicatorColor((1, 0, 0));
                break;
            }
        }
        wait .05;
        while (distance(self lookPos() + (0, 0, 30), level.chess_Player[playerIndex].pieces[level.chess_Player[playerIndex].currentPieceIndex].piece.origin) <= 45 && isDefined(level.chess_Player[playerIndex].currentPieceIndex)) wait .05;
        while (distance(self lookPos() + (0, 0, 30), level.chess_Player[enemyIndex].pieces[level.chess_Player[playerIndex].enemyPieceIndex].piece.origin) <= 45 && isDefined(level.chess_Player[playerIndex].enemyPieceIndex)) {
            if (self.chess_hudIndicator.color != (1, 0, 0) && !isDefined(level.chess_Player[playerIndex].chosePlayer)) self thread chess_setIndicatorColor((1, 0, 0));
            wait .05;
        }
    }
}
chess_watchForMove(playerIndex, origins) {
    level.chess_Player[playerIndex] endon("chess_newChoice");
    self thread chess_watchPotentialChoice(playerIndex, origins);
    while (true) {
        level.chess_Player[playerIndex].potentialMoveIndex = undefined;
        if (!isDefined(level.chess_Player[playerIndex].currentPieceIndex)) self thread chess_setIndicatorColor((1, 1, 1));
        for (a = 0; a < origins.size; a++)
            if (distance(self lookPos() + (0, 0, 30), origins[a]) <= 45) {
                level.chess_Player[playerIndex].potentialMoveIndex = a;
                if (!chess_spotIsEnemy(origins[a], playerIndex)) self thread chess_setIndicatorColor(divideColor(255, 255, 0));
                else self thread chess_setIndicatorColor((1, 0, 0));
                break;
            }
        wait .05;
        while (distance(self lookPos() + (0, 0, 30), origins[level.chess_Player[playerIndex].potentialMoveIndex]) <= 45 && isDefined(level.chess_Player[playerIndex].potentialMoveIndex)) wait .05;
    }
}
chess_watchPotentialChoice(playerIndex, origins) {
    level.chess_Player[playerIndex] endon("chess_newChoice");
    pieceIndex = level.chess_Player[playerIndex].currentPieceIndex;
    pieceType = level.chess_Player[playerIndex].pieces[pieceIndex].pieceType;
    while (self useButtonPressed()) wait .05;
    wait .15;
    while (true) {
        if (self useButtonPressed() && isDefined(level.chess_Player[playerIndex].potentialMoveIndex)) {
            level.chess_Player[playerIndex].inCheck = undefined;
            level.chess_Player[playerIndex].playersTurn = undefined;
            level.chess_Player[playerIndex].chosePlayer = undefined;
            self thread chess_setIndicatorColor((1, 1, 1));
            self thread chess_movePiece(pieceType, origins, pieceIndex, playerIndex);
            break;
        }
        wait .05;
    }
}
chess_movePiece(pieceType, origins, pieceIndex, playerIndex) {
    level.chess_Player[playerIndex].run = true;
    piece = level.chess_Player[playerIndex].pieces[pieceIndex].piece;
    moveOrigin = origins[level.chess_Player[playerIndex].potentialMoveIndex];
    level.chess_Player[playerIndex].pieces[pieceIndex].moveOrigin = moveOrigin;
    if (chess_spotIsEnemy(moveOrigin, playerIndex)) {
        enemyStruct = chess_getEnemy(moveOrigin, level.chess_Player[playerIndex].otherPlayerIndex);
        enemyStruct thread chess_moveToGrave(playerIndex);
        enemyStruct.dead = true;
        enemyStruct.moveOrigin = enemyStruct.deathOrigin;
    }
    for (a = 1; a < 3; a++) {
        level.chess_Player[a].attackingPositions = [];
        level.chess_Player[a].allAttackPositions = [];
        level.chess_Player[a].guardedAttackPositions = [];
        level.chess_Player[a].kingAttackersIndex = [];
        level.chess_Player[a].kingAttackersPath = [];
        level.chess_Player[a].kingAttackersOrigin = [];
    }
    level notify("CHESS_UPDATE_ALL_MOVE_POSITIONS");
    level thread chess_checkForCheck(playerIndex);
    if (pieceType != "KNIGHT") {
        savedAngle = piece.angles;
        angle = vectorToAngles(moveOrigin - piece.origin);
        if (pieceType != "ROOK" && pieceType != "BISHOP") piece rotateTo((piece.angles[0], angle[1], piece.angles[2]), .1);
        if (!isDefined(level.chess_Player[playerIndex].pieces[pieceIndex].firstMove) && pieceType == "PAWN") level.chess_Player[playerIndex].pieces[pieceIndex].firstMove = true;
        piece moveTo(moveOrigin, 1);
        piece waittill("movedone");
        piece rotateTo(savedAngle, .2);
        wait .05;
    } else piece chess_knightJump(moveOrigin, pieceIndex, playerIndex);
    while (isDefined(level.chess_Player[playerIndex].chess_playerPromotion)) wait .05;
    level.chess_Player[playerIndex].potentialMoveIndex = undefined;
    wait .05;
    level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].playersTurn = true;
}
chess_moveToGrave(playerIndex) {
    self.piece moveZ(110, .4);
    self.piece rotateTo((0, 0 + 180 * (level.chess_Player[playerIndex].otherPlayerIndex - 1), 0), 1.5);
    wait .35;
    self.piece moveTo(self.deathOrigin, 1.1);
}
chess_watchChoice(playerIndex) {
    level endon("chess_GameOver");
    current = undefined;
    tag = undefined;
    tag2 = undefined;
    while (true) {
        if (self useButtonPressed() && !isDefined(level.chess_Player[playerIndex].chess_playerPromotion) && level.chess_Player[playerIndex].currentPieceIndex != current && !isDefined(level.chess_Player[playerIndex].potentialMoveIndex) && !isDefined(level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].potentialMoveIndex) && isDefined(level.chess_Player[playerIndex].playersTurn) || isDefined(level.chess_Player[playerIndex].run)) {
            level.chess_Player[playerIndex].chosePlayer = undefined;
            if (isDefined(tag)) tag remove();
            if (isDefined(tag2)) tag2 remove();
            tag = undefined;
            tag2 = undefined;
            level.chess_Player[playerIndex] notify("chess_newChoice");
            current = undefined;
            if (isDefined(level.chess_Player[playerIndex].currentPieceIndex) && !isDefined(level.chess_Player[playerIndex].run) && !isDefined(level.chess_Player[playerIndex].pieces[level.chess_Player[playerIndex].currentPieceIndex].dead)) {
                level.chess_Player[playerIndex].chosePlayer = true;
                current = level.chess_Player[playerIndex].currentPieceIndex;
                self thread chess_showMoves(playerIndex);
                origin = level.chess_Player[playerIndex].pieces[current].piece.origin;
                tag = spawnSM(origin + (0, 0, 5), "tag_origin");
                tag2 = spawnSM(tag.origin + (sin(0) * 22, cos(0) * 22, 5), "tag_origin", vectorToAngles(anglesToUp((0, 0, 0))));
                playFxOnTag(level._effect["tesla_bolt"], tag2, "tag_origin");
                tag2 linkTo(tag);
                tag thread chess_circleChoice();
                level thread chess_deleteTags(tag, tag2);
            }
            level.chess_Player[playerIndex].run = undefined;
        }
        wait .05;
    }
}
chess_deleteTags(tag, tag2) {
    level waittill("CHECK_MATE");
    if (isDefined(tag)) {
        tag delete();
        tag2 delete();
    }
}
chess_circleChoice() {
    self thread rotateEntYaw(360, .3);
    while (isDefined(self)) {
        self moveZ(48, 3);
        wait 3;
        self moveZ(-48, 3);
        wait 3;
    }
}
chess_showMoves(playerIndex) {
    pieceIndex = level.chess_Player[playerIndex].currentPieceIndex;
    origin = level.chess_Player[playerIndex].pieces[pieceIndex].moveOrigin;
    pieceType = level.chess_Player[playerIndex].pieces[pieceIndex].pieceType;
    ROW = chess_findRow(origin);
    COLUMN = chess_findColumn(origin);
    DIRECTION = level.chess_Player[playerIndex].direction;
    spots = [];
    origins = [];
    level.chess_area = [];
    level.chess_org = [];
    chess_checkDirection(playerIndex, pieceIndex, pieceType);
    for (a = 0; a < level.chess_area.size; a++) {
        spots[spots.size] = level.chess_area[a];
        origins[origins.size] = level.chess_org[a];
    }
    level.chess_area = undefined;
    level.chess_org = undefined;
    self thread chess_watchForMove(playerIndex, origins);
    wait .05;
    for (a = 0; a < spots.size; a++) spots[a] moveTo(origins[a] + (0, 0, 5), .5);
    level.chess_Player[playerIndex] waittill("chess_newChoice");
    for (a = 0; a < spots.size; a++) spots[a] moveTo(origins[a] - (0, 0, 15), .5);
}
chess_checkForCheck(playerIndex) {
    wait .05;
    enemyIndex = level.chess_Player[playerIndex].otherPlayerIndex;
    enemyKing = chess_getKing(enemyIndex);
    level.chess_winnerIndex = playerIndex;
    if (chess_kingIsInMyAttackPosition(playerIndex, enemyKing.moveOrigin)) {
        level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].inCheck = true;
        level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex] notify("chess_Check");
    }
    if (chess_gameIsOver(level.chess_Player[playerIndex].otherPlayerIndex, "DRAW") && !isDefined(level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].inCheck)) {
        level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].draw = true;
        level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].checkMate = true;
        level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex] notify("chess_Check");
    }
    if (chess_gameIsOver(level.chess_Player[playerIndex].otherPlayerIndex, "CHECKMATE") && isDefined(level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].inCheck)) {
        level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].checkMate = true;
        level notify("CHECK_MATE");
        level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex] notify("chess_Check");
    }
}
chess_findRow(origin) {
    for (a = 0; a < 8; a++)
        for (b = 0; b < 8; b++)
            if (level.chess_Spots[a][b].org == origin) return level.chess_Spots[a][b].row;
    return 0;
}
chess_findColumn(origin) {
    for (a = 0; a < 8; a++)
        for (b = 0; b < 8; b++)
            if (level.chess_Spots[a][b].org == origin) return level.chess_Spots[a][b].column;
    return 0;
}
chess_spotIsFriendly(origin, playerIndex) {
    for (a = 0; a < 16; a++)
        if (level.chess_Player[playerIndex].pieces[a].moveOrigin == origin) return 1;
    return 0;
}
chess_spotIsEnemy(origin, playerIndex) {
    for (a = 0; a < 16; a++)
        if (level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].pieces[a].moveOrigin == origin) return 1;
    return 0;
}
chess_getPieceIndex(origin, playerIndex) {
    for (a = 0; a < 16; a++)
        if (level.chess_Player[playerIndex].pieces[a].moveOrigin == origin) return a;
    return 0;
}
chess_getKing(playerIndex) {
    return level.chess_Player[playerIndex].pieces[15];
}
chess_getEnemy(enemyOrigin, enemyIndex) {
    for (a = 0; a < 16; a++)
        if (level.chess_Player[enemyIndex].pieces[a].moveOrigin == enemyOrigin) return level.chess_Player[enemyIndex].pieces[a];
    return undefined;
}
chess_setIndicatorColor(color) {
    self.chess_hudIndicator fadeOverTime(.1);
    self.chess_hudIndicator.color = color;
}
chess_updateAllPositions(playerIndex, pieceIndex, path) {
    while (true) {
        direction = undefined;
        PIECETYPE = level.chess_Player[playerIndex].pieces[pieceIndex].pieceType;
        ORIGIN = level.chess_Player[playerIndex].pieces[pieceIndex].moveOrigin;
        level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[path] = [];
        if (isDefined(level.chess_Player[playerIndex].pieces[pieceIndex].dead)) break;
        ROW = chess_findRow(ORIGIN);
        COLUMN = chess_findColumn(ORIGIN);
        direction = chess_addPieceDirection(PIECETYPE, playerIndex, path);
        for (b = 0; b < 7; b++) {
            ROW += direction[0];
            COLUMN += direction[1];
            if (chess_spotIsFriendly(level.chess_Spots[ROW][COLUMN].org, playerIndex) || !isDefined(level.chess_Spots[ROW][COLUMN].org)) break;
            if (PIECETYPE == "PAWN") {
                if (path == 1 && (chess_pawnMoved(playerIndex, pieceIndex) && b == 1 || b == 2) || (b == 1 && (path == 0 || path == 2)) || (chess_spotIsEnemy(level.chess_Spots[ROW][COLUMN].org, playerIndex) && path == 1)) break;
                if (path == 0 || path == 2) {
                    size = level.chess_Player[playerIndex].allAttackPositions.size;
                    level.chess_Player[playerIndex].allAttackPositions[size] = level.chess_Spots[ROW][COLUMN].org;
                    if (!chess_spotIsEnemy(level.chess_Spots[ROW][COLUMN].org, playerIndex)) break;
                }
            }
            size = level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[path].size;
            level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[path][size] = level.chess_Spots[ROW][COLUMN];
            if (PIECETYPE != "PAWN") {
                size = level.chess_Player[playerIndex].allAttackPositions.size;
                level.chess_Player[playerIndex].allAttackPositions[size] = level.chess_Spots[ROW][COLUMN].org;
            }
            if (chess_spotIsEnemy(level.chess_Spots[ROW][COLUMN].org, playerIndex) || PIECETYPE == "KING" || PIECETYPE == "KNIGHT") break;
        }
        enemyKing = chess_getKing(level.chess_Player[playerIndex].otherPlayerIndex);
        if (isDefined(level.chess_Spots[ROW][COLUMN].org) && level.chess_Spots[ROW][COLUMN].org == enemyKing.moveOrigin && PIECETYPE != "KING") {
            if ((PIECETYPE == "PAWN" && (path == 0 || path == 2)) || (PIECETYPE != "PAWN")) {
                level.chess_Player[playerIndex].kingAttackersIndex[level.chess_Player[playerIndex].kingAttackersIndex.size] = pieceIndex;
                level.chess_Player[playerIndex].kingAttackersPath[level.chess_Player[playerIndex].kingAttackersPath.size] = path;
                level.chess_Player[playerIndex].kingAttackersOrigin[level.chess_Player[playerIndex].kingAttackersOrigin.size] = level.chess_Spots[chess_findRow(ORIGIN)][chess_findColumn(ORIGIN)].org;
            }
            if (!chess_spotIsEnemy(level.chess_Spots[ROW + direction[0]][COLUMN + direction[1]].org, playerIndex) && !chess_spotIsFriendly(level.chess_Spots[ROW + direction[0]][COLUMN + direction[1]].org, playerIndex) && PIECETYPE != "PAWN" && PIECETYPE != "KNIGHT") {
                level.chess_Player[playerIndex].allAttackPositions[level.chess_Player[playerIndex].allAttackPositions.size] = level.chess_Spots[ROW + direction[0]][COLUMN + direction[1]].org;
            }
        }
        if (chess_spotIsFriendly(level.chess_Spots[ROW][COLUMN].org, playerIndex)) {
            if ((PIECETYPE == "PAWN" && (path == 0 || path == 2)) || (PIECETYPE != "PAWN")) {
                size = level.chess_Player[playerIndex].guardedAttackPositions.size;
                level.chess_Player[playerIndex].guardedAttackPositions[size] = level.chess_Spots[ROW][COLUMN].org;
            }
        }
        if (PIECETYPE != "PAWN" || PIECETYPE != "KNIGHT" || PIECETYPE != "KING")
            while (true) {
                ROW += direction[0];
                COLUMN += direction[1];
                if (!isDefined(level.chess_Spots[ROW][COLUMN].org) || chess_spotIsFriendly(level.chess_Spots[ROW][COLUMN].org, playerIndex) || (chess_spotIsEnemy(level.chess_Spots[ROW][COLUMN].org, playerIndex) && enemyKing.moveOrigin != level.chess_Spots[ROW][COLUMN].org) || PIECETYPE == "PAWN" || PIECETYPE == "KNIGHT" || PIECETYPE == "KING") break;
                if (enemyKing.moveOrigin == level.chess_Spots[ROW][COLUMN].org) {
                    for (c = 0; c < level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[path].size; c++) level.chess_Player[playerIndex].attackingPositions[c] = level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[path][c].org;
                    level.chess_Player[playerIndex].attackingPositions[level.chess_Player[playerIndex].attackingPositions.size] = level.chess_Spots[chess_findRow(ORIGIN)][chess_findColumn(ORIGIN)].org;
                    break;
                }
                wait .05;
            }
        level waittill("CHESS_UPDATE_ALL_MOVE_POSITIONS");
    }
}
chess_addPieceDirection(pieceType, playerIndex, DI) {
    add = [];
    negative = level.chess_Player[playerIndex].direction;
    if (pieceType == "PAWN") {
        add[0] = (-1 + DI) * (negative);
        add[1] = 1 * negative;
    } else if (pieceType == "ROOK") {
        rook = 1;
        if (DI == 1 || DI == 3) rook = -1;
        if (DI <= 1) {
            add[0] = (-1 * rook) * negative;
            add[1] = 0;
        }
        if (DI > 1) {
            add[0] = 0;
            add[1] = (-1 * rook) * negative;
        }
    } else if (pieceType == "KNIGHT") {
        knight = 1;
        if (DI == 2 || DI == 3 || DI == 6 || DI == 7) knight = -1;
        flip = 1;
        if (!isOdd(DI + 1)) flip = -1;
        if (DI <= 3) {
            add[0] = -2 * knight;
            add[1] = 1 * flip;
        }
        if (DI > 3) {
            add[0] = -1 * knight;
            add[1] = 2 * flip;
        }
    } else if (pieceType == "BISHOP") {
        bishop = 1;
        if (DI == 1 || DI == 3) bishop = -1;
        if (DI <= 1) {
            add[0] = (-1 * bishop) * negative;
            add[1] = (1 * bishop) * negative;
        }
        if (DI > 1) {
            add[0] = (-1 * bishop) * negative;
            add[1] = (-1 * bishop) * negative;
        }
    } else {
        QK = 1;
        if (isOdd(DI)) QK = -1;
        if (DI <= 3) {
            if (DI <= 1) {
                add[0] = (-1 * QK) * negative;
                add[1] = (1 * QK) * negative;
            } else {
                add[0] = (-1 * QK) * negative;
                add[1] = (-1 * QK) * negative;
            }
        } else {
            if (DI <= 5) {
                add[0] = (-1 * QK) * negative;
                add[1] = 0;
            } else {
                add[0] = 0;
                add[1] = (-1 * QK) * negative;
            }
        }
    }
    return add;
}
chess_gameIsOver(playerIndex, type) {
    start = strTok("0;8;10;12;14;15", ";");
    end = strTok("8;10;12;14;15;16", ";");
    for (a = 0; a < 6; a++) {
        for (c = int(start[a]); c < int(end[a]); c++) {
            pieceType = level.chess_Player[playerIndex].pieces[c].pieceType;
            pieceIndex = c;
            for (b = 0; b < level.chess_pieceType[pieceType]; b++) {
                if (isDefined(level.chess_Player[playerIndex].pieces[pieceIndex].dead)) continue;
                for (d = 0; d < 8; d++) {
                    if (!isDefined(level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[b][d].org)) break;
                    if (chess_kingIsAttackingGuardedPiece(playerIndex, pieceType, level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[b][d].org) || !chess_kingPositionIsSafe(playerIndex, pieceType, level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[b][d].org)) {
                        continue;
                    }
                    if (type == "DRAW") {
                        if (chess_moveingPieceWillCauseCheck(playerIndex, pieceIndex, level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[b][d].org)) {
                            continue;
                        }
                    } else {
                        if ((pieceType == "KING" && !chess_kingPositionIsSafe(playerIndex, pieceType, level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[b][d].org)) || pieceType != "KING" && !chess_canBlockKingFromAttacker(playerIndex, pieceIndex, pieceType, level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[b][d].org) && !chess_canKillKingAttacker(playerIndex, pieceIndex, pieceType, level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[b][d].org)) continue;
                    }
                    return false;
                }
            }
        }
    }
    return true;
}
chess_kingIsInMyAttackPosition(playerIndex, kingOrigin) {
    for (a = 0; a < level.chess_Player[playerIndex].allAttackPositions.size; a++)
        if (level.chess_Player[playerIndex].allAttackPositions[a] == kingOrigin) return true;
    return false;
}
chess_canKillKingAttacker(playerIndex, pieceIndex, pieceType, origin) {
    if (level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].kingAttackersOrigin.size > 1) return false;
    attackerOrigin = level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].kingAttackersOrigin[0];
    if (origin == attackerOrigin) return true;
    return false;
}
chess_canBlockKingFromAttacker(playerIndex, pieceIndex, pieceType, origin) {
    if (level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].kingAttackersIndex.size != 1) return false;
    attackerIndex = level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].kingAttackersIndex[0];
    attackerPath = level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].kingAttackersPath[0];
    for (a = 0; a < level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].pieces[attackerIndex].currentMovePathPosition[attackerPath].size; a++) {
        if (origin == level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].pieces[attackerIndex].currentMovePathPosition[attackerPath][a].org) return true;
    }
    return false;
}
chess_kingPositionIsSafe(playerIndex, pieceType, origin) {
    if (pieceType != "KING") return true;
    attackerOrigin = level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].kingAttackersOrigin[0];
    for (a = 0; a < level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].allAttackPositions.size; a++) {
        if (isDefined(level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].allAttackPositions[a])) {
            if (level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].allAttackPositions[a] == origin) {
                if (isDefined(attackerOrigin) && attackerOrigin == origin) return true;
                return false;
            }
        }
    }
    return true;
}
chess_kingIsAttackingGuardedPiece(playerIndex, pieceType, origin) {
    if (pieceType != "KING" || (!chess_spotIsFriendly(origin, playerIndex) && !chess_spotIsEnemy(origin, playerIndex))) return false;
    for (a = 0; a < level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].guardedAttackPositions.size; a++)
        if (level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].guardedAttackPositions[a] == origin) return true;
    return false;
}
chess_moveingPieceWillCauseCheck(playerIndex, pieceIndex, origin) {
    if (level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].attackingPositions.size <= 0) return false;
    equals = true;
    for (a = 0; a < level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].attackingPositions.size; a++)
        if (origin == level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].attackingPositions[a]) equals = false;
    if (equals) {
        for (a = 0; a < level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].attackingPositions.size; a++)
            if (level.chess_Player[level.chess_Player[playerIndex].otherPlayerIndex].attackingPositions[a] == level.chess_Player[playerIndex].pieces[pieceIndex].moveOrigin) return true;
        return false;
    }
    return equals;
}
chess_checkDirection(playerIndex, pieceIndex, pieceType) {
    level endon("chess_GameOver");
    for (a = 0; a < level.chess_pieceType[pieceType]; a++) {
        for (b = 0; b < 8; b++) {
            if (chess_kingIsAttackingGuardedPiece(playerIndex, pieceType, level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[a][b].org) || !chess_kingPositionIsSafe(playerIndex, pieceType, level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[a][b].org)) {
                continue;
            }
            if (!isDefined(level.chess_Player[playerIndex].inCheck)) {
                if (chess_moveingPieceWillCauseCheck(playerIndex, pieceIndex, level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[a][b].org)) {
                    continue;
                }
            } else {
                if ((pieceType == "KING" && !chess_kingPositionIsSafe(playerIndex, pieceType, level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[a][b].org)) || pieceType != "KING" && !chess_canBlockKingFromAttacker(playerIndex, pieceIndex, pieceType, level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[a][b].org) && !chess_canKillKingAttacker(playerIndex, pieceIndex, pieceType, level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[a][b].org)) continue;
            }
            level.chess_area[level.chess_area.size] = level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[a][b].positions;
            level.chess_org[level.chess_org.size] = level.chess_Player[playerIndex].pieces[pieceIndex].currentMovePathPosition[a][b].org;
        }
    }
}
chess_pawnMoved(playerIndex, attackerIndex) {
    if (isDefined(level.chess_Player[playerIndex].pieces[attackerIndex].firstMove)) return 1;
    return 0;
}
chess_watchForCheck(playerIndex) {
    hud = [];
    while (true) {
        level.chess_Player[playerIndex] waittill("chess_Check");
        wait .1;
        if (isDefined(level.chess_Player[playerIndex].checkMate)) break;
        while (!isDefined(level.chess_Player[playerIndex].inCheck)) wait .05;
        hud = self chess_notifyPlayer("You're In Check", divideColor(255, 255, 255), 119);
        while (isDefined(level.chess_Player[playerIndex].inCheck)) wait .05;
        for (a = 0; a < hud.size; a++) hud[a] thread hudFadenDestroy(0, .3);
    }
    loserIndex = level.chess_Player[level.chess_winnerIndex].otherPlayerIndex;
    if (isDefined(level.chess_Player[playerIndex].draw)) {
        hud = self chess_notifyPlayer("Draw", divideColor(255, 255, 255), 58);
        if (!isSolo()) array_thread(getPlayers(), ::deathMessage, "^1Game Over", "^2Draw ^7- ^1" + getPlayers()[loserIndex - 1] getName() + " ^7Is Out Of Moves And His/Her King Is Safe | ^2" + getPlayers()[level.chess_winnerIndex - 1] getName() + " ^7Has Won This Chess Match By Default!", undefined, 20, 5.4);
        else self thread deathMessage("^1Game Over", "^2Draw ^7- ^3You Are Out Of Moves And Your King Is Safe ^7| ^1Also You Were Unable To Beat Yourself At Chess...WOW!", undefined, 10, 5.5);
    } else {
        hud = self chess_notifyPlayer("Check Mate", divideColor(255, 255, 255), 95);
        if (!isSolo()) array_thread(getPlayers(), ::deathMessage, "^1Game Over", "^2Check Mate ^7- ^1" + getPlayers()[loserIndex - 1] getName() + "'s ^7King Has Nowhere To Run | ^2" + getPlayers()[level.chess_winnerIndex - 1] getName() + " ^7Has Won This Chess Match!", undefined, 20, 5.4);
        else self thread deathMessage("^1Game Over", "^2Check Mate ^7- ^3Congratulations I Guess, You Beat Yourself At Chess... ^1WOW, WHAT AN ACCOMPLISHMENT IN LIFE!", undefined, 10, 5.85);
    }
    wait 2;
    level notify("chess_GameOver");
    wait 5;
    array_thread(getPlayers(), ::_hideSeek_timeoutInit);
}
chess_notifyPlayer(text, color, size) {
    hud = [];
    hud[0] = self createRectangle("CENTER", "BOTTOM", 0, 100, 2, 30, (0, 0, 0), "white", 100, .7);
    hud[0] thread hudMoveY(hud[0].y - 125, .3);
    wait .45;
    hud[0] scaleOverTime(.3, size, 30);
    wait .25;
    hud[1] = self createText(self getFont(), 1.3, "CENTER", "BOTTOM", hud[0].x, hud[0].y, 200, 1, text, color);
    hud[1] thread hudFade(1, .45);
    return hud;
}
chess_watchForPromoton(player, playerIndex, pieceIndex) {
    enemyKing = chess_getKing(level.chess_Player[playerIndex].otherPlayerIndex);
    promotionAxis = enemyKing.moveOrigin[1];
    angles = self.piece.angles;
    while (true) {
        if (self.piece.origin[1] == promotionAxis) break;
        wait .05;
    }
    level.chess_Player[playerIndex].chess_playerPromotion = self;
    level chess_choosePromotionPiece(self, angles, player, playerIndex, pieceIndex);
}
chess_choosePromotionPiece(pieceStruct, pieceAngles, player, playerIndex, pieceIndex) {
    pieceIndex = chess_getPieceIndex(pieceStruct.piece.origin, playerIndex);
    pieceOrg = pieceStruct.piece.origin;
    origin = pieceOrg + anglesToForward(pieceAngles) * 160;
    pieceStruct.piece moveTo(origin, .5);
    tag = spawnSM(origin - (0, 0, 200), "tag_origin");
    fx = spawnSM(origin, "tag_origin");
    pieceStruct.piece thread chess_promotionArt(tag, fx, origin, player);
    promotion = [];
    promotion[0] = chess_makeRook(origin + (cos(0) * 60, sin(0) * 60, -200), (0, 180, 0), true);
    promotion[1] = chess_makeKnight(origin + (cos(90) * 60, sin(90) * 60, -200), (0, 0, 0), playerIndex, pieceIndex, true);
    promotion[2] = chess_makeBishop(origin + (cos(180) * 60, sin(180) * 60, -200), (0, 0, 0), true);
    promotion[3] = chess_makeQueen(origin + (cos(270) * 60, sin(270) * 60, -200), (0, 90, 0), true);
    for (a = 0; a < 4; a++) promotion[a] linkTo(tag);
    if (playerIndex == 1) index = 1;
    else index = 3;
    tok = strTok("ROOK|KNIGHT|BISHOP|QUEEN", "|");
    wait 1;
    while (true) {
        if (player adsButtonPressed() || player attackButtonPressed()) {
            oldIndex = index;
            index += player attackButtonPressed();
            index -= player adsButtonPressed();
            if (index < oldIndex) tag rotateTo(tag.angles + (0, 90, 0), .5);
            if (index > oldIndex) tag rotateTo(tag.angles - (0, 90, 0), .5);
            tag waittill("rotatedone");
            if (index > 3) index = 0;
            if (index < 0) index = 3;
        } else if (player useButtonPressed()) {
            promotion[index] unLink();
            tag moveZ(-500, 2);
            fx delete();
            pieceStruct.piece moveZ(-500, 2);
            break;
        }
        wait .05;
    }
    promotion[index] moveTo(pieceOrg, .5);
    wait .55;
    level.chess_Player[playerIndex].chess_playerPromotion = undefined;
    level notify("Chess_Promotion_Over");
    for (a = 0; a < 4; a++)
        if (a != index) {
            promotion[a] notify("CHESS_PROMOTION");
            promotion[a] delete();
        }
    tag delete();
    pieceStruct.piece notify("CHESS_PROMOTION");
    pieceStruct.piece delete();
    pieceStruct.firstMove = undefined;
    pieceStruct.piece = promotion[index];
    pieceStruct.pieceType = tok[index];
    for (a = 3; a < level.chess_pieceType[tok[index]]; a++) level thread chess_updateAllPositions(playerIndex, pieceIndex, a);
    for (a = 1; a < 3; a++) {
        level.chess_Player[a].attackingPositions = [];
        level.chess_Player[a].allAttackPositions = [];
        level.chess_Player[a].guardedAttackPositions = [];
        level.chess_Player[a].kingAttackersIndex = [];
        level.chess_Player[a].kingAttackersPath = [];
        level.chess_Player[a].kingAttackersOrigin = [];
    }
    level notify("CHESS_UPDATE_ALL_MOVE_POSITIONS");
    level thread chess_checkForCheck(playerIndex);
}
chess_watchForDelete(piece) {
    self waittill("CHESS_PROMOTION");
    piece delete();
}
chess_promotionArt(tag, fx, origin, player) {
    player playSound("object_hit");
    wait .45;
    tag moveZ(200, 1);
    playFxOnTag(loadFx("misc/fx_zombie_powerup_on"), fx, "tag_origin");
    self thread rotateEntYaw(360, 1);
}
chess_moveToPromotionArea(playerIndex, clip) {
    save = clip.origin;
    clip.origin = level.chess_Player[playerIndex].chess_playerPromotion.moveOrigin + (0, 0, 50) + anglesToForward(level.chess_Player[playerIndex].chess_playerPromotion.savedAngles) * -80;
    self setPlayerAngles(level.chess_Player[playerIndex].chess_playerPromotion.savedAngles + (27, 0, 0));
    level waittill("Chess_Promotion_Over");
    clip.origin = save;
    wait .5;
}
checkers_playerAxisMovement(playerIndex) {
    self hide();
    origin = -200 - 640 * (playerIndex - 1);
    self setPlayerAngles((57, -90 + 180 * (playerIndex - 1), 0));
    clip = spawnSM((-1582, origin, 955), "script_origin");
    self playerLinkTo(clip);
    hud = [];
    hud["BG"] = self createRectangle("LEFT", "LEFT", 10, 0, 160, 85, (0, 0, 0), "white", 1, .6);
    hud["TITLE"] = self createText(self getFont(), 1.2, "CENTER", "LEFT", hud["BG"].x + 80, -33.75, 10, 1, "Clip Controls");
    hud["LINE"] = self createRectangle("LEFT", "LEFT", hud["BG"].x, -25, 160, 1, divideColor(0, 110, 255), "white", 10, 1);
    hud[0] = self createText(self getFont(), 1, "LEFT", "LEFT", hud["TITLE"].x - 75, -15, 10, 1, "[{+attack}]: Move Forwards");
    hud[1] = self createText(self getFont(), 1, "LEFT", "LEFT", hud[0].x, 0, 10, 1, "[{+speed_throw}]: Move Backwards");
    hud[2] = self createText(self getFont(), 1, "LEFT", "LEFT", hud[0].x, 15, 10, 1, "[{+activate}]: Select Checker / Move");
    hud["LINE2"] = self createRectangle("LEFT", "LEFT", hud["BG"].x, 25, 160, 1, divideColor(0, 110, 255), "white", 10, 1);
    hud["TURN"] = self createText(self getFont(), 1.2, "CENTER", "LEFT", hud["TITLE"].x, 33.75, 10, 1, "Solo Play");
    if (!isSolo()) self thread checkers_watchForNewTurn(playerIndex, hud["TURN"]);
    wall_1 = -424;
    wall_2 = -844;
    if (playerIndex == 1 && !isSolo()) {
        wall_1 = -204;
        wall_2 = -624;
    }
    if (isSolo()) wall_1 = -204;
    if (!isSolo()) level waittill("CHECKER_BOARD");
    while (true) {
        vec = anglesToForward(self getPlayerAngles());
        end = (vec[0] * 20, vec[1] * 20, vec[2] * 20);
        if (self attackButtonPressed()) {
            forward = clip.origin + end;
            if (forward[0] <= -1302 && forward[0] >= -1862 && forward[1] >= wall_2 && forward[1] <= wall_1 && forward[2] >= 630 && forward[2] <= 1310) clip.origin = clip.origin + end;
        } else if (self adsButtonPressed()) {
            back = clip.origin - end;
            if (back[0] <= -1302 && back[0] >= -1862 && back[1] >= wall_2 && back[1] <= wall_1 && back[2] >= 630 && back[2] <= 1310) clip.origin = clip.origin - end;
        }
        wait .05;
    }
}
checkers_watchForNewTurn(playerIndex, hud) {
    wait 5;
    enemyIndex = level.checkerPlayer[level.checkerplayer[playerIndex].otherPlayerIndex].playerIndex;
    while (true) {
        if (isDefined(level.checkerPlayer[playerIndex].playersTurn)) {
            hud.alpha = 0;
            hud setText("It's Your Move");
            hud hudFade(1, 1);
            while (isDefined(level.checkerPlayer[playerIndex].playersTurn)) wait .05;
        } else {
            hud.alpha = 0;
            hud setText("It's " + getPlayers()[enemyIndex] getName() + "'s Move");
            hud hudFade(1, 1);
            while (!isDefined(level.checkerPlayer[playerIndex].playersTurn)) wait .05;
        }
        wait .05;
    }
}
checkers_makeBoard() {
    level.checkersBoard = [];
    board = spawnStruct();
    board.origin = (-1366.005, -326, 587.5);
    board.origin2 = board.origin + (-17, 5, 30);
    board.model = "static_berlin_metal_desk";
    board.model2 = "static_peleliu_palette";
    board.length = 72;
    board.width = 36;
    board.length2 = 57;
    board.width2 = 58;
    for (a = 0; a < 13; a++)
        for (b = 0; b < 6; b++) level.checkersBoard[level.checkersBoard.size] = spawnSM(board.origin - (board.width * a, board.length * b, 0), board.model, (0, 90, 0));
    level.checkersBoard[level.checkersBoard.size] = spawnSM(board.origin - (0, 396, .1), board.model, (0, 90, 0));
    for (a = 0; a < 6; a++) level.checkersBoard[level.checkersBoard.size] = spawnSM(board.origin - (board.length * a + (54), 414, 0), board.model);
    for (a = 0; a < 8; a++)
        for (b = a % 2; b < 8; b += 2) level.checkersBoard[level.checkersBoard.size] = spawnSM(board.origin2 - (board.length2 * a, board.width2 * b, 0), board.model2, (0, 90, 0));
    level.checkerSpots = [];
    for (a = 0; a < 8; a++) {
        level.checkerSpots[a] = [];
        for (b = 0; b < 8; b++) level.checkerSpots[a][b] = spawnStruct();
    }
    for (a = 0; a < 8; a++)
        for (b = 0; b < 8; b++) {
            level.checkerSpots[a][b].org = board.origin2 - (board.length2 * a, board.width2 * b, -5);
            level.checkerSpots[a][b].row = a;
            level.checkerSpots[a][b].column = b;
            level.checkerSpots[a][b].positions = spawnSM(level.checkerSpots[a][b].org + (0, 0, 5), "tag_origin", vectorToAngles(anglesToUp((0, 0, 0))));
            playFxOnTag(level._effect["zapper_light_ready"], level.checkerSpots[a][b].positions, "tag_origin");
            playFxOnTag(level._effect["zapper_light_notready"], level.checkerSpots[a][b].positions, "tag_origin");
        }
    for (a = 1; a < 3; a++) {
        level.checkerPlayer[a].pieces = [];
        for (b = 0; b < 12; b++) level.checkerPlayer[a].pieces[b] = spawnStruct();
    }
    checkers_buildCheckers();
    for (a = 1; a < 3; a++)
        for (b = 0; b < 12; b++) level.checkerPlayer[a].pieces[b].moveOrigin = level.checkerPlayer[a].pieces[b].piece.origin;
    for (a = 0; a < 8; a++)
        for (b = 0; b < 8; b++) level.checkerSpots[a][b].positions moveZ(-20, 1);
    if (isSolo()) wait .05;
    level notify("CHECKER_BOARD");
}
checkers_setUpPlayers() {
    level.checkerPlayer = [];
    for (a = 1; a < 3; a++) level.checkerPlayer[a] = spawnStruct();
    if (!isSolo()) level.checkerPlayer[randomIntRange(1, 3)].playersTurn = true;
    else level.checkerPlayer[1].playersTurn = true;
    level.checkerPlayer[1].playerIndex = 0;
    level.checkerPlayer[2].playerIndex = 1;
    level.checkerPlayer[1].direction = 1;
    level.checkerPlayer[2].direction = -1;
    level.checkerPlayer[1].otherPlayerIndex = 2;
    level.checkerPlayer[2].otherPlayerIndex = 1;
}
checkers_buildCheckers() {
    player = [];
    player[1] = spawnStruct();
    player[2] = spawnStruct();
    player[1].index = 0;
    player[2].index = 0;
    player[1].deathIndex = 0;
    player[2].deathIndex = 0;
    for (a = 0; a < 8; a++) {
        for (b = 0; b < 3; b++) {
            for (c = 1; c < 3; c++) {
                if ((c == 1 && (isOdd(a + 1) && isOdd(b + 1) || !isOdd(a + 1) && !isOdd(b + 1))) || (c == 2 && (!isOdd(a + 1) && isOdd(b + 1) || isOdd(a + 1) && !isOdd(b + 1)))) {
                    level.checkerPlayer[c].pieces[int(player[c].index)].piece = checkers_buildChecker(level.checkerSpots[a][b + (c - 1) * 5].org, (0, (c - 1) * 180, 0), c);
                    level.checkerPlayer[c].pieces[int(player[c].index)] thread checkers_watchForKingMe(c);
                    level.checkerPlayer[c].pieces[int(player[c].index)].deathOrigin = (-1582.005 - (300 * level.checkerPlayer[c].direction), -334 - ((420 / 12) * player[c].deathIndex), 619.125);
                    player[c].index += 1;
                    player[c].deathIndex += 1;
                }
            }
        }
    }
}
checkers_buildChecker(origin, angle, playerIndex) {
    tag = spawnSM(origin, "tag_origin", angle + (0, 270, 0));
    checker = spawnSM(origin + (0, 0, 6), "clutter_peleliu_tire_single", (90, 90, 0));
    checker linkTo(tag);
    effect = level._effect["zapper_light_ready"];
    if (playerIndex == 2) effect = level._effect["zapper_light_notready"];
    for (a = 0; a < 12; a++) {
        light = spawnSM(checker.origin + (cos(30 * a) * 10, sin(30 * a) * 10, 8), "tag_origin", vectorToAngles(anglesToForward((90, 90, 0))));
        playFxOnTag(effect, light, "tag_origin");
        light linkTo(tag);
    }
    return tag;
}
checkers_watchForKingMe(playerIndex) {
    index = level.checkerPlayer[playerIndex].otherPlayerIndex;
    kingMeAxis = level.checkerSpots[0][0 + (index - 1) * 7].org;
    while (true) {
        if (self.piece.origin[1] == kingMeAxis[1]) break;
        wait .05;
    }
    self.startKingMe = true;
    self.kingMe = true;
    getPlayers()[playerIndex - 1] playLocalSound("object_hit");
    tag = spawnSM(self.piece.origin, "tag_origin", (0, (playerIndex - 1) * 180, 0) + (0, 270, 0));
    newTag = spawnSM(self.piece.origin - (0, 0, 5.5), "clutter_peleliu_tire_single", (90, 90, 0));
    self.piece linkTo(newTag);
    newTag moveZ(11.5, 1, .5, .5);
    self.piece = tag;
    wait 1;
    newTag linkTo(tag);
    self.startKingMe = undefined;
}
checkers_watchPieces(playerIndex) {
    level waittill("CHECKER_BOARD");
    self thread checkers_watchForGameOver(playerIndex);
    self thread checkers_watchChoice(playerIndex);
    enemyIndex = level.checkerPlayer[playerIndex].otherPlayerIndex;
    if (!isDefined(self.checkerhudIndicator)) {
        self.checkerhudIndicator = self createRectangle("CENTER", "CENTER", 0, 0, 1, 2, (1, 1, 1), "hud_flamethrower_reticle", 5, 1);
        self.checkerhudIndicator scaleOverTime(.5, 35, 35);
    }
    while (true) {
        if (isSolo())
            while (!isDefined(level.checkerPlayer[playerIndex].playersTurn)) wait .05;
        level.checkerPlayer[playerIndex].currentPieceIndex = undefined;
        level.checkerPlayer[playerIndex].enemyPieceIndex = undefined;
        if (!isDefined(level.checkerPlayer[playerIndex].potentialMoveIndex)) self thread checkers_setIndicatorColor((1, 1, 1));
        for (a = 0; a < level.checkerPlayer[playerIndex].pieces.size; a++) {
            if (distance(self lookPos() + (0, 0, 30), level.checkerPlayer[playerIndex].pieces[a].piece.origin) <= 45) {
                level.checkerPlayer[playerIndex].currentPieceIndex = a;
                self thread checkers_setIndicatorColor((0, 1, 0));
                break;
            }
            if (distance(self lookPos() + (0, 0, 30), level.checkerPlayer[enemyIndex].pieces[a].piece.origin) <= 45) {
                level.checkerPlayer[playerIndex].enemyPieceIndex = a;
                if (!isDefined(level.checkerPlayer[playerIndex].chosePlayer)) self thread checkers_setIndicatorColor((1, 0, 0));
                break;
            }
        }
        wait .05;
        while (distance(self lookPos() + (0, 0, 30), level.checkerPlayer[playerIndex].pieces[level.checkerPlayer[playerIndex].currentPieceIndex].piece.origin) <= 45 && isDefined(level.checkerPlayer[playerIndex].currentPieceIndex)) wait .05;
        while (distance(self lookPos() + (0, 0, 30), level.checkerPlayer[enemyIndex].pieces[level.checkerPlayer[playerIndex].enemyPieceIndex].piece.origin) <= 45 && isDefined(level.checkerPlayer[playerIndex].enemyPieceIndex)) {
            if (self.checkerhudIndicator.color != (1, 0, 0) && !isDefined(level.checkerPlayer[playerIndex].chosePlayer)) self thread checkers_setIndicatorColor((1, 0, 0));
            wait .05;
        }
    }
}
checkers_setIndicatorColor(color) {
    self.checkerhudIndicator fadeOverTime(.1);
    self.checkerhudIndicator.color = color;
}
checkers_watchPotentialChoice(playerIndex) {
    level.checkerPlayer[playerIndex] endon("checkers_newChoice");
    pieceIndex = level.checkerPlayer[playerIndex].currentPieceIndex;
    while (self useButtonPressed()) wait .05;
    wait .15;
    while (true) {
        if (self useButtonPressed() && isDefined(level.checkerPlayer[playerIndex].potentialMoveIndex)) {
            level.checkerPlayer[playerIndex].inCheck = undefined;
            level.checkerPlayer[playerIndex].playersTurn = undefined;
            level.checkerPlayer[playerIndex].chosePlayer = undefined;
            self thread checkers_setIndicatorColor((1, 1, 1));
            self thread checkers_movePiece(pieceIndex, playerIndex);
            break;
        }
        wait .05;
    }
}
checkers_movePiece(pieceIndex, playerIndex) {
    level.checkerPlayer[playerIndex].run = true;
    checker = level.checkerPlayer[playerIndex].pieces[pieceIndex];
    index = level.checkerPlayer[playerIndex].potentialMoveIndex;
    index2 = level.checkerPlayer[playerIndex].potentialMoveIndex2;
    doubleSpotPath = checkers_jumpOverTwice(index, index2);
    if (doubleSpotPath > index2) level.checkerPlayer[playerIndex].potentialMoveIndex2 = doubleSpotPath;
    hasDuplicatePath = checkers_hasDuplicateJump(index, index2);
    if (hasDuplicatePath) {
        biggestPathIndex = checkers_findBiggestPathIndex(index);
        biggestPathIndexMatches2 = checkers_comparePathsMatch(biggestPathIndex, index, index2);
        if (biggestPathIndex != index && biggestPathIndexMatches2 > 0) {
            level.checkerPlayer[playerIndex].potentialMoveIndex = biggestPathIndex;
            level.checkerPlayer[playerIndex].potentialMoveIndex2 = biggestPathIndexMatches2;
        }
    }
    index = level.checkerPlayer[playerIndex].potentialMoveIndex;
    index2 = level.checkerPlayer[playerIndex].potentialMoveIndex2;
    jump = undefined;
    if (level.checkerJumpsEnemys[index].size > 0) jump = true;
    for (a = 0; a <= index2; a++) {
        moveOrigin = level.checkerJumps[index][a];
        level.checkerPlayer[playerIndex].pieces[pieceIndex].moveOrigin = moveOrigin;
        if (isDefined(jump)) {
            checker.piece checkers_checkerJump(moveOrigin, pieceIndex, playerIndex);
            jumpOrigin = level.checkerJumpsEnemys[index][a];
            enemyStruct = checkers_getEnemy(jumpOrigin, level.checkerPlayer[playerIndex].otherPlayerIndex);
            enemyStruct thread checkers_moveToGrave(playerIndex);
            enemyStruct.dead = true;
            enemyStruct.moveOrigin = enemyStruct.deathOrigin;
        } else {
            checker.piece moveTo(moveOrigin, 1);
            checker.piece waittill("movedone");
        }
        if (isDefined(checker.startKingMe)) wait 1;
        else wait .1;
    }
    level.checkersWinner = playerIndex;
    if (checkers_gameOver(level.checkerPlayer[playerIndex].otherPlayerIndex)) {
        level.checkersWinType = "WIN";
        level notify("checkers_GameOver");
    } else if (checkers_draw(level.checkerPlayer[playerIndex].otherPlayerIndex)) {
        level.checkersWinType = "DRAW";
        level notify("checkers_GameOver");
    }
    level.checkerPlayer[level.checkerPlayer[playerIndex].otherPlayerIndex].playersTurn = true;
    level.checkerPlayer[playerIndex].potentialMoveIndex = undefined;
    level.checkerPlayer[playerIndex].potentialMoveIndex2 = undefined;
}
checkers_watchForGameOver(playerIndex) {
    level waittill("checkers_GameOver");
    if (level.checkersWinType == "DRAW") {
        if (level.checkersWinner == playerIndex) self thread deathMessage("^1Game Over", "^2Draw ^7- ^3" + getPlayers()[playerIndex - 1] getName() + " ^7has won this checkers match by default", undefined, 20);
        else self thread deathMessage("^1Game Over", "^2Draw ^7- Congratulations, you have won this checkers match by default", undefined, 20, 5.55);
    } else {
        if (level.checkersWinner == playerIndex) self thread deathMessage("^1Game Over", "^2Win ^7- Congratulations, you have won this checkers match", undefined, 20, 5.55);
        else self thread deathMessage("^1Game Over", "^1Loser ^7- ^3" + getPlayers()[level.checkersWinner - 1] getName() + " ^7has won this checkers match", undefined, 20, 5.45);
    }
    wait 5;
    array_thread(getPlayers(), ::_hideSeek_timeoutInit);
}
checkers_draw(playerIndex) {
    for (a = 0; a < 12; a++) {
        if (isDefined(level.checkerPlayer[playerIndex].pieces[a].dead)) continue;
        level checkers_calculateMoves(playerIndex, level.checkerPlayer[playerIndex].pieces[a].moveOrigin, a);
        if (level.checkerArea.size > 0) return false;
        level.checkerArea = undefined;
        level.checkerOrg = undefined;
    }
    return true;
}
checkers_gameOver(playerIndex) {
    for (a = 0; a < 12; a++)
        if (!isDefined(level.checkerPlayer[playerIndex].pieces[a].dead)) return false;
    return true;
}
checkers_checkerJump(moveOrigin, pieceIndex, playerIndex) {
    savedAngle = self.angles;
    angle = vectorToAngles(moveOrigin - self.origin);
    distance = distance(self.origin, moveOrigin);
    self.angles = (self.angles[0], angle[1], self.angles[2]);
    vecF = anglesToForward(self.angles + (-70, 0, 0));
    self moveGravity(vectorScale(vecF, distance * 2.7), 1);
    wait 1;
    self.origin = moveOrigin;
    self.angles = savedAngle;
}
checkers_moveToGrave(playerIndex) {
    self.piece moveZ(110, .4);
    wait .35;
    self.piece moveTo(self.deathOrigin, 1.1);
}
checkers_watchForMove(playerIndex) {
    level.checkerPlayer[playerIndex] endon("checkers_newChoice");
    self thread checkers_watchPotentialChoice(playerIndex);
    org = undefined;
    while (true) {
        level.checkerPlayer[playerIndex].potentialMoveIndex = undefined;
        level.checkerPlayer[playerIndex].potentialMoveIndex2 = undefined;
        if (!isDefined(level.checkerPlayer[playerIndex].currentPieceIndex)) self thread checkers_setIndicatorColor((1, 1, 1));
        for (a = 0; a < level.checkerJumps.size; a++) {
            if (level.checkerJumps[a].size > 0) {
                for (b = 0; b < level.checkerJumps[a].size; b++) {
                    org = level.checkerJumps[a][b];
                    if (distance(self lookPos() + (0, 0, 30), org) <= 45) {
                        level.checkerPlayer[playerIndex].potentialMoveIndex = a;
                        level.checkerPlayer[playerIndex].potentialMoveIndex2 = b;
                        if (!checkers_spotIsEnemy(org, playerIndex)) self thread checkers_setIndicatorColor(divideColor(255, 255, 0));
                        else self thread checkers_setIndicatorColor((1, 0, 0));
                        break;
                    }
                }
            }
        }
        wait .05;
        while (distance(self lookPos() + (0, 0, 30), org) <= 45 && (isDefined(level.checkerPlayer[playerIndex].potentialMoveIndex) && isDefined(level.checkerPlayer[playerIndex].potentialMoveIndex2))) wait .05;
    }
}
checkers_jumpOverTwice(index, index2) {
    for (a = 0; a < level.checkerJumps[index].size; a++)
        if (a != index2 && level.checkerJumps[index][a] == level.checkerJumps[index][index2]) return a;
    return -1;
}
checkers_comparePathsMatch(biggestIndex, startIndex, startIndex2) {
    for (a = 0; a < level.checkerJumps[biggestIndex].size; a++)
        for (b = 0; b < startIndex2; b++)
            if (level.checkerJumps[biggestIndex][a] == level.checkerJumps[startIndex][b]) return a;
    return -1;
}
checkers_findBiggestPathIndex(current) {
    index = current;
    for (a = 0; a < level.checkerJumps.size; a++)
        if (level.checkerJumps[a].size > level.checkerJumps[index].size) index = a;
    return index;
}
checkers_hasDuplicateJump(index, index2) {
    for (a = 0; a < level.checkerJumps.size; a++)
        for (b = 0; b < level.checkerJumps[a].size; b++)
            if (level.checkerJumps[a][b] == level.checkerJumps[index][index2] && index != a && index2 != b) return true;
    return false;
}
checkers_watchChoice(playerIndex) {
    level endon("checkers_GameOver");
    current = undefined;
    tag = undefined;
    tag2 = undefined;
    while (true) {
        if (self useButtonPressed() && level.checkerPlayer[playerIndex].currentPieceIndex != current && !isDefined(level.checkerPlayer[playerIndex].potentialMoveIndex) && !isDefined(level.checkerPlayer[level.checkerPlayer[playerIndex].otherPlayerIndex].potentialMoveIndex) && isDefined(level.checkerPlayer[playerIndex].playersTurn) || isDefined(level.checkerPlayer[playerIndex].run)) {
            level.checkerPlayer[playerIndex].chosePlayer = undefined;
            if (isDefined(tag)) tag remove();
            if (isDefined(tag2)) tag2 remove();
            tag = undefined;
            tag2 = undefined;
            level.checkerPlayer[playerIndex] notify("checkers_newChoice");
            current = undefined;
            if (isDefined(level.checkerPlayer[playerIndex].currentPieceIndex) && !isDefined(level.checkerPlayer[playerIndex].run) && !isDefined(level.checkerPlayer[playerIndex].pieces[level.checkerPlayer[playerIndex].currentPieceIndex].dead)) {
                level.checkerPlayer[playerIndex].chosePlayer = true;
                current = level.checkerPlayer[playerIndex].currentPieceIndex;
                self thread checkers_showMoves(playerIndex);
                origin = level.checkerPlayer[playerIndex].pieces[current].piece.origin;
                tag = spawnSM(origin, "tag_origin");
                tag2 = spawnSM(tag.origin + (sin(0) * 22, cos(0) * 22, 6), "tag_origin", vectorToAngles(anglesToUp((0, 0, 0))));
                tag thread rotateEntYaw(360, .3);
                playFxOnTag(level._effect["tesla_bolt"], tag2, "tag_origin");
                tag2 linkTo(tag);
                tag thread checkers_deleteTags();
                tag2 thread checkers_deleteTags();
            }
            level.checkerPlayer[playerIndex].run = undefined;
        }
        wait .05;
    }
}
checkers_deleteTags() {
    level waittill("CHECKERS_OVER");
    if (isDefined(self)) self remove();
}
checkers_showMoves(playerIndex) {
    level checkers_calculateMoves(playerIndex);
    spots = [];
    origins = [];
    for (a = 0; a < level.checkerArea.size; a++) {
        spots[spots.size] = level.checkerArea[a];
        origins[origins.size] = level.checkerOrg[a];
    }
    level.checkerArea = undefined;
    level.checkerOrg = undefined;
    self thread checkers_watchForMove(playerIndex);
    wait .05;
    for (a = 0; a < spots.size; a++) spots[a] moveTo(origins[a] + (0, 0, 5), .5);
    level.checkerPlayer[playerIndex] waittill("checkers_newChoice");
    for (a = 0; a < spots.size; a++) spots[a] moveTo(origins[a] - (0, 0, 15), .5);
}
checkers_calculateMoves(playerIndex, origin, pieceIndex) {
    if (!isDefined(pieceIndex)) pieceIndex = level.checkerPlayer[playerIndex].currentPieceIndex;
    if (!isDefined(origin)) origin = level.checkerPlayer[playerIndex].pieces[pieceIndex].moveOrigin;
    checker = level.checkerPlayer[playerIndex].pieces[pieceIndex];
    ROW = checkers_findRow(origin);
    COLUMN = checkers_findColumn(origin);
    DIRECTION = level.checkerPlayer[playerIndex].direction;
    level.checkerKingMe = undefined;
    level.checkerJumps = [];
    level.checkerJumpsEnemys = [];
    level.checkerArea = [];
    level.checkerOrg = [];
    if (isDefined(checker.kingMe)) level.checkerKingMe = true;
    level.checkerJumps[0] = [];
    level.checkerJumpsEnemys[0] = [];
    size = level.checkerJumps.size;
    level.checkerJumps[size] = [];
    level.checkerJumpsEnemys[size] = [];
    checkers_checkDirection(ROW - 1 * DIRECTION, COLUMN + 1 * DIRECTION, DIRECTION, playerIndex, -1 * DIRECTION, 1 * DIRECTION, 0);
    checkers_checkDirection(ROW + 1 * DIRECTION, COLUMN + 1 * DIRECTION, DIRECTION, playerIndex, 1 * DIRECTION, 1 * DIRECTION, size);
    if (isDefined(checker.kingMe)) {
        size = level.checkerJumps.size;
        level.checkerJumps[size] = [];
        level.checkerJumpsEnemys[size] = [];
        size2 = level.checkerJumps.size;
        level.checkerJumps[size2] = [];
        level.checkerJumpsEnemys[size2] = [];
        checkers_checkDirection(ROW - 1 * DIRECTION, COLUMN - 1 * DIRECTION, DIRECTION, playerIndex, -1 * DIRECTION, -1 * DIRECTION, size);
        checkers_checkDirection(ROW + 1 * DIRECTION, COLUMN - 1 * DIRECTION, DIRECTION, playerIndex, 1 * DIRECTION, -1 * DIRECTION, size2);
    }
}
checkers_isAddedToPath(ROW, COLUMN, ROUTE_ARRAY_INDEX) {
    origin = level.checkerSpots[ROW][COLUMN].org;
    for (a = 0; a < level.checkerJumps[ROUTE_ARRAY_INDEX].size; a++)
        if (level.checkerJumps[ROUTE_ARRAY_INDEX][a] == origin) return true;
    return false;
}
checkers_findRow(origin) {
    for (a = 0; a < 8; a++)
        for (b = 0; b < 8; b++)
            if (level.checkerSpots[a][b].org == origin) return level.checkerSpots[a][b].row;
    return 0;
}
checkers_findColumn(origin) {
    for (a = 0; a < 8; a++)
        for (b = 0; b < 8; b++)
            if (level.checkerSpots[a][b].org == origin) return level.checkerSpots[a][b].column;
    return 0;
}
checkers_checkDirection(ROW, COLUMN, DIRECTION, playerIndex, ROW_ADD, COLUMN_ADD, ROUTE_ARRAY_INDEX, BUILD_FROM_THIS_INDEX, BUILD_ARRAY_SIZE) {
    level endon("checkers_GameOver");
    foundJump = undefined;
    if (isDefined(level.checkerSpots[ROW][COLUMN].positions) && !checkers_spotIsFriendly(level.checkerSpots[ROW][COLUMN].org, playerIndex)) {
        if (checkers_spotIsEnemy(level.checkerSpots[ROW][COLUMN].org, playerIndex)) {
            if (!checkers_spotIsEnemy(level.checkerSpots[ROW + ROW_ADD][COLUMN + COLUMN_ADD].org, playerIndex) && !checkers_spotIsFriendly(level.checkerSpots[ROW + ROW_ADD][COLUMN + COLUMN_ADD].org, playerIndex)) {
                if (isDefined(BUILD_FROM_THIS_INDEX)) {
                    level.checkerJumps[level.checkerJumps.size] = [];
                    level.checkerJumpsEnemys[level.checkerJumpsEnemys.size] = [];
                    for (a = 0; a < BUILD_ARRAY_SIZE; a++) {
                        level.checkerJumps[ROUTE_ARRAY_INDEX][a] = level.checkerJumps[BUILD_FROM_THIS_INDEX][a];
                        level.checkerJumpsEnemys[ROUTE_ARRAY_INDEX][a] = level.checkerJumpsEnemys[BUILD_FROM_THIS_INDEX][a];
                    }
                    if (checkers_isAddedToPath(ROW, COLUMN, ROUTE_ARRAY_INDEX)) return;
                }
                level checkers_addMove(ROW + ROW_ADD, COLUMN + COLUMN_ADD, ROUTE_ARRAY_INDEX);
                level.checkerJumpsEnemys[ROUTE_ARRAY_INDEX][level.checkerJumpsEnemys[ROUTE_ARRAY_INDEX].size] = level.checkerSpots[ROW][COLUMN].org;
                ROW += ROW_ADD;
                COLUMN += COLUMN_ADD;
                foundJump = true;
            }
        } else {
            noJumps = true;
            if (level.checkerJumpsEnemys[ROUTE_ARRAY_INDEX].size > 0) noJumps = undefined;
            if (isDefined(noJumps)) level checkers_addMove(ROW, COLUMN, ROUTE_ARRAY_INDEX);
        }
        if (isDefined(foundJump)) {
            size = level.checkerJumps[ROUTE_ARRAY_INDEX].size;
            if (checkers_spotIsEnemy(level.checkerSpots[ROW + ROW_ADD][COLUMN + COLUMN_ADD].org, playerIndex)) checkers_checkDirection(ROW + ROW_ADD, COLUMN + COLUMN_ADD, DIRECTION, playerIndex, ROW_ADD, COLUMN_ADD, ROUTE_ARRAY_INDEX);
            if (checkers_spotIsEnemy(level.checkerSpots[ROW - ROW_ADD][COLUMN + COLUMN_ADD].org, playerIndex)) checkers_checkDirection(ROW - ROW_ADD, COLUMN + COLUMN_ADD, DIRECTION, playerIndex, ROW_ADD * -1, COLUMN_ADD, level.checkerJumps.size, ROUTE_ARRAY_INDEX, size);
            if (isDefined(level.checkerKingMe))
                if (checkers_spotIsEnemy(level.checkerSpots[ROW + ROW_ADD][COLUMN - COLUMN_ADD].org, playerIndex)) checkers_checkDirection(ROW + ROW_ADD, COLUMN - COLUMN_ADD, DIRECTION, playerIndex, ROW_ADD, COLUMN_ADD * -1, level.checkerJumps.size, ROUTE_ARRAY_INDEX, size);
        }
    }
}
checkers_addMove(ROW, COLUMN, ROUTE_ARRAY_INDEX) {
    level.checkerArea[level.checkerArea.size] = level.checkerSpots[ROW][COLUMN].positions;
    level.checkerOrg[level.checkerOrg.size] = level.checkerSpots[ROW][COLUMN].org;
    level.checkerJumps[ROUTE_ARRAY_INDEX][level.checkerJumps[ROUTE_ARRAY_INDEX].size] = level.checkerSpots[ROW][COLUMN].org;
}
checkers_spotIsFriendly(origin, playerIndex) {
    for (a = 0; a < 12; a++)
        if (level.checkerPlayer[playerIndex].pieces[a].moveOrigin == origin && !isDefined(level.checkerPlayer[playerIndex].pieces[a].dead)) return true;
    return false;
}
checkers_spotIsEnemy(origin, playerIndex) {
    for (a = 0; a < 12; a++)
        if (level.checkerPlayer[level.checkerPlayer[playerIndex].otherPlayerIndex].pieces[a].moveOrigin == origin && !isDefined(level.checkerPlayer[level.checkerPlayer[playerIndex].otherPlayerIndex].pieces[a].dead)) return true;
    return false;
}
checkers_getEnemy(enemyOrigin, enemyIndex) {
    for (a = 0; a < 12; a++)
        if (level.checkerPlayer[enemyIndex].pieces[a].moveOrigin == enemyOrigin && !isDefined(level.checkerPlayer[enemyIndex].pieces[a].dead)) return level.checkerPlayer[enemyIndex].pieces[a];
    return undefined;
}
pong_createPongBoard() {
    effects = strTok("zapper_light_ready|zapper_light_notready", "|");
    for (a = 0; a < 2; a++)
        for (b = 0; b < 4; b++)
            for (c = 0; c < 63; c++) {
                fx = spawnSM((-1118.88 - a * 926.25 + (-6 + a * 12) * b, -741 + c * 7, 616), "tag_origin", (-90, 0, 0));
                playFxOnTag(level._effect[effects[a]], fx, "tag_origin");
            }
    for (a = 0; a < 32; a++) {
        fx = spawnSM((-1582.005, -741 + a * 14, 616), "tag_origin", (-90, 0, 0));
        playFxOnTag(level._effect[effects[0]], fx, "tag_origin");
        playFxOnTag(level._effect[effects[1]], fx, "tag_origin");
        playFxOnTag(level._effect[effects[1]], fx, "tag_origin");
    }
    rails = [];
    for (a = 0; a < 2; a++)
        for (b = 0; b < 10; b++) rails[rails.size] = spawnSM((-1177.005 - b * 90, -303.875 - a * 440.25, 595.125), "zombie_treasure_box_lid", (0, 180 + a * 180, 90));
    for (a = 0; a < rails.size; a++) rails[a] moveZ(20, 1);
    level.pongBall = pong_createBall();
    level thread pong_controlBall();
    if (isSolo()) wait .05;
    level notify("PONG_BOARD_MADE");
}
pong_controlBall() {
    level endon("3D_PONG_GAME_OVER");
    wait 2;
    level.pong_X = randomIntRange(5, 11);
    level.pong_Y = randomIntRange(5, 11);
    tok = [];
    tok[0] = 1;
    tok[1] = -1;
    negative = tok[randomIntRange(0, 2)];
    level.pong_X *= negative;
    level.pong_Y *= negative;
    position = undefined;
    while (true) {
        if (isDefined(level.stopPongBall)) break;
        if (!isDefined(level.pongDontMove)) level.pongBall.origin = level.pongBall.origin + (level.pong_X, level.pong_Y, 0);
        if ((level.pongBall.origin[0] <= -1132 && level.pongBall.origin[0] >= -2032) && (level.pongBall.origin[1] + 22 >= -303.875 || level.pongBall.origin[1] - 22 <= -744.125)) {
            position = (level.pong_X / level.pong_Y) * level.pongBall.origin[1];
            B = level.pongBall.origin[0] - position;
            if (level.pongBall.origin[1] + 17 + level.pong_Y >= -303.875) {
                MX = (level.pong_X / level.pong_Y) * -321.5;
                Y = MX + B;
                level.pongBall.origin = (Y, -321.5, level.pongBall.origin[2]);
            }
            if (level.pongBall.origin[1] - 17 + level.pong_Y <= -744.125) {
                MX = (level.pong_X / level.pong_Y) * -726.5;
                Y = MX + B;
                level.pongBall.origin = (Y, -726.5, level.pongBall.origin[2]);
            }
            level.pong_Y *= -1;
        }
        wait .05;
    }
    level.pongBall moveZ(-600, 3);
    wait 2;
    level.pongBall.origin = (-1582.005, -524, 600);
    level.pongBall moveZ(25, 1);
    level.stopPongBall = undefined;
    level.pongBallBounced = undefined;
    level.pongDontMove = undefined;
    level.pongJustScored = undefined;
    level thread pong_controlBall();
}
pong_pegController(playerIndex, loserIndex) {
    level endon("3D_PONG_GAME_OVER");
    hud = [];
    score = 0;
    hud["bg"] = self createRectangle("TOP", "TOP", -100 + 200 * (playerIndex - 1), 10, 160, 20, (0, 0, 0), "white", 8, 1, true);
    hud["loader"] = self createRectangle("TOPLEFT", "TOP", -180 + 200 * (playerIndex - 1), 10, 1, 20, divideColor(135, 206, 250), "white", 9, 1, true);
    hud["name"] = self createServerText(self getFont(), 1.25, "TOP", "TOP", hud["bg"].x, hud["bg"].y + 2, 10, 1, "");
    hud["name"].label = self getName() + "'s Score: ";
    hud["name"] setValue(score);
    level waittill("PONG_BOARD_MADE");
    peg = pong_createPeg(playerIndex);
    level.pong_X = 0;
    level.pong_Y = 0;
    dir = 1;
    if (playerIndex == 2) dir = -1;
    while (true) {
        if (!isDefined(level.pongJustScored) && isDefined(level.stopPongBall) && level.stopPongBall == playerIndex) {
            score++;
            hud["loader"] scaleOverTime(.5, 32 * score, 20);
            hud["name"] setValue(score);
            level.pongJustScored = true;
            if (score == 5) break;
        }
        if (playerIndex == 1) {
            if (level.pongBall.origin[0] - 17 > peg.origin[0] + 24) level.stopPongBall = 2;
            if (level.pongBall.origin[0] > peg.origin[0] - 12 && level.pongBall.origin[0] < peg.origin[0] + 12 && !isDefined(level.pongBallBounced)) {
                if (level.pongBall.origin[1] + 17 >= peg.origin[1] - 65 && level.pongBall.origin[1] + 17 <= peg.origin[1]) {
                    level.pongDontMove = true;
                    level.pongBall.origin = (level.pongBall.origin[0], peg.origin[1] - 64, level.pongBall.origin[2]);
                    if (level.pong_Y > 0) level.pong_Y *= -1;
                    level.pong_Y -= 5;
                    level.pong_X += 5;
                    level.pongBallBounced = true;
                    level.pongDontMove = undefined;
                }
                if (level.pongBall.origin[1] - 17 <= peg.origin[1] + 65 && level.pongBall.origin[1] - 17 >= peg.origin[1]) {
                    level.pongDontMove = true;
                    level.pongBall.origin = (level.pongBall.origin[0], peg.origin[1] + 64, level.pongBall.origin[2]);
                    if (level.pong_Y < 0) level.pong_Y *= -1;
                    level.pong_Y += 5;
                    level.pong_X += 5;
                    level.pongBallBounced = true;
                    level.pongDontMove = undefined;
                }
            }
            if (level.pongBall.origin[0] + 17 + level.pong_X >= peg.origin[0] - 12 && level.pongBall.origin[0] - 17 + level.pong_X < peg.origin[0] + 12 && level.pongBall.origin[1] - 17 <= peg.origin[1] + 45 && level.pongBall.origin[1] + 17 >= peg.origin[1] - 45 && !isDefined(level.pongBallBounced)) {
                level.pongDontMove = true;
                level.pongBall.origin = (peg.origin[0] - 28, level.pongBall.origin[1], level.pongBall.origin[2]);
                level.pong_X *= -1;
                level.pong_X -= randomIntRange(1, 3);
                if (level.pong_Y > 0) level.pong_Y += randomIntRange(1, 3);
                else level.pong_Y -= randomIntRange(1, 3);
                level.pongDontMove = undefined;
            }
        } else {
            if (level.pongBall.origin[0] + 17 < peg.origin[0] - 24) level.stopPongBall = 1;
            if (level.pongBall.origin[0] < peg.origin[0] + 12 && level.pongBall.origin[0] > peg.origin[0] - 12 && !isDefined(level.pongBallBounced)) {
                if (level.pongBall.origin[1] - 17 <= peg.origin[1] + 65 && level.pongBall.origin[1] - 17 >= peg.origin[1]) {
                    level.pongDontMove = true;
                    level.pongBall.origin = (level.pongBall.origin[0], peg.origin[1] + 64, level.pongBall.origin[2]);
                    if (level.pong_Y < 0) level.pong_Y *= -1;
                    level.pong_Y += 5;
                    level.pong_X -= 5;
                    level.pongBallBounced = true;
                    level.pongDontMove = undefined;
                }
                if (level.pongBall.origin[1] + 17 >= peg.origin[1] - 65 && level.pongBall.origin[1] + 17 <= peg.origin[1]) {
                    level.pongDontMove = true;
                    level.pongBall.origin = (level.pongBall.origin[0], peg.origin[1] - 64, level.pongBall.origin[2]);
                    if (level.pong_Y > 0) level.pong_Y *= -1;
                    level.pong_Y -= 5;
                    level.pong_X -= 5;
                    level.pongBallBounced = true;
                    level.pongDontMove = undefined;
                }
            }
            if (level.pongBall.origin[0] - 17 + level.pong_X <= peg.origin[0] + 12 && level.pongBall.origin[0] + 17 + level.pong_X > peg.origin[0] - 12 && level.pongBall.origin[1] - 17 <= peg.origin[1] + 45 && level.pongBall.origin[1] + 17 >= peg.origin[1] - 45 && !isDefined(level.pongBallBounced)) {
                level.pongDontMove = true;
                level.pongBall.origin = (peg.origin[0] + 28, level.pongBall.origin[1], level.pongBall.origin[2]);
                level.pong_X *= -1;
                level.pong_X += randomIntRange(1, 3);
                if (level.pong_Y > 0) level.pong_Y += randomIntRange(1, 3);
                else level.pong_Y -= randomIntRange(1, 3);
                level.pongDontMove = undefined;
            }
        }
        curs = 0;
        if (self attackButtonPressed() || self adsButtonPressed()) {
            curs += self attackButtonPressed();
            curs -= self adsButtonPressed();
            if (curs > 0) {
                if (peg.origin[1] + 5 * dir <= -349 && peg.origin[1] + 5 * dir >= -699) peg.origin = peg.origin + (0, 5 * dir, 0);
            } else {
                if (peg.origin[1] + -5 * dir >= -699 && peg.origin[1] + -5 * dir <= -349) peg.origin = peg.origin + (0, -5 * dir, 0);
            }
        }
        wait .05;
    }
    level thread pong_gameOver(playerIndex, loserIndex, hud);
}
pong_gameOver(playerIndex, loserIndex, hud) {
    if (isSolo()) array_thread(getPlayers(), ::deathMessage, "^1Game Over", "^3You have won the 3-D PONG match against yourself! ^2Congratulations I guess?", 438, 20);
    else array_thread(getPlayers(), ::deathMessage, "^1Game Over", getPlayers()[playerIndex - 1] getName() + " has won the 3-D PONG match! " + getPlayers()[loserIndex - 1] getName() + "...YOU SUCK!", undefined, 20, 6);
    hud["name"] thread flashFlash();
    hud["loader"] thread alwaysColorful();
    wait 3;
    level notify("3D_PONG_GAME_OVER");
    wait 5;
    array_thread(getPlayers(), ::_hideSeek_timeoutInit);
}
pong_playPosition(playerIndex) {
    hud = [];
    hud["BG"] = self createRectangle("LEFT", "LEFT", 10, 0, 140, 84, (0, 0, 0), "white", 1, .6);
    hud["TITLE"] = self createText("smallfixed", 1.1, "CENTER", "LEFT", hud["BG"].x + 70, -33, 10, 1, "PONG");
    hud["LINE"] = self createRectangle("LEFT", "LEFT", hud["BG"].x, hud["TITLE"].y + 9, 140, 1, divideColor(0, 110, 255), "white", 10, 1);
    hud[0] = self createText(self getFont(), 1, "LEFT", "LEFT", hud["TITLE"].x - 65, hud["LINE"].y + 9, 10, 1, "[{+speed_throw}]: Move Left");
    hud[1] = self createText(self getFont(), 1, "LEFT", "LEFT", hud[0].x, hud[0].y + 15, 10, 1, "[{+attack}]: Move Right");
    hud[2] = self createText(self getFont(), 1, "LEFT", "LEFT", hud[0].x, hud[1].y + 15, 10, 1, "[{+frag}]: Toggle Bird View");
    hud["LINE2"] = self createRectangle("LEFT", "LEFT", hud["BG"].x, hud[2].y + 9, 140, 1, divideColor(0, 110, 255), "white", 10, 1);
    hud["TURN"] = self createText("smallfixed", 1.1, "CENTER", "LEFT", hud["TITLE"].x, hud["LINE2"].y + 9, 10, 1, "CONTROLS");
    self hide();
    tag = spawnSM((-1038.63 - (playerIndex - 1) * 1086.75, -524, 697.349), "tag_origin");
    tag hide();
    self playerLinkTo(tag);
    self setPlayerAngles((20, 180 - (playerIndex - 1) * 180, 0));
    while (true) {
        count = 0;
        while (self fragButtonPressed()) {
            if (count >= .5) {
                if (tag.origin[2] < 800) tag.origin = tag.origin + (0, 0, 800);
                else tag.origin = tag.origin - (0, 0, 800);
                wait .25;
                break;
            }
            count += .05;
            wait .05;
        }
        wait .05;
    }
    wait .05;
}
pong_createPeg(playerIndex) {
    box = spawnSM((-1127.88 - 908.25 * (playerIndex - 1), -524, 619.125), "zombie_treasure_box", (0, -90 + (playerIndex - 1) * 180, 0));
    lid = spawnSM(box.origin + (-12 + (playerIndex - 1) * 24, 0, 17.6), "zombie_treasure_box_lid", (0, -90 + (playerIndex - 1) * 180, 0));
    lid linkTo(box);
    return box;
}
pong_createBall() {
    tire = spawnSM((-1582.005, -524, 625), "clutter_peleliu_tire_single", (90, 90, 0));
    for (a = 0; a < 12; a++) {
        light = spawnSM(tire.origin + (cos(30 * a) * 10, sin(30 * a) * 10, 8), "tag_origin", vectorToAngles(anglesToForward((90, 90, 0))));
        playFxOnTag(level._effect["zapper_light_notready"], light, "tag_origin");
        playFxOnTag(level._effect["zapper_light_notready"], light, "tag_origin");
        playFxOnTag(level._effect["zapper_light_ready"], light, "tag_origin");
        light linkTo(tire);
    }
    for (a = 0; a < 12; a++) {
        light = spawnSM(tire.origin + (cos(30 * a) * 7, sin(30 * a) * 7, 8), "tag_origin", vectorToAngles(anglesToForward((90, 90, 0))));
        playFxOnTag(level._effect["zapper_light_notready"], light, "tag_origin");
        playFxOnTag(level._effect["zapper_light_notready"], light, "tag_origin");
        playFxOnTag(level._effect["zapper_light_ready"], light, "tag_origin");
        light linkTo(tire);
    }
    for (a = 0; a < 12; a++) {
        light = spawnSM(tire.origin + (cos(30 * a) * 4, sin(30 * a) * 4, 8), "tag_origin", vectorToAngles(anglesToForward((90, 90, 0))));
        playFxOnTag(level._effect["zapper_light_notready"], light, "tag_origin");
        playFxOnTag(level._effect["zapper_light_notready"], light, "tag_origin");
        playFxOnTag(level._effect["zapper_light_ready"], light, "tag_origin");
        light linkTo(tire);
    }
    return tire;
}
cFour_createBoard() {
    for (c = 0; c < 2; c++)
        for (a = 0; a < 6; a++)
            for (b = 0; b < 7; b++) spawnSM((-1367.505, -504 - c * 40, 670.125) + anglesToForward((0, 0, 90)) * (-71.5 * b) + anglesToRight((0, 0, 90)) * (-71.5 * a), "zombie_teleporter_mainframe_ring1", (0, 0, 90));
    for (a = 0; a < 14; a++) spawnSM((-1348.005 - a * 36, -524, 602), "static_berlin_metal_desk", (0, 90, 0));
    level.cFour_moveOrigins = [];
    for (a = 0; a < 6; a++) level.cFour_moveOrigins[a] = [];
    for (a = 0; a < 6; a++) {
        for (b = 0; b < 7; b++) {
            level.cFour_moveOrigins[a][b] = spawnStruct();
            level.cFour_moveOrigins[a][b].x = -1796.505 + b * 71.5;
            level.cFour_moveOrigins[a][b].y = -524;
            level.cFour_moveOrigins[a][b].z = 670.125 + a * 71.5;
        }
    }
    for (a = 1; a < 3; a++) {
        level.cFourPlayer[a].pieces = [];
        for (b = 0; b < 21; b++) {
            level.cFourPlayer[a].pieces[b] = spawnStruct();
            level.cFourPlayer[a].pieces[b].piece = cFour_buildChecker(a, (-1653.505 + (a - 1) * 143, -490 + b * 15, 1100), (0, -90, 0));
        }
    }
    if (isSolo()) wait .05;
    level notify("CONNECT_FOUR_BUILT");
}
cFour_setUpPlayers() {
    level.cFourPlayer = [];
    for (a = 1; a < 3; a++) level.cFourPlayer[a] = spawnStruct();
    if (!isSolo()) level.cFourPlayer[randomIntRange(1, 3)].playersTurn = true;
    else level.cFourPlayer[1].playersTurn = true;
    level.cFourPlayer[1].playerIndex = 0;
    level.cFourPlayer[2].playerIndex = 1;
    level.cFourPlayer[1].otherPlayerIndex = 2;
    level.cFourPlayer[2].otherPlayerIndex = 1;
}
cFour_viewPosition(playerIndex) {
    hud = [];
    hud["BG"] = self createRectangle("LEFT", "LEFT", 10, 0, 160, 85, (0, 0, 0), "white", 1, .6);
    hud["TITLE"] = self createText(self getFont(), 1.2, "CENTER", "LEFT", hud["BG"].x + 80, -33.75, 10, 1, "Connect Four Controls");
    hud["LINE"] = self createRectangle("LEFT", "LEFT", hud["BG"].x, -25, 160, 1, divideColor(0, 110, 255), "white", 10, 1);
    hud[0] = self createText(self getFont(), 1, "LEFT", "LEFT", hud["TITLE"].x - 75, -15, 10, 1, "[{+attack}]: Move Piece Right");
    hud[1] = self createText(self getFont(), 1, "LEFT", "LEFT", hud[0].x, 0, 10, 1, "[{+speed_throw}]: Move Piece Left");
    hud[2] = self createText(self getFont(), 1, "LEFT", "LEFT", hud[0].x, 15, 10, 1, "[{+activate}]: Set Piece");
    hud["LINE2"] = self createRectangle("LEFT", "LEFT", hud["BG"].x, 25, 160, 1, divideColor(0, 110, 255), "white", 10, 1);
    hud["TURN"] = self createText(self getFont(), 1.2, "CENTER", "LEFT", hud["TITLE"].x, 33.75, 10, 1, "Solo Play");
    if (!isSolo()) self thread cFour_watchForNewTurn(playerIndex, hud["TURN"]);
    self hide();
    tag = spawnSM((-1582.005, -1066, 1050), "tag_origin");
    self playerLinkTo(tag);
    self setPlayerAngles((22, 90, 0));
}
cFour_watchForNewTurn(playerIndex, hud) {
    wait 5;
    enemyIndex = level.cFourPlayer[level.cFourPlayer[playerIndex].otherPlayerIndex].playerIndex;
    while (true) {
        if (isDefined(level.cFourPlayer[playerIndex].playersTurn)) {
            hud.alpha = 0;
            hud setText("It's Your Move");
            hud hudFade(1, 1);
            while (isDefined(level.cFourPlayer[playerIndex].playersTurn)) wait .05;
        } else {
            hud.alpha = 0;
            hud setText("It's " + getPlayers()[enemyIndex] getName() + "'s Move");
            hud hudFade(1, 1);
            while (!isDefined(level.cFourPlayer[playerIndex].playersTurn)) wait .05;
        }
        wait .05;
    }
}
cFour_buildChecker(playerIndex, origin, angle) {
    checker = spawnSM(origin, "clutter_peleliu_tire_single", angle);
    for (a = 0; a < 10; a++) {
        light = spawnSM(checker.origin + (sin((360 / 10) * a) * 10, 0, cos((360 / 10) * a) * 10), "tag_origin", vectorToAngles(anglesToForward(angle)));
        if (playerIndex == 2) {
            playFxOnTag(level._effect["zapper_light_notready"], light, "tag_origin");
            playFxOnTag(level._effect["zapper_light_notready"], light, "tag_origin");
        } else {
            playFxOnTag(level._effect["zapper_light_ready"], light, "tag_origin");
            playFxOnTag(level._effect["zapper_light_ready"], light, "tag_origin");
        }
        light linkTo(checker);
    }
    return checker;
}
cFour_makeMove(playerIndex) {
    level waittill("CONNECT_FOUR_BUILT");
    row = 0;
    moves = 0;
    enemyIndex = level.cFourPlayer[playerIndex].otherPlayerIndex;
    winnerIndex = undefined;
    while (moves < 21) {
        if (isDefined(level.cFourPlayer[playerIndex].winner) || isDefined(level.cFourPlayer[enemyIndex].winner)) break;
        if (isDefined(level.cFourPlayer[playerIndex].playersTurn)) {
            level.cFourPlayer[playerIndex].pieces[moves].piece cFour_pieceIntoPosition(playerIndex);
            column = 3;
            while (true) {
                if (self adsButtonPressed() || self attackButtonPressed()) {
                    column += self attackButtonPressed();
                    column -= self adsButtonPressed();
                    if (column > 6) column = 0;
                    if (column < 0) column = 6;
                    origin = (-1796.505 + (column * 71.5), level.cFourPlayer[playerIndex].pieces[moves].piece.origin[1], level.cFourPlayer[playerIndex].pieces[moves].piece.origin[2]);
                    level.cFourPlayer[playerIndex].pieces[moves].piece moveTo(origin, .35);
                    wait .35;
                } else if (self useButtonPressed()) {
                    if (!isDefined(level.cFour_moveOrigins[5][column].taken)) {
                        row = 0;
                        for (a = 0; a < 6; a++) {
                            if (isDefined(level.cFour_moveOrigins[row][column].taken)) row++;
                            else break;
                        }
                        origin = level.cFour_moveOrigins[row][column];
                        level.cFourPlayer[playerIndex].pieces[moves].moveOrigin = (origin.x, origin.y, origin.z);
                        level.cFourPlayer[playerIndex].pieces[moves].placed = true;
                        level.cFourPlayer[playerIndex].pieces[moves].row = row;
                        level.cFourPlayer[playerIndex].pieces[moves].column = column;
                        level.cFour_moveOrigins[row][column].taken = true;
                        level.cFourPlayer[playerIndex].pieces[moves] thread cFour_movePieceInColumn(row, column);
                        if (cFour_connectFour(playerIndex)) {
                            winnerIndex = playerIndex;
                            level.cFourPlayer[playerIndex].winner = true;
                        }
                        moves++;
                        wait .25;
                        break;
                    }
                }
                wait .05;
            }
            level.cFourPlayer[playerIndex].playersTurn = undefined;
            level.cFourPlayer[level.cFourPlayer[playerIndex].otherPlayerIndex].playersTurn = true;
        }
        wait .05;
    }
    if (moves == 21) level.cFourPlayer[playerIndex].outOfMoves = true;
    if (isDefined(level.cFourPlayer[enemyIndex].outOfMoves) && !cFour_isWinner(playerIndex) && !cFour_isWinner(enemyIndex)) array_thread(getPlayers(), ::cFour_tie);
    if (cFour_isWinner(playerIndex)) {
        cFour_findAllWinnings(playerIndex);
        wait 1 - (row * (1 / 6));
        for (a = 0; a < level.cFourPlayer[playerIndex].winningPieces.size; a++) level.cFourPlayer[playerIndex].winningPieces[a].piece thread rotateEntYaw(360, 1);
        self thread cFour_win(winnerIndex, playerIndex);
    }
}
cFour_isWinner(playerIndex) {
    if (isDefined(level.cFourPlayer[playerIndex].winner)) return true;
    return false;
}
cFour_findAllWinnings(playerIndex) {
    extra = [];
    for (c = 0; c < 21; c++)
        if (isDefined(level.cFourPlayer[playerIndex].pieces[c].placed)) {
            if (cFour_checkAllDirections(playerIndex, level.cFourPlayer[playerIndex].pieces[c].row, level.cFourPlayer[playerIndex].pieces[c].column, "L"))
                for (a = 0; a < 7; a++) {
                    origin = level.cFourPlayer[playerIndex].pieces[c].moveOrigin - ((71.5 * a), 0, 0);
                    if (cFour_isFriendly(playerIndex, origin)) extra[extra.size] = cFour_grabPiece(playerIndex, origin);
                    else break;
                }
            if (cFour_checkAllDirections(playerIndex, level.cFourPlayer[playerIndex].pieces[c].row, level.cFourPlayer[playerIndex].pieces[c].column, "U"))
                for (a = 0; a < 7; a++) {
                    origin = level.cFourPlayer[playerIndex].pieces[c].moveOrigin + (0, 0, (71.5 * a));
                    if (cFour_isFriendly(playerIndex, origin)) extra[extra.size] = cFour_grabPiece(playerIndex, origin);
                    else break;
                }
            if (cFour_checkAllDirections(playerIndex, level.cFourPlayer[playerIndex].pieces[c].row, level.cFourPlayer[playerIndex].pieces[c].column, "UR"))
                for (a = 0; a < 7; a++) {
                    origin = level.cFourPlayer[playerIndex].pieces[c].moveOrigin + ((71.5 * a), 0, (71.5 * a));
                    if (cFour_isFriendly(playerIndex, origin)) extra[extra.size] = cFour_grabPiece(playerIndex, origin);
                    else break;
                }
            if (cFour_checkAllDirections(playerIndex, level.cFourPlayer[playerIndex].pieces[c].row, level.cFourPlayer[playerIndex].pieces[c].column, "UL"))
                for (a = 0; a < 7; a++) {
                    origin = level.cFourPlayer[playerIndex].pieces[c].moveOrigin + ((-71.5 * a), 0, (71.5 * a));
                    if (cFour_isFriendly(playerIndex, origin)) extra[extra.size] = cFour_grabPiece(playerIndex, origin);
                    else break;
                }
        }
    for (a = 0; a < extra.size; a++) level.cFourPlayer[playerIndex].winningPieces[level.cFourPlayer[playerIndex].winningPieces.size] = extra[a];
}
cFour_tie() {
    if (isSolo()) self thread deathMessage("^1Game Over", "^3You were unable to beat yourself at Connect Four!... ^1WOW, NO COMMENT!", 434, 20);
    else array_thread(getPlayers(), ::deathMessage, "^1Game Over", "^3The game was a ^1TIE^3, which means you both SUCK! ^1IF YOU'RE NOT FIRST YOU'RE LAST!", 505, 20);
    wait 5;
    array_thread(getPlayers(), ::_hideSeek_timeoutInit);
}
cFour_win(winnerIndex, playerIndex) {
    loserIndex = playerIndex;
    if (winnerIndex == playerIndex) loserIndex = level.cFourPlayer[playerIndex].otherPlayerIndex;
    if (isSolo()) self thread deathMessage("^1Game Over", "^3You have won the Connect Four match against yourself! ^2Congratulations I guess?", 450, 20);
    else array_thread(getPlayers(), ::deathMessage, "^1Game Over", "^2" + getPlayers()[winnerIndex - 1] getName() + "^7 has won the Connect Four match! ^1" + getPlayers()[loserIndex - 1] getName() + "^7...YOU SUCK!", undefined, 20, 5.6);
    wait 5;
    array_thread(getPlayers(), ::_hideSeek_timeoutInit);
}
cFour_connectFour(playerIndex) {
    for (a = 0; a < 21; a++) {
        if (isDefined(level.cFourPlayer[playerIndex].pieces[a].placed)) {
            if (cFour_checkAllDirections(playerIndex, level.cFourPlayer[playerIndex].pieces[a].row, level.cFourPlayer[playerIndex].pieces[a].column)) {
                level.cFourPlayer[playerIndex].winningPieces[level.cFourPlayer[playerIndex].winningPieces.size] = level.cFourPlayer[playerIndex].pieces[a];
                return true;
            }
        }
    }
    return false;
}
cFour_checkAllDirections(playerIndex, ROW, COLUMN, DIRECTION) {
    if (!isDefined(DIRECTION) || DIRECTION == "U")
        for (a = 1; a < 4; a++) {
            check = cFour_checkForRow(playerIndex, ROW + a, COLUMN, a);
            if (isDefined(check)) {
                if (check) return true;
                else if (!check) break;
            }
        }
    if (!isDefined(DIRECTION) || DIRECTION == "L")
        for (a = 1; a < 4; a++) {
            check = cFour_checkForRow(playerIndex, ROW, COLUMN - a, a);
            if (isDefined(check)) {
                if (check) return true;
                else if (!check) break;
            }
        }
    if (!isDefined(DIRECTION) || DIRECTION == "UR")
        for (a = 1; a < 4; a++) {
            check = cFour_checkForRow(playerIndex, ROW + a, COLUMN + a, a);
            if (isDefined(check)) {
                if (check) return true;
                else if (!check) break;
            }
        }
    if (!isDefined(DIRECTION) || DIRECTION == "UL")
        for (a = 1; a < 4; a++) {
            check = cFour_checkForRow(playerIndex, ROW + a, COLUMN - a, a);
            if (isDefined(check)) {
                if (check) return true;
                else if (!check) break;
            }
        }
    return false;
}
cFour_checkForRow(playerIndex, ROW, COLUMN, val) {
    if (val == 1) level.cFourPlayer[playerIndex].winningPieces = [];
    if (isDefined(level.cFour_moveOrigins[ROW][COLUMN])) {
        origin = level.cFour_moveOrigins[ROW][COLUMN];
        if (cFour_isFriendly(playerIndex, (origin.x, origin.y, origin.z))) {
            level.cFourPlayer[playerIndex].winningPieces[level.cFourPlayer[playerIndex].winningPieces.size] = cFour_grabPiece(playerIndex, (origin.x, origin.y, origin.z));
            if (val == 3) return true;
        } else return false;
    } else return false;
    return undefined;
}
cFour_isFriendly(playerIndex, origin) {
    for (a = 0; a < 21; a++)
        if (isDefined(level.cFourPlayer[playerIndex].pieces[a].placed))
            if (level.cFourPlayer[playerIndex].pieces[a].moveOrigin == origin) return true;
    return false;
}
cFour_grabPiece(playerIndex, origin) {
    for (a = 0; a < 21; a++)
        if (isDefined(level.cFourPlayer[playerIndex].pieces[a].placed))
            if (level.cFourPlayer[playerIndex].pieces[a].moveOrigin == origin) return level.cFourPlayer[playerIndex].pieces[a];
}
cFour_pieceIntoPosition(playerIndex) {
    self moveTo((-1582.005, self.origin[1], self.origin[2]), .5, .25);
    wait .55;
    self moveTo((-1582.005, -524, self.origin[2] - 10), .5);
    wait .75;
}
cFour_movePieceInColumn(row, column) {
    self.piece moveTo(self.moveOrigin, 1 - (row * (1 / 6)));
    self.piece waittill("movedone");
    wait .05;
    self.piece moveTo(self.piece.origin - (0, 20, 0), .5);
}
new_intermissionCamera() {
    stuff[0] = strTok("19;-1930;714 37;24;0 -751;-216;714 100", " ");
    stuff[1] = strTok("-217;-1251;596 36;180;0 -217;-476;596 100", " ");
    cameras = getStructArray("intermission", "targetname");
    for (m = 0; m < cameras.size; m++) {
        pos = strTok(stuff[m][0], ";");
        end = strTok(stuff[m][2], ";");
        ang = strTok(stuff[m][1], ";");
        cameras[m].origin = (int(pos[0]), int(pos[1]), int(pos[2]));
        cameras[m].angles = (int(ang[0]), int(ang[1]), int(ang[2]));
        cameras[m].speed = int(stuff[m][3]);
        cameraPoint = getStruct(cameras[m].target, "targetname");
        cameraPoint.origin = (int(end[0]), int(end[1]), int(end[2]));
        cameraPoint.angles = (int(ang[0]), int(ang[1]), int(ang[2]));
    }
}
startCampaign(input2) {
    if (!isSolo()) self thread briefing(10, "Extinction");
    self hide();
    hud = [];
    hud[5] = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", 19, 1);
    if (!isSolo()) wait 10;
    for (a = 0; a < 5; a++) hud[a] = self createText(self getFont(), 1.5, "BOTTOMLEFT", "BOTTOMLEFT", 0, -110 + a * 20, 20, 0, "");
    hud[0] settext("'Extinction'");
    hud[1] settext("Waffenfabrik der Riese");
    hud[2] settext("381 Months Later");
    hud[3] settext("Difficulty: " + self.menu["EXTINCTION_DIF"]["option"][input2]);
    hud[4] settext("Created By: AgreedBog381");
    for (a = 0; a < 5; a++) {
        hud[a] thread hudFade(1, 3.5);
        wait 2.5;
    }
    wait 1;
    for (a = 0; a < 5; a++) hud[a] thread hudFadenDestroy(0, 2.5);
    hud[5] thread hudFadenDestroy(0, 3.5);
    self show();
    self freezeControls(false);
    level notify("HUD");
}
campaignSolids() {
    zomb_doors = getEntArray("zombie_door", "targetname");
    zomb_doors[7] thread watchPRDoor();
    zomb_doors[6] trigger_off();
    self thread watchBankDoor(zomb_doors[6]);
    level thread watchOtherDoors(zomb_doors[4], zomb_doors[5]);
    tok = strTok("8 1", " ");
    for (a = 0; a < tok.size; a++) zomb_doors[int(tok[a])] open_door();
    zomb_doors[8].doors[0].origin = (-85, -395, 35);
    zomb_doors[8].doors[0].angles = (0, 225, 0);
    zomb_doors[1].doors[0].origin = (-85, -362, 35);
    zomb_doors[1].doors[0].angles = (0, 90, 0);
    zomb_doors[7] trigger_off();
    for (a = 0; a < tok.size; a++) {
        zomb_doors[int(tok[a])].doors[0] thread alwaysSolidDoors();
        zomb_doors[int(tok[a])].doors[0] hide();
        zomb_doors[int(tok[a])].doors[0] solid();
        zomb_doors[int(tok[a])].doors[0].door_moving = true;
    }
    org = zomb_doors[3].doors[0].origin;
    org2 = zomb_doors[2].doors[0].origin;
    while (true) {
        if (zomb_doors[3].doors[0].origin != org) {
            wait 2;
            zomb_doors[3].doors[0] hide();
            zomb_doors[3].doors[0].origin = (295, -2960, 189);
            zomb_doors[3].doors[0].angles = (0, 90, 0);
            break;
        }
        if (zomb_doors[2].doors[0].origin != org2) {
            wait 2;
            zomb_doors[2].doors[0] hide();
            zomb_doors[2].doors[0].origin = (295, -2960, 189);
            zomb_doors[2].doors[0].angles = (0, 90, 0);
            break;
        }
        wait .05;
    }
    level connect_zones("outside_east_zone", "outside_south_zone");
    level connect_zones("outside_west_zone", "outside_south_zone", true);
    org = zomb_doors[0].doors[0].origin;
    while (true) {
        if (zomb_doors[0].doors[0].origin != org) break;
        wait .05;
    }
    wait 1.5;
    zomb_doors[0].doors[1] hide();
    zomb_doors[0].doors[1] solid();
    zomb_doors[0].doors[1].origin = (-157.073, -2284.28, 214.037);
    zomb_doors[0].doors[1].angles = (90, 228, 0);
    zomb_doors[0].doors[0] hide();
    zomb_doors[0].doors[0].origin = (95, -2415, 400);
    zomb_doors[0].doors[0].angles = (0, 90, 0);
    level waittill("GENERAL_KEY");
    zomb_doors[7] open_door();
    level waittill("OraclePlaced");
    zomb_doors[0].doors[0].origin = (505, -2225, 400);
}
watchPRDoor() {
    level waittill("StratPower");
    for (a = 0; a < 2; a++) {
        self.doors[a] hide();
        self.doors[a] solid();
        self.doors[a].origin = (-1609, -970 + a * 30, 85);
    }
}
watchBankDoor(door) {
    door.doors[0] hide();
    level waittill("StratPower");
    door open_door();
    wait 2;
    door.doors[0].origin = (1495, 942, 168);
    door.doors[0].angles = (0, 0, 0);
}
watchOtherDoors(door, door2) {
    org = door.doors[0].origin;
    org2 = door2.doors[0].origin;
    while (true) {
        if (door.doors[0].origin != org) {
            wait 2;
            for (a = 0; a < 2; a++) {
                door.doors[a] hide();
                door.doors[a] solid();
                door.doors[a].origin = (990, 932, 190);
                door.doors[a].angles = (0, 0, 0);
            }
            break;
        }
        if (door2.doors[0].origin != org2) {
            wait 2;
            for (a = 0; a < 2; a++) {
                door2.doors[a] hide();
                door2.doors[a] solid();
                door2.doors[a].origin = (990, 942, 190);
                door2.doors[a].angles = (0, 0, 0);
            }
            break;
        }
        wait 0.05;
    }
}
alwaysSolidDoors(door) {
    while (true) {
        self solid();
        wait 1;
    }
}
deletePerks() {
    vend = strTok("vending_sleight|vending_revive|vending_jugg|vending_doubletap", "|");
    for (a = 0; a < vend.size; a++) {
        perkMachine[a] = getEntArray(vend[a], "targetname");
        for (b = 0; b < perkMachine[a].size; b++) perkMachine[a][b] remove();
    }
}
disablePower() {
    trig = getent("use_power_switch", "targetname");
    handle = getent("power_switch", "targetname");
    handle rotateroll(-90, .3);
    trig remove();
    playfx(level._effect["switch_sparks"], getstruct("power_switch_fx", "targetname").origin);
}
deleteZone() {
    struct = getStructArray("initial_spawn_points", "targetname");
    for (a = 0; a < struct.size; a++) struct[a].origin = (-56, 272, 104);
    spawnPoints = getStructArray("player_respawn_point", "targetname");
    for (a = 0; a < spawnPoints.size; a++) {
        spawnPoints[a].origin = (-56, 272, 104);
        spawnArray = getStructArray(spawnPoints[a].target, "targetname");
        for (i = 0; i < spawnArray.size; i++) spawnArray[i].origin = (-56, 272, 104);
    }
    goals = getStructArray("exterior_goal", "targetname");
    for (b = 0; b < goals[6].barrier_chunks.size; b++) {
        goals[12].barrier_chunks[b] delete();
        goals[14].barrier_chunks[b] delete();
        goals[15].barrier_chunks[b] delete();
    }
    goals[12].trigger_location.origin = goals[12].trigger_location.origin + (0, 0, 100000);
    goals[14].trigger_location.origin = goals[14].trigger_location.origin + (0, 0, 100000);
    goals[15].trigger_location.origin = goals[15].trigger_location.origin + (0, 0, 100000);
    zkeys = getArrayKeys(level.zones);
    while (true) {
        for (a = 0; a < 10; a++)
            if (isDefined(level.zones[zkeys[3]].spawners[a])) level.zones[zkeys[3]].spawners[a] = undefined;
        for (a = 0; a < level.zones[zkeys[3]].dog_spawners.size; a++)
            if (isDefined(level.zones[zkeys[3]].dog_spawners[a])) level.zones[zkeys[3]].dog_spawners[a] = undefined;
        for (a = 0; a < level.zones[zkeys[3]].dog_locations.size; a++)
            if (isDefined(level.zones[zkeys[3]].dog_locations[a])) level.zones[zkeys[3]].dog_locations[a] = undefined;
        for (a = 2; a < 5; a++)
            if (isDefined(level.zones[zkeys[2]].spawners[a])) level.zones[zkeys[2]].spawners[a] = undefined;
        for (a = 0; a < level.zones[zkeys[2]].dog_spawners.size; a++)
            if (isDefined(level.zones[zkeys[2]].dog_spawners[a])) level.zones[zkeys[2]].dog_spawners[a] = undefined;
        for (a = 0; a < level.zones[zkeys[2]].dog_locations.size; a++)
            if (isDefined(level.zones[zkeys[2]].dog_locations[a])) level.zones[zkeys[2]].dog_locations[a] = undefined;
        wait 1;
    }
}
dSettings(input2) {
    if (input2 == 0) {
        level.winningXP = 10000;
        level.runTime = 60;
        level.zDelay = 1;
    }
    if (input2 == 1) {
        level.winningXP = 15000;
        level.runTime = 50;
        level.zDelay = .5;
    }
    if (input2 == 2) {
        level.winningXP = 30000;
        level.runTime = 40;
        level.zDelay = .25;
    }
    if (input2 == 3) {
        level.winningXP = 50000;
        level.runTime = 30;
        level.zDelay = .05;
    }
}
campaignPlayerSettings() {
    self.xpNeeded = strTok("10;16;22;28;34;40;46;52;58;64;70;76;82;88;94;100;106;112;118;124;130;136;142;148;154;160;166;172;178;184;190;196;202;208;214;220;226;232;238;244;250;256;262;268;274;280;286;292;298;304;310;316;322;328;334;340;346;352;358;364;370;376;382;388;394;400", ";");
    self.prestigeLevel = self getSavedVariable("153");
    self.rankLevel = self getSavedVariable("154");
    self.XPGot = self getSavedVariable("hctwar_losses", "mp/playerStatsTable.csv");
    self.XPextra = self getSavedVariable("hckoth_losses", "mp/playerStatsTable.csv");
    self.XPBar = self getSavedVariable("155");
    if (self getSavedVariable("250") != 1) {
        self setSavedVariable("152", 1);
        self.prestigeLevel = 0;
    }
    if (self.XPBar == 0) self.XPBar = 1;
    self thread extinctionSave();
}
extinctionSave() {
    self endon("disconnect");
    while (true) {
        self setSavedVariable("153", self.prestigeLevel);
        self setSavedVariable("154", self.rankLevel);
        self setSavedVariable("hctwar_losses", self.XPGot, "mp/playerStatsTable.csv");
        self setSavedVariable("hckoth_losses", self.XPextra, "mp/playerStatsTable.csv");
        self setSavedVariable("155", self.XPBar);
        wait 1;
    }
}
extinctionVisionWatch() {
    while (true) {
        self thread setVision("ber1_default");
        wait 5;
    }
}
extinctionFogWatch() {
    while (true) {
        self round_wait();
        wait 12;
        self thread setVision("ber1_default");
        self thread changeFog((0, 0, 0), 5);
        wait 5;
    }
}
campaignLightning() {
    while (true) {
        setSunLight(4, 4, 4.5);
        setSunLight(1, 1, 1.5);
        wait 0.05;
        setSunLight(3, 3, 3.5);
        setSunLight(2, 2, 2.5);
        setSunLight(1.5, 1.5, 2);
        wait 0.05;
        setSunLight(1, 1, 1.5);
        setSunLight(5, 5, 5.5);
        wait 0.05;
        setSunLight(4, 4, 4.5);
        setSunLight(1, 1, 1.5);
        wait 0.05;
        setSunLight(2.5, 2.5, 3);
        wait 0.05;
        resetsunLight();
        wait randomIntRange(3, 25);
    }
}
campaignThunder() {
    while (true) {
        self playSound("nuke_flash");
        earthquake(0.17, 0.5, self.origin, 100);
        self playSound("couch_slam");
        earthquake(0.17, 0.5, self.origin, 100);
        wait randomInt(35);
    }
}
stielGernades() {
    self takeWeapon("stielhandgranate");
    self giveWeapon("fraggrenade");
    self giveMaxAmmo("fraggrenade");
    self setWeaponAmmoClip("fraggrenade", 4);
    while (true) {
        self setWeaponAmmoClip("stielhandgranate", 0);
        wait 0.1;
    }
}
watchKills() {
    while (true) {
        self waittill("zom_kill");
        if (!isDefined(self.hitMarker)) self notify("HitMarker");
        self thread createFeedbackMarker();
    }
}
watchHeadshots() {
    old = self.headshots;
    while (true) {
        if (self.headshots > old) {
            old++;
            self notify("headshot");
            if (!isDefined(self.hitMarker)) self notify("HitMarker");
            self thread createFeedbackMarker();
        }
        wait .05;
    }
}
runRankMenu() {
    self.campaignHud = [];
    self.campaignHud["bg"] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 0, 0, 200, 60, (0, 0, 0), "white", -4, 0.3);
    self.campaignHud["mission"] = self createText(self getFont(), 1, "BOTTOMLEFT", "BOTTOMLEFT", 5, -45, 4, 1, "Objective: Find General Blunts");
    self.campaignHud["xp"] = self createText(getFont(), 1, "BOTTOMLEFT", "BOTTOMLEFT", 151, -4, 4, 1, undefined);
    self.campaignHud["xp"].label = "Rank: ";
    self.campaignHud["bank"] = self createText(self getFont(), 1, "BOTTOMLEFT", "BOTTOMLEFT", 5, -4, 4, 1, undefined);
    if (self getSavedVariable("500") == 1 || self getName() == "AgreedBog381") self.campaignHud["bank"].label = "Bank Amount: ^2Infinite";
    else self.campaignHud["bank"].label = "Bank Amount: ^2$^7";
    if (self.prestigeLevel == 0) {
        self.campaignHud["rank"] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 5, -20, 20, 20, (1, 1, 1), level.rankBadges[self.rankLevel], 2, 1);
        if (self.rankLevel == 64) self.campaignHud["nextrank"] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 175, -20, 20, 20, (1, 1, 1), level.rankPrestige[self.prestigeLevel], 2, 1);
        else self.campaignHud["nextrank"] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 175, -20, 20, 20, (1, 1, 1), level.rankBadges[self.rankLevel + 1], 2, 1);
    } else {
        if (self.prestigeLevel == 10) {
            self.campaignHud["rank"] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 5, -20, 20, 20, (1, 1, 1), level.rankPrestige[self.prestigeLevel - 2], 2, 1);
            self.campaignHud["nextrank"] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 175, -20, 20, 20, (1, 1, 1), level.rankPrestige[self.prestigeLevel - 1], 2, 1);
        } else {
            self.campaignHud["rank"] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 5, -20, 20, 20, (1, 1, 1), level.rankPrestige[self.prestigeLevel - 1], 2, 1);
            self.campaignHud["nextrank"] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 175, -20, 20, 20, (1, 1, 1), level.rankPrestige[self.prestigeLevel], 2, 1);
        }
    }
    self.campaignHud["bar"] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 32.5, -25, 135, 10, (0, 0, 0), "white", 2, 1);
    self.campaignHud["barprog"] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", 32.5, -25, self.XPBar, 10, (1, 1, 1), "white", 3, 1);
    if (self.prestigeLevel != 10 || self.rankLevel != 64 || self.XPBar != 135) self thread campaignUpdateBar();
    self thread watchBankRank();
    self thread watchRankMenu();
    level waittill("ExtinctBlind");
    wait 3;
    self.campaignHud["bg"] destroy();
    self.campaignHud["mission"] destroy();
    self.campaignHud["bank"] destroy();
    self thread clearPerks();
    self destroyAll(self.campaignHud);
}
watchForPrestige() {
    while (true) {
        if (self.prestigeLevel > 0) break;
        wait .05;
    }
    self.campaignHud["xp"].x -= 14;
    self.campaignHud["xp"].label = "Prestige: ";
    while (true) {
        if (self getSavedVariable("500") != 1) self.campaignHud["bank"] setValue(self.Banking);
        self.campaignHud["xp"] setValue(self.prestigeLevel);
        wait .05;
    }
}
watchBankRank() {
    self thread watchForPrestige();
    while (self.prestigeLevel == 0) {
        if (self getSavedVariable("500") != 1) self.campaignHud["bank"] setValue(self.Banking);
        self.campaignHud["xp"] setValue(self.rankLevel + 1);
        wait .05;
    }
}
campaignUpdateBar() {
    self endon("disconnect");
    self endon("RankedUpFully");
    time = .1;
    while (true) {
        if (self.rankLevel < 64 && self.XPGot < int(self.xpNeeded[self.rankLevel]) || self.prestigeLevel > 0 && self.XPGot < 13130) {
            if (time == 0.05) time = .1;
            if (self.prestigeLevel == 0) {
                if (self.XPextra * (135 / int(self.xpNeeded[self.rankLevel])) == 0) {
                    self.campaignHud["barprog"] scaleOverTime(time, 1, 10);
                    time = 0.05;
                }
                self.campaignHud["barprog"] scaleOverTime(time, int(self.XPextra * (135 / int(self.xpNeeded[self.rankLevel]))), 10);
                if (self.XPBar != int(self.XPextra * (135 / int(self.xpNeeded[self.rankLevel])))) self.XPBar = int(self.XPextra * (135 / int(self.xpNeeded[self.rankLevel])));
            } else {
                if (self.XPextra * (135 / 13130) == 0) {
                    self.campaignHud["barprog"] scaleOverTime(time, 1, 10);
                    time = 0.05;
                }
                self.campaignHud["barprog"] scaleOverTime(time, int(self.XPextra * (135 / 13130)), 10);
                if (self.XPBar != int(self.XPextra * (135 / 13130))) self.XPBar = int(self.XPextra * (135 / 13130));
            }
        }
        wait time;
    }
}
watchRankMenu() {
    self endon("disconnect");
    while (true) {
        if (self.rankLevel == 64 && self.prestigeLevel == 10) break;
        if (self.rankLevel < 64 || self.prestigeLevel < 10) {
            if ((self.prestigeLevel == 0 && self.XPGot >= int(self.xpNeeded[self.rankLevel])) || (self.prestigeLevel > 0 && self.XPGot >= 13130)) {
                self.campaignHud["barprog"] scaleOverTime(.05, 135, 10);
                wait .05;
                if (self.prestigeLevel == 0) self.XPextra = int(self.xpNeeded[self.rankLevel]);
                else self.XPextra = 13130;
                self.XPGot -= self.XPextra;
                self.XPextra = 0;
                if (self.rankLevel == 64) {
                    self.prestigeLevel++;
                    if (self.prestigeLevel == 10) break;
                } else self.rankLevel++;
                self.campaignHud["barprog"] scaleOverTime(.05, 1, 10);
                if (self.prestigeLevel == 0) {
                    self.campaignHud["rank"] setShader(level.rankBadges[self.rankLevel], 20, 20);
                    self.campaignHud["nextrank"] setShader(level.rankBadges[self.rankLevel + 1], 20, 20);
                } else {
                    self.campaignHud["rank"] setShader(level.rankPrestige[self.prestigeLevel - 1], 20, 20);
                    self.campaignHud["nextrank"] setShader(level.rankPrestige[self.prestigeLevel], 20, 20);
                }
                wait 0.05;
            } else if (self.XPextra != self.XPGot) self.XPextra = self.XPGot;
        }
        wait 0.05;
    }
    self notify("RankedUpFully");
    self.XPextra = int(self.xpNeeded[self.rankLevel]);
    self.campaignHud["barprog"] scaleOverTime(.1, 135, 10);
    self.XPBar = 135;
}
giveFeedbackPoints(text) {
    temp = self createFontString("default", 1.5, self);
    temp setText(text);
    temp setPoint("LEFT", "BOTTOMLEFT", self.campaignHud["xp"].x + 35, self.campaignHud["xp"].y);
    temp.color = divideColor(237, 255, 83);
    temp moveOverTime(0.5);
    temp setPoint("LEFT", "BOTTOMLEFT", temp.x + 30, temp.y + randomIntRange(-15, 15));
    temp hudFadenDestroy(0, 0.6);
}
watchForRescue() {
    self waittill("EXTINCTION_SUCCESS");
    self.XPGot += level.winningXP;
    self thread giveFeedbackPoints("+" + level.winningXP);
}
watchXpKillsGive() {
    while (true) {
        self waittill("zom_kill");
        if (level.zombie_vars["zombie_point_scalar"] == 2 || isDefined(self.zombie_point_scalar)) {
            self.XPGot += 20;
            self thread giveFeedbackPoints("+20");
        } else {
            self.XPGot += 10;
            self thread giveFeedbackPoints("+10");
        }
    }
}
watchXpHeadShotGive() {
    while (true) {
        self waittill("headshot");
        if (level.zombie_vars["zombie_point_scalar"] == 2 || isDefined(self.zombie_point_scalar)) {
            self.XPGot += 80;
            self thread giveFeedbackPoints("+80");
        } else {
            self.XPGot += 40;
            self thread giveFeedbackPoints("+40");
        }
    }
}
stratDia(y, hud, text, time, bool) {
    if (isDefined(self.strat_dia))
        while (true) {
            wait .05;
            if (!isDefined(self.strat_dia)) break;
        }
    self.strat_dia = true;
    if (!isDefined(self.dialogueBox)) self.dialogueBox = self createRectangle(hud, hud, 0, 0, 1000, 20, (0, 0, 0), "white", 0, .4);
    if (!isDefined(self.dialogue)) self.dialogue = self createText(self getFont(), 1.5, hud, hud, 0, y, 1, 1, text);
    else self.dialogue setText(text);
    wait time;
    if (isDefined(bool)) {
        self.dialogue thread hudFadenDestroy(0, .3);
        self.dialogueBox thread hudFadenDestroy(0, .3);
    }
    self.strat_dia = undefined;
}
setObjectiveLog(text) {
    self.campaignHud["mission"] setText("Objective: " + text);
}
bankExchange() {
    zomb = getAISpeciesArray("axis", "all");
    general = spawnSM((1636.5, 823, 167.125), zomb[0].model, (0, 180, 0));
    general attach(zomb[0].headModel, "", true);
    general useAnimTree(#animtree);
    general setAnim( % casual_stand_v2_idle);
    general attach(getWeaponModel("tesla_gun_upgraded"), "tag_weapon_right");
    trig = spawnTrigger(general.origin - (40, 0, 0), 41);
    trig setString("Hold [{+activate}] To Send " + getPlayers()[0] getName() + " $1000");
    index = 0;
    while (true) {
        trig waittill("trigger", who);
        if ((who attackButtonPressed() || who adsButtonPressed()) && !who.is_zombie) {
            index += who attackButtonPressed();
            index -= who adsButtonPressed();
            if (index > getPlayers().size - 1) index = 0;
            if (index < 0) index = getPlayers().size - 1;
            trig setString("Hold [{+activate}] To Send " + getPlayers()[index] getName() + " $1000");
            wait .05;
        }
        if (!who.is_zombie && who useButtonPressed()) {
            if (who.banking >= 1000 || who getSavedVariable("500") == 1) {
                if (who getSavedVariable("500") != 1) who.banking -= 1000;
                getPlayers()[index].banking += 1000;
                getPlayers()[index] setSavedVariable("sab_losses", getPlayers()[index].Banking, "mp/playerStatsTable.csv");
                who setSavedVariable("sab_losses", who.Banking, "mp/playerStatsTable.csv");
            } else if (who.score >= 1000) {
                who.score -= 1000;
                getPlayers()[index].banking += 1000;
            } else who iprintln("Insufficient Funds");
        }
    }
}
#using_animtree("generic_human");
doBanking() {
    level thread doSewerSteam();
    zomb = getAISpeciesArray("axis", "all");
    general = [];
    for (a = 0; a < 2; a++) board = spawnSM((-33 - a * 1, -2797 - a * 8, 90), "zombie_treasure_box_lid", (20 - a * 40, -90, 90));
    board = spawnSM((-128, -2250, 155.5), "zombie_treasure_box_lid", (0, -12, 180));
    board = spawnSM((-128, -2212, 155.5), "zombie_treasure_box_lid", (0, 0, 180));
    for (a = 0; a < 2; a++) {
        general[a] = spawnSM((990 + a * 540, 985, 168.125), zomb[0].model, (0, -90, 0));
        general[a] attach(zomb[a].headModel, "", true);
        general[a] useAnimTree(#animtree);
        general[a] setAnim( % casual_stand_v2_idle);
        general[a] attach(getWeaponModel("zombie_ppsh_upgraded"), "tag_weapon_right");
    }
    trig = spawnTrigger((1530, 917, 168.125), 41);
    trig setString("Hold [{+activate}] To Withdraw $1000 [Cost: $100]");
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie && who.score >= 100) {
            wait .1;
            if (who usebuttonPressed() && !who.is_zombie) {
                if (who getName() == "AgreedBog381" || who getSavedVariable("500") == 1 || who.Banking >= 1000) {
                    who playSound("cha_ching");
                    who.score -= 100;
                    if (who getSavedVariable("500") != 1) who.Banking -= 1000;
                    who.score += 1000;
                    who setSavedVariable("sab_losses", who.Banking, "mp/playerStatsTable.csv");
                }
                wait .5;
            }
        }
    }
}
doBankDeposit() {
    trig = spawnTrigger((990, 917, 168.125), 41);
    trig setString("Hold [{+activate}] To Deposit $1000");
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie && who.score >= 1000) {
            if (who.banking < 2147483647 && who getSavedVariable("500") != 1) {
                wait .1;
                if (who usebuttonPressed() && !who.is_zombie) {
                    who playSound("cha_ching");
                    who.score -= 1000;
                    if (2147483647 - who.banking >= 1000) who.Banking += 1000;
                    else who.banking = 2147483647;
                    who setSavedVariable("sab_losses", who.Banking, "mp/playerStatsTable.csv");
                    wait .5;
                }
            } else who iprintln("Bank Amount Maxed Out!");
        }
    }
}
doSewerSteam() {
    while (true) {
        playFx(level._effect["zombie_heat_sink"], (-14, -2665, 88));
        wait 8;
    }
}
doPerkOfFortune() {
    ZL = "zombie_treasure_box_lid";
    pos = (292, -2990, 305);
    desk = [];
    machines = [];
    master = spawnSM(pos, "tag_origin", (0, 0, 0));
    for (b = 0; b < 2; b++) {
        for (a = 0; a < 10; a++) {
            wheel = spawnSM(pos + (sin(a * 36) * 139, b * 24, cos(a * 36) * 139), ZL, (180 + a * 36, 0, 180));
            wheel linkTo(master);
        }
    }
    tok = strTok("zombie_vending_packapunch|zombie_vending_sleight|zombie_vending_revive|zombie_vending_doubletap|zombie_vending_jugg", "|");
    for (a = 0; a < tok.size; a++) machines[a] = spawnSM(pos + (sin(a * 72) * 139, 0, cos(a * 72) * 139), tok[a], (180 - a * 72, 180, 0));
    for (a = 0; a < 8; a++) {
        for (b = 0; b < 13; b++) {
            if (a > 6 && b > 7) board = spawnSM(pos + (270 - (a * 89.9) + 45, 20, 136 - (b * 24)), ZL, (0, -90, 90));
            if (a < 7) board = spawnSM(pos + (270 - a * 89.9, -25, 136 - b * 24), ZL, (0, 0, 90));
        }
    }
    fortuneTrig = spawn("trigger_radius", (300, -2940, 145), 1, 40, 40);
    fortuneTrig setCursorHint("HINT_NOICON");
    fortuneTrig setHintString("Requires A Power Source");
    level waittill("StratPower");
    machines[0] playSound("perks_power_on");
    for (a = 0; a < tok.size; a++) {
        machines[a] setModel(tok[a] + "_on");
        machines[a] linkTo(master);
    }
    fortuneTrig thread perkOfFortuneSounds();
    tok = strTok("zombie_perk_bottle_revive|zombie_perk_bottle_sleight|pack|zombie_perk_bottle_jugg|zombie_perk_bottle_doubletap", "|");
    tokk = strTok("mx_revive_sting|mx_speed_sting|pack|mx_jugger_sting|mx_doubletap_sting", "|");
    Ptok = strTok("specialty_quickrevive|specialty_fastreload|pack|specialty_armorvest|specialty_rof", "|");
    perkIcon = strTok("specialty_quickrevive_zombies|specialty_fastreload_zombies|null|specialty_juggernaut_zombies|specialty_doubletap_zombies", "|");
    name = strTok("Quick Revive|Speed Cola|Pack 'a' Punch Upgrade|Jugger-Nog|Double-Tap", "|");
    cost = strTok("1500|3000|5000|2500|2500", "|");
    level.perkRange = 0;
    level.perkAngle = 0;
    level.perkAngleInt = 0;
    while (true) {
        fortuneTrig setHintString("Perk of Fortune is Spinning!");
        level spinPerkOfFortune(master, level.perkRange, level.perkAngle, level.perkAngleInt);
        if (level.perkRange == 2) {
            wait .5;
            fortuneTrig setHintString("Press &&1 To Buy " + name[level.perkRange] + " [Cost: " + cost[level.perkRange] + "]");
            level thread grabThePack(fortuneTrig, pos);
        } else {
            wait .5;
            fortuneTrig setHintString("Press &&1 To Buy " + name[level.perkRange] + " [Cost: " + cost[level.perkRange] + "]");
            level thread grabTheVenders(fortuneTrig, tok, tokk, Ptok, perkIcon, cost);
        }
        level waittill("VENDED");
        wait .05;
    }
}
perkOfFortuneCount(arg, arg2) {
    wait 45;
    level notify("VENDED");
    arg delete();
    arg2 delete();
}
perkOfFortuneSounds() {
    while (true) {
        tok = strTok("mx_packa_jingle|mx_jugger_jingle|mx_speed_jingle|mx_doubletap_jingle|mx_revive_jingle", "|");
        randy = randomIntRange(0, 5);
        playSoundAtPosition(tok[randy], self.origin);
        wait 45;
    }
}
grabTheVenders(trig, tok, tokk, Ptok, perkIcon, cost) {
    level thread perkOfFortuneCount();
    level endon("VENDED");
    while (true) {
        trig waittill("trigger", me);
        if (me usebuttonPressed() && !me hasPerk(Ptok[level.perkRange]) && !me.is_zombie) {
            if (me.score >= int(cost[level.perkRange])) {
                me.score -= int(cost[level.perkRange]);
                me thread giveFortunePerks(tok[level.perkRange], tokk[level.perkRange], Ptok[level.perkRange], perkIcon[level.perkRange]);
                wait 1;
            } else me noMoneySound();
        }
    }
}
giveFortunePerks(tok, tokk, Ptok, icon, col) {
    self setPerk(Ptok);
    if (!isDefined(self.perk_hudCount)) self.perk_hudCount = 0;
    weap = self getCurrentWeapon();
    playSoundAtPosition("bottle_dispense3d", self.origin);
    self disableOffhandWeapons();
    self disableWeaponCycling();
    self playSound(tokk);
    self giveWeapon(tok);
    self switchToWeapon(tok);
    self waittill_any("fake_death", "death", "player_downed", "weapon_change_complete");
    self takeWeapon(tok);
    self.perk_hud[Ptok] = self createRectangle("BOTTOMLEFT", "BOTTOMLEFT", self.campaignHud["bg"].x + self.perk_hudCount * 30, self.campaignHud["bg"].y - 62, 1, 1, col, icon, 8, 1);
    self.perk_hud[Ptok] scaleOverTime(.3, 24, 24);
    self thread menuPerk_think(Ptok);
    self enableOffhandWeapons();
    self enableWeaponCycling();
    self giveWeapon(weap);
    self switchToWeapon(weap);
    if (Ptok == "specialty_armorvest") {
        self.maxhealth = level.zombie_vars["zombie_perk_juggernaut_health"];
        self.health = self.maxhealth;
    }
    self.perk_hudCount++;
}
grabThePack(trig, pos) {
    pack = spawnStruct();
    pack = spawnSM(pos + (sin(180) * 139, 0, cos(180) * 139), "script_origin", (0, 180, 0));
    pack.trig = spawn("trigger_radius", (300, -2940, 145), 1, 50, 50);
    pack.rollers = spawn("script_origin", pack.origin);
    pack.timer = spawn("script_origin", pack.origin);
    pack.rollers playLoopSound("packa_rollers_loop");
    level thread perkOfFortuneCount(pack.rollers, pack.timer);
    level endon("VENDED");
    while (true) {
        wait .05;
        while (true) {
            pack.trig waittill("trigger", user);
            if (user useButtonPressed() && !user.is_zombie) {
                currentWeapon = user getCurrentWeapon();
                if (!isDefined(level.zombie_include_weapons[currentWeapon]) || !isDefined(level.zombie_include_weapons[currentWeapon + "_upgraded"])) {
                    wait .1;
                    continue;
                }
                if (user.score < 5000) {
                    pack playSound("deny");
                    user noMoneySound();
                    wait .1;
                    continue;
                } else break;
            }
        }
        user.score -= 5000;
        pack playSound("bottle_dispense3d");
        user playSound("plr_" + user getEntityNumber() + "_vox_perk_packa_wait_" + randomInt(5));
        trig setHintString("");
        user thread nuckleCrack();
        weaponModel = user thirdPersonWeaponUpgrade(currentWeapon, pack.origin + (0, -1, 34), (0, 270, 0), pack, true);
        trig setHintString("Press &&1 To Take Your Upgraded Weapon");
        pack thread waitForPlayerToTake(user, currentWeapon, pack.timer);
        pack thread waitForTimeout(pack.timer);
        pack waittill_either("pap_timeout", "pap_taken");
        trig setHintString("");
        weaponModel delete();
        wait 1;
        trig setHintString("Press &&1 To Buy Pack 'a' Punch Upgrade [Cost: 5000]");
    }
}
spinPerkOfFortune(tag, arg, int, str) {
    speed = .5;
    count = 0;
    num = 0;
    sec = str + 360;
    perk = randomIntRange(0, 5);
    SPINS = 12;
    while (true) {
        for (a = str; a <= sec + num; a += speed) {
            if (count == SPINS) speed -= ((176.15) / (360 + num));
            tag rotateTo((a, 0, 0), .35);
            if (count == 0) speed += .5;
            wait .01;
        }
        if (count == SPINS) {
            tag rotateTo((perk * 72 + 36, 0, 0), .4);
            break;
        }
        count++;
        if (count == SPINS) num = (int + perk * 72 + 36);
        wait .01;
    }
    level.PerkAngle = (perk - 4) * -72 + 36;
    level.perkRange = perk;
    level.perkAngleInt = (perk * 72 + 36);
}
rainFire() {
    self endon("disconnect");
    link = spawn("script_model", self.origin);
    link setModel("tag_origin");
    link.angles = (-90, 0, 0);
    for (i = 0; i < 30; i++) playFxOnTag(level._effect["mp_ash_and_embers"], link, "tag_origin");
    while (true) {
        link.origin = self.origin;
        wait .1;
    }
}
watchForOracle(input) {
    self endon("disconnect");
    playableArea = getEntArray("playable_area", "targetname");
    level waittill("StratPower");
    while (true) {
        if (self.kills >= (input - (input / 3)) && !isDefined(level.oracalTalk)) self oracalTalk();
        if (self.kills >= input) {
            zom = getAIArray("axis");
            if (zom.size == 0) {
                while (true) {
                    zom = getAIArray("axis");
                    if (zom.size > 0) break;
                    wait .05;
                }
            }
            zom = getAIArray("axis");
            chosenZombie = zom[0];
            chosenZombie thread dropOracle(playableArea, self, input);
            break;
        }
        wait .5;
    }
}
dropOracle(play, me, input) {
    self waittill("death");
    if (!self inMap()) {
        me thread watchForOracle(input);
        return;
    }
    oracle = [];
    oracle[0] = spawnSM(self.origin + (0, 0, 45), "lights_lantern_vactube", (0, 0, 0), 1);
    oracle[1] = spawnSM(self.origin + (0, 0, 45), "lights_lantern_vactube", (0, 0, -180), 1);
    oracle[1] linkTo(oracle[0]);
    playFxOnTag(level._effect["powerup_on"], oracle[0], "tag_origin");
    oracle[0] thread powerup_wobble();
    trig = spawnTrigger(self.origin, 35);
    trig setString("Press [{+activate}] To Retrieve Oracle");
    while (true) {
        trig waittill("trigger", who);
        if (who useButtonPressed() && !who.is_zombie && !isDefined(who.revivetrigger)) break;
    }
    for (a = 0; a < 2; a++) oracle[a] delete();
    trig delete();
    deleteBoards();
    array_thread(getPlayers(), ::setObjectiveLog, "Listen To Admiral Bog");
    array_thread(getPlayers(), ::stratDia, 0, "TOP", "Admiral Bog: YOU FOUND THE ORACLE! Okay plans have changed! You need to find a hot place for it", 5);
    wait 5;
    array_thread(getPlayers(), ::stratDia, 0, "TOP", "Admiral Bog: Find a place hot like a furnice and place the Oracle there! You must hurry though!", 5);
    wait 5;
    board = spawnSM((-607, -1257, 84), "static_peleliu_palette");
    array_thread(getPlayers(), ::setObjectiveLog, "Place The Oracle In A Furnice");
    getPlayers()[0] thread buildPlane((290, -4600, 850), true);
    num = level.runTime - 5;
    array_thread(getPlayers(), ::stratDia, 0, "TOP", "Admiral Bog: Once the Oracle is placed You will only have " + num + " seconds to get out or else!", 5);
    wait 5;
    array_thread(getPlayers(), ::stratDia, 0, "TOP", "Admiral Bog: Remember, I will be waiting for you by General Blunts, PLEASE HURRY!", 5, true);
    wait 5;
    trig = spawnTrigger((-557, -1256, 72), 40);
    trig setString("All Players Required -- Press [{+activate}] To Place The Oracle");
    while (true) {
        trig waittill("trigger", who);
        if (who useButtonPressed() && !who.is_zombie) {
            level.oracalNuke = true;
            for (a = 0; a < getPlayers().size; a++)
                if (distance(getPlayers()[a].origin, trig.origin) > 250 && isAlive(getPlayers()[a])) level.oracalNuke = undefined;
            if (isDefined(level.oracalNuke)) {
                playSoundAtPosition("warning", who.origin);
                break;
            }
        }
    }
    array_thread(getPlayers(), ::setObjectiveLog, "Get To The Rescue Vehicle");
    oracle[0] = spawnSM(board.origin + (-15, 0, 15), "lights_lantern_vactube", (0, 0, 90));
    oracle[1] = spawnSM(board.origin + (-15, 0, 15), "lights_lantern_vactube", (0, 0, -90));
    trig delete();
    level notify("OraclePlaced");
    block = spawnSM((529.5, -2219.5, 293), "static_peleliu_corrugated_metal1", (90, 90, 0));
    array_thread(getPlayers(), ::checkForRescue);
    array_thread(getPlayers(), ::oracalNuke);
    level thread leaveMap();
}
checkForRescue() {
    level endon("EXTINCTION");
    while (true) {
        if (!isDefined(self.extinctionRescued) && self.origin[1] >= -2301 && self.origin[2] >= 280 && self.origin[1] <= -2015) {
            self.extinctionRescued = true;
            self thread doNoTarget(true);
            self allowJump(false);
        }
        if (isDefined(self.extinctionRescued) && (self.origin[1] < -2301 || self.origin[1] > -2005 || self.origin[2] < 274)) {
            self.extinctionRescued = undefined;
            self thread doNoTarget(false);
            self allowJump(true);
        }
        wait .05;
    }
}
oracalTalk() {
    if (isDefined(level.oracalTalk)) return;
    level.oracalTalk = true;
    array_thread(getPlayers(), ::stratDia, 0, "TOP", "Admiral Bog: I cant believe it, you actually might save us all!", 5);
    wait 5;
    array_thread(getPlayers(), ::stratDia, 0, "TOP", "Admiral Bog: My reader is telling me that the Oracle is near, you can finally finish this", 5, true);
    wait 5;
}
oracalNuke() {
    bgTop = self createRectangle("CENTER", "CENTER", -250, -201, 76, 12, (0, 0, 0), "white", 1, 1);
    bgBot = self createRectangle("CENTER", "CENTER", -250, -159, 76, 12, (0, 0, 0), "white", 1, 1);
    topTxt = self createText(getFont(), 1, "CENTER", "CENTER", -250, -201, 2, 1, "Oracle Nuke");
    botTxt = self createText(getFont(), 1, "CENTER", "CENTER", -250, -159, 2, 1, "");
    botTxt thread doCountdownx(level.runTime, true);
    color[0] = (1, (188 / 255), (33 / 255));
    color[1] = (0, 0, 0);
    col = color[0];
    while (!isDefined(level.nukeXplosion)) {
        hud = self createRectangle("CENTER", "CENTER", -287.5, -180, 1, 30, col, "white", 1, 1);
        hud scaleOverTime(.5, 15, 30);
        hud moveOverTime(.5);
        hud.x += 7.5;
        wait .5;
        hud thread doNukeMovement();
        if (col == color[0]) col = color[1];
        else col = color[0];
    }
    wait 1;
    if (!isDefined(self.extinctionRescued)) self thread deathWithGodMode(undefined, undefined, 100, "MOD_MELEE", undefined, self.origin);
    wait 1.5;
    topTxt thread hudFadenDestroy(0, .4);
    botTxt hudFadenDestroy(0, .4);
    bgTop thread hudMoveY(-180, .4);
    bgBot hudMoveY(-180, .4);
    bgTop destroy();
    bgBot scaleOverTime(.4, 1, 1);
    wait .4;
    bgBot destroy();
}
deathWithGodMode(eInflictor, eAttacker, iDamage, sMeansOfDeath, sWeapon, vDir) {
    if (iDamage < self.health) {
        if (isDefined(eAttacker)) eAttacker.sound_damage_player = self;
        return;
    }
    if (level.intermission) level waittill("forever");
    self.intermission = true;
    self thread maps\_laststand::PlayerLastStand(eInflictor, eAttacker, iDamage, sMeansOfDeath, sWeapon, vDir);
    self player_fake_death();
    self theGameIsOv();
}
player_fake_death() {
    level notify("fake_death");
    self notify("fake_death");
    self notify("death");
    self takeAllGuns();
    self allowStand(false);
    self allowCrouch(false);
    self allowProne(true);
    self.ignoreme = true;
    self enableInvulnerability();
    wait 1;
    self freezeControls(true);
}
theGameIsOv(now) {
    level.intermission = true;
    game_over = self createText(undefined, 3, "CENTER", "CENTER", 0, -10, 100, 0, &"ZOMBIE_GAME_OVER");
    game_over fadeOverTime(1);
    game_over.alpha = 1;
    survived = self createText(undefined, 2, "CENTER", "CENTER", 0, 20, 100, 0, "");
    if (level.round_number < 2) survived setText( &"ZOMBIE_SURVIVED_ROUND");
    else survived setText( &"ZOMBIE_SURVIVED_ROUNDS", level.round_number);
    self playlocalSound("mx_game_over") maps\_busing::setBusState("default");
    survived fadeOverTime(1);
    survived.alpha = 1;
    wait 3;
    my_InterM();
    wait(level.zombie_vars["zombie_intermission_time"]);
    level notify("stop_intermission");
    array_thread(getPlayers(), ::player_exit_level);
    wait 1.5;
    if (!isDefined(now)) self quickRestart(true);
    else missionFailed();
    wait 667;
}
quickRestart(arg) {
    if (!isDefined(arg)) self openMenu("popup_restart_warning");
    else {
        self setClientDvar("sv_cheats", "1");
        array_thread(getPlayers(), ::_hideSeek_timeoutInit);
    }
}
changeMap(map) {
    changeLevel(map, false, 2);
}
player_exit_level() {
    self allowStand(true);
    self allowCrouch(false);
    self allowProne(false);
    if (isDefined(self.game_over_bg)) {
        self.game_over_bg.foreground = true;
        self.game_over_bg.sort = 100;
        self.game_over_bg FadeOverTime(1);
        self.game_over_bg.alpha = 1;
    }
}
my_InterM() {
    level.intermission = true;
    level notify("intermission");
    players = getPlayers();
    for (i = 0; i < players.size; i++) {
        setclientsysstate("levelNotify", "zi", players[i]);
        players[i] setClientDvars("cg_thirdPerson", "0", "cg_fov", "65");
        players[i].health = 100;
        players[i] thread player_intermission();
    }
    wait 0.25;
    players = getPlayers();
    for (i = 0; i < players.size; i++) setClientSysState("lsm", "1", players[i]);
    visionset = "zombie";
    if (isDefined(level.zombie_vars["intermission_visionset"])) visionset = level.zombie_vars["intermission_visionset"];
    level thread set_all_players_visionset(visionset, 2);
}
player_intermission() {
    self closeInGameMenu();
    level endon("stop_intermission");
    self.score = self.score_total;
    self.sessionstate = "intermission";
    self.spectatorclient = -1;
    self.killcamentity = -1;
    self.archivetime = 0;
    self.psoffsettime = 0;
    self.friendlydamage = undefined;
    points = getStructArray("intermission", "targetname");
    if (!isDefined(points) || points.size == 0) {
        points = getEntArray("info_intermission", "classname");
        if (points.size < 1) return;
    }
    self.game_over_bg = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "black", 100, 1);
    org = undefined;
    while (true) {
        points = array_randomize(points);
        for (i = 0; i < points.size; i++) {
            point = points[i];
            if (!isDefined(org)) self spawn(point.origin, point.angles);
            if (isDefined(points[i].target)) {
                if (!isDefined(org)) org = spawn("script_origin", self.origin + (0, 0, -60));
                self linkTo(org, "", (0, 0, -60), (0, 0, 0));
                self setPlayerAngles(points[i].angles);
                org.origin = points[i].origin;
                speed = 20;
                if (isDefined(points[i].speed)) speed = points[i].speed;
                target_point = getstruct(points[i].target, "targetname");
                dist = distance(points[i].origin, target_point.origin);
                time = dist / speed;
                q_time = time * 0.25;
                if (q_time > 1) q_time = 1;
                self.game_over_bg fadeOverTime(q_time);
                self.game_over_bg.alpha = 0;
                org moveTo(target_point.origin, time, q_time, q_time);
                wait(time - q_time);
                self.game_over_bg fadeOverTime(q_time);
                self.game_over_bg.alpha = 1;
                wait(q_time);
            } else {
                self.game_over_bg fadeOverTime(1);
                self.game_over_bg.alpha = 0;
                wait 5;
                self.game_over_bg fadeOverTime(1);
                self.game_over_bg.alpha = 1;
                wait 1;
            }
        }
    }
}
leaveMap() {
    wait level.runTime - 5;
    level notify("BRIDGE");
    wait .05;
    level notify("EXTINCTION");
}
newBank() {
    door = [];
    for (a = 0; a < 2; a++)
        for (b = 0; b < 2; b++) door[door.size] = spawnSM((1125 + b * 50, 342, 110 + a * 96), "static_peleliu_corrugated_metal4");
    for (a = 1; a < 4; a++) door[a] linkTo(door[0]);
    Wwall = spawnSM((990.634, 341.512, 132.863), "static_peleliu_corrugated_metal4");
    window = [];
    for (a = 0; a < 2; a++)
        for (b = 0; b < 4; b++) wall = spawnSM((1115 + b * 96, 920, 237 + a * 96), "static_peleliu_corrugated_metal4");
    for (b = 0; b < 2; b++)
        for (a = 0; a < 4; a++) desk = spawnSM((896 + a * 72 + b * 464, 950, 166), "static_berlin_metal_desk", (0, 180, 0));
    for (b = 0; b < 2; b++)
        for (a = 0; a < 2; a++) crate = spawnSM((962 + a * 59 + b * 548, 947.5, 168.125), "static_peleliu_crate01");
    for (a = 0; a < 2; a++)
        for (b = 0; b < 2; b++) window[window.size] = spawnSM((968 + b * 50 + a * 542, 933, 248), "static_peleliu_corrugated_metal4");
    window[1] linkTo(window[0]);
    window[3] linkTo(window[2]);
    money = spawnSM((1275, 922, 178), "zombie_x2_icon");
    playFx(level._effect["powerup_on"], money.origin);
    money thread rotateEntYaw(360, 4);
    level thread watchPlayerBank(window[0], window[2]);
    level waittill("StratPower");
    level thread watchAllApproaches(door[0]);
}
watchAllApproaches(one) {
    save = one.origin;
    while (true) {
        level.bankOpen = undefined;
        zoms = getAISpeciesArray("axis", "all");
        for (a = 0; a < zoms.size; a++)
            if (distance2d(zoms[a].origin, save) < 190) level.bankOpen = true;
        for (a = 0; a < getPlayers().size; a++)
            if (distance2d(getPlayers()[a].origin, save) < 190) level.bankOpen = true;
        if (isDefined(level.bankOpen)) {
            if (!isDefined(level.bankClose)) one moveTo(save + (131, 0, 0), .3);
            level.bankClose = true;
        } else {
            if (isDefined(level.bankClose)) one moveTo(save, .3);
            level.bankClose = undefined;
        }
        wait 0.05;
    }
}
#using_animtree("generic_human");
generalBill() {
    num = [];
    for (a = 0; a < 3; a++) {
        num[a] = randomIntRange(1, 11);
        level.clock["numbers"][a] = num[a];
    }
    bill = spawnSM((43, -2493, 272), "char_ger_honorgd_bodyz1_1", (0, 45, 0));
    bill attach("char_jap_impinf_officer_head", "", true);
    bill attach("char_ger_waffen_officercap1_zomb", "", true);
    bill useAnimTree(#animtree);
    bill setAnim( % casual_crouch_idle);
    bill attach(getWeaponModel("zombie_thompson"), "tag_weapon_right");
    level thread billRoom(bill);
    trig = spawnTrigger((120, -2410, 278), 40);
    trig setString("Press [{+activate}] To Talk");
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie) {
            trig setString("");
            array_thread(getPlayers(), ::setObjectiveLog, "Retrieve The Key From Blunts");
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: Ahhh, who are you!", 3);
            wait 3;
            bill clearAnim( % casual_crouch_idle, 0);
            bill setAnim( % crouch_aim_straight, 1, 0.2, 1);
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: Speak or i'll Shoot!", 3, true);
            wait 3;
            break;
        }
    }
    trig setString("Press [{+activate}] To Talk");
    wait 1;
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie) {
            trig setString("");
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: Ohh, Admiral Bog sent you here, he probably thought I was dead!", 4);
            wait 4;
            bill clearAnim( % crouch_aim_straight, 0);
            bill setAnim( % casual_stand_v2_idle, 1, 0.2, 1);
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: Well what do you want from me!", 3, true);
            wait 3;
            break;
        }
    }
    trig setString("Press [{+activate}] To Talk");
    wait 1;
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie) {
            trig setString("");
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: I will give you the key but I need you to do something for me!", 5);
            wait 5;
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: I have been bitten and I can feel myself changing into one of those....things!", 5);
            wait 5;
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: I need you to find me a cure, please hurry though, I dont have much time, aghhhhh!", 5);
            wait 5;
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: Everything you need to make it should be in the 'Animal Test Laboratory', agghhh Hurry!", 5, true);
            wait 5;
            trig setString("Come Back When You Have The Medicine");
            array_thread(getPlayers(), ::setObjectiveLog, "Make A Cure For General Blunts");
            level thread startIngredients();
            level waittill("CURE_MADE");
            array_thread(getPlayers(), ::setObjectiveLog, "Take The Cure To General Blunts");
            break;
        }
    }
    trig setString("Press [{+activate}] To Give Cure");
    wait 1;
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie && isDefined(who.hasCure)) {
            level notify("CURE_GIVEN");
            who.hasCure = undefined;
            trig setString("");
            array_thread(getPlayers(), ::setObjectiveLog, "Take Power Key From Blunts");
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: Aghhhhhh, I feel it working already, thank you!", 3);
            wait 3;
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: Okay here is the key you asked for, but beware once the power is on there is no stopping them!", 5, true);
            wait 5;
            break;
        }
    }
    trig setString("Press [{+activate}] To Take Power Room Key");
    wait 1;
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie) {
            level.GeneralKey = true;
            trig setString("");
            array_thread(getPlayers(), ::setObjectiveLog, "Turn On The Power");
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: Okay I warned you", 3);
            wait 3;
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: Head back here once the power is on", 4, true);
            wait 4;
            break;
        }
    }
    trig setString("Come Back Once The Power Is On");
    level waittill("StratPower");
    trig setString("Press [{+activate}] To Talk");
    wait 1;
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie) {
            trig setString("");
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: Now that the power is on I can tell you that this place holds great secrets", 5);
            wait 5;
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: All you need to know is the code to unlock those secrets", 5);
            wait 5;
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: Since you saved my life I will give you the code...I think it was " + num[0] + "." + num[1] + "." + num[2], 5);
            wait 5;
            array_thread(getPlayers(), ::stratDia, 0, "TOP", "General Blunts: You will die if you dont figure out what to do with the code, so you need to find out where it goes", 6, true);
            wait 6;
            break;
        }
    }
    trig delete();
}
billRoom(bill) {
    stuff = [];
    stuff[0] = spawnSM((47, -2458, 302), "static_berlin_ger_radio", (0, 315, 0));
    stuff[1] = spawnSM((74, -2481, 302), "zombie_handheld_radio", (0, 315, 0));
    stuff[2] = spawnSM((84, -2493, 272), "lights_lantern_vactube", (0, 315, 0));
    stuff[3] = spawnSM((60, -2460, 272), "static_peleliu_crate01", (0, 315, 0));
    for (a = 0; a < 2; a++) stuff[stuff.size] = spawnSM((106, -2397 - a * 35, 272), "static_berlin_sandbags_lego_end", (0, a * 180, 0));
    stuff[stuff.size] = spawnSM((106, -2415, 285), "static_peleliu_barbedwire");
    level waittill("OraclePlaced");
    for (a = 0; a < stuff.size; a++) stuff[a] delete();
    bill.origin = level.GeneralBog.origin - (-60, 190, 0);
    bill.angles = (0, -111, 0);
    bill linkTo(level.GeneralBog);
    level notify("MOVEPLANE");
    players = getPlayers();
    pass = false;
    while (true) {
        for (a = 0; a < players.size; a++) {
            if (players[a].origin[1] <= -2350) {
                pass = true;
                break;
            }
        }
        if (pass == true) break;
        wait .05;
    }
    trap = getEntArray("bridge_electric_trap", "targetname");
    for (a = 0; a < trap.size; a++) trap[a] delete();
    coils = getEntArray("wnuen_bridge_coils", "targetname");
    for (a = 0; a < coils.size; a++) coils[a] delete();
    coil = getEntArray("warehouse_bridge_coils", "targetname");
    for (a = 0; a < coil.size; a++) coil[a] delete();
    bridge = getEnt("warehouse_bridge", "targetname");
    bridge hide();
    bridge2 = getEnt("wnuen_bridge", "targetname");
    bridge2 hide();
    bridge.angles = (6.5, 90, 0);
    bridge2.angles = (8.5, 90, 0);
    bridge.origin = level.GeneralBog.origin - (0, 98, 0);
    bridge2.origin = level.GeneralBog.origin - (0, 100, 0);
    bridge linkTo(level.GeneralBog);
    bridge2 linkTo(level.GeneralBog);
    level notify("BRIDGE");
}
startIngredients() {
    level thread ingrediantTable();
    org = (681.5, -852.9, 89.2);
    beaker = spawnSM(org, "zombie_beaker_med");
    level thread medicineTrigs(beaker.origin - (-25, 0, 10), "381ml of Perchloric Acid", beaker);
    org = (651, -600, 101.387);
    brain = spawnSM(org, "zombie_brain");
    level thread medicineTrigs(brain.origin - (-15, 0, 10), "381mg of a Hydrobicarbonate Isotope", brain);
    org = (1231.8, 256.3, 103.784);
    jel = spawnSM(org, "zombie_beaker_brain");
    level thread medicineTrigs(jel.origin - (20, 0, 10), "381L of Plasmic Trichloric Jel", jel);
}
medicineTrigs(org, id, ent) {
    level endon(id);
    trig = spawnTrigger(org, 40);
    trig setString("Press [{+activate}] to grab Ingredient");
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie && !isDefined(who.hasIngredient) && !isDefined(who.hasMagicPart)) {
            ent hide();
            trig delete();
            med = who createText(self getFont(), 1.25, "BOTTOM", "BOTTOM", 0, 0, 1, 1, "Ingredient: " + id);
            who.hasIngredient = id;
            who thread watchMeds(org, id, ent, med);
            who waittill("Ingredient_Added");
            ent delete();
            med hudFadenDestroy(0, .3);
            break;
            wait .05;
        }
    }
}
watchMeds(org, id, ent, med) {
    level endon("CURE_GIVEN");
    self endon("Ingredient_Added");
    self waittill_any("death", "disconnect");
    level notify(id);
    ent show();
    med destroy();
    self.hasIngredient = undefined;
    level thread medicineTrigs(org, id, ent);
}
watchCure(med, trig, cure) {
    level endon("CURE_GIVEN");
    self waittill_any("death", "disconnect");
    med show();
    cure destroy();
    self.hasCure = undefined;
    self.hasIngredient = undefined;
    trig setString("Press [{+activate}] for Cure");
    level.resetCure = true;
    level notify("CURE_GIVEN");
}
ingrediantTable() {
    med = spawnSM((951.687, -897.89, 100.125), "zombie_beaker_med");
    trig = spawnTrigger((950, -875, 95), 45);
    count = 0;
    while (true) {
        trig waittill("trigger", who);
        if (!isDefined(who.hasIngredient)) trig setString("Ingredients Required");
        else trig setString("Press [{+activate}] to add Ingredient");
        if (who usebuttonPressed() && !who.is_zombie && isDefined(who.hasIngredient)) {
            trig setString("Adding Ingredient...");
            if (count < 2) who thread createProgressBar(1.75, "Adding Ingredient");
            else who thread createProgressBar(1.75, "Mixing Ingredients", 1, "Cure Made");
            who thread magicNuckleCrack("syrette");
            wait 1.7;
            trig setString("Ingredient Added");
            who notify("Ingredient_Added");
            who.hasIngredient = undefined;
            if (count >= 2) break;
            count++;
            wait 2;
        }
    }
    wait 1;
    array_thread(getPlayers(), ::setObjectiveLog, "Grab The Cure");
    while (true) {
        trig waittill("trigger", who);
        trig setString("Press [{+activate}] for Cure");
        if (who usebuttonPressed() && !who.is_zombie && !isDefined(who.hasMagicPart)) {
            trig setString("");
            who.hasIngredient = true;
            who.hasCure = true;
            med hide();
            cure = who createText(self getFont(), 1.25, "BOTTOM", "BOTTOM", 0, 0, 1, 1, "You Have The Cure");
            level notify("CURE_MADE");
            who thread watchCure(med, trig, cure);
            level waittill("CURE_GIVEN");
            if (isDefined(level.resetCure)) {
                level.resetCure = undefined;
                continue;
            }
            who.hasIngredient = undefined;
            trig delete();
            med delete();
            cure destroy();
            break;
        }
    }
}
watchPlayerBank(one, two) {
    save = one.origin;
    save2 = two.origin;
    while (true) {
        level.bankWindow = undefined;
        level.bankWindow2 = undefined;
        for (a = 0; a < getPlayers().size; a++)
            if (distance2d(getPlayers()[a].origin, save) < 200) level.bankWindow = true;
        for (a = 0; a < getPlayers().size; a++)
            if (distance2d(getPlayers()[a].origin, save2) < 200) level.bankWindow2 = true;
        if (isDefined(level.bankWindow)) {
            if (!isDefined(level.bankWin)) one moveTo(save + (0, 0, 45), .3);
            level.bankWin = true;
        } else {
            if (isDefined(level.bankWin)) one moveTo(save, .3);
            level.bankWin = undefined;
        }
        if (isDefined(level.bankWindow2)) {
            if (!isDefined(level.bankWin2)) two moveTo(save2 + (0, 0, 45), .3);
            level.bankWin2 = true;
        } else {
            if (isDefined(level.bankWin2)) two moveTo(save2, .3);
            level.bankWin2 = undefined;
        }
        wait 0.05;
    }
}
zombieDifficulty(input) {
    level waittill("StratPower");
    level.zombie_vars["zombie_max_ai"] = 50;
    level.zombie_vars["zombie_spawn_delay"] = level.zDelay;
    level.zombie_vars["zombie_ai_per_player"] = 25;
    level.zombie_vars["zombie_powerup_drop_increment"] = 3500;
    level.zombie_vars["zombie_powerup_drop_max_per_round"] = 15;
    while (true) {
        zom = getAISpeciesArray("axis", "all");
        for (a = 0; a < zom.size; a++)
            if (!isDefined(zom[a].healthFix)) zom[a] thread zombieHealth(input);
        wait .1;
    }
}
zombieHealth(input) {
    self.healthFix = true;
    self.health = input / 2;
    self waittill("death");
    self.healthFix = undefined;
}
buildPlane(org, arg) {
    plane = [];
    door = [];
    seat = [];
    tag = spawnSM(org, "tag_origin");
    for (a = 0; a < 2; a++)
        for (b = 0; b < 2; b++)
            for (c = 0; c < 3; c++) plane[plane.size] = spawnSM(org + (b * -96, c * 96 - 40 * a, -2 + a * 88), "static_peleliu_corrugated_metal4", (0, 0, 90));
    for (a = 0; a < 2; a++) plane[plane.size] = spawnSM(org + (a * -96, 248, 86), "static_peleliu_corrugated_metal4", (0, 0, 90));
    for (a = 0; a < 2; a++)
        for (b = 1; b < 7; b++) plane[plane.size] = spawnSM(org + (35 - a * 164, 241.5 - b * 44, 14), "static_seelow_blackbarrel", (0, 0, 90));
    for (a = 0; a < 8; a++) plane[plane.size] = spawnSM(org + (-144 + a * 24, -46, 42), "zombie_treasure_box_lid", (90, 0, 90));
    for (a = 0; a < 2; a++)
        for (b = 0; b < 2; b++)
            for (c = 0; c < 6; c++) plane[plane.size] = spawnSM(org + (45 - a * 192, 265 - c * 57, 15 + b * 59), "static_peleliu_palette", (90, 0, 0));
    if (!isDefined(arg))
        for (a = 0; a < 2; a++) door[door.size] = spawnSM(org + (a * -96, 261, 41), "static_peleliu_corrugated_metal4", (0, 0, -28));
    level.GeneralBog = spawnSM(org + (-48, -14, 0), "char_ger_honorgd_bodyz1_1", (0, 90, 0));
    level.GeneralBog attach("char_ger_ansel_head_zomb", "", true);
    level.GeneralBog attach("char_ger_waffen_officercap1_zomb", "", true);
    level.GeneralBog useAnimTree(#animtree);
    level.GeneralBog setAnim( % casual_crouch_idle);
    level.GeneralBog attach(getWeaponModel("tesla_gun_upgraded"), "tag_weapon_right");
    for (a = 0; a < 2; a++)
        for (b = 0; b < 2; b++) seat[seat.size] = spawnSM(org + (26 - a * 156, 45 + b * 65, 18.5), "tag_origin", (0, 180 * (a + 1), 0));
    level.GeneralBog linkTo(tag);
    for (a = 0; a < door.size; a++) door[a] linkTo(tag);
    for (a = 0; a < plane.size; a++) plane[a] linkTo(tag);
    for (a = 0; a < seat.size; a++) seat[a] linkTo(tag);
    if (isDefined(arg)) {
        tag rotateTo(tag.angles + (0, 180, 0), 1, .5, .5);
        tag waittill("rotatedone");
        level waittill("MOVEPLANE");
        tag moveTo((290, -2038, 1900), 5, 2.5, 2.5);
        tag waittill("movedone");
        tag moveTo((290, -2038, 290), 4, 2, 2);
        level waittill("BRIDGE");
        tag thread initRolling();
        level waittill("EXTINCTION");
        tag rotateTo((0, 180, 0), .25, .15, .15);
        temp = [];
        for (a = 0; a < getPlayers().size; a++) {
            if (isDefined(getPlayers()[a].extinctionRescued)) {
                temp[temp.size] = spawnSM(getPlayers()[a].origin, "tag_origin");
                getPlayers()[a] linkTo(temp[temp.size - 1]);
                temp[temp.size - 1] linkTo(tag);
                getPlayers()[a] thread waitForComplete();
            }
        }
        tag thread moveToAngles();
        tag rotateTo(tag.angles - (0, 0, 45), 2, 1, 1);
        wait 2;
        tag rotateTo(tag.angles + (0, 0, 45), 2, 1, 1);
        wait 2;
        tag thread initRolling();
        level waittill("ExtinctBlind");
        for (a = 0; a < plane.size; a++) plane[a] delete();
        for (a = 0; a < seat.size; a++) seat[a] delete();
        level.GeneralBog delete();
        tag delete();
        return;
    }
    if (isSolo()) wait .05;
    level notify("plane_build");
    for (a = 0; a < getPlayers().size; a++) {
        num = 1;
        if (a == 2 || a == 3) num = 0;
        getPlayers()[a] allowProne(false);
        getPlayers()[a] allowStand(false);
        getPlayers()[a] allowSprint(false);
        getPlayers()[a] setPlayerAngles((0, 180 * num, 0));
        getPlayers()[a] playerLinkTo(seat[a]);
    }
    tag thread initRolling();
    level waittill("HUD");
    tag moveTo(tag.origin - (0, 13150, 0), 41);
    array_thread(getPlayers(), ::stratDia, -2, "BOTTOM", "Admiral Bog: Your mission is to find and retrieve the Oracle", 5);
    wait 3.5;
    getPlayers()[0] playSound("plr_0_vox_gen_sigh_5");
    wait .85;
    getPlayers()[0] playSound("plr_0_vox_gen_meteor_0");
    wait .65;
    array_thread(getPlayers(), ::stratDia, -2, "BOTTOM", "Admiral Bog: You're our last hope for surviving this Extinction", 5);
    wait 5;
    array_thread(getPlayers(), ::stratDia, -2, "BOTTOM", "Admiral Bog: If you fail to retrieve the Oracle then all hope is lost", 5);
    wait 5;
    getPlayers()[0] playSound("plr_0_vox_perk_packa_wait_4");
    array_thread(getPlayers(), ::stratDia, -2, "BOTTOM", "Admiral Bog: Remember your training and survive as long as you can", 5);
    wait 5;
    array_thread(getPlayers(), ::stratDia, -2, "BOTTOM", "Admiral Bog: God speed my friends", 5);
    wait 5;
    for (a = 0; a < door.size; a++) {
        door[a] unlink();
        door[a] thread physicalPlaneDoor();
    }
    array_thread(getPlayers(), ::stratDia, -2, "BOTTOM", "Admiral Bog: ITS TIME! NOW.. GO GO GO!", 2.5, true);
    wait .05;
    earthQuake(.6, 5, tag.origin, 400);
    wait 1.5;
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a] thread planeFire(seat, a);
    wait 3;
    for (a = 0; a < door.size; a++) door[a] delete();
    wait 7;
    for (a = 0; a < plane.size; a++) plane[a] delete();
    for (a = 0; a < seat.size; a++) seat[a] delete();
    level.GeneralBog delete();
    tag delete();
}
waitForComplete() {
    wait 4;
    self notify("EXTINCTION_SUCCESS");
    wait 8;
    if (self == getPlayers()[0]) {
        getPlayers()[0] thread slowMotion();
        array_thread(getPlayers(), ::doEndingHud);
    }
}
slowMotion() {
    for (a = .9; a >= .3; a -= .1) {
        self setClientDvar("timescale", a);
        wait .1;
    }
}
doEndingHud() {
    for (a = 0; a < getPlayers().size; a++)
        if (!isDefined(getPlayers()[a].extinctionRescued)) level.extinctionDead = true;
    wait 2.5;
    hud = [];
    self setClientDvars("ammoCounterHide", 1, "ui_hud_hardcore", 1);
    hud[0] = self createRectangle("CENTER", "CENTER", 0, 0, 1000, 1000, (0, 0, 0), "white", 100, 0);
    hud[0] thread hudFade(1, .4);
    wait .5;
    self hide();
    self freezeControls(true);
    level notify("ExtinctBlind");
    hud[1] = self createText("objective", 3, "CENTER", "CENTER", 0, -130, 101, 0, "Thanks For Playing Extinction");
    hud[2] = self createText("objective", 2, "CENTER", "CENTER", 0, -80, 101, 0, "Congratulations To:");
    for (a = 0; a < getPlayers().size; a++) {
        if (isDefined(getPlayers()[a].extinctionRescued)) hud[hud.size] = self createText("objective", 1.75, "CENTER", "CENTER", 0, -50 + a * 30, 101, 0, "^2" + getPlayers()[a] getName());
    }
    hud[hud.size] = self createText("objective", 2, "CENTER", "CENTER", 0, hud[hud.size - 1].y + 30, 101, 0, "For Surviving The Extinction");
    if (isDefined(level.extinctionDead)) {
        hud[hud.size] = self createText("objective", 2, "CENTER", "CENTER", 0, hud[hud.size - 1].y + 50, 101, 0, "No Thanks To:");
        for (a = 0; a < getPlayers().size; a++) {
            num = hud[hud.size - 1].y;
            if (!isDefined(getPlayers()[a].extinctionRescued)) hud[hud.size] = self createText("objective", 1.75, "CENTER", "CENTER", 0, num + (a + 1) * 30, 101, 0, "^1" + getPlayers()[a] getName());
        }
        hud[hud.size] = self createText("objective", 2, "CENTER", "CENTER", 0, hud[hud.size - 1].y + 30, 101, 0, "For Dying");
    } else hud[hud.size] = self createText("objective", 3, "CENTER", "CENTER", 0, hud[hud.size - 1].y + 90, 101, 0, "Everyone Made It Out Alive");
    hud[1] thread hudFade(1, 1);
    wait 1.5;
    for (a = 2; a < hud.size; a++) {
        hud[a] thread hudFade(1, 1.5);
        wait 1;
    }
    if (self == getPlayers()[0]) self quickRestart(true);
}
moveToAngles() {
    while (true) {
        vec = anglesToRight(self.angles);
        end = (vec[0] * 33, vec[1] * 33, vec[2] * 33);
        self.origin = self.origin + end;
        wait .05;
    }
}
physicalPlaneDoor() {
    for (a = 0; a < 60; a++) {
        self physicsLaunch();
        wait .05;
    }
    self delete();
}
planeFire(seat, a) {
    self endon("disconnect");
    seat[a] unlink();
    for (b = 0; b < 20; b++) {
        seat[a] moveTo(seat[a].origin + (0, sin(55 + b * 4.5) * 500, cos(55 + b * 4.5) * 500 - 250), 0.5);
        wait .05;
    }
    wait .45;
    self playLocalSound("plr_" + self getEntityNumber() + "_vox_gen_pain_0");
    earthQuake(.5, 3, self.origin, 100);
    killZombiesWithinDistance(self.origin, 180, "headGib");
    playFx(level._effect["betty_explode"], self.origin);
    self shellShock("death", 4);
    self unlink();
    self setClientDvars("ui_hud_hardcore", 0);
    self enableWeapons();
    self setStance("stand");
    self allowProne(true);
    self allowStand(true);
    self allowSprint(true);
    self runRankMenu();
}
initRolling() {
    self rotatePitch(4, 2, 1, 1);
    wait 2;
    level endon("EXTINCTION");
    while (isDefined(self)) {
        self rotatePitch(-4, 2, 1, 0);
        wait 2;
        self rotatePitch(-4, 2, 0, 1);
        wait 2;
        self rotatePitch(4, 2, 1, 0);
        wait 2;
        self rotatePitch(4, 2, 0, 1);
        wait 2;
    }
}
magicParts() {
    org = [];
    trig = [];
    ang = [];
    org[0] = (584.5, -2858.8, 108.6);
    ang[0] = (0, 90, 0);
    trig[0] = (15, 0, 0);
    org[1] = (-3.8, -2448, 108.649);
    ang[1] = (0, 270, 0);
    trig[1] = (-15, 0, 0);
    org[2] = (-1198.43, -723.336, 248.769);
    ang[2] = (0, 0, 0);
    trig[2] = (0, -10, 30);
    ran = randomIntRange(0, org.size);
    box = spawnSM(org[ran], "zombie_treasure_box", ang[ran]);
    level thread magicPartTrigs(box.origin - trig[ran], "Mystery Box", box);
    org = [];
    trig = [];
    ang = [];
    org[0] = (1564, 355, 118);
    ang[0] = (260, 0, 0);
    trig[0] = (-10, -40, 20);
    org[1] = (933, -571, 64);
    ang[1] = (0, 0, 0);
    trig[1] = (0, 8, 0);
    org[2] = (-1062.95, -1137.76, 241.578);
    ang[2] = (110, 90, 0);
    trig[2] = (12, 5, 15);
    ran = randomIntRange(0, org.size);
    lid = spawnSM(org[ran], "zombie_treasure_box_lid", ang[ran]);
    level thread magicPartTrigs(lid.origin - trig[ran], "Mystery Box Lid", lid);
    weaps = spawnSM((-1313, -460, 240), "tag_origin");
    array = [];
    gunArray = getArrayKeys(level.zombie_weapons);
    for (i = 0; i < gunArray.size; i++) array[array.size] = gunArray[i];
    array[array.size] = "zombie_bowie_flourish";
    level thread magicPartTrigs(weaps.origin - (0, 15, 30), "Random Weapons", weaps, array);
}
doChangingWeaps(array) {
    while (isDefined(self)) {
        self setModel(getWeaponModel(array[randomInt(array.size)]));
        wait 0.1;
    }
}
magicPartTrigs(org, id, ent, array) {
    level endon(id);
    trig = spawnTrigger(org, 40);
    trig setString("Press [{+activate}] to grab Part");
    if (id == "Random Weapons") ent thread doChangingWeaps(array);
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie && !isDefined(who.hasMagicPart) && !isDefined(who.hasIngredient)) {
            ent hide();
            trig delete();
            who.hasMagicPart = id;
            part = who createText(self getFont(), 1.25, "BOTTOM", "BOTTOM", 0, 0, 1, 1, "Part: " + id);
            who thread watchParts(org, id, ent, array, part);
            who waittill("Part_Added");
            ent delete();
            part hudFadenDestroy(0, .3);
            break;
        }
    }
}
watchParts(org, id, ent, array, part) {
    self endon("Part_Added");
    self waittill_any("death", "disconnect");
    level notify(id);
    self.hasMagicPart = undefined;
    ent show();
    part destroy();
    self thread magicPartTrigs(org, id, ent, array);
}
magicNuckleCrack(arg) {
    weap = self getCurrentWeapon();
    self giveWeapon(arg);
    self switchToWeapon(arg);
    self waittill("weapon_change_complete");
    self takeWeapon(arg);
    self giveWeapon(weap);
    self switchToWeapon(weap);
}
magicBox() {
    spawnLoc = (-90.5924, -371.541, 11.875);
    MagicBox[0] = spawnSM((-90.5924, -312.541, -34.875), "static_peleliu_filecabinet_metal", (0, 90, 0));
    MagicBox[2] = spawnSM((-102.5924, -371.541, 11.875), "zombie_treasure_box_lid", (160, 270, 0));
    MagicBox[4] = spawnSM((-90.5924, -409.718, 1.35), "static_peleliu_filecabinet_metal", (330, 90, 0));
    MagicBox[5] = spawnSM((-90.5924, -458.422, -3), "static_peleliu_filecabinet_metal", (0, 90, 0));
    MagicBox["trigger"] = spawn("trigger_radius", spawnLoc + (18, 0, 0), 1, 43, 43);
    MagicBox["trigger"] setCursorHint("HINT_NOICON");
    count = 0;
    while (true) {
        MagicBox["trigger"] waittill("trigger", who);
        if (!isDefined(who.hasMagicPart)) MagicBox["trigger"] setHintString("Parts Required");
        else MagicBox["trigger"] setHintString("Press &&1 to add Part");
        if (who usebuttonPressed() && !who.is_zombie && isDefined(who.hasMagicPart)) {
            MagicBox["trigger"] setHintString("Adding Part...");
            if (count < 2) who thread createProgressBar(2.5, "Building");
            else who thread createProgressBar(2.5, "Building", 1, "Built");
            who thread magicNuckleCrack("zombie_knuckle_crack");
            wait 2.45;
            if (who.hasMagicPart == "Mystery Box") MagicBox[1] = spawnSM((-90.5924, -371.541, 11.875), "zombie_treasure_box", (20, 90, 0));
            if (who.hasMagicPart == "Mystery Box Lid") MagicBox[3] = spawnSM((-101.5924, -365.541, 28), "zombie_treasure_box_lid", (340, 270, 0));
            MagicBox["trigger"] setHintString("Part Added");
            who notify("Part_Added");
            who.hasMagicPart = undefined;
            if (count >= 2) break;
            count++;
            wait 2;
        }
    }
    wait 1;
    playfx(level._effect["lght_marker"], spawnLoc - (0, 0, 10));
    playfx(level._effect["lght_marker_flare"], spawnLoc - (0, 0, 10));
    while (true) {
        MagicBox["trigger"] setHintString("Press &&1 for a Random weapon [Cost: 800]");
        who = undefined;
        while (true) {
            MagicBox["trigger"] waittill("trigger", who);
            if (who usebuttonPressed() && !who.is_zombie) {
                if (who.score < 800) {
                    who noMoneySound();
                    wait .1;
                    continue;
                } else break;
            }
        }
        who minus_to_player_score(800);
        if (who hasPerk("specialty_altmelee")) who.hasBowieWeap = true;
        who playsound("cha_ching");
        who playsound(level.zombie_sounds["open_chest"], spawnLoc);
        MagicBox[3] rotateRoll(100, .5, .25);
        who playsound(level.zombie_sounds["music_chest"], spawnLoc);
        MagicBox["trigger"] setHintString("");
        gun = level runMagicBox(spawnLoc + (0, 5, 0), who);
        wait .55;
        MagicBox["trigger"] setHintString("Press &&1 to trade weapons");
        who thread timedChest(gun, MagicBox["trigger"]);
        while (true) {
            MagicBox["trigger"] waittill("trigger", grab);
            if (grab useButtonPressed() && !grab.is_zombie && grab == who) {
                who playSound("cha_ching");
                if (gun.weapon == "zombie_bowie_flourish") who thread magicFixBowie();
                if (gun.weapon == "zombie_cymbal_monkey") who thread treasure_chest_give_weapon("zombie_cymbal_monkey");
                who giveWeapon(gun.weapon);
                primaries = who getWeaponsListPrimaries();
                if (isDefined(primaries) && primaries.size >= 3) who takeWeapon(who getCurrentWeapon());
                who switchToWeapon(gun.weapon);
                level notify("grab_weapon");
                break;
            } else if (grab == level) {
                level notify("grab_weapon");
                break;
            }
        }
        gun delete();
        gun.affect delete();
        who playsound(level.zombie_sounds["close_chest"], spawnLoc);
        MagicBox[3] rotateRoll(-100, .5, .25);
        MagicBox["trigger"] setHintString("");
        wait 2;
    }
}
timedChest(gun, trig) {
    level endon("grab_weapon");
    gun moveTo(gun.origin - (0, 0, 40), 12, (12 * .5));
    wait 12;
    trig notify("trigger", level);
}
magicFixBowie() {
    current = self getCurrentWeapon();
    self giveBowie();
    self giveWeapon(current);
    self.hasBowieWeap = true;
}
giveBetty(weap) {
    trigs = getEntArray("betty_purchase", "targetname");
    for (i = 0; i < trigs.size; i++) trigs[i] notify("trigger", self);
    self giveWeapon(weap);
    self switchToWeapon(weap);
    self.has_betties = true;
}
runMagicBox(location, who) {
    gun = spawnSM(location, "", (20, 90, 0));
    gun.affect = spawnSM(location + (5, 0, 5), "tag_origin", (90, 0, 0));
    playfxontag(level._effect["chest_light"], gun.affect, "tag_origin");
    array = [];
    gunArray = getArrayKeys(level.zombie_weapons);
    for (i = 0; i < gunArray.size; i++)
        if (!isSubStr(gunArray[i], "mine_bouncing_betty") && !isSubStr(gunArray[i], "_upgraded") && !who hasWeapon(gunArray[i]) && !isWeakWeapon(gunArray[i])) array[array.size] = gunArray[i];
    if (!isDefined(who.hasBowieWeap)) array[array.size + 1] = "zombie_bowie_flourish";
    gun moveTo(location + (0, sin(10) * 40, cos(10) * 40), 3, 2, .9);
    random = 0;
    for (a = 0; a < 70; a++) {
        if (a < 60) wait 0.03;
        else if (a < 40) wait 0.05;
        else if (a < 30) wait 0.07;
        else if (a < 20) wait 0.09;
        random = array[randomIntRange(0, array.size)];
        gun setModel(getWeaponModel(random));
        gun.weapon = random;
        if (random == "stielhandgranate") {
            gun setModel(getWeaponModel("fraggrenade"));
            gun.weapon = "fraggrenade";
        }
        if (random == "zombie_bowie_flourish" && !isDefined(who.hasBowieWeap)) {
            gun setModel("viewmodel_knife_bowie");
            gun.weapon = "zombie_bowie_flourish";
        }
    }
    return gun;
}
hoverWeapons(pos, weap, name, cost, wall, am, rank) {
    new = undefined;
    num = 90;
    amu = 5;
    start = 0;
    hint = spawnTrigger(pos - (0, am, 0), 40 - (am / 2));
    hint setString("Unlocked At Rank " + rank);
    if (rank == 0) hint setString("Press [{+activate}] to buy " + name + " [Cost: " + cost + "]");
    if (wall == "one") new = pos + (0, -13, 0);
    if (wall == "two") new = pos + (13, 0, 0);
    if (wall == "three") {
        new = pos + (0, 13, 0);
        start = 4;
        amu = 9;
    }
    if (wall == "CIRCLE") {
        amu = 8;
        new = pos;
    }
    tag = spawnSM(new + (0, 0, 50), "tag_origin", (270, 0, 0));
    for (a = start; a < amu; a++) base = spawnSM(pos + (sin(a * 45 + num) * 27, cos(a * 45 + num) * 27, 0), "zombie_zapper_tesla_coil");
    playFx(level._effect["mp_light_lamp"], new);
    tag setModel(getWeaponModel(weap));
    hint thread hoverBuyers(weap, cost, name, rank);
    tag thread rotateEntYaw(360, 4);
}
hoverBuyers(weap, cost, name, rank) {
    while (true) {
        self waittill("trigger", bog);
        if (!bog hasWeapon(weap) && !bog hasWeapon(weap + "_upgraded") && bog.rankLevel >= rank) self setString("Press [{+activate}] to buy " + name + " [Cost: " + cost + "]");
        else if (bog hasWeapon(weap) || bog hasWeapon(weap + "_upgraded") && bog.rankLevel >= rank) self setString("Press [{+activate}] to buy " + name + " Ammo [Cost: " + cost / 2 + "]");
        else self setString("Unlocked At Rank " + rank);
        if (bog usebuttonPressed() && !bog.is_zombie && bog.rankLevel >= rank) {
            if (bog.score < cost && !bog hasWeapon(weap)) {
                bog noMoneySound();
                wait .1;
            }
            if (bog.score < cost / 2 && bog hasWeapon(weap)) {
                bog noMoneySound();
                wait .1;
            }
            if (bog.score >= cost && !bog hasWeapon(weap) && !bog hasWeapon(weap + "_upgraded")) {
                bog.score -= cost;
                bog giveWeapon(weap);
                primaries = bog getWeaponsListPrimaries();
                if (isDefined(primaries) && primaries.size >= 3) bog takeWeapon(bog getCurrentWeapon());
                bog giveMaxAmmo(weap);
                bog switchToWeapon(weap);
                wait .15;
                continue;
            }
            if (bog.score >= (cost / 2) && ((bog getWeaponAmmoStock(weap) < weaponMaxAmmo(weap) && bog hasWeapon(weap)) || (bog getWeaponAmmoStock(weap + "_upgraded") < weaponMaxAmmo(weap + "_upgraded") && bog hasWeapon(weap + "_upgraded")))) {
                bog.score -= int(cost / 2);
                bog giveMaxAmmo(weap);
                bog giveMaxAmmo(weap + "_upgraded");
                wait .15;
            }
        }
    }
}
buildPowerRoom() {
    trig = spawnTrigger((-867, -1203, 200), 40);
    trig setString("Press [{+activate}] To Open Door");
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie) {
            if (isDefined(level.GeneralKey)) {
                level notify("GENERAL_KEY");
                trig delete();
                return;
            }
            playSoundAtPosition("deny", who.origin);
            trig setString("Locked Requires General Blunts' Key");
            break;
        }
    }
    wait 1;
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie) {
            if (isDefined(level.GeneralKey)) break;
            playSoundAtPosition("deny", who.origin);
            wait 1;
        }
    }
    level notify("GENERAL_KEY");
    trig delete();
}
powerSwitch() {
    tok = strTok("one|two|three", "|");
    pannel = spawnSM((-1422, -550, 199.125), "zombie_power_lever", (0, 90, 0));
    handle = spawnSM((-1416, -550, 244), "zombie_power_lever_handle", (0, 90, 90));
    trig = spawnTrigger((-1410, -550, 205), 40);
    trig setString("Press & hold [{+activate}] to turn on the electricity");
    while (true) {
        trig waittill("trigger", who);
        if (who usebuttonPressed() && !who.is_zombie) {
            handle rotateroll(-90, .3);
            who thread doZombiePush(false);
            level thread jumpToRound(100, true);
            playSoundAtPosition("switch_flip", who.origin);
            flag_set("electricity_on");
            level.extinctionPower = true;
            level notify("StratPower");
            level clientNotify("ag1");
            for (a = 0; a < 3; a++) getEnt("meteor_" + tok[a], "targetname") notify("trigger", who);
            clientNotify("pl1");
            playfx(level._effect["switch_sparks"], handle.origin + (0, 0, 15));
            array_thread(getPlayers(), ::setObjectiveLog, "Survive And Retrieve The Oracle");
            exploder(600);
            break;
        }
    }
    for (a = 0; a < getPlayers().size; a++) getPlayers()[a].XPGot += 300;
    array_thread(getPlayers(), ::giveFeedbackPoints, "+300");
    trig delete();
}
vault() {
    latch = spawnSM((1151.65, -1364.13, 183.443), "static_berlin_furnacelatch", (0, 270, 0));
    latchDoor = spawnSM((1115, -1340, 184), "static_berlin_furnacedoor", (180, -7, 0));
    trig = spawnTrigger((1145, -1390, 145), 40);
    array = [];
    vaultArray = getArrayKeys(level.zombie_weapons);
    for (a = 0; a < vaultArray.size; a++) array[array.size] = vaultArray[a];
    while (true) {
        trig waittill("trigger", who);
        if (who.prestigeLevel < 6) trig setString("Unlocked At Prestige 6");
        else {
            if (!isDefined(who.vaultWeapon)) trig setString("Press [{+activate}] To Store Current Weapon In Vault");
            if (isDefined(who.vaultWeapon)) trig setString("Press [{+activate}] To Get Vault Weapon");
            if (isDefined(who.vaultWeapon) && who hasWeapon(array[who getSavedVariable("bgen1", "mp/rankTable.csv") - 1])) trig setString("You Already Have This Weapon");
            if (who getCurrentWeapon() == "walther" && who getWeaponsListPrimaries().size > 1 && !isDefined(who.vaultWeapon)) trig setString("Cannot Store This Weapon In Vault");
        }
        if (who useButtonPressed() && !who.is_zombie && !who hasWeapon(array[who getSavedVariable("bgen1", "mp/rankTable.csv") - 1]) && who.prestigeLevel >= 6) {
            if (!isDefined(who.vaultWeapon) && who getWeaponsListPrimaries().size > 1 && who getCurrentWeapon() != "walther") {
                num = who checkVaultNumber(array);
                ammo = who getWeaponAmmoStock(array[num - 1]);
                clip = who getWeaponAmmoClip(array[num - 1]);
                who takeWeapon(array[num - 1]);
                for (a = 0; a < who getWeaponsListPrimaries().size; a++)
                    if (isDefined(who getWeaponsListPrimaries()[a])) who switchToWeapon(who getWeaponsListPrimaries()[a]);
                who.vaultWeapon = array[num - 1];
                who setSavedVariable("bgen1", num, "mp/rankTable.csv");
                who setSavedVariable("hcsab_cur_win_streak", ammo, "mp/playerStatsTable.csv");
                who setSavedVariable("bgen3", clip, "mp/rankTable.csv");
                trig setString("Press [{+activate}] To Get Vault Weapon");
                wait .2;
            } else {
                if (who getWeaponsListPrimaries().size > 1) {
                    num = who getSavedVariable("bgen1", "mp/rankTable.csv");
                    number = who checkVaultNumber(array);
                    ammo = who getWeaponAmmoStock(array[number - 1]);
                    clip = who getWeaponAmmoClip(array[number - 1]);
                    who takeWeapon(array[number - 1]);
                    who.vaultWeapon = array[number - 1];
                    who giveWeapon(array[num - 1]);
                    who switchToWeapon(array[num - 1]);
                    who setWeaponAmmoStock(array[num - 1], who getSavedVariable("hcsab_cur_win_streak", "mp/playerStatsTable.csv"));
                    who setWeaponAmmoClip(array[num - 1], who getSavedVariable("bgen3", "mp/rankTable.csv"));
                    who setSavedVariable("bgen1", number, "mp/rankTable.csv");
                    who setSavedVariable("hcsab_cur_win_streak", ammo, "mp/playerStatsTable.csv");
                    who setSavedVariable("bgen3", clip, "mp/rankTable.csv");
                    trig setString("Press [{+activate}] To Get Vault Weapon");
                } else {
                    num = who getSavedVariable("bgen1", "mp/rankTable.csv");
                    who giveWeapon(array[num - 1]);
                    who switchToWeapon(array[num - 1]);
                    who setWeaponAmmoStock(array[num - 1], who getSavedVariable("hcsab_cur_win_streak", "mp/playerStatsTable.csv"));
                    who setWeaponAmmoClip(array[num - 1], who getSavedVariable("bgen3", "mp/rankTable.csv"));
                    trig setString("Press [{+activate}] To Store Current Weapon In Vault");
                    who setSavedVariable("bgen1", 0, "mp/rankTable.csv");
                    who.vaultWeapon = undefined;
                }
                wait .2;
            }
        }
        wait .05;
    }
}
checkVaultNumber(array) {
    if (self getCurrentWeapon() != "walther")
        for (a = 0; a < array; a++)
            if (self getCurrentWeapon() == array[a]) return a + 1;
    for (a = 0; a < array; a++)
        for (b = 0; b < self getWeaponsListPrimaries().size; b++)
            if (self getCurrentWeapon() != array[a] && self getWeaponsListPrimaries()[b] == array[a]) return a + 1;
}
buildClockCode() {
    clock = [];
    trig = [];
    for (a = 0; a < 3; a++) {
        val = a + 1;
        level.clock["curs"][a] = 0;
        clock[a] = spawnSM((1022, -1151 - a * 60, 231), "zombie_wallclock_main", (-90, 270, 90));
        level.clock["trig"][a] = spawnTrigger(clock[a].origin - (15, 0, 40), 40);
        level.clock["trig"][a] setString("Press [{+activate}] To Rotate Clock " + val);
        self thread watchClockRotation(clock[a], a);
    }
}
watchClockRotation(clock, num) {
    while (isDefined(level.clock["curs"][0])) {
        level.clock["trig"][num] waittill("trigger", who);
        if (!isDefined(level.clock["curs"][0])) break;
        if (who usebuttonPressed() && !who.is_zombie) {
            level.clock["curs"][num]++;
            if (level.clock["curs"][num] > 10) level.clock["curs"][num] = 1;
            who playSound("pa_audio_link_" + level.clock["curs"][num]);
            clock rotateTo((-90 + level.clock["curs"][num] * 36, 270, 90), .5);
            if (level.clock["curs"][0] == level.clock["numbers"][0] && level.clock["curs"][1] == level.clock["numbers"][1] && level.clock["curs"][2] == level.clock["numbers"][2]) level.clock["curs"][0] = undefined;
            wait .4;
        }
    }
    playSoundAtPosition("cha_ching", clock.origin);
    for (a = 0; a < 3; a++) level.clock["trig"][a] notify("trigger");
    level.clock["trig"][num] delete();
    clock moveTo(clock.origin + (10, 0, 0), .5);
    wait .5;
    clock delete();
    if (!isDefined(level.extinctionPower)) {
        level waittill("StratPower");
        wait 1;
    }
    level notify("clockRotate");
}
secretRoomTeleperter() {
    ring = [];
    zap = [];
    tag = [];
    for (a = 0; a < 2; a++) ring[a] = spawnSM((-835, -1082, 67 + a * 112), "zombie_teleporter_mainframe_ring3", (0 + a * 180, 0, 0));
    for (b = 0; b < 2; b++) {
        for (a = 0; a < 4; a++) {
            zap[a + 4 * b] = spawnSM(ring[b].origin + (sin(45 + a * 90) * 42, cos(45 + a * 90) * 42, 0), "zombie_zapper_tesla_coil", (0 + b * 180, 0, 0));
            zap[a + 4 * b] linkTo(ring[b]);
        }
    }
    trig = spawnTrigger(ring[0].origin, 30);
    trig setString("Requires A Power Source");
    level waittill("StratPower");
    for (a = 0; a < zap.size; a++) playFxOnTag(level._effect["tesla_bolt"], zap[a], "tag_origin");
    trig setString("Clock Code Required");
    level waittill("clockRotate");
    trig setString("Unlocked At Prestige 3");
    ring[0] thread rotateEntYaw(360, .25);
    ring[1] thread rotateEntYaw(360, .25);
    while (true) {
        trig waittill("trigger", who);
        if (who.prestigeLevel >= 3) {
            if (!isDefined(who.extinctionTreasures)) trig setString("Choose Carefully You Only Get One");
            else trig setString("Sorry You Already Have A Treasure");
        } else trig setString("Unlocked At Prestige 3");
        if (who.is_zombie == true || isDefined(who.extinctionTreasures)) continue;
        wait 1.5;
        if (distance(who.origin, trig.origin) <= 30 && who.prestigeLevel >= 3) {
            link = spawn("script_origin", who.origin);
            who playerLinkToDelta(link);
            link moveTo(who.origin + (0, 0, 50), 1);
            wait .9;
            who unlink();
            who setOrigin((-1746, -1453, 120));
            who setPlayerAngles((0, 94, 0));
            link delete();
            who thread watchForTricks();
            who.extinctionSecret = true;
        }
    }
}
watchForTricks() {
    timer = self createText("default", 1.5, "TOP", "TOP", 0, 0, 1, 1, "");
    timer.label = "Time Left: ^2";
    for (a = 30; a > 0; a--) {
        timer setValue(a);
        if (isDefined(self.extinctionTreasures)) break;
        wait 1;
    }
    timer destroy();
    if (!isDefined(self.extinctionTreasures)) {
        self setOrigin((-56, 272, 280));
        self setPlayerAngles((0, -90, 0));
        self.extinctionSecret = undefined;
    }
}
mysteryTurrets() {
    tesla = [];
    coil = spawnSM((96.9906, -682.721, 200), "zombie_zapper_tesla_coil");
    tesla[0] = spawnSM(coil.origin + (0, 0, 23), getWeaponModel("tesla_gun"), (10, 80, 0));
    coil = spawnSM((-15.8035, -686.631, 200), "zombie_zapper_tesla_coil");
    tesla[1] = spawnSM(coil.origin + (0, 0, 23), getWeaponModel("tesla_gun"), (10, 100, 0));
    power = spawnSM((230.693, -423.102, 34.7333), "zombie_zapper_wall_control", (0, 180, 0));
    powerSwitch = spawnSM((235.904, -433.649, 48.2812), "zombie_zapper_handle", (180, 0, 0));
    trig = spawnTrigger(power.origin - (10, 0, 5), 45);
    while (true) {
        trig waittill("trigger", who);
        if (who.prestigeLevel < 4) trig setString("Unlocked At Prestige 4");
        else trig setString("Press [{+activate}] To Activate Tesla Turrets [Cost: 2500]");
        if (who useButtonPressed() && who.score >= 2500 && !who.is_zombie && !isDefined(who.revivetrigger) && who.prestigeLevel >= 4) {
            who minus_to_player_score(2500);
            playSoundAtPosition("switch_flip", who.origin);
            powerSwitch rotatePitch(-180, .5, 0, .25);
            trig setString("");
            for (a = 0; a < 2; a++) tesla[a] thread startTeslaTurret("tesla_gun", 10);
            wait 60;
            for (a = 0; a < 2; a++) {
                tesla[a].isNotTargetting = undefined;
                tesla[a] notify("idle_over");
                tesla[a] notify("overHeated");
                tesla[a] rotateTo((10, 80 + a * 20, 0), 1, 0, .5);
            }
            powerSwitch rotatePitch(180, .5, 0, .25);
            trig setString("Press [{+activate}] To Activate Tesla Turrets [Cost: 2500]");
        }
    }
}
bankTurrets() {
    coil = spawnSM((1264.005, 697, 156), "zombie_zapper_tesla_coil");
    tesla = spawnSM(coil.origin + (0, 0, 23), getWeaponModel("tesla_gun"), (10, 270, 0));
    button = spawnSM((1264.005, 583, 100), "zombie_teleporter_control_panel");
    trig = spawnTrigger(button.origin - (0, 15, 0), 40);
    while (true) {
        trig waittill("trigger", who);
        if (who.prestigeLevel < 4) trig setString("Unlocked At Prestige 4");
        else trig setString("Press [{+activate}] To Activate Tesla Turrets [Cost: 2500]");
        if (who useButtonPressed() && who.score >= 2500 && !who.is_zombie && !isDefined(who.revivetrigger) && who.prestigeLevel >= 4) {
            who minus_to_player_score(2500);
            playSoundAtPosition("switch_flip", who.origin);
            trig setString("");
            tesla thread startTeslaTurret("tesla_gun", 10);
            wait 60;
            tesla.isNotTargetting = undefined;
            tesla notify("idle_over");
            tesla notify("overHeated");
            tesla rotateTo((10, 270, 0), 1, 0, .5);
            trig setString("Press [{+activate}] To Activate Tesla Turrets [Cost: 2500]");
        }
    }
}
holeTeslaTurrets() {
    tesla = [];
    coil = spawnSM((145, -1973, 225.5), "zombie_zapper_tesla_coil");
    tesla[0] = spawnSM(coil.origin + (0, 0, 23), getWeaponModel("tesla_gun"), (10, 80, 0));
    coil = spawnSM((382, -1973, 225.5), "zombie_zapper_tesla_coil");
    tesla[1] = spawnSM(coil.origin + (0, 0, 23), getWeaponModel("tesla_gun"), (10, 100, 0));
    chalk = spawnSM((-93.5, -2213.47, 158.125), "zombie_chalkboard", (0, 30, 0));
    chalk = spawnSM((-175.649, -2298.57, 158.125), "zombie_chalkboard", (0, 60, 0));
    power = spawnSM((-142.611, -2249.18, 158.125), "zombie_power_lever", (0, 224, 0));
    lever = spawnSM((-147.378, -2243.93, 204.5525), "zombie_power_lever_handle", (0, 224, 90));
    trans = spawnSM((-110.74, -2283.62, 158.125), "zombie_transformer", (0, 224, 0));
    trig = spawnTrigger(power.origin + (0, 0, 20), 45);
    while (true) {
        trig waittill("trigger", who);
        if (who.prestigeLevel < 4) trig setString("Unlocked At Prestige 4");
        else trig setString("Press [{+activate}] To Activate Tesla Turrets [Cost: 2500]");
        if (who useButtonPressed() && who.score >= 2500 && !who.is_zombie && !isDefined(who.revivetrigger) && who.prestigeLevel >= 4) {
            who minus_to_player_score(2500);
            playSoundAtPosition("switch_flip", who.origin);
            lever rotateRoll(-90, .5, 0, .25);
            trig setString("");
            for (a = 0; a < 2; a++) tesla[a] thread startTeslaTurret("tesla_gun", 10);
            wait 60;
            for (a = 0; a < 2; a++) {
                tesla[a].isNotTargetting = undefined;
                tesla[a] notify("idle_over");
                tesla[a] notify("overHeated");
                tesla[a] rotateTo((10, 80 + a * 20, 0), 1, 0, .5);
            }
            trig setString("Tesla Turrets Are Cooling Down...");
            wait(randomIntRange(20, 65));
            lever rotateRoll(90, .5, 0, .25);
            trig setString("Press [{+activate}] To Activate Tesla Turrets [Cost: 2500]");
        }
    }
}
teslaTurret() {
    turret = spawnSM((951.323, -915.875, 157.089), "static_peleliu_crate01");
    coil = spawnSM((951.323, -915.875, 173.995), "zombie_zapper_tesla_coil");
    tesla = spawnSM(turret.origin + (0, 0, 40), getWeaponModel("tesla_gun"), (10, 90, 0));
    trig = spawnTrigger((949.5, -935, 164), 40);
    while (true) {
        trig waittill("trigger", who);
        if (who.prestigeLevel < 4) trig setString("Unlocked At Prestige 4");
        else trig setString("Press [{+activate}] To Activate Tesla Turret [Cost: 1500]");
        if (who useButtonPressed() && who.score >= 1500 && !who.is_zombie && !isDefined(who.revivetrigger) && who.prestigeLevel >= 4) {
            who minus_to_player_score(1500);
            trig setString("");
            tesla thread startTeslaTurret("tesla_gun", 10);
            wait 45;
            tesla.isNotTargetting = undefined;
            tesla notify("idle_over");
            tesla notify("overHeated");
            tesla rotateTo((10, 90, 0), 1, 0, .5);
            trig setString("Tesla Turret Cooling Down...");
            wait(randomIntRange(20, 40));
            trig setString("Press [{+activate}] To Activate Tesla Turret [Cost: 1500]");
        }
    }
}
secretArea() {
    lights = [];
    array = [];
    treasures = [];
    for (a = 0; a < 2; a++)
        for (b = 0; b < 9; b++) wall = spawnSM((-1620.5, -1061 - b * 50, 143.3 - a * 96), "static_peleliu_corrugated_metal4", (0, 90, 0));
    for (a = 0; a < 2; a++)
        for (b = 0; b < 3; b++) wall = spawnSM((-1620.5, -857 + b * 50, 143.3 - a * 96), "static_peleliu_corrugated_metal4", (0, 90, 0));
    for (a = 0; a < 2; a++)
        for (b = 0; b < 5; b++) door = spawnSM((-1612.51, -1008 + a * 89.9, 67 + b * 24), "zombie_treasure_box_lid", (0, 90, 90));
    for (a = 0; a < 2; a++) door = spawnSM((-1622, -1008 + a * 89.9, 191), "zombie_treasure_box_lid", (0, 270, 0));
    for (a = 0; a < 4; a++) {
        lamp = spawnSM((-1875, -1350 + a * 156, 160), "lights_indlight_on");
        lights[a] = spawnSM(lamp.origin + (30, 0, -5), "tag_origin", (90, 0, 0));
        playFxOnTag(level._effect["mp_light_lamp"], lights[a], "tag_origin");
    }
    lamp = spawnSM((-1748, -752.125, 160), "lights_indlight_on", (0, 270, 0));
    lights[4] = spawnSM(lamp.origin - (0, 30, 5), "tag_origin", (90, 0, 0));
    playFxOnTag(level._effect["mp_light_lamp"], lights[4], "tag_origin");
    treasures[0] = spawnSM(lights[0].origin + (0, 0, -40), "tag_origin");
    gunArray = getArrayKeys(level.zombie_weapons);
    for (i = 0; i < gunArray.size; i++)
        if (isSubStr(gunArray[i], "_upgraded")) array[array.size] = gunArray[i];
    treasures[0] thread doChangingWeaps(array);
    level thread treasureTrigs(treasures[0].origin + (5, 0, -20), treasures[0], "a Random Upgraded Weapon", "Random Upgraded Weapon", 3, array);
    treasures[1] = spawnSM(lights[1].origin + (0, 0, -40), "tag_origin");
    treasures[1] setModel("zombie_perk_bottle_doubletap");
    level thread treasureTrigs(treasures[1].origin + (5, 0, -20), treasures[1], "Double XP Cola", "Double XP Cola", 6);
    treasures[2] = spawnSM(lights[2].origin + (0, 0, -40), "tag_origin");
    treasures[2] setModel("zombie_perk_bottle_sleight");
    level thread treasureTrigs(treasures[2].origin + (5, 0, -20), treasures[2], "Stamin Jump", "Stamin Jump", 7);
    treasures[3] = spawnSM(lights[3].origin + (0, 0, -40), "tag_origin");
    treasures[3] setModel("zombie_ammocan");
    level thread treasureTrigs(treasures[3].origin + (5, 0, -20), treasures[3], "Ammo Regeneration", "Ammo Regeneration", 8);
    treasures[4] = spawnSM(lights[4].origin + (0, 0, -40), "tag_origin");
    treasures[4] setModel(getWeaponModel("walther"));
    level thread treasureTrigs(treasures[4].origin + (5, 0, -20), treasures[4], "a Thunder Walther", "Thunder Gun", 10);
    for (a = 0; a < 5; a++) treasures[a] thread powerup_wobble(true);
}
secretRoomBarrier() {
    while (true) {
        for (a = 0; a < getPlayers().size; a++)
            if (isDefined(getPlayers()[a].extinctionSecret)) killZombiesWithinDistance((-1650, -952, 67.125), 400, "delete");
        wait .05;
    }
}
treasureTrigs(org, ent, text, id, prestige, array) {
    trig = spawnTrigger(org, 40);
    if (id == "Random Upgraded Weapon") ent thread doChangingWeaps(array);
    while (true) {
        trig waittill("trigger", who);
        if (who.prestigeLevel >= prestige) trig setString("Press [{+activate}] for " + text);
        else trig setString(id + " Unlocked At Prestige " + prestige);
        if (who usebuttonPressed() && !who.is_zombie && !isDefined(who.extinctionTreasures) && !isDefined(who.revivetrigger) && who.prestigeLevel >= prestige) {
            who thread doTreasures(id, array);
            if (id != "Random Upgraded Weapon") {
                ent hide();
                trig delete();
                who thread watchTreasures(org, ent, text, id, prestige, array);
                break;
            }
        }
    }
}
doTreasures(id, array) {
    primaries = self getWeaponsListPrimaries();
    self.extinctionTreasures = true;
    if (id == "Random Upgraded Weapon") {
        randy = randomInt(array.size);
        if (isDefined(primaries) && primaries.size >= 2) self takeWeapon(self getCurrentWeapon());
        self giveWeapon(array[randy]);
        self switchToWeapon(array[randy]);
        self thread watchThis(id, array[randy]);
    }
    if (id == "Double XP Cola") {
        self giveFortunePerks("zombie_perk_bottle_doubletap", "dp_vox", "DP", "specialty_doublepoints_zombies", (172 / 255, 88 / 255, 1));
        self.zombie_point_scalar = true;
    }
    if (id == "Stamin Jump") {
        self giveFortunePerks("zombie_perk_bottle_sleight", undefined, "specialty_longersprint", "objective");
        self setMoveSpeedScale(1.3);
        self setClientDvar("jump_height", 60);
    }
    if (id == "Ammo Regeneration") self thread ammoRegen();
    if (id == "Thunder Gun") {
        if (isDefined(primaries) && primaries.size >= 2) self takeWeapon(self getCurrentWeapon());
        self giveWeapon("walther");
        self switchToWeapon("walther");
        self thread doThunderColt("walther", "walther");
        self thread watchThis(id);
    }
    self.extinctionSecret = undefined;
    self setOrigin((-56, 272, 280));
    self setPlayerAngles((0, -90, 0));
    self thread afterKillstreakProtection(true);
}
watchThis(id, weap) {
    self endon("death");
    self endon("disconnect");
    while (true) {
        if (id == "Thunder Gun")
            if (!self hasWeapon("walther")) break;
        if (id == "Random Upgraded Weapon")
            if (!self hasWeapon(weap)) break;
        wait .05;
    }
    self notify("other");
    self.extinctionTreasures = undefined;
}
ammoRegen() {
    self endon("death");
    self endon("disconnect");
    while (true) {
        if (self getWeaponAmmoStock(self getCurrentWeapon()) < weaponMaxAmmo(self getCurrentWeapon())) self setWeaponAmmoStock(self getCurrentWeapon(), self getWeaponAmmoStock(self getCurrentWeapon()) + 3);
        wait .5;
    }
}
watchTreasures(org, ent, text, id, prestige, array) {
    self waittill_any("death", "disconnect", "other");
    self.extinctionTreasures = undefined;
    self.zombie_point_scalar = undefined;
    self setClientDvar("jump_height", 40);
    self setMoveSpeedScale(1);
    ent show();
    level thread treasureTrigs(org, ent, text, id, prestige, array);
}
horse_pickArena() {
    level.horse_pickArena++;
    arena = strTok("Mainframe|Courtyard", "|");
    if (level.horse_pickArena > arena.size - 1) level.horse_pickArena = 0;
    array_thread(getPlayers(), ::updateMenu, "Arena Selected: ^6" + arena[level.horse_pickArena]);
}
horse_pickType() {
    level.horse_pickType++;
    type = strTok("HORSE|PIG", "|");
    if (level.horse_pickType > type.size - 1) level.horse_pickType = 0;
    array_thread(getPlayers(), ::updateMenu, "Type Selected: ^6" + type[level.horse_pickType]);
}
horse_pickEnviro() {
    level.horse_pickEnviro++;
    type = strTok("Day|Night", "|");
    if (level.horse_pickEnviro > type.size - 1) level.horse_pickEnviro = 0;
    array_thread(getPlayers(), ::updateMenu, "Environment: ^6" + type[level.horse_pickEnviro]);
}
horse_updateStatus() {
    players = [];
    size = getPlayers().size - 1;
    for (a = 0; a < getPlayers().size; a++) {
        bg = getPlayers()[a] createRectangle("LEFT", "LEFT", 0, 0, 140, 20 + 15 * size, getPlayers()[a].menu["Banner_Color"], getPlayers()[a].menu["Banner_Shader"], 8, 1);
        getPlayers()[a] createRectangle("LEFT", "LEFT", bg.x - 2, bg.y, 144, 24 + 15 * size, getPlayers()[a].menu["Edging_Color"], getPlayers()[a].menu["Edging_Shader"], -10, 1);
    }
    for (a = 0; a < getPlayers().size; a++) {
        players[a] = createServerText(getFont(), 1.1, "LEFT", "LEFT", 5, (0 - ((20 + 15 * size) / 2)) + 10 + 15 * a, 10, 1, getPlayers()[a] getName() + ":^6 None");
        getPlayers()[a] thread horse_monitorPlayerText(players[a]);
        getPlayers()[a] thread horse_monitorPlayerFlash(players[a]);
    }
}
horse_monitorPlayerText(hud) {
    while (!isDefined(self.horse_gameOver)) {
        self waittill("HORSE_ADD_LETTER");
        wait .05;
        hud setText(self getName() + ":^6 " + self.horse_currentText);
        wait .05;
    }
}
horse_monitorPlayerFlash(hud) {
    if (!isDefined(level.horse_playerOut)) level.horse_playerOut = 0;
    while (true) {
        hud notify("flashFlash_endon");
        hud.alpha = 1;
        if (self == level.horse_playerTurn) hud thread flashFlash();
        if (isDefined(self.horse_gameOver)) break;
        level waittill("HORSE_NEXT_TURN");
        wait .1;
    }
    hud setText(self getName() + ": ^1OUT");
    level.horse_playerOut++;
    if (level.horse_playerOut >= getPlayers().size - 1) {
        array_thread(getPlayers(), ::deathMessage, "^1Game Over", level.horse_playerTurn getName() + " Has Won This Basketball game!", 250, 20);
        wait 3;
        array_thread(getPlayers(), ::_hideSeek_timeoutInit);
    }
}
horse_buildHoop() {
    type = strTok("HORSE|PIG", "|");
    gameText = type[level.horse_pickType];
    level thread horse_playerTurnRotation();
    array_thread(getPlayers(), ::horse_createHud, gameText);
    array_thread(getPlayers(), ::horse_createPowerBar);
    box = [];
    hoop = undefined;
    door = getEntArray("zombie_door", "targetname");
    goal = [];
    if (level.horse_pickArena == 0) {
        array_thread(getPlayers(), ::returnToSpawn);
        level thread deleteATrigger("trigger_teleport_core");
        door[2].doors[0].origin = door[2].doors[0].savedOrigin;
        door[3].doors[0].origin = door[3].doors[0].savedOrigin;
        door[2].doors[0].angles = door[2].doors[0].savedAngles;
        door[3].doors[0].angles = door[3].doors[0].savedAngles;
        door[2].doors[0] solid();
        door[3].doors[0] solid();
        hoop = spawnSM((-444.398, -422.719, 292.564) - anglesToRight((0, -45, 0)) * 33 - (0, 0, 26), "zombie_teleporter_mainframe_ring1", (0, -45, 0));
        box[0] = spawnSM(hoop.origin + anglesToRight((0, -45, 0)) * 35 + anglesToForward((0, -45, 0)) * 30 + (0, 0, 10), "tag_origin", vectorToAngles(anglesToRight((0, -45, 0)) * -1));
        for (b = 1; b >= -1; b -= 2) {
            for (a = 0; a < 8; a++) box[box.size] = spawnSM(box[box.size - 1].origin + (0, 0, 5 * b), "tag_origin", box[box.size - 1].angles);
            for (a = 0; a < 12; a++) box[box.size] = spawnSM(box[box.size - 1].origin - anglesToForward((0, -45, 0)) * 5 * b, "tag_origin", box[box.size - 1].angles);
        }
        goal[0] = spawnSM(hoop.origin + anglesToRight((0, -45, 0)) * 65 + anglesToForward((0, -45, 0)) * 30 + (0, 0, 10), "tag_origin", vectorToAngles(anglesToRight((0, -45, 0)) * -1));
        for (b = 1; b >= -1; b -= 2) {
            for (a = 0; a < 8; a++) goal[goal.size] = spawnSM(goal[goal.size - 1].origin + (0, 0, 5 * b), "tag_origin", goal[goal.size - 1].angles);
            for (a = 0; a < 12; a++) goal[goal.size] = spawnSM(goal[goal.size - 1].origin - anglesToForward((0, -45, 0)) * 5 * b, "tag_origin", goal[goal.size - 1].angles);
        }
    } else if (level.horse_pickArena == 1) {
        point = [];
        point[0] = (397, -1784, 56);
        point[1] = (297, -1784, 56);
        point[2] = (397, -1684, 56);
        point[3] = (297, -1684, 56);
        for (a = 0; a < getPlayers().size; a++) {
            getPlayers()[a] setOrigin(point[a]);
            getPlayers()[a] setPlayerAngles((0, 90, 0));
        }
        wait 1;
        door[2].doors[0].origin = (125, -1013, 182);
        door[7].doors[0].origin = (477.886, -1139.925 - 26, 117);
        door[7].doors[1].origin = (477.886, -1139.925 + 26, 117);
        door[3].doors[0].origin = (487, -1139.925, 117);
        door[2].doors[0].angles = door[2].doors[0].savedAngles;
        door[7].doors[0].angles = door[7].doors[0].savedAngles + (0, 180, 0);
        door[7].doors[1].angles = door[7].doors[1].savedAngles + (0, 180, 0);
        door[3].doors[0].angles = door[3].doors[0].savedAngles;
        door[2].doors[0] solid();
        door[3].doors[0] solid();
        door[7].doors[0] solid();
        door[7].doors[1] solid();
        door[3].doors[0] solid();
        door[3].doors[0] hide();
        flag_set("electricity_on");
        trig = getent("use_power_switch", "targetname");
        trig remove();
        powerSwitch = getent("power_switch", "targetname");
        powerSwitch remove();
        hoop = spawnSM((283, -980.367, 308.303), "zombie_teleporter_mainframe_ring1");
        box[0] = spawnSM(hoop.origin - anglesToRight((0, 0, 0)) * 34 - anglesToForward((0, 0, 0)) * 30 + (0, 0, 10), "tag_origin", (0, -90, 0));
        for (b = 1; b >= -1; b -= 2) {
            for (a = 0; a < 8; a++) box[box.size] = spawnSM(box[box.size - 1].origin + (0, 0, 5 * b), "tag_origin", box[box.size - 1].angles);
            for (a = 0; a < 12; a++) box[box.size] = spawnSM(box[box.size - 1].origin + anglesToForward((0, 0, 0)) * 5 * b, "tag_origin", box[box.size - 1].angles);
        }
        goal[0] = spawnSM(hoop.origin - anglesToRight((0, 0, 0)) * 64 - anglesToForward((0, 0, 0)) * 30 + (0, 0, 10), "tag_origin", (0, -90, 0));
        for (b = 1; b >= -1; b -= 2) {
            for (a = 0; a < 8; a++) goal[goal.size] = spawnSM(goal[goal.size - 1].origin + (0, 0, 5 * b), "tag_origin", goal[goal.size - 1].angles);
            for (a = 0; a < 12; a++) goal[goal.size] = spawnSM(goal[goal.size - 1].origin + anglesToForward((0, 0, 0)) * 5 * b, "tag_origin", goal[goal.size - 1].angles);
        }
    }
    for (a = 0; a < box.size; a++) {
        playFxOnTag(level._effect["zapper_light_notready"], box[a], "tag_origin");
        playFxOnTag(level._effect["zapper_light_ready"], box[a], "tag_origin");
        playFxOnTag(level._effect["zapper_light_ready"], goal[a], "tag_origin");
        box[a] linkTo(box[0]);
        goal[a] linkTo(goal[0]);
    }
    array_thread(getPlayers(), ::horse_createBallSlot);
    array_thread(getPlayers(), ::horse_shootForGoal);
    self thread horse_watchForGoal(hoop, box[0], goal[0]);
    self horse_createBall(hoop);
    level thread horse_monitorRotation();
    icon = textMarker(undefined, hoop.origin, "GOAL", false, "RAIN");
    wait 10;
    icon hudFadenDestroy(0, 1);
}
horse_createHud(gameText) {
    letter = [];
    bg = [];
    backround = self createRectangle("CENTER", "RIGHT", 100, 0, 41, 41, (0, 0, 0), "white", -100, 0);
    backround thread hudFade(1, .5);
    self.horse_currentText = "";
    color = divideColor(255, 112, 219);
    if (gameText == "HORSE") color = divideColor(101, 67, 33);
    for (a = 0; a < gameText.size; a++) {
        self waittill("HORSE_ADD_LETTER");
        self.horse_currentText += gameText[a];
        bg[a] = self createRectangle("CENTER", "RIGHT", 100, 0, 35, 35, (1, 1, 1), "white", 2, 1);
        letter[a] = self createText(self getFont(), 3.5, "CENTER", "RIGHT", 100, 0, 3, 1, gameText[a], color);
        if (a == 0) {
            letter[a] thread hudMoveX(0, 1);
            bg[a] thread hudMoveX(0, 1);
            backround thread hudMoveX(0, 1);
        } else {
            backround scaleOverTime(1, 40, 41 + 38 * a);
            for (b = 0; b < a; b++) {
                letter[b] thread hudMoveY(letter[b].y - 19, 1);
                bg[b] thread hudMoveY(bg[b].y - 19, 1);
            }
            letter[a].y = letter[a - 1].y + 38;
            bg[a].y = bg[a - 1].y + 38;
            letter[a] thread hudMoveX(0, 1.3);
            bg[a] thread hudMoveX(0, 1.3);
        }
    }
    self.horse_gameOver = true;
}
horse_createPowerBar() {
    bar = self createRectangle("CENTER", "BOTTOM", 0, -35, 100, 20, (0, 0, 0), "white", 10, 0);
    bar thread hudFade(1, .2);
    slider = self createRectangle("LEFT", "BOTTOM", bar.x - 50, bar.y, 1, 20, (1, 1, 1), "white", 12, 0);
    slider thread hudFade(1, .2);
    percent = self createText(self getFont(), 1, "LEFT", "BOTTOM", bar.x + 55, bar.y, 1, 0, undefined, (1, 1, 1));
    percent thread hudFade(1, .2);
    info = self createText(self getFont(), 1, "CENTER", "BOTTOM", slider.x - 10, slider.y, 1, 0, "[{+speed_throw}]");
    info thread hudFade(1, .2);
    power = self createText(self getFont(), 1.3, "CENTER", "BOTTOM", bar.x, bar.y, 100, 0, "P O W E R", (1, 0, 0));
    power thread hudFade(1, .2);
    percent setValue(0);
    wait 1;
    up = true;
    self.horse_power = -1;
    while (isDefined(bar)) {
        if (self adsButtonPressed()) {
            self.horse_power = -1;
            slider setShader("white", 1, 20);
            while (self adsButtonPressed()) {
                if (isDefined(up)) {
                    self.horse_power++;
                    if (self.horse_power > 20) {
                        up = undefined;
                        self.horse_power = 19;
                    }
                } else {
                    self.horse_power--;
                    if (self.horse_power < 0) {
                        up = true;
                        self.horse_power = 1;
                    }
                }
                slider scaleOverTime(.05, 1 + self.horse_power * 5, 20);
                percent setValue(self.horse_power * 5);
                percent.color = divideColor(255, 255 - (self.horse_power * 12.75), 255 - (self.horse_power * 12.75));
                power.color = divideColor(255, 0 + (self.horse_power * 12.75), 0 + (self.horse_power * 12.75));
                slider.color = divideColor(255, 255 - (self.horse_power * 12.75), 255 - (self.horse_power * 12.75));
                wait .05;
            }
            if (self.horse_power == 20) self thread horse_tempString();
        }
        wait .05;
    }
}
horse_tempString() {
    max = self createText(self getFont(), 1, "LEFT", "BOTTOM", 50, -50, 100, 1, "MAX", (1, 0, 0));
    max hudMoveXY(.5, max.x + randomIntRange(-15, 15), max.y - 30);
    max hudFadenDestroy(0, 0.6);
}
horse_createBallSlot() {
    self.horse_ballTag = spawnSM(self getEye() + vectorScale(anglesToforward(self getPlayerAngles()), 60), "tag_origin");
    self.horse_ballTag hide();
    while (true) {
        self.horse_ballTag.origin = self getEye() + vectorScale(anglesToforward(self getPlayerAngles()), 60);
        self.horse_ballTag.angles = self getPlayerAngles();
        wait .05;
    }
}
horse_createBall(hoop) {
    ball = [];
    level.horse_ball = spawnSM((0, 0, 0), "tag_origin");
    for (a = 0; a < 120; a++) ball[ball.size] = spawnSM(level.horse_ball.origin + (0, 0, 1.5), "lights_berlin_subway_hat_0", (0, a * 3, 0));
    for (a = 1; a < ball.size; a++) ball[a] linkTo(ball[0]);
    ball[0] linkTo(level.horse_ball);
    level thread horse_watchForNewBall(ball[0]);
    level thread horse_solidHoop(hoop, ball[0]);
}
horse_watchForNewBall(ball) {
    while (true) {
        level waittill("HORSE_NEW_BALL");
        level.horse_ball delete();
        level.horse_ball = snapSM(ball.origin, "tag_origin");
        ball linkTo(level.horse_ball);
    }
}
horse_playerTurnRotation() {
    index = randomIntRange(0, getPlayers().size);
    level.horse_playerTurn = getPlayers()[index];
    while (true) {
        level waittill("HORSE_NEXT_TURN");
        while (true) {
            index++;
            if (index > getPlayers().size) index = 0;
            level.horse_playerTurn = getPlayers()[index];
            if (isDefined(getPlayers()[index]) && !isDefined(getPlayers()[index].horse_gameOver)) break;
            wait .05;
        }
    }
}
horse_shootForGoal() {
    while (!isDefined(self.horse_gameOver)) {
        while (level.horse_playerTurn == self) {
            if (self attackButtonPressed()) {
                level.horse_goalWatch = true;
                self allowJump(true);
                self setMoveSpeedScale(1);
                level.horse_ball unlink();
                level.horse_possibleNextShotPosition = self.origin;
                level.horse_ball physicsLaunch(self.horse_ballTag.origin, anglesToforward(self getPlayerAngles()) * (70 * self.horse_power));
                level thread horse_watchBallVelocity();
                level waittill("HORSE_NEXT_TURN");
                if (isDefined(level.horse_previousPlayerMadeShot)) {
                    if (!isDefined(level.horse_playerStartShot)) level.horse_playerStartShot = self;
                } else {
                    if (isDefined(level.horse_playerStartShot) && level.horse_playerStartShot != self) self notify("HORSE_ADD_LETTER");
                    level.horse_playerStartShot = undefined;
                }
                level.horse_goalWatch = undefined;
                wait .3;
            }
            wait .05;
        }
        wait .05;
    }
}
horse_monitorRotation() {
    while (true) {
        level.horse_ball.origin = level.horse_playerTurn.horse_ballTag.origin;
        level.horse_ball linkTo(level.horse_playerTurn.horse_ballTag);
        if (isDefined(level.horse_playerStartShot))
            if (level.horse_playerStartShot == level.horse_playerTurn) level.horse_previousPlayerMadeShot = undefined;
        if (isDefined(level.horse_previousPlayerMadeShot)) {
            level.horse_previousPlayerMadeShot = undefined;
            level.horse_playerTurn allowJump(false);
            level.horse_playerTurn setMoveSpeedScale(0);
            level.horse_playerTurn setOrigin(level.horse_possibleNextShotPosition);
        }
        level waittill("HORSE_NEXT_TURN");
        wait .15;
    }
}
horse_watchBallVelocity() {
    level endon("HORSE_NEXT_TURN");
    level endon("HORSE_NEW_BALL");
    while (true) {
        oldOrigin = level.horse_ball.origin;
        wait .1;
        origin = level.horse_ball.origin;
        if (oldOrigin == origin) break;
    }
    wait .1;
    level notify("HORSE_NEXT_TURN");
}
horse_solidHoop(hoop, ball) {
    for (a = 0; a < 60; a++) {
        tag = spawnSM(hoop.origin + (sin(a * 6) * 35, cos(a * 6) * 35, 3), "tag_origin");
        if (level.horse_pickArena == 0) {
            if (a >= 25 && a <= 50) {
                tag thread horse_repelBall(ball, 11);
            } else tag thread horse_repelBall(ball, 24);
        } else {
            if (a >= 0 && a <= 8 || a >= 51 && a <= 59) {
                tag thread horse_repelBall(ball, 12);
            } else tag thread horse_repelBall(ball, 24);
        }
    }
}
horse_repelBall(ball, area) {
    sounds = strTok("plr_0_vox_crappy_5|plr_0_vox_crappy_2|plr_0_vox_crappy_0|plr_0_vox_insta_melee_5|plr_0_vox_gen_respond_neg_0|plr_0_vox_revived_4|plr_0_vox_revived_0|plr_0_vox_down_gen_1|plr_0_vox_gen_sigh_0|plr_0_vox_gen_sigh_5", "|");
    while (true) {
        if (distance(self.origin, level.horse_ball.origin) <= area && level.horse_ball.origin[2] > self.origin[2] && isDefined(level.horse_ball) && !isDefined(level.horse_ballHit)) {
            level.horse_ballHit = true;
            level notify("HORSE_NEW_BALL");
            wait .05;
            level.horse_ball physicsLaunch(level.horse_ball.origin, anglesToforward(getPlayers()[0] getPlayerAngles()) * ((-60 * getPlayers()[0].horse_power) / 2) + anglesToUp(getPlayers()[0] getPlayerAngles()) * ((60 * getPlayers()[0].horse_power) / 2));
            level.horse_playerTurn playSound(sounds[randomIntRange(0, sounds.size)]);
            level thread horse_watchBallVelocity();
            wait .5;
            level.horse_ballHit = undefined;
        }
        wait .05;
    }
}
horse_watchForGoal(hoop, box, goal) {
    sounds = strTok("plr_0_vox_flame_0|plr_0_vox_357_0|plr_0_vox_resp_riv_headdist_4|plr_0_vox_raygun_2|plr_0_vox_raygun_1|plr_0_vox_tesla_0|plr_0_vox_mg_2|plr_0_vox_insta_melee_1|plr_0_vox_gen_respond_pos_3|plr_0_vox_kill_explo_3", "|");
    while (true) {
        if (distance2d(hoop.origin, level.horse_ball.origin) <= 42 && level.horse_ball.origin[2] < hoop.origin[2] + 40 && level.horse_ball.origin[2] > hoop.origin[2] - 8 && isDefined(level.horse_ball)) {
            while (isDefined(level.horse_goalWatch)) {
                if (isDefined(level.horse_ballHit)) break;
                if (distance(hoop.origin - (0, 0, 50), level.horse_ball.origin) <= 90 && isDefined(level.horse_ball) && level.horse_ball.origin[2] < hoop.origin[2] - 15) {
                    level.horse_previousPlayerMadeShot = true;
                    level.horse_playerTurn playSound(sounds[randomIntRange(0, sounds.size)]);
                    for (a = 0; a < 5; a++) {
                        origin = box.origin;
                        box.origin = goal.origin;
                        wait .05;
                        goal.origin = origin;
                        wait .15;
                        origin = goal.origin;
                        goal.origin = box.origin;
                        wait .05;
                        box.origin = origin;
                        wait .15;
                    }
                    break;
                }
                wait .05;
            }
        }
        wait .05;
    }
}
horse_deleteAllZombies() {
    while (true) {
        killZombiesWithinDistance(self getOrigin(), 10000000, "delete");
        wait .05;
    }
}
forge_onScreenText_init() {
    if (!isDefined(self.forgeText)) self.forgeText = [];
    self.forgeText["noclip"] = self createText(self getFont(), 1, "BOTTOM", "BOTTOM", 0, 0, 5, 1, "No-Clip [^1OFF^7] - Prone + [{+activate}] to Activate No-Clip");
}
forgeButtonMonitor() {
    self endon("death");
    self endon("disconnect");
    for (;;) {
        if (self getStance() == "prone")
            if (self useButtonPressed()) self notify("noclip");
        wait .05;
    }
}
forgeNoClip() {
    self endon("death");
    self endon("disconnect");
    for (;;) {
        self waittill("noclip");
        self.forgeText["noclip"] setText("No-Clip [^2ON^7] ^7[{+speed_throw}]: Move Backwards - [{+frag}]: Move Forwards - [{+melee}]: Exit Noclip");
        self enableGodMode();
        self disableOffHandWeapons();
        clip = spawn("script_origin", self.origin);
        self playerLinkTo(clip);
        for (;;) {
            vec = anglesToForward(self getPlayerAngles());
            end = (vec[0] * 30, vec[1] * 30, vec[2] * 30);
            if (self fragButtonPressed()) clip.origin = clip.origin + end;
            if (self adsButtonPressed()) clip.origin = clip.origin - end;
            if (self meleeButtonPressed()) break;
            wait .05;
        }
        self.forgeText["noclip"] setText("No-Clip [^1OFF^7] - Prone + [{+activate}] to Activate No-Clip");
        self unlink();
        clip delete();
        self enableWeapons();
        self thread godCheck();
    }
}